#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int N, n, M, m, k, q; cin >> N >> n >> M >> m >> k >> q;
    vector<pair<int, int>> a(n), b(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second; a[i].second--;
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i].first >> b[i].second;
        b[i].second--;
    }
    vector<int> prefa(n), prefb(m);
    prefa[0] = a[0].first;
    prefb[0] = b[0].first;
    for (int i = 1; i < n; i++) prefa[i] = prefa[i - 1] + a[i].first;
    for (int i = 1; i < m; i++) prefb[i] = prefb[i - 1] + b[i].first;
    vector<int> prva(n,- 1), prvb(n, -1), nxta(n, -1), nxtb(n, -1);
    vector<int> lp(k, -1);
    for (int i = 0; i < n; i++) {
        prva[i] = lp[a[i].second];
        lp[a[i].second] = i;
    }
    lp.assign(k, -1);
    for (int i = 0; i < m; i++) {
        prvb[i] = lp[b[i].second];
        lp[b[i].second] = i;
    }
    lp.assign(k, -1);
    for (int i = n - 1; i >= 0; i--) {
        nxta[i] = lp[a[i].second];
        lp[a[i].second] = i;
    }
    lp.assign(k, -1);
    for (int i = m - 1; i >= 0; i--) {
        nxtb[i] = lp[b[i].second];
        lp[b[i].second] = i;
    }

    vector<vector<bool>> dp(n, vector<bool>(m)), cj(n, vector<bool>(m));
    for (int i = n - 1; i >= 0; i--) {
        vector<int> nxt(k, -1);
        for (int i1 = n - 1; i1 > i; i1--) {
            nxt[a[i1].second] = i1;
        }
        int cnt = 0;
        vector<int> nxt2(k, -1);
        for (int j = m - 1; j >= 0; j--) {
            cj[i][j] = (cnt > 0);
            if (cj[i][j]) {
                dp[i][j] = 1;
            } else {
                dp[i][j] = (min(a[i].first, b[j].first) % 2 ? 0 : 1);
                //if (!dp[i][j]) cj[i][j] = 1;
            }
            if (nxt2[b[j].second] != -1 && nxt[b[j].second] != -1) cnt -= !dp[nxt[b[j].second]][nxt2[b[j].second]];
            nxt2[b[j].second] = j;
            if (nxt[b[j].second] != -1) {
                cnt += !dp[nxt[b[j].second]][j];
            }
        }
    }

    while (q--) {
        int x, y; cin >> x >> y;
        int L = -1, R = n;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (prefa[M] <= x) L = M;
            else R = M;
        }
        int ps1 = R;
        L = -1; R = m;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (prefb[M] <= y) L = M;
            else R = M;
        }
        int ps2 = R;
        //cout << ps1<< ' ' << ps2 << '\n';
        if (cj[ps1][ps2]) {
            cout << "Yes\n";
        } else {
            //cout << ps1 << ' ' << ps2 << ' ' << y << ' ' << prefb[0] << '\n';
            int steps = min(prefa[ps1] - x - 1, prefb[ps2] - y - 1);
            cout << (steps % 2 == 0 ? "Yes\n" :"No\n");
        }
    }
}

signed main() {
    int tt = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else
        cin.tie(0)->sync_with_stdio(false);
    #endif  

    while (tt--) {
        solve();
    }

    return 0;
}