#include <bits/stdc++.h>

using namespace std;

constexpr int maxn = 5e3 + 5;

int dp[maxn][maxn];

int cnt[maxn][maxn];

int a[maxn], b[maxn];

int nxt_a[maxn][maxn], nxt_b[maxn][maxn];

void solve() {
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    int pos_a = 0;
    for (int i = 0; i < n; ++i) {
        int l, v;
        cin >> l >> v;
        v--;
        while (l--) {
            a[pos_a] = v;
            pos_a++;
        }
    }
    int pos_b = 0;
    for (int i = 0; i < m; ++i) {
        int l, v;
        cin >> l >> v;
        v--;
        while (l--) {
            b[pos_b] = v;
            pos_b++;
        }
    }
    for (int i = 0; i <= N; ++i) {
        for (int j = 0; j < k; ++j) {
            nxt_a[i][j] = N;
        }
        for (int j = i; j < N; ++j) {
            nxt_a[i][a[j]] = min(nxt_a[i][a[j]], j);
        }
    }
    for (int i = 0; i <= M; ++i) {
        for (int j = 0; j < k; ++j) {
            nxt_b[i][j] = M;
        }
        for (int j = i; j < M; ++j) {
            nxt_b[i][b[j]] = min(nxt_b[i][b[j]], j);
        };
    }
    auto check_move = [&](int i, int j, int v) -> bool {
        return nxt_a[i + 1][v] != N && nxt_b[j + 1][v] != M && !dp[nxt_a[i + 1][v]][nxt_b[j + 1][v]];
    };
    for (int i = N - 1; i >= 0; --i) {
        for (int j = M - 1; j >= 0; --j) {
            if (j == M - 1) {
                cnt[i][j] = 0;
            } else {
                cnt[i][j] = cnt[i][j + 1];
                if (check_move(i, j + 1, b[j + 1])) {
                    cnt[i][j]--;
                }
                if (check_move(i, j, b[j + 1])) {
                    cnt[i][j]++;
                }
            }
            if (a[i] != b[j]) {
                continue;
            }
            if (cnt[i][j]) {
                dp[i][j] = 1;
            }
        }
    }
    while (q--) {
        int x, y;
        cin >> x >> y;
        int ans = 0;
        for (int v = 0; v < k; ++v) {
            if (nxt_a[x][v] != N && nxt_b[y][v] != M && !dp[nxt_a[x][v]][nxt_b[y][v]]) {
                ans = 1;
            }
        }
        if (ans) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
