#ifdef _DEBUG
#define _CRT_SECURE_NO_WARNINGS
#endif
#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <limits>
#include <stack>
#include <queue>
#include <deque>
#include <vector>
#include <numeric>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <chrono>
#include <random>
#include <assert.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ui = unsigned int;
using ld = long double;
using pii = pair<int, int>;
using pli = pair<long long, int>;
using pil = pair<int, long long>;
using pll = pair<long long, long long>;
template <typename T>
using uset = unordered_set<T>;
template <typename T1, typename T2>
using umap = unordered_map<T1, T2>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

inline void solve() {
	int N, n, M, m, k, q;
	cin >> N >> n >> M >> m >> k >> q;
	vector<int> la(n), va(n);
	for (int i = 0; i < n; i++) {
		cin >> la[i] >> va[i];
		va[i]--;
	}
	vector<int> lb(m), vb(m);
	for (int i = 0; i < m; i++) {
		cin >> lb[i] >> vb[i];
		vb[i]--;
	}
	vector<int> pref_a(n + 1), pref_b(m + 1);
	for (int i = 0; i < n; i++)
		pref_a[i + 1] = pref_a[i] + la[i];
	for (int i = 0; i < m; i++)
		pref_b[i + 1] = pref_b[i] + lb[i];
	vector<vector<pii>> buc(k);
	for (int i = 0; i < m; i++)
		buc[vb[i]].push_back({ pref_b[i], pref_b[i] + lb[i] - 1 });
	vector<vector<int>> suf_buc(k);
	for (int v = 0; v < k; v++) {
		suf_buc[v].resize(buc[v].size());
		for (int i = 0; i < (int)buc[v].size(); i++)
			suf_buc[v][i] = buc[v][i].second - buc[v][i].first + 1;
		for (int i = (int)buc[v].size() - 2; i > -1; i--)
			suf_buc[v][i] += suf_buc[v][i + 1];
	}
	while (q--) {
		int x, y;
		cin >> x >> y;
		int i = upper_bound(all(pref_a), x) - pref_a.begin();
		i--;
		int j = upper_bound(all(pref_b), y) - pref_b.begin();
		j--;
		int cnta = pref_a[i + 1] - x;
		int cntb = pref_b[j + 1] - y;
		int ptr = upper_bound(all(buc[vb[j]]), pii{ y, M + 1 }) - buc[vb[j]].begin();
		if (ptr < (int)buc[vb[j]].size())
			cntb += suf_buc[vb[j]][ptr];
		if (min(cnta, cntb) & 1)
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("01.dat", "r", stdin);
#endif
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif
	for (int test_id = 1; test_id <= tt; test_id++) {
#ifdef _DEBUG
		cout << "TESTCASE# " << test_id << '\n';
#endif
		solve();
	}
	return 0;
}
