#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#ifdef LOCAL
    #define debug(x) cout << #x << ": " << x << endl;
#else
    #define debug(x)
#endif
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define time_now chrono::high_resolution_clock::now()
#define time_res(s, f) chrono::duration_cast<chrono::nanoseconds>(f - s).count()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("input.txt", "r", stdin);
#define file_out freopen("output.txt", "w", stdout);
#define all(a) a.begin(), a.end()
#define sz(a) (int)(a.size())
#define pb push_back
#define ff first
#define sc second
#define int ll

using namespace std;
using namespace __gnu_pbds;

using ld = long double;
using ll = long long;
using ull = unsigned long long;
using str = string;
using pii = pair<int, int>;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2> istream& operator>>(istream &in, pair<T1, T2> &a) { in >> a.ff >> a.sc; return in; }
#ifdef LOCAL
    template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << "{" << a.ff << ' ' << a.sc << "}"; return out; }
#else
    template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << a.ff << ' ' << a.sc; return out; }
#endif
template<typename T> istream& operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const set<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const multiset<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T, typename comp> ostream& operator<<(ostream &out, const unordered_set<T, comp> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> T max(T a, T b, T c) { return max(a, max(b, c)); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
template<typename T> T min(T a, T b, T c) { return min(a, min(b, c)); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
const ll LOL = mt_seed;
mt19937_64 genom(LOL); ll randint(ll l, ll r) { uniform_int_distribution<ll> random_distrib_2_0(l, r); return random_distrib_2_0(genom); }
const ll RANDOM = genom(); struct chash { ll operator()(ll x) { return x ^ RANDOM; } };

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<pii> a(n), b(m);
    cin >> a >> b;

    vector<int> A, B;
    for (int i = 0; i < n; ++i) {
        --a[i].sc;
        for (int j = 0; j < a[i].ff; ++j) {
            A.pb(a[i].sc);
        }
    }
    for (int i = 0; i < m; ++i) {
        --b[i].sc;
        for (int j = 0; j < b[i].ff; ++j) {
            B.pb(b[i].sc);
        }
    }

    vector<vector<int>> dp(N + 1, vector<int>(M + 1));
    for (int i = 0; i <= N; ++i)
        dp[i][M] = 0;
    for (int i = 0; i <= M; ++i)
        dp[N][i] = 0;

    debug(A)
    debug(B)

    vector<int> lastA(k, N + 1);
    for (int i = N - 1; i >= 0; --i) {
        vector<int> lastB(k, M + 1);
        int cnt0 = 0;
        lastA[A[i]] = i + 1;
        for (int j = M - 1; j >= 0; --j) {
            if (lastA[B[j]] != N + 1 && lastB[B[j]] != M + 1)
                cnt0 -= dp[lastA[B[j]]][lastB[B[j]]] == 0;
            lastB[B[j]] = j + 1;
            if (lastA[B[j]] != N + 1 && lastB[B[j]] != M + 1)
                cnt0 += dp[lastA[B[j]]][lastB[B[j]]] == 0;

            cout << i << " " << j << ": " << lastA << "| " << lastB << "| " << cnt0 << endl; 

            dp[i][j] = cnt0 > 0;
        }
    }

    for (int i = 0; i < q; ++i) {
        int x, y;
        cin >> x >> y;
        cout << (dp[x][y] ? "Yes" : "No") << '\n';
    }

    return 0;
}
