#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18;


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int N, M, n, m, k, q;
	cin >> N >> n >> M >> m >> k >> q;
	vector<int> a(N), b(M);
	int i = 0;
	for (int _ = 0; _ < n; ++_) {
		int l, v;
		cin >> l >> v;
		for (int j = 0; j < l; ++j) {
			a[i] = v;
			i++;
		}
	}
	i = 0;
	for (int _ = 0; _ < m; ++_) {
		int l, v;
		cin >> l >> v;
		for (int j = 0; j < l; ++j) {
			b[i] = v;
			i++;
		}
	}
	vector<vector<bool>> dp(N + 1, vector<bool>(M + 1, false));
	for (int i = N - 1; i >= 0; --i) {
		vector<int> ind_a(k + 1, -1);
		for (int pos = i; pos < N; ++pos) {
			if (ind_a[a[pos]] == -1)
				ind_a[a[pos]] = pos;
		}
		vector<int> ind_b(k + 1, -1);
		vector<int> cnt(k + 1, 0);
		int all_cnt = 0;
		for (int j = M - 1; j >= 0; --j) {
			if (ind_b[b[j]] == -1) {
				if (ind_a[b[j]] != -1 && !dp[ind_a[b[j]] + 1][j + 1]) {
					all_cnt++;
					cnt[b[j]]++;
				}
				ind_b[b[j]] = j;
			}
			else {
				all_cnt -= cnt[b[j]];
				cnt[b[j]] = 0;
				if (ind_a[b[j]] != -1 && !dp[ind_a[b[j]] + 1][j + 1]) {
					all_cnt++;
					cnt[b[j]]++;
				}
				ind_b[b[j]] = j;
			}
			dp[i][j] = (all_cnt > 0);
		}
	}
	//cout << dp[N - 1][M - 1];
	for (int _ = 0; _ < q; ++_) {
		int x, y;
		cin >> x >> y;
		if (dp[x][y]) cout << "Yes\n";
		else cout << "No\n";
	}

	return 0;
}