#ifndef LOCAL
#include <bits/stdc++.h>
#endif
using namespace std;
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx2")

#ifdef LOCAL
#include "algo/debug.h"
#else
template <typename... Args>
void dummy(Args&&... args){}
#define ps dummy
#endif

#define f first
#define s second
template<class T> using V = vector<T>; 
using vi = V<int>;
using vb = V<bool>;
using vs = V<string>;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x) 
#define len(x) (int)((x).size())
#define rsz resize
#define ins insert
#define ft front()
#define bk back()
#define pb push_back
#define eb emplace_back
#define pf push_front
#define lb lower_bound
#define ub upper_bound
#define ai2 array<int,2>
#define ai3 array<int,3>
#define ai4 array<int,4>
#define ai5 array<int,5>
template<class T> int lwb(const V<T>& a, const T& b) { return lb(all(a),b)-begin(a); }
template<class T> int upb(const V<T>& a, const T& b) { return ub(all(a),b)-begin(a); }
template<class T> bool ckmin(T& a, const T& b) { return a > b ? a=b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a=b, true : false; }
#define pct __builtin_popcountll
#define ctz __builtin_ctzll
#define clz __builtin_clzll
constexpr int p2(int x) { return (int)1 << x; }
constexpr int bits(int x) { return x == 0 ? 0 : 63-clz(x); } // floor(log2(x)) 
template<class T>void UNIQUE(V<T>& v) { sort(all(v)); v.erase(unique(all(v)),end(v)); }
template<class T,class U>void erase(T& t, const U& u) { auto it = t.find(u); assert(it != end(t)); t.erase(it); }
template<class F> struct y_combinator_result {
    F f;
    template<class T> explicit y_combinator_result(T &&f): f(std::forward<T>(f)) {}
    template<class ...Args> decltype(auto) operator()(Args &&...args) { return f(std::ref(*this), std::forward<Args>(args)...); }
};
template<class Fun> decltype(auto) yy(Fun &&fun) { return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun)); }

const int max_n = 1600, K = 1600;
V<ai2> b[2];
vi pre_len[2];
vi nxt[2][max_n];

void solve() {
    ai2 N, n;
    int k, q;
    cin >> N[0] >> n[0] >> N[1] >> n[1] >> k >> q;

    array<set<int>, 2> distinct;
    for (int s : { 0, 1 }) {
        pre_len[s].eb();
        for (int i = 0; i < n[s]; i++) {
            int l, v; cin >> l >> v; v--;
            b[s].pb({ v, l });
            pre_len[s].pb(pre_len[s].bk + l);
            distinct[s].ins(v);
        }
    }
    for (int s : { 0, 1 }) {
        vi last(k, n[s]);
        for (int i = n[s] - 1; i >= 0; i--) {
            last[b[s][i][0]] = i;
            for (int c = 0; c < k; c++) {
                nxt[s][i] = last;
            }
        }
    }


    if (N[0] <= 5000 && N[1] <= 5000) {
    // if (false) {
        V<vi> a(2);
        for (int s : { 0, 1 }) {
            auto& vec = a[s];
            for (auto [v, l] : b[s]) {
                for (int j = 0; j < l; j++) {
                    vec.pb(v);
                }
            }
        }

        V<V<vi>> nxt_a(2);
        for (int s : { 0, 1 }) {
            nxt_a[s] = V<vi>(N[s]);
            vi last(k, N[s]);
            for (int i = N[s] - 1; i >= 0; i--) {
                last[a[s][i]] = i;
                for (int c = 0; c < k; c++) {
                    nxt_a[s][i] = last;
                }
            }
        }

        V<vi> dp(N[0] + 1, vi(N[1] + 1));
        for (int i = 1; i <= N[0]; i++) {
            int cnt_w = 0;
            vb is_win(k);

            for (int j = 1; j <= N[1]; j++) {
                int c = a[1][N[1] - j];
                int ind = nxt_a[0][N[0] - i][c];
                if (ind < N[0]) {
                    cnt_w -= is_win[c];
                    is_win[c] = !dp[N[0] - ind - 1][j - 1];
                    cnt_w += is_win[c];
                }

                dp[i][j] = cnt_w;
            }
        }

        for (int i = 0; i < q; i++) {
            int x, y; cin >> x >> y;
            cout << ( dp[N[0] - x][N[1] - y] ? "Yes" : "No") << '\n';
        }

    } else if (len(distinct[0]) == n[0] && len(distinct[1]) == n[1]) {

        V<vi> dp(n[0] + 1, vi(n[1] + 1));
        for (int i = 1; i <= n[0]; i++) {
            int cnt_w = 0;
            vb is_win(k);

            for (int j = 1; j <= n[1]; j++) {
                int c = b[1][n[1] - j][0];
                int ind = nxt[0][n[0] - i][c];

                if (ind < n[0]) {
                    cnt_w -= is_win[c];
                    is_win[c] = !dp[n[0] - ind - 1][j - 1] && (min(b[0][ind][1], b[1][n[1] - j][1]) & 1);
                    cnt_w += is_win[c];
                }

                dp[i][j] = cnt_w;
            }
        }

        for (int i = 0; i < q; i++) {
            ai2 x, full_blocks;
            for (int s : { 0, 1 }) {
                cin >> x[s];
                full_blocks[s] = upb(pre_len[s], x[s]) - 1;
            }

            bool w = false;
            for (int c = 0; c < k; c++) {
                ai2 ind, sz;
                for (int s : { 0, 1 }) {
                    ind[s] = nxt[s][full_blocks[s]][c];
                }
                if (ind[0] < n[0] && ind[1] < n[1]) {
                    for (int s : { 0, 1 }) {
                        sz[s] = pre_len[s][ind[s] + 1] - max(x[s], pre_len[s][ind[s]]);
                    }

                    if (!dp[n[0] - ind[0] - 1][n[1] - ind[1] - 1] && (min(sz[0], sz[1]) & 1)) {
                        w = true;
                    }
                }
            }

            cout << (w ? "Yes" : "No") << '\n';
        }

    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    solve();
    return 0;
}
