#ifndef LOCAL
#pragma GCC optimize("O3")
#endif

#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
const ll nMax = 5010;
int amt1[nMax],amt2[nMax];
int pos1[nMax],pos2[nMax];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    ll N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<int> a, b;
    for (int i = 0; i < n; i++) {
        int l, v;
        cin >> l >> v;
        pos1[v]=a.size();
        amt1[v]=l;
        for (int i = 0; i < l; i++)a.push_back(v);
    }
    for (int i = 0; i < m; i++) {
        int l, v;
        cin >> l >> v;
        pos2[v]=b.size();
        amt2[v]=l;
        for (int i = 0; i < l; i++)b.push_back(v);
    }
    vector<pair<int,int>> loses;
    vector<pair<int,int>> dots;
    for(int i = 1; i <=k;i++){
        dots.push_back({pos1[i],pos2[i]});
        if(min(amt2[i],amt1[i])%2==0)continue;
        loses.push_back({pos1[i],pos2[i]});
    }
    sort(loses.begin(),loses.end());

    for(int i = 0; i < q; i++){
        int l,r;
        cin >> l >> r;
        bool haveLose = false;
        bool haveDots = false;
        for(auto [x,y] : loses) if(x > l && y > r)haveLose = true;
        for(auto [x,y] : dots) if(x > l && y > r)haveDots = true;
        int sz1 = pos1[a[l]]+amt1[a[l]]-l;
        int sz2 = pos2[a[l]]+amt2[a[l]]-r;
        bool inv = min(sz1,sz2)%2 ;
        cout << ((haveLose || inv  ) ? "Yes" : "No" ) <<'\n';
    }
}