#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
#include <queue>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

void solve()
{
	long long ns, n, ms, m, k, q;
	cin >> ns >> n >> ms >> m >> k >> q;
	vector<long long> a, b;
	for (long long i = 0; i < n; i++)
	{
		long long len, val;
		cin >> len >> val;
		val--;
		while (len--)
		{
			a.push_back(val);
		}
	}
	for (long long i = 0; i < m; i++)
	{
		long long len, val;
		cin >> len >> val;
		val--;
		while (len--)
		{
			b.push_back(val);
		}
	}

	vector<vector<bool>> dp(ns + 1, vector<bool>(ms + 1, false));
	vector<long long> nxta(k, ns);
	for (long long i = ns; i > -1; i--)
	{
		if (i < ns)
		{
			nxta[a[i]] = i;
		}
		vector<long long> nxtb(k, ms);
		for (long long j = ms; j > -1; j--)
		{
			if (j < ms)
			{
				nxtb[b[j]] = j;
			}
			for (long long add = 0; add < k; add++)
			{
				if (nxta[add] == ns || nxtb[add] == ms)
				{
					continue;
				}

				long long ti = nxta[add], tj = nxtb[add];
				if (!dp[ti + 1][tj + 1])
				{
					dp[i][j] = true;
					break;
				}
			}
		}
	}

	while (q--)
	{
		long long x, y;
		cin >> x >> y;
		cout << (dp[x][y] ? "Yes\n" : "No\n");
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
