#include<bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

int main()
{
  int N, n, M, m, k, q;
  cin >> N >> n >> M >> m >> k >> q;
  vector<int> a, b;
  vector<int> idxA[k], idxB[k];
  
  for(int i = 0, j = 0; i < n; i ++)
    {
      int l, v;
      cin >> l >> v;
      v--;
      while(l--)
	idxA[v].push_back(j++);
    }

  for(int i = 0, j = 0; i < m; i ++)
    {
      int l, v;
      cin >> l >> v;
      v--;
      while(l--)
	idxB[v].push_back(j++);
    }

  bool dp[N + 1][M + 1];
  memset(dp, false, sizeof(dp));

  for(int i = N; i >= 0; i--)
    for(int j = M; j >= 0; j--)
      for(int e = 0; e < k; e++)
	{
	  if(idxA[e].empty() || idxB[e].empty() || idxA[e].back() < i || idxB[e].back() < j)
	    continue;
	  
	  int nxtA = *lower_bound(all(idxA[e]), i)
	    , nxtB = *lower_bound(all(idxB[e]), j);

	  if(nxtA < N && nxtB < M)
	    dp[i][j] |= !dp[min(N, nxtA + 1)][min(nxtB + 1, M)];
	}

  /*
  for(int i = 0; i <= N; i ++)
    for(int j = 0; j <= M; j ++)
      cout << "dp[" << i << "][" << j << "] = " << dp[i][j] << "\n";
  //*/
  while(q--)
    {
      int x, y;
      cin >> x >> y;
      // x--, y--;
      cout << (dp[x][y] ? "Yes" : "No") << endl;
    }
  
  return 0;
}
