#include <bits/stdc++.h>
#pragma GCC optimize("unroll-loops")
//#define int long long

using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e18;
const int MOD = 1e9 + 7;
const int N = 3e5 + 69;

void solve() {
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<int> a, b;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        for (int j = 0; j < x; ++j) a.push_back(y);
    }
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        for (int j = 0; j < x; ++j) b.push_back(y);
    }
    vector<vector<int>> dp(N + 1, vector<int> (M + 1));
    dp[N][M] = false;
    for (int i = N - 1; i >= 0; --i) {
        for (int j = M - 1; j >= 0; --j) {
            if (a[i] == b[j] && !dp[i + 1][j + 1]) {
                dp[i][j] = true;
            } else if (a[i] != b[j]) {
                dp[i][j] = max({dp[i + 1][j], dp[i][j + 1], dp[i + 1][j + 1]});
            }
        }
    }
    while (q--) {
        int x, y;
        cin >> x >> y;
        if (dp[x][y]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
