#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = int(1e9) + 7, lg = 20;
const ll inf = ll(2e18) + 36;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<ll> a, b;
    for (ll i = 0; i < n; i++) {
        ll l, x;
        cin >> l >> x;
        x--;
        for (ll j = 0; j < l; j++) {
            a.emplace_back(x);
        }
    }
    for (ll i = 0; i < m; i++) {
        ll l, x;
        cin >> l >> x;
        x--;
        for (ll j = 0; j < l; j++) {
            b.emplace_back(x);
        }
    }
    swap(N, n);
    swap(M, m);
    vector<vector<vector<pair<ll, ll>>>> g(n, vector<vector<pair<ll, ll>>>(m));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < m; j++) {
            if (a[i] != b[j]) continue;
            vector<ll> f(k, -1), s(k, -1);
            for (ll e = i + 1; e < n; e++) {
                if (f[a[e]] < 0) {
                    f[a[e]] = e;
                }
            }
            for (ll e = j + 1; e < m; e++) {
                if (s[b[e]] < 0) {
                    s[b[e]] = e;
                }
            }
            for (ll e = 0; e < k; e++) {
                if (f[e] < 0 || s[e] < 0) continue;
                g[i][j].emplace_back(f[e], s[e]);
            }
        }
    }
    vector <vector <bool>> win(n, vector <bool>(m));
    for (ll i = n - 1; i >= 0; i--) {
        for (ll j = m - 1; j >= 0; j--) {
            for (auto& [f, s] : g[i][j]) {
                if (!win[f][s]) {
                    win[i][j] = true;
                    break;
                }
            }
        }
    }
    while (q--) {
        ll x, y; cin >> x >> y;
        cout << (win[x][y] ? "No\n" : "Yes\n");
    }
    return 0;
}
