#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <random>
#include <chrono>
using namespace std;
typedef int ll;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll N, n, M, m, k, q;
	cin >> N >> n >> M >> m >> k >> q;
	vector<ll> l1(n), v1(n), l2(m), v2(m), a, b;
	for (ll i = 0; i < n; ++i) {
		cin >> l1[i] >> v1[i];
		--v1[i];
	}
	for (ll i = 0; i < m; ++i) {
		cin >> l2[i] >> v2[i];
		--v2[i];
	}
	vector<vector<ll>> r1(n + 1, vector<ll>(k, n)), r2(m + 1, vector<ll>(k, m));
	for (ll i = n - 1; i >= 0; --i) {
		r1[i] = r1[i + 1];
		r1[i][v1[i]] = i;
	}
	for (ll i = m - 1; i >= 0; --i) {
		r2[i] = r2[i + 1];
		r2[i][v2[i]] = i;
	}
	vector<vector<vector<vector<ll>>>> dp(n + 1, vector<vector<vector<ll>>>(2, vector<vector<ll>>(m + 1, vector<ll>(2, 0))));
	for (ll i = n - 1; i >= 0; --i) {
		for (ll i1 = 0; i1 < 1; ++i1) {
			for (ll j = m - 1; j >= 0; --j) {
				for (ll j1 = 0; j1 < 2; ++j1) {
					if (v1[i] == v2[i]) {
						ll z = min(l1[i] - i1, l2[j] - j1);
						if (z % 2 == 0) dp[i][i1][j][j1] = max(max(dp[i + 1][0][j + 1][0], dp[i + 1][0][j + 1][1]), max(dp[i + 1][1][j + 1][0], dp[i + 1][1][j + 1][1]));
						else dp[i][i1][j][j1] = max(max(1 - dp[i + 1][0][j + 1][0], 1 - dp[i + 1][0][j + 1][1]), max(1 - dp[i + 1][1][j + 1][0], 1 - dp[i + 1][1][j + 1][1]));
						continue;
					}
					for (ll l = 0; l < k; ++l) {
						ll R1 = r1[i][l], R2 = r2[j][l];
						if (i1 == l1[i] % 2 && l == v1[i]) R1 = r1[i + 1][l];
						if (j1 == l2[i] % 2 && l == v2[j]) R2 = r2[j + 1][l];
						if (R1 == n || R2 == m) continue;
						ll i2 = 1, j2 = 1;
						if (R1 == i) i2 = 1 - i1;
						if (R2 == j) j2 = 1 - j1;
						if (dp[R1][i2][R2][j2] == 0) dp[i][i1][j][j1] = 1;
					}
				}
			}
		}
	}
	while (q--) {
		ll x, y;
		cin >> x >> y;
		ll i = 0, j = 0, i1 = 0, j1 = 0;
		while (x >= l1[i]) x -= l1[i++];
		i1 = x % 2;
		while (y >= l2[j]) y -= l2[j++];
		j1 = y % 2;
		if (dp[i][i1][j][j1]) cout << "Yes\n";
		else cout << "No\n";
	}
	cout << endl;
	return 0;
}