// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#ifdef LOCAL
// #define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
#define int long long
// #define ll __int128
using namespace std;
// using namespace __gnu_pbds;
// #define unordered_map gp_hash_table
// #define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

const int INF = 1e13 + 7;

void solve() {
    int n, z1, m, z2, k, q;
    cin >> n >> z1 >> m >> z2 >> k >> q;
    vector<int> a;
    for (int i = 0; i < z1; i++) {
        int l, v;
        cin >> l >> v;
        while (l--) {
            a.push_back(v);
        }
    }
    vector<int> b;
    for (int i = 0; i < z2; i++) {
        int l, v;
        cin >> l >> v;
        while (l--) {
            b.push_back(v);
        }
    }
    a.insert(a.begin(), -1);
    b.insert(b.begin(), -1);
    vector<vector<int>> t1(k + 1);
    vector<vector<int>> t2(k + 1);
    for (int i = 1; i <= n; i++) {
        t1[a[i]].push_back(i);
    }
    for (int i = 1; i <= m; i++) {
        t2[b[i]].push_back(i);
    }
    for (int i = 0; i <= k; i++) {
        t1[i].push_back(INF);
        t2[i].push_back(INF);
    }
    vector<vector<bool>> dp(n + 1, vector<bool>(m + 1));
    for (int x = n; x >= 0; x--) {
        for (int y = m; y >= 0; y--) {
            bool flag = false;
            for (int z = 0; z <= k; z++) {
                int a, b;
                a = *upper_bound(t1[z].begin(), t1[z].end(), x);
                b = *upper_bound(t2[z].begin(), t2[z].end(), y);
                if (a == INF || b == INF) {
                    continue;
                }
                flag |= !(dp[a][b]);
            }
            dp[x][y] = flag;
        }
    }
    while (q--) {
        int x, y;
        cin >> x >> y;
        if (dp[x][y]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    // cout << fixed << setprecision(20);
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}