#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#define ll long long
#define len(x) (int)x.size()
#define ld long double
#define all(x) x.begin(), x.end()
const ll mod1 = 1e9 + 7;

using namespace std;

void print(vector<int>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<ll>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<char>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<string>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<pair<int, int>>& a) {
	for (auto x : a) {
		cout << x.first << ' ' << x.second << '\n';
	}
}

void print(vector<vector<int>>& a) {
	for (auto x : a) {
		print(x);
	}
}

void print(vector<vector<ll>>& a) {
	for (auto x : a) {
		print(x);
	}
}

//#define int ll
//#define mtask

int ln, n, lm, m, k, q;
vector<int> a;
vector<int> b;
map<pair<int, int>, int> mem;


bool get(int i, int j) {
	if (mem.find({ i, j }) != mem.end()) return mem[{i, j}];
	if (i < ln - 1 && j < lm - 1) {
		if (a[i] == a[i + 1] && b[j] == b[j + 1] && a[i] == b[j]) {
			return mem[{i, j}] = get(i + 2, j + 2);
		}
	}
	vector<int> lst(k, -1);
	for (int t = ln - 1; t >= i; --t) {
		lst[a[t]] = t;
	}
	for (int t = j; t < lm; ++t) {
		if (lst[b[t]] != -1) {
			if (!get(lst[b[t]] + 1, t + 1)) {
				return mem[{i, j}] = true;
			}
			lst[b[t]] = -1;
		}
	}
	return mem[{i, j}] = false;
}

void solve() {
	cin >> ln >> n >> lm >> m >> k >> q;
	for (int i = 0; i < n; ++i) {
		int l, v;
		cin >> l >> v;
		--v;
		while (l--) {
			a.push_back(v);
		}
	}
	for (int i = 0; i < m; ++i) {
		int l, v;
		cin >> l >> v;
		--v;
		while (l--) {
			b.push_back(v);
		}
	}

	while (q--) {
		int x, y;
		cin >> x >> y;
		if (get(x, y)) {
			cout << "Yes\n";
			continue;
		}
		cout << "No\n";
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
	int tt;
	cin >> tt;
	while (tt--)
#endif
		solve();
}