#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

//#include <ext/pb_ds/assoc_containe.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template <class T> order_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//find_by_orede, order_of_key

#define int long long
#define all(a) (a).begin(), (a).end()

#pragma GCC optimize ("O3")
//#pragma GCC target ("avx2")


const int inf = 1e18;

map<pair<int, int>, bool> mp;


int N, M, n, m, k, q;
vector<vector<int>> colA, colB;

bool dfs(int i, int j) {
	if (mp.count({ i, j })) return mp[{i, j}];
	bool fl = 1;

	for (int t = 0; t < k; ++t) {
		auto A = upper_bound(all(colA[t]), i);
		if (A == colA[t].end()) continue;

		auto B = upper_bound(all(colB[t]), j);
		if (B == colB[t].end()) continue;

		int res = dfs(*A, *B);
		if (res == 0) return (mp[{i, j}] = 1);
	}

	mp[{i, j}] = 0;
	return mp[{i, j}];
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> N >> n >> M >> m >> k >> q;
	colA.assign(k, {});
	colB.assign(k, {});


	vector<int> a, b;
	for (int i = 0; i < n; ++i) {
		int l, num;
		cin >> l >> num;
		while (l--) {
			colA[num - 1].push_back(a.size());
			a.push_back(num);
			
		}
	}

	for (int i = 0; i < m; ++i) {
		int l, num;
		cin >> l >> num;
		while (l--) {
			colB[num - 1].push_back(b.size());
			b.push_back(num);
		}
	}
	
	while (q--) {
		int x, y; cin >> x >> y;
		bool f = 1;

		for (int t = 0; t < k && f; ++t) {
			auto A = lower_bound(all(colA[t]), x);
			if (A == colA[t].end()) continue;

			auto B = lower_bound(all(colB[t]), y);
			if (B == colB[t].end()) continue;

			f = dfs(*A, *B);
		}
		if (!f) cout << "Yes\n";
		else cout << "No\n";
	}
}