#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <immintrin.h>
#include <numeric>
#include <queue>

using ll = long long;
using ld = long double;
using namespace std;

#define unused(x) (void)x
#define used(x) (x)
#define temp(x) tmp_##x

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	// ooshp 2024-2025 zakluchitelnuy tur
	// Code is written by Mark_Pr (c) 2025
	int N, n, M, m, k, q;
	cin >> N >> n >> M >> m >> k >> q;
	unused(N);
	unused(M);
	unused(k);
	vector <int> pr1(1), pr2(1);
	vector <int> c1, c2;
	vector <int> s1, s2;
	vector <int> f;
	for (size_t i = 0; i < n; i++)
	{
		int x, d;
		cin >> x >> d;
		pr1.push_back(pr1.back() + x);
		c1.push_back(d);
		for (size_t j = 0; j < x; j++)
		{
			s1.push_back(d);
		}
		f.push_back(d);
		//c2.push_back(d);
	}
	for (size_t i = 0; i < m; i++)
	{
		int x, d;
		cin >> x >> d;
		pr2.push_back(pr2.back() + x);
		c2.push_back(d);
		for (size_t j = 0; j < x; j++)
		{
			s2.push_back(d);
		}
	}
	sort(f.begin(), f.end());
	f.resize(unique(f.begin(), f.end()) - f.begin());
	vector <vector <bool>> dp(s1.size(), vector<bool>(s2.size()));
	int q1 = s1.size(), q2 = s2.size();
	for (int i = q1 - 1; i >= 0; i--)
	{
		for (int j = q2 - 1; j >= 0; j--)
		{
			dp[i][j] = true;
			set <int> nums;
			for (int t = i + 1; t < q1; t++)
			{
				if (nums.count(s1[t]))
					continue;
				int t2 = find(s2.begin() + j + 1, s2.end(), s1[t]) - s2.begin();
				nums.insert(s1[t]);
				if (t2 != q2 && dp[t][t2])
				{
					dp[i][j] = false;
					break;
				}
			}
		}
	}
	vector <vector <bool>> ans(q1, vector<bool>(q2));
	for (int i = q1 - 1; i >= 0; i--)
	{
		for (int j = q2 - 1; j >= 0; j--)
		{
			ans[i][j] = dp[i][j];
			auto it = upper_bound(pr1.begin(), pr1.end(), i);
			if (*it != q1 && ans[*it][j])
				ans[i][j] = true;
		}
	}
	for (size_t i = 0; i < q; i++)
	{
		int x, y;
		cin >> x >> y;
		if (ans[x][y])
			cout << "Yes";
		else
			cout << "No";
		cout << '\n';
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
