#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

using namespace std;

int N, n, M, m;

vector<pair<int, int>> va;
vector<pair<int, int>> vb;
vector<int> va2;
vector<int> vb2;
vector<vector<int>> win;

vector<vector<int>> nxta;
vector<vector<int>> nxtb;

int k;

int rec(int a, int b, int sza, int szb) {
    if (a == n || b == m) {
        return 0;
    }
    if (win[a][b] != -1 && sza == va[a].first - 1 && szb == vb[b].first - 1) {
        return win[a][b];
    }
    win[a][b] = 0;
    if (sza == -1) {
        sza = va[a].first;
        szb = vb[b].first;
    }
    if (min(sza, szb) % 2 == 1) {
        win[a][b] = 1;
        return 1;
    }
    int c = va[a].second;
    for (int i = 0; i < k; i++) {
        int ta = nxta[a][i], tb = nxtb[b][i];
        if (ta == -1 || tb == -1 || i == c) {
            continue;
        }
        if (rec(ta, tb, va[ta].first - 1, vb[tb].first - 1) == 0) {
            win[a][b] = 1;
            return 1;
        }
    }
    
    return 0;
}


int main()
{
    //cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int q;
    cin >> N >> n >> M >> m >> k >> q;
    
    win.resize(n + 1, vector<int>(m + 1, -1));
    set<int> st;
    for (int i = 0; i < n; i++) {
        int l, v;
        cin >> l >> v;
        st.insert(v);
        va.push_back({l, v});
        for (int j = 0; j < l; j++) {
            va2.push_back(v);
        }
    }
    for (int i = 0; i < m; i++) {
        int l, v;
        cin >> l >> v;
        st.insert(v);
        vb.push_back({l, v});
        for (int j = 0; j < l; j++) {
            vb2.push_back(v);
        }
    }
    map<int, int> mp;
    int it = 0;
    for (auto i : st) {
        mp[i] = it++;
    }
    k = it;
    for (int i = 0; i < N; i++) {
        va2[i] = mp[va2[i]];
    }
    for (int i = 0; i < n; i++) {
        va[i].second = mp[va[i].second];
    }
    for (int i = 0; i < M; i++) {
        vb2[i] = mp[vb2[i]];
    }
    for (int i = 0; i < m; i++) {
        vb[i].second = mp[vb[i].second];
    }

    nxta.resize(n + 1);
    nxtb.resize(m + 1);
    vector<int> cur(k, -1);
    for (int i = n - 1; i >= 0; i--) {
        cur[va[i].second] = i;
        nxta[i] = cur;
    }
    cur.assign(k, -1);
    for (int i = m - 1; i >= 0; i--) {
        cur[vb[i].second] = i;
        nxtb[i] = cur;
    }

    for (int i = 0; i < q; i++) {
        int x, y;
        cin >> x >> y;
        int a = 0, b = 0;
        bool fl = false;
        while (x >= va[a].first) {
            x -= va[a].first;
            a++;
        }
        while (y >= vb[b].first) {
            y -= vb[b].first;
            b++;
        }
        int t = rec(a, b, va[a].first - x, vb[b].first - y);
        if (t == 1) {
            cout << "Yes" << '\n';
        } else {
            cout << "No" << '\n';
        }
    }




    return 0;
}