#ifndef LOCAL
  #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#ifndef LOCAL
  #pragma GCC target("avx,avx2,fma")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

int NOP(const vector<int>& a, const vector<int>& b) {
  const int n = a.size();
  const int m = b.size();
  vector dp(n + 1, vector<int>(m + 1));
  for (int i = 1; i <= n; ++i) {
    for (int j = 1; j <= m; ++j) {
      dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
      if (a[i - 1] == b[j - 1]) {
        dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + 1);
      }
    }
  }
  return dp[n][m];
}

void solve() {
  int N, n, M, m, k, q;
  cin >> N >> n >> M >> m >> k >> q;
  vector<int> a;
  for (int i = 0; i < n; ++i) {
    int l, v;
    cin >> l >> v;
    for (int j = 0; j < l; ++j) {
      a.push_back(v);
    }
  }
  vector<int> b;
  for (int i = 0; i < m; ++i) {
    int l, v;
    cin >> l >> v;
    for (int j = 0; j < l; ++j) {
      b.push_back(v);
    }
  }
  while (q --> 0) {
    int x, y;
    cin >> x >> y;
    int val = NOP(vector<int>(a.begin() + x, a.end()), vector<int>(b.begin() + y, b.end()));
    // cerr << "NOP " << x << ' ' << y << " -> " << val << endl;
    cout << (val & 1 ? "YES\n" : "NO\n");
  }
}

signed main() {
  // freopen("in", "r", stdin);
  cin.tie(0)->sync_with_stdio(0);
  int t = 1;
  // cin >> t;
  for (int i = 0; i < t; ++i) {
    solve();
  }
}