#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double

int N, n, M, m, k, q;
ll mod = 1000000007;
ll p = 1601;
vector<ll> P;

ll get_hash(int l, int r, vector<ll> &h) {
    ll ans = h[r] - (h[l] * P[r - l]) % mod;
    if (ans < 0) ans += mod;
    return ans;
}

void solve() {
    cin >> N >> n >> M >> m >> k >> q;
    vector<ll> a, b;
    P.resize(max(N, M) + 1, 1);
    for (int i = 1; i <= max(N, M); ++i) {
        P[i] = (P[i-1] * p) % mod;
    }

    for (int i = 0; i < n; ++i) {
        int l, v; cin >> l >> v;
        for (int j = 0; j < l; ++j) {
            a.push_back(v);
        }
    }
    vector<ll> ha(N + 1);
    for (int i = 1; i <= N; ++i) {
        ha[i] = (ha[i-1] * p) % mod + (a[i-1]);
        if (ha[i] >= mod) ha[i]-=mod;
    }

    for (int i = 0; i < m; ++i) {
        int l, v; cin >> l >> v;
        for (int j = 0; j < l; ++j) {
            b.push_back(v);
        }
    }
    vector<ll> hb(M + 1);
    for (int i = 1; i <= M; ++i) {
        hb[i] = (hb[i-1] * p)%mod + (b[i-1]);
        if (hb[i] >= mod) hb[i]-=mod;
    }

    while (q--) {
        int x1, x2; cin >> x1 >> x2;
        int l = 0, r = min(N - x1, M - x2) + 1, mid;
        while (r - l > 1) {
            mid = ((r + l)>>1);
            if (get_hash(x1, x1 + mid, ha) == get_hash(x2, x2 + mid, hb)) l = mid;
            else r = mid;
        }
        cout << l << '\n';
        if (l % 2 == 1) cout << "Yes\n";
        else cout << "No\n";
    }
}

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
}
