#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll INF = 1e9 + 5;

void solve() {
    ll n1, n, m1, m, k, q;
    cin >> n1 >> n >> m1 >> m >> k >> q;
    vector<ll> a, b;
    for (ll i = 0; i < n; ++i) {
        ll l, v;
        cin >> l >> v;
        for (ll j = 0; j < l; ++j) {
            a.push_back(v - 1);
        }
    }
    for (ll i = 0; i < m; ++i) {
        ll l, v;
        cin >> l >> v;
        for (ll j = 0; j < l; ++j) {
            b.push_back(v - 1);
        }
    }

    vector<vector<ll>> next_a(n1 + 1, vector<ll> (k, -1)), next_b(m1 + 1, vector<ll> (k, -1));
    for (ll i = n1 - 1; i >= 0; --i) {
        next_a[i] = next_a[i + 1];
        next_a[i][a[i]] = i;
    }
    for (ll i = m1 - 1; i >= 0; --i) {
        next_b[i] = next_b[i + 1];
        next_b[i][b[i]] = i;
    }

    vector<vector<ll>> dp(n1 + 1, vector<ll> (m1 + 1, 0));
    for (ll i = n1 - 1; i >= 0; --i) {
        for (ll j = m1 - 1; j >= 0; --j) {
            for (ll v = 0; v < k; ++v) {
                if (next_a[i][v] != -1 && next_b[j][v] != -1 && dp[next_a[i][v] + 1][next_b[j][v] + 1] == 0) {
                    dp[i][j] = 1;
                    break;
                }
            }
        }
    }

    for (ll i = 0; i < q; ++i) {
        ll x, y;
        cin >> x >> y;
        if (dp[x][y] == 1) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
