#include <bits/stdc++.h>
#define pb push_back
#define endl "\n"
// #define pb push_back
using namespace std;
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;


void solve(){
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<int> a, b;
    for (int i = 0; i < n; ++i){
        int l, v;
        cin >> l >> v;
        v--;
        while (l--) a.pb(v);
    }
    for (int i = 0; i < m; ++i){
        int l, v;
        cin >> l >> v;
        v--;
        while (l--) b.pb(v);
    }
    vector<int> lasta(k, N), lastb(k, M);
    vector<vector<int>> nexta(N, vector<int> (k, N)), nextb(M, vector<int> (k, M));
    for (int i = N - 1; i > -1; --i){
        for (int j = 0; j < k; ++j){
            nexta[i][j] = lasta[j];
        }
        lasta[a[i]] = i;
    }
    for (int i = M - 1; i > -1; --i){
        for (int j = 0; j < k; ++j){
            nextb[i][j] = lastb[j];
        }
        lastb[b[i]] = i;
    }
    vector<vector<int>> good(N + 1, vector<int> (M + 1, 0));
    for (int i = N - 1; i > -1; --i){
        for (int j = M - 1; j > -1; --j){
            int ok = 0;
            for (int el = 0; el < k; ++el){
                if (nexta[i][el] == N || nextb[j][el] == M) continue;
                if (good[nexta[i][el]][nextb[j][el]] == 0) ok = 1;
            }
            good[i][j] = ok;
        }
    }
    while (q--){
        int x, y;
        cin >> x >> y;
        if (good[x][y] == 0){
            cout << "Yes" << endl;
        } else{
            cout << "No" << endl;
        }
    }
}



signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    // cin >> t;
    while (t--){
        solve();
    }
}