#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rec(vector<deque<ll>> osta, vector<deque<ll>> ostb, ll k){
    for (auto &x: osta) while (!x.empty() && x[0] <= k) x.pop_front();
    for (auto &x: ostb) while (!x.empty() && x[0] <= k) x.pop_front();
    ll fl = 0;
//    ll cnt = 0;
    for (int i=0; i<osta.size(); ++i) if (!osta[i].empty() && !ostb[i].empty()) fl |= !rec(osta, ostb, max(osta[i][0], ostb[i][0]));
//    cout << k << ' ' << ostb[0].size() << '\n';
    return fl;
}

void solve(){
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    deque<ll> a, b;
    for (int i=0; i<n; ++i){
        int l, r;
        cin >> l >> r;
        while (l--) a.push_back(r);
    }
    for (int i=0; i<m; ++i){
        int l, r;
        cin >> l >> r;
        while (l--) b.push_back(r);
    }
    while (q--){
        int x, y;
        cin >> x >> y;
        auto a1 = a, b1 = b;
        while (x--) a1.pop_front();
        while (y--) b1.pop_front();
        vector<deque<ll>> osta(k);
        vector<deque<ll>> ostb(k);
        for (int i=0; i<a1.size(); ++i) osta[a1[i]-1].push_back(i);
        for (int i=0; i<b1.size(); ++i) ostb[b1[i]-1].push_back(i);
        cout << (rec(osta, ostb, -1) ? "Yes" : "No") << '\n';
//        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t;
//    cin >> t;
    t = 1;
    while (t--) solve(), cout << '\n';
    return 0;
}
