#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<cstdio>
#include<unordered_set>
#include<unordered_map>
#include<iomanip>
#include<random>
#include<bitset>
#include<ctime>

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;

ll gcd(ll a, ll b) {
	return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}
mt19937 mt(time(0));
const int N = 3e5 + 2, inf = 1e9 + 100, mod = 1e9 + 7, mod2 = 998244353, P = 257;
const ll llinf = 1e18 + 100;
struct segtree {
	struct node {
		int mn, indmn, mx, indmx;
		node() : mn(inf), indmn(-1), mx(-inf), indmx(-1) {}
		node operator+(node a) {
			node ans;
			ans.mn = min(mn, a.mn);
			ans.indmn = mn == ans.mn ? indmn : a.indmn;
			ans.mx = max(mx, a.mx);
			ans.indmx = mx == ans.mx ? indmx : a.indmx;
			return ans;
		}
	};
	node t[N * 2];
	segtree() {
		fill(t, t + N * 2, node());
	}
	void upd(int v, int l, int r, int i, int val, int ty) {
		if (r - l == 1) {
			t[v].mn = ty == 0 ? val : inf;
			t[v].indmn = l;
			t[v].mx = ty == 1 ? val : -inf;
			t[v].indmx = l;
			return;
		}
		int m = (l + r) >> 1;
		if (i < m) upd(v + 1, l, m, i, val, ty);
		else
			upd(v + 2 * (m - l), m, r, i, val, ty);
		t[v] = t[v + 1] + t[v + 2 * (m - l)];
	}
	void upd(int i, int val, int ty) {
		upd(0, 0, N, i, val, ty);
	}
	node get(int v, int l, int r, int ql, int qr) {
		if (r <= ql || qr <= l) return node();
		if (ql <= l && r <= qr) return t[v];
		int m = (l + r) >> 1;
		return get(v + 1, l, m, ql, qr) + get(v + 2 * (m - l), m, r, ql, qr);
		t[v] = t[v + 1] + t[v + 2 * (m - l)];
	}
	node get(int l, int r) {
		return get(0, 0, N, l, r);
	}
};
struct segtree2 {
	struct node {
		int sum, mn, mn2, rmn, rmn2, mx, mx2, rmx, rmx2;
		node() : sum(0), mn(inf), mn2(inf), rmn(-1), rmn2(-1), mx(-inf), mx2(-inf), rmx(-1), rmx2(-1) {}
		node operator+(node a) {
			a.mn += sum;
			a.mn2 += sum;
			a.mx += sum;
			a.mx2 += sum;
			node ans;
			ans.sum = sum + a.sum;
			if (mn == a.mn) {
				ans.mn = a.mn, ans.rmn = a.rmn;
				if (mn2 < a.mn2) ans.mn2 = mn2, ans.rmn2 = rmn2;
				else
					ans.mn2 = a.mn2, ans.rmn2 = a.rmn2;
			} else if (mn < a.mn) {
				ans.mn = mn, ans.rmn = rmn;
				if (mn2 < a.mn) ans.mn2 = mn2, ans.rmn2 = rmn2;
				else
					ans.mn2 = a.mn, ans.rmn2 = a.rmn2;
			} else {
				ans.mn = a.mn, ans.rmn = a.rmn;
				if (mn < a.mn2) ans.mn2 = mn, ans.rmn2 = rmn;
				else
					ans.mn2 = a.mn2, ans.rmn2 = a.rmn2;
			}
			if (mx == a.mx) {
				ans.mx = a.mx, ans.rmx = a.rmx;
				if (mx2 > a.mx2) ans.mx2 = mx2, ans.rmx2 = rmx2;
				else
					ans.mx2 = a.mx2, ans.rmx2 = a.rmx2;
			} else if (mx > a.mx) {
				ans.mx = mx, ans.rmx = rmx;
				if (mx2 > a.mx) ans.mx2 = mx2, ans.rmx2 = rmx2;
				else
					ans.mx2 = a.mx, ans.rmx2 = a.rmx2;
			} else {
				ans.mx = a.mx, ans.rmx = a.rmx;
				if (mx > a.mx2) ans.mx2 = mx, ans.rmx2 = rmx;
				else
					ans.mx2 = a.mx2, ans.rmx2 = a.rmx2;
			}
			return ans;
		}
	};
	node t[N * 2];
	segtree2() {
		fill(t, t + N * 2, node());
	}
	void upd(int v, int l, int r, int i, int x) {
		if (r - l == 1) {
			t[v].mn = x;
			t[v].mx = x;
			t[v].rmn = l;
			t[v].rmx = l;
			t[v].sum = x;
			return;
		}
		int m = (l + r) >> 1;
		if (i < m) upd(v + 1, l, m, i, x);
		else
			upd(v + 2 * (m - l), m, r, i, x);
		t[v] = t[v + 1] + t[v + 2 * (m - l)];
	}
	void upd(int i, int x) {
		upd(0, 0, N, i, x);
	}
	node get(int v, int l, int r, int ql, int qr) {
		if (r <= ql || qr <= l) return node();
		if (ql <= l && r <= qr) return t[v];
		int m = (l + r) >> 1;
		return get(v + 1, l, m, ql, qr) + get(v + 2 * (m - l), m, r, ql, qr);
	}
	node get(int l, int r) {
		return get(0, 0, N, l, r);
	}
};
segtree t;
segtree2 t2;
int n, m, a[N];

void solve() {
	cin >> n >> m;
	ll sum = 0;
	for (int i = 0; i < m; ++i) cin >> a[i];
	reverse(a, a + m);
	int cnt = 0;
	for (int i = 0; i < m; ++i) {
		if (a[i] >= 0) {
			t.upd(i, a[i], 0);
			t2.upd(i, 1);
			sum += a[i];
			++cnt;
		} else {
			t.upd(i, a[i], 1);
			t2.upd(i, -1);
			sum -= a[i];
			--cnt;
		}
		if (cnt > n) {
			auto p = t2.get(0, i + 1);
			int last1 = -1;
			if (p.mn <= 1) last1 = max(last1, p.rmn);
			if (p.mn2 <= 1) last1 = max(last1, p.rmn2);
			int ind = t.get(last1 + 1, i + 1).indmn;
			sum -= a[ind] * 2;
			t.upd(ind, a[ind], 1);
			t2.upd(ind, -1);
			cnt -= 2;
		}
		if (cnt < 0) {
			auto p = t2.get(0, i + 1);
			int last1 = -1;
			if (p.mx >= n - 1) last1 = max(last1, p.rmx);
			if (p.mx2 >= n - 1) last1 = max(last1, p.rmx2);
			int ind = t.get(last1 + 1, i + 1).indmx;
			sum += a[ind] * 2;
			t.upd(ind, a[ind], 0);
			t2.upd(ind, 1);
			cnt += 2;
		}
	}
	cout << sum;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
		cout.flush();
	}
	return 0;
}