#include <bits/stdc++.h>

using namespace std;

constexpr long long INF = (long long)1e18 + 7;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
    }
    reverse(x.begin(), x.end());
    vector<vector<long long>> dp(m + 1, vector<long long>(n + 1, -INF));
    dp[0][n] = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (j > 0) {
                dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] + x[i]);
            }
            if (j + 1 <= n) {
                dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] - x[i]);
            }
        }
    }
    long long ans = -INF;
    for (int i = 0; i <= n; ++i) {
        ans = max(ans, dp[m][i]);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
