#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 2e5 + 10;

int n, m, a[N];
set<pii> dp0, dp1;

void solve() {
    cin >> n >> m;
    for(int i = 1; i <= m; ++i) cin >> a[i];

    dp0.clear(); dp1.clear();
    dp0.insert({0, 0});
    for(int i = 1; i <= m; ++i) {
        for(auto [x1, x2] : dp0) {
            dp1.insert({a[i] - x1, x2});
            dp1.insert({x1, a[i] - x2});
        }
        swap(dp0, dp1);
        dp1.clear();
    }
    int ans = 0;
    for(auto to : dp0) {
        ans = max(ans, to.X + to.Y);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    auto start = clock();
#endif
    int ttt = 1;
    cin >> ttt;
    while(ttt--) {
        solve();
    }
#ifdef LOCAL
    auto end = clock();
    cerr << "TIME: " << (end - start) << "ms" << '\n';
#endif
}