#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll infll = 1e18;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    vector<ll> dp(n + 1);
    for (int i = 0; i < m; i++) {
        vector<ll> ndp(n + 1, -infll);
        for (int j = 0; j <= n; j++) {
            if (j > 0) {
                ndp[j - 1] = max(ndp[j - 1], dp[j] + x[i]);
            }
            if (j < n) {
                ndp[j + 1] = max(ndp[j + 1], dp[j] - x[i]);
            }
        }
        dp = ndp;
    }
    cout << dp[0] << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
}
