#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

auto seed = std::chrono::steady_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

using ll = long long;

#define int ll

using vi = vector<int>;
using pii = pair<int, int>;
using vp = vector<pair<int, int>>;

template<class T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;
ll inf = 1e18;

void solve() {
    int n, m;
    cin >> n >> m;
    int sz = m + n;
    if (sz % 2 == 1) {
        sz--;
    }
    vi x(m);

    for (int i = 0; i < m; ++i) {
        cin >> x[i];
    }
    ll an = -inf;
    for (int ma = 0; ma < 1 << m; ++ma) {
        vi a;
        vi b;
        for (int j = 0; j < m; ++j) {
            if (ma >> j & 1) {
                a.push_back(x[j]);
            } else {
                b.push_back(x[j]);
            };
        }
        ll tec = 0;
        std::reverse(a.begin(), a.end());
        std::reverse(b.begin(), b.end());
        for (int i = 0; i < a.size(); ++i) {
            if (i % 2 == 1) {
                tec -= a[i];
            } else {
                tec += a[i];
            }
        }
        for (int i = 0; i < b.size(); ++i) {
            if (i % 2 == 1) {
                tec -= b[i];
            } else {
                tec += b[i];
            }
        }
        an = max(an, tec);
    }
    cout << an << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
    freopen("C:\\work\\untitled\\output.txt", "w", stdout);
    auto start = std::chrono::steady_clock::now();
#else
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(0);
#endif
    int t_ = 1;
    cin >> t_;
    while (t_--) {
        solve();
    }

#ifdef LOCAL
    auto end = std::chrono::steady_clock::now();
    cout << "\n======\n";
    cout << chrono::duration_cast<chrono::milliseconds>(end - start);
#endif
}
