#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#define endl '\n'
#define int long long

using namespace std;

int md = 4e9;

int twoinone(int a, int b) {
    return a * md + b;
}

pair<int, int> oneintwo(int a) {
    return {a / md, a % md};
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<int> a(m);
        for (int i = 0; i < m; ++i) {
            cin >> a[i];
        }
        unordered_map<int, pair<int, int>> d;
        d[0] = {0, 0};
        for (int i = 0; i < m; ++i) {
            unordered_map<int, pair<int, int>> w;
            for (auto it = d.begin(); it != d.end(); ++it) {
                int u = (it -> second).first;
                int v = (it -> second).second;
                int q1 = a[i] - u;
                int w1 = v;
                if (q1 < w1) {
                    swap(q1, w1);
                }
                int q2 = u;
                int w2 = a[i] - v;
                if (q2 < w2) {
                    swap(q2, w2);
                }
                if (w.find(q1 + w1) == w.end()) {
                    w[q1 + w1] = {q1, w1};
                } else if (q1 > w[q1 + w1].first) {
                    w[q1 + w1] = {q1, w1};
                }
                if (w.find(q2 + w2) == w.end()) {
                    w[q2 + w2] = {q2, w2};
                } else if (q1 > w[q2 + w2].first) {
                    w[q2 + w2] = {q2, w2};
                }
            }
            d = w;
        }
        int ans = -2e9;
        for (auto it = d.begin(); it != d.end(); ++it) {
            ans = max(ans, (it -> first));
        }
        cout << ans << endl;
    }
    return 0;
}
