#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")
#endif

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;

const int maxn = 2000;
ll dp[maxn + 1][maxn + 1];

void solve() {
    int n, m;
    cin >> n >> m;  
    vector<ll> ar(m);
    for (ll &i: ar) {
        cin >> i;
    }
    reverse(all(ar));
    dp[0][0] = 0;
    for(int i = 1; i <= n; ++i){
        dp[0][i] = -1e18;
    }
    for(int i = 1; i <= m; ++i){
        dp[i][0] = dp[i - 1][1] - ar[i - 1];
        for(int j = 1; j < n; ++j) {
            dp[i][j] = max(dp[i - 1][j - 1] + ar[i - 1], dp[i - 1][j + 1] - ar[i - 1]);
        }
        dp[i][n] = dp[i - 1][n - 1] + ar[i - 1];
    }
    ll ans = -1e18;
    for(int i = 0; i <= n; ++i){
        ans = max(ans, dp[m][i]);
    }
    cout << ans << '\n';
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("C:\\Users\\User\\aboab\\input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while(t--)
        solve();
}