#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

#define ll long long

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vector<ll> b(m);
        for (ll i = 0; i < m; i++) {
            cin >> b[i];
        }
        vector<vector<vector<bool>>> dp(m, vector<vector<bool>>(1000, vector<bool>(1000)));
        dp[0][b[0] + 500][500] = true;
        dp[0][500][b[0] + 500] = true;
        for (ll i = 1; i < m; i++) {
            for (ll i1 = 0; i1 < 1000; i1++) {
                for (ll j1 = 0; j1 < 1000; j1++) {
                    if (!dp[i - 1][i1][j1]) {
                        continue;
                    }
                    ll x1 = i1 - 500;
                    ll y1 = j1 - 500;
                    x1 = b[i] - x1;
                    dp[i][x1 + 500][y1 + 500] = true;
                    x1 = i1 - 500;
                    y1 = j1 - 500;
                    y1 = b[i] - y1;
                    dp[i][x1 + 500][y1 + 500] = true;
                }
            }
        }
        ll answer = -1e18;
        for (ll i1 = 0; i1 < 1000; i1++) {
            for (ll j1 = 0; j1 < 1000; j1++) {
                if (dp[m - 1][i1][j1]) {
                    answer = max(answer, i1 + j1 - 1000);
                }
            }
        }
        cout << answer << '\n';
    }
}