#include <iostream>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <set>
#include <bitset>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <algorithm>
#include <random>

using namespace std;

random_device rd;
mt19937 rnd(rd());

#define int long long
using pii = pair<int, int>;

void solve() {
    int n, m; cin >> n >> m;
   // vector<int> a(n, 0);
    set<pii> s;
    for (int i = 0; i < n; i++) {
        s.insert({0, i});
    }
    while (m--) {
        int x; cin >> x;
        auto [val, id] = *s.begin();
        s.erase({val, id});
        val = x - val;
        s.insert({val, id});
    }
    int res = 0;
    for (auto [val, id] : s) {
        res += val;
    }
    cout << res << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
