#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve(){
    ll n, m;
    cin >> n >> m;

    multiset<ll> a;
    for (int i = 0; i < n; ++i) {
        a.insert(0);
    }

    ll sum = 0;
    while (m--){
        ll x;
        cin >> x;

        ll v = *a.begin();
        a.erase(a.begin());

        sum += -v + (x - v);
        a.insert(x - v);
    }

    cout << sum << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t;
    cin >> t;

    while (t--) solve();
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}