#include <iostream>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;

int inf = 1e17;

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<int> dp;
    dp.resize(n + 1, -inf);
    dp[0] = 0;
    vector<int> x(m);
    for(int &z : x) cin >> z;
    reverse(x.begin(), x.end());
    for(int i = 0; i < m; ++i){
        for(int j = (i + 1)%2; j <= n; j += 2){
            if(j == 0) dp[j] = dp[1] - x[i];
            else if(j == n) dp[j] = dp[j - 1] + x[i];
            else dp[j] = max(dp[j - 1] + x[i], dp[j + 1] - x[i]);
        }
    }
    int ans = -inf;
    for(int i = m%2; i <= n; i += 2)
        ans = max(ans, dp[i]);
    cout << ans << endl;
}

signed main()
{
    int t;
    cin >> t;
    for(int i = 0; i < t; ++i) solve();
}