#include <bits/stdc++.h>


using namespace std;


using ll = long long;


const ll inf = 1e18 + 7;


ostream & operator <<(ostream &os, pair<ll, ll> &a) {
    os << "{" << a.first << " " << a.second << "}";
    return os;
}


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


pair<ll, ll> maxx(const pair<ll, ll> &a, const pair<ll, ll> &b) {
    if (a.first + a.second > b.first + b.second) {
        return a;
    }
    return b;
}


pair<ll, ll> minn(const pair<ll, ll> &a, const pair<ll, ll> &b) {
    if (a.first + a.second > b.first + b.second) {
        return b;
    }
    return a;
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> xs(m + 1, 0);
    for (int i = 1; i <= m; i++) {
        cin >> xs.at(i);
    }
    ll x = xs.at(1);
    ll diff = m - n;
    if (m >= n) {
        if (diff % 2 == 0) {
            cout << n * x << '\n';
        } else {
            cout << (n - 1) * x << '\n';
        }
    } else {
        cout << x * diff << '\n';
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}


/*1
2 3
2 3 5*/


/*
1
2 7
10 3 7 1 4 6 3
*/

/*4
1 4
1 2 3 4
2 7
10 3 7 1 4 6 3
4 10
103 354 1
227 179 189 142 201 165 140
5 3
-10 11 -4*/
