#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <experimental/random>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3,unroll-loops")
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;
#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << "\n";
    }
}

vector<int> a;
int n;
vector<vector<int>> ans;

int solve(int k, int l) {
    if (l == -1) {
        return 0;
    }
    if (ans[k][l] != -INF) {
        return ans[k][l];
    }
    int an;
    if (k == 0) {
        an = solve(k + 1, l - 1) - a[l];
    } else if (k == n) {
        an = solve(k - 1, l - 1) + a[l];
    } else {
        an = max(solve(k + 1, l - 1) - a[l], solve(k - 1, l - 1) + a[l]);
    }
    ans[k][l] = an;
    return an;
}

void solve() {
    int m;
    cin >> n >> m;
    a.clear();
    a.resize(m);
    ans.clear();
    ans.resize(n + 1, vector<int>(m, -INF));
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    cout << solve(n, m - 1);
}