#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<long long> arr(m);
    for(int i = 0; i < m; i++) cin >> arr[i];
    reverse(arr.begin(), arr.end());
    vector<vector<long long>> dp(m + 1, vector<long long>(1 << n, LLONG_MIN / 2));
    dp[0][0] = 0;
    for(int i = 1; i <= m; i++) {
        for(int mask = 0; mask < (1 << n); mask++) {
            for(int j = 0; j < n; j++) {
                dp[i][mask] = max(dp[i][mask], dp[i - 1][mask ^ (1 << j)] +
                        arr[i - 1] * ((((mask >> j) & 1)) ? 1 : -1));
            }
        }
    }
    long long ans = *max_element(dp[m].begin(), dp[m].end());
    cout << ans << '\n';
}

/*
a = x1 - a
a = x2 - a = x2 - (x1 - a) = x2 - x1 + a = x2 - x1
a = x3 - a = x3 - (x2 - x1) = x3 - x2 + x1
a = x4 - a = x4 - (x3 - x2 + x1) = x4 - x3 + x2 - x1
*/

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) solve();
}
