#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<long long> arr(m);
    for(int i = 0; i < m; i++) cin >> arr[i];
    reverse(arr.begin(), arr.end());
    vector<vector<long long>> dp(m + 1, vector<long long>(n + 1, LLONG_MAX / 2));
    dp[0][0] = 0;
    for(int i = 1; i <= m; i++) {
        for(int j = 0; j <= n; j++) {
            if(j > 0) dp[i][j] = min(dp[i][j], dp[i - 1][j - 1]);
            if(j < n) dp[i][j] = min(dp[i][j], dp[i - 1][j + 1] + arr[i - 1]);
        }
    }
    long long ans = *min_element(dp[m].begin(), dp[m].end());
    // cout << ">>> " << ans << '\n';
    ans *= -2;
    for(auto i : arr) ans += i;
    cout << ans << '\n';
}

/*
a = x1 - a
a = x2 - a = x2 - (x1 - a) = x2 - x1 + a = x2 - x1
a = x3 - a = x3 - (x2 - x1) = x3 - x2 + x1
a = x4 - a = x4 - (x3 - x2 + x1) = x4 - x3 + x2 - x1
*/

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) solve();
}
