#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend();

void solve();

int main() {
	cin.tie(nullptr)->sync_with_stdio(false);
	cout << fixed << setprecision(30);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> x(m);
	for (int i = 0; i < m; i++) {
		cin >> x[i];
	}
	reverse(all(x));
	vector<vector<ll>> dp(m + 1, vector<ll>(n + 1, INT64_MIN / 2));
	dp[0][0] = 0;
	for (int i = 0; i < m; i++) {
		for (int j = 0; j <= n; j++) {
			if (j) {
				dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] - x[i]);
			}
			if (j < n) {
				dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] + x[i]);
			}
		}
	}
	ll ans = INT64_MIN / 2;
	for (int i = 0; i <= n; i++) {
		ans = max(ans, dp[m][i]);
	}
	cout << ans << '\n';
}
