#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

constexpr ll inf = 1e18;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (ll &e : x) cin >> e;
    set<vector<ll>> able;
    able.emplace(n, 0);
    for (ll const &e : x) {
        auto able_ = able;
        able.clear();
        for (vector<ll> p : able_) {
            for (int i = 0; i < n; ++i) {
                p[i] = e - p[i];
                able.insert(p);
            }
        }
    }
    ll ans = -inf;
    for (vector<ll> const &p : able) ans = max(ans, accumulate(all(p), 0ll));
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--)
    solve();
}