#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock().now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename T>
using orderet_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ull = unsigned long long;
using uint = unsigned int;
using ld = long double;
using dd = double;

#define int ll

void solve(){
    int n, m;
    cin>>n>>m;
    set<pair<int, int>> st;
    ll sum = 0;
    for(int i = 0; i < n; ++i){
        st.insert({0, i});
    }
    vector<int> x(m);
    for(int i = 0; i < m; ++i) cin>>x[i];
    sort(x.begin(), x.end());
    for(int i = 0; i < m; ++i){
        auto [val, ind] = *st.begin();
        st.erase({val, ind});
        sum -= val;
        st.insert({x[i] - val, ind});
        sum += x[i] - val;
    }
    cout << sum << "\n";
}

signed main(){
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    int t = 1;
    cin>>t;
    while(t--) solve();
}