#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock().now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename T>
using orderet_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ull = unsigned long long;
using uint = unsigned int;
using ld = long double;
using dd = double;

#define int ll

void solve(){
    int n, m;
    cin>>n>>m;
    map<int, int> mp;
    mp[0] = 0;
    for(int i = 0; i < m; ++i){
        int x;
        cin>>x;
        map<int, int> mp1;
        for(auto [val1, val2]: mp){
            if(mp1.find(x-val1) != mp1.end()) 
                mp1[x - val1] = max(mp1[x - val1], mp[val1]);
            else
                mp1[x-val1] = mp[val1];
            if(mp1.find(val1) != mp1.end())
                mp1[val1] = max(x - val2, mp1[val1]);
            else
                mp1[val1] = x - val2;
        }
        mp = mp1;
    }
    int ans = 0;
    for(auto c: mp) ans = max(ans, c.first + c.second);
    cout << ans << "\n";
}

signed main(){
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    int t = 1;
    cin>>t;
    while(t--) solve();
}