#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll infLL = 3e18;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> X(m);
    for (int i = 0; i < m; ++i) {
        cin >> X[i];
    }
    vector<ll> dp(n + 1, -infLL);
    dp[0] = 0;
    for (int i = m - 1; i >= 0; --i) {
        int x = X[i];
        vector<ll> dq(n + 1, -infLL);
        for (int k = 0; k <= n; ++k) {
            if (dp[k] <= -infLL) {
                continue;
            }
            for (int d : {-1, 1}) {
                int nk = k + d;
                if (nk >= 0 && nk <= n) {
                    dq[nk] = max(dq[nk], dp[k] + d * X[i]);
                }
            }
        }
        swap(dp, dq);
    }
    cout << *max_element(dp.begin(), dp.end()) << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}