#include <iostream>
#include <cstdint>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>

using namespace std;
using ll = long long;
using ull = unsigned long long;

constexpr int maxn = 3e5 + 10;
constexpr ll inf = 1e18;

int n, m;
ll vals[maxn];
ll dp[maxn], ndp[maxn];

void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) cin >> vals[i];
    ll cnt = std::min(n - 1, m - 1);
    ll ans = vals[0] * cnt;
    if ((m - cnt) % 2 != 0) ans += vals[0];
    cout << ans << "\n";
//    if (m % 2 == 0) cout << 0;
//    else cout << ;
//    for (int i = 0; i <= n; ++i) dp[i] = -inf;
//    dp[n] = 0;
//    for (int i = m - 1; i >= 0; --i) {
//        for (int j = 0; j <= n; ++j) ndp[j] = -inf;
//        for (int j = 0; j <= n; ++j) {
//            if (j) ndp[j - 1] = std::max(ndp[j - 1], dp[j] + vals[i]);
//            if (j + 1 <= n) ndp[j + 1] = std::max(ndp[j + 1], dp[j] - vals[i]);
//        }
//        swap(dp, ndp);
//    }
//    cout << *max_element(dp, dp + n + 1) << "\n";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    cin >> t;
    while (t--) solve();
    return 0;
}
