#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define db long double

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, m, ans = LLONG_MIN; cin >> n >> m;

    vector<int> a(m);
    for (int i = 0; i < m; ++i) cin >> a[i];

    reverse(a.begin(), a.end());

    for (int mask = 0; mask < (1 << m); ++mask) {
        int sm = 0;

        vector<bool> type(m, false);
        for (int i = 0; i < m; ++i) {
            if ((mask >> i) % 2) {
                type[i] = true;
            }
        }

        int cnt = 0;
        vector<bool> used(m, false);

        for (int i = 0; i < m; ++i) {
            if (type[i]) {
                sm += a[i];
            } else {
                sm -= a[i];
            }

            bool flag = false;
            for (int j = 0; j < i; ++j) {
                if (used[j] && type[i] != type[j]) {
                    flag = true;
                    used[j] = false;
                    break;
                }
            }

            if (!flag) {
                if (type[i]) {
                    ++cnt;
                } else {
                    cnt = n + 1;
                    break;
                }
            }

            used[i] = true;
        }

        if (cnt <= n) {
            ans = max(ans, sm);
        }
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt; cin >> tt;
    while (tt--) {
        solve();
        cout << "\n";
    }
}