#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    cin >> q;
    while (q--) {
        solve();
    }
}

const ll INF = 1e18;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    if (m * m > 1e7) {
        if (m % 2 == 1) {
            cout << x[0];
        } else {
            cout << 0;
        }
        return;
    }
    reverse(x.begin(), x.end());
    vector<vector<ll>> dp(m + 1, vector<ll>(m + 1, -INF));
    dp[0][0] = 0;
    for (int i = 1; i <= m; i++) {
        ll l = max(0ll, (i - n + 1) / 2);
        ll r = i / 2;
        for (ll j = l; j <= r; j++) {
            dp[i][j] = max(dp[i][j], dp[i - 1][j] + x[i - 1]);
            if (j - 1 >= 0) {
                dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] - x[i - 1]);
            }
        }
    }
    ll ans = -INF;
    for (int j = 0; j <= m; j++) {
        ans = max(ans, dp[m][j]);
    }
    cout << ans << '\n';
} 