#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <climits>
#include <time.h>
#include <cmath>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")

using namespace std;
using ll = long long;
using ld = long double;
ll inf = 4e18;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution <> distr(0, INT_MAX);

ll binpow(ll x, ll d, ll mod) {
	if (d == 0)
		return 1;
	if (d == 1)
		return x;
	ll cur = binpow(x, d >> 1, mod) * binpow(x, d >> 1, mod) % mod;
	if (d & 1)
		cur = cur * x % mod;
	return cur;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vector<ll> x(m);
		for (int i = 0; i < m; i++)
			cin >> x[i];
		pair<ll, ll> mina = { 0, 0 }, maxa = { 0, 0 }, minb = { 0, 0 }, maxb = { 0, 0 };
		for (auto i : x) {
			vector<pair<ll, ll>> newp;
			auto p = mina;
			p.first = i - p.first;
			newp.push_back(p);
			p = mina;
			p.second = i - p.second;
			newp.push_back(p);
			p = maxa;
			p.first = i - p.first;
			newp.push_back(p);
			p = maxa;
			p.second = i - p.second;
			newp.push_back(p);
			p = minb;
			p.first = i - p.first;
			newp.push_back(p);
			p = minb;
			p.second = i - p.second;
			newp.push_back(p);
			p = maxb;
			p.first = i - p.first;
			newp.push_back(p);
			p = maxb;
			p.second = i - p.second;
			newp.push_back(p);
			mina = newp[0];
			maxa = newp[0];
			minb = newp[0];
			maxb = newp[0];
			for (auto j : newp) {
				if (j.first < mina.first)
					mina = j;
				if (j.first > maxa.first)
					maxa = j;
				if (j.second < minb.second)
					minb = j;
				if (j.second > maxb.second)
					maxb = j;
			}
		}
		ll ans = mina.first + mina.second;
		ans = max(ans, maxa.first + maxa.second);
		ans = max(ans, minb.first + minb.second);
		ans = max(ans, maxb.first + maxb.second);
		cout << ans << '\n';
	}
}