#include <iostream>
#include <set>
#include <vector>
#include <random>
#include <iomanip>
//#include <fstream>
#include <algorithm>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;
#define int long long
const int INF = 1e18;
void dfs0(vector<vector<int>>& g, vector<int>& h, int u, int p) {
    for (auto v : g[u]) {
        if (v == p) continue;
        h[v] = h[u] + 1;
        dfs0(g, h, v, u);
    }
}
int dfs1(vector<vector<int>>& g, vector<int>& cost, int u, int p, int cst) {
    if (cost[u] <= cst) return 0;
    int ans = 1;
    for (auto v : g[u]) {
        if (v == p) continue;
        if (cost[v] <= cst) continue;
        ans += dfs1(g, cost, v, u, cst);
    }
    return ans;
}
signed main()
{
    cin.tie(nullptr)->sync_with_stdio(false);
    int q;
    cin >> q;
    while (q--) {
        int n, m;
        cin >> n >> m;
        vector<int> x(m);
        for (int i = 0; i < m; i++) {
            cin >> x[i];
        }
        int ans = -INF;
        vector<unordered_map<int, int>> dp(m + 1);
        dp[0][0] = 0;
        for (int i = 0; i < m; i++) {
            for (auto j : dp[i]) {
                int sm1 = j.first, sm2 = j.second;
                dp[i + 1][sm1] = x[i] - sm2;
                dp[i + 1][x[i] - sm1] = sm2;
            }
        }
        for (auto j : dp.back()) {
            ans = max(ans, j.first + j.second);
        }
        cout << ans << '\n';
    }
}