#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

void solve()
{
	long long k, n;
	vector<long long> v;
	cin >> k >> n;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}
	reverse(v.begin(), v.end());

	vector<long long> bal(n);
	vector<long long> pm(n);
	long long ans = 0;
	for (long long i = 0; i < n; i++)
	{
		bal[i] = (i ? bal[i - 1] : k);
		if (v[i] >= 0)
		{
			bal[i]--;
			pm[i] = -1;
			ans += v[i];
			if (bal[i] < 0)
			{
				long long best = i, mxbal = -1;
				for (long long j = i - 1; j > -1; j--)
				{
					mxbal = max(mxbal, bal[j]);
					if (mxbal + 2 > k)
					{
						break;
					}
					if (pm[j] == -1 && v[j] < v[best])
					{
						best = j;
					}
				}
				pm[best] = 1;
				for (long long j = best; j <= i; j++)
				{
					bal[j] += 2;
				}
				ans -= v[best] * 2;
			}
		}
		else
		{
			bal[i]++;
			pm[i] = 1;
			ans -= v[i];
			if (bal[i] > k)
			{
				long long best = i, mnbal = bal[i];
				for (long long j = i - 1; j > -1; j--)
				{
					mnbal = min(mnbal, bal[j]);
					if (mnbal - 2 < 0)
					{
						break;
					}
					if (pm[j] == 1 && v[j] > v[best])
					{
						best = j;
					}
				}
				pm[best] = -1;
				for (long long j = best; j <= i; j++)
				{
					bal[j] -= 2;
				}
				ans += v[best] * 2;
			}
		}
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
