#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int inf = 1e18 + 100;

void sol() {
    int n, m;
    cin >> n >> m;
    vector<int> lst(m + 1, 0);
    for (int i = 0; i < m; i++) {
        cin >> lst[i];
    }
    reverse(lst.begin(), lst.end());
    vector<vector<int>> dp(m + 1, vector<int>(n + 1, -inf));
    dp[0][n] = 0;
    for (int i = 1; i <= m; i++) {
        for (int j = 0; j <= n; j++) {
            if (j != n) {
                dp[i][j] = max(dp[i][j], dp[i - 1][j + 1] + lst[i]);
            }
            if (j != 0) {
                dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] - lst[i]);
            }
            //cout << i << " " << j << " " << dp[i][j] << endl;
        }
    }
    int ans = -inf;
    for (int j = 0; j <= n; j++) {
        ans = max(ans, dp[m][j]);
    }
    cout << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(15);
    int t;
    cin >> t;
    for (; t > 0; --t) {
        sol();
    }
}
