// semenInRussia 2025
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<int> x(m);

  for (auto &v : x) {
    cin >> v;
  }

  int64_t ans = -1e18;

  for (int b = 0; b < (1 << m); b++) {
    int64_t op[2] = {0, 0};
    for (int j = 0; j < m; j++) {
      if ((b >> j) & 1) {
        op[0] += x[j];
      } else {
        op[1] += x[j];
      }
    }
    ans = max(ans, op[0] + op[1]);
  }

  cout << ans << endl;
}

int main() {
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}