#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = int(1e9) + 7, lg = 20;
const ll inf = ll(2e18) + 36;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct Fast {
    void main() {
        ll n, m;
        cin >> n >> m;
        vector<ll> x(m);
        for (auto &it: x) cin >> it;
        set <pair <ll, ll>> st, t;
        st.insert({0, 0});
        for (ll i = 0; i < m; i++) {
            t.clear();
            for (auto& [f, s] : st) {
                t.insert({x[i] - f, s});
                t.insert({f, x[i] - s});
            }
            st = t;
        }
        ll ans = -inf;
        for (auto& [f, s] : t) {
            ans = max(ans, f + s);
        }
        cout << ans;
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll testC; cin >> testC;
    while (testC--) {
        Fast().main();
        cout << '\n';
    }
    return 0;
}
