#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <random>
#include <chrono>
using namespace std;
typedef long long ll;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll t;
	cin >> t;
	while (t--) {
		ll n, m;
		cin >> n >> m;
		vector<ll> a(m);
		for (ll i = 0; i < m; ++i) cin >> a[i];
		vector<vector<ll>> dp(m + 1, vector<ll>(n + 1, -1e18));
		dp[m][n] = 0;
		for (ll i = m - 1; i >= 0; --i) {
			for (ll j = 0; j <= n; ++j) {
				if (j > 0) dp[i][j] = max(dp[i][j], dp[i + 1][j - 1] - a[i]);
				if (j < n) dp[i][j] = max(dp[i][j], dp[i + 1][j + 1] + a[i]);
			}
		}
		ll ans = -1e18;
		for (ll i = 0; i <= n; ++i) ans = max(ans, dp[0][i]);
		cout << ans << "\n";
	}
	cout << endl;
	return 0;
}