#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define itn int
#define int long long
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)
#define pii pair<int, int>
#define ff first
#define ss second
#define sz(a) (int)(a).size()
#define ll long long
#define ld long double

mt19937 rnd(time(0));

const int N = 1000;

int vsp[N + 1][N + 1];
int vsp1[N + 1][N + 1];

vector <itn> a, b;

void solve(){
    int n, m;
    cin >> n >> m;
    a.resize(2);
    b.resize(m);
    for (auto &x: b){
        cin >> x;
    }

    for (int i = 0; i < N; ++i){
        fill(all(vsp[i]), 0);
        fill(all(vsp1[i]), 0);
    }

    vsp1[501][501] = 1;

    for (itn i = 0; i < m; ++i){
        for (itn j = 0; j < N; ++j){
            for (itn k = 0; k < N; ++k){
                if (!vsp1[j][k]) continue;
                vsp[j][b[i] - (k - 501) + 501] |= vsp1[j][k];
                vsp[(b[i] - (j - 501)) + 501][k] |= vsp1[j][k];
            }
        }
        swap(vsp, vsp1);
        for (int j = 0; j < N; ++j){
            fill(all(vsp[j]), 0);
        }
    }
    int ans = 0;
    for (int i = 0; i < N; ++i){
        for (int j = 0; j < N; ++j){
            if (vsp1[i][j])
                ans = max(ans, i + j);
        }
    }
    cout << ans - N - 2 << '\n';
}

signed main(){
    cin.tie(nullptr) ->sync_with_stdio(false);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;
    while (t--){
        solve();
    }
}