#include <bits/stdc++.h>

using namespace std;

#define int long long
using ld = long double;
using ll = long long;
using pii = pair<int, int>;

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; ++i)
        cin >> x[i];
    reverse(x.begin(), x.end());
    vector<vector<int>> dp(m, vector<int>(n + 1, LLONG_MIN));
    for (int i = m - 1; i >= 0; --i)
    {
        // текущий элемент
        for (int pl = 0; pl <= n; ++pl)
        {
            // количество положительных цепей
            int mi = n - pl;
            dp[i][pl] = LLONG_MIN;
            if (pl > 0)
            {
                // берем текущий элемент с +
                int var = x[i];
                bool ok = i == m - 1 || dp[i + 1][pl - 1] != LLONG_MIN;
                if (i != m - 1 && dp[i + 1][pl - 1] != LLONG_MIN)
                {
                    var += dp[i + 1][pl - 1];
                }
                if (ok)
                {
                    dp[i][pl] = max(dp[i][pl], var);
                }
            }
            if (mi > 0)
            {
                // берем текущий элемент с -
                int var = -x[i];
                bool ok = i == m - 1 || dp[i + 1][pl + 1] != LLONG_MIN;
                if (i != m - 1 && dp[i + 1][pl + 1] != LLONG_MIN)
                {
                    var += dp[i + 1][pl + 1];
                }
                if (ok)
                {
                    dp[i][pl] = max(dp[i][pl], var);
                }
            }
        }
    }
    cout << dp[0][n] << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(0);
    ios::sync_with_stdio(0);

    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}