#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include <windows.h>

#define f first
#define s second
#define pb push_back
#define pf push_front
#define in insert
#define oo 1e18
#define nl '\n'
#define orderedSet tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC poison

typedef long double ld;
typedef int64_t int64;
typedef uint64_t uint64;
typedef uint32_t uint;

using namespace std;
using namespace __gnu_pbds;
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define int int64

const int N = 3e5 + 9;

int k, n, a[N];

struct tre {
    tre *L = NULL,
        *R = NULL;
    int l, md, r, mn, mnPos, mx, mxPos, pl;
    tre(int l, int r): l(l), md((l + r) / 2), r(r) {
        if (l == r)
            return;
        L = new tre(l, md);
        R = new tre(md + 1, r);
    }
    void clear(int _r) {
        mn = oo;
        mx = -oo;
        pl = 0;
        mnPos = mxPos = l;
        if (_r < l || l == r)
            return;
        L -> clear(_r);
        R -> clear(_r);
    }
    void push() {
        if (L -> mn != oo)
            L -> mn += pl;
        if (L -> mx != -oo)
            L -> mx += pl;
        L -> pl += pl;
        if (R -> mn != oo)
            R -> mn += pl;
        if (R -> mx != -oo)
            R -> mx += pl;
        R -> pl += pl;
        pl = 0;
    }
    void upd(int t, int x) {
        if (r < t || t < l)
            return;
        if (l == r) {
            if (x == -1) {
                mn = oo;
                mx = -oo;
            }
            else
                mn = mx = x;
            return;
        }
        push();
        L -> upd(t, x);
        R -> upd(t, x);
        mn = min(L -> mn, R -> mn);
        mnPos = (mn == L -> mn ? L -> mnPos : R -> mnPos);
        mx = max(L -> mx, R -> mx);
        mxPos = (mx == L -> mx ? L -> mxPos : R -> mxPos);
    }
    void pluss(int _l, int _r, int x) {
        if (r < _l || _r < l)
            return;
        if (_l <= l && r <= _r) {
            if (mn != oo)
                mn += x;
            if (mx != -oo)
                mx += x;
            pl += x;
            return;
        }
        push();
        L -> pluss(_l, _r, x);
        R -> pluss(_l, _r, x);
        mn = min(L -> mn, R -> mn);
        mnPos = (mn == L -> mn ? L -> mnPos : R -> mnPos);
        mx = max(L -> mx, R -> mx);
        mxPos = (mx == L -> mx ? L -> mxPos : R -> mxPos);
    }
    int get(int t) {
        if (l == r)
            return mn;
        push();
        if (t <= md)
            return L -> get(t);
        else
            return R -> get(t);
    }
    int findLastMn1() {
        if (l == r)
            return l;
        push();
        if (R -> mn <= 1)
            return R -> findLastMn1();
        else
            return L -> findLastMn1();
    }
    int findLastMxK_1() {
        if (l == r)
            return l;
        push();
        if (R -> mx >= k - 1)
            return R -> findLastMxK_1();
        else
            return L -> findLastMxK_1();
    }
    pair <int, int> getMn(int _l, int _r) {
        if (_r < l || r < _l)
            return {oo, -1};
        if (_l <= l && r <= _r)
            return {mn, mnPos};
        push();
        auto lf = L -> getMn(_l, _r),
             rg = R -> getMn(_l, _r);
        int ans = min(lf.f, rg.f);
        return {ans, (ans == lf.f ? lf.s : rg.s)};
    }
    pair <int, int> getMx(int _l, int _r) {
        if (_r < l || r < _l)
            return {-oo, -1};
        if (_l <= l && r <= _r)
            return {mx, mxPos};
        push();
        auto lf = L -> getMx(_l, _r),
             rg = R -> getMx(_l, _r);
        int ans = max(lf.f, rg.f);
        return {ans, (ans == lf.f ? lf.s : rg.s)};
    }
};

tre pl(0, N - 1), mn(0, N - 1), pr(0, N - 1);

void solve() {
    cin >> k >> n;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    pl.clear(n - 1);
    mn.clear(n - 1);
    pr.clear(n - 1);
    reverse(a, a + n);
    int sum = 0;
    for (int i = 0; i < n; ++i)
        if (a[i] >= 0) {
            sum += a[i];
            pl.upd(i, a[i]);
            int val = (i > 0 ? pr.get(i - 1) : 0) + 1;
            pr.upd(i, val);
            if (val == k + 1) {
                int pos1 = pr.findLastMn1();
                int pos = pl.getMn(pos1 + 1, i).s;
                sum -= a[pos] + a[pos];
                pl.upd(pos, -1); //del
                mn.upd(pos, a[pos]);
                pr.pluss(pos, i, -2);
            }
        }
        else {
            sum -= a[i];
            mn.upd(i, a[i]);
            int val = (i > 0 ? pr.get(i - 1) : 0) - 1;
            pr.upd(i, val);
            if (val == -1) {
                int posN_1 = (pr.getMx(0, i).f < k - 1 ? -1 : pr.findLastMxK_1());
                int pos = mn.getMx(posN_1 + 1, i).s;
                sum += a[pos] + a[pos];
                mn.upd(pos, -1); //del
                pl.upd(pos, a[pos]);
                pr.pluss(pos, i, 2);
            }
        }
    cout << sum << nl;
}

main() {
//    cin.tie(0); ios::sync_with_stdio(0); cout.tie(0);
    int t;
    cin >> t;
    while (t--)
        solve();
}
