#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3, unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <experimental/random>

using namespace __gnu_pbds;
using namespace std;
using ordered_set = tree<long long, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;
const ll inf = 1e18;
using str = string;
#define all(a) a.begin(), a.end()
#define len(a) int(a.size())
#define pb push_back
#define pbb pop_back
#define vc vector
#define rev reverse
#define F first
#define S second

void solve() {
    int n, m;
    cin >> n >> m;
    swap(n, m);
    vector<ll> x(n);
    for (int i = 0; i < n; i++) cin >> x[i];
    rev(all(x));
    vector<vector<ll>> dp(n + 1, vector<ll>(2, -inf));
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int last = 0; last < i; last++) {
            if (dp[last][1] != -inf) {
                ll var = dp[last][1] - x[i - 1];
                int pos = 1;
                if (last % 2 == 0) {
                    pos = 0;
                }
                for (int j = last + 1; j < i; j++) {
                    if (pos % 2 == 1) var += x[j - 1];
                    else var -= x[j - 1];
                    pos++;
                }
                dp[i][0] = max(dp[i][0], var);
            }
            if (dp[last][0] != -inf) {
                ll var = dp[last][0] + x[i - 1];
                int pos = 1;
                if (last % 2 != 0) {
                    pos = 0;
                }
                for (int j = last + 1; j < i; j++) {
                    if (pos % 2 == 1) var += x[j - 1];
                    else var -= x[j - 1];
                    pos++;
                }
                dp[i][1] = max(dp[i][1], var);
            }
        }
    }
    cout << max(dp[n][0], dp[n][1]) << "\n";
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _;
    cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
