#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second
const ll inf = 1e9 + 7;
vector<ll> tree;
void build(ll v, ll l, ll r, vector<ll> &a) {
    if (r - l == 1) {
        tree[v] = a[l];
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v + 1, l, m, a);
    build(2 * v + 2, m, r, a);
}

void update(ll v, ll l, ll r, ll ql, ll qr, ll x) {
    if (l >= qr || r <= ql) {
        return;
    }
    if (l >= ql && r <= qr) {
        tree[v] = x;
        return;
    }
    ll m = (l + r) / 2;
    update(2 * v + 1, l, m , ql, qr, x);
    update(2 * v + 2, m, r, ql, qr, x);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}



void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> a(m);
    for(int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    vector<ll> ans(n);
    ll pos = 0;
    for(int i = 0; i < m; ++i) {
        ans[pos]++;
        if (pos + 1 < n) {
            pos++;
        }
    }
    ll res = 0;
    for(int i = 0; i < n; ++i) {
        res += (ans[i] % 2) * a[0];
    }
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll T = 1;
    cin >> T;
    while(T--) {
        solve();
        cout << '\n';
    }
    return 0;
}
