#include <iostream>
#include <vector>

#define int long long

void solve()
{
    int n, m;
    std::cin >> n >> m;
    std::vector<int> x(m + 1);
    for (int i = 1; i <= m; ++i)
        std::cin >> x[i];
    std::vector<int> dp1(m + 2), dp2(m + 2);
    for (int i = 2; i <= m + 1; ++i) {
        int x2 = 0;
        for (int j = i - 1; j >= 1; --j) {
            int x1 = x[i - 1] - x[j - 1];
            if (i - j % 2 == 1) {
                dp1[i] = std::max(dp1[j - 1] + x1 + x2, dp1[i]);
                dp2[i] = std::max(dp2[j - 1] + x1 - x2, dp2[i]);
            } else {
                dp1[i] = std::max(dp2[j - 1] + x1 + x2, dp1[i]);
                dp2[i] = std::max(dp1[j - 1] + x1 - x2, dp2[i]);
            }
            x2 = x[j - 1] - x2;
        }
    }
    std::cout << dp1[m] << '\n';
}

signed main()
{
    int t = 1;
#ifdef LOCAL
    freopen("stream/inb.txt", "r", stdin);
    freopen("stream/outb.txt", "w", stdout);
    std::cin >> t;
#else
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cin >> t;
#endif
    for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
        solve();
    }
    std::cout.flush();
    return 0;
}