#include <bits/stdc++.h>
#define ll long long
#define len(x) (int)x.size()
#define ld long double
#define all(x) x.begin(), x.end()
const ll mod1 = 1e9 + 7;

using namespace std;

void print(vector<int> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<ll> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<char> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<string> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<pair<int, int>> &a){
    for(auto x : a){
        cout << x.first << ' ' << x.second << '\n';
    }
}

void print(vector<vector<int>> &a){
    for(auto x : a){
        print(x);
    }
}

void print(vector<vector<ll>> &a){
    for(auto x : a){
        print(x);
    }
}

//#define int ll
#define mtask

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    for(int i = 0; i < m; ++i){
        cin >> a[i];
    }
    reverse(all(a));
    vector<ll> dp(n + 1, -1e18);
    dp[n] = 0;
    for(auto x : a){
        vector<ll> ndp(n + 1, -1e18);
        for(int i = 0; i <= n; ++i){
            if(i){
                ndp[i - 1] = max(ndp[i - 1], dp[i] + x);
            }
            if(i < n){
                ndp[i + 1] = max(ndp[i + 1], dp[i] - x);
            }
        }
        swap(dp, ndp);
    }
    ll ans = -1e18;
    for(int i = 0; i <= n; ++i){
        ans = max(ans, dp[i]);
    }
    cout << ans << '\n';
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
    int tt;
    cin >> tt;
    while(tt--)
#endif
    solve();
}