#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#define ll long long
#define len(x) (int)x.size()
#define ld long double
#define all(x) x.begin(), x.end()
const ll mod1 = 1e9 + 7;

using namespace std;

void print(vector<int>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<ll>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<char>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<string>& a) {
	for (auto x : a) {
		cout << x << ' ';
	}
	cout << '\n';
}

void print(vector<pair<int, int>>& a) {
	for (auto x : a) {
		cout << x.first << ' ' << x.second << '\n';
	}
}

void print(vector<vector<int>>& a) {
	for (auto x : a) {
		print(x);
	}
}

void print(vector<vector<ll>>& a) {
	for (auto x : a) {
		print(x);
	}
}

//#define int ll
#define mtask

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(m);
	int mmin = 1e9;
	for (int i = 0; i < m; ++i) {
		cin >> a[i];
		mmin = min(mmin, a[i]);
	}
	reverse(all(a));
	{
		
	}

	auto get = [&](int cnt) -> ll{
		int pot = n;
		ll ans = 0;
		for (int i = 0; i < m; ++i) {
			if (m - i <= pot || pot == n) {
				--pot;
				ans += a[i];
			}
			else if (a[i] == mmin || cnt) {
				++pot;
				ans -= a[i];
				cnt -= a[i] != mmin;
			}
			else {
				--pot;
				ans += a[i];
			}
			if (pot < 0) return -1e18;
		}
		return ans;
	};

	int l = -1, r = n;
	while (l + 1 != r) {
		int mid = (l + r) / 2;
		ll cur = get(mid);
		if (cur == -1e18) {
			l = mid;
		}
		else {
			r = mid;
		}
	}
	cout << get(r) << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
	int tt;
	cin >> tt;
	while (tt--)
#endif
		solve();
}