#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

//#include <ext/pb_ds/assoc_containe.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template <class T> order_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//find_by_orede, order_of_key

#define int long long
#define all(a) (a).begin(), (a).end()

#pragma GCC optimize ("O3")
#pragma GCC target ("avx2")


const int inf = 1e18;


int dp[2][2][300005];

void solve() {
	int n, m; cin >> n >> m;
	vector<int> x(m);
	for (int& i : x) cin >> i;

	int res = -inf;
	for (int i = 0; i <= m; ++i)
		for (int a = 0; a < 2; ++a)
			dp[a][0][i] = dp[a][1][i] = -inf;

	if (m % 2 == 0) {
		dp[0][1][0] = abs(x[0]);
		dp[1][0][0] = abs(x[0]);
	}
	else{
		dp[0][0][0] = x[0];
		dp[1][1][0] = -x[0];
	}

	for (int i = 1; i < m; ++i) {
		if (dp[0][0][i - 1] != -inf) {
			dp[1][0][i] = max(dp[1][0][i], dp[0][0][i - 1] - x[i]);
			dp[0][1][i] = max(dp[0][1][i], dp[0][0][i - 1] - x[i]);
		}

		if (dp[1][0][i - 1] != -inf) {
			dp[0][0][i] = max(dp[0][0][i], dp[1][0][i - 1] + x[i]);
			dp[1][1][i] = max(dp[1][1][i], dp[1][0][i - 1] - x[i]);
		}

		if (dp[0][1][i - 1] != -inf) {
			dp[1][1][i] = max(dp[1][1][i], dp[0][1][i - 1] - x[i]);
			dp[0][0][i] = max(dp[0][0][i], dp[0][1][i - 1] + x[i]);
		}

		if (dp[1][1][i - 1] != -inf) {
			dp[0][1][i] = max(dp[0][1][i], dp[1][1][i - 1] + x[i]);
			dp[1][0][i] = max(dp[1][0][i], dp[1][1][i - 1] + x[i]);
		}
	}

	for (int a = 0; a < 2; ++a) {
		for (int b = 0; b < 2; ++b) {
			res = max(res, dp[a][b][m - 1]);

		}
	}
	cout << res << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t; cin >> t;
	while (t--) solve();
}