#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <vector>
#include <map>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el;
    }
    return out;
}

vector<vector<ll>> g;
vector<bool> used;
vector<ll> dist;

void dfs(ll v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            dist[u] = dist[v] + 1;
            dfs(u);
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vector<ll> x(m);
        cin >> x;
        if (m <= n) {
            cout << m * x[0] << '\n';
        } else {
            m -= n;
            if (m % 2) {
                cout << (n - 1) * x[0] << '\n';
            } else {
                cout << n * x[0] << '\n';
            }
        }
    }
}