#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
const int oo = 1e18;

bool get_bit(int x, int d) {
	return x >> d & 1;
}

void solution() {
	int n, m;
	cin >> n >> m;
	vector <int> x(m);
	for (int i = 0; i < m; i++) {
		cin >> x[i];
	}
	auto b = x;
	sort(b.begin(), b.end());
	int ans = 0;
	int cn = 0;
	for (int i = 0; i < m; i++) {
		if (x[i] >= b[m / 2]) {
			if (cn < m) {
				ans += x[i];
				cn++;
			}
			else {
				ans -= x[i];
				cn--;
			}
		}
		else {
			if (cn > 0) {
				ans -= x[i];
				cn--;
			}
			else {
				ans += x[i];
				cn++;
			}
		}
	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solution();
		cout << '\n';
	}
}