#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <unordered_map>
#include <assert.h>
using namespace std;

template<typename T1,typename T2>
istream&operator>>(istream&in,pair<T1,T2>&a){
    return in>>a.first>>a.second;
}
template<typename T1,typename T2>
ostream&operator<<(ostream&out,const pair<T1,T2>&a){
    return out<<a.first<<' '<<a.second<<'\n';
}
template<typename T>
istream&operator>>(istream&in,vector<T>&a){
    for (auto &i:a)in>>i;
    return in;
}
template<typename T>
ostream&operator<<(ostream&out,const vector<T>&a){
    for (const auto &i:a)out<<i<<' ';
    return out;
}
template<typename T>
ostream&operator<<(ostream&out,const vector<vector<T>>&a){
    for (const auto &i:a)out<<i<<'\n';
    return out;
}
typedef long long ll;
const ll inf =1e18+7;
void print(bool flag){
if (flag)cout<<"YES\n";
else cout<<"NO\n";
}
struct solve{
    int n,m;
    vector<ll>a;
    solve(){
        cin>>m>>n;
        a.resize(n);
        cin>>a;
        ll t=(1<<n);
        ll ans=-inf;
        for (ll x=0;x<t;x++){
            ll u=0;
            ll v=0;
            for (int i=0;i<n;i++){
                if ((1<<i)&x)u=a[i]-u;
                else v=a[i]-v;
            }
            ans=max(ans,u+v);
        }
        cout<<ans<<'\n';
    }
};
int main()
{
    int t=1;

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin>>t;
    while(t--)solve();
}
