#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

ll inf = (ll)1e18;

template<class T>
ll len(T& a) {
    return (ll)a.size();
}

ll n, q;
vector<vector<ll>> g;
vector<ll> s;
vector<ll> queries;
vector<ll> h;

map<ll, ll> ans;
void find_ans() {
    vector<ll> topsort;
    priority_queue<pair<ll, ll>> que;
    que.push({s[0], 0});
    while (!que.empty()) {
        pair<ll, ll> temp = que.top(); que.pop();
        topsort.push_back(temp.second);
        for (ll to : g[temp.second]) {
            que.push({s[to], to});
        }
    }
    for (ll i = 0; i < len(topsort); ++i) {
        if (ans.count(topsort[i]) == 0) {
            ans[topsort[i]] = i;
        } else {
            ans[topsort[i]] = min(ans[topsort[i]], i);
        }
    }
}

void dfs(ll x) {
    vector<ll> temp = {g[x].begin(), g[x].end()};
    sort(temp.rbegin(), temp.rend(), [&](ll a, ll b) { return s[a] < s[b]; });

    if (len(temp) == 1) {
        ll tt = temp[0];
        s[temp[0]] = 0;
        find_ans();
        s[temp[0]] = tt;
    } else if (len(temp) > 1) {
        ll tt = temp[0];
        s[temp[0]] = 0;
        find_ans();
        s[temp[0]] = tt;

        ll ttt = temp[1];
        s[temp[1]] = 0;
        find_ans();
        s[temp[1]] = ttt;
    }
    for (ll to : g[x]) {
        dfs(to);
    }
}

void solve() {
    cin >> n >> q;
    h.resize(n, 0);
    ll x;
    g.resize(n);
    s.resize(n);
    h.resize(n);
    queries.resize(q);
    for (ll i = 1; i < n; ++i) {
        cin >> x;
        x--;
        g[x].push_back(i);
    }
    for (ll i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (ll i = 0; i < q; ++i) {
        cin >> queries[i];
        queries[i]--;
    }

    vector<ll> topsort;
    priority_queue<pair<ll, ll>> que;
    que.push({s[0], 0});
    while (!que.empty()) {
        pair<ll, ll> temp = que.top(); que.pop();
        topsort.push_back(temp.second);
        for (ll to : g[temp.second]) {
            que.push({s[to], to});
        }
    }

    dfs(0);

    for (ll i = 0; i < q; ++i) {
        cout << ans[queries[i]] << " ";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}