#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

//using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ld = long double;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18;

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (int i = 0; i < m; ++i)
    {
        cin >> x[i];
    }
    vector<ll> a(n, 0);
    ll ans = -INF;
    for (int msk = 0; msk < (1 << m); ++msk)
    {
        for (int i = 0; i < m; ++i)
        {
            if ((msk >> i) & 1)
            {
                a[0] = a[0] - x[i];
            } else
            {
                a[1] = a[1] - x[i];
            }
        }
        ans = max(ans, a[0] + a[1]);
    }
    cout << ans << '\n';
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}
