#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begoin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

#define mp make_pair

void solve() {
    int n, m;
    cin >> n >> m;

    vector<ll> x(m);
    for (auto &i: x) {
        cin >> i;
    }

    set<pair<ll, ll>> dp;
    dp.insert(mp(0,0));
    for (int i = 0; i < m; ++i) {
        set<pair<ll, ll>> ndp;
        for (auto [x1, x2]: dp) {
            ndp.insert(mp(x1,x[i]-x2));
            ndp.insert(mp(x[i]-x1, x2));
        }
        swap(dp,ndp);
    }

    ll ans = -INF;
    for (auto [x1, x2]: dp) {
        ans = max(ans, x1 + x2);
    }

    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
#endif

    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}