#pragma GNU optimize("O3")
#pragma GNU optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define in insert
#define int long long
#define ll long long
#define inf 1000000000000000
#define N 300000

int a[N];
int n, m;

struct node_pr{
    node_pr *ls = 0, *rs = 0;
    int l, r, mi, i, j, d = 0;

    void push(){
        if(ls != 0){
            ls->d += d;
            rs->d += d;
        }
        mi -= d;
        d = 0;
    }

    void recalc(){
        if(ls->mi < rs->mi){
            mi = ls->mi;
            i = ls->i;
            j = ls->j;
        }
        else if(ls->mi == rs->mi){
            mi = ls->mi;
            i = ls->i;
            j = rs->j;
        }
        else{
            mi = rs->mi;
            i = rs->i;
            j = rs->j;
        }
    }

    node_pr(int l, int r): l(l), r(r){
        if(r - l == 1) mi = r, i = l, j = i;
        else{
            ls = new node_pr(l, (l + r) / 2);
            rs = new node_pr((l + r) / 2, r);
            recalc();
        }
    }

    void add(int L){
        push();
        if(L <= l){ d += 2; push(); return ; }
        if(r <= L) return;
        ls->add(L), rs->add(L);
        recalc();
    }

    pair<int, int> get_min(){
        if(mi == -n || mi == 1 - n) return {mi, j + 1};
        return {mi, i};
    }
};

struct node{
    node *ls = 0, *rs = 0;
    int l, r, mi, mi_i;

    void recalc(){
        if(ls->mi <= rs->mi){
            mi = ls->mi;
            mi_i = ls->mi_i;
        }
        else{
            mi = rs->mi;
            mi_i = rs->mi_i;
        }
    }

    node(int l, int r): l(l), r(r){
        if(r - l == 1) mi = a[l], mi_i = l;
        else{
            ls = new node(l, (l + r) / 2);
            rs = new node((l + r) / 2, r);
            recalc();
        }
    }

    void del(int i){
        if(ls == 0 && l == i){
            mi = inf;
            return;
        }
        if(r <= i || i < l) return;
        ls->del(i), rs->del(i);
        recalc();
    }

    pair<int, int> get_min(int L, int R){
        if(L <= l && r <= R) return {mi, mi_i};
        if(r <= L || R <= l) return {inf, inf};
        return min(ls->get_min(L, R), rs->get_min(L, R));
    }
};

void tup(){
    cin >> n >> m;
    int S = 0;
    for(int i = 0; i < m; i++){ cin >> a[i]; S += a[i]; }
//    cout << 0 << endl;
    node_pr pref(0, m);
    node root(0, m);
//    cout << 1 << endl;

    int j = n + 1;
    while(j <= m + 1){
//        cout << 3 << endl;
        pair<int, int> pr = pref.get_min();
//        cout << 4 << endl;
        int mi_pr = pr.first, i_pr = pr.second;
        if(mi_pr == -n || mi_pr == 1 - n) i_pr++;
//        cout << i_pr << ' ' << j << endl;
        pair<int, int> g = root.get_min(i_pr, min(j, m - 1));
        int mi = g.first, i = g.second;
//        cout << "res: " << mi << ' ' << i << endl;
//        cout << 5 << endl << endl;
        S -= a[i] * 2;
        root.del(i);
        pref.add(i);

        j += 2;
    }
    cout << S << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    while(t--) tup();
}