#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#define int long long

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), x(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
    }
    int ans = -1e18;
    for (int i = 0; i < 1 << m; ++i) {
        int c1 = 0, c2 = 0;
        for (int j = 0; j < m; ++j) {
            if (i >> j & 1) {
                c2 = -c2 + x[j];
            } else {
                c1 = -c1 + x[j];
            }
        }
        ans = max(ans, c1 + c2);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
