#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define yes() cout << "YES\n"
#define no() cout << "NO\n"
using ll = long long;
using ld = long double;
using namespace std;
using namespace __gnu_pbds;

template<typename K>
using oset = tree<K, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<int> b(m);
    for (int& i : b) cin >> i;

    unordered_map<int, unordered_map<int, int>> mp;
    mp[0][0] = 1;
    for (int i = 0; i < m; i++) {
        unordered_map<int, unordered_map<int, int>> mp4;
        for (auto& [f1, mp1] : mp) {
            for (auto& [f2, mp2] : mp[f1]) {
                if (mp[f1][f2]) {
                    mp4[b[i] - f1][f2] = 1;
                    mp4[f1][b[i] - f2] = 1;
                }
            }
        }

        mp = mp4;
    }

    int ans = -1e18;
    for (auto& [f1, mp1] : mp) {
        for (auto& [f2, mp2] : mp[f1]) {
            if (mp[f1][f2]) {
                ans = max(f1 + f2, ans);
            }
        }
    }

    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}