#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>

#define len(v) (int)((v).size())
#define ss second
#define ff first


typedef long long ll;

using namespace std;

void solve() {
	int n, m;
	cin >> n >> m;

	vector<int> x(m);
	for (int i = 0; i < m; ++i) {
		cin >> x[i];
	}

	multiset<ll> s;
	for (int i = 0; i < m; ++i) {
		if (len(s) < n) s.insert(x[i]);
		else {
			ll v = *s.begin();
			s.erase(s.begin());
			s.insert(x[i] - v);
		}
	}

	ll ans = 0;
	for (auto it = s.begin(); it != s.end(); ++it) {
		ans += *it;
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);

	int t = 1;
	//    cin >> t;
	while (t--) solve();
}



