#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>

#define len(v) (int)((v).size())
#define ss second
#define ff first


typedef long long ll;

using namespace std;

void solve() {
	int n, m;
	cin >> n >> m;

	vector<int> x(m);
	for (int i = 0; i < m; ++i) {
		cin >> x[i];
	}

	multiset<ll> s0, s1;
	for (int i = 0; i < n; ++i) {
		s0.insert(0);
	}
	for (int i = m - 1; i >= 0; --i) {
		if (x[i] >= 0 && !s0.empty()) {
			ll v = *s0.begin();
			s0.erase(s0.begin());
			s1.insert(v + x[i]);
		}
		else if (x[i] <= 0 && !s1.empty()) {
			ll v = *--s1.end();
			s1.erase(--s1.end());
			s0.insert(v - x[i]);
		}
		else {
			if (!s0.empty()) {
				ll v = *s0.begin();
				s0.erase(s0.begin());
				s1.insert(v + x[i]);
			}
			else {
				ll v = *--s1.end();
				s1.erase(--s1.end());
				s0.insert(v - x[i]);
			}
		}
	}

	ll ans = 0;
	for (auto it = s0.begin(); it != s0.end(); ++it) {
		ans += *it;
	}
	for (auto it = s1.begin(); it != s1.end(); ++it) {
		ans += *it;
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);

	int t = 1;
	   cin >> t;
	while (t--) solve();
}



