#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll INF = 1e18 + 5;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (ll i = 0; i < m; ++i) {
        cin >> x[i];
    }

    ll ans = -INF;
    for (ll i = 0; i < (1ll << m); ++i) {
        ll a = 0, b = 0, i1 = i;
        for (ll j = 0; j < m; ++j) {
            if (i1 & 1) {
                a = x[j] - a;
            } else {
                b = x[j] - b;
            }
            i1 >>= 1;
        }
        ans = max(ans, a + b);
    }

    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
