#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll INF = 160003;

void lessgo(vector<vector<int>> &dp11, vector<vector<int>> &dp01, vector<vector<int>> &dp00, int i, int j, ll ind) {
    dp11[ind + 1][i + INF] = max(dp11[ind + 1][i + INF], i + j);
    dp01[ind + 1][i + INF] = max(dp01[ind + 1][i + INF], i - j);
    dp01[ind + 1][j + INF] = max(dp01[ind + 1][j + INF], j - i);
    dp00[ind + 1][i + INF] = max(dp00[ind + 1][i + INF], -i - j);
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (ll i = 0; i < m; ++i) {
        cin >> x[i];
    }

    vector<vector<int>> dp11(m + 1, vector<int> (2 * INF, -INF)), dp01 = dp11, dp00 = dp01;
    dp00[0][INF] = 0;
    dp01[0][INF] = 0;
    dp00[0][INF] = 0;
    for (ll ind = 0; ind < m; ++ind) {
        for (ll i = -INF; i < INF; ++i) {
            if (dp11[ind][i + INF] != -INF) {
                ll j = dp11[ind][i + INF] - i;
                lessgo(dp11, dp01, dp00, x[ind] - i, j, ind);
                lessgo(dp11, dp01, dp00, i, x[ind] - j, ind);
            }
            if (dp01[ind][i + INF] != -INF) {
                ll j = i - dp01[ind][i + INF];
                lessgo(dp11, dp01, dp00, x[ind] - i, j, ind);
                lessgo(dp11, dp01, dp00, i, x[ind] - j, ind);
            }
            if (dp00[ind][i + INF] != -INF) {
                ll j = -i - dp00[ind][i + INF];
                lessgo(dp11, dp01, dp00, x[ind] - i, j, ind);
                lessgo(dp11, dp01, dp00, i, x[ind] - j, ind);
            }
        }
    }

    int ans = -INF * 2;
    for (ll i = -INF; i < INF; ++i) {
        ans = max(ans, dp11[m][i + INF]);
    }
    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
