#include <iostream>
//#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
//#include <map>
//#include <cmath>

using namespace std;

typedef long long ll;
//typedef long double ld;

#define int long long
#define ff first
#define ss second
#define endl '\n'
#define all(a) (a).begin, (a).end()

const int INF = 1e18 + 123;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
    }
    vector<vector<int>> dp(m + 1, vector<int> (n + 1, -INF));
    for (int k1 = 0; k1 < n + 1; ++k1) {
        if (k1 % 2 == m % 2) {
            dp[0][k1] = 0;
        }
    }

    for (int i = 1; i < m + 1; ++i) {
        for (int j = 0; j < n + 1; ++j) {
            if (j + 1 < n + 1 && dp[i - 1][j + 1] != -INF) dp[i][j] = max(dp[i][j], dp[i - 1][j + 1] + x[i - 1]);
            if (j - 1 >= 0 && dp[i - 1][j - 1] != -INF) dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] - x[i - 1]);
        }
    }

    cout << dp[m][0] << endl;
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
