#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifndef DEBUG
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#endif

using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = int;
using pll = std::pair<ll, ll>;
using ld = long double;
using i128 = __int128;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    ll n, m;
    std::cin >> n >> m;
    ll C = 160000;
    std::vector<ll> dp(2 * C + 1, -1e9), dp1(2 * C + 1, 1e9);
    dp[C] = 0;
    dp1[C] = 0;
    for (int i = 0; i < m; ++i) {
        ll x;
        std::cin >> x;
        auto dp2 = std::vector<ll>(2 * C + 1, -1e9), dp3 = std::vector<ll>(2 * C + 1, 1e9);
        for (int j = -C; j <= C; ++j) {
            if (dp[j + C] != -1e9){
                dp3[j + C] = std::min(dp3[j + C], x - dp[j + C]);
            }
            if (dp1[j + C] != 1e9){
                dp2[j + C] = std::max(dp2[j + C], x - dp1[j + C]);
            }
            if (-C <= x - j && x - j <= C){
                if (dp[j + C] != -1e9) {
                    dp2[x - j + C] = std::max(dp2[x - j + C], dp[j + C]);
                }
                if (dp1[j + C] != 1e9) {
                    dp3[x - j + C] = std::min(dp3[x - j + C], dp1[j + C]);
                }
            }
        }
        dp = dp2, dp1 = dp3;
    }
    ll ans = -1e9;
    for (int i = 0; i <= 2 * C; ++i) {
        ans = std::max(ans, i - C + dp[i]);
    }
    std::cout << ans << '\n';
}

int main() {
#ifdef DEBUG
    std::freopen("/home/olymp/CLionProjects/untitled/input.txt", "r", stdin);
#endif
    std::cin.tie(0)->std::ios::sync_with_stdio(0);
    int tt = 1;
    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
