#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifndef DEBUG
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#endif

using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using pll = std::pair<ll, ll>;
using ld = long double;
using i128 = __int128;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    ll n, m;
    std::cin >> n >> m;
    std::vector<ll> x(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> x[i];
    }
    ll ans = -1e9;
    for (int msk = 0; msk < 1ll << m; ++msk) {
        std::vector<ll> b(n);
        for (int j = 0; j < m; ++j) {
            if ((msk >> j) & 1){
                ll ind = std::max_element(b.begin(), b.end()) - b.begin();
                b[ind] = x[j] - b[ind];
            }
            else{
                ll ind = std::min_element(b.begin(), b.end()) - b.begin();
                b[ind] = x[j] - b[ind];
            }
        }
        ll cnt = 0;
        for (int i = 0; i < n; ++i) {
            cnt += b[i];
        }
        ans = std::max(ans, cnt);
    }
    std::cout << ans << '\n';
}

int main() {
#ifdef DEBUG
    std::freopen("/home/olymp/CLionProjects/untitled/input.txt", "r", stdin);
#endif
    std::cin.tie(0)->std::ios::sync_with_stdio(0);
    int tt = 1;
    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
