#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    cin >> a;
    reverse(a.begin(), a.end());
    vector<vector<int>> dp(m + 1, vector<int>(n + 1, -1e18));
    dp[0][0] = 0;
    a.insert(a.begin(), 0);

    for (int i = 1; i <= m; i++) {
        for (int cb = 0; cb <= n; cb++) {
            if (cb) dp[i][cb - 1] = max(dp[i][cb - 1], dp[i-1][cb] - a[i]);
            if (cb < n) dp[i][cb + 1] = max(dp[i][cb + 1], dp[i-1][cb] + a[i]);
        }
    }

    cout << *max_element(dp[m].begin(), dp[m].end());
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
     cin >> t;
    while (t--)
        solve(), cout << '\n';
}
