#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

const long long inf = (1ll << 63) - 1;
void solve() {
	int k, n;
	std::cin >> k >> n;
	std::vector<long long> a(n);
	for (int i = n - 1; i >= 0; --i) {
		std::cin >> a[i];
	}
	std::vector<long long> dp(k + 1);
	dp[1] = a[0];
	for (int i = 1; i < n; ++i) {
		const bool p = (i + 1) & 1;
		const int d = std::min(i + 1, k) + 1;
		for (int j = p; j < d; j += 2) {
			dp[j] = -inf;
			if (j - 1 >= 0) {
				dp[j] = dp[j - 1] + a[i];
			}
			if (j + 1 < d) {
				dp[j] = std::max(dp[j], dp[j + 1] - a[i]);
			}
		}
	}
	long long ans = dp[n & 1];
	for (int i = n & 1; i < std::min(k + 1, n + 2); i += 2) {
		ans = std::max(ans, dp[i]);
	}
	std::cout << ans << '\n';
}
int main() {
	int t;
	std::cin >> t;
	while (t--) {
		solve();
	}
}
