#include <bits/stdc++.h>
// #include <bits/extc++.h>

using namespace std;

#define all(a)	a.begin(),a.end()
#define rall(a)	a.rbegin(),a.rend()
#define FastIO	ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

typedef long long			ll;
typedef long double			ld;
typedef unsigned long long	ull;
// typedef _int128_t lll;

template<typename T1, typename T2>
ostream& operator<< (ostream &x, const pair<T1, T2> &pr) { return x << "{" << pr.first << ", " << pr.second << "}"; }
// template<typename T> void cerr_cont(const T &cont) { for (auto &it : cont) cerr << it << ' '; }
template<typename T> void print_cont(const T &cont, ostream &x=cout) { for (auto &it : cont) x << it << ' '; }

const ll INF = 1e12;

void solve() {
	int n, m;
	cin >> n >> m;

	vector<int> x(m);
	for (auto &it : x) cin >> it;
	reverse(all(x));

	vector<ll> dp(n + 1, -INF);
	dp[0] = 0;
	
	for (int i = 0; i < m; ++i) {
		vector<ll> ndp(n + 1);
		// cerr_cont(dp);
		// cerr << endl;
		for (int j = 0; j <= n; ++j) {
			ll a = (j == 0 || dp[j - 1] == -INF ? -INF : dp[j - 1] + x[i]);
			ll b = (j == n || dp[j + 1] == -INF ? -INF : dp[j + 1] - x[i]);
			ndp[j] = max(a, b);
		}
		dp = ndp;
	}
		// cerr_cont(dp);
		// cerr << endl;
	cout << *max_element(all(dp)) << '\n';
}

int main() {
	FastIO;
	int t;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
	return 0;
}

