#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll INF = 1e18;

void solve() {
    ll n, m; cin >> n >> m;
    vector<ll> b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }
    ll f = *min_element(b.begin(), b.end());
    ll z = *max_element(b.begin(), b.end());
    f = abs(f);
    ll M = (ll)b.size() * max(f, z);
    vector<vector<int>> dp(2 * M + 1, vector<int>(2 * M + 1, 0)), ndp(2 * M + 1, vector<int>(2 * M + 1));
    dp[0 + M][b[0] + M] = 1;
    dp[b[0] + M][0 + M] = 1;
    for (int i = 1; i < m; i++) {
        for (ll s1 = -M; s1 <= M; s1++) {
            for (ll s2 = -M; s2 <= M; s2++) {
                if (dp[s1 + M][s2 + M]) {
                    ndp[s1 + M][b[i] - s2 + M] = 1;
                    ndp[b[i] - s1 + M][s2 + M] = 1;
                }
            }
        }
        dp = ndp;
        for (ll s1 = -M; s1 <= M; s1++) {
            for (ll s2 = -M; s2 <= M; s2++) {
                ndp[s1 + M][s2 + M] = 0;
            }
        }
    }
    ll ans = -INF;
    for (ll s1 = -M; s1 <= M; s1++) {
        for (ll s2 = -M; s2 <= M; s2++) {
            if (dp[s1 + M][s2 + M]) {
                ans = max(ans, s1 + s2);
            }
        }
    }
    cout << ans << '\n';
}

int main() {
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}
