#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <climits>
#include <iomanip>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <queue>
#include <random>

#define int long long

#pragma GCC optimize("03,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using ll = long long;
using ld = long double;
using namespace std;

const ll INF = 1e18;


void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    for (int i = 0; i < m; i++){
        cin >> a[i];
    }
    reverse(a.begin(), a.end());
    vector<vector<int>> dp(m, vector<int>(n + 1, -INF));
    dp[0][1] = a[0];
    for (int i = 1; i < m; i++){
        for (int bal = 0; bal <= n; bal++){
            if (bal == 0){
                dp[i][bal] = dp[i - 1][1]  - a[i];
            } else if (bal == n){
                dp[i][bal] = dp[i - 1][bal - 1] + a[i];
            } else {
                dp[i][bal] = max(dp[i - 1][bal - 1] + a[i], dp[i - 1][bal + 1] - a[i]);
            }
        }
    }
    int mx = -INF;
    for (int bal = 0; bal <= n; bal++){
        mx = max(mx, dp[m - 1][bal]);
    }
    cout << mx << "\n";
}


signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--){
        solve();
    }
    return 0;
}