#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int inf = 1e9;
    int t;
    cin >> t;
    for (int _ = 0; _ < t; ++_) {
        int n, m;
        cin >> n >> m;
        vector<int> a(m);
        for (int i = 0; i < m; ++i) {
            cin >> a[i];
        }
        reverse(a.begin(), a.end());
        vector<vector<int>> dp(m);
        for (int i = 0; i < m; ++i) {
            dp[i] = {-inf, -inf, -inf};
        }
        dp[0] = {-inf, a[0], -inf};
        for (int i = 1; i < m; ++i) {
            dp[i][0] = dp[i - 1][1] - a[i];
            dp[i][1] = max(dp[i - 1][0] + a[i], dp[i - 1][2] - a[i]);
            dp[i][2] = dp[i - 1][1] + a[i];
        }
        cout << max(max(dp[m - 1][0], dp[m - 1][1]), dp[m - 1][2]) << endl;
    }
}
