#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef string str;
mt19937 rnd(157);

#define all(a) a.begin(), a.end()
#define int long long

int INF = 1e18;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while(t--) {
        int n, m;
        cin >> n >> m;
        vector<int> a(m);
        for(int i = 0; i < m; i++) {
            cin >> a[i];
        }
        reverse(all(a));
        vector<vector<int>> dp(n + 1, vector<int> (m + 1, -INF));
        dp[0][0] = 0;
        for(int i = 0; i < m; i++) {
            for(int j = 0; j <= n; j++) {
                if(j != 0) {
                    dp[j - 1][i + 1] = max(dp[j - 1][i + 1], dp[j][i] - a[i]);
                }
                if(j < n) {
                    dp[j + 1][i + 1] = max(dp[j + 1][i + 1], dp[j][i] + a[i]);
                }
            }
        }
        int ans = -INF;
        for(int i = 0; i <= n; i++) {
            ans = max(ans, dp[i][m]);
        }
        cout << ans << '\n';
    }
}
