#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, q; cin >> n >> q;
    vector<int> p(n);
    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i]; p[i]--;
        g[p[i]].pb(i);
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++) cin >> s[i];
    vector<int> ans(n);
    vector<vector<int>> g2 = g;
    int root = 0;
    vector<int> seq;

    for (int i = 0; i < n; i++) {
        seq.pb(root);
        vector<vector<int>> newg = g2;
        int newroot = -1;
        for (int u : g2[root]) {
            if (newroot == -1 || (s[newroot] < s[u])) newroot = u;
        }
        for (auto u : g2[root]) {
            if (u != newroot) newg[newroot].pb(u);
        }
        swap(g2, newg);
        root = newroot;
    }
    vector<int> pos(n);
    for (int i = 0; i < n; i++) pos[seq[i]] = i;
    for (int i = 0; i < n; i++) {
        int best = 0;
        for (int j = 0; j < n; j++) {
            bool in_s = false;
            int cntt = 0;
            auto dfs = [&](int v, auto&&self) -> void {
                cntt += (pos[v] < pos[i]);
                if (v == i) in_s = 1;
                for (int u : g[v]) {self(u, self);}
            };
            dfs(j, dfs);
            if (!in_s) {
                best = max(best, cntt);
            }
        }
        ans[i] = pos[i] - best;
    }
    while (q--) {
        int v; cin >> v; cout << ans[v - 1] << ' ';
    }
    cout << '\n';
}

signed main() {
    int tt = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else
        cin.tie(0)->sync_with_stdio(false);
    #endif  

    while (tt--) {
        solve();
    }

    return 0;
}