#include <bits/stdc++.h>

using namespace std;

constexpr int maxn = 3e5 + 5;

vector<int> g[maxn];

int p[maxn];

int s[maxn];

int ans[maxn];

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector<int> ord = {0};
    set<pair<int, int>> candidates;
    for (auto v : g[0]) {
        candidates.emplace(s[v], v);
    }
    while (!candidates.empty()) {
        int v = candidates.rbegin()->second;
        candidates.erase(*candidates.rbegin());
        ord.push_back(v);
        for (auto u : g[v]) {
            candidates.emplace(s[u], u);
        }
    }
    multiset<int> vals;
    vector<int> cnt(n);
    for (int i = 1; i < n; ++i) {
        vals.insert(cnt[i]);
    }
    for (int i = 0; i < n; ++i) {
        int v = ord[i];
        int nw = v;
        while (nw != 0) {
            vals.erase(vals.find(cnt[nw]));
            nw = p[nw];
        }
        ans[v] = i;
        if (!vals.empty()) {
            ans[v] = i - *vals.rbegin();
        }
        nw = v;
        while (nw != 0) {
            cnt[nw]++;
            vals.insert(cnt[nw]);
            nw = p[nw];
        }
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << ans[v] << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
