#include <bits/stdc++.h>

using namespace std;
const int MAXN = 3e5 + 1;
vector<int> g[MAXN];
int s[MAXN], ans[MAXN];

void solve() {
    int u = 1, timer = 1;
    set<pair<int, int>, greater<>> rm;
    for (int v: g[u]) {
        rm.emplace(s[v], v);
    }
    while (!rm.empty()) {
        auto [_, v] = *rm.begin();
        rm.erase(rm.begin());
        u = v;
        for (int v: g[u]) {
            rm.emplace(s[v], v);
        }
        ans[u] = min(ans[u], timer);
        timer++;
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        ans[i] = MAXN;
        cin >> s[i];
    }
    ans[1] = 0;
    for (int i = 1; i <= n; i++) {
        sort(g[i].begin(), g[i].end(), [&](int a, int b) {
            return s[a] < s[b];
        });
    }
    for (int i = 0; i <= n; i++) {
        int was = s[i];
        s[i] = 0;
        solve();
        s[i] = was;
    }
    while (q--) {
        int v;
        cin >> v;
        cout << ans[v] << " ";
    }
    return 0;
}
