//#pragma GCC optimize("unroll-loops,Ofast")
//#pragma GCC target("sse,sse2,avx,avx2")

#include <bits/stdc++.h>

using namespace std;
const int inf = 1e9;
vector<set<pair<int, int>>> g;
vector<int> s, pr;
vector<int> poses;
vector<int> PP;
int n;
struct query {
    int v, i, pos;
};

bool cmp(query a, query b) {
    return a.pos < b.pos;
}

void get_poses(int v) {
    poses.assign(n, 0);
    auto g1 = g;
    if (v) {
        g1[pr[v]].erase({s[v], v});
        g1[pr[v]].insert({0, v});
    }
    int root = 0;
    int tim = 0;
    while (true) {
        poses[root] = tim++;
        if (g1[root].empty())break;
        auto z = --g1[root].end();
        int r1 = z->second;
        g1[root].erase(z);
        if (g1[root].size() > g1[r1].size()) {
            swap(g1[root], g1[r1]);
        }
        for (auto to: g1[root]) {
            g1[r1].insert(to);
        }
        root = r1;
    }
}

vector<int> depth, tin, tout;
vector<int> dp;
int t;

void dfs(int v, int d) {
    tin[v] = t++;
    depth[v] = d;
    for (auto to: g[v]) {
        dfs(to.second, d + 1);
    }
    tout[v] = t++;
}

void solve() {
    int q;
    cin >> n >> q;
    pr.assign(n, 0), s.assign(n, 0), g.assign(n, {});
    depth.assign(n, 0), dp.assign(n, 0), PP.assign(n, 0);
    tin.assign(n, 0), tout.assign(n, 0);
    for (int i = 1; i < n; ++i) {
        cin >> pr[i];
        pr[i]--;
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 1; i < n; ++i) {
        g[pr[i]].insert({s[i], i});
    }
    t = 0;
    dfs(0, 0);
    get_poses(0);
    for (int i = 0; i < n; ++i) {
        PP[i] = poses[i];
    }
    vector<query> Q;
    vector<bool> used(n, false);
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        v--;
        used[v] = true;
        Q.push_back({v, i, PP[v]});
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i])Q.push_back({i, -1, PP[i]});
    }
    sort(Q.begin(), Q.end(), cmp);
    vector<int> ans(q);
    for (int i = 0; i < n; ++i) {
        int v = Q[i].v;
        int id = Q[i].i;
        if (id == -1) {
            while (true) {
                dp[v]++;
                if (v == 0)break;
                v = pr[v];
            }
        } else {
            ans[id] = PP[v];
            if (v) {
                int P = pr[v];
                int V = v;
                while (true) {
                    for (auto to: g[P]) {
                        if (to.second == V)continue;
                        ans[id] = min(ans[id], PP[v] - dp[to.second]);
                    }
                    if (P == 0)break;
                    V = P;
                    P = pr[P];
                }
            }
            while (true) {
                dp[v]++;
                if (v == 0)break;
                v = pr[v];
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
