#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = (int) 1e5 * 3 + 10;

vector<int> g[N];

int p[N], s[N], ans[N], cur = 0, val[N], tin[N], tout[N], timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for (auto u: g[v])
        if (u != p[v])
            dfs(u);
    tout[v] = timer++;
}

bool anc(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

vector<int> tour;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    p[0] = -1;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        --p[i], g[p[i]].emplace_back(i);
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    dfs(0);
    vector<int> neigh = g[0];
    int ver = 0;
    while ((int) tour.size() < n) {
        tour.emplace_back(ver);
        ver = -1;
        for (auto u: neigh) {
            if (ver == -1 || s[u] > s[ver])
                ver = u;
        }
        vector<int> new_neigh;
        for (auto u: neigh) {
            if (u != ver) new_neigh.emplace_back(u);
            else for (auto uu: g[u]) new_neigh.emplace_back(uu);
        }
        neigh = new_neigh;
    }
    for (int i: tour) {
        int mx = 0;
        for (int j = 0; j < n; j++)
            if (!anc(j, i))
                mx = max(mx, val[j]);
        ans[i] = cur - mx;
        cur++;
        int v = i;
        while (v != -1) {
            val[v]++;
            v = p[v];
        }
    }
    for (int i = 0; i < q; i++) {
        int v;
        cin >> v;
        cout << ans[v - 1] << " ";
    }
    return 0;
}