// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(69); // chrono::steady_clock::now().time_since_epoch().count()
#define all(x) x.begin(), x.end()
#define int long long
#define ull unsigned long long
#define ld long double
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2")

const long long INF = 1e15 + 69;

vector<vector<int>> graph;
vector<int> p;
vector<int> s;
vector<int> tin;
vector<int> tout;
vector<int> ans_source;
int cur_t = 0;
int ans;

void dfs_precalc(int v, int p) {
    tin[v] = cur_t++;
    for (auto u : graph[v]) {
        if (u != p) {
            dfs_precalc(u, v);
        }
    }
    tout[v] = cur_t++;
}

bool is_ancestor(int v, int u) {
    return (tin[v] <= tin[u] && tout[v] >= tout[u]);
}

bool cmp(int v, int u) {
    return s[v] > s[u];
}

int dfs_calc_subtree(int v, int min_q) {
    int cur_ans = 1;
    for (auto u : graph[v]) {
        if (u != p[v] && s[u] > min_q) {
            cur_ans += dfs_calc_subtree(u, min_q);
        }
    }
    ans = max(ans, cur_ans);
    return cur_ans;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    int n, q, v;
    cin >> n >> q;
    graph.resize(n);
    p.resize(n, -1);
    tin.resize(n);
    tout.resize(n);
    s.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        graph[p[i]].push_back(i);
    }
    set<pair<int, int>> first_dfs;
    first_dfs.insert({s[0], 0});
    cur_t = 0;
    ans_source.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    while (first_dfs.size()) {
        v = (*(--first_dfs.end())).second;
        first_dfs.erase(--first_dfs.end());
        for (auto u : graph[v]) {
            first_dfs.insert({s[u], u});
        }
        ans_source[v] = cur_t++;
    }
    cur_t = 0;
    dfs_precalc(0, 0);
    for (int i = 0; i < q; i++) {
        cin >> v;
        v--;
        int cur_min = s[v];
        ans = 0;
        int cur_ans = ans_source[v];
        while (v) {
            cur_min = min(cur_min, s[v]);
            for (auto u : graph[p[v]]) {
                if (u != p[p[v]]) {
                    if (s[u] > cur_min && u != v) {
                        dfs_calc_subtree(u, cur_min);
                    }
                }
            }
            v = p[v];
        }
        cout << cur_ans - ans << " ";
    }
    return 0;
}
