#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <fstream>
#include <algorithm>
#include <queue>

using ll = long long;
#define endl '\n'
#pragma GCC target("avx,avx2,fma")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("O3")
// #pragma GCC optimize("unrool-loops")

using namespace std;

//const int N = 100000 + 1, mod = 1e9 + 7;
int n, m, k, q, N, M;
int st = 1;

vector<int> p;
vector<vector<int>> g;
vector<int> mxt;
vector<int> tt;
vector<int> s;

vector<int> h;
vector<int> sz;
vector<bool> used;
void predfs(int v) {
	for (auto u : g[v]) {
		if (u != p[v]) {
			h[u] = h[v] + 1; predfs(u);
		}
	}
}
void calcsz(int v, int pr) {
	sz[v] = 1;
	for (auto u : g[v]) {
		if (u != pr && !used[u]) {
			calcsz(u, v);
			sz[v] += sz[u];
		}
	}
}

int findc(int v, int pr, int szz) {
	for (auto u : g[v]) {
		if (!used[u] && u != pr && sz[u] >= szz / 2) return findc(u, v, szz);
	}
	return v;
}

vector<int> tree;
void upd(int v) {
	v /= 2;
	while (v > 0) {
		tree[v] = max(tree[2 * v], tree[2 * v + 1]);
		v /= 2;
	}
}
int get(int v, int vl, int vr, int ql, int qr) {
	if (vr < ql || qr < vl) return 0;
	if (ql <= vl && vr <= qr) return tree[v];
	return max(get(2 * v, vl, (vl + vr) / 2, ql, qr), get(2 * v + 1, (vl + vr + 1) / 2, vr, ql, qr));
}
vector<vector<int>> num;
int ind;
void dfs1(int v, int pr, int x) {
	x = min(x, s[v]);
	num[ind].push_back(x);
	for (auto u : g[v]) {
		if (!used[u] && u != pr) dfs1(u, v, x);
	}
}
vector<vector<int>> num2; int ind2 = 0;
void dfs13(int v, int pr, int x) {
	x = min(x, s[v]);
	num2[ind2].push_back(x);
	for (auto u : g[v]) {
		if (!used[u] && u != pr) dfs13(u, v, x);
	}
}
void dfs12(int v, int pr, int x) {
	for (auto u : g[v]) {
		if (!used[u] && u != pr && p[v] != u) {
			num2.emplace_back();
			ind2++;
			dfs13(u, v, x);
		}
	}
	if (p[v] != -1 && !used[p[v]]) {
		dfs12(p[v], v, x);
	}
}
vector<multiset<int>> mn;
vector<int> numall;
void dfs2(int v, int pr) {
	mxt[v] = max(mxt[v], get(1, 0, st - 1, lower_bound(numall.begin(), numall.end(), s[v]) - numall.begin(), st - 1));
	for (auto u : g[v]) {
		if (!used[u] && u != pr) dfs2(u, v);
	}
}
void dfsnum(int v, int pr) {
    numall.push_back(s[v]);
    for (auto u : g[v]) {
        if (!used[u] && u != pr) dfsnum(u, v);
    }
}
void cen(int v) {
	calcsz(v, -1);
	int x = findc(v, -1, sz[v]);
	calcsz(x, -1);
	num.clear();
	numall.clear();
    dfsnum(x, -1);
	num.resize(g[x].size());
	for (int i = (x != 0); i < g[x].size(); i++) {
		if (used[g[x][i]]) continue;
		ind = i;
		dfs1(g[x][i], x, 1e9);
		sort(num[ind].begin(), num[ind].end());
	}
	ind2 = -1; num2.clear();
	if (p[x] >= 0 && !used[p[x]]) dfs12(p[x], x, 1e9);

	sort(numall.begin(), numall.end());
	numall.erase(unique(numall.begin(), numall.end()), numall.end());
	st = 1;
	while (st < sz[x]) st <<= 1;
	tree.assign(2 * st, 0);
	mn.clear(); mn.resize(st); for (int i = 0; i < mn.size(); i++) mn[i].insert(0);
	for (int i = (v != 0); i < g[x].size(); i++) {
		if (used[g[x][i]]) continue;
		for (int j = num[i].size() - 1; j >= 0; j--) {
			int ii = lower_bound(numall.begin(), numall.end(), num[i][j]) - numall.begin();
			mn[ii].insert(j - num[i].size());
			if (*mn[ii].begin() != tree[st + ii]) {
				tree[st + ii] = -*mn[ii].begin();
				upd(st + ii);
			}
		}
	}
	for (int i = (x != 0); i < g[x].size(); i++) {
		if (used[g[x][i]]) continue;
		for (int j = num[i].size() - 1; j >= 0; j--) {
			int ii = lower_bound(numall.begin(), numall.end(), num[i][j]) - numall.begin();
			mn[ii].erase(mn[ii].find(j - num[i].size()));
			if (*mn[ii].begin() != tree[st + ii]) {
				tree[st + ii] = -*mn[ii].begin();
				upd(st + ii);
			}
		}
		dfs2(g[x][i], x);
		for (int j = num[i].size() - 1; j >= 0; j--) {
			int ii = lower_bound(numall.begin(), numall.end(), num[i][j]) - numall.begin();
			mn[ii].insert(j - num[i].size());
			if (*mn[ii].begin() != tree[st + ii]) {
				tree[st + ii] = -*mn[ii].begin();
				upd(st + ii);
			}
		}
	}
	if (x != 0 && !used[g[x][0]]) {
        
		mn.clear(); mn.resize(st); for (int i = 0; i < mn.size(); i++) mn[i].insert(0);
        tree.assign(2 * st, 0);
		for (auto& x : num2) {
			for (int j = x.size() - 1; j >= 0; j--) {
				int ii = lower_bound(numall.begin(), numall.end(), x[j]) - numall.begin();
				mn[ii].insert(j - x.size());
				if (*mn[ii].begin() != tree[st + ii]) {
					tree[st + ii] = -*mn[ii].begin();
					upd(st + ii);
				}
			}
		}
		for (int i = 1; i < g[x].size(); i++) {
			if (!used[g[x][i]]) {
				dfs2(g[x][i], x);
			}
		}
	}
	used[x] = true;
	for (auto u : g[x]) {
		if (!used[u]) cen(u);
	}
}

vector<vector<int>> cl; int ii;
void subdfs(int v, int pr, int x) {
    x = min(s[v], x);
    cl[ii].push_back(x);
    for (auto u : g[v]) if (u != pr) subdfs(u, v, x);
}
void dfs3(int v, int pr) {
    ii = -1;
    cl.clear(); cl.resize(g[v].size() - (v != 0));
    for (auto x : g[v]) {
        if (x != pr) {
            ii++;
            subdfs(x, v, 1e9);
            sort(cl[ii].begin(), cl[ii].end());
        }
    }
    for (auto x : g[v]) {
        if (x == pr)continue;
        ii = 0;
        for (auto u : g[v]) {
            if (u==x)ii++;
            if (u == pr || u == x) continue;
            mxt[x] = max(mxt[x], (int)(cl[ii].end() - lower_bound(cl[ii].begin(), cl[ii].end(), s[x])));
            ii++;
        }
    }
}


void solve() {
	cin >> n >> q;
	tt.assign(n, 0); mxt.assign(n, 0);
	h.resize(n, 0);
	sz.resize(n);
	used.assign(n, false);
	g.resize(n);
	p.assign(n, -1);
	for (int i = 1; i < n; i++) {
		cin >> p[i]; p[i]--;
		g[p[i]].push_back(i);
		g[i].push_back(p[i]);
	}
	s.resize(n);
	for (auto& x : s) cin >> x;
	priority_queue<pair<int, int>> qq;
	qq.push({ s[0], 0 });
	int timer = 0;
	while (!qq.empty()) {
		int v = qq.top().second; qq.pop();
		tt[v] = timer++;
		for (auto u : g[v]) {
			if (u != p[v] && u != n) qq.push({ s[u], u });
		}
	}
	cen(0);

    dfs3(0, -1);
	while (q--) {
		int v; cin >> v; --v;
		cout << tt[v] - mxt[v] << ' ';
	}
}

#define LOCAL
signed main() {
	ios_base::sync_with_stdio(false);
	cout.tie(0);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif
	int t = 1;  //cin >> t;
	while (t--) {
		solve();
	}
}