#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <fstream>
#include <algorithm>
#include <queue>

using ll = long long;
#define endl '\n'
#pragma GCC target("avx,avx2,fma")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("O3")
// #pragma GCC optimize("unrool-loops")

using namespace std;

//const int N = 100000 + 1, mod = 1e9 + 7;
int n, m, k, q, N, M;
int st = 1;

vector<int> p;
vector<vector<int>> g;
vector<int> mxt;
vector<int> tt;
vector<int> s;

vector<int> h;
vector<int> sz;
vector<bool> used;

vector<vector<int>> cl; int ii;
void subdfs(int v, int pr, int x) {
    x = min(s[v], x);
    cl[ii].push_back(x);
    for (auto u : g[v]) if (u != pr) subdfs(u, v, x);
}
void dfs3(int v, int pr) {
    ii = -1;
    cl.clear(); cl.resize(g[v].size() - (v != 0));
    for (auto x : g[v]) {
        if (x != pr) {
            ii++;
            subdfs(x, v, 1e9);
            sort(cl[ii].begin(), cl[ii].end());
        }
    }
    for (auto x : g[v]) {
        if (x == pr)continue;
        ii = 0;
        for (auto u : g[v]) {
            if (u==x)ii++;
            if (u == pr || u == x) continue;
            mxt[x] = max(mxt[x], (int)(cl[ii].end() - lower_bound(cl[ii].begin(), cl[ii].end(), s[x])));
            ii++;
        }
    }
}




void solve() {
	cin >> n >> q;
	tt.assign(n, 0); mxt.assign(n, 0);
	h.resize(n, 0);
	sz.resize(n);
	used.assign(n, false);
	g.resize(n);
	p.assign(n, -1);
	for (int i = 1; i < n; i++) {
		cin >> p[i]; p[i]--;
		g[p[i]].push_back(i);
		g[i].push_back(p[i]);
	}
	s.resize(n);
	for (auto& x : s) cin >> x;
    vector<bool> ch(n, false);
    int x0 = 0;
    for (int i = 0; i < n; i++) {
        if (p[i] != i - 1 || (i && ch[i - 1])) ch[i] = true;
        if (!ch[i]) x0++;
    }

	while (q--) {
		int v; cin >> v; --v;
        if (ch[v]) {
            cout << v + 2 - x0 << ' ';
        } else {
            cout << v + 1 << ' ';
        }
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cout.tie(0);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
#endif
	int t = 1;  //cin >> t;
	while (t--) {
		solve();
	}
}