#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>

using namespace std;

using ll = long long;

#pragma GCC optimaze("Ofast");

vector<vector<int>> gr;
vector<ll> s;

void dfs(int v, ll& su, ll x) {
	if (s[v] <= x) return;
	su++;
	for (int u : gr[v]) dfs(u, su, x);
}

vector<int> h;

void dfs2(int v, int H) {
	h[v] = H;
	for (int u : gr[v]) {
		dfs2(u, H + 1);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll n, q;
	cin >> n >> q;
	gr.resize(n);
	h.resize(n);
	vector<int> p(n, -1);
	s.resize(n);
	for (int i = 1; i < n; i++) {
		int x;
		cin >> x;
		x--;
		p[i] = x;
		gr[x].push_back(i);
	}
	for (int i = 0; i < n; i++) cin >> s[i];
	dfs2(0, 0);
	while (q--) {
		int v;
		cin >> v;
		v--;
		cout << h[v] << ' ';
	}
}



