#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#define int long long
using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

mt19937_64 rnd(1488);

vector<vector<int>> G;
vector<int> C1;
vector<int> P, tin, tout, cnt, dp;
int t;
int a;

void dfs(int v) {
    tin[v] = t;
    ++t;
    for (auto i : G[v]) {
        dfs(i);
    }
    tout[v] = t;
}

bool anc(int a, int b) {
    return (tin[a] <= tin[b] && tout[b] <= tout[a]);
}

int ans1 = 0;

void dfs1(int v, int q) {
    dp[v] += cnt[v];
    for (auto i : G[v]) {
        dfs1(i, q);
        dp[v] += dp[i];
    }
    if (!anc(v, q)) {
        ans1 = max(ans1, dp[v]);
    }
}

signed main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);
    int q;
    cin >> a >> q;
    P.resize(a, 0);
    G.resize(a);
    tin.resize(a, 0);
    tout.resize(a, 0);
    for (int i = 1; i < a; ++i) {
        int b;
        cin >> b;
        --b;
        G[b].push_back(i);
        P[i] = b;
    }
    dfs(0);
    set<pair<int, int>> C;
    C1.resize(a);
    cnt.resize(a);
    for (int i = 0; i < a; ++i) {
        cin >> C1[i];
    }
    vector<int> ans(q), Q(a, -1);
    for (int i = 0; i < q; ++i) {
        int q1;
        cin >> q1;
        --q1;
        Q[q1] = i;
    }
    C.insert({0, 0});
    for (int i = 0; i < a; ++i) {
        int op = C.begin()->second;
        ++cnt[op];
        if (Q[op] != -1) {
            ans1 = 0;
            dp.assign(a, 0);
            dfs1(0, op);
            ans[Q[op]] = i - ans1;
        }
        C.erase(C.begin());
        for (auto i : G[op]) {
            C.insert({-C1[i], i});
        }
    }
    for (auto i : ans) {
        cout << i << ' ';
    }
}

