#include <bits/stdc++.h>
using namespace std;

const int N = 3e5 + 100;
int n, q, par[N], sz[N], a[N], ans[N], asked[N], stme[N], ftme[N], tme;
vector<int> g[N], vec;
priority_queue<pair<int, int>> order;
bool mark[N];

void traverse(){
    order.push({a[1], 1});
    while (!order.empty()){
        int v = (order.top()).second;
        order.pop();
        vec.push_back(v);
        for (int u : g[v])
            order.push({a[u], u});
    }
}


void dfs(int v){
    stme[v] = tme++;
    sz[v] = mark[v];
    for (int u : g[v]){
        dfs(u);
        sz[v] += sz[u];
    }
    ftme[v] = tme;
}

bool insub(int u, int v){
    return (stme[v] <= stme[u] and stme[u] < ftme[v]);
}

int main(){
    ios::sync_with_stdio(0); cin.tie(0);

    cin >> n >> q;
    for (int i = 2; i <= n; i ++){
        cin >> par[i], g[par[i]].push_back(i);
    }
    for (int i = 1; i <= n; i ++)
        cin >> a[i];

    traverse();
    for (int i = 1; i <= q; i ++){
        int v;
        cin >> v;
        asked[v] = i;
        memset(mark, 0, sizeof mark);
        for (int u : vec){
            mark[u] = 1;
            if (u == v) break;
        }
        dfs(1);

        int visited = sz[1];
        ans[asked[v]] = visited;
        for (int u = 1; u <= n; u ++)
            if (!insub(v, u))
                ans[asked[v]] = min(ans[asked[v]], visited - sz[u]);
    }

    for (int i = 1; i <= q; i ++)
        cout << ans[i] - 1 << " ";
    cout << endl;
}