#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
using namespace std;

#define ll long long
#define ull unsigned long long
#define db double
#define str string
#define vc vector
#define its(a) (a).begin(), (a).end()
#define itsr(a) (a).rbegin(), (a).rend()
#define tstr(a) to_string((a))
#define INF ((ll)1e18)

void solve() {
    ll n, q; cin >> n >> q;
    vc<vc<ll>> g(n);
    vc<ll> stop(n);
    for (int i = 1;i < n ;++i) {
        ll u; cin >> u;
        --u;
        if (u == 0) stop[i] = 1;
        g[u].push_back(i);
    }
    vc<ll> as(n);
    ll cur = 1;
    for (int i = 1;i < n;++i) {
        if (stop[i]) {
            cur = 1;
        }
        as[i] = cur;
        ++cur;
    }

    vc<ll> s(n);
    for (auto& i : s) cin >> i;
    for (int i = 0;i < q;++i) {
        ll u; cin >> u;
        cout << as[u-1] << " ";
    }
    return;



    ll ans = 0;
    ll best = 0;
    for (int i = 0;i < n;++i) {
        sort(its(g[i]), [&s](ll i, ll j)->bool {
            return s[i] > s[j];
            });
    }
    vc<ll> trs(n);
    auto ct = [&](auto ct, int u) -> void {
        ll cur = 1;
        for (auto v : g[u]) {
            ct(ct, v);
            cur += trs[v];
        }
        trs[u] = cur;
        };
    ct(ct, 0);
    vc<ll> path;
    ll timer = 0;
    vc<ll> tin(n), tout(n);
    auto dfst = [&](auto dfst, int u) -> void {
        tin[u] = timer++;
        for (auto v : g[u]) {
            dfst(dfst, v);
        }
        tout[u] = timer;
        };
    dfst(dfst, 0);
    vc<ll> szt(n);
    auto dfs = [&](auto dfs, int u, int f) ->  void {
        ll t = 1;

        for (auto v : g[u]) {
            if (s[v] > s[f]) {
                dfs(dfs, v, f);
                t += szt[v];
            }
        }
        szt[u] = t;
    };
    auto fnd = [&](auto fnd, int u, int f) ->  void {
        ll t = 1;

        for (auto v : g[u]) {
            if (tin[v] <= tin[f] and tout[f] <= tout[v]) {
                ++ans;
                fnd(fnd, v, f);
            }
            else {
                ans += szt[v];
                best = max(best, szt[v]);
            }
        }

        };



    while (q--) {
        ll u; cin >> u; --u;
        if (u == 0) { cout << "0 "; continue; }
        best = 0;
        ans = 0;
        szt.assign(n, 0);
        dfs(dfs, 0, u);
        fnd(fnd, 0, u);
        cout << ans - best << " ";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll _t = 1;
    //cin >> _t;
    while (_t--)
        solve();
}
