#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
using namespace std;

#define ll long long
#define ull unsigned long long
#define db double
#define str string
#define vc vector
#define its(a) (a).begin(), (a).end()
#define itsr(a) (a).rbegin(), (a).rend()
#define tstr(a) to_string((a))
#define INF ((ll)1e18)

void solve() {
    ll n, q; cin >> n >> q;
    vc<vc<ll>> g(n);
    vc<ll> pr(n, -1);
    for (int i = 1;i < n ;++i) {
        ll u; cin >> u;
        --u;
        pr[i] = u;
        g[u].push_back(i);
    }
    

    vc<ll> s(n);
    for (auto& i : s) cin >> i;
    
    for (int i = 0;i < n;++i) {
        sort(its(g[i]), [&s](ll i, ll j) -> bool {
            return s[i] > s[j];
            });
    }
    vc<ll> vt;
    
    set<pair<ll, ll>> cand;
    for (auto u : g[0]) cand.insert({ s[u], u });

    while (cand.size()) {
        auto [cs, u] = *cand.rbegin();
        vt.push_back(u);
        cand.erase({ cs, u });
        for (auto v : g[u]) {
            cand.insert({ s[v], v });
        }
    }

    vc<ll> used(n);
    vc<ll> trs(n);
    trs[0] = used[0] = 1;
    
    vc<ll> tr(4 * n);
    vc<ll> add(4 * n);
    auto push = [&](int v, int l, int r) {
        if (add[v] == 0) return;
        if (r - l == 1) {
            tr[v] += add[v];
            add[v] = 0;
            return;
        }
        tr[v] += add[v];
        add[2 * v + 1] += add[v];
        add[2 * v + 2] += add[v];
        add[v] = 0;
    };
    auto rsq = [&](auto rsq, int v, int l, int r, int lq, int rq, ll x) -> void {
        push(v, l, r);
        if (lq <= l and r <= rq) {
            add[v] = x;
            push(v, l, r);
            return;
        }
        if (r <= lq or rq <= l) {
            return;
        }
        int mid = (r + l) >> 1;
        rsq(rsq, 2 * v + 1, l, mid, lq, rq, x);
        rsq(rsq, 2 * v + 2, mid, r, lq, rq, x);
        tr[v] = max(tr[2 * v + 1], tr[2 * v + 2]);
        
    };
    vc<ll> head(n, -1);
    auto hld_reord = [&](auto hld_reord, int u, int p) -> ll {
        pair<ll, ll> bst = { -1, -1 };
        ll st = 1;
        for (auto v : g[u]) {
            ll t = hld_reord(hld_reord, v, u);
            bst = max(bst, { t, v });
            st += t;
        }
        for (int i = 0;i < g[u].size();++i) {
            if (g[u][i] == bst.second) swap(g[u][i], g[u][0]);
        }
        return st;
    };
    vc<ll> dep(n);
    vc<ll> tin(n);
    ll timer = 0;
    head[0] = 0;
    auto dfs = [&](auto dfs, int u, int p) -> void {
        tin[u] = timer++;
        for (auto v : g[u]) {
            if (v == g[u][0]) {
                head[v] = head[u];
            }
            else head[v] = v;
            dep[v] = dep[u] + 1;
            dfs(dfs, v, u);
        }
    };
    hld_reord(hld_reord, 0, 0);
    dfs(dfs, 0, 0);
    auto rsq_p = [&](int u, ll x) {
        while (head[u] != 0) {
            rsq(rsq, 0, 0, n, tin[head[u]], tin[u] + 1, x);
            u = pr[head[u]];
        }
        rsq(rsq, 0, 0, n, tin[0], tin[u] + 1, x);
    };
    rsq(rsq, 0, 0, n, 0, 1, 1);
    vc<ll> ans(n);
    ll crs = 0;
    for (auto u : vt) {
        if (u == 0) continue;
        ++crs;
        ll v = u;
       /* while (v != -1) {
            used[v] = 1;
            rsq(rsq, 0, 0, n, v, -1e6);
            v = pr[v];
        }*/
        rsq_p(u, -1e6);
        push(0,0, n);
        if (tr[0] > 0) {
            ans[u] = crs - tr[0];
        }
        else ans[u] = crs;
        v = u;
        /*while (v != -1) {
            used[v] = 1;
            rsq(rsq, 0, 0, n, v, 1e6+1);
            v = pr[v];
        }*/
        rsq_p(u, 1e6+1);
    }

    for (int i = 0;i < q;++i) {
        ll u; cin >> u;
        cout << ans[u - 1] << " ";
    }
    
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll _t = 1;
    //cin >> _t;
    while (_t--)
        solve();
}
