#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <array>
#include <iomanip>
using namespace std;
using ll = long long;
using ld = long double;
#define endl '\n'
vector<vector<int>> g;
vector<int> s; vector<int> ord;
vector<int> dp;
struct tree {
	int l, r; vector<int> v;
	tree* left = 0, *right = 0;
	tree(int l, int r, vector<int>&vv) :l(l), r(r) {
		for (int i = l; i <= r; i++) v.push_back(vv[i]);
		sort(v.begin(), v.end());
		if (l < r) {
			int mid = (l + r) >> 1;
			left = new tree(l, mid, vv); right = new tree(mid + 1, r, vv);
		}
	}
	int get(int lq, int rq, int x) {
		if (max(l, lq) > min(r, rq)) return 0;
		if (lq <= l && r <= rq) {
			return upper_bound(v.begin(), v.end(), x) - v.begin();
		}
		return left->get(lq, rq, x) + right->get(lq, rq, x);
	}
};
vector<int> tin, tout; int t = 0;
void dfs0(int v, int pr) {
	tin[v] = t++;
	for (auto to : g[v]) {
		if (to != pr) dfs0(to, v);
	}
	tout[v] = t;
}
tree* tr;
void dfs(int v, int pr) {
	vector<int> ch;
	for (auto to : g[v]) {
		if (to != pr) ch.push_back(to);
	}
	sort(ch.begin(), ch.end(), [](int a, int b) {return ord[a] < ord[b]; });
	for (int i = 0; i < ch.size(); i++) {
		int to = ch[i]; dp[to] = dp[v] + ord[to] - ord[v];
		for (int j = 0; j < i; j++) dp[to] = min(dp[to], ord[to] - tr->get(tin[ch[j]], tout[ch[j]] - 1, ord[i]));
	}
	for (auto el : ch) dfs(el, v);
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, q; cin >> n >> q; g.resize(n); s.resize(n);
	for (int i = 1; i < n; i++) {
		int p; cin >> p; p--; g[p].push_back(i); g[i].push_back(p);
	}
	for (auto& i : s) cin >> i;
	tin.resize(n); tout.resize(n); dfs0(0, 0);
	set<pair<int, int>> st; t = 0; ord.resize(n, -1); st.insert({ s[0], 0 });
	while (st.size()) {
		pair<int, int> par = *prev(st.end()); st.erase(prev(st.end())); int v = par.second; ord[v] = t++;
		for (auto to : g[v]) {
			if (ord[to] == -1) st.insert({ s[to], to });
		}
	}
	vector<int> v1(n);
	for (int i = 0; i < n; i++) v1[tin[i]] = ord[i];
	tr = new tree(0, n - 1, v1); dp.resize(n, 0);
	while (q--) {
		int x; cin >> x; x--; int res = ord[x];
		for (int i = 0; i < n; i++) {
			if (tin[i] <= tin[x] && tin[x] < tout[i]) continue;
			if (tin[x] <= tin[i] && tin[i] < tout[x]) continue;
			res = min(res, ord[x] - tr->get(tin[i], tout[i] - 1, ord[x]));
		}
		cout << res << endl;
	}
	return 0;
}
