#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define ull unsigned long long
#define sll __int128
#define size(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define int long long

mt19937 rnd(time(0));

vector<int> get(int n, vector<vector<int>> &g, vector<int> &s){
    set<pair<int, int>> ord = {{-s[0], 0}};
    vector<int> a(n);
    int k = 0;
    while (!ord.empty()){
        auto [w, v] = *ord.begin();
        ord.erase(ord.begin());
        for (auto to : g[v]){
            ord.insert({-s[to], to});
        }
        a[v] = k++;
    }
    return a;
}

void solve(){
    int n, q;
    cin >> n >> q;
    vector<vector<int>> g(n);
    vector<int> pr(n), nxt(n, -1);
    for (int i = 1; i < n; i++){
        int p; cin >> p; p--;
        g[p].push_back(i);
        pr[i] = p;
        if (p + 1 == i){
            nxt[p] = i;
        }
    }
    vector<int> s(n);
    for (auto &x : s){
        cin >> x;
    }
    vector<int> ans(n, n);
    ans[0] = 0;
    multiset<int> st;
    set<array<int, 3>> ord;
    vector<int> nw(n);
    int cnt = 0;
    for (auto v : g[0]){
        ord.insert({-s[v], v, cnt});
        st.insert(0);
    }
    int k = 1;
    while (!ord.empty()){
        auto [w, v, c] = *ord.begin();
        ord.erase(ord.begin());
        for (auto to : g[v]){
            ord.insert({-s[to], to, c});
        }
        st.erase(st.find(-nw[c]));
        if (st.empty()) ans[v] = k;
        else ans[v] = k + *st.begin();
        nw[c]++;
        st.insert(-nw[c]);
        k++;
    }
    for (int i = 0; i < q; i++){
        int x; cin >> x; x--;
        cout << ans[x] << " ";
    }
}

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while (ttt--){
        solve();
    }
}
