#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <experimental/random>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3,unroll-loops")
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;
#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
        cout << "\n";
    }
}

vector<vector<int>> g;
vector<int> col;
vector<int> s;

void dfs(int v) {
    col[v] = 0;
    set<pair<int, int>> u;
    for (auto to: g[v]) {
        u.insert({s[to], to});
    }
    int o = 0;
    while ((int) u.size() > 0) {
        auto k = *u.rbegin();
        u.erase(u.find(k));
        col[k.second] = o + 1;
        for (auto to: g[k.second]) {
            u.insert({s[to], to});
        }
        o++;
    }
}

vector<int> p;

int get2(int v, int f) {
    int sum = 0;
    if (col[v] < f) {
        sum++;
    } else {
        return 0;
    }
    for (auto to: g[v]) {
        sum += get2(to, f);
    }
    return sum;
}

int get(int v, int pr, int f) {
    if (v == -1) {
        return 0;
    }
    auto u = get(p[v], v, f);
    for (auto to: g[v]) {
        if (to != pr) {
            u = max(u, get2(to, f));
        }
    }
    return u;
}

void solve() {
    int n, q;
    cin >> n >> q;
    g.resize(n);
    col.resize(n);
    p.resize(n);
    for (int i = 1; i < n; ++i) {
        int p1;
        cin >> p1;
        p1--;
        g[p1].push_back(i);
        p[i] = p1;
    }
    p[0] = -1;
    s.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    dfs(0);
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        v--;
        cout << col[v] - get(p[v], v, col[v]) << " ";
    }
}