#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()

using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

const ll INF = 1e18;

void dfs(int s, vector<vector<int>> &g, vector<int> &p, int lst) {
    p[s] = lst;
    if (g[s].size() >= 2)
        lst = s;
    for (int i: g[s])
        dfs(i, g, p, lst);
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> p(n, -1);
    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    dfs(0, g, p, -1);
    vector<int> s(n);
    for (int &i: s)
        cin >> i;
    vector<set<pair<int, int>>> l(n);
    for (int i = 0; i < n; i++) {
        for (int j: g[i])
            l[i].insert({s[j], j});
    }
    vector<int> v(q), a(n);
    for (int i = 0; i < q; i++) {
        cin >> v[i];
        v[i]--;
    }
    vector<pair<pair<int, int>, pair<int, int>>> mx(n, {{-1, -1},
                                                        {-1, -1}});
    set<pair<int, int>> x{{s[0], 0}};
    vector<int> cnt(n);
    int num = 0;
    while (x.size()) {
        int r = x.rbegin()->second;
        x.erase(*x.rbegin());
        int r1 = r;
        int ans = 0;
        while (p[r1] != -1) {
            if (mx[p[r1]].first.second == r1)
                ans = max(ans, mx[p[r1]].second.first);
            else
                ans = max(ans, mx[p[r1]].first.first);
            cnt[r1]++;
            if (mx[p[r1]].first.second == r1)
                mx[p[r1]].first.first++;
            else if (mx[p[r1]].second.second == r1) {
                mx[p[r1]].second.first++;
                if (mx[p[r1]].first < mx[p[r1]].second)
                    swap(mx[p[r1]].first, mx[p[r1]].second);
            } else {
                pair<int, int> x = {cnt[r1], r1};
                if (mx[p[r1]].first < x) {
                    mx[p[r1]].second = mx[p[r1]].first;
                    mx[p[r1]].first = x;
                } else
                    mx[p[r1]].second = max(mx[p[r1]].second, x);
            }
            r1 = p[r1];
        }
        a[r] = num - ans;
        num++;
        if (x.size() < l[r].size())
            x.swap(l[r]);
        for (auto i: l[r])
            x.insert(i);
    }
    for (int i: v)
        cout << a[i] << ' ';
}