#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()

using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

const ll INF = 1e18;

void dfs(int s, vector<vector<int>> &g, vector<int> &cnt, vector<int> &cnt1) {
    for (int i: g[s]) {
        dfs(i, g, cnt, cnt1);
        cnt1[s] += cnt1[i];
    }
    cnt[s] += cnt1[s];
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> p(n, -1);
    vector<vector<int>> g(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    vector<int> s(n);
    for (int &i: s)
        cin >> i;
    vector<set<pair<int, int>>> l(n);
    for (int i = 0; i < n; i++) {
        for (int j: g[i])
            l[i].insert({s[j], j});
    }
    vector<int> v(q), u(n);
    for (int i = 0; i < q; i++) {
        cin >> v[i];
        v[i]--;
        u[v[i]] = 1;
    }
    set<pair<int, int>> x{{s[0], 0}};
    vector<int> cnt(n), cnt1(n);
    int num = 0;
    while (x.size()) {
        int r = x.rbegin()->second;
        x.erase(*x.rbegin());
        int r1 = r;
        if (u[r]) {
            dfs(0, g, cnt, cnt1);
            for (int &i: cnt1)
                i = 0;
            int ans = 0;
            while (p[r1] != -1) {
                for (int i: g[p[r1]]) {
                    if (i != r1)
                        ans = max(ans, cnt[i]);
                }
                r1 = p[r1];
            }
            u[r] = num - ans;
        }
        cnt1[r]++;
        if (x.size() < l[r].size())
            x.swap(l[r]);
        for (auto i: l[r])
            x.insert(i);
        num++;
    }
    for (int i: v)
        cout << u[i] << ' ';
}