#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

int n, q;

vector<vector<int>> g;
vector<int> h;
vector<int> s;

int get(int goal) {
    if (goal == 0) return 0;
    auto g_ = g;
    int cnt = 0;
    while (1) {
        cnt++;
        int mx = g_[0][0];
        for (int const &i : g_[0]) {
            if (s[i] > s[mx]) {
                mx = i;
            }
        }
        if (mx == goal) {
            return cnt;
        }
        for (int i = 0; i < g_[0].size(); ++i) {
            if (g_[0][i] == mx) {
                g_[0].erase(g_[0].begin() + i);
                break;
            }
        }
        for (int const &e : g_[mx]) g_[0].push_back(e);
    }
}

void solve() {
    cin >> n >> q;
    g.resize(n);
    h.resize(n);
    s.resize(n);
    int t;
    for (int i = 1; i < n; ++i) {
        cin >> t;
        g[t - 1].push_back(i);
    }
    for (int &e : s) cin >> e;
    for (int i = 0; i < q; ++i) {
        cin >> t;
        int res = n;
        for (int j = 0; j < n; ++j) {
            int was = s[j];
            s[j] = 0;
            res = min(res, get(t - 1));
            s[j] = was;
        }
        cout << res << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}