#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
//#define int long long
using ll = long long;

typedef tree<pair<int, int>, null_type,less<>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 3e5+10, inf = 1e9;
vector<int> g[N];
int p[N], s[N], a[N];
int cnt[N], u, ans = 0;

bool dfs(int v) {
    bool f = false;
    if (u == v) {
        f = true;
    }
    cnt[v] = 0;
    for (int i: g[v]) {
        bool t = dfs(i);
        f = (f||t);
        cnt[v] += cnt[i];
    }
    if (a[v] < a[u]) {
        cnt[v]++;
    }
    if (!f) {
        ans = max(ans, cnt[v]);
    }
    return f;
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }
    set<pair<int, int>> st;
    st.insert({s[1], 1});
    vector<int> vc;
    int j = 1;
    while (!st.empty()) {
        pair<int, int> p = *st.rbegin();
        st.erase(p);
        vc.push_back(p.second);
        a[p.second] = j;
        j++;
        for (int i: g[p.second]) {
            st.insert({s[i], i});
        }
    }
    while (q--) {
        ans = 0;
        cin >> u;
        dfs(1);
        cout << cnt[1] - ans << ' ';
    }
    return 0;
}