#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
//#define int long long
using ll = long long;

typedef tree<pair<int, int>, null_type,less<>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 4e5+10, inf = 1e9;
vector<int> g[N];
vector<pair<int, int>> g1[N];
int p[N], s[N], a[N];
int cnt[N], u, ans[N], otv = 0;
ordered_set st[N];

void dfs(int v) {
    cnt[v] = 0;
    for (int i: g[v]) {
        dfs(i);
        for (pair<int, int> r: st[i]) {
            st[v].insert(r);
        }
    }
    st[v].insert({a[v], v});
    return;
}

void dfs1 (int v, int k) {
    if (v*2 == k) {
        otv = max(otv, (int)st[v*2+1].size() - (int)st[v*2+1].order_of_key({a[u], -inf}));
    } else {
        otv = max(otv, (int)st[v*2].size() - (int)st[v*2].order_of_key({a[u], -inf}));
    }
    if (v == 1) {
        return;
    }
    dfs1(v/2, v);
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }
    set<pair<int, int>> st;
    st.insert({s[1], 1});
    vector<int> vc;
    int j = 1;
    while (!st.empty()) {
        pair<int, int> p = *st.rbegin();
        st.erase(p);
        vc.push_back(p.second);
        a[p.second] = j;
        j++;
        for (int i: g[p.second]) {
            st.insert({s[i], i});
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j: g[i]) {
            g1[i].push_back({a[j], j});
        }
        sort(g1[i].begin(), g1[i].end());
    }
    dfs(1);
    while (q--) {
        cin >> u;
        if (u == 1) {
            cout << 0 << ' ';
            continue;
        }
        otv = 0;
        dfs1(p[u], u);
        cout << a[u] - otv-1 << ' ';
    }
    return 0;
}