#include<bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 3e5 + 31;

int p[MAXN];

int best[MAXN];
int s[MAXN];

vector<int> g[MAXN];
int banned[MAXN];

set<pair<int, int>> now;

void solve(int v, int step = 0){
    best[v] = min(best[v], step);
    if(now.empty()) return;
    int ch = now.begin()->second;
    now.erase(now.begin());
    for(auto to : g[ch]){
        now.insert({-s[to], to});
    }
    solve(ch, step + 1);
}

signed main(){
    int n, q;
    cin >> n >> q;
    for(int i = 1; i < n; i++){
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    for(int i = 0; i < n; i++){
        best[i] = 1e9;
        cin >> s[i];
    }
    for(int i = 0; i < n; i++){
        int sv = s[i];
        s[i] = 0;
        for(auto to : g[0]){
            now.insert({-s[to], to});
        }
        solve(0);
        s[i] = sv;
    }
    while(q--){
        int x;
        cin >> x;
        x--;
        cout << best[x] << " ";
    }
}

