#include <bits/stdc++.h>

using namespace std;

#ifndef lisie_bimbi
#define endl '\n'
#endif

const int N = 1100;

random_device rd;

mt19937 rnd(rd());

vector<vector<int>> v;
vector<int> s;
vector<int> tin, tout;

bool cmp(int a, int b){
    return (s[a] > s[b]);
}

int tt = 0;

void dfs(int u){
    tin[u] = tt++;
    for(auto i : v[u]){
        dfs(i);
    }
    tout[u] = tt++;
}

bool isp(int a, int b){
    return ((tin[a] <= tin[b]) && (tout[a] >= tout[b]));
}

vector<int> sum;

void dfs2(int u){
    for(auto i : v[u]){
        dfs2(i);
        sum[u] += sum[i];
    }
}

vector<int> o;

void solve(){
    int n, q;
    cin >> n >> q;
    v.resize(n);
    for(int i = 1; i < n; i++){
        int pp;
        cin >> pp;
        pp--;
        v[pp].push_back(i);
    }
    s.resize(n);
    tin.resize(n);
    tout.resize(n);
    sum.resize(n);
    for(int i = 0; i < n; i++){
        cin >> s[i];
        sort(v[i].begin(), v[i].end(), cmp);
    }
    dfs(0);
    vector<int> o;
    set<pair<int, int>> st;
    st.insert({s[0], 0});
    while(!st.empty()){
        auto it = st.begin();
        o.push_back(it->second);
        st.erase(it);
        for(auto i : v[o.back()]){
            st.insert({-s[i], i});
        }
    }
    while(q--){
        int u;
        cin >> u;
        u--;
        sum.clear();
        sum.resize(n);
        for(int i = 0; o[i] != u; i++){
            sum[o[i]] = 1;
        }
        dfs2(0);
        int ans = sum[0];
        for(int i = 0; i < n; i++){
            if(isp(i, u)){
                continue;
            }
            ans = min(ans, sum[0] - sum[i]);
        }
        cout << ans << " ";
    }
    cout << endl;
}

signed main(){
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif            
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}