#include <bits/stdc++.h>

using namespace std;

#ifndef lisie_bimbi
#define endl '\n'
#endif

const int N = 1100;

random_device rd;

mt19937 rnd(rd());

vector<vector<int>> v;
vector<int> s;
vector<int> ans, ans2;
vector<int> mx;
vector<int> sz;

bool cmp(int a, int b){
    return (s[a] > s[b]);
}

int tt = 0;

void dfs(int u){
    ans[u] = tt++;
    sz[u] = 1;
    int now = 0;
    for(auto i : v[u]){
        dfs(i);
        sz[u] += sz[i];
        mx[i] = now;
        now = max(now, sz[i]);
    }
}

void dfs2(int u, int mx2){
    mx2 = max(mx2, mx[u]);
    ans2[u] = mx2;
    for(auto i : v[u]){
        dfs2(i, mx2);
    }
}

void solve(){
    int n, q;
    cin >> n >> q;
    v.resize(n);
    for(int i = 1; i < n; i++){
        int pp;
        cin >> pp;
        pp--;
        v[pp].push_back(i);
    }
    s.resize(n);
    sz.resize(n);
    mx.resize(n);
    for(int i = 0; i < n; i++){
        cin >> s[i];
    }
    for(int i = 0; i < n; i++){
        sort(v[i].begin(), v[i].end(), cmp);
    }
    ans.resize(n);
    ans2.resize(n);
    dfs(0);
    dfs2(0, 0);
    while(q--){
        int u;
        cin >> u;
        u--;
        cout << ans[u] - ans2[u] << " ";
    }
    cout << endl;
}

signed main(){
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif            
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}