#include <bits/stdc++.h>

using namespace std;

#ifndef lisie_bimbi
#define endl '\n'
#endif

const int N = 1100;

random_device rd;

mt19937 rnd(rd());

vector<vector<int>> v;
vector<int> s;

bool cmp(int a, int b){
    return (s[a] > s[b]);
}

vector<int> ord(int u){
    vector<int> o;
    set<pair<int, int>> st;
    st.insert({s[u], u});
    while(!st.empty()){
        auto it = st.begin();
        o.push_back(it->second);
        st.erase(it);
        for(auto i : v[o.back()]){
            st.insert({-s[i], i});
        }
    }
    return o;
}

vector<vector<int>> o;
vector<int> p;
vector<int> mx;
vector<int> ind;

void dfs(int u, int par){
    p[u] = par;
    o[u] = ord(u);
    for(auto i : v[u]){
        dfs(i, u);
    }
}

void dfs2(int u){
    int now = 0;
    if(v[u].empty()){
        return;
    }
    int last = ind[v[u][0]];
    for(auto i : v[u]){
        dfs2(i);
        now = max(now, ind[i] - last);
        last = ind[i];
        mx[i] = now;
    }   
}

void dfs3(int u, int mx2){
    mx2 = max(mx2, mx[u]);
    mx[u] = mx2;
    for(auto i : v[u]){
        dfs3(i, mx2);
    }
}

void solve(){
    int n, q;
    cin >> n >> q;
    v.resize(n);
    for(int i = 1; i < n; i++){
        int pp;
        cin >> pp;
        pp--;
        v[pp].push_back(i);
    }
    s.resize(n);
    p.resize(n);
    o.resize(n);
    mx.resize(n);
    ind.resize(n);
    for(int i = 0; i < n; i++){
        cin >> s[i];
    }
    for(int i = 0; i < n; i++){
        sort(v[i].begin(), v[i].end(), cmp);
    }
    dfs(0, -1);
    for(int k = 0; k < n; k++){
        auto i = o[k];
        for(int j = 0; j < i.size(); j++){
            if(p[i[j]] == k){
                ind[i[j]] = j;
            }
        }
    }
    dfs2(0);
    dfs3(0, 0);
    vector<int> ind2(n);
    for(int i = 0; i < n; i++){
        ind2[o[0][i]] = i;
    }
    /*
    for(auto i : ind){
        cout << i << " ";
    }
    cout << endl;
    for(auto i : mx){
        cout << i << " ";
    }
    cout << endl;
    */
    while(q--){
        int u;
        cin >> u;
        u--;
        cout << ind2[u] - mx[u] << " ";
    }
    cout << endl;
}

signed main(){
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif            
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}