#include <bits/stdc++.h>

using namespace std;

#ifndef lisie_bimbi
#define endl '\n'
#endif

const int N = 1100;

random_device rd;

mt19937 rnd(rd());

vector<vector<int>> v;
vector<int> s;

bool cmp(int a, int b){
    return (s[a] > s[b]);
}

vector<int> ord(int u){
    vector<int> o;
    set<pair<int, int>> st;
    st.insert({s[u], u});
    while(!st.empty()){
        auto it = st.begin();
        o.push_back(it->second);
        st.erase(it);
        for(auto i : v[o.back()]){
            st.insert({-s[i], i});
        }
    }
    return o;
}

vector<vector<int>> o;
vector<int> p;
vector<int> mx;
vector<int> ind;

void dfs(int u, int par){
    p[u] = par;
    o[u] = ord(u);
    for(auto i : v[u]){
        dfs(i, u);
    }
}

void dfs2(int u){
    int now = 0;
    if(v[u].empty()){
        return;
    }
    int last = ind[v[u][0]];
    for(auto i : v[u]){
        dfs2(i);
        now = max(now, ind[i] - last);
        last = ind[i];
        mx[i] = now;
    }   
}

void dfs3(int u, int mx2){
    mx2 = max(mx2, mx[u]);
    mx[u] = mx2;
    for(auto i : v[u]){
        dfs3(i, mx2);
    }
}

void solve(){
    int n, q;
    cin >> n >> q;
    v.resize(n);
    vector<int> z(n);
    int now = 0;
    z[0] = 0;
    for(int i = 1; i < n; i++){
        int pp;
        cin >> pp;
        pp--;
        if(pp != i - 1){
            now++;
        }
        z[i] = now;
        v[pp].push_back(i);
    }
    s.resize(n);
    p.resize(n);
    o.resize(n);
    mx.resize(n);
    ind.resize(n);
    for(int i = 0; i < n; i++){
        cin >> s[i];
    }
    for(int i = 0; i < n; i++){
        sort(v[i].begin(), v[i].end(), cmp);
    }
    vector<int> o = ord(0);
    int cnt = 0;
    multiset<int> s;
    now++;
    vector<int> t(now);
    for(auto i : t){
        s.insert(i);
    }
    vector<int> ans(n);
    int kk = 0;
    for(auto i : o){
        ans[i] = kk - *(--s.end());
        s.erase(s.find(t[z[i]]));
        t[z[i]]++;
        s.insert(t[z[i]]);
        kk++;
    }
    while(q--){
        int u;
        cin >> u;
        u--;
        cout << ans[u] << endl;
    }
}

signed main(){
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif            
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}