#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
struct fenw {
    vector<int> f;
    explicit fenw(int n) {
        f.resize(n);
    }
    void upd(int i, int x) {
        while (i < f.size()) {
            f[i] += x;
            i |= (i + 1);
        }
    }
    int get(int i) {
        int sum = 0;
        while (i >= 0) {
            sum += f[i];
            i %= (i + 1);
            i--;
        }
        return sum;
    }
};
template <typename T>
bool smin(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template <typename T>
bool smax(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    int st1 = 1, st2;
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        if (x != i) {
            st2 = i;
        }
    }
    for (int i = 0; i < n; i++) {
        int _;
        cin >> _;
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        if (v == 0) {
            cout << 0 << '\n';
        } else {
            if (v < st2) {
                cout << v - st1 + 1 << '\n';
            } else {
                cout << v - st2 + 1 << '\n';
            }
        }
    }
    return 0;
}
