//#pragma GCC optimize("O3, Ofast, unroll-loops, inline, no-stack-protector")
#include <bits/stdc++.h>
//#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using pii = pair<int, int>;

vector<vector<int>> g;
vector<int> cnt, s;


void calc(int v, int val) {
    if (s[v] < val) return;
    cnt[v] = 1;
    for (auto u : g[v]) {
        calc(u, val);
        cnt[v] += cnt[u];
    }
}

int ans = 1e9;
int now;
vector<int> st;

void dfs(int v, int dp0, int dp1) {
    if (v == now) {
        ans = min(dp0, dp1);
        return;
    }
    dp0 += 1;
    dp1 += 1;
    int sum = 0, mx = 0;
    st.pop_back();
    for (auto u : g[v]) {
        if (u == st.back()) continue;
        sum += cnt[u];
        mx = max(mx, cnt[u]);
    }
    dp1 = min(dp0 + sum - mx, dp1 + sum);
    dp0 += sum;
    dfs(st.back(), dp0, dp1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    g.resize(n);
    vector<int> p(n, -1);
    s.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) cin >> s[i];
    while (q --> 0) {
        int v;
        cin >> v;
        --v;
        cnt.assign(n, 0);
        int mn = s[v];
        now = v;
        int u = v;
        st.clear();
        while (u != -1) {
            st.push_back(u);
            mn = min(mn, s[u]);
            u = p[u];
        }
        calc(0, mn);
        dfs(0, 0, 0);
        cout << ans << " ";
    }
}
