#include <bits/extc++.h>
#define int long long

using namespace std;
using namespace __gnu_pbds;

const int inf = 2e9;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<pair<int, int>>> g;
vector<int> t;
int get(int v, int x) {
    int sum = t[v] < x;
    for (auto [f, u]: g[v]) {
        sum += get(u, x);
    }
    return sum;
}

void solve() {
    int n, k; cin >> n >> k;
    vector<int> p(n, -1), s(n);
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i]; --p[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        if (i != 0) {
            g[p[i]].push_back({-s[i], i});
        }
    }
    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
    }
    t.resize(n, inf);
    set<pair<int, int>> q;
    t.resize(n, inf);
    q.insert({s[0], 0});
    for (int i = 0; !q.empty(); ++i) {
        int v = q.begin()->second;
        q.erase(q.begin());
        t[v] = min(t[v], i);
        for (auto [f, u]: g[v]) {
            q.insert({f, u});
        }
    }
    for (int it = 0; it < k; ++it) {
        int v; cin >> v; --v;
        int vog = v;
        int cur = p[v];
        int ans = t[v];
        while (cur != -1) {
            int mx = 0;
            for (auto [f, u]: g[cur]) {
                if (u != v) {
                    mx = max(mx, get(u, t[vog]));
                }
            }
            ans = min(ans, t[vog] - mx);
            v = cur;
            cur = p[cur];
        }
        cout << ans << ' ';
    }
}

signed main(void) {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}