#include <iostream>
#include <set>
#include <vector>
#include <random>
#include <iomanip>
//#include <fstream>
#include <algorithm>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;
#define int long long
void dfs0(vector<vector<int>>& g, vector<int>& h, vector<vector<int>> &mt, vector<int> &cst, int u, int p) {
    int id1 = -1, id2 = -1;
    for (auto v : g[u]) {
        if (v == p) continue;
        if (id1 != -1) {
            id2 = v;
        }
        else {
            id1 = v;
        }
        h[v] = h[u] + 1;
        dfs0(g, h, mt, cst, v, u);
    }
    mt[u].push_back(cst[u]);
    int l = 0, r = 0;
    if (id1 != -1 and id2 != -1) {
        while (l < mt[id1].size() and r < mt[id2].size()) {
            if (mt[id1][l] > mt[id2][r]) {
                mt[u].push_back(mt[id1][l++]);
            }
            else {
                mt[u].push_back(mt[id2][r++]);
            }
        }
    }
    if (id1 != -1) {
        while (l < mt[id1].size()) {
            mt[u].push_back(mt[id1][l++]);
        }
    }
    if (id2 != -1) {
        while (r < mt[id2].size()) {
            mt[u].push_back(mt[id2][r++]);
        }
    }
}
signed main()
{
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    vector<vector<int>> g(n);
    vector<int> p(n, -1);
    for (int i = 1; i < n; i++) {
        int pr;
        cin >> pr;
        pr--;
        g[pr].push_back(i);
        p[i] = pr;
    }
    vector<int> cost(n);
    for (int i = 0; i < n; i++) {
        cin >> cost[i];
    }
    vector<int> h(n);
    vector<vector<int>> mt(n);
    vector<vector<int>> pm(n);
    
    dfs0(g, h,mt, cost, 0, 0);
    for (int i = 0; i < n; i++) {
        pm[i].push_back(mt[i][0]);
        for (int j = 1; j < mt[i].size(); j++) {
            pm[i].push_back(min(pm[i].back(), mt[i][j]));
        }
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        int ans = h[v];
        int u = v;

        int mxv = 0;
        int mnv = cost[v];
        int lst = v;
        int z = p[v];
        while (z != -1) {
            for (auto k : g[z]) {
                if (k == p[z] or k == lst) continue;
                int l = -1, r = pm[k].size();
                while (l + 1 < r) {
                    int mid = (l + r) / 2;
                    if (pm[k][mid] > mnv) {
                        l = mid;
                    }
                    else {
                        r = mid;
                    }
                }
                int val = l + 1;
                mxv = max(mxv, val);
                ans += val;
            }
            mnv = min(mnv, cost[z]);
            lst = z;
            z = p[z];
        }
        cout << ans - mxv << ' ';
    }
}