#ifdef LOCAL
// #define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) int((x).size())
using ld = long double;
using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;

void solve();

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}

int n, q;
vector<vector<int>> g;
vector<int> s;
vector<int> p;

struct cmp {
    bool operator()(const int a, const int b) const {
        return s[a] > s[b];
    }
};

vector<int> simulate() {
    vector<int> order;
    int root = 0;
    vector<set<int, cmp>> leika(n);
    for (int i = 0; i < n; i++) {
        for (int j : g[i]) {
            leika[i].insert(j);
        }
    }
    while (!leika[0].empty()) {
        int v = *leika[0].begin();
        leika[0].erase(leika[0].begin());
        order.push_back(root);
        root = v;
        if (leika[0].size() < leika[v].size()) {
            swap(leika[0], leika[v]);
        }
        leika[0].insert(all(leika[v]));
        leika[v].clear();
    }
    order.push_back(root);
    return order;
}

void solve() {
    cin >> n >> q;
    p.resize(n, -1);
    g.resize(n);
    s.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    vector<int> initial_order = simulate();
    while (q--) {
        int v;
        cin >> v;
        v--;
        int mn = n;
        for (int u : g[0]) {
            int su = s[u];
            s[u] = 0;
            vector<int> order = simulate();
            mn = min(mn, int(find(all(order), v) - order.begin()));
            s[u] = su;
        }
        cout << mn << '\n';
    }
}