#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define int long long
constexpr int INF = 1e18;
constexpr int MOD = 1e9 + 7;
//mt19937_64 rnd(0);

vector<vector<int>> g;
vector<int> a;
vector<int> day;

pair<bool, int> dfs(int v, int u) {
    if (v == u) {
        return {true, 0};
    }
    int cnt = 0, mx = 0;
    bool fl = false;
    for (auto to : g[v]) {
        auto x = dfs(to, u);
        if (x.first) {
            fl = true;
        }
        mx = max(mx, x.second);
        cnt += x.second;
    }
    if (fl) {
        return {fl, mx};
    }
    if (a[v] > a[u]) {
        return {false, cnt + 1};
    }
    return {false, 0};
}

void solve() {
    int n, q;
    cin >> n >> q;
    g.assign(n, {});
    day.assign(n, -1);
    for (int i = 0; i < n - 1; ++i) {
        int x;
        cin >> x;
        x--;
        g[x].push_back(i + 1);
    }
    a.assign(n, {});
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    set<pair<int, int>> st;
    st.insert({-a[0], 0});
    int d = 0;
    while (!st.empty()) {
        auto v = *st.begin();
        st.erase(st.begin());
        day[v.second] = d;
        for (auto to : g[v.second]) {
            if (day[to] == -1) {
                st.insert({-a[to], to});
            }
        }
        d++;
    }
    for (int i = 0; i < q; ++i) {
        int u;
        cin >> u;
        u--;
        cout << day[u] - dfs(0, u).second << " ";
    }
    cout << "\n";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
#ifdef MULTY
    cin >> t;
#endif
    while (t--) {
        solve();
    }

    return 0;
}