#include <bits/allocator.h>
#pragma GCC optimize("O3,Ofast,no-stack-protector,unroll-loops,inline")
#pragma GCC target("avx2,popcnt,lzcnt,bmi2")
#include <bits/stdc++.h>
using ll = long long;
using namespace std;
vector <vector <int>> g;
vector <int> s, vec;
int n;

void get_ans(int u, vector <int> &ans) {
    int last = s[u];
    s[u] = 0;
    priority_queue <pair <int, int>, vector <pair <int, int>>> q;
    q.emplace(s[0], 0);
    vector <int> used(n, 0);
    int col = 0;
    while (!q.empty()) {
        int v = q.top().second;
        used[v] = 1;
        q.pop();
        ans[v] = min(ans[v], col);
        for (auto &to : g[v]) {
            if (used[to]) continue;
            q.emplace(s[to], to);
        }
        col++;
    }
    s[u] = last;
}
vector <int> p;

void dfs(int v, int prev) {
    for (auto &to : g[v]) {
        if (to == prev) continue;
        p[to] = p[v];
        dfs(to, v);
    }
}

vector <int> get_good_ans() {
    p.assign(n, 0);
    vector <int> ans(n, 0);
    for (auto &to : g[0]) {
        p[to] = to;
        dfs(to, 0);
    }
    priority_queue <pair <int, int>, vector <pair <int, int>>> q;
    vector <int> used(n, 0);
    used[0] = 1;
    for (auto &to : g[0]) q.emplace(s[to], to);
    int col = 1;
    set <pair <int, int>> cur_val;
    vector <int> cur_col(n, 0);
    for (int i = 0; i < n; i++) {
        cur_val.insert({0, i});
    }
    while (!q.empty()) {
        int v = q.top().second;
        used[v] = 1;
        q.pop();
        int u = p[v];
        cur_val.erase(cur_val.find({cur_col[u], u}));
        auto it = cur_val.rbegin();
        ans[v] = col - (*it).first;
        cur_col[u]++;
        cur_val.insert({cur_col[u], u});
        for (auto &to : g[v]) {
            if (used[to]) continue;
            q.emplace(s[to], to);
        }
        col++;
    }
    return ans;
}

void solve() {
    int q; cin >> n >> q;
    g.assign(n, {});
    s.assign(n, 0);
    vec.assign(q, 0);
    int fl = 1;
    for (int i = 1; i < n; i++) {
        int x; cin >> x;
        if (!(x == 1 || x == i)) fl = 0;
        x--;
        g[i].emplace_back(x);
        g[x].emplace_back(i);
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < q; i++) {
        cin >> vec[i];
        vec[i]--;
    }
    vector <int> ans(n, n + 2);
    if (fl) {
        for (int i = 0; i < n; i++) {
            get_ans(i, ans);
        }
    } else {
        ans = get_good_ans();
    }
    for (auto &u : vec) {
        cout << ans[u] << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    for (int i = 0; i < test; i++) {
        solve();
    }
}
