#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define endl '\n'
typedef long long ll;
using namespace std;
using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less_equal<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

const ll INF = 1e18;

const int N = 3e5 + 5;
vector<int> g[N];
int pos[N], ans[N], p[N], s[N];

void take(int b = -1) {
    set<pair<int, int>> t;
    for (auto x : g[0]) {
        if (x == b) t.insert({N, x});
        else t.insert({-s[x], x});
    }

    int w = 0;
    while (!t.empty()) {
        w++;

        pair<int, int> v = *t.begin();
        t.erase(t.begin());

        pos[v.ss] = w;
        ans[v.ss] = w;

        for (auto x : g[v.ss]) {
            if (x == b) t.insert({N, x});
            else t.insert({-s[x], x});
        }
    }
}

//ordered_set e[N];
vector<int> e[N];

struct ST {
    int sz = 1;
    vector<ll> tree, mod;

    ST (int n) {
        while (sz < n) sz *= 2;

        tree.resize(sz * 2);
        mod.resize(sz * 2);
    }

    void push(int v, int tl, int tr) {
        if (!mod[v]) return;

        tree[v] += mod[v];

        if(v < sz) {
            mod[v * 2] += mod[v];
            mod[v * 2 + 1] += mod[v];
        }
        mod[v] = 0;
    }

    void update(int v, int tl, int tr, int l, int r, ll x) {
        if (tl >= l && tr <= r) {
            mod[v] += x;
            push(v, tl, tr);
            return;
        }

        push(v, tl, tr);
        if (tl > r || tr < l) return;

        int m = (tl + tr) / 2;
        update(v * 2, tl, m, l, r, x);
        update(v * 2 + 1, m + 1, tr, l, r, x);
        tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
    }

    ll get(int v, int tl, int tr, int l, int r) {
        push(v, tl, tr);

        if (tl >= l && tr <= l) return tree[v];

        if (tl > r || tr < l) return 0;

        int m = (tl + tr) / 2;
        return max(get(v * 2, tl, m, l, r), get(v * 2 + 1, m + 1, tr, l, r));
    }
};

ST st(N + 5);

void dfs(int v) {
    e[v].push_back(pos[v]);

    for (auto to : g[v]) {
        dfs(to);

        if (e[to].size() > e[v].size()) swap(e[v], e[to]);

        for (auto x : e[to]) {
            e[v].push_back(x);
        }
    }

    sort(all(e[v]));

    int m = e[v].size();
    int f = N;
    for (int i = m - 1; i >= 0; i--) {
        int x = e[v][i];

        st.update(1, 0, st.sz - 1, x + 1, f, i + 1);
        f = x;
    }
}

void solve() {
    int n, q;
    cin >> n >> q;


    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }

    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    take();

    dfs(0);

    for (int i = 0; i < n; i++) {
        ans[i] = pos[i] - st.get(1, 0, st.sz - 1, pos[i], pos[i]);
    }

    while (q--) {
        int v;
        cin >> v;
        v--;

        cout << ans[v] << " ";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}
