#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3, unroll-loops"
using namespace std;

using ll = long long;
using ld = long double;
using str = string;
#define all(a) a.begin(), a.end()
#define len(a) int(a.size())
#define pb push_back
#define pbb pop_back
#define vc vector
#define rev reverse
#define F first
#define S second
vector<vector<int>> g;
vector<int> p, ans, id, order;
vector<vector<int>> pr;
vector<bool> us;

vector<int> t;

void upd(int v, int l, int r, int i, int val) {
    if (l + 1 == r) {
        t[v] = val;
        return;
    }
    int m = (l + r) / 2;
    if (i < m) {
        upd(v * 2, l, m, i, val);
    } else {
        upd(v * 2 + 1, m, r, i, val);
    }
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (qr <= l || r <= ql) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t[v];
    }
    int m = (l + r) / 2;
    int v1 = get(v * 2, l, m, ql, qr);
    int v2 = get(v * 2 + 1, m, r, ql, qr);
    return max(v1, v2);
}

int n;

void process() {
    us[0] = true;
    map<int, int> mp;
    vector<int> cnt(n + 1);
    t.resize(4 * (n + 1));
    order[0] = 1;
    cnt[1] = 1;
    for (int u: g[0]) {
        mp[p[u]] = u;
    }
    while (!mp.empty()) {
        auto [level, v] = *mp.rbegin();
        mp.erase(level);
        us[v] = true;
        for (int par: pr[v]) {
            if (par != v) {
                cnt[order[par]]--;
                if (cnt[order[par]] == 0) {
                    upd(1, 0, n + 1, order[par], 0);
                }
            }
        }
        if (!cnt.empty()) {
            ans[v] = t[1];
        }
        for (int par: pr[v]) {
            order[par]++;
            cnt[order[par]]++;
            upd(1, 0, n + 1, order[par], order[par]);
        }
        id.pb(v);
        for (int u: g[v]) {
            if (!us[u]) {
                mp[p[u]] = u;
            }
        }
    }
}

void dfs(int v, int parent) {
    if (parent != -1) {
        for (int var: pr[parent]) pr[v].pb(var);
    }
    pr[v].pb(v);
    for (int u: g[v]) {
        if (u != parent) {
            dfs(u, v);
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> n >> q;
    g.resize(n), p.resize(n), us.assign(n, false), pr.resize(n);
    ans.resize(n), order.resize(n);
    for (int i = 1; i < n; i++) {
        int par;
        cin >> par;
        g[par - 1].pb(i);
        g[i].pb(par - 1);
    }
    for (int i = 0; i < n; i++) cin >> p[i];
    dfs(0, -1);
    process();
    vector<int> timing(n);
    for (int i = 0; i < len(id); i++) {
        timing[id[i]] = i + 1;
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << timing[v] - ans[v] << "\n";
    }
    return 0;
}
