#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// #define int long long
// #define ll __int128
using namespace std;
// using namespace __gnu_pbds;
// #define unordered_map gp_hash_table
// #define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

const int INF = (int)1e9 + 7;

int n;
vector<int> g[(int)3e5 + 7] = {};
int s[(int)3e5 + 7] = {};
int min_t[(int)3e5 + 7] = {};

mt19937 rnd(1792);

void model(int v) {
    vector<int> p;
    int old_s = s[v];
    s[v] = 0;
    p.push_back(0);
    priority_queue<pair<int, int>> st;
    for (int u : g[0]) {
        st.push(pair<int, int>(s[u], u));
    }
    while (!st.empty()) {
        int v = st.top().second;
        st.pop();
        for (int u : g[v]) {
            st.push(pair<int, int>(s[u], u));
        }
        p.push_back(v);
    }
    for (int i = 0; i < n; i++) {
        min_t[p[i]] = min(min_t[p[i]], i);
    }
    s[v] = old_s;
}

vector<int> h;

void dfs(int v) {
    for (int u : g[v]) {
        dfs(u);
        h[v] += h[u];
    }
    h[v] += s[v];
}

void solve() {
    int q;
    cin >> n >> q;
    h.resize(n);
    for (int i = 0; i < n; i++) {
        min_t[i] = INF;
    }
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    dfs(0);
    vector<int> z = g[0];
    sort(z.begin(), z.end(), [&](int v, int u) -> bool {
        return h[v] * s[v] > h[u] * s[u];
    });
    model(0);
    for (int i = 0; i < min((int)z.size(), 150); i++) {
        model(z[i]);
    }
    for (int i = 0; i < min((int)z.size(), 150); i++) {
        model(z[(int)z.size() - i - 1]);
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << min_t[v] << " ";
    }
    cout << "\n";
}

signed main() {
    // cout << fixed << setprecision(20);
    #ifdef LOCAL
    freopen("C:\\work\\input.txt", "r", stdin);
    #else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #endif
    solve();
}