#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, q;
	cin >> n >> q;
	vector<ll> p(n);
	vector<vector<ll>> sons(n);
	p[0] = -1;
	for (ll i = 1; i < n; i++) {
		cin >> p[i];
		p[i]--;
		sons[p[i]].push_back(i);
	}
	vector<ll> s(n);
	for (ll i = 0; i < n; i++) {
		cin >> s[i];
	}
	ll nc = 0;
	vector<multiset<ll>> csons(n);
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j <= sons[i].size(); j++) {
			csons[i].insert(0);
		}
	}
	vector<ll> cpd(n);
	vector<ll> ans(n);
	set<pair<ll, ll>> all;
	all.emplace(s[0], 0);
	while (!all.empty()) {
		auto[x, v] = *all.rbegin();
		all.erase(make_pair(x, v));
		ans[v] = nc;
		for (auto j : sons[v]) {
			all.emplace(s[j], j);
		}
		nc++;
		ll now = v;
		ll mc = 0;
		while (v != -1) {
			if (p[v] != -1) {
				csons[p[v]].erase(csons[p[v]].find(cpd[v]));
			}
			cpd[v]++;
			if (p[v] != -1) {
				assign_max(mc, *csons[p[v]].rbegin());
				csons[p[v]].insert(cpd[v]);
			}
			v = p[v];
		}
		ans[now] -= mc;
	}
	for (ll i = 0; i < q; i++) {
		ll v;
		cin >> v;
		v--;
		cout << ans[v] << ' ';
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
