#include <bits/stdc++.h>

#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ld = long double;

const ll infll = (ll) 1e18;
const int inf = (int) 1e9;
const ll MOD = 1e9 + 7;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

ll mod(ll a) {
    ll r = a % MOD;
    if (r < 0) {
        return r + MOD;
    }
    return r;
}

vector<multiset<pair<int, int>, greater<>>> g;
vector<int> pr;
vector<int> s;
vector<int> sz, tin, tout;
vector<int> ord;
int timer = 0;

void dfs(int v) {
    ord.push_back(v);
    if (!g[v].empty()) {
        int u = g[v].begin()->second;
        g[v].erase(g[v].begin());
        for (auto to : g[v]) {
            g[u].insert(to);
        }
        dfs(u);
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    pr.resize(n);
    tin.resize(n);
    tout.resize(n);
    sz.resize(n);
    g.resize(n);
    s.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        pr[i] = p;
    }
    for (auto &x : s) cin >> x;
    for (int i = 1; i < n; ++i) {
        g[pr[i]].insert({s[i], i});
    }
    vector<int> us(n);
    for (int _ = 0; _ < q; ++_) {
        int x;
        cin >> x;
        x--;
        int mn = inf;
        for (int j = 1; j < n; ++j) {
            if (x == j) continue;
            ord.clear();
            int y = s[j];
            s[j] = 0;
            vector<multiset<pair<int, int>, greater<>>> g2 = g;
            g[pr[j]].erase({y, j});
            g[pr[j]].insert({0, j});
            dfs(0);
            g = g2;
            for (int i = 0; i < n; ++i) {
                us[ord[i]] = i;
            }
            mn = min(mn, us[x]);
            s[j] = y;
        }
        cout << mn << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}