#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using sll = __int128;

template <typename T>
istream &operator>>(istream &in, pair<T, T> &a){
    in >> a.first >> a.second;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, pair<T, T> &a){
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream &operator>>(istream &in, vector<T> &a){
    for(auto &x : a) in >> x;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector<T> &a){
    for(auto x : a) out << x << ' ';
    return out;
}

vector<vector<int>> g;

vector<int> check(vector<int> &s, vector<int> &pr){
    int main = 1;
    int cnt = -1;
    set<pair<int, int>> st;
    st.insert({-s[1], 1});
    vector<int> qu;
    while(!st.empty()){
        main = (*st.begin()).second;
        st.erase(st.begin());
        qu.push_back(main);
        for(auto to : g[main]){
            st.insert({-s[to], to});
        }
        cnt++;
    }
    return qu;
}

vector<int> tin, tout;
int cur = 1;

void dfs(int vi){
    tin[vi] = cur++;
    for(auto to : g[vi]){
        dfs(to);
    }
    tout[vi] = cur++;
}

bool is_anc(int a, int b){
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

void solve(){
    int n, q;
    cin >> n >> q;
    g.resize(n + 1);
    vector<int> pr(n + 1);
    for(int i = 2; i <= n; i++){
        int p; cin >> p;
        if(p == 1) pr[i] = i;
        else pr[i] = pr[p];
        g[p].push_back(i);
    }
    vector<int> s(n + 1);
    for(int i = 1; i <= n; i++) cin >> s[i];
    auto qu = check(s, pr);
    vector<int> pos(n + 1);
    for(int i = 1; i < qu.size(); i++){
        pos[qu[i]] = i;
    }
//    cout << qu << '\n';
    tin.resize(n + 1);
    tout.resize(n + 1);
    dfs(1);
    vector<int> pref(qu.size() + 2);
    for(int i = 2; i <= n; i++){
        int cnt = 0;
        for(int j = 1; j < qu.size(); j++){
            if(!is_anc(i, qu[j])) pref[j] = max(pref[j], cnt);
            cnt += is_anc(i, qu[j]);
        }
    }
//    cout << pref << '\n';
    while(q--){
        int x; cin >> x;
        int res = pos[x] - pref[pos[x]];
        cout << res << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test = 1;
//    cin >> test;
    while(test--){
        solve();
    }
}

