#include <bits/stdc++.h>
#define ll long long
#define len(x) (int)x.size()
#define ld long double
#define all(x) x.begin(), x.end()
const ll mod1 = 1e9 + 7;

using namespace std;

void print(vector<int> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<ll> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<char> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<string> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<pair<int, int>> &a){
    for(auto x : a){
        cout << x.first << ' ' << x.second << '\n';
    }
}

void print(vector<vector<int>> &a){
    for(auto x : a){
        print(x);
    }
}

void print(vector<vector<ll>> &a){
    for(auto x : a){
        print(x);
    }
}

//#define int ll
//#define mtask

vector<vector<int>> g;
vector<int> tin;
vector<int> tout;
vector<int> s;
vector<int> a;
vector<int> sum;

int tim = 0;

void gett(int cur){
    tin[cur] = tim++;
    for(auto x : g[cur]){
        gett(x);
    }
    tout[cur] = tim++;
}

void calc(int cur){
    sum[cur] = a[cur];
    for(auto x : g[cur]){
        calc(x);
        sum[cur] += sum[x];
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    g.resize(n);
    tin.resize(n);
    tout.resize( n);
    sum.resize(n);
    a.resize(n);
    s.resize(n);
    for(int i = 1; i < n; ++i){
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }
    for(int i = 0; i < n; ++i){
        cin >> s[i];
    }
    gett(0);
    set<pair<int, int>> que;
    que.insert({s[0], 0});
    vector<int> ans(n);
    for(int i = 0; i < n; ++i){
        auto cur = que.rbegin()->second;
        que.erase(*que.rbegin());
        calc(0);
        int tmpans = sum[0] - sum[cur];
        for(int j = 0; j < n; ++j){
            if(!(tin[j] <= tin[cur] && tin[cur] <= tout[j]) && !(tin[cur] <= tin[j] && tin[j] <= tout[cur])){
                tmpans = min(tmpans, sum[0] - sum[cur] - sum[j]);
            }
        }
        ans[cur] = tmpans;
        ++a[cur];
        for(auto x : g[cur]){
            que.insert({s[x], x});
        }
    }
    while(q--){
        int x;
        cin >> x;
        --x;
        cout << ans[x] << ' ';
    }
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
    int tt;
    cin >> tt;
    while(tt--)
#endif
        solve();
}