#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx")

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;
template<class T> using oset = tree<T, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
int inf = 1e9;
int n;
vector<vector<int>> kids;
vector<int> p, s;
vector<int> ans;
void slow(){
    int res = inf;
    for(int x = 0; x < n; ++x){
        int vv = s[x];
        s[x] = 0;
        set<pair<int, int>> gg;
        int time = 0;
        gg.insert({s[0], 0});
        while(!gg.empty()){
            int v = gg.rbegin()->second;
            ans[v] = min(ans[v], time);
            time++;
            for(auto x : kids[v]){
                gg.insert({s[x], x});
            }
            gg.erase({s[v], v});
        }
        s[x] = vv;
    }
}

void solve() {
    int q ;
    cin >> n >> q;
    p.assign(n, 0);
    p[0] = -1;
    kids.assign(n, {});
    for(int i = 1; i < n; ++i){
        cin >> p[i];
        p[i]--;
        kids[p[i]].push_back(i);
    }
    s.assign(n, 0);
    for(int i = 0; i < n; ++i){
        cin >> s[i];
    }
    ans.assign(n, inf);
    slow();
    while(q--){
        int d;
        cin >>d;
        d--;
        cout << ans[d] << " ";
    }
}

signed main(){
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
    int tt = 1;
    //cin >> tt;
    while(tt--){
        solve();
        cout << '\n';
    }
    return 0;
}
