#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

//#include <ext/pb_ds/assoc_containe.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template <class T> order_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//find_by_orede, order_of_key

#define int long long
#define all(a) (a).begin(), (a).end()

#pragma GCC optimize ("O3")
#pragma GCC target ("avx2")


const int inf = 1e18;



vector<vector<pair<int, int>>> g;
vector<int> s, res;

set<int> mx;
int all = 0;

int get() {
	if (mx.empty()) return 0;
	return -(*mx.begin());
}

int dfs(int v) {
	res[v] = all - get();
	all++;

	sort(all(g[v]));
	int sz = 1;

	for (auto [S, u] : g[v]) {
		int cur = dfs(u);
		sz += cur;
	}

	mx.insert(sz);
	return sz;
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif


	int n, q; cin >> n >> q;
	g.resize(n);
	s.resize(n);
	res.resize(n, inf);

	vector<int> p(n);

	for (int i = 1; i < n; ++i) {
		cin >> p[i]; --p[i];
	}

	for (int i = 0; i < n; ++i) {
		cin >> s[i];
		if (i)
			g[p[i]].push_back({ -s[i], i });
	}

	dfs(0);

	while (q--) {
		int v; cin >> v;
		cout << res[v - 1] << ' ';
	}
}