#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ld = long double;

void dfs(int v, vector <vector <int>> & sons, vector <int> & h) {
    for (int u : sons[v]) {
        h[u] = h[v] + 1;
        dfs(u, sons, h);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector <vector <int>> sons(n + 1);
    for (int i=1; i < n; ++i) {
        int p;
        cin >> p;
        sons[p].push_back(i + 1);
    }
    vector <int> s(n + 1);
    for (int i=1; i <= n; ++i) {
        cin >> s[i];
    }
    vector <int> h(n + 1);
    dfs(1, sons, h);
    while (q--) {
        int v;
        cin >> v;
        cout << h[v] << "\n";
    }
    return 0;
}
