#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ld = long double;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector <vector <int>> sons(n + 1);
    for (int i=1; i < n; ++i) {
        int p;
        cin >> p;
        sons[p].push_back(i + 1);
    }
    vector <int> s(n + 1);
    for (int i=1; i <= n; ++i) {
        cin >> s[i];
    }
    vector <int> ans(n + 1, n);
    for (int i=1; i <= n; ++i) {
        set <vector <int>> d;
        d.insert({1 == i, -s[1], 1});
        int day = 0;
        while (!d.empty()) {
            vector <int> v = *d.begin();
            d.erase(d.begin());
            ans[v[2]] = min(ans[v[2]], day);
            for (int u : sons[v[2]]) {
                d.insert({u == i, -s[u], u});
            }
            day++;
        }
    }
    while (q--) {
        int v;
        cin >> v;
        cout << ans[v] << "\n";
    }
    return 0;
}
