#include <bits/stdc++.h>
using namespace std;
#define int long long

const int maxn = 1e6;
int s[maxn], p[maxn], ans[maxn], sz[maxn];
vector<int> g[maxn], order;

void emulate(set<pair<int, int>> st) {
    while (!st.empty()) {
        auto [x, v] = *st.begin();
        for (auto u : g[v]) {
            st.insert({-s[u], u});
        }
        order.push_back(v);
        st.erase({x, v});
    }
}

pair<int, int> ans1[maxn][2];

void update(int v, int x, int y) {
    if (ans1[v][0].second == x) {
        ans1[v][0].first = y;
        return;
    }
    if (ans1[v][1].second == x) {
        ans1[v][1].first = y;
        return;
    }
    if (ans1[v][0].first <= y) {
        swap(ans1[v][0], ans1[v][1]);
        ans1[v][0] = {y, x};
        return;
    }
    if (ans1[v][1].first <= y) {
        ans1[v][1] = {y, x};
    }
}

int get(int v, int ban) {
    if (ans1[v][0].second == ban) {
        return ans1[v][1].first;
    }
    return ans1[v][0].first;
}

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x; x--;
        p[i] = x;
        g[x].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    fill(ans, ans + n, 1e7);
    set<pair<int, int>> st;
    st.insert({-s[0], 0});
    emulate(st);
    int pos = 0;
    for (auto el : order) {
        int idx = el;
        ans[idx] = pos;
        while (p[el] != el) {
            int par = p[el];
            sz[el]++;
            update(p[el], el, sz[el]);
            ans[idx] = min(ans[idx], pos - get(p[el], el));
            el = p[el];
        }
        pos++;
    }
    while (q--) {
        int v;
        cin >> v; v--;
        cout << ans[v] << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    while (tests--) solve();
}

