#include <bits/stdc++.h>
// #include<ext/pb_ds/assoc_container.hpp>
// #include<ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
using namespace std;

#define int long long
const int INF = 1e9;

void solve1();

// typedef tree<int,null_type,less<>,rb_tree_tag,tree_order_statistics_node_update>ordered_set;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int qwerty = 1;
    // cin >> qwerty;
    while(qwerty--){
        solve1();
    }
}

struct seg_tree{
    struct Node{
        int mx, sum;
    };

    vector<Node> d;

    seg_tree(int n){
        d.resize(4 * n);
    }

    Node merge(Node a, Node b){
        return {max(a.mx, b.mx), a.sum + b.sum};
    }

    void update(int v, int l, int r, int ind){
        if(r - l == 1){
            d[v].mx++;
            d[v].sum++;
            return;
        }
        int m = (l + r) / 2;
        if(ind < m){
            update(2 * v + 1, l, m, ind);
        } else{
            update(2 * v + 2, m, r, ind);
        }
        d[v] = merge(d[2 * v + 1], d[2 * v + 2]);
    }

    Node get(int v, int l, int r, int ql, int qr){
        if(ql >= r || l >= qr) return {-INF, 0};
        if(ql <= l && r <= qr) return d[v];
        int m = (l + r) / 2;
        return merge(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }
};

void perenum(int v, int p, vector<vector<int>>& gr, vector<int>& num, vector<pair<int, int>>& lr, int& sc){
    int mn = INF, mx = -INF;
    for(int u : gr[v]){
        num[u] = ++sc;
        mn = min(mn, num[u]);
        mx = max(mx, num[u]);
    }
    lr[v] = {mn, mx};
    for(int u : gr[v]){
        perenum(u, v, gr, num, lr, sc);
    }
}

void dfs(int v, int p, vector<vector<int>>& gr, vector<int>& minus, vector<int>& all, vector<int>& ans){
    ans[v] = ans[v] - minus[v];
    if(p != -1){
        ans[v] = min(ans[v], ans[p] + all[v] + 1);
    }
    for(int u : gr[v]){
        dfs(u, v, gr, minus, all, ans);
    }
}

void solve1(){
    int n, q;
    cin >> n >> q;
    vector<vector<int>> gr(n);
    for(int i = 1; i < n; i++){
        int p;
        cin >> p;
        p--;
        gr[p].push_back(i);
    }
    vector<int> num(n);
    int sc = 0;
    vector<pair<int, int>> lr(n);
    perenum(0, -1, gr, num, lr, sc);
    vector<vector<int>> new_gr(n);
    vector<int> pred(n);
    for(int i = 0; i < n; i++){
        for(int j : gr[i]){
            new_gr[num[i]].push_back(num[j]);
            pred[num[j]] = num[i];
        }
    }
    vector<int> s(n);
    for(int i = 0; i < n; i++){
        cin >> s[i];
    }
    set<pair<int, int>> st;
    vector<int> minus(n), all(n);
    int now = 0;
    st.insert({s[0], 0});
    seg_tree seg(n);
    vector<int> ans(n);
    int cc = 0;
    while(!st.empty()){
        auto x = *(--st.end());
        ans[x.second] = cc++;
        if(x.second != 0){
            auto lrr = lr[pred[num[x.second]]];
            auto qq = seg.get(0, 0, n, lrr.first, lrr.second + 1);
            minus[x.second] = qq.mx;
            all[x.second] = qq.sum;
            int xx = num[x.second];
            while(xx != 0){
                seg.update(0, 0, n, xx);
                xx = pred[xx];
            }
        }
        for(int u : gr[x.second]){
            st.insert({s[u], u});
        }
        st.erase(x);
    }
    dfs(0, -1, gr, minus, all, ans);
    while(q--){
        int x;
        cin >> x;
        x--;
        cout << ans[x] << ' ';
    }
}