#include <bits/stdc++.h>
using namespace std;
#ifdef _LOCAL
#define debug(x) cout << __LINE__ << ' ' << __PRETTY_FUNCTION__ << ": " << (x) << endl
#else
#define debug(...) 238;
#endif
mt19937 rng(238);
mt19937_64 rng64(238);
using ll = long long;
template <typename T, int U>
using ar = array<T, U>;
template <typename T, typename U>
bool chmin(T& x, const U&& y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
template <typename T, typename U>
bool chmax(T& x, const U&& y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

#include <ext/pb_ds/assoc_container.hpp>
template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type,
                                     less<T>,
                                     __gnu_pbds::rb_tree_tag,
                                     __gnu_pbds::tree_order_statistics_node_update>; 
constexpr int Inf = 0x3f3f3f3f;
constexpr ll inf = 1144000000000000000;


const int maxn = 300005;
vector<int> g[maxn];
int s[maxn], id[maxn], p[maxn], ans[maxn];
int down[maxn], sdown[maxn], bigch[maxn], subt[maxn];

void solve() {
    int n, q;
    cin >> n >> q;
    p[0] = -1;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }

    int t = 0;
    priority_queue<pair<int, int>> pq;
    pq.emplace(s[0], 0);
    while (!pq.empty()) {
        auto [prior, key] = pq.top();
        pq.pop();
        for (int v : g[key]) {
            pq.emplace(s[v], v);
        }

        ans[key] = t;
        int v = p[key];
        int pre = key;
        while (v != -1) {
            if (bigch[v] != pre) {
                ans[key] = min(t - down[v], ans[key]);
            } else {
                ans[key] = min(t - sdown[v], ans[key]);
            }
            pre = v;
            v = p[v];
        }

        subt[key]++;
        v = p[key];
        pre = key;
        while (v != -1) {
            subt[v]++;

            if (subt[pre] > down[v]) {
                sdown[v] = down[v];
                down[v] = subt[pre];
                bigch[v] = pre;
            } else if (subt[pre] > sdown[v]) {
                sdown[v] = subt[pre];
            }

            pre = v;
            v = p[v];
        }

        t++;
    }
    

    while (q--) {
        int v;
        cin >> v;
        cout << ans[--v] << ' ';
    }
}

int main() {
#ifdef _LOCAL
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
    freopen("test.out", "w", stderr);
#endif
    cin.tie(0)->sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while (Tc--) {
        solve();
        cout << '\n';
    }

    return 0;
}