
#ifndef _LOCAL
#pragma GCC optimize("Ofast")

#endif


#include <bits/stdc++.h>
using namespace std;
#ifdef _LOCAL
#define debug(x) cout << __LINE__ << ' ' << __PRETTY_FUNCTION__ << ": " << (x) << endl
#else
#define debug(...) 238;
#endif
mt19937 rng(238);
mt19937_64 rng64(238);
using ll = long long;
template <typename T, int U>
using ar = array<T, U>;
template <typename T, typename U>
bool chmin(T& x, const U&& y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
template <typename T, typename U>
bool chmax(T& x, const U&& y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

#include <ext/pb_ds/assoc_container.hpp>
template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type,
                                     less<T>,
                                     __gnu_pbds::rb_tree_tag,
                                     __gnu_pbds::tree_order_statistics_node_update>; 
constexpr int Inf = 0x3f3f3f3f;
constexpr ll inf = 1144000000000000000;

#pragma GCC target("avx2")
const int maxn = 300005;
vector<int> g[maxn];
vector<int> events[maxn + 5];
int s[maxn], p[maxn], ans[maxn], tin[maxn], tout[maxn], sz[maxn], head[maxn], jmp[maxn];
int timer;
void prec(int v) {
    sz[v] = 1;
    if (g[v].size()) {
        prec(g[v][0]);
        sz[v] += sz[g[v][0]];
    }
    for (int i = 1; i < (int)g[v].size(); ++i) {
        int& u = g[v][i];
        prec(u);
        sz[v] += sz[u];
        if (sz[u] > sz[g[v][0]]) {
            swap(u, g[v][0]);
        }
    }
}
void hld(int v, int p) {
    tin[v] = timer++;
    head[v] = p;
    if (g[v].size()) {
        hld(g[v][0], p);
    }
    for (int i = 1; i < (int)g[v].size(); ++i) {
        jmp[g[v][i]] = v;
        hld(g[v][i], g[v][i]);
    }
    tout[v] = timer;
}

int md[maxn << 2], tr[maxn << 2];
void push(int v, int l, int r) {
    if (!md[v]) {
        return;
    }
    if (l + 1 == r) {
        return;
    }
    tr[2 * v + 1] += md[v];
    md[2 * v + 1] += md[v];
    tr[2 * v + 2] += md[v];
    md[2 * v + 2] += md[v];
    md[v] = 0;
}
void update(int v, int l, int r, int ql, int qr) {
    push(v, l, r);
    if (ql <= l && r <= qr) {
        md[v]++;
        tr[v]++;
        return;
    }
    if (ql >= r || qr <= l) {
        return;
    }
    int m = (l + r) >> 1;
    update(2 * v + 1, l, m, ql, qr);
    update(2 * v + 2, m, r, ql, qr);
    tr[v] = max(tr[v * 2 + 1], tr[v * 2 + 2]);
}
int get(int v, int l, int r, int ql, int qr) {
    push(v, l, r);
    if (ql <= l && r <= qr) {
        return tr[v];
    }
    if (ql >= r || qr <= l) {
        return -Inf;
    }
    int m = (l + r) >> 1;
    int x1 = get(2 * v + 1, l, m, ql, qr);
    int x2 = get(2 * v + 2, m, r, ql, qr);
    return max(x1, x2);
}

void solve() {
    int n, q;
    cin >> n >> q;
    p[0] = -1;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    prec(0);
    jmp[0] = -1;
    hld(0, 0);

    int t = 0;
    priority_queue<pair<int, int>> pq;
    pq.emplace(s[0], 0);
    while (!pq.empty()) {
        auto [prior, key] = pq.top();
        pq.pop();
        for (int v : g[key]) {
            pq.emplace(s[v], v);
        }
 
        vector<pair<int, int>> vv;
        vv.reserve(30);
        int v = key;
        while (v != -1) {
            int L = tin[head[v]];
            int R = tin[v];
            vv.emplace_back(L, R + 1);
            update(0, 0, maxn, L, R + 1);
            v = jmp[head[v]];
        }
        int res = 0;
        int R = 0;
        for (int i = (int)vv.size() - 1; ~i; --i) {
            if (vv[i].first != R) {
                res = max(res, get(0, 0, maxn, R, vv[i].first));
            }
            R = vv[i].second;
        }
        if (R != n) {
            res = max(res, get(0, 0, maxn, R, n));
        }

        ans[key] = t - res;

        t++;
    }

    while (q--) {
        int v;
        cin >> v;
        cout << ans[--v] << ' ';
    }
}

int main() {
#ifdef _LOCAL
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
    freopen("test.out", "w", stderr);
#endif
    cin.tie(0)->sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while (Tc--) {
        solve();
        cout << '\n';
    }

    return 0;
}