#include <iostream>

#include <vector>

using namespace std;

void dfs(int v, int pred, vector <vector <int>>& a, vector <int>& minn, vector <int>& s) {
    if (pred != -1 && pred != 0) {
        minn[v] = min(minn[pred], s[v]);
    }
    if (pred == 0) {
        minn[v] = s[v];
    }
    for (int u : a[v]) {
        if (u != pred) {
            dfs(u, v, a, minn, s);
        }
    }
    return;
}

void dfs2(int v, int pred, vector <vector <int>>& a, vector <int>& in, vector <int>& out, vector <int>& que, vector <int>& cost, int& tt) {
    in[v] = tt;
    que[tt] = cost[v];
    tt++;
    for (int u : a[v]) {
        if (u != pred) {
            dfs2(u, v, a, in, out, que, cost, tt);
        }
    }
    out[v] = tt;
    que[tt] = cost[v];
    tt++;
    return;
}

int num(vector <int>& que, int ll, int rr, int x) {
    int ans = 0;
    for (int i = ll; i <= rr; i++) {
        if (que[i] > x) {
            ans++;
        }
    }
    return ans;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, q, xx;
    cin >> n >> q;
    vector <vector <int>> a(n);
    vector <int> predd(n);
    predd[0] = -1;
    for (int i = 1; i < n; i++) {
        cin >> xx;
        predd[i] = xx - 1;
        a[xx - 1].push_back(i);
        a[i].push_back(xx - 1);
    }
    vector <int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    vector <int> zaprosi(q);
    for (int i = 0; i < q; i++) {
        cin >> zaprosi[i];
        zaprosi[i]--;
    }
    vector <int> minn(n, 0);
    dfs(0, -1, a, minn, s);
    vector <int> in(n);
    vector <int> out(n);
    vector <int> que(2 * n);
    int tt = 0;
    dfs2(0, -1, a, in, out, que, minn, tt);
    for (int v : zaprosi) {
        if (v == 0) {
            cout << 0 << '\n';
        } else {
            int numm = num(que, in[0], out[0], s[v]) / 2 + 1;
            int maxx = 0;
            for (int i = 1; i < n; i++) {
                if (!(in[i] <= in[v] && out[i] >= out[v])) {
                    maxx = max(maxx, num(que, in[i], out[i], s[v]) / 2);
                }
            }
            cout << numm - maxx << ' ';
        }
    }
    return 0;
}