#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

vector<vector<int>> gr;
vector<int> s;
vector<int> szs;

vector<int> ans;
int ht = 0;
int mx = 0;

bool comp(int a, int b) {
    return s[a] > s[b];
}

void dfs(int v) {
    szs[v] = 1;
    ans[v] = ht - mx;
    ht++;
    sort(gr[v].begin(), gr[v].end(), comp);
    for (auto u : gr[v]) {
        dfs(u);
        szs[v] += szs[u];
        mx = max(mx, szs[u]);
    }
}

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    gr.resize(n);
    ans.reserve(n);
    vector<int> pr(n, -1);
    for (int i = 0; i < n - 1; i++) {
        int p;
        cin >> p;
        p--;
        gr[p].push_back(i + 1);
    }
    s.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    szs.resize(n);
    dfs(0);
    for (int i = 0; i < q; i++) {
        int x;
        cin >> x;
        cout << ans[x - 1] << " ";
    }
    return 0;
}