#ifdef _MSC_VER
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream& operator>>(istream& is, vector<T>& a) {
	for (auto& i : a) {
		is >> i;
	}
	return is;
}

mt19937 rng(228);

vector<int> s;
vector<vector<int>> g;

int32_t main() {
#ifdef LOCAL
	assert(freopen("C:\\Users\\User\\input.txt", "r", stdin));
#else
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int n, q;
	cin >> n >> q;
	g.resize(n);
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		--p;
		g[p].push_back(i);
	}
	s.resize(n);
	cin >> s;
	vector<int> ans(n, inf);
	for (int i = 0; i < n; ++i) {
		int was = s[i];
		s[i] = 0;
		vector<int> ch;
		for (auto u : g[0]) {
			ch.push_back(u);
		}
		ans[0] = min(ans[0], 0);
		for (int j = 1; j < n; ++j) {
			int mx = -inf;
			int id = -1;
			for (auto u : ch) {
				if (mx < s[u]) {
					mx = s[u];
					id = u;
				}
			}
			vector<int> nch;
			for (auto u : ch) {
				if (u != id) {
					nch.push_back(u);
				}
			}
			for (auto u : g[id]) {
				nch.push_back(u);
			}
			ans[id] = min(ans[id], j);
			ch = nch;
		}
		s[i] = was;
	}
	while (q--) {
		int v;
		cin >> v;
		--v;
		cout << ans[v] << " ";
	}
	cout << "\n";
	return 0;
}