//#pragma GCC optimize("Ofast")
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bits/stdc++.h>
#define int long long
#define ld long double
#define speed ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
using namespace std;
//#pragma GCC target("avx2")
const int INF = 1e12, maxn = 3e5 + 100;
vector<int> g[maxn], ab, tmr, tin, tout, zn, pr;
int timer = 0, timer2 = 0;
vector<vector<pair<int, int>>> mxv;
void dfs(int v) {
    tin[v] = timer++;
    for (auto u : g[v]) {
        dfs(u);
    }
    tout[v] = timer++;
}

set<pair<int, int>> rb;

void supfs(int v) {
    tmr[v] = timer2++;
    for (auto u : g[v]) {
        rb.insert({ab[u], u});
    }

    if (!rb.empty()) {
        auto it = rb.end();
        it--;
        int nxt = it->second;
        rb.erase(it);
        supfs(nxt);
    }
}

bool check(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}
int get(int v) {

    int w = pr[v], res = 0;
    while (w != -1) {

        if (mxv[w][0].second != -1 && !check(mxv[w][0].second, v)) {
            res = max(res, mxv[w][0].first);
        }
        else if (mxv[w][1].second != -1){
            res = max(res, mxv[w][1].first);
        }

        w = pr[w];
    }
    return res;
}

void upd(int v) {
    int w = v, res = 0, k = -1;
    while (w != -1) {
        if (k != -1) {
            mxv[w].push_back({res, k});
            sort(mxv[w].begin(), mxv[w].end());
            reverse(mxv[w].begin(), mxv[w].end());
            if (mxv[w][0].second == mxv[w][1].second) {
                mxv[w] = {mxv[w][0], mxv[w][2]};
            }
            else {
                mxv[w].pop_back();
            }
        }

        zn[w] += 1;
        res = zn[w];
        k = w;
        w = pr[w];
    }
}

int qwe = 0;

int answer(int v, int x, int w) {

    int res = 0;
    if (tmr[v] < x) {
        res++;
    }
    for (auto u : g[v]) {
        res += answer(u, x, w);
    }
    if (!check(v, w)) {
        qwe = max(qwe, res);
    }
    return res;
}

signed main() {
    int n, q;
    cin >> n >> q;
    pr.resize(n + 1, -1);
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
        pr[i] = p;
    }
    ab.resize(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> ab[i];
    tin.resize(n + 1, 0);
    tout.resize(n + 1, 0);
    tmr.resize(n + 1, 0);
    dfs(1);
    vector<int> answer(n + 1, INF);
    for (auto u : g[1]) {
        int sv = ab[u] = 0;
        rb.clear();
        timer2 = 0;
        supfs(1);
        
        for (int i = 1; i <= n; i++) {
            answer[i] = min(answer[i], tmr[i]);
        }
        ab[u] = sv;
    }
    
    for (int i = 0; i < q; i++) {
        int v;
        cin >> v;
        cout << answer[v] << ' ';
    }
}