
#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define ve vector
#define pb push_back
#define all(a) a.begin(), a.end()
#define first f
#define second s
using ld = long double;
#define int ll
mt19937 rnd(321932);

template<class A>
istream &operator>>(istream &in, ve<A> &a) {
    for (auto &x: a)
        in >> x;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> a) {
    for (auto &x: a)
        out << x << ' ';
    return out << '\n';
}

void sol() {
    int n, m;
    cin >> n >> m;
    ve<int> x(m);
    cin >> x;
    reverse(all(x));
    // dp[j] --- max res if we used j bad x
    ve<ve<int>> dp(m + 1, ve<int>(m + 1, -1e18));
    dp[0][0] = 0;
    for (int cnt = 1; cnt <= m; ++cnt) {
        cout << (cnt+1)/2 << ' ' << min(cnt, (cnt+n)/2) << '\n';
        for (int i = (cnt+1)/2; cnt + n >= 2 * i && i <= cnt; ++i) {
            dp[i][cnt] = max(dp[i][cnt-1], dp[i-1][cnt-1] + x[cnt-1]);
        }
    }
    int sum = 0;
    for (auto &c : x)
        sum += c;
    int mx = -1e18;
    for (int i = 0; i <= m; ++i)
        mx = max(mx, dp[i][m]);
    cout << 2 * mx - sum << '\n';
}
ve<ve<int>> g;
ve<int> h;
multiset<int> mn;
ve<int> c, xc;
ve<int> tin, tout;
int timer = 0;
void dfs(int v) {
    mn.insert(c[v]);
    xc[v] = *mn.begin();
    tin[v] = timer++;
    for (auto &u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u);
    }
    tout[v] = timer;
    mn.erase(mn.find(c[v]));
}

struct mst {
    ve<ve<tuple<int, int, int>>> t;
    void build(int v, int l, int r, ve<tuple<int, int, int>> &a) {
        if (l + 1 == r) {
            t[v] = {a[l]};
            return;
        }
        int m = (l + r)/2;
        build(2*v+1, l, m, a);
        build(2*v+2, m, r, a);
        merge(all(t[2*v+1]), all(t[2*v+2]), back_inserter(t[v]));
    }

    int get(int v, int l, int r, int ql, int qr, tuple<int, int, int> q) {
        if (ql >= r || l >= qr)
            return 0;
        if (ql <= l && r <= qr)
            return std::lower_bound(t[v].begin(), t[v].end(), q) - t[v].begin();
        int m = (l + r)/2;
        return get(2*v+1, l, m, ql, qr, q) + get(2*v+2, m, r, ql, qr, q);
    }
    mst (ve<tuple<int, int, int>> &a) {
        t.resize(4*a.size());
        build(0, 0, a.size(), a);
    }
};

bool pd(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int32_t main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q;
    cin >> n >> q;
    ve<int> p(n, -1);
    g.resize(n);
    h.assign(n, 0);
    tin = tout = xc = h;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].pb(i);
    }
    dfs(0);
    ve<tuple<int, int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = {xc[i], c[i], h[i]};
    }
    mst t(a);
    c.resize(n);
    cin >> c;
    while (q--) {
        int v;
        cin >> v;
        v--;
        if (v == 0) {
            cout << "0\n";
        }
        int ans = 1e9;
        for (int i = 0; i < n; ++i) {
            if (!pd(i, v)) {
                ans = min(ans, t.get(0, 0, n, 0, n, a[v]) - t.get(0, 0, n, tin[i], tout[i], a[v]));
            }
        }
        cout << ans << '\n';
    }
}
