#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

ll inf = (ll)1e18;

template<class T>
ll len(T& a) {
    return (ll)a.size();
}

ll n, q;
vector<vector<ll>> g;
vector<ll> s;
vector<ll> queries;
vector<ll> h;

ll find_ans(ll x) {
    vector<ll> topsort;
    priority_queue<pair<ll, ll>> que;
    que.push({s[0], 0});
    while (!que.empty()) {
        pair<ll, ll> temp = que.top(); que.pop();
        topsort.push_back(temp.second);
        for (ll to : g[temp.second]) {
            que.push({s[to], to});
        }
    }

    for (ll i = 0; i < len(topsort); ++i) {
        if (x == topsort[i]) {
            return i;
        }
    }
    return -1;
}

void solve() {
    cin >> n >> q;
    h.resize(n, 0);
    ll x;
    g.resize(n);
    s.resize(n);
    h.resize(n);
    queries.resize(q);
    for (ll i = 1; i < n; ++i) {
        cin >> x;
        x--;
        g[x].push_back(i);
    }
    for (ll i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (ll i = 0; i < q; ++i) {
        cin >> queries[i];
        queries[i]--;
    }

    vector<ll> topsort;
    priority_queue<pair<ll, ll>> que;
    que.push({s[0], 0});
    while (!que.empty()) {
        pair<ll, ll> temp = que.top(); que.pop();
        topsort.push_back(temp.second);
        for (ll to : g[temp.second]) {
            que.push({s[to], to});
        }
    }

    for (ll i = 0; i < q; ++i) {
        ll mini = inf;
        for (ll j = 0; j < len(topsort); ++j) {
            ll temp = s[topsort[j]];
            s[topsort[j]] = 0;
            mini = min(mini, find_ans(queries[i]));
            s[topsort[j]] = temp;
            if (topsort[j] == queries[i]) { break; }
        }
        cout << mini << "\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}