#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <bitset>
#include <string>

//#pragma GCC optimize("unroll-loops,inline,O2,O3,Ofast")
//#pragma GCC target("avx,avx2,bmi,bmi2,sse,sse2,sse3,sse4,ssse3,abm,mmx,fma,popcnt,lzcnt")

using namespace std;

typedef long long ll;

ll INF = 1e18 + 9;

vector<ll> ans, res;

ll func(ll v, ll p, vector<vector<pair<ll, ll>>> &g) {

    ll cnt = 1, mx = 0;

    for (auto u : g[v]) {
        ans[u.second] = min(ans[v] + cnt, res[v] + cnt - mx);
        res[u.second] = res[v] + cnt + 1;
        ll sm = func(u.second, v, g);
        mx = max(mx, sm);
        cnt += sm;
    }

    return cnt;
}

void solve() {

    ll n, q;
    cin >> n >> q;

    ans = vector<ll> (n, 0);
    res = vector<ll> (n, 0);
    vector<vector<pair<ll, ll>>> g(n);
    vector<ll> q1(n);
    for (int i = 1; i < n; i++) {
        cin >> q1[i];
        q1[i]--;
    }
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 1; i < n; i++) {
        g[q1[i]].emplace_back(a[i], i);
    }

    for (auto &i : g) {
        if (!i.empty()) {
            sort(i.begin(), i.end());
            reverse(i.begin(), i.end());
        }
    }

    func(0, -1, g);

    while (q--) {
        ll t;
        cin >> t;
        t--;

        cout << ans[t] << "\n";
    }
}

signed main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}
