#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <math.h>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) x.begin(),x.end()
#pragma GCC optimize("Ofast")
const ll INF = 1e9 + 7;
template<typename T>
void input(vector<T>& arr, size_t size) {
	arr.resize(size);
	for (T& i : arr) {
		cin >> i;
	}
}
template<typename T>
void print(vector<T>& arr) {
	for (T& i : arr) {
		cout << i << ' ';
	}
	cout << '\n';
}

vector<int> ans,s;
vector<vector<int>> g;

void make() {
	set<pair<int, int>> x;
	x.insert({ s[0],0 });
	int t = 0;
	while (!x.empty())
	{
		auto r = *x.rbegin();
		x.erase(r);
		ans[r.second] = min(ans[r.second], t++);
		for (auto i : g[r.second]) {
			x.insert({ s[i], i });
		}
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	ans.assign(n, n + 1);
	g.resize(n); 
	for (size_t i = 0; i < n -1; i++)
	{
		int p;
		cin >> p; --p;
		g[p].push_back(i + 1);
	}
	input(s, n);
	vector<int> r;
	input(r, q);
	for (size_t i = 0; i < n; i++)
	{
		int val = s[i];
		s[i] = 0;
		make();
		s[i] = val;
	}
	for (size_t i = 0; i < q; i++)
	{
		cout << ans[r[i] - 1] << ' ';
	}
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif // _DEBUG
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif // _DEBUG
	while (tt--)
	{
		solve();
#ifdef _DEBUG
		cout << "\n================\n";
#endif // _DEBUG
	}
}