#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll INF = 1e16;
const ll SZ = 3e5;

vector<ll> g[SZ];

void solve() {
	ll n, q, v;
	cin >> n >> q;
	vector<ll> p(n - 1);
	vector<ll> s(n);
	for (ll i = 0; i < n - 1; i++) cin >> p[i];
	for (ll i = 0; i < n; i++) cin >> s[i];
	vector<ll> cnt;
	vector<ll> next;
	priority_queue<pii> pq;
	set<pii> se;
	for (ll i = 0; i < n - 1; i++) {
		--p[i];
		if (p[i]) g[p[i]].push_back(i + 1);
		else {
			pq.push({ s[i + 1], cnt.size() });
			se.insert({ 0, cnt.size() });
			cnt.push_back(0);
			next.push_back(i + 1);
		}
	}
	ll sz = cnt.size();
	vector<ll> ans(n);
	for (ll i = 0; i < n - 1; i++) {
		auto pi = pq.top();
		pq.pop();
		se.erase({ cnt[pi.se], pi.se });
		ll in = next[pi.se];
		auto it = se.end();
		it--;
		//cout << in << '\n';
		if (!se.empty()) ans[in] = (i + 1) - it->fi;
		else ans[in] = (i + 1);
		if (!g[in].empty()) next[pi.se] = g[in][0];
		cnt[pi.se]++;
		se.insert({ cnt[pi.se], pi.se });
		if (!g[in].empty()) {
			pq.push({s[next[pi.se]], pi.se});
		}
	}
	for (ll i = 0; i < q; i++) {
		cin >> v;
		cout << ans[--v] << ' ';
	}
	cout << '\n';
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}
