#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll INF = 1e16;
const ll SZ = 3e5;

vector<ll> g[SZ];
priority_queue<pii> pq[SZ];
ll used[SZ];

void dfs(ll v, ll c) {
	used[v] = c;
	for (auto u : g[v]) {
		dfs(u, c);
	}
}

void solve() {
	ll n, q, v;
	cin >> n >> q;
	vector<ll> p(n - 1);
	vector<ll> s(n);
	for (ll i = 0; i < n - 1; i++) cin >> p[i];
	for (ll i = 0; i < n; i++) cin >> s[i];
	for (ll i = 0; i < n - 1; i++) {
		--p[i];
		g[p[i]].push_back(i + 1);
	}
	for (auto u : g[0]) {
		dfs(u, u);
	}
	vector<ll> cnt(n);
	vector<ll> ans(n);
	set<pii> se;
	ans[0] = 0;
	for (ll i = 0; i < n - 1; i++) {
		pq[p[i]].push({ s[i + 1], i + 1 });
	}
	for (ll i = 0; i < n - 1; i++) {
		auto pi = pq[0].top();
		pq[0].pop();
		ll u = pi.se;
		se.erase({ cnt[used[u]], used[u]});
		if (!se.empty()) {
			auto it = se.end();
			it--;
			ans[u] = i + 1 - it->fi;
		}
		else {
			ans[u] = i + 1;
		}
		cnt[used[u]]++;
		se.insert({ cnt[used[u]], used[u] });
		ll in1 = 0, in2 = u;
		if (pq[in2].size() > pq[in1].size()) {
			swap(pq[in1], pq[in2]);
		}
		while (!pq[in2].empty()) {
			pi = pq[in2].top();
			pq[in2].pop();
			pq[in1].push(pi);
		}
	}
	for (ll i = 0; i < q; i++) {
		cin >> v;
		cout << ans[--v] << ' ';
	}
	cout << '\n';
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}
