#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef int ll;
typedef long double ld;
typedef pair<int, int> pii;

const ll INF = 1e16;
const ll SZ = 3e5 + 1;

vector<ll> g[SZ];
priority_queue<pii> pq[SZ];
ll used[SZ];
ll sz[SZ];
ll s[SZ];
ll ans[SZ];
ll in = -1;
vector<ll> path;

void dfs(ll v, ll ma) {
	in++;
	ans[v] = in - ma;
	sz[v] = 1;
	for (auto u : g[v]) {
		dfs(u, ma);
		sz[v] += sz[u];
		ma = max(ma, sz[u]);
	}
}

bool cmp(ll v, ll u) {
	return (s[v] > s[u]);
}

void solve() {
	ll n, q, v;
	cin >> n >> q;
	vector<ll> p(n, -1);
	for (ll i = 1; i < n; i++) cin >> p[i];
	for (ll i = 0; i < n; i++) cin >> s[i];
	for (ll i = 1; i < n; i++) {
		--p[i];
		g[p[i]].push_back(i);
	}
	for (ll i = 0; i < n; i++) {
		sort(all(g[i]), cmp);
	}
	dfs(0, 0);
	for (ll i = 0; i < q; i++) {
		cin >> v;
		cout << ans[--v] << ' ';
	}
	cout << '\n';
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}
