#include <bits/stdc++.h>

#define ll long long
#define vl vector<ll>
#define pl pair<ll,ll>
#define pb push_back
#define all(x) x.begin(),x.end()

using namespace std;

struct SegmentTree
{
	SegmentTree *lc,*rc;
	int s,e,sum=0,mx=0;
	multiset<int> cur={0};
	SegmentTree(int l,int r)
	{
		s=l;e=r;
		if(l==r)
			return;
		int mid=(s+e)/2;
		lc=new SegmentTree(s,mid);
		rc=new SegmentTree(mid+1,e);
	}
	void add(int ind,int val)
	{
		if(e<ind or ind<s)
			return;
		if(s==e)
		{
			cur.insert(val);
			sum+=val;
			mx=*rbegin(cur);
			return;
		}
		lc->add(ind,val);
		rc->add(ind,val);
		sum=lc->sum+rc->sum;
		mx=max(lc->mx,rc->mx);
	}
	void rem(int ind,int val)
	{
		if(e<ind or ind<s)
			return;
		if(s==e)
		{
			cur.erase(cur.find(val));
			sum-=val;
			mx=*rbegin(cur);
			return;
		}
		lc->rem(ind,val);
		rc->rem(ind,val);
		sum=lc->sum+rc->sum;
		mx=max(lc->mx,rc->mx);
	}
	pair<int,int> query(int l,int r)
	{
		if(r<s or e<l)return {0,0};
		if(l<=s and e<=r)
		{
			return {sum,mx};
		}
		auto fp=lc->query(l,r);
		auto sp=rc->query(l,r);
		return {fp.first+sp.first,max(fp.second,sp.second)};
	}
};

const ll N=3e5+10;
vl ma[N];
ll sz[N],s[N],par[N],h[N],ans[N];
multiset<ll> val[N];
bool have[N];
void dfs_(int x)
{
	sz[x]=1;
	for(auto y:ma[x])
	{
		par[y]=x;
		h[y]=h[x]+1;
		dfs_(y);
		sz[x]+=sz[y];
	}
}
SegmentTree *seg=NULL;
void togle(int v)
{
	if(have[v])
	{
		seg->rem(s[v],sz[v]);
		have[v]=0;
	}
	else
	{
		seg->add(s[v],sz[v]);
		have[v]=1;
	}
}
bool cpt(int x,int y)
{
	return s[x]>s[y];
}
ll n,q;
void dfs(int x)
{
	// cout<<"Current "<<x<<endl;
	// cout<<"On are: ";
	// for(int j=1;j<=n;j++)
	// {
	// 	if(have[j])
	// 	{
	// 		cout<<j<<' ';
	// 	}
	// }
	// cout<<endl;
	// add x somehow????
	// add sz[x] to s[x]
	// query(l,r) tell the max/sum of the sz[y] where l<=s[y]<=r
	// ans is h[x]+query_sum(s[x]+1,n)-query_max(s[x]+1,n)
	// togle(x);
	auto ry=seg->query(0,n);
	ans[x]=h[x]+ry.first-ry.second;
	sort(all(ma[x]),cpt);
	for(auto y:ma[x])
	{
		dfs(y);
		togle(y);
	}
	for(auto y:ma[x])
	{
		togle(y);
	}
}
// ll query(ll x)
// {

// }
void solve()
{
	cin>>n>>q;
	seg=new SegmentTree(0,n);
	for(int i=2;i<=n;i++)
	{
		int p;
		cin>>p;
		ma[p].pb(i);
	}
	dfs_(1);
	// array s is a permutation
	for(int i=1;i<=n;i++)
	{
		cin>>s[i];
	}
	dfs(1);
	while(q--)
	{
		ll v;
		cin>>v;
		cout<<ans[v]<<' '; 
		// first let try brute force
	}
	cout<<endl;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t=1;
	// cin>>t;
	while(t--)
	{
		solve();
	}
}