#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double

const int maxn = 2e5;
const int LOG = 30;
const int N = 2e3;
const ld eps = 1e-12;

vector<int> g[maxn];
int s[maxn];

int n, q;

vector<int> d(int f) {
    vector<int> r(n, -1);

    set<pair<int, int>> st;

    st.insert({f == 0 ? 0 : s[0], 0});

    int t = 0;

    while(st.size()) {
        auto [val, v] = *st.rbegin();
        st.erase({val, v});
        r[v] = t++;

        for(int u: g[v]) {
            st.insert({u == f ? 0 : s[u], u});
        }
    }
    return r;
}

inline void solve() {
    cin >> n >> q;
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        x--;
        g[x].pb(i);
    }
    for (int i = 0; i < n; i++) cin >> s[i];

    vector<int> ans(n, n);

    for (int i = 0; i < n; i++) {
        vector<int> e = d(i);
        for(int j = 0; j  < n; j++) {
            ans[j] = min(ans[j], e[j]);
        }
    }

    while(q--) {
        int v;
        cin >> v;
        v--;
        cout << ans[v] << ' ';
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt = 1;
    //cin >> tt;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    while (tt--) {
        solve();
    }
    return 0;
}
 