
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define ll long long
#define FOR(i, s, f) for(ll (i) = (s); (i) < (f); (i)++)
const long long INF = 1e9;

vector<set<pair<ll, ll>>> graph;
vector<ll> ans;
ll d = 0;

void DFS(ll x){
    ans[x] = d++;
    for(auto g: graph[x]){
        DFS(g.second);
    }
    d--;
}

void solve(){
    ll n, q;
    cin >> n >> q;
    graph.resize(n);
    ans.resize(n, INF);
    vector<ll> pred(n - 1), comp(n);
    FOR(i, 0, n - 1) cin >> pred[i];
    FOR(i, 0, n) cin >> comp[i];
    FOR(j, 0, n - 1){
        graph[pred[j] - 1].insert({comp[j + 1], j + 1});
    }
    DFS(0);
    while(q--){
        ll x;
        cin >> x;
        x--;
        cout << ans[x] << " ";
    }
}

int main() {
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
