#include<bits/stdc++.h>
using namespace std;
using ll = long long;
int maxn = 3e5 + 3, n;
vector<vector<int>> g(maxn);
vector<int> s(maxn);

int calc(int t) {
    priority_queue<pair<int, int>> q;
    for (int u : g[1]) {
        q.emplace(s[u], u);
    }
    for (int i = 1; i <= n - 1; i++) {
        auto [x, v] = q.top();
        if (v == t) {
            return i;
        }
        q.pop();
        for (int u : g[v]) {
            q.emplace(s[u], u);
        }
    }
    return -1;
}



int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q, v;
    cin >> n >> q;
    for (int i = 2; i <= n; i++) {
        cin >> v;
        g[v].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }
    for (int i = 1; i <= q; i++) {
        cin >> v;
        if (v == 1) {
            cout << 0 << ' ';
            continue;
        }
        int res = 1e9;
        for (int j = 1; j <= n; j++) {
            if (v == j) continue;
            int pr = s[j];
            s[j] = 0;
            res = min(res, calc(v));
            s[j] = pr;
        }
        cout << res << ' ';
    }
}
