#include<bits/stdc++.h>
using namespace std;
using ll = long long;
int maxn = 3e5 + 3, n, cnt = 0, tx = 1, flag = 0;
vector<vector<int>> g(maxn);
vector<int> s(maxn), tin(maxn), tout(maxn);

bool parent(int a, int b) {
    return tin[a] > tin[b] && tout[a] < tout[b];
}

void dfs(int v, int x) {
    cnt++;
    for (int u : g[v]) {
        if (s[u] > s[x] || parent(x, u)) {
            dfs(u, x);
        }
    }
}

void dfs2(int v) {
    tin[v] = tx++;
    for (int u : g[v]) {
        dfs2(u);
    }
    tout[v] = tx++;
}



int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q, v;
    cin >> n >> q;
    for (int i = 2; i <= n; i++) {
        cin >> v;
        g[v].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }
    dfs2(1);
    for (int i = 1; i <= q; i++) {
        cin >> v;
        if (v == 1) {
            cout << 0 << ' ';
            continue;
        }
        cnt = 0;
        dfs(1, v);
        int res = 1e9;
        for (int j = 1; j <= n; j++) {
            if (j == v) continue;
            int pr = s[j];
            s[j] = 0;
            cnt = 0;
            dfs(1, v);
            res = min(res, cnt);
            s[j] = pr;
        }
        cout << res << ' ';
    }
}
