#include<bits/stdc++.h>
//#include<ext/pb_ds/assoc_container.hpp>
#define ll long long

using namespace std;
//using namespace __gnu_pbds;

ll n, q;
vector<ll> s, v, pos, ans, color;
vector<vector<ll>> a;
vector<bool> used;

void input() {
    cin >> n >> q;
    a.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll p;
        cin >> p;
        a[p - 1].push_back(i + 1);
        a[i + 1].push_back(p - 1);
    }
    s.resize(n);
    v.resize(q);
    for (ll i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (ll i = 0; i < q; i++) {
        cin >> v[i];
    }
}

void dfs(ll u, ll cl) {
    used[u] = true;
    color[u] = cl;
    for (ll i = 0; i < a[u].size(); i++) {
        if (!used[a[u][i]]) {
            dfs(a[u][i], cl);
        }
    }
}

void solve() {
    pos.resize(n);
    pos[0] = 1;
    set<pair<ll, ll>> ses;
    used.assign(n, false);
    used[0] = true;
    for (ll i = 0; i < a[0].size(); i++) {
        used[a[0][i]] = true;
        ses.insert({-s[a[0][i]], a[0][i]});
    }
    ll cnt = 1;
    vector<ll> order = {0};
    while (ses.size() > 0) {
        cnt++;
        ll u = ses.begin() -> second;
        pos[u] = cnt;
        order.push_back(u);
        ses.erase(ses.begin());
        for (ll i = 0; i < a[u].size(); i++) {
            if (!used[a[u][i]]) {
                used[a[u][i]] = true;
                ses.insert({-s[a[u][i]], a[u][i]});
            }
        }
    }
    used.assign(n, false);
    color.resize(n);
    used[0] = true;
    ll dd = 0;
    for (ll i = 0; i < a[0].size(); i++) {
        dfs(a[0][i], dd);
        dd++;
    }
    ans.resize(n);
    multiset<ll> st;
    vector<ll> sum(dd, 0);
    for (ll i = 0; i < dd; i++) {
        st.insert(0);
    }
    for (ll i = 1; i < n; i++) {
        //cout << order[i] << " " << color[order[i]] << endl;
        ll tk = color[order[i]];
        st.erase(st.find(-sum[tk]));
        ll maxim;
        if (st.size() == 0) {
            maxim = 0;
        } else {
            maxim = -*st.begin();
        }
        //cout << maxim << endl;
        ans[order[i]] = i - maxim;
        sum[tk]++;
        st.insert(-sum[tk]);
    }
}

void output() {
    for (ll i = 0; i < q; i++) {
        cout << ans[v[i] - 1] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}
