#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll INF = 1e18;

vector<vector<int>> g;
vector<ll> a;
vector<int> dep, up, used;
vector<int> ord;

vector<ll> ans;
vector<int> req;

void dfs(int v, int p) {
    dep[v] = (p == -1 ? 0 : dep[p] + 1);
    if (p == -1) {
        up[v] = -1;
    }
    else {
        if (up[p] == -1) up[v] = v;
        else up[v] = up[p];
    }
    for (auto to : g[v]) {
        if (to != p) {
            dfs(to, v);
        }
    }
}

void make(int v) {
    used[v] = 1;
    ord.push_back(v);
    int mx = -1;
    for (auto to : g[v]) {
        if (!used[to] && (mx == -1 || a[to] > a[mx])) {
            mx = to;
        }
    }
    if (mx == -1) return;
    for (auto to : g[v]) {
        if (!used[to] && to != mx) {
            g[mx].push_back(to);
        }
    }
    make(mx);
}

void solve() {
    int n, q; cin >> n >> q;
    a.resize(n);
    g.resize(n), used.resize(n), dep.resize(n), up.resize(n);
    for (int i = 2; i <= n; i++) {
        int p; cin >> p;
        g[p - 1].push_back(i - 1);
        g[i - 1].push_back(p - 1);
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    dfs(0, -1);
    make(0);
    req.resize(n, -1);
    ans.resize(q);
    for (int i = 0; i < q; i++) {
        ll v; cin >> v;
        v--;
        req[v] = i;
    }
    vector<ll> cnt(n, 0);
    for (int i = 0; i < ord.size(); i++) {
        int x = ord[i];
        if (up[x] == -1) {
            if (req[x] != -1) {
                ans[req[x]] = 0;
            }
            continue;
        }
        cnt[up[x]] += 1;
        if (req[x] == -1) continue;
        int mx = -1;
        for (int j = 0; j < n; j++) {
            if (j == up[x]) continue;
            if (mx == -1 || cnt[j] > cnt[mx]) {
                mx = j;
            }
        }
        if (mx == -1) {
            ans[req[x]] = i;
        }
        else {
            ans[req[x]] = i - cnt[mx];
        }
    }
    for (auto x : ans) cout << x << ' ';
    /*cout << '\n';
    for (auto x : ord) cout << x + 1 << ' ';
    cout << '\n' << '\n';
    for (auto x : ord) cout << up[x] + 1 << ' ';
    //for (auto x : ans) cout << x << ' ';*/
    //cout << "ok";
}

int main() {
    int t = 1; //cin >> t;
    cin.tie(0);
    ios::sync_with_stdio(0);
    while (t--) {
        solve();
    }
}
