#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using ll = long long;

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

vector<ll> s;
vector<vector<ll>> g;
vector<ll> p;
vector<ll> d;

void dfs(ll v, ll prev) {
    if (prev != -1) {
        d[v] = d[prev] + 1;
    } else {
        d[v] = 0;
    }
    for (auto i : g[v]) {
        if (i != prev) {
            dfs(i, v);
        }
    }
}

inline void solve() {
    ll n, q;
    cin >> n >> q;
    s.resize(n);
    p.resize(n);
    g.resize(n);
    d.resize(n);
    for (ll i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[i].push_back(p[i]);
        g[p[i]].push_back(i);
    }
    for (ll i = 0; i < n; i++) {
        cin >> s[i];
    }
    dfs(0, -1);
    for (ll _ = 0; _ < q; _++) {
        ll x;
        cin >> x;
        x--;
        cout << d[x] << endl;
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll q = 1;
    // cin >> q;
    while (q--) {
        solve();
    }
}
