#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

vector<int> p;
vector<vector<int>> sons;
vector<int> power;
vector<int> used;
vector<int> used2;

int dfs(int v){
    int am = 1;
    used2[v] = 1;
    for(auto u : sons[v])
        if(!used[u])
            am += dfs(u);
    return am;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, q;
    cin >> n >> q;

    p.resize(n + 1);
    sons.resize(n + 1);
    power.resize(n + 1);

    for(int i = 2; i <= n; ++i){
        int x;
        cin >> x;
        p[i] = x;
        sons[x].push_back(i);
    }

    for(int i = 1; i <= n; ++i)
        cin >> power[i];

    vector<int> dir;

    set<pair<int, int>> s;
    s.insert({-power[1], 1});
    while(!s.empty()){
        auto x = *(s.begin());

        s.erase(x);
        dir.push_back(x.second);
        for(auto u : sons[x.second])
            s.insert({-power[u], u});
    }

    for(int i = 0; i < q; ++i){
        int v;
        cin >> v;
        used.assign(n + 1, 1);
        used2.assign(n + 1, 1);

        int cnt = 0;
        while(dir[cnt] != v){
            used[dir[cnt]] = 0;
            ++cnt;
        }
        used[v] = 0;

        int ans = cnt;
        for(int j = 0; j < cnt; ++j){
            used2[v] = 0;
            int val = dfs(dir[j]);
            if(used2[v] == 0){
                ans = min(ans, cnt - val);
                //cout << j << " " << ans << " " << val << endl;
            }
        }
        //cout << endl;
        cout << ans << " ";
    }
}
