#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void dfs(ll v, vector<vector<ll>> &g, vector<ll> &ans, ll x) {
    ans[v] = x;
    for (ll u : g[v]) {
        dfs(u, g, ans, x + 1);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, q;
    cin >> n >> q;
    vector<vector<ll>> g(n);
    for (ll i = 1; i < n; i++) {
        ll p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    ll p = 0;
    for (ll i = 0; i < n; i++) {
        if (i != 0 && !g[i].empty()) p = i;
    }
    vector<ll> s(n);
    for (ll &i : s) cin >> i;
    vector<ll> ans(n);
    dfs(0, g, ans, 0);
    set<pair<ll, ll>> b;
    for (ll i : g[0]) {
        b.emplace(s[i], i);
    }
    ll cnt = (ll) b.size() - 1;
    for (auto i : b) {
        ans[i.second] = max(1ll, cnt);
        cnt--;
    }
    while (q--) {
        ll x;
        cin >> x;
        x--;
        if (x != 0 && b.find({s[x], x}) == b.end()) {
            ans[x] += max(0ll, ans[p] - 1);
        }
        cout << ans[x] << ' ';
    }
    cout << '\n';
}
