#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
using ll = long long;
const int inf = 1e9 + 52;
vector<vector<int>> gr;
vector<int> tin;
vector<int> tout;

int t = 1;

void bldt(int v) {
    tin[v] = t++;
    for (int u: gr[v]) {
        if (!tin[u])
            bldt(u);
    }
    tout[v] = t;
}

bool anc(int v, int u) {
    return (tin[v] <= tin[u] && tin[u] < tout[v]);
}

vector<int> a;

int dfs2(int v, int mn, int p) {
    if (a[v] < mn)
        return 0;
    int ans = 1;
    for (int u: gr[v]) {
        if (u != p) {
            ans += dfs2(u, mn, v);
        }
    }
    return ans;
}

int sm = 0;
int mx = 0;


int dfs1(int v, int q, int p) {
    if (v == q) {
        return a[v];
    }
    int mn = inf;
    for (int u: gr[v]) {
        if (anc(u, q) && u != p) {
            //cout << u << " " << q  << " " << anc(u, q) << " " << tin[u] << " " << tout[u] << " " << tin[q] << endl;
            sm++;
            mn = dfs1(u, q, v);
        }
    }
    for (int u: gr[v]) {
        if (!anc(u, q) && u != p) {
            int smn = dfs2(u, mn, v);
            sm += smn;
            mx = max(mx, smn);
        }
    }
    return min(mn, a[v]);
}

signed main() {
    int n, q;
    cin >> n >> q;
    a.resize(n);
    gr.resize(n);
    tin.resize(n);
    tout.resize(n);
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        x--;
        gr[i].push_back(x);
        gr[x].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    bldt(0);
    while (q--) {
        int x;
        cin >> x;
        x--;
        sm = 0;
        mx = 0;
        dfs1(0, x, -1);
        cout << sm - mx << " ";
    }
    cout << endl;
}