#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using pii = pair<int, int>;
constexpr char nl = '\n';

int lgn;
vvi g;
vi sz;

void dfs(int u) {
    for (int v: g[u]) {
        dfs(v);
        sz[u] += sz[v];
    }
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vi p(n);
    lgn = __lg(n) + 1;
    sz.assign(n, 1);
    g.resize(n);
    p[0] = -1;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    dfs(0);
    vi s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vi tin(n);
    int t = 0;
    priority_queue<pii> qu;
    qu.emplace(s[0], 0);
    while (!qu.empty()) {
        auto [w, v] = qu.top();
        qu.pop();
        tin[v] = t;
        for (int u: g[v]) {
            qu.emplace(s[u], u);
        }
        ++t;
    }
    vi seq(n);
    iota(seq.begin(), seq.end(), 0);
    sort(seq.begin(), seq.end(), [&tin](int i, int j) {
        return tin[i] < tin[j];
    });
    vi ans = tin;
    vvi dp(n + 1);
    for (int i = 0; i < n; ++i) {
        int v = seq[i];
        dp[i + sz[v]].push_back(sz[v]);
    }
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        int v = seq[i];
        for (int j: dp[i])
            mx = max(mx, j);
        ans[v] = min(ans[v], tin[v] - mx);
    }
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        cout << ans[--v] << ' ';
    }
}