#ifdef LOCAL
#pragma optimize("", off)
#include "localstd1.h"
#else
#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/allocator.h>
#pragma GCC target("avx2,bmi,bmi2")
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(a) (a).begin(), (a).end()

ll solve(vector<ll> a) {
	ll res = 0;
	for (int i = 0; i < a.size(); i++) {
		res = max(res, a[i] + i + 1);
	}
	return res;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, k; cin >> n >> k;
	vector<ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	if (k >= 2) {
		vector<int> p(n - 1); iota(all(p), 0);
		sort(all(p), [&](int l, int r) {return a[l] < a[r]; });
		int last = *max_element(p.end() - (k - 1), p.end());
		last++;
		vector<ll> b(a.begin() + last, a.end());
		a.erase(a.begin() + last, a.end());
		sort(all(a));
		ll res = accumulate(a.end() - (k - 1), a.end(), (ll)0);
		if (a.size() >= k) b.insert(b.begin(), a[a.size() - k]);
		res += last - (a.size() >= k);
		cout << res + solve(b);
	}
	else {
		cout << solve(a);
	}
	return 0;
}