#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <iomanip>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <random>
using namespace std;

#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define pub push_back
#define pob pop_back
#define for0(i,n) for(ll i = 0; i < ll(n); i++)

typedef long long ll;
typedef vector<ll> vll;
typedef vector<pair<ll,ll>> vpll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<int> vi;
typedef vector<pair<int,int>> vpi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_multiset;


template<typename T1, typename T2>
ostream& operator <<(ostream& out, pair<T1, T2>& a){
    out << a.fi << " " << a.se << endl;
    return out;
}

template<typename T1, typename T2>
istream& operator <<(istream& in, pair<T1, T2>& a){
    in >> a.fi >> a.se;
    return in;
}

template<typename T>
istream& operator >>(istream& in, vector<T>& a){
    for(T& ai : a) in >> ai;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T>& a){
    for(T& ai : a) out << ai << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<vector<T>>& a){
    for(vector<T>& ai : a){
        for(T& aii : ai) in >> aii;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<vector<T>>& a){
    for(vector<T>& ai : a){
        for(T& aii : ai) out << aii << " ";
        out << endl;
    }
    return out;
}

void solve(){
    int n, k;
    cin >> n >> k;
    vll a(n);
    cin >> a;
    /*for(ll mask = 1; mask <= (1LL<<a.size()); mask++){
        ll maskc = mask;
        vll b;
        int cnt = 0;
        for(int i = 0; i < a.size(); i++){
            if (maskc & (1LL << i)){
                b.pub(1);
                cnt++;
            }else{
                b.pub(0);
            }
        }
        if (cnt != k) continue;

    }*/
    set<pair<ll, ll>, greater<pair<ll, ll>>> ms;
    for0(i,n){
        ms.insert({a[i],i});
    }
    ll best = 0;
    ll mx = -1;
    ll mxi = 0;
    for0(i,n-1){
        if (a[i] >= mx){
            mx = a[i];
            mxi = i;
        }
        ms.erase({a[i],i});
        pair<ll, ll> el = *ms.begin();
        ll ans = mx + el.fi + mxi+1 + (el.se-i);
        best = max(best, ans);
        //cout << i << " " << ans << endl;
    }
    cout << best << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
