#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#define int long long
using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

mt19937_64 rnd(1488);

struct Node{
    int a, sz, push;
};

vector<Node> T;
vector<int> A;

void push(int v) {
    if (T[v].push == 0) {
        return;
    }
    T[v * 2 + 1].a += T[v].push * T[v * 2 + 1].sz;
    T[v * 2 + 2].a += T[v].push * T[v * 2 + 1].sz;
    T[v * 2 + 1].push += T[v].push;
    T[v * 2 + 2].push += T[v].push;
    T[v].push = 0;
}

void build(int i, int l, int r) {
    if (l == r - 1) {
        T[i].push = 0;
        T[i].sz = 1;
        T[i].a = A[l];
        return;
    }
    int m = (l + r) / 2;
    build(i * 2 + 1, l, m);
    build(i * 2 + 2, m, r);
    T[i].a = T[i * 2 + 1].a + T[i * 2 + 2].a;
    T[i].sz = T[i * 2 + 1].sz + T[i * 2 + 2].sz;
}

int gets(int i, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return T[i].a;
    }
    if (r <= ql || l >= qr) {
        return 0;
    }
    push(i);
    int m = (l + r) / 2;
    return gets(i * 2 + 1, l, m, ql, qr) + gets(i * 2 + 2, m, r, ql, qr);
}

void mod(int i, int l, int r, int ql, int qr, int val) {
    if (ql <= l && r <= qr) {
        T[i].a += val * T[i].sz;
        T[i].push += val;
        return;
    }
    if (r <= ql || l >= qr) {
        return;
    }
    push(i);
    int m = (l + r) / 2;
    mod(i * 2 + 1, l, m, ql, qr, val);
    mod(i * 2 + 2, m, r, ql, qr, val);
    T[i].a = T[i * 2 + 1].a + T[i * 2 + 2].a;
}

struct Point{
    int x, y;
    Point (int x_ = 0, int y_ = 0) {
        x = x_;
        y = y_;
    }
};

Point operator +(Point a, Point b) {
    Point ans(a.x + b.x, a.y + b.y);
    return ans;
}

Point operator -(Point a, Point b) {
    Point ans(a.x - b.x, a.y - b.y);
    return ans;
}

int operator *(Point a, Point b) {
    return a.x * b.x + a.y * b.y;
}

int operator %(Point a, Point b) {
    return a.x * b.y - a.y * b.x;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int a, b;
    cin >> a >> b;
    vector<int> A;
    multiset<int> B;
    for (int i = 0; i < a - 1; ++i) {
        int c;
        cin >> c;
        A.push_back(c);
        B.insert(-c);
    }
    int c;
    cin >> c;
    A.push_back(c);
    int ans = 0;
    for (auto i : B) {
        if (b == 1) {
            break;
        }
        --b;
        //cout << i << endl;
        ans -= i;
    }
    //cout << ans << endl;
    cout << a + ans + A.back();
}
