#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rand1(ll a, ll b) {
    return uniform_int_distribution<ll> (a, b) (gen);
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (auto &i : a) cin >> i;
    ll res = n + a[n - 1];
    a.pop_back();
    n--;
    k--;
    sort(a.begin(), a.end());
    for (ll i = n - 1; n - i <= k; i--) {
        res += a[i];
    }
    cout << res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t12 = 1;
//    cin >> t12;
    while (t12--) {
        solve();
        cout << '\n';
    }
    return 0;
}
