#include "bits/stdc++.h"

using namespace std;

template<class T>
istream& operator>>(istream &is, vector<T> &vec) {
      for (auto &elem: vec) is >> elem;
      return is;
}
template<class T>
ostream& operator<<(ostream &os, const vector<T> &vec) {
      for (auto &elem: vec) os << elem << ' ';
      os << '\n';
      return os;
}

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("ans.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, k;
      cin >> n >> k;
      vector<int> a(n);
      cin >> a;

      int res = 0;
      for (int m = 0; m < (1 << n); ++m) {
            int mx1 = 0, mx2 = 0, cnt1 = 0, cnt2 = 0;
            for (int i = 0; i < n; ++i) {
                  if ((m >> i) & 1) cnt1++, mx1 = max(mx1, a[i] + cnt1);
                  else cnt2++, mx2 = max(mx2, a[i] + cnt2);
            }
            res = max(res, mx1 + mx2);
      }
      cout << res << endl;
}