#include "bits/stdc++.h"

using namespace std;

template<class T>
istream& operator>>(istream &is, vector<T> &vec) {
      for (auto &elem: vec) is >> elem;
      return is;
}
template<class T>
ostream& operator<<(ostream &os, const vector<T> &vec) {
      for (auto &elem: vec) os << elem << ' ';
      os << '\n';
      return os;
}
#define int long long
signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("ans.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, k;
      cin >> n >> k;
      vector<int> a(n);
      cin >> a;

      int res = 0;
      int t = pow(k, n);
      for (int m = 0; m < t; ++m) {
            vector<int> cnt(k), mx(k);
            int temp = m;
            for (int i = 0; i < n; ++i) {
                  int now = temp % k;
                  temp /= k;
                  cnt[now]++;
                  mx[now] = max(mx[now], a[i] + cnt[now]);
            }
            bool flag = true;
            for (int i = 0; i < k; ++i) {
                  if (!cnt[i]) flag = false;
            }

            if (flag) res = max(res, accumulate(mx.begin(), mx.end(), 0ll));
      }
      cout << res << endl;
}