#ifdef ONPC
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;


mt19937_64 rng(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 505050;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;
    ll ans = 0;
    priority_queue<int, vector<int>, greater<int>> pq;
    ll s = 0;
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        if (pq.size() >= k - 1) {
            ans = max(ans, x + s + i);
        }

        pq.push(x);
        s += x;
        if (pq.size() > k - 1) {
            s -= pq.top();
            pq.pop();
        }
    }

    cout << ans << '\n';

    return 0;
}
