#include <bits/stdc++.h>


using namespace std;


using ll = long long;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    vector<ll> en(k, 0);
    vector<ll> cnt(k, 0);
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
    }
    ll ans = 0;
    int buf = 0;
    for (int i = 0; i < n; i++) {
        int pos = -1;
        for (int j = 0; j < k; j++) {
            if (en.at(j) - 1 - buf <= a.at(i)) {
                if (pos == -1 || en.at(pos) > en.at(j)) {
                    pos = j;
                }
            }
        }
        if (pos != -1) {
            en.at(pos) = a.at(i);
            cnt.at(pos) += buf + 1;
            buf = 0;
        } else {
            buf++;
        }
    }
    for (int i = 0; i < k; i++) {
        ans += en.at(i);
        ans += cnt.at(i);
    }
    cout << ans;
    return 0;
}
