#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>

#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using oset = tree<pll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>; 

constexpr ll inf = 1e18;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    multiset<ll> q;
    for (ll &e : a) {
        cin >> e;
        q.insert(e);
    }
    while (q.size() != k) {
        q.erase(q.begin());
    }
    int mx = 0;
    for (int i = 0; i < n; ++i) if (q.find(a[i]) != q.end()) mx = i;
    ll s = mx + 1;
    for (ll const &e : q) s += e;
    ll res = s;

    {
    for (ll &e : a) {
        e++;
    }
    ll s = accumulate(all(a), 0);
    oset a_;
    set<pll> kostyl;
    for (int i = 0; i < n; ++i) {
        a_.insert({i, a[i]});
        kostyl.emplace(a[i], i);
    }

    map<int, int> cnt;
    for (pll const &e : a_) cnt[e.second]++;
    for (int i = k; i < n; ++i) {
        int mn = 0;

        auto it = kostyl.begin();
        if (prev(a_.end())->second == it->first and cnt[it->first] == 1) ++it;

        mn = it->second;

        s -= it->first;
        cnt[it->first]--;
        a_.erase({it->second, it->first});
        kostyl.erase(it);

        auto z = *prev(a_.end());
        a_.erase(z);
        kostyl.erase({z.second, z.first});
        cnt[z.second]--;
        z.second++;
        kostyl.insert({z.second, z.first});
        a_.insert(z);
        cnt[z.second]++;
        s++;
    }
    res = max(s, res);
    }
    cout << res;
}

signed main() {
    //ios::sync_with_stdio(false);
    //cin.tie(nullptr);
    solve();
}