#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock().now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename T>
using orderet_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ull = unsigned long long;
using uint = unsigned int;
using ld = long double;
using dd = double;

#define int ll

int cost(vector<int> v, int l){
    int n = v.size();
    int ans = 0;
    for(int i = l; i < n; ++i){
        ans = max(ans, v[i] + i + 1 - l);
    }
    return ans;
}

void solve(){
    int n, k;
    cin>>n>>k;
    vector<int> v(n);
    for(int i = 0; i < n; ++i) cin>>v[i];
    vector<vector<int>> dp(n, vector<int>(k, -1e18));
    for(int i = 0; i < n; ++i){
        dp[i][0] = i+1+v[i];
    }
    for(int j = 1; j < k; ++j){
        int mx = dp[0][j-1];
        for(int i = 1; i < n; ++i){
            dp[i][j] = mx + v[i] + i;
            mx = max(mx, dp[i][j-1] - i);
        }
    }
    int ans = 0;
    for(int i = k; i < n; ++i){
        ans = max(ans, dp[i-1][k-2] + cost(v, i));
    }
    cout << ans;
}

signed main(){
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    int t = 1;
    //cin>>t;
    while(t--) solve();
}