#ifndef LOCAL
#include <bits/allocator.h>
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#else
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using i128 = __int128_t;

#define all(x) (x).begin(), (x).end()

int n, k;
vector<int> arr;
ll best_score = 0;

int calc(ll penalty1) {
    double penalty = (double) penalty1 / 2.0;
    vector<int> sizes;
    vector<ll> curr_scores;
    for (int i = 0; i < n; ++i) {
        double max_score = arr[i] + 1 - penalty;
        ll best_seq = -1;
        for (int j = 0; j < (int) curr_scores.size(); ++j) {
            double new_score = arr[i] + sizes[j] + 1;
            if (new_score - (double) curr_scores[j] > max_score) {
                max_score = new_score;
                best_seq = j;
            }
        }
        if (best_seq == -1) {
            sizes.push_back({1});
            curr_scores.push_back(arr[i] + 1);
        } else {
            sizes[best_seq]++;
            curr_scores[best_seq] = max<ll>(curr_scores[best_seq], arr[i] + sizes[best_seq]);
        }
    }
    if ((int) sizes.size() == k) {
        ll score = 0;
        for (ll x : curr_scores) {
            score += x;
        }
        best_score = max(best_score, score);
    }
    return (int) sizes.size();
}

void solve() {
    cin >> n >> k;
    arr.resize(n);
    for (int &x : arr) cin >> x;
    ll left = 0.0;
    ll right = 1e18;
    while (left < right) {
        ll mid = (left + right) / 2;
        int sz = calc(mid);
        if (sz > k) {
            left = mid + 1;
        } else {
            right = mid;
        }
    }
    calc(left);
    assert(best_score != 0);
    cout << best_score << "\n";
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}