#ifndef LOCAL
#include <bits/allocator.h>
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#else
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using i128 = __int128_t;

#define all(x) (x).begin(), (x).end()

const int MAX_N = 5e5;

int n, k;
int arr[MAX_N];

void solve() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }

    vector<int> sizes(k);
    vector<ll> curr_scores(k, -2e18);
    for (int i = 0; i < n; ++i) {
        ll max_delta = -2e18;
        ll best_seq = -1;
        for (int j = 0; j < k; ++j) {
            ll new_score = arr[i] + sizes[j] + 1;
            if (new_score - curr_scores[j] > max_delta) {
                max_delta = new_score - curr_scores[j];
                best_seq = j;
            }
        }
        sizes[best_seq]++;
        curr_scores[best_seq] = max<ll>(curr_scores[best_seq], arr[i] + sizes[best_seq]);
    }
    ll score = 0;
    for (ll x : curr_scores) {
        score += x;
    }
    cout << score << "\n";
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}