#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;
using ll = long long;
using ull = unsigned long long;

constexpr ll maxn = 5e5 + 10;
//constexpr ll inf = 1e18;

ll n, k;
ll vals[maxn];

void solve() {
    cin >> n >> k;
    for (ll i = 0; i < n; ++i) cin >> vals[i];
    multiset<ll> svs;
    ll sv_sum = 0;
    for (ll i = 0; i + 1 < k; ++i) svs.insert(vals[i]), sv_sum += vals[i];
    ll ans = 0;
    for (ll i = k - 1; i < n; ++i) {
        ll cans = sv_sum;
        cans += vals[i];
        ans = max(ans, cans + i + 1);
        svs.insert(vals[i]), sv_sum += vals[i];
        sv_sum -= *svs.begin(), svs.erase(svs.begin());
    }
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    ll t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) solve();
    return 0;
}
