#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    while (q--) {
        solve();
    }
}

const ll INF = 1e18;

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (k == 1) {
        ll ans = 0;
        for (int i = 0; i < n; i++) {
            ans = max(ans, i + 1 + a[i]);
        }
        cout << ans;
        return;
    }
    multiset<ll> cur;
    vector<ll> dp(n, -INF);
    for (int i = 0; i < n; i++) {
        cur.insert(-a[i]);
        if (cur.size() < k - 1) {
            continue;
        }
        ll sm = 0;
        auto it = cur.begin();
        for (int j = 0; j < k - 1; j++) {
            sm -= *it;
            it++;
        }
        dp[i] = sm;
    }
    ll ans = 0;
    for (int i = 0; i < n - 1; i++) {
        ans = max(ans, dp[i] + a[i + 1] + i + 2);
    }
    cout << ans;
} 