#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pp = pair<int, int>;
using ld = long double;

template <typename T>
istream &operator>>(istream &s, vector<T> &a)
{
    for (T &el : a)
    {
        s >> el;
    }
    return s;
}

template <typename T>
ostream &operator<<(ostream &s, vector<T> &a)
{
    for (T el : a)
    {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

void solve()
{
    ll n, k;
    cin >> n >> k;
    vector<ll> arr(n);
    cin >> arr;
    multiset<ll> bst;
    ll bst_sum = 0;
    ll ans = 0;
    for (ll i = 0; i < n; i++)
    {
        ans = max(ans, i + 1 + bst_sum + arr[i]);
        bst.insert(arr[i]);
        bst_sum += arr[i];
        if (ll(bst.size()) > k - 1)
        {
            bst_sum -= *bst.begin();
            bst.erase(bst.begin());
        }
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}