#include <iostream>
#include <vector>

#define int long long
constexpr int INF = 4e18;

void solve()
{
    int n, k;
    std::cin >> n >> k;
    std::vector<int> a(n);
    for (int i = 0; i < n; ++i)
        std::cin >> a[i];
    std::vector<int> val(n);
    int res = 0;
    while (val[n - 1] != k) {
        std::vector<int> cnt(k, 0), val_k(k, 0);
        for (int i = 0; i < n; ++i) {
            cnt[val[i]] += 1;
            val_k[val[i]] = std::max(a[i] + cnt[val[i]], val_k[val[i]]);
        }    
        int cur = 0;
        for (int i = 0; i < k; ++i)
            cur += val_k[i];
        res = std::max(res, cur);
        val[0] += 1;
        for (int i = 0; i < n - 1; ++i) {
            if (val[i] == k) {
                val[i] = 0;
                val[i + 1] += 1;
            }
        }
    }
    std::cout << res << '\n';
}

signed main()
{
    int t = 1;
#ifdef LOCAL
    freopen("stream/ind.txt", "r", stdin);
    freopen("stream/outd.txt", "w", stdout);
    std::cin >> t;
#else
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#endif
    for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
        solve();
    }
    std::cout.flush();
    return 0;
}