#include <algorithm>
#include <iostream>
#include <vector>

#define int long long
constexpr int INF = 4e18;

void solve()
{
    int n, k;
    std::cin >> n >> k;
    std::vector<int> a(n);
    for (int i = 0; i < n; ++i)
        std::cin >> a[i];
    std::vector<int> pref(n + 1);
    for (int i = 1; i <= n; ++i)
        pref[i] = std::max(pref[i - 1], a[i - 1]);
    int res = 0;
    for (int i = 0; i < n; ++i) {
        res = std::max(res, pref[i] + a[i] + i + 1);
    }
    std::cout << res << '\n';
}

signed main()
{
    int t = 1;
#ifdef LOCAL
    freopen("stream/ind.txt", "r", stdin);
    freopen("stream/outd.txt", "w", stdout);
    std::cin >> t;
#else
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#endif
    for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
        solve();
    }
    std::cout.flush();
    return 0;
}