#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

#define int long long
constexpr int INF = 4e18;

void solve()
{
    int n, k;
    std::cin >> n >> k;
    std::vector<int> a(n);
    for (int i = 0; i < n; ++i)
        std::cin >> a[i];
    // std::vector<int> pref(n + 1);
    // for (int i = 1; i <= n; ++i)
    //     pref[i] = std::max(pref[i - 1], a[i - 1]);
    std::set<int> set;
    int res = 0, cur = 0;
    for (int i = 0; i < n; ++i) {
        if (set.size() < k - 1) {
            set.insert(a[i]);
            cur += a[i];
            continue;
        }
        res = std::max(res, cur + a[i] + i + 1);
        if (set.lower_bound(a[i]) != set.begin()) {
            cur += a[i];
            cur -= *set.begin();
            set.erase(set.begin());
            set.insert(a[i]);
        }
    }
    std::cout << res << '\n';
}

signed main()
{
    int t = 1;
#ifdef LOCAL
    freopen("stream/ind.txt", "r", stdin);
    freopen("stream/outd.txt", "w", stdout);
    std::cin >> t;
#else
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#endif
    for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
        solve();
    }
    std::cout.flush();
    return 0;
}