#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<random>
#include<chrono>
#include<map>
#include<deque>
#define int long long
#define ll long long
#define ld long double
using namespace std;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());
int n, k;
vector<int> v;
int ans = -1e18;
void dfs(int I, vector<int> t) {
	if (I == n) {
		map<int, vector<int>> mp;
		for (int i = 0; i < n; i++) {
			mp[t[i]].push_back(v[i]);
		}
		if (mp.size() != k)return;
		int cur = 0;
		for (auto p : mp) {
			int mx = -1e18;
			for (int i = 0; i < p.second.size(); i++) {
				mx = max(mx, p.second[i] + i + 1);
			}
			cur += mx;
		}
		ans = max(ans, cur);
		return;
	}
	for (int i = 0; i < k; i++) {
		t.push_back(i);
		dfs(I + 1, t);
		t.pop_back();
	}
}
void solve() {
	cin >> n >> k;
	v.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	dfs(0, {});
	cout << ans;

}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	//cin >> t;
	t = 1;
	while (t--) {
		solve();
	}
}
