#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    vector<pair<int, int>> b(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        b[i] = {a[i], i};
    }
    sort(b.rbegin(), b.rend());
    ll ans = a[n - 1] + n;
    for (int i = 0; i < k - 1; ++i) {
        ans += b[i].first;
    }
    cout << ans << '\n';
    return 0;
}
