#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    ll ans = 0;
    multiset<ll> st;
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        ll mn = 0;
        if ((int) st.size() == k) {
            mn = *st.begin();
        }
        ans = max(ans, sum - mn + a[i] + i + 1);
        //cout << sum - mn + a[i] + i + 1 << '\n';
        st.insert(a[i]);
        sum += a[i];
        if ((int) st.size() > k) {
            sum -= *st.begin();
            st.erase(*st.begin());
        }
    }
    cout << ans << '\n';
    return 0;
}
