#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2,bmi")

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl "\n"
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

constexpr int INF = 2e18;
constexpr int MOD = 1e9 + 7;


pair<int, int> solve(vector<int> a, int n, int k, int L) {
    vector<vector<int>> dp(n, vector<int>(k + 1, -INF));
    vector<vector<int>> cnt(n, vector<int>(k + 1, 0));
    for (int i = n - 1; i >= 0; i--) {
        dp[i][1] = a[i] + 1 - L;
        cnt[i][1] = 1;
    }
    for (int i = n - 2; i >= 0; i--) {
        for (int j = 0; j < k; j++) {
            if (dp[i][j + 1] < dp[i + 1][j] + a[i] + 1 - L) {
                dp[i][j + 1] = dp[i + 1][j] + a[i] + 1 - L;
                cnt[i][j + 1] = cnt[i + 1][j] + 1;
            }
        }
        for (int j = 1; j <= k; j++) {
            if (dp[i][j] < dp[i + 1][j] + 1) {
                dp[i][j] = dp[i + 1][j] + 1;
                cnt[i][j] = cnt[i + 1][j];
            }
        }
    }
    return {cnt[0][k], dp[0][k]};
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int l = -INF, r = INF;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        auto [res, ans] = solve(a, n, k, m);
        if (res > k) {
            l = m;
        } else {
            r = m;
        }
    }
    auto [res, ans] = solve(a, n, k, r);
    cout << ans + res * r;
}
