#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ld = long double;
const ll INF = 1e9 * 5e5;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector <ll> a(n);
    vector <pair <ll, int>> b(n);
    for (int i=0; i < n; ++i) {
        cin >> a[i];
    }
    vector <ll> suff(n);
    suff[n - 1] = 0;
    for (int i=n - 2; i >= 0; --i) {
        suff[i] = max(suff[i + 1], a[i + 1] + i + 2);
    }
    ll ans = 0;
    ll maxi = 0;
    for (int i=0; i < n; ++i) {
        ans = max(ans, a[i] + 1 + max(suff[i] - 1, maxi));
        maxi = max(maxi, a[i]);
    }
    cout << ans << '\n';
    return 0;
}
