#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ve vector
#define pb push_back
ll const inf = 1e9 + 3;

ll const INF = 1e18;

struct Node {
    ll val = 0;
    ll added = 0;
    bool is_added = false;
};

ve<Node> tree;

void build(ll v, ll tl, ll tr) {
    if (tr - tl == 1) {

        return;
    }
    ll m = (tl + tr) / 2;
    build(2 * v, tl, m);
    build(2 * v + 1, m, tr);
}

void add_to_Node(ll v, ll tl, ll tr, ll val) {
    tree[v].val += (tr - tl) * val;
    tree[v].added += val;
    tree[v].is_added = true;
}

void push(ll v, ll tl, ll tr) {
    if (tree[v].is_added) {
        ll m = (tl + tr) / 2;
        add_to_Node(2 * v, tl, m, tree[v].added);
        add_to_Node(2 * v + 1, m, tr, tree[v].added);
        tree[v].added = 0;
        tree[v].is_added = false;
    }
}

void Add(ll v, ll tl, ll tr, ll ql, ll qr, ll val) {
    if (tl >= qr || tr <= ql)
        return;
    if (tr == qr && tl == ql) {
        add_to_Node(v, tl, tr, val);
        return;
    }
    ll m = (tl + tr) / 2;
    push(v, tl, tr);
    Add(2 * v, tl, m, ql, min(m, qr), val);
    Add(2 * v + 1, m, tr, max(m, ql), qr, val);
    tree[v].is_added = 0;
    tree[v].val = tree[2 * v].val + tree[2 * v + 1].val;
}

ll get_sum(ll v, ll tl, ll tr, ll ql, ll qr) {
    if (tr == qr && tl == ql) {
        return tree[v].val;
    }
    push(v, tl, tr);
    ll m = (tl + tr) / 2;
    ll s1 = get_sum(2 * v, tl, m, ql, min(qr, m));
    ll s2 = get_sum(2 * v + 1, m, tr, max(m, qr), ql);
    return s1 + s2;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll n, k;
    cin >> n >> k;
    ve<ll> a(n);
    ll i, j;
    ve<pair<ll, ll>> b(n);
    for (i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = {a[i], i};
    }
    if (k == 1) {
        ll mx = 0;
        for (i = 0; i < n; i++) {
            mx = max(mx, a[i] + i + 1);\

        }
        cout << mx;
        return 0;
    }
    sort(b.begin(), b.end());
    ll pos[n];
    for (i = 0; i < n; i++) {
        pos[b[i].second] = i;
    }

    ll sum_on_pref = 0;
    ll mx_on_suf = 0;
    mx_on_suf = a[n - 1] + 1;
    for (i = n - 1; i >= n - k + 1; i--) {
        sum_on_pref += b[i].first;
    }
    ll ans = 0;
    ll last = n - k + 1;
    if (a[n - 1] >= b[last].first) {
        sum_on_pref -= a[n - 1];
        last--;
        sum_on_pref += b[last].first;
    }
    b[pos[n - 1]].first = -1;
    // сумма на префиксе максимальных если нет последнего

    mx_on_suf = a[n - 1] + 1;
    ans = mx_on_suf + sum_on_pref + n - 1;
    for (i = n - 2; i >= k - 1; i--) {
        if (a[i] >= b[last].first) {
            sum_on_pref -= a[i];
            last--;
            while (b[last].first == -1)
                last--;
            sum_on_pref += b[last].first;
        }
        mx_on_suf = a[i] + 1;
        b[pos[i]].first = -1;
        ans = max(ans, mx_on_suf + sum_on_pref + i);
    }
    cout << ans;
}
