#ifdef _MSC_VER
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream& operator>>(istream& is, vector<T>& a) {
	for (auto& i : a) {
		is >> i;
	}
	return is;
}

mt19937 rng(228);

int32_t main() {
#ifdef LOCAL
	assert(freopen("C:\\Users\\User\\input.txt", "r", stdin));
#else
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	cin >> a;
	vector<pair<int, int>> bb;
	for (int i = 0; i < n; ++i) {
		bb.push_back({ a[i], 1 });
	}
	sort(bb.begin(), bb.end(), [](const pair<int, int>& p, const pair<int, int>& q) {
		return p.first + p.second > q.first + q.second;
		});
	while ((int)bb.size() > k) {
		auto [x1, y1] = bb.back();
		bb.pop_back();
		auto [x2, y2] = bb.back();
		bb.pop_back();
		bb.push_back({ max(x1, x2), y1 + y2 });
	}
	ll ans = 0;
	for (int i = 0; i < k; ++i) {
		auto [x, y] = bb[i];
		ans += x + y;
	}
	cout << ans << "\n";
	return 0;
}