#ifdef _MSC_VER
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream& operator>>(istream& is, vector<T>& a) {
	for (auto& i : a) {
		is >> i;
	}
	return is;
}

mt19937 rng(228);

int32_t main() {
#ifdef LOCAL
	assert(freopen("C:\\Users\\User\\input.txt", "r", stdin));
#else
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	cin >> a;
	vector<int> p(n);
	iota(p.begin(), p.end(), 0);
	sort(p.begin(), p.end(), [&](int i, int j) {
		if (a[i] == a[j]) {
			return i < j;
		}
		return a[i] > a[j];
		});
	vector<pair<int, int>> b(k);
	ll ans = 0;
	for (int i = 0; i < k; ++i) {
		b[i] = { p[i], 0 };
		ans += a[b[i].first] + b[i].second;
	}
	sort(b.begin(), b.end());
	for (int i = 0; i < n; ++i) {
		int j = lower_bound(b.begin(), b.end(), pair{ i, -inf }) - b.begin();
		if (j < k) {
			ans -= a[b[j].first] + b[j].second;
			b[j].second += 1;
			ans += a[b[j].first] + b[j].second;
		}
	}
	int mx = 0;
	int id = -1;
	for (int i = 0; i < k; ++i) {
		if (mx < b[i].second) {
			mx = b[i].second;
			id = i;
		}
	}
	bool found = false;
	ll cur = a[b[id].first] + b[id].second;
	for (int i = 0; i < n; ++i) {
		int j = lower_bound(b.begin(), b.end(), pair{ i, -inf }) - b.begin();
		if (j == k) {
			++mx;
			if (cur < a[i] + mx) {
				cur = a[i] + mx;
				found = true;
			}
		}
	}
	if (found) {
		ans -= a[b[id].first] + b[id].second;
		ans += cur;
	}
	cout << ans << "\n";
	return 0;
}