#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

ll inf = (ll)1e18;
template<class T>
ll len(T& a) {
    return (ll)a.size();
}


ll get(vector<ll> a, ll k) {
    if (len(a) == k) {
        return accumulate(a.begin(), a.end(), 0ll) + len(a);
    }
    if (k == 1) {
        ll curr = 0;
        for (ll i = 0; i < len(a); ++i) {
            curr = max(curr, a[i] + i + 1);
        }
        return curr;
    }
    ll res = -1;
    for (ll bit = 0; bit < (1ll << len(a)); ++bit) {
        vector<ll> oth;
        vector<ll> now;
        for (ll i = 0; i < len(a); ++i) {
            if ((bit >> i) & 1ll) {
                now.push_back(a[i]);
            } else {
                oth.push_back(a[i]);
            }
        }
        if (len(oth) < k-1) {
            continue;
        }
        if (len(now) == 0) {
            continue;
        }
        ll curr = 0;
        for (ll i = 0; i < len(now); ++i) {
            curr = max(curr, now[i] + i + 1);
        }
        res = max(res, get(oth, k-1) + curr);
    }
    return res;
}

void solve() {
    ll n, k;
    cin >> n >> k;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    cout << get(a, k) << "\n";
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}