#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

ll inf = (ll)1e18;

template<class T>
ll len(T& a) {
    return (ll)a.size();
}

void solve() {
    ll n, k;
    cin >> n >> k;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    ll res = 0;
    priority_queue<ll, vector<ll>, greater<ll>> q;
    ll curr = 0;
    for (ll i = 0; i < k-1; ++i) {
        curr += a[i];
        q.push(a[i]);
    }
    for (ll i = k-1; i < n; ++i) {
        res = max(res, curr + i + 1 + a[i]);
        ll mini = q.top(); q.pop();
        if (a[i] > mini) {
            curr -= mini;
            curr += a[i];
            q.push(a[i]);
        } else {
            q.push(mini);
        }
    }

    cout << res << "\n";
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}