#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
using namespace __gnu_pbds;
using ord_set = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    vector<pair<int, int>> b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = {a[i], i};
    }
    if (k == 1) {
        cout << a[n - 1] + n;
        return;
    }
    sort(b.begin(), b.end());
    vector<int> u1(n, 1);
    priority_queue<pair<int, int>, vector<pair<int, int>>> q;
    int bal = n;
    for (int i = n - 1, cnt = 1; i >= 0 && cnt < k; i--, cnt++) {
        u1[b[i].second] = 0;
        q.push(b[i]);
    }
    ll ans = 0;
    while (!q.empty()) {
        auto [v, pos] = q.top();
        q.pop();
        int l = 1;
        priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> s;
        for (int i = 0; i <= pos; i++) {
            if (u1[i]) {
                s.push({a[i], i});
            }
        }
        while (!s.empty() && l < (n + k - 1) / k) {
            auto [i, j] = s.top();
            l++;
            u1[j] = 0;
        }
        bal -= l;
        ans += a[pos] + l;
    }
    for (int i = n - 1; i >= 0; i--) {
        if (u1[i]) {
            ans += a[i] + bal;
            break;
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
}
