#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

//using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ld = long double;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    if (k == 1)
    {
        ll ans = 0;
        for (int i = 0; i < n; ++i)
        {
            ll cur = a[i] + i + 1;
            ans = max(ans, cur);
        }
        cout << ans;
        return 0;
    }
    multiset<int> ms;
    ll sum = 0;
    for (int i = 0; i < k - 1; ++i)
    {
        ms.insert(a[i]);
        sum += a[i];
    }
    ll ans = 0;
    for (int i = k - 1; i < n; ++i)
    {
        ll cur = sum + a[i] + (i - (k - 1)) + k;
        ans = max(ans, cur);
        int mn = *ms.begin();
        if (a[i] > mn)
        {
            ms.erase(ms.begin());
            ms.insert(a[i]);
            sum -= mn;
            sum += a[i];
        }
    }
    cout << ans;

    return 0;
}
