#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begoin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

const int N = 1e5 + 10;

int a[N], cur[N];
int ans = -INFi;

void gen(int n, int i, int k) {
    if (i == n) {
        vector<vector<int>> posl(k);
        for (int i = 0; i < n; ++i) {
            posl[cur[i]].push_back(a[i]);
        }
        int res = 0;
        for (int i = 0; i < k; ++i) {
            if (!len(posl[i])) return;
            int b = -INFi;
            for (int j = 0; j < len(posl[i]); ++j) {
                b = max(b, posl[i][j] + j + 1);
            }
            res += b;
        }
        ans = max(ans, res);
        return;
    }

    for (int j = 0; j < k; ++j) {
        cur[i] = j;
        gen(n, i + 1, k);
    }
}

void solve() {
    int n, k;
    cin >> n >> k;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    gen(n, 0, k);

    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
#endif

    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}