//#pragma GCC target("avx, avx2")
#pragma GCC optimize("O3, Ofast, unroll-loops")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <iomanip>
#include <random>
#include <vector>
#include <map>


using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define each(x, a) for(auto &x : a)



void solve() {
	ll n, k;
	cin >> n >> k;
	vector<ll> a(n);
	each(x, a) {
		cin >> x;
	}
	vector<ll> b(n);
	for (int i = 0; i < n; ++i) {
		b[i] = i;
	}
	ll ans = 0;
	do {
		for (int mask = 0; mask < (1 << n); ++mask) {
			vector<vector<ll>> v;
			int cur = 0;
			for (int i = 0; i < n; ++i) {
				if (cur == v.size()) {
					v.push_back({});
				}
				v.back().push_back({ b[i] });
				if ((mask >> i) & 1) {
					cur++;
				}
			}
			if (v.size() != k) continue;
			ll sum = 0;
			each(x, v) {
				sort(all(x));
				ll cur = 0;
				for (int j = 0; j < (ll)x.size(); ++j) {
					cur = max(cur, a[x[j]] + j + 1);
				}
				sum += cur;
			}
			ans = max(ans, sum);
		}
	} while (next_permutation(all(b)));
	cout << ans;
}


signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll t = 1;
	// cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}