#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define ff first
#define ss second
#define endl '\n'
#define all(a) (a).begin, (a).end()

const int INF = 1e9 + 123;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    multiset<int> mn;
    int s = 0;
    for (int i = 0; i < k - 1; ++i) {
        mn.insert(a[i]);
        s += a[i];
    }

    int ans = 0;
    for (int i = k - 1; i < n; ++i) {
        ans = max(ans, s + a[i] + i + 1);
        if (a[i] > *mn.begin()) {
            s -= *mn.begin();
            mn.erase(mn.begin());
            s += a[i];
            mn.insert(a[i]);
        }
    }

    cout << ans << endl;
}
