#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <tuple>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int INF = 2 * 1e9;
const ll MAX = 1e15;
const ll MIN = -1e15;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-7;


vector<int> a, ind;

bool cmp(int i, int j) {
    return a[i] + i > a[j] + j;
}

void solve() {
    int n, k; cin >> n >> k;
    a.assign(n, 0);
    ind.assign(n, 0);
    for (int i = 0; i < n; i++) cin >> a[i], ind[i] = i;
    sort(ind.begin(), ind.end(), cmp);
    vector<bool> flag(n, false);
    for (int i = 0; i < k; i++) {
        flag[ind[i]] = true;
    }
    ll ans = 0, cur = 0;
    for (int i = 0; i < n; i++) {
        cur++;
        if (flag[i]) ans += a[i] + cur, cur = 0;
    }
    cout << ans << endl;
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
