#include <iostream>
#include <vector>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#define int long long
#define ld long double

using namespace std;

void solve() {
    int n, k; cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<pair<int, int>> b(n);
    for (int i = 0; i < n; i++) {
        b[i] = {a[i] + i + 1, i};
    }
    sort(b.begin(), b.end());
    vector<vector<int>> ks(k);
    vector<int> cols(n, -1);
    int it = 0;
    for (int i = n - 1; i >= n - k; i--) {
        cols[b[i].second] = it++;
    }
    for (int i = 0; i < n; i++) {
        if (cols[i] == -1) {
            ks[it - 1].push_back(a[i]);
        } else {
            ks[cols[i]].push_back(a[i]);
        }
    }
    int ans = 0;
    for (int i = 0; i < k; i++) {
        int mx = -1;
        for (int j = 0; j < ks[i].size(); j++) {
            mx = max(mx, ks[i][j] + j + 1);
        }
        ans += mx;
    }
    cout << ans << '\n';
}
signed main() {
    solve();
}
