#include <iostream>
#include <vector>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#define int long long
#define ld long double

using namespace std;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    if (k == 1) {
        int ans = 0;
        for (int i = 0; i < n; i++) {
            ans = max(ans, a[i] + i + 1);
        }
        cout << ans << '\n';
        return;
    }
    multiset<int> temp;
    int pls = 0;
    for (int i = 0; i < k - 1; i++) {
        temp.insert(a[i]);
        pls += a[i];
    }
    int ans = 0;
    int val = 0;
    for (int i = k - 1; i < n; i++) {
        val = a[i] + i + 1 - (k - 1);
        val += pls + k - 1;
        ans = max(ans, val);
        int mn = *temp.begin();
        if (mn < a[i]) {
            temp.erase(temp.find(mn));
            temp.insert(a[i]);
            pls += (a[i] - mn);
        }
    }
    cout << ans << '\n';
}
signed main() {
    solve();
}
/*
5 3
3 7 10 1 2
*/
