#include <iostream>
#include <chrono>
#include <climits>
#include <cmath>
#include <random>
#include <algorithm>
#include <vector>
#include <string>

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, k, tmp;
    cin >> n >> k;
    vector<pair<ll, ll> > b;
    for (int i = 0; i < n; i++) {
        cin >> tmp;
        b.emplace_back(-tmp, -i);
    }
    sort(b.begin(), b.end());

    ll ind = 0, max_i = 0;
    ll ans = 0;
    for (int j = 0; j < k - 1; j++) {
        ans += -b[ind].first;
        max_i = max(max_i, -b[ind].second);
        ind++;
    }
    tmp = 0;
    for (int i = ind; i < n; i++) {
        tmp = max(tmp, -b[i].first + max(max_i + 1, -b[i].second + 1));
    }
    ans += tmp;
    cout << ans;
    return 0;
}
