#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <climits>
#include <iomanip>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <queue>
#include <random>

#define int long long

#pragma GCC optimize("03,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using ll = long long;
using ld = long double;
using namespace std;

const ll INF = 1e18;


void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    vector<pair<int, int>> b;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        b.push_back({a[i], -i});
    }
    sort(b.rbegin(), b.rend());
    for (int i = 0; i < n; i++){
        b[i].second *= -1;
    }
    int ind = 0;
    int s = 0;
    int mn = INF;
    for (int i = 0; i < k; i++){
        ind = max(ind, b[i].second);
        s += b[i].first;
        mn = min(mn, b[i].first);
    }
    int ans = s + ind + 1;
    int val = 0;
    for (int i = ind + 1; i < n; i++){
        val = max(val, a[i] + i - ind);
    }
    if (val + 1 > mn){
        ans -= (mn + 1);
        ans += (val + 1);
    }
    cout << ans;
}


signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}