//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2")
#define _GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forsn(i,s,e) for(ll i = s; i <= e; i++)
#define rforsn(i,s,e) for(ll i = s; i >= e; i--)
#define ln '\n'
#define all(x) x.begin(), x.end()

const ll inf = INT64_MAX;

ll n, k;
vector <ll> a;

ll cnt;
vector <ll> par, sz, val;

ll get_leader(ll v) {
    if (par[v] == v)
        return v;
    par[v] = get_leader(par[v]);
    return par[v];
}

void unite(ll v, ll u) {
    v = get_leader(v);
    u = get_leader(u);
    if (v == u)
        return;
    if (sz[v] < sz[u])
        swap(v, u);
    par[u] = v;
    sz[v] += sz[u];
    cnt--;
    ll idx = 0;
    forsn(i, 0, n - 1) {
        if (get_leader(i) == v) {
            idx++;
            ll cur = a[i] + idx;
            val[v] = max(val[v], cur);
        }
    }
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0);

    cin >> n >> k;
    a.resize(n);
    for (ll& i: a)
        cin >> i;

    set <pair <ll, ll>> s;
    par.resize(n);
    sz.resize(n);
    val.resize(n);
    forsn(i, 0, n - 1) {
        par[i] = i;
        sz[i] = 1;
        val[i] = a[i] + 1;
        s.emplace(val[i], i);
    }
    cnt = n;

    if (n == 1) {
        cout << val[0];
        exit(0);
    }

    while (cnt > k) {
        ll v = s.begin()->second;
        s.erase(s.begin());
        ll u = s.begin()->second;
        s.erase(s.begin());
        unite(v, u);
        ll w = get_leader(v);
        s.emplace(val[w], w);
    }

    ll ans = 0;
    for (auto p: s)
        ans += p.first;

    cout << ans;

    return 0;
}
