#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

template<class T>
using order_set = tree<T, nullptr_t, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using mll = map<ll, ll>;
using pll = pair<ll, ll>;
using vll = vector<ll>;

const ll inf = 1e16;
const ll mod = 1e9 + 7;
const ld eps = 1e-9;

const ll nmax = 5e5 + 1;
ll n, k;
ll ans = 0;
vector<vll> t;
vector<ll> a;

ll check() {
    for (ll i = 0; i < k; i++)
        if (t[i].empty())
            return 0;
    ll res = 0;
    for (ll i = 0; i < k; i++) {
        ll dop = 0;
        for (ll j = 0; j < t[i].size(); j++)
            dop = max(dop, t[i][j] + j + 1);
        res += dop;
    }
    return res;
}

void dfs(ll i) {
    if (i >= n) {
        ans = max(ans, check());
        return;
    }
    for (ll j = 0; j < k; j++) {
        t[j].push_back(a[i]);
        dfs(i + 1);
        t[j].pop_back();
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> k;
    a.resize(n);
    for (ll &i: a)
        cin >> i;
    t.resize(k);
    dfs(0);
    cout << ans << '\n';
}