#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

void gen(int pos, int n, int k, vector<int>& now, vector<vector<int>>& perm) {
    for (int i = 0; i < k; ++i) {
        now[pos] = i;
        if (pos == n - 1) {
            vector<int> b;
            for (auto j: now) {
                b.push_back(j);
            }
            perm.push_back(b);
        }
        else {
            gen(pos + 1, n, k, now, perm);
        }
    }
}

signed main() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<int>> perm;
    vector<int> now(n);
    gen(0, n, k, now, perm);
    int ans = 0;
    for (auto i: perm) {
        vector<int> cnt(k), res(k);
        for (int j = 0; j < n; ++j) {
            cnt[i[j]]++;
            res[i[j]] = max(res[i[j]], a[j] + cnt[i[j]]);
        }
        for (auto j: cnt) {
            if (j == 0) {
                continue;
            }
        }
        int sum = 0;
        for (auto j: res) {
            sum += j;
        }
        ans = max(ans, sum);
    }
    cout << ans;
}
