#include <iostream>
#include <vector>
#include <math.h>
#include <map>
#include <algorithm>
#include <set>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <string>

typedef long long ll;
typedef long double ld;

using namespace std;

ll const MAXN = 5e5;
ll const A = 367;
ll const B = 1e9 + 7;
ll row[MAXN];
ll ans = 0;


ll logpow(ll num, ll deb) {
	ll sum = 1;
	while (deb != 0) {
		if (deb % 2 == 0) {
			num *= num;
			deb /= 2;
		}
		else {
			sum *= num;
			deb--;
		}
	}
	return sum;
}

void req(ll i, ll n, vector<vector<ll>> hz, ll k) {
	if (i == n) {
		ll preans = 0;
		for (ll j = 0; j < k; j++) {
			ll pre = 0;
			if (hz[j].size() == 0) {
				return;
			}
			for (ll g = 0; g < hz[j].size(); g++) {
				pre = max(pre, hz[j][g] + g + 1);
			}
			preans += pre;
		}
		ans = max(ans, preans);
	}
	else {
		for (ll j = 0; j < k; j++) {
			hz[j].emplace_back(row[i]);
			req(i+1, n, hz, k);
			hz[j].pop_back();
		}
	}
}


void solve() {
	ll n, k;
	cin >> n >> k;
	for (ll i = 0; i < n; i++) {
		cin >> row[i];
	}
	vector<vector<ll>> hz(k);
	req(0, n, hz,k);
	cout << ans << endl;
}

int main()
{
	ll t = 1;
	//cin>> t;
	while (t--) {
		solve();
	}
}
