#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e18;

void solveAll(int n, int k, vector<ll> a) {
    ll ans = 0, sm = 0;
    multiset<ll> mx;
    for (int ls = 0; ls < n; ++ls) {
        ans = max(ans, sm + a[ls] + ls + 1);
        if (mx.size() < k - 1) {
            mx.insert(a[ls]);
            sm += a[ls];
        } else if (*mx.begin() < a[ls]) {
            ll v = *mx.begin();
            sm = sm + a[ls] - v;
            mx.erase(mx.begin());
            mx.insert(a[ls]);
        }
    }
    cout << ans << '\n';
}
void solvek2(int n, int k, vector<ll> a) {
    ll ans = 0;
    vector<ll> pm(n + 1);
    for (int i = 0; i < n; ++i) {
        pm[i + 1] = max(pm[i], a[i]);
    }
    for (int ls = 0; ls < n; ++ls) {
        ans = max(ans, pm[ls] + a[ls] + ls + 1);
    }
    cout << ans << '\n';
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    solveAll(n, k, a);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
