#include <bits/stdc++.h>
#include <bits/extc++.h>

#pragma GCC target("avx2")
#ifndef ABOBA
#pragma GCC optimize("O3")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll inf = 1e18, mod = 1e9 + 7;

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<pair<ll, ll>> a(n);
    vector<ll> b(n), used(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i].first;
        a[i].second = i, b[i] = a[i].first;
    }
    std::sort(a.rbegin(), a.rend());
    vector<vector<ll>> ans(k);
    for (ll i = 0; i < k; ++i) {
        used[a[i].second] = 1;
    }
    bool flag = false;
    for (ll i = 0; i < k; ++i) {
        if (a[i].second == n - 1) {
            flag = true;
            break;
        }
    }
    for (ll i = 0; i < k - !flag; ++i) {
        for (ll j = 0; j < a[i].second; ++j) {
            if (!used[j]) {
                ans[i].emplace_back(j);
                used[j] = 1;
            }
        }
        ans[i].emplace_back(a[i].second);
    }
    ll ans1 = 0;
    if (!flag) {
        used[a[k - 1].second] = 0;
        for (ll i = 0; i < n; ++i) {
            if (!used[i]) {
                ans[k - 1].emplace_back(i);
            }
        }
    }
    for (ll i = 0; i < k; ++i) {
        ll cur = 0;
        for (ll j = 0; j < ans[i].size(); ++j) {
            cur = max(cur, b[ans[i][j]] + j + 1);
        }
        ans1 += cur;
    }
    cout << ans1;

}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tt = 1;
    while (tt--) solve();
}