#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, m, G; cin >> n >> m >> G;
    vector<vector<int>> g(n), gr(n);
    for (int i = 0; i <m ; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].pb(v);
        gr[v].pb(u);
    }

    vector<int> ts, used(n, 0);
    auto dfs = [&](int v, auto&&self) -> void {
        used[v] = 1;
        for (int u : g[v]) {
            if (!used[u]) self(u, self);
        }
        ts.pb(v);
    };
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs(i, dfs);
    }
    reverse(all(ts));
    used.assign(n, 0);
    vector<int> cmp(n);
    int cc = 0;
    auto dfs2 = [&](int v, auto&&self) -> void {
        used[v] = 1; cmp[v] = cc;
        for (int u : gr[v]) {
            if (!used[u]) self(u, self);
        }
    };
    for (int i : ts) {
        if (!used[i]) {
            dfs2(i, dfs2);
            cc++;
        }
    }

    vector<vector<int>> g2(cc), cnte(cc, vector<int>(cc));
    for (int i = 0; i < n; i++) {
        for (int u : g[i]) {
            if (cmp[i] != cmp[u]) {
                cnte[cmp[i]][cmp[u]]++;
                g2[cmp[i]].pb(cmp[u]);
            }
        }
    }

    vector<vector<int>> U(cc, vector<int>(cc));
    auto dfs3 = [&](int v, int rt, auto&&self) -> void {
        U[rt][v] = 1;
        for (int u : g2[v]) {
            if (!U[rt][u]) self(u, rt, self);
        }
    };
    for (int i = 0; i < cc; i++) dfs3(i, i, dfs3);

    int candel = 0, ans = 1;
    constexpr int mod = 1e9 + 7;

    for (int i = 0; i < cc; i++) {
        for (int j = 0; j < cc; j++) {
            if (cnte[i][j] > 0) {
                bool C = false;
                for (int I = 0; I < cc; I++) {
                    if (i != I && I != j && U[i][I] && U[I][j]) {
                        C = true;
                    }
                }
                if (C) {
                    candel += cnte[i][j];
                } else {
                    candel += cnte[i][j] - 1;
                    ans = (ans * 1ll * cnte[i][j]) % mod;
                }
            }
        }
    }
    cout << candel << '\n' << ans << '\n';
}

signed main() {
    int tt = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else
        cin.tie(0)->sync_with_stdio(false);
    #endif  

    while (tt--) {
        solve();
    }

    return 0;
}