#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<cstdio>
#include<unordered_set>
#include<unordered_map>
#include<iomanip>
#include<random>
#include<bitset>
#include<ctime>

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;

ll gcd(ll a, ll b) {
	return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}
mt19937 mt(time(0));
const int N = 2000 + 2, inf = 1e9 + 100, mod = 1e9 + 7, mod2 = 998244353, P = 257;
const ll llinf = 1e18 + 100;
int n, m, gg;
vector<int> g[N], g2[N];
bool used[N][N], used2[N][N];
void dfs(int v, int p) {
	used[p][v] = true;
	for (auto to : g[v]) {
		if (!used[to]) dfs(to, p);
	}
}
void dfs2(int v, int p) {
	used2[p][v] = true;
	for (auto to : g2[v]) {
		if (!used2[p][to]) dfs2(to, p);
	}
}

void solve() {
	cin >> n >> m >> gg;
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		--x, --y;
		g[x].push_back(y);
	}
	int ans = -1, cnt = 0;
	for (int mask = 0; mask < (1 << m); ++mask) {
		bool f = true;
		for (int sm = mask; sm; sm = (sm - 1) & mask) {
			for (int i = 0; i < n; ++i) g2[i].clear();
			int c = 0;
			for (int i = 0; i < n; ++i) {
				for (auto to : g[i]) {
					if ((sm >> c) & 1) g2[to].push_back(i);
					else
						g2[i].push_back(to);
					++c;
				}
			}
			bool f1 = true;
			for (int i = 0; i < n; ++i) {
				fill(used[i], used[i] + n, false);
				fill(used2[i], used2[i] + n, false);
				dfs(i, i);
				dfs2(i, i);
			}
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < n; ++j) {
					if ((used[i][j] & used[j][i]) ^ (used2[i][j] & used2[j][i])) {
						f1 = false;
						break;
					}
				}
			}
			if (f1) {
				f = false;
				break;
			}
		}
		if (f) {
			int cn = 0;
			for (int i = 0; i < m; ++i) if ((mask >> i) & 1) ++cn;
			if (cn > ans) {
				ans = cn, cnt = 1;
			}
			else if (cn == ans) cnt++;
		}
	}
	cout << ans << ' ' << cnt;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
		cout.flush();
	}
	return 0;
}