#ifdef LOCAL
#pragma optimize("", off)
#include "localstd1.h"
#else
#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/allocator.h>
#pragma GCC target("avx2,bmi,bmi2")
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(a) (a).begin(), (a).end()

struct Node {
	vector<int> e;
	int comp = -1;
	int vers = -1;
	int banned = -1;
};
vector<Node> graph;

void dfs(int u, int vers) {
	if (graph[u].vers == vers) return;
	graph[u].vers = vers;
	for (int to : graph[u].e) if (graph[u].banned != to) {
		dfs(to, vers);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	
	int n, m, g; cin >> n >> m >> g;
	graph.assign(n, {});
	int cnt = 0, vers = 0;
	for (int i = 0; i < m; i++) {
		int u, v; cin >> u >> v; u--; v--;
		graph[u].e.push_back(v);
	}

	for (int u = 0; u < n; u++) {
		for (int to : graph[u].e) {
			graph[u].banned = to;
			dfs(u, vers);
			if (graph[to].vers == vers) cnt++;
			graph[u].banned = -1;
		}
	}

	cout << m - n + 1 << '\n' << 1;
	

	return 0;
}