//#pragma GCC optimize("unroll-loops, Ofast")
//#pragma GCC target("sse,sse2,avx,avx2")

#include <bits/stdc++.h>

using namespace std;
vector<int> used;
bool is_cyc;
vector<vector<int>> gg;

void dfs(int v) {
    used[v] = 1;
    for (int to: gg[v]) {
        if (!used[to]) {
            dfs(to);
        } else if (used[to] == 1) {
            is_cyc = true;
        }
    }
    used[v] = 2;
}

void solve() {
    int n, m, G;
    cin >> n >> m >> G;
    vector<vector<int>> g(n);
    vector<pair<int, int>> e;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        e.push_back({u, v});
    }
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        gg.assign(n, {});
        for (int j = 0; j < m; ++j) {
            if (i == j) {
                gg[e[j].second].push_back(e[j].first);
            } else {
                gg[e[j].first].push_back(e[j].second);
            }
        }
        is_cyc = false;
        used.assign(n, 0);
        for (int j = 0; j < n; ++j) {
            if (!used[j]) {
                dfs(j);
            }
        }
        if (is_cyc) {
            cnt++;
        }
    }
    cout << cnt << "\n";
    cout << 1 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
