#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#define endl '\n'

using namespace std;

void dfs(int v, vector<vector<int>> &g, vector<bool> &been) {
    been[v] = true;
    for (auto u : g[v]) {
        if (!been[u]) {
            dfs(u, g, been);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, z;
    cin >> n >> m >> z;
    int u, v;
    vector<vector<int>> g(n);
    vector<pair<int, int>> e;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        e.push_back({u, v});
    }
    int cnt = 0;
    vector<bool> been(n, false);
    for (int i = 0; i < n; ++i) {
        if (!been[i]) {
            cnt++;
            dfs(i, g, been);
        }
    }
    cout << m - (n - cnt) << endl;
    cout << 1 << endl;
    return 0;
}
