#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#define endl '\n'
#define int long long

using namespace std;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, z;
    cin >> n >> m >> z;
    vector<vector<int>> g(n);
    int u, v;
    for (int i = 0; i < m; ++i) {
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
    }
    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
    }
    vector<vector<bool>> can(n, vector<bool>(n, false));
    int ans = 0;
    for (int i = n - 1; i >= 0; --i) {
        can[i][i] = true;
        for (int j = 0; j < (int)g[i].size(); ++j) {
            if (j == 0) {
                for (int x = 0; x < n; ++x) {
                    if (can[g[i][j]][x]) {
                        can[i][x] = true;
                    }
                }
            } else {
                if (can[i][g[i][j]]) {
                    ans++;
                }
                for (int x = 0; x < n; ++x) {
                    if (can[g[i][j]][x]) {
                        can[i][x] = true;
                    }
                }
            }
        }
    }
    cout << ans << endl;
    cout << 1 << endl;
    return 0;
}
