#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rand1(ll a, ll b) {
    return uniform_int_distribution<ll> (a, b) (gen);
}

bool cyc = false;
ll st = -1;

void dfs(ll v, vector<ll> &vis, vector<vector<ll>> &g) {
    vis[v] = 1;
    for (auto &u : g[v]) {
        if (vis[u] == 2) continue;
        if (vis[u] == 1) {
            if (st == u) cyc = true;
        } else {
            dfs(u, vis, g);
        }
    }
    vis[v] = 2;
}

void solve() {
    ll n, m, gn;
    cin >> n >> m >> gn;
    vector<pair<ll, ll>> edges;
    for (ll i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        edges.push_back({x, y});
    }
    vector<ll> typeb(m, 0), typea(m, 0);
    for (ll i = 0; i < m; i++) {
        st = edges[i].first;
        cyc = false;
        vector<vector<ll>> g(n, vector<ll> ());
        for (auto &[x, y] : edges) g[x].push_back(y);
        vector<ll> vis(n, 0);
        dfs(st, vis, g);
        if (cyc) {
            typeb[i] = 1;
        }
    }
    for (ll i = 0; i < m; i++) {
        st = edges[i].second;
        cyc = false;
        swap(edges[i].first, edges[i].second);
        vector<vector<ll>> g(n, vector<ll> ());
        for (auto &[x, y] : edges) g[x].push_back(y);
        vector<ll> vis(n, 0);
        dfs(st, vis, g);
        swap(edges[i].first, edges[i].second);
        if (cyc) {
            typea[i]++;
        }
    }
    vector<pair<ll, ll>> nedges;
    ll res = 0;
    for (ll i = 0; i < m; i++) {
        if (typeb[i] == 0) {
            if (typea[i] == 1) res++;
        } else {
            if (typea[i] == 0) nedges.push_back(edges[i]);
        }
    }
    vector<ll> cnt(n, 0);
    ll k = nedges.size();
    for (ll i = 0; i < k; i++) {
        cnt[nedges[i].first]++;
    }
    ll sum = 0;
    for (auto &e : cnt) {
        if (e > 0) sum++;
    }
//    if (k == 0) {
//        res += 0;
//    }
//    res += k - sum + 1;
    cout << res << '\n' << 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t12 = 1;
//    cin >> t12;
    while (t12--) {
        solve();
        cout << '\n';
    }
    return 0;
}