#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<vector<ll>> g, rg;
vector<ll> us;
vector<ll> clr;
vector<ll> ord, d;
vector<vector<ll>> cmp;
vector<vector<ll>> cg;
vector<vector<ll>> edj;
vector<vector<pair<ll, ll>>> edjs;
vector<ll> edc;
void rdfs(ll v) {
    if (us[v]) return;
    us[v] = 1;
    for (auto u : rg[v]) rdfs(u);
    ord.push_back(v);
}
void cdfs(ll v, ll c) {
    if (us[v]) return;
    us[v] = 1;
    clr[v] = c;
    cmp.back().push_back(v);
    for (auto u : g[v]) cdfs(u, c);
}
void adfs(ll v) {
    for (int i : cg[v]) {
        if (d[i] < 2) {
            d[i] = d[v] + 1;
            adfs(i);
        }
    }
}

bool fndc(ll v, ll msk, ll p) {
    if (us[v] == msk) return 1;
    us[v] = msk;
    for (int i : cg[v]) if (i != p && edj[i][v] != -1) {
        if (msk & (1 << edj[i][v])) {
            if (fndc(i, msk, v)) return 1;
        }
    }
    return 0;
}

int main() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<pair<ll, ll>> e(m);
    for (auto& [i, j] : e) {
        cin >> i >> j;
        i--;
        j--;
    }
    vector<ll> CLR(n);
    vector<ll> wmsk;
    for (ll msk = 0; msk < (1<<m); msk++) {
        g.clear();
        rg.clear();
        ord.clear();
        g.resize(n);
        rg.resize(n);
        for (int i = 0; i < m; i++) {
            auto [u, v] = e[i];
            if (msk & (1 << i)) swap(u, v);
            g[u].push_back(v);
            rg[v].push_back(u);
        }

        us.assign(n, 0);
        for (int i = 0; i < n; i++) rdfs(i);
        reverse(ord.begin(), ord.end());
        int k = 0;
        us.assign(n, 0);
        clr.assign(n, 0);
        for (int i : ord) {
            if (us[i] == 0) {
                cmp.push_back({});
                cdfs(i, k++);
            }
        }
        cg.clear();
        cg.resize(k);
        if (msk == 0) CLR = clr;
        else {
            bool f = 1;
            for (auto [i, j] : e) {
                if ((clr[i] == clr[j]) != (CLR[i] == CLR[j])) {
                    f = 0;
                    break;
                }
            }
            if (f) wmsk.push_back(msk);
        }
    }
    ll ans = 0;
    ll cnt = 0;
    ll amsk = 0;
    sort(wmsk.begin(), wmsk.end());
    for (ll msk = 0; msk < (1<<m); msk++) {
        ll sz = 0;
        for (int i = 0; i < m; i++) {
            if (msk & (1 << i)) sz++;
        }
        if (sz < ans) continue;
        bool f = 1;
        for (ll i : wmsk) {
            if ((i | msk) == msk) {
                f = 0;
                break;
            }
        }
        if (f) {
            if (ans < sz) {
                ans = sz;
                cnt = 1;
                amsk = msk;
            } else if (ans == sz) {
                cnt++;
            }
        }
    }
    //cout << amsk << endl;
    cout << ans << "\n" << cnt << endl;
}