#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

// #define FILE
#define int long long

const int N = 20;
vector<vector<int>> g(N, vector<int>(N)), path(N, vector<int>(N));
vector<int> comp(N);
int timer = 1, m;
int n;

void dfs(int v) {
    comp[v] = timer;
    for (int i = 0; i < n; ++i) {
        if (!comp[i] && path[v][i] && path[i][v]) {
            dfs(i);
        }
    }
}

bool f = false;

bool get() {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            path[i][j] = g[i][j];
            /* if (f && g[i][j]) {
                cout << i + 1 << " " << j + 1 << endl;
            } */
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int z = 0; z < n; ++z) {
                path[i][j] |= path[i][z] & path[z][j];
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) continue;
            if (path[i][j] && path[j][i] && comp[i] != comp[j]) return false;
            if ((!path[i][j] || !path[j][i]) && comp[i] == comp[j]) return false;
        }
    }
    if (f) {
        cout << "!!!!" << endl;
    }
    return true;
}

void print(int n) {
    for (int i = 0; i < m; ++i) {
        cout << ((n >> i) & 1);
    }
    cout << endl;
    
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int gg;
    cin >> n >> m >> gg;
    vector<pair<int, int>> r;
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y; x--; y--;
        g[x][y] = 1;
        path[x][y] = 1;
        r.push_back({x, y});
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int z = 0; z < n; ++z) {
                path[i][j] += path[i][z] & path[z][j];
            }
        }
    }
    int ans = 0;
    for (auto [x, y] : r) {
        if (path[x][y] > 1) {
            ans++;
        }
    }
    cout << ans << " " << 1 << endl;
    return 0;

}