#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

// #define FILE
#define int long long

const int N = 2000;
vector<vector<int>> g(N);
vector<vector<int>> path(N, vector<int>(N));

void dfs(int st, int v) {
    path[st][v]++;
    for (auto x : g[v]) {
        dfs(st, x);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int gg;
    int n, m;
    cin >> n >> m >> gg;
    vector<pair<int, int>> r;
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y; x--; y--;
        g[x].push_back(y);
        r.push_back({x, y});
    }
    for (int i = 0; i < n; ++i) {
        dfs(i, i);
    }
    int ans = 0;
    for (auto [x, y] : r) {
        if (path[x][y] > 1) {
            ans++;
        }
    }
    cout << ans << " " << 1 << endl;
    return 0;

}