#include<iostream>
#include<algorithm>
#include<vector>

using namespace std;

#define ll long long

vector<vector<ll>> gr;
vector<vector<ll>> gr1;
vector<bool> used;
vector<ll> t;

void dfs(ll v) {
    used[v] = true;
    for (auto elem : gr[v]) {
        if (!used[elem]) {
            dfs(elem);
        }
    }
    t.push_back(v);
}

vector<vector<ll>> gr2;
vector<ll> a;
vector<ll> b;

void dfs1(ll v, ll k) {
    a[v] = k;
    b[k]++;
    used[v] = true;
    for (auto elem : gr1[v]) {
        if (!used[elem]) {
            dfs1(elem, k);
        } else if (a[elem] != k) {
            gr2[a[elem]].push_back(k);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, m, g;
    cin >> n >> m >> g;
    gr.resize(n);
    gr1.resize(n);
    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr1[v].push_back(u);
    }
    used.assign(n, false);
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(t.begin(), t.end());
    a.resize(n);
    used.assign(n, false);
    ll k = 0;
    for (auto i : t) {
        if (!used[i]) {
            gr2.push_back(vector<ll>());
            b.push_back(0);
            dfs1(i, k);
            k++;
        }
    }
    vector<vector<ll>> c(k, vector<ll>(k));
    for (ll i = 0; i < k; i++) {
        for (auto elem : gr2[i]) {
            c[i][elem]++;
        }
    }
    ll answer = 0;
    for (ll i = 0; i < k; i++) {
        for (ll j = 0; j < k; j++) {
            if (c[i][j] != 0) {
                answer += c[i][j] - 1;
            }
        }
    }
    answer += k;
    cout << answer << '\n';
    cout << 0 << '\n';
}