#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>> g;
vector<bool> us;

void dfs(int v, int p)
{
    if(us[v]) return;
    us[v] = 1;
    for(int u : g[v]) if(u != p){
        dfs(u, -1);
    }
}

signed main()
{
    int n, m, gr;
    cin >> n >> m >> gr;
    g.resize(n);
    for(int i = 0; i < m; ++i){
        int u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
    }
    int ans = 0;
    for(int u = 0; u < n; ++u) for(int v : g[u]){
        us.assign(n, 0);
        dfs(u, v);
        if(us[v]) ++ans;
    }
    cout << ans << endl << 1 << endl;
}