#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
//#define int long long
using ll = long long;

typedef tree<int, null_type,less<>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 100, inf = 1e9;
vector<int> g[N], g1[N], g3[N], g4[N];
int x[N], y[N];
int used[N], u[N], tim = 0, a[N], b[N], cnt = 0, mask[20000010], arr[20000010];
vector<int> vc;

void dfs(int v) {
    used[v] = tim;
    for (int p: g[v]) {
        if (used[p] != tim) {
            dfs(p);
        }
    }
    vc.push_back(v);
}

void dfs1 (int v) {
    used[v] = tim;
    a[v] = cnt;
    for (int p: g1[v]) {
        if (used[p] != tim) {
            dfs1(p);
        }
    }
}

void dfs3(int v) {
    used[v] = tim;
    for (int p: g3[v]) {
        if (used[p] != tim) {
            dfs3(p);
        }
    }
    vc.push_back(v);
}

void dfs4 (int v) {
    used[v] = tim;
    b[v] = cnt;
    for (int p: g4[v]) {
        if (used[p] != tim) {
            dfs4(p);
        }
    }
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, t, u, v;
    cin >> n >> m >> t;
    for (int i = 0; i < m; i++) {
        cin >> u >> v;
        x[i] = u; y[i] = v;
        g[u].push_back(v);
        g1[v].push_back(u);
    }
    tim++;
    for (int i = 1; i <= n; i++) {
        if (used[i] != tim) {
            dfs(i);
        }
    }
    reverse(vc.begin(), vc.end());
    tim++;
    cnt = 0;
    for (int i: vc) {
        if (used[i] != tim) {
            dfs1(i);
            cnt++;
        }
    }
    for (int mk = 0; mk <= (1<<m); mk++) {
        vc.clear();
        for (int i = 1; i <= n; i++) {
            g3[i].clear();
            g4[i].clear();
        }
        for (int j = 0; j < m; j++) {
            if (((mk>>j)&1) == 0) {
                g3[x[j]].push_back(y[j]);
                g4[y[j]].push_back(x[j]);
            } else {
                g4[x[j]].push_back(y[j]);
                g3[y[j]].push_back(x[j]);
            }
        }
        tim++;
        for (int i = 1; i <= n; i++) {
            if (used[i] != tim) {
                dfs3(i);
            }
        }
        reverse(vc.begin(), vc.end());
        tim++;
        cnt = 0;
        for (int i: vc) {
            if (used[i] != tim) {
                dfs4(i);
                cnt++;
            }
        }
        bool x = false;
        for (int i = 1; i <= n; i++) {
            for (int j = i+1; j <= n; j++) {
                if (a[i] == a[j] && b[i] != b[j]) {
                    x = true;
                }
                if (b[i] == b[j] && a[i] != a[j]) {
                    x = true;
                }
            }
        }
        if (!x) {
            mask[mk] = 1;
        }
    }
    int ans = 0, ct = 0;
    for (int j = m-1; j >= 0; j--) {
        for (int mk = (1<<m)-1; mk >= 0; mk--) {
            if (((mk>>j)&1) == 1) {
                mask[mk] += mask[mk-(1<<j)];
                arr[mk]++;
            }
            if (j == 0) {
                if (mask[mk] == 1) {
                    if (ans == arr[mk]) {
                        ct++;
                    } else if (ans < arr[mk]) {
                        ans = arr[mk];
                        ct = 1;
                    }
                }
            }
        }
    }
    cout << ans << '\n' << ct;
    return 0;
}