#include<bits/stdc++.h>

using namespace std;

const int MAXN = 21;

vector<int> g[MAXN];
vector<int> ng[MAXN];
vector<int> ncol;
vector<int> gcol;

vector<int> ord;
int was[MAXN];

int n, m, gg;

void dfs(int v){
    was[v] = 1;
    for(auto to : g[v]){
        if(!was[to]) dfs(to);
    }
    ord.push_back(v);
}

vector<int> now;

int mn = 1e9;

void paint(int v){
    was[v] = 1;
    now.push_back(v);
    mn = min(mn, v);
    for(auto to : ng[v]){
        if(!was[to]) paint(to);
    }
}

void get_comps(){
    ncol.clear();
    ncol.resize(n);
    ord.clear();
    for(int i = 0; i < n; i++){
        was[i] = 0;
    }
    for(int i = 0; i < n; i++){
        if(!was[i]){
            dfs(i);
        }
    }
    for(int i = 0; i < n; i++){
        was[i] = 0;
    }
    reverse(ord.begin(), ord.end());
    for(auto v : ord){
        if(was[v]) continue;
        mn = 1e9;
        now.clear();
        paint(v);
        for(auto x : now){
            ncol[x] = mn;
        }
    }
}

int banned[(1 << MAXN)];

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> gg;
    vector<pair<int, int>> edges;
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        ng[b].push_back(a);
        edges.push_back({a, b});
    }
    get_comps();
    gcol = ncol;
    //for(auto x : gcol) cout << x << " ";
    for(int mask = 1; mask < (1 << m); mask++){
        for(int i = 0; i < n; i++){
            g[i].clear();
            ng[i].clear();
        }
        for(int i = 0; i < m; i++){
            auto [a, b] = edges[i];
            if((mask >> i) & 1){
                g[b].push_back(a);
                ng[a].push_back(b);
            }
            else{
                g[a].push_back(b);
                ng[b].push_back(a);
            }
        }
        get_comps();
        if(ncol == gcol) banned[mask] = 1;
    }
    int mx = 0, cnt = 0;
    for(int mask = 0; mask < (1 << m); mask++){
        if(banned[mask]){
            for(int i = 0; i < m; i++){
                banned[mask | (1 << i)] = 1;
            }
            continue;
        }
        int res = __builtin_popcount(mask);
        if(res > mx){
            mx = res;
            cnt = 0;
        }
        if(res == mx) cnt++;
    }
    cout << mx << "\n" << cnt;
}
