#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

vector<pi> edges;
int timer = 0;
vector<vi> g;
vector<vi> gg;
vi col;
map<vi, vi> cnt;
vi order;
vi used;

void topsort(int v, int mask) {
    if (used[v]) return;

    used[v] = 1;

    for (int e : gg[v]) {
        if (((mask >> e) & 1) && (edges[e].second == v)) {
            continue; 
        } 

        if (!((mask >> e) & 1) && (edges[e].first == v)) {
            continue;
        }

        int u;

        if ((mask >> e) & 1) u = edges[e].second;
        else u = edges[e].first;

        topsort(u, mask);
    }

    order.pb(v);
}

void dfs(int v, int mask) {
    if (col[v]) return;

    used[v] = timer;

    for (int e : gg[v]) {
        if (((mask >> e) & 1) && (edges[e].second == v)) {
            continue; 
        } 

        if (!((mask >> e) & 1) && (edges[e].first == v)) {
            continue;
        }

        int u;

        if ((mask >> e) & 1) u = edges[e].second;
        else u = edges[e].first;

        dfs(u, mask);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, ggg;
    cin >> n >> m >> ggg;

    g.resize(n);
    gg.resize(n);
    
    int ans = 0;

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].pb(v);
        edges.pb({u, v});

        if (v - u > 1) ++ans;

        gg[u].pb(edges.size() - 1);
        gg[v].pb(edges.size() - 1);
    }

    cout << ans;
}