#include <bits/stdc++.h>
#include <immintrin.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

using namespace std;

const int N = 1100;

random_device rd;

mt19937 rnd(rd());

vector<vector<int>> v;

vector<int> o;
vector<int> used;

void dfs1(int u){
    used[u] = 1;
    for(auto i : v[u]){
        if(!used[i]){
            dfs1(i);
        }
    }
    o.push_back(u);
}

int tt = 0;
vector<int> c;
vector<vector<int>> comps;

void dfs2(int u){
    used[u] = 1;
    c[u] = tt++;
    comps.back().push_back(u);
    for(auto i : v[u]){
        if(!used[i]){
            dfs2(i);
        }
    }
}

vector<vector<int>> v1;

void dfs(int u){
    used[u] = 1;
    for(auto i : v1[u]){
        if(!used[i]){
            dfs(i);
        }
    }
}

void solve(){
    int n, m, g;
    cin >> n >> m >> g;
    v.resize(n);
    v1.resize(n);
    c.resize(n);
    vector<pair<int, int>> r;
    for(int i = 0; i < m; i++){
        int a, b;
        cin >> a >> b;
        a--;b--;
        r.emplace_back(a, b);
        v[a].push_back(b);
        v1[a].push_back(b);
        v1[b].push_back(a);
    }
    int cnt = 0;
    used.clear();
    used.resize(n);
    for(int i = 0; i < n; i++){
        if(!used[i]){
            cnt++;
            dfs(i);
        }
    }
    used.clear();
    used.resize(n);
    for(int i = 0; i < n; i++){
        if(!used[i]){
            dfs1(i);
        }
    }
    used.clear();
    used.resize(n);
    for(auto i : o){
        if(!used[i]){
            comps.emplace_back();
            dfs2(i);
            tt++;
        }
    }
    int rr = 0;
    for(auto [a , b] : r){
        if(c[a] != c[b]){
            rr++;
        }
    }
    int ans = 0;
    for(auto i : comps){
        ans += i.size() - 1;
    }
    ans += rr - (tt - cnt);
    cout << ans << endl << 0 << endl;
}

signed main(){
#ifdef lisie_bimbi
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif            
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}