#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>

using namespace std;

long long n, m, G, ans = 0;

vector<long long> dpp;

void dfs4(long long v, vector<vector<long long>>& g) {
	++dpp[v];
	if (dpp[v] > 2)
		return;
	for (long long i = 0; i < g[v].size(); ++i)
		dfs4(g[v][i], g);
}

long long f(vector<vector<long long>> g) {
	long long x55 = 0;
	for (long long i = 0; i < n; ++i) {
		dpp.clear();
		dpp.resize(n, 0);
		dfs4(i, g);
		for (long long j = 0; j < g[i].size(); ++j)
			if (dpp[g[i][j]] > 1)
				++x55;
	}
	return x55;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m >> G;

	vector<vector<long long>> g(n);

	for (long long i = 0; i < m; ++i) {
		long long a, b;
		cin >> a >> b;
		--a;
		--b;
		g[a].push_back(b);
	}

	cout << f(g) << "\n1";

	return 0;
}
