#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <random>
#include <time.h>
#include <climits>
//#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

using namespace std;
using ll = long long;
using ld = long double;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution <> distr(0, INT_MAX);

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m, gr;
	cin >> n >> m >> gr;
	vector<vector<int>> g(n), rev(n);
	vector<pair<int, int>> e;
	vector<int> col(n, -1);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		rev[b].push_back(a);
		e.push_back({ a, b });
	}
	int ans = 0;
	for (auto i : e) {
		if (rev[i.first].size() == 0 && g[i.second].size() == 0)
			ans++;
	}
	cout << ans << '\n' << 1;
}
