//#pragma GCC optimize("O3, Ofast, unroll-loops, inline, no-stack-protector")
#include <bits/stdc++.h>
//#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using pii = pair<int, int>;

vector<vector<int>> g;
vector<vector<int>> gr;
vector<int> used;
int ans = 0;

void dfs(int v, int p) {
    used[v] = 1;
    for (auto u : gr[v]) {
        if (u == p) continue;
        if (used[u] == 1) {
            ++ans;
            continue;
        }
    }
    for (auto u : g[v]) {
        if (!used[u]) dfs(u, v);
    }
    used[v] = 2;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, group;
    cin >> n >> m >> group;
    g.resize(n);
    gr.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        gr[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        std::sort(g[i].begin(), g[i].end());
    }
    used.resize(n);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) dfs(i, -1);
    }
    cout << ans << "\n" << 1 << "\n";
}
