#ifndef LOCAL
#pragma GCC optimize("O3")
#endif

#include <bits/extc++.h>

using namespace std;


using namespace __gnu_pbds;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
const ll nMax = 2000 + 228;
const ll mod = 1e9+7;
vector<int> g[nMax];
bitset<400> used;
void dfs (int v, int p){
    used[p*20+v]=true;
    for(auto u : g[v]){
        if(used[p*20+u])continue;
        dfs(u,p);
    }
};
bool bad[1 << 20];
void solve() {
    ll n,m,gg;
    cin >> n >> m >> gg;
    vector<pair<int,int>> edges;
    for(int i=0;i<m;i++){
        int u,v;
        cin >> u >> v;
        edges.push_back({u,v});
        g[u].push_back(v);
    }
    for(int i=1;i<=n;i++)
        dfs(i,i);
    for(int i =1;i<=n;i++){
        for(int j=1;j<=n;j++){
            int id1 = i*20+j;
            int id2 = j*20+i;
            used[id1]=used[id2] = (used[id1] & used[id2]);
        }
    }
    auto def = used;
    used.reset();

    for(int i=0; i < (1 << m); i++){
        for(int j=1;j<=n;j++)g[j].clear();
        for(int j=0;j<m;j++){
            if((i & (1<<j)) == 0)g[edges[j].first].push_back(edges[j].second);
            else g[edges[j].second].push_back(edges[j].first);
        }
        used.reset();
        for(int i=1;i<=n;i++)dfs(i,i);
        for(int i =1;i<=n;i++){
            for(int j=1;j<=n;j++){
                int id1 = i*20+j;
                int id2 = j*20+i;
                used[id1]=used[id2] = (used[id1] & used[id2]);
            }
        }
        if(used==def)bad[i]=true;
    }
    int maxo =0;
    for(int i =0;i<(1 << m); i++){
        int cnt =0;
        for(int j = i; j; j = (j-1) & i){
            if(bad[j])cnt++;
        }
        if(!cnt){
            maxo = max(maxo, __builtin_popcount(i));
        }
    }
    cout << maxo << ' ' << 0;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    int tt = 1;
    //cin >> tt;
    while (tt--)solve();
}