#pragma GCC optimize("03")
#include <iostream>
#include <set>
#include <vector>
#include <random>
#include <iomanip>
//#include <fstream>
#include <algorithm>
#include <map>
#include <unordered_set>
#include <unordered_map>
#pragma GCC target("avx2")
#define int long long
const int INF = 1e7;
const int N = 3e5 + 1;
using namespace std;
void dfs(vector<vector<int>>& g, vector<bool>& used, vector<int>& top, int u) {
    used[u] = true;
    for (auto v : g[u]) {
        if (used[v]) continue;
        dfs(g, used, top, v);
    }
    top.push_back(u);
}
void dfs2(vector<vector<int>>& g, vector<int>& color, int u, int col) {
    color[u] = col;
    for (auto v : g[u]) {
        if (color[v] != 0) continue;
        dfs2(g, color, v, col);
    }
}
signed main()
{
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, m, tp;
    cin >> n >> m >> tp;
    vector<vector<int>> g(n);
    vector<vector<int>> g2(n);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g2[v].push_back(u);
    }
    vector<bool> used(n);
    vector<int> top;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(g, used, top, i);
        }
    }
    reverse(top.begin(), top.end());
    vector<int> colors(n);
    int col = 1;
    for (auto i : top) {
        if (colors[i] == 0) {
            dfs2(g2, colors, i, col++);
        }
    }
    vector<pair<int, int>> sz_comp(col);
    for (int i = 0; i < n; i++) {
        sz_comp[colors[i]].first++;
        for (auto v : g[i]) {
            if (colors[v] == colors[i]) {
                sz_comp[colors[i]].second++;
            }
        }
    }
    int ans = 0;
    for (int i = 1; i < col; i++) {
        int cur = sz_comp[i].second - sz_comp[i].first + 1;
        cur = sz_comp[i].first - cur;
        cur = max(cur, 0ll);
        ans += cur;
    }
    cout << ans << "\n" << ans;
}