#pragma GCC optimize("O3, unroll-loops, no-stack-protector")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <string>
#define int long long

using namespace std;

const int INF = 2e15;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, m, q;
	cin >> n >> m >> q;
	vector <multiset <int>> g(n);
	vector <pair<int, int>> eds;
	for (int i = 0; i < m; i++) {
		int v, u;
		cin >> v >> u;
		v--;
		u--;
		g[v].insert(u);
		eds.push_back({ v, u });
	}
	vector <int> lrr, rrr;
	int currL = 0;
	for (int i = 0; i < n - 1; i++) {
		if (!g[i].count(i + 1)) {
			lrr.push_back(currL);
			rrr.push_back(i);
			currL = i + 1;
		}
	}
	lrr.push_back(currL);
	rrr.push_back(n - 1);
	int cnt = 0;
	for (auto el : eds) {
		if (el.second - el.first > 1) {
			int l = *(--upper_bound(lrr.begin(), lrr.end(), el.first));
			if (*lower_bound(rrr.begin(), rrr.end(), l) >= el.second) {
				cnt++;
			}
		}
	}
	cout << cnt << '\n' << 1 << '\n';
}
