#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include <windows.h>

#define f first
#define s second
#define pb push_back
#define pf push_front
#define in insert
#define nl '\n'
#define orderedSet tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC poison

typedef long double ld;
typedef int64_t int64;
typedef uint64_t uint64;
typedef uint32_t uint;

using namespace std;
using namespace __gnu_pbds;
mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define int int64

const int N = 2000 + 9, mod = 1e9 + 7;

bool was[N];
int n, m, g, col[N], dp[N];
vector <int> v[N], w[N], v2[N], w2[N], order;

void topSort(int x) {
    was[x] = 1;
    for (int u : v[x])
        if (!was[u])
            topSort(u);
    order.pb(x);
}

void topSort2(int x) {
    was[x] = 1;
    for (int u : v2[x])
        if (!was[u])
            topSort2(u);
    order.pb(x);
}

void dfs2(int x, int c) {
    col[x] = c;
    for (int u : w[x])
        if (col[u] == -1)
            dfs2(u, c);
}

main() {
    cin.tie(0); ios::sync_with_stdio(0); cout.tie(0);
    cin >> n >> m >> g;
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
             --x; --y;
        v[x].pb(y);
        w[y].pb(x);
    }
    topSort(0);
    reverse(order.begin(), order.end());
    fill(col, col + n, -1);
    int cntCol = 0;
    for (int i = 0; i < n; ++i)
        if (col[i] == -1)
            dfs2(i, cntCol++);

    for (int i = 0; i < n; ++i)
        for (int u : v[i])
            if (col[i] != col[u])
                v2[col[i]].pb(col[u]);

    order.clear();
    fill(was, was + n, 0);
    topSort2(0);
    reverse(order.begin(), order.end());

    int cnt = 0, ans = 1;
    for (int i = 0; i < cntCol; ++i) {
        fill(dp, dp + n, 0);
        dp[i] = 1;
        for (int j = i; j < cntCol; ++j)
            for (int u : v2[j])
                dp[u] = min(int(2), dp[u] + dp[j]);
        for (int u : v2[i])
            cnt += (dp[u] > 1);
    }

    for (int i = 0; i < n; ++i)
        v2[i].clear();
    for (int i = 0; i < n; ++i)
        for (int u : v[i])
            if (col[i] == col[u]) {
                v2[i].pb(u);
                w2[u].pb(i);
            }

    for (int i = 0; i < cntCol; ++i) {
        vector <int> g;
        for (int j = 0; j < n; ++j)
            if (col[j] == i)
                g.pb(j);
        if (g.size() == 1)
            continue;
        int cntt = 0;
        for (int u : g)
            cntt += v2[u].size();
        int cntOut = 0, cntIn = 0;
        for (int u : g) {
            cntOut += (v2[u].size() > 1) * v2[u].size();
            cntIn  += (w2[u].size() > 1) * w2[u].size();
        }
        if (cntOut == 0 && cntIn == 0) {
            cnt += cntt - 1;
            ans = ans * cntt % mod;
            continue;
        }
        cnt += cntt - min(cntOut, cntIn);
        if (cntOut == cntIn)
            ans = ans * 2 % mod;
    }

    cout << cnt << nl << ans;
}
