#include <bits/stdc++.h>

using ll = long long;

using namespace std;

#define int ll

int ans;

vector<vector<pair<int, int>>> g;
vector<int> cnt;
vector<int> used;
vector<pair<int, int>> edges;

vector<int> cur;

vector<int> nxt;

int dfs(int v) {
    int longest = 0;
    for (auto [u, i] : g[v]) {
        if (!used[i]) {
            int lol = dfs(u) + 1;
            if (longest < lol) {
                longest = lol;
                nxt[v] = i;
            }
        }
    }
    return longest;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int n, m, gr;
    cin >> n >> m >> gr;
    assert(gr == 3 || gr == 4);
    ans = m;
    g.resize(n);
    cnt.assign(n, 0);
    used.assign(m, 0);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        edges.push_back({v, u});
        g[v].push_back({u, i});
        cnt[u]++;
    }
    for (int i = 0; i < n; i++) {
        if (cnt[i] == 0) {
            nxt.assign(n, -1);
            dfs(i);
            int cur = i;
            while (nxt[cur] != -1) {
                used[nxt[cur]] = 1;
                cur = edges[nxt[cur]].second;
            }
        }
    }
    ans -= accumulate(used.begin(), used.end(), int(0));
    cout << ans << " " << 1;

    cout << "\n";
    return 0;
}