#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

bool dfs(int v, int dest, vector<vector<int>> & g) {
    if (v == dest) return true;
    for (auto i : g[v]) {
        if (i == v) continue;
        if (dfs(i, dest, g)) return true;
    }
    return false;
}

pair<int, int> get_for_groups(int n, int m, vector<vector<int>> & g) {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            int old = g[i][j];
            g[i][j] = i;
            if (dfs(i, old, g)) ++ans;
            g[i][j] = old;
        }
    }
    return {ans, 1};
}

vector<vector<int>> g;


void solve() {
    int n, m, G;
    cin >> n >> m >> G;
    g.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[--u].push_back(--v);
    }
    pair<int, int> ans = get_for_groups(n, m, g);
    cout << ans.first << " " << ans.second << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) solve();
}
