#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<int> reach;

void dfs(int v, vector<vector<int>>& g) {
    for (auto i : g[v]) {
        if (!reach[i]) {
            reach[i] = true;
            dfs(i, g);
        }
    }
}

bool check(int v, int dest, vector<vector<int>> & g) {
    reach.assign(g.size(), false);
    reach[v] = true;
    dfs(v, g);
    return reach[dest];
}

vector<vector<int>> g;


void solve() {
    int n, m, G;
    cin >> n >> m >> G;
    g.assign(n, {});
    vector<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[--u].push_back(--v);
        edges.push_back({u, v});
    }
    vector<vector<int>> connections(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (check(i, j, g) && check(j, i, g)) connections[i].push_back(j);
        }
    }
    int answer = m, cntt = 0;
    vector<bool> can((1 << m), false);
    for (int mask = 0; mask < (1 << m); ++mask) {
        if (mask == 19) {
            int qqq = 1;
        }
        vector<vector<int>> g1(n);
        for (int i = 0; i < m; ++i) {
            if (mask & (1 << i)) g1[edges[i].first].push_back(edges[i].second);
            else g1[edges[i].second].push_back(edges[i].first);
        }
        vector<vector<int>> connections1(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (check(i, j, g1) && check(j, i, g1)) connections1[i].push_back(j);
            }
        }
        if (connections == connections1) {
            can[mask] = true;
        }
    }
    can.back() = false;
    for (int mask = (1 << m) - 1; mask >= 0; --mask) {
        if (!can[mask]) {
            int cnt = 0;
            for (int i = 0; i < m; ++i) if (mask & (1 << i)) ++cnt;
            if (cnt < answer) {
                answer = cnt;
                cntt = 1;
            } else if (cnt == answer) {
                ++cntt;
            }
            continue;
        }
        for (int i = 0; i < m; ++i) {
            if (mask & (1 << i)) can[mask ^ (1 << i)] = true;
        }
    }
    cout << m - answer << " " << cntt << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) solve();
}
