#include <bits/stdc++.h>

#ifndef  WILEYNE

#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC target("avx2")

#endif

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
using ordered_set = __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;


using ll = long long;
using ld = long double;

using namespace std;

const int MAX_N = (int) 3e5 + 100;
const double eps = acos(-1);
const int INT_INF = (int) 2e9 + 10;
const int MOD = (int) 1e9 + 7;
auto seet = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rng(seet);

vector<int>graph[MAX_N];
vector<int>graphr[MAX_N];
vector<vector<int>>comp;
int n,m,g;
void build_graph(const vector<pair<int,int>>&e){
    for(int i = 1;i<=n;++i){
        graph[i].resize(0);
        graph[i].shrink_to_fit();
        graphr[i].resize(0);
        graphr[i].shrink_to_fit();
    }
    for(auto c:e){
        graph[c.first].push_back(c.second);
        graphr[c.second].push_back(c.first);
    }
}

bool used[MAX_N];
vector<int>ts;
void dfsts(int v){
    used[v] = true;
    for(auto c:graph[v]){
        if(!used[c]) dfsts(c);
    }
    ts.push_back(v);
}

void dfs2(int v,int col, vector<int>&res,vector<vector<int>>&v1){
    res[v] = col;
    v1[(int)v1.size()-1].push_back(v);
    for(auto c:graphr[v]){
        if(!res[c]){
            dfs2(c,col,res,v1);
        }
    }
}

vector<vector<int>>comp_calc(){
    vector<vector<int>>res;
    for(int i = 1;i<=n;++i){
        used[i] = false;
    }
    vector<int>coll(n+1);
    ts.resize(0);
    ts.shrink_to_fit();
    for(int i = 1;i<=n;++i){
        if(!used[i]){
            dfsts(i);
        }
    }
    reverse(ts.begin(),ts.end());
    int cnt = 1;
    for(int i = 0;i<n;++i){
        if(!coll[ts[i]]){
            res.push_back({});
            dfs2(ts[i],cnt++,coll,res);
            sort(res.back().begin(),res.back().end());
        }
    }
    sort(res.begin(),res.end());
    return res;
}

bool chech(vector<int>&inds, vector<pair<int,int>>&e){
    for(int i = 1;i<(1<<(int)inds.size());++i){
        for(int j = 0;j<(int)inds.size();++j){
            if(i&(1<<j)){
                swap(e[inds[j]].first,e[inds[j]].second);
            }
        }
        build_graph(e);
        vector<vector<int>>comp1 = comp_calc();
        bool f = comp == comp1;
        for(int j = 0;j<(int)inds.size();++j){
            if(i&(1<<j)){
                swap(e[inds[j]].first,e[inds[j]].second);
            }
        }
        if(f){
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef WILEYNE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin>>n>>m>>g;
    vector<pair<int,int>>e(m);
    for(auto &c:e){
        cin>>c.first>>c.second;
    }
    build_graph(e);
    comp = comp_calc();
    int ans = 0;
    int ans_cnt = 0;
    for(int i = 1;i<(1<<m);++i){
        int cnt = 0;
        vector<int>inds;
        for(int j = 0;j<m;++j){
            if(i&(1<<j)){
                inds.push_back(j);
            }
        }
        if(i == 27){
            cout<<"";
        }
        if(chech(inds,e)){
            if(ans<(int)inds.size()){
                ans = (int)inds.size();
                ans_cnt = 1;
            }
            else if(ans == (int)inds.size()){
                ans_cnt++;
            }
        }
    }
    cout<<ans<<"\n"<<ans_cnt;
    return 0;
}
