#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cstdint>
using namespace std;
#define int long long

void solution();

int32_t main() {
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solution();
    }
}

vector<vector<int>> gr;
pair<int, int> block;
vector<bool> used;

void dfs(int s) {
    used[s] = true;
    for (auto v : gr[s]) {
        if (used[v]) continue;
        if (s == block.first && v == block.second) continue;
        dfs(v);
    }
}

void solution() {
    int n, m, g;
    cin >> n >> m >> g;

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;

        gr[u].push_back(v);
    }

    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (auto v : gr[i]) {
            block = {i, v};
            used.assign(n, false);
            dfs(i);
            if (used[v]) cnt++;
        }
    }

    cout << cnt << " 1\n";
}