//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
//#pragma GCC target("avx2")
using namespace std;
using ll = int64_t;
constexpr ll N = 2e3 + 1, mod = 1e9 + 7;
vector<ll> g[N];

bool dfs(ll v, ll need) {
    if (v == need) {
        return true;
    }
    for (auto &u : g[v]) {
        if (dfs(u, need)) {
            return true;
        }
    }
    return false;
}

void solve() {
    ll n, m, G;
    cin >> n >> m >> G;

    for (ll i = 0, a, b; i < m; ++i) {
        cin >> a >> b;
        g[a].push_back(b);
    }

    ll cnt = 0;
    for (ll i = 1; i <= n; ++i) {
        for (auto &u : g[i]) {
            for (auto &e : g[i]) {
                if (e == u) {
                    continue;
                }
                if (dfs(e, u)) {
                    ++cnt;
                    break;
                }
            }
        }
    }
    cout << cnt << '\n' << 1 << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
//    cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}

