#include <bits/stdc++.h>
using namespace std;
#define int long long
const int maxn = 2e3 + 1;
int n, m, g52;
unordered_set<int> g[maxn], t[maxn];
pair<int, int> edges[maxn];
bool used[maxn];
vector<int> g1[maxn];
vector<int> order;

void topsort(int v) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u]) continue;
        topsort(u);
    }
    order.push_back(v);
}

int cmp[maxn], clr = 0;

void color(int v) {
    cmp[v] = clr;
    for (auto u : t[v]) {
        if (cmp[u] != -1) continue;
        color(u);
    }
}

int recalccss() {
    fill(cmp, cmp + n, -1);
    fill(used, used + n, 0);
    order.clear();
    clr = 0;
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        topsort(i);
    }
    reverse(order.begin(), order.end());
    for (auto v : order) {
        if (cmp[v] != -1) continue;
        color(v);
        clr++;
    }
    return clr;
}

void recmp(int v) {
    used[v] = 1;
    for (auto u : g1[v]) {
        if (used[u]) continue;
        recmp(u);
    }
}

void solve() {
    cin >> n >> m >> g52;
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y; x--, y--;
        g[x].insert(y);
        t[y].insert(x);
        edges[i] = {x, y};
    }
    int cmp0 = recalccss();
    vector<int> nwed;
    for (int i = 0; i < m; i++) {
        auto [x, y] = edges[i];
        g[x].erase(y);
        g[y].insert(x);
        t[y].erase(x);
        t[x].insert(y);
        int cmp1 = recalccss();
        if (cmp0 != cmp1) {
            nwed.push_back(i);
        }
        g[x].insert(y);
        g[y].erase(x);
        t[y].insert(x);
        t[x].erase(y);
    }
    for (auto i : nwed) {
        auto [x, y] = edges[i];
        g[x].erase(y);
        t[y].erase(x);
        //cout << x << ' ' << y << '\n';
    }
    //cout << "OK\n";
    int cmp2 = recalccss();
    for (auto b : nwed) {
        auto [i, u] = edges[b];
        g1[cmp[i]].push_back(cmp[u]);
        g1[cmp[u]].push_back(cmp[i]);
    }
    /*for (int i = 0; i < cmp2; i++) {
        cout << i << ": ";
        for (auto u : g1[i]) {
            cout << u << ' ';
        }
        cout << '\n';
    }*/
    fill(used, used + cmp2, 0);
    int cmpsz = 0;
    for (int i = 0; i < cmp2; i++) {
        if (used[i]) continue;
        recmp(i);
        cmpsz++;
    }
    //cout << cmp2 << ' ' << cmpsz << '\n';
    cout << cmp2 - cmpsz << ' ' << 1 << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    while (tests--) solve();
}
