#include <bits/stdc++.h>

using namespace std;
using ll = long long;
vector<pair<int, int>> edges;
int n, m;

vector<vector<int>> getcmp(int mask) {
    vector<int> g[21];
    vector<int> gr[21];
    for (int i = 0; i < edges.size(); ++i) {
        auto [u, v] = edges[i];
        if (mask >> i & 1) {
            g[v].push_back(u);
            gr[u].push_back(v);
        } else {
            g[u].push_back(v);
            gr[v].push_back(u);
        }
    }
    vector<int> used(21), tops;
    function<void(int)> dfs_for_tops = [&](int u) {
        used[u] = 1;
        for (auto v: g[u]) {
            if (used[v]) continue;
            dfs_for_tops(v);
        }
        tops.push_back(u);
    };
    for (int i = 1; i <= n; ++i) {
        if (!used[i])
            dfs_for_tops(i);
    }

    reverse(tops.begin(), tops.end());
    vector<vector<int>> cmp;
    used.assign(n + 1, 0);
    function<void(int)> dfsforcomp = [&](int u) {
        used[u] = 1;
        cmp.back().push_back(u);
        for (auto v: g[u]) {
            if (used[v]) continue;
            dfsforcomp(v);
        }
    };
    for (auto u: tops) {
        if (!used[u]) {
            cmp.emplace_back();
            dfsforcomp(u);
        }
    }
    sort(cmp.begin(), cmp.end());
    return cmp;
}

template<typename T>
void print(vector<T> ff) {
    for (auto dd: ff) cout << dd << ' ';
    cout << '\n';
}

void solve() {
    int gg;
    cin >> n >> m >> gg;
    const int maxn = 21;
    edges.resize(m);
    for (auto &[u, v]: edges) cin >> u >> v;
    auto eta = getcmp(0);
    vector<int> proh(1 << m);
    for (int mask = 1; mask < 1 << m; ++mask) {
        auto tmp = getcmp(mask);
        if (tmp == eta) proh[mask] = 1;
    }
    for (int mask = 0; mask < 1 << m; mask++) {
        for (int submask = mask; submask > 0; submask = (submask - 1) & mask) {
            proh[mask] |= proh[submask];
            if (proh[mask]) break;
        }
    }
    int ans = 0, cnt = 0;
    for (int i = 0; i < 1 << m; ++i) {
        if (!proh[i]) {
            int x = __popcount(i);
            if (x == ans) cnt++;
            if (x > ans) cnt = 1, ans = x;
        }
    }
    cout << ans << "\n" << cnt << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
