#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int ll

vector<vector<int>> g;
vector<vector<int>> rg;
int n, m, T;

void ts_dfs(int v, vector<int> &used, vector<int> &ts, vector<vector<int>> &g) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (!used[u]) {
            ts_dfs(u, used, ts, g);
        }
    }
    ts.push_back(v);
}

vector<int> tsort(vector<vector<int>> &g) {
    vector<int> res; 
    vector<int> used(n + 1);
    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            ts_dfs(i, used, res, g);
        }
    }
    reverse(res.begin(), res.end());
    return res;
}

vector<int> color;
int tc = 1;
int ud = 0, cnt = 0;

void f_kss(int v, vector<vector<int>> &g) {
    color[v] = tc;
    for (auto u : g[v]) {
        if (!color[u]) {
            f_kss(u, g);
        }
    }
}


void solve() {
    cin >> n >> m >> T;
    g.resize(n + 1);
    rg.resize(n + 1);
    color.resize(n + 1);
    cnt = 1;
    for (int i = 0, a, b; i < m; i++) {
        cin >> a >> b;
        g[a].emplace_back(b);
        if (a != b - 1)
            ud++;
        rg[b].emplace_back(a);
    }
    auto ts = tsort(g);
    for (auto v : ts) {
        if (!color[v]) {
            f_kss(v, rg);
            tc++;
        }
    }
    cout << 1 << "\n" << n;
    /*
    for (int i = 1; i <= n; i++)
        cout << color[i] << " ";
        */
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--)
        solve();
}