#pragma GCC optimize("Ofast,inline")

#include <bits/stdc++.h>

using namespace std;

//#define int int64_t
#define fi first
#define se second
mt19937 gen(time(0));

const int N = 21;
vector <int> g[N];

bool used[N];
bool check(int v, int u) {
    fill(used, used + N, 0);
    used[v] = 1;
    queue <int> q;
    q.push(v);
    while(q.size() && !used[u]) {
        int v = q.front();
        q.pop();
        for(auto to : g[v]) {
            if(!used[to]) {
                used[to] = 1;
                q.push(to);
            }
        }
    }
    return used[u];
}

bool base[N][N];

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, G2;
    cin >> n >> m >> G2;
    vector <pair<int,int>> edge;
    for(int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        edge.push_back({v, u});
        g[v].push_back(u);
    }
    for(int v = 1; v <= n; ++v) {
        for(int u = 1; u <= n; ++i) {
            base[v][u] = check(v, u);
        }
    }
    int ans1 = 0, ans2 = 0;
    for(int mask = 0; mask < (1 << m); ++mask) {
        vector <pair<int,int>> e1;
        vector <pair<int,int>> no;
        for(int i = 0; i < m; ++i) {
            if(mask & (1 << i)) {
                e1.push_back(edge[i]);
            } else {
                no.push_back(edge[i]);
            }
        }
        for(int i = 1; i <= n; ++i) {
            g[i].clear();
        }
        for(auto [v, u] : e1) {
            g[v].push_back(u);
        }
        int cnt = 0;
        for(int msk = 0; msk < (1 << int(no.size())); ++msk) {
            for(int i = 0; i < no.size(); ++i) {
                if(msk & (1 << i)) 
                    g[no[i].first].push_back(no[i].second);
            }
            bool ok = 1;
            for(int v = 1; v <= n; ++v) {
                for(int u = 1; u <= n; ++i) {
                    if(check(v, u) != base[v][u]) {
                        ok = 0;
                        break;
                    }
                }
                if(!ok)
                    break;
            }
            if(ok)
                cnt++;
            if(cnt > 1)
                break;
            for(int i = 0; i < no.size(); ++i) {
                if(msk & (1 << i)) 
                    g[no[i].first].pop_back();
            }
        }
        if(cnt == 1) {
            int cur = m - edge.size();
            if(cur > ans1) {
                ans1 = cur;
                ans2 = 1;
            } else if(ans1 == cur) {
                ans2++;
            }
        }
    }
    cout << ans1 << ' ' << ans2;
    return 0;
}
