#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <math.h>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) x.begin(),x.end()
//#pragma GCC optimize("Ofast")
const ll INF = 1e9 + 7;
template<typename T>
void input(vector<T>& arr, size_t size) {
	arr.resize(size);
	for (T& i : arr) {
		cin >> i;
	}
}
template<typename T>
void print(vector<T>& arr) {
	for (T& i : arr) {
		cout << i << ' ';
	}
	cout << '\n';
}

vector<vector<int>> g,gr;
vector<int> tp, used;
int tr = 1;
void top(int u) {
	used[u] = tr;
	for (auto i : g[u]) {
		if (used[i] < tr) {
			top(i);
		}
	}
	tp.push_back(u);
}
void dfs(int u, vector<int>& c, int val) {
	c[u] = val;
	for (auto i : gr[u]) {
		if (!c[i]) {
			dfs(i, c, val);
		}
	}
}


void con(vector<int>& c) {
	fill(all(c), 0);
	tp.clear();
	fill(all(used), 0);
	int n = c.size(), val = 1;
	for (size_t i = 0; i < n; i++)
	{
		if (!used[i]) {
			top(i);
		}
	}
	reverse(all(tp));
	for (auto i : tp)
	{
		if (c[i])continue;
		dfs(i, c, val++);
	}
}
void check(int u, pair<int, int> d) {
	used[u] = 1;
	for (auto i : g[u]) {
		if (u == d.first and i == d.second) {
			continue;
		}
		if (used[i]) {
			continue;
		}
		check(i, d);
	}
}


void solve() {
	int n, m, gp;
	cin >> n >> m >> gp;
	g.resize(n);
	gr.resize(n);
	used.resize(n);
	vector<pair<int, int>> e;
	vector<int> c(n),p(n);
	for (size_t i = 0; i < m; i++)
	{
		int a, b;
		cin >> a >> b;
		--a; --b;
		e.push_back({ a,b });
		g[a].push_back(b);
		gr[b].push_back(a);
	}
	vector<int> pt(m,0);
	int sum = 0;
	for (size_t i = 0; i < m; i++)
	{
		fill(all(used), 0);
		check(e[i].first, e[i]);
		pt[i] = used[e[i].second];
		sum += pt[i];
	}
	cout << sum << " 1";
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif // _DEBUG
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif // _DEBUG
	while (tt--)
	{
		solve();
#ifdef _DEBUG
		cout << "\n================\n";
#endif // _DEBUG
	}
}