#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>
#include <queue>

#define len(v) (int)((v).size())
#define ss second
#define ff first


typedef long long ll;

using namespace std;

const ll inf = 1e12 + 7;

const int N = 2005;
vector<int> g[N];

const int M = 1e9 + 7;

void solve() {
	int n, m, gr;
	cin >> n >> m >> gr;

	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		g[--x].push_back(--y);
	}

	int res = 0;
	vector<vector<int>> dp(n, vector<int>(n, 0));
	for (int v = n - 1; v >= 0; --v) {
		for (int u : g[v]) {
			for (int j = u; j < n; ++j) {
				dp[v][j] = (dp[v][j] + dp[u][j]) % M;
			}
		}

		for (int u : g[v]) {
			if (dp[v][u] > 1) {
				++res;
			}
		}
	}
	cout << res << '\n';
	cout << 1 << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);

	int t = 1;
	//	cin >> t;
	while (t--) solve();
}



