#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifndef DEBUG
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#endif

using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using pll = std::pair<ll, ll>;
using ld = long double;
using i128 = __int128;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

std::vector<std::vector<ll>> G;
std::vector<ll> ord, used;
ll cntcmp = 0;

void dfs(ll v, bool flg = false){
    used[v] = 1;
    for(auto u : G[v]){
        if (!used[u]){
            dfs(u);
        }
    }
    if (!flg){
        ord.push_back(v);
    }
}

void solve() {
    ll n, m, g;
    std::cin >> n >> m >> g;
    G.resize(n);
    used.resize(n);
    for (int i = 0; i < m; ++i) {
        ll v, u;
        std::cin >> v >> u;
        --v, --u;
        G[v].push_back(u);
        G[u].push_back(v);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]){
            dfs(i);
        }
    }
    std::reverse(ord.begin(), ord.end());
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[ord[i]]){
            ++cntcmp;
            dfs(ord[i], 1);
        }
    }
    std::cout << m - (n - cntcmp) <<'\n'<<1;
}

int main() {
#ifdef DEBUG
    std::freopen("/home/olymp/CLionProjects/untitled/input.txt", "r", stdin);
#endif
    std::cin.tie(0)->std::ios::sync_with_stdio(0);
    int tt = 1;
//    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
