#include <iostream>
#include <vector>
#include <math.h>
#include <map>
#include <algorithm>
#include <set>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <string>

typedef long long ll;
typedef long double ld;

using namespace std;

ll const MAXN = 2e3 + 1;
ll const A = 367;
ll const B = 1e9 + 7;
ll o = 0;
ll rex[MAXN];
vector <vector<ll>> point(MAXN);
vector <pair<ll, ll>> some;


ll logpow(ll num, ll deb) {
	ll sum = 1;
	while (deb != 0) {
		if (deb % 2 == 0) {
			num *= num;
			deb /= 2;
		}
		else {
			sum *= num;
			deb--;
		}
	}
	return sum;
}

void dfs(ll v, ll st, ll st2) {
	rex[v] = 1;
	for (ll i = 0; i < point[v].size(); i++) {
		if (rex[point[v][i]] == 0 && (v!=st|| point[v][i]!=st2) && point[v][i]!=0) {
			dfs(point[v][i], st, st2);
		}
	}
}


void solve() {
	ll ans = 0;
	ll n, m, g;
	cin >> n >> m >> g;
	for (ll i = 1; i <= m; i++) {
		ll a, b;
		cin >> a >> b;
		point[a].emplace_back(b);
		some.emplace_back(make_pair(a, b));
	}
	for (ll i = 0; i < some.size(); i++) {
		for (ll h = 0; h < MAXN; h++) {
			rex[h] = 0;
		}
		dfs(i, some[i].first, some[i].second);
		if (rex[some[i].second] == 0) {
			ans++;
			point[some[i].second].emplace_back(some[i].first);
			for (ll h = 0; h < point[some[i].first].size(); h++) {
				if (point[some[i].first][h] == some[i].second) {
					point[some[i].first][h] = 0;
				}
			}
		}
	}
	cout << ans << endl << 1 << endl;
}

int main()
{
	ll t = 1;
	//cin>> t;
	while (t--) {
		solve();
	}
}
