#include <bits/stdc++.h>
using namespace std;

using ll = long long;

int main() {
    int n, m, g;
    cin >> n >> m >> g;

    vector<vector<int>> gr(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;

        gr[v].push_back(u);
    }

    vector<bitset<2000>> reachable(n);
    int cnt = 0;
    for (int v = n - 1; v >= 0; v--) {
        for (int u : gr[v]) {
            reachable[v] |= reachable[u];
        }
        for (int u : gr[v]) {
            if (reachable[v][u]) {
                cnt++;
            } else {
                reachable[v][u] = true;
            }
        }
    }

    cout << cnt << '\n';
    cout << 1 << '\n';
}