#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<long long> pr_sum(n + 1);
    for (int i = 0; i < n; ++i) {
        pr_sum[i + 1] = pr_sum[i] + a[i];
    }
    vector<int> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        b[i]--;
    }
    int ans = 0;
    int pos = 0;
    for (int i = 0; i < n; ++i) {
        while (pos < m && b[pos] < i) {
            pos++;
        }
        if (pos < m) {
            long long d = pr_sum[b[pos] + 1] - pr_sum[i + 1];
            if (d <= t) {
                ans = max((long long)ans, b[pos] - i + (t - d) / a[i]);
            }
        }
        if (pos > 0) {
            long long d = pr_sum[i] - pr_sum[b[pos - 1]];
            if (d <= t) {
                ans = max((long long)ans, i - b[pos - 1] + (t - d) / a[i]);
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
