#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const long long inf = 1e9;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    int n, m, T;
    cin >> n >> m >> T;

    vector<long long> a(n + 1), pref(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }

    set<int> pos;
    vector<int> dist(n + 1, inf);
    for (int i = 0; i < m; ++i) {
        int v; cin >> v;
        pos.insert(v);
        dist[v] = 0;
    }

    long long ans = 0;
    for (int i = 1; i <= n; ++i) {
        if (dist[i] == 0) {
            ans = max(ans, T / a[i]);
        } else {
            {
                auto it = pos.lower_bound(i);
                if (it != pos.begin()) {
                    --it;
                    int p = *it;

                    long long need = pref[i - 1] - pref[p - 1];
                    if (need <= T) {
                        ans = max(ans, i - p + (T - need) / a[i]);
                    }
                }
            }

            {
                auto it = pos.upper_bound(i);
                if (it != pos.end()) {
                    int p = *it;

                    long long need = pref[p] - pref[i];
                    if (need <= T) {
                        ans = max(ans, p - i + (T - need) / a[i]);
                    }
                }
            }
        }
    }

    cout << ans << "\n";

    return 0;
}
