#include<bits/stdc++.h>
#define int long long
using namespace std;

void solve() {
    int n, m, t, ans = 0;
    cin >> n >> m >> t;
    vector<int> a(n + 1), b(n + 1), c1(n + 1, 1), c2(n + 1, n), pref(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    for (int i = 1; i <= m; i++) {
        int x;
        cin >> x;
        b[x] = 1;
    }
    deque<int> dq;
    dq.push_back(1);
    for (int i = 2; i <= n; i++) {
        while (!dq.empty()) {
            int j = dq.back();
            int res = i - j, t1 = pref[i] - pref[j];
            res += (t - t1) / a[j];
            if (t1 > t || res < t / a[i]) {
                dq.pop_back();
            }
            else {
                break;
            }
        }
        while (!dq.empty()) {
            int j = dq.front();
            if (pref[i] - pref[j] > t) dq.pop_front();
            else {
                break;
            }
        }
        dq.push_back(i);
        c1[i] = dq.front();
    }
    dq.clear();
    dq.push_back(n);
    for (int i = n - 1; i >= 1; i--) {
        while (!dq.empty()) {
            int j = dq.back();
            int res = j - i, t1 = pref[j - 1] - pref[i - 1];
            res += (t - t1) / a[j];
            if (t1 > t || res < t / a[i]) {
                dq.pop_back();
            }
            else {
                break;
            }
        }
        while (!dq.empty()) {
            int j = dq.front();
            if (pref[j - 1] - pref[i - 1] > t) dq.pop_front();
            else {
                break;
            }
        }
        dq.push_back(i);
        c2[i] = dq.front();
    }
    for (int i = 1; i <= n; i++) {
        if (!b[i]) continue;
        int res1 = i - c1[i], t1 = pref[i] - pref[c1[i]];
        res1 += (t - t1) / a[c1[i]];
        int res2 = c2[i] - i, t2 = pref[c2[i] - 1] - pref[i - 1];
        res2 += (t - t2) / a[c2[i]];
        ans = max({ans, res1, res2});
    }
    cout << ans;
}
int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    solve();
}
