//
// created by Vadim in 12/34/56
//

#include <bits/stdc++.h>
using ll = long long;

using namespace std;

void solve() {
    ll n, m, t; cin >> n >> m >> t;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> pos(n, -1);
    vector<int> wh(m);
    for (int i = 0; i < m; ++i) {
        int p; cin >> p;
        pos[p - 1] = i;
        wh[i] = p - 1;
    }
    vector<ll> pref(n + 1), post(n + 1);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i - 1];
        post[n - i] = post[n - i + 1] + a[n - i];
    }
    int cur = -1;
    for (int i = 0; i < n; i++) {
        if (pos[i] > -1) cur = pos[i];
        pos[i] = cur;
    }
    cur = -1;
    for (int i = n - 1; i >= 0; i--) {
        if (pos[i] > -1) {
            if (cur > -1) {
                if (pref[i] - pref[wh[pos[i]]] <= post[i + 1] - post[wh[cur] + 1]) {
                    cur = pos[i];
                }
            }
            else {
                cur = pos[i];
            }
        }
        pos[i] = cur;
    }
    ll ans = 0;
    for (int i = 0; i < n; i++) {
        ll dist, rd;
        if (i < wh[pos[i]]) {
            dist = post[i + 1] - post[wh[pos[i]] + 1];
            rd = wh[pos[i]] - i;
        }
        else {
            dist = pref[i] - pref[wh[pos[i]]];
            rd = i - wh[pos[i]];
        }
        if (t - dist >= 0) {
            ans = max(ans, (t - dist) / a[i] + rd);
        }
    }
    cout << ans;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
