#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

// #define FILE
#define int long long



signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, T;
    cin >> n >> m >> T;
    vector<int> a(n), b(m);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        b[i]--;
    }
    vector<int> otv(n, 0);
    vector<int> left(n), right(n);
    vector<int> st;
    vector<int> pref(n + 1);
    for (int i = 1; i <= n; ++i) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.back()] >= a[i]) {
            st.pop_back();
        }
        if (st.empty()) {
            left[i] = -1;
        } else {
            left[i] = st.back();
        }
        int l = -1, r = st.size();
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int j = st[mid];
            int sum = pref[i + 1] - pref[j + 1];
            if (sum <= T) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (r != st.size()) {
            int j = st[r];
            int sum = pref[i + 1] - pref[j + 1];
            otv[i] = max(otv[i], i - j + (T - sum) / a[j]);
        }
        st.push_back(i);
    }
    while (!st.empty()) st.pop_back();
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && a[st.back()] >= a[i]) {
            st.pop_back();
        }
        if (st.empty()) {
            right[i] = n;
        } else {
            right[i] = st.back();
        }
        int l = -1, r = st.size();
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int j = st[mid];
            int sum = pref[j] - pref[i];
            if (sum <= T) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (l != -1) {
            int j = st[l];
            int sum = pref[j] - pref[i];
            otv[i] = max(otv[i], j - i + (T - sum) / a[j]);
        }
        st.push_back(i);
    }
    /* for (auto x : otv) {
        cout << x << " ";
    }
    cout << endl; */
    int ans = 0;
    for (auto i : b) {
        ans = max(ans, T / a[i]);
        ans = max(ans, otv[i]);
    }
    cout << ans;
}