// Created by rost on 08.03.25.

#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#endif

    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n), b(m);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        --b[i];
    }

    vector<ll> prefSum(n + 1);
    for (int i = 0; i < n; ++i)
        prefSum[i + 1] = prefSum[i] + a[i];

    ll res = 0;
    for (int i = 0; i < n; ++i) {
        auto it = lower_bound(b.begin(), b.end(), i);

        if (it != b.end()) {
            int j = *it;
            if (prefSum[j + 1] - prefSum[i + 1] <= t)
                res = max(res, j - i + (t - (prefSum[j + 1] - prefSum[i + 1])) / a[i]);
        }
        if (it != b.begin() && (it == b.end() || *it != i)) {
            int j = *(it - 1);
            if (prefSum[i] - prefSum[j] <= t)
                res = max(res, i - j + (t - (prefSum[i] - prefSum[j])) / a[i]);
        }
    }
    cout << res << '\n';
}