#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
using ld = long double;

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

	int n, m, T;
	cin >> n >> m >> T;
	vector<int> a(n);
	vector<ll> pref(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		pref[i] = a[i];
		if (i > 0) {
			pref[i] += pref[i - 1];
		}
	}
	vector<int> b(m);
	for (int i = 0; i < m; ++i) {
		cin >> b[i]; b[i]--;
	}
	auto get_sum = [&](int l, int r) -> ll {
		return pref[r] - (l == 0 ? 0 : pref[l - 1]);
	};
	ll res = 0;
	for (int i = 0; i < n; ++i) {
		if (b[0] <= i) {
			int l = 0, r = m;
			while (l + 1 < r) {
				int mid = (l + r) >> 1;
				if (b[mid] <= i) {
					l = mid;
				} else {
					r = mid;
				}
			}
			if (get_sum(b[l], i) <= T) {
				res = std::max(res, (i - b[l] + 1) + (T - get_sum(b[l], i)) / a[i]);
			}
		}
		if (i <= b[m - 1]) {
			int l = -1, r = m - 1;
			while (l + 1 < r) {
				int mid = (l + r) >> 1;
				if (i <= b[mid]) {
					r = mid;
				} else {
					l = mid;
				}
			}
			if (get_sum(i, b[r]) <= T) {
				res = std::max(res, (b[r] - i + 1) + (T - get_sum(i, b[r])) / a[i]);
			}
		}
	}
	cout << res;
}
