#include <bits/stdc++.h>

using namespace std;

#define ll long long
//#define ld long double
//#define ull unsigned long long
//#define sll __int128
#define size(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
//#define int long long

mt19937 rnd(time(0));

ll INF = 1e18;
int mod = 1e9 + 7;

int kv(int x) {
    return ((ll)x * x) % mod;
}

int mult(int a, int b){
    return ((ll)a * b) % mod;
}

int fast_pow(int x, int a){
    if (a == 0) return 1;
    if (a == 1) return x;
    if (a & 1) return mult(x, fast_pow(x, a - 1));
    return kv(fast_pow(x, a / 2));
}



void gsrt(int v, vector<bool> &used, vector<vector<int>> &g, vector<int> &ord){
    used[v] = true;
    for (auto to : g[v]){
        if (!used[to]) gsrt(to, used, g, ord);
    }
    ord.push_back(v);
}

void recol(int v, vector<bool> &used, int &cl, vector<vector<int>> &g){
    cl ^= (1 << v);
    used[v] = true;
    for (auto to : g[v]){
        if (used[to]) continue;
        recol(to, used, cl, g);
    }
}

void solve(){
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n);
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; i++){
        int x; cin >> x; a[i] = x;
        pref[i + 1] = pref[i] + x;
    }
    set<int> st;
    for (int i = 0; i < m; i++){
        int x; cin >> x; x--;
        st.insert(x);
    }
    //cout << 434 << endl;
    ll ans = 0;
    for (int j = 0; j < n; j++){
        auto it = st.lower_bound(j);
        int pr = -1, nxt = -1;
        if (it != st.end()){
            nxt = *it;
        }
        if (it != st.begin()){
            pr = *(--it);
        }
        if (nxt != -1 && pref[nxt + 1] - pref[j + 1] <= t){
            ans = max(ans, nxt - j + (t - (pref[nxt + 1] - pref[j + 1])) / a[j]);
        }
        if (pr != -1 && pref[j] - pref[pr] <= t){
            ans = max(ans, j - pr + (t - (pref[j] - pref[pr])) / a[j]);
        }
    }
    cout << ans;
}

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while (ttt--){
        solve();
    }
}
