#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <bits/stdc++.h>

using ll = long long;
using ld = long double;

#define int ll
#define pii pair<int, int>
#define all(obj) obj.begin(), obj.end()
#define rall(obj) obj.rbegin(), obj.rend()
#define pb push_back

const int inf = 1e9;
const int INF = 1e18;

using namespace std;

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int n, m, t;
    cin >> n >> m >> t;
    vector<int>a(n);
    for (int i=0; i<n; i++) {
        cin >> a[i];
    }
    vector<int>b(m);
    for (int i=0; i<m; i++) {
        cin >> b[i];
        b[i]--;
    }

    vector<int>pref(n+1);
    pref[0] = 0;
    for (int i=1; i<=n; i++) {
        pref[i] = pref[i-1] + a[i-1];
    }

    vector<int>ans(b.size());
    for (int i=0; i<n; i++) {
        int cl = lower_bound(all(b), i) - b.begin() - 1;
        int cr = cl + 1;

        int l;
        if (cl >= 0) l = b[cl];
        int r;
        if (cr < m) r = b[cr];

        int cur, ost;

        if (cl >= 0) {
            cur = 0;
            ost = t - (pref[i+1] - pref[l]);
            if (ost >= 0) {
                cur = (i-l+1) + ost / a[i];
            }
            ans[cl] = max(ans[cl], cur);
        }

        if (cr < m) {
            cur = 0;
            ost = t - (pref[r+1] - pref[i]);
            if (ost >= 0) {
                cur = (r-i+1) + ost / a[i];
            }
            ans[cr] = max(ans[cr], cur);
        }
    }

    int vv = 0;
    for (int i=0; i<m; i++) {
        vv = max(vv, ans[i]);
    }
    cout << vv;
}