#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()

using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

void solve() {
    ll n, m, T;
    cin >> n >> m >> T;
    vector<ll> a(n), b(n);
    for (ll &i: a)
        cin >> i;
    while (m--) {
        ll x;
        cin >> x;
        b[x - 1] = 1;
    }
    ll ans = 0;
    vector<ll> pr(n);
    for (ll i = 0; i < n; i++) {
        pr[i] = a[i];
        if (i)
            pr[i] += a[i - 1];
        if (b[i]) {
            if (pr[i] <= T) {
                ans = max(ans, (T - pr[i]) / a[0] + i + 1);
                continue;
            }
            ll l = 0, r = i;
            while (r - l > 1) {
                ll mid = (r + l) / 2;
                if (pr[i] - pr[mid] <= T)
                    r = mid;
                else
                    l = mid;
            }
            ans = max(ans, (T - pr[i] + pr[r]) / a[r] + (i - r));
        }
    }
    cout << ans << '\n';
}