#ifndef LOCAL
#include <bits/allocator.h>
#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#else
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using i128 = __int128_t;

#define all(x) (x).begin(), (x).end()

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    int best = 0;
    vector<int> arr(n);
    for (int &x : arr) cin >> x;
    vector<int> positions(m);
    for (int i = 0; i < m; ++i) {
        int j;
        cin >> j;
        --j;
        positions[i] = j;
    }
    for (int i = 0; i < m; ++i) {
        int left_bound = i == 0 ? 0 : positions[i - 1] + 1;
        int right_bound = i == m - 1 ? n - 1 : positions[i + 1] - 1;
        ll curr_time = 0, curr_ran = 0;
        for (int j = positions[i]; j >= left_bound; --j) {
            curr_time += arr[j];
            curr_ran++;
            if (curr_time > t)
                break;
            best = max<int>(best, curr_ran + (t - curr_time) / arr[j]);
        }
        curr_time = 0, curr_ran = 0;
        for (int j = positions[i]; j <= right_bound; ++j) {
            curr_time += arr[j];
            curr_ran++;
            if (curr_time > t)
                break;
            best = max<int>(best, curr_ran + (t - curr_time) / arr[j]);
        }
    }
    cout << best << "\n";
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}