#include <bits/stdc++.h>
#define pb push_back
#define int long long

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, T;
    cin >> n >> m >> T;

    vi a(n), b(m);

    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < m; ++i) cin >> b[i];
    for (int i = 0; i < m; ++i) --b[i];

    vi pref(n + 1);
    for (int i = 1; i <= n; ++i) pref[i] = pref[i - 1] + a[i - 1];

    int ans = 0;

    for (int p = 0; p < m; ++p) {
        int cur = b[p];
        for (int i = 0; i <= cur; ++i) {
            int curSpent = pref[cur + 1] - pref[i + 1];
            int curAns = cur - i;
            if (curSpent > T) continue;

            int rest = T - curSpent;
            curAns += rest / a[i];

            ans = max(ans, curAns);
        }

        for (int i = cur + 1; i < n; ++i) {
            int curSpent = pref[i] - pref[cur];
            int curAns = i - cur;
            if (curSpent > T) continue;

            int rest = T - curSpent;
            curAns += rest / a[i];

            ans = max(ans, curAns);
        }
    }
    
    cout << ans;
}