#include <bits/stdc++.h>
#define pb push_back
#define int long long

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

int n, m, T;

vi a, b, pref, pl;

int get(int i, int j) {
    int ans = 0;
    if (i >= j) {
        int curSpent = pref[i + 1] - pref[j + 1];
        int curAns = i - j;
        if (curSpent > T) return -100;
        int rest = T - curSpent;
        curAns += rest / a[j];
        ans = max(ans, curAns);
    } else {
        int curSpent = pref[j] - pref[i];
        int curAns = j - i;
        if (curSpent > T) return -100;

        int rest = T - curSpent;
        curAns += rest / a[j];

        ans = max(ans, curAns);
    }

    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    
    cin >> n >> m >> T;

    a.resize(n);
    b.resize(m);
    pref.resize(n + 1);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < m; ++i) cin >> b[i];
    for (int i = 0; i < m; ++i) --b[i];

    for (int i = 1; i <= n; ++i) pref[i] = pref[i - 1] + a[i - 1];

    pl.resize(n);
    for (int i = 0; i < m; ++i) pl[b[i]] = 1;

    int ans = 0;

    vi st;

    int pos = 0;

    for (int i = 0; i < n; ++i) {
        while (!st.empty()) {
            int v = st.back();
            if (a[v] < a[i]) break;
            st.pop_back();
        }

        st.pb(i);

        pos = min(pos, (int)st.size() - 1);

        int curAns = 0;

        int sz = st.size();

        while (pos < sz - 1) {
            if (get(i, st[pos]) >= get(i, st[pos + 1])) break;
            else ++pos;
        }

        curAns = get(i, st[pos]);

        if (pl[i]) ans = max(ans, curAns);
    }

    st.clear();
    pos = 0;

    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty()) {
            int v = st.back();
            if (a[v] < a[i]) break;
            st.pop_back();
        }

        st.pb(i);

        pos = min(pos, (int)st.size() - 1);

        int curAns = 0;

        int sz = st.size();

        while (pos < sz - 1) {
            if (get(i, st[pos]) >= get(i, st[pos + 1])) break;
            else ++pos;
        }

        curAns = get(i, st[pos]);

        if (pl[i]) ans = max(ans, curAns);
    }
    
    cout << ans;
}