#include <bits/stdc++.h>
#define pb push_back
#define int long long

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

int n, m, T;

vi a, b, pref, pl;

int get(int i, int j) {
    int ans = 0;
    if (i >= j) {
        int curSpent = pref[i + 1] - pref[j + 1];
        int curAns = i - j;
        if (curSpent > T) return -100;
        int rest = T - curSpent;
        curAns += rest / a[j];
        ans = max(ans, curAns);
    } else {
        int curSpent = pref[j] - pref[i];
        int curAns = j - i;
        if (curSpent > T) return -100;

        int rest = T - curSpent;
        curAns += rest / a[j];

        ans = max(ans, curAns);
    }

    return ans;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    // freopen("out1.txt", "w", stdout);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    
    cin >> n >> m >> T;

    a.resize(n);
    b.resize(m);
    pref.resize(n + 1);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < m; ++i) cin >> b[i];
    for (int i = 0; i < m; ++i) --b[i];

    for (int i = 1; i <= n; ++i) pref[i] = pref[i - 1] + a[i - 1];

    pl.resize(n);
    for (int i = 0; i < m; ++i) pl[b[i]] = 1;

    int ans = 0;

    vi ls(n, -1), rs(n, n);

    for (int i = 0; i < n; ++i) {
        if (i != 0) ls[i] = ls[i - 1];
        if (pl[i]) ls[i] = i;
    }

    for (int i = n - 1; i >= 0; --i) {
        if (i != n - 1) rs[i] = rs[i + 1];
        if (pl[i]) rs[i] = i;
    }
    
    // for (int i = 0; i < n; ++i) cout << "l " << ls[i] << ' ' << rs[i] << endl;

    for (int i = 0; i < n; ++i) {
        if (ls[i] != -1) {
            int lf = ls[i];
            ans = max(ans, get(lf, i));
        }
        if (rs[i] != n) {
            int rf = rs[i];
            ans = max(ans, get(rf, i));
        }
    }

    cout << ans;
}