#include <bits/stdc++.h>
#include <bits/extc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimize("unrool-looops")
#endif

std::random_device rd;
std::mt19937_64 gen(rd());

using namespace __gnu_pbds;
using ll = long long;

template<class T>
using ordered_set = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 3e5;

std::array<int, N + 1> a, b;
std::array<ll, N + 1> pref, best;

void not_main() {
    int n, m, t;
    std::cin >> n >> m >> t;
    for (int i = 1; i <= n; ++i) {
        std::cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    for (int i = 1; i <= m; ++i) {
        std::cin >> b[i];
    }
    for (int i = 1; i <= n; ++i) {
        int ind = i;
        for (int j = i; j >= 1; --j) {
            if (pref[i] - pref[j - 1] > t) {
                break;
            }
            if (a[ind] > a[j]) {
                ind = j;
            }
            // best[i] = std::max(best[i], i - j + (t - pref[i] + pref[j - 1]) / a[j]);
        }
        best[i] = std::max(best[i], i - ind + (t - pref[i] + pref[ind]) / a[ind]);
        ind = i;
        for (int j = i; j <= n; ++j) {
            if (pref[j] - pref[i - 1] > t) {
                break;
            }
            if (a[ind] > a[j]) {
                ind = j;
            }
            // best[i] = std::max(best[i], j - i + (t - pref[j] + pref[i - 1]) / a[j]);
        }
        best[i] = std::max(best[i], ind - i + (t - pref[ind - 1] + pref[i - 1]) / a[ind]);
    }
    ll ans = 0;
    for (int i = 1; i <= m; ++i) {
        ans = std::max(ans, best[b[i]]);
    }
    std::cout << ans << '\n';
}

signed main() {
    std::ios_base::sync_with_stdio(false);
#ifndef LOCAL
    std::cin.tie(nullptr);
#endif
    int tests = 1;
    // std::cin >> tests;
    while (tests--) {
        not_main();
    }
    return 0;
}