#pragma GCC optimize("O3,unroll-loops")
#include<bits/stdc++.h>
#pragma GCC target("avx,avx2,bmi,bmi2")

using namespace std;

#define all(x) (x).begin(),x.end()

#ifdef DBG
#define debug(x) cout << #x << " = " << x << endl
#else
#define debug(x) 
#endif

using ll = long long;
using dbl = long double;

const int INF = 1e9;

mt19937 rnd(42);

// struct CHT {
//     struct Line {
//         dbl k = 0, b = 0;

//         Line(dbl b_, dbl k_) {
//             b = b_;
//             k = k_;
//         }

//         dbl cross(Line o) {
//             return (b - o.b) / (o.k - k); 
//         }
//     };

//     vector<Line> ls;
//     void add_line(dbl k, dbl b) {
//         Line l = Line(k, b);
        
//         // ls.push_back();
//     }
// };

inline void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n), ans(n);
    vector<int> px(n + 1, 0);

    

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        px[i + 1] = px[i] + a[i];
    }

    auto get = [&](int i, int j) {
        if (px[i + 1] - px[j] > t) return -INF;
        return i - j + (t - (px[i + 1] - px[j + 1])) / a[j];
    };
    auto get_r = [&](int i, int j) {
        if (px[j + 1] - px[i] > t) return -INF;
        return j - i + (t - (px[j] - px[i])) / a[j];
    };

    deque<int> st;

    for (int i = 0; i < n; ++i) {
        st.push_back(i);

        while (st.size() && a[st.back()] >= a[i]) st.pop_back();
        st.push_back(i);
        while (st.size() >= 2 && get(i, st.front()) <= get(i, st[1])) {
            st.pop_front();
        }

        ans[i] = max(ans[i], get(i, st[0]));
    }

    st.clear();

    for (int i = n - 1; i >= 0; --i) {
        st.push_back(i);

        while (st.size() && a[st.back()] >= a[i]) st.pop_back();
        st.push_back(i);
        while (st.size() >= 2 && get_r(i, st.front()) <= get_r(i, st[1])) {
            st.pop_front();
        }

        ans[i] = max(ans[i], get_r(i, st[0]));
    }

    int mx = 0;    

    for (int i = 0; i < m; ++i) {
        int b;
        cin >> b;
        b--;
        debug(b << " " << ans[b]);
        mx = max(mx, ans[b]);
    }
    cout << mx << '\n';
} 

int main() {
    int t = 1;
    #ifdef DBG
    cin >> t;
    #endif
    for (int i = 0; i < t; ++i) {
        solve();
        #ifdef DBG
        cout << '\n';
        #endif
    }
}