#pragma GCC optimize('Ofast')
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
struct fenw {
    vector<int> f;
    explicit fenw(int n) {
        f.resize(n);
    }
    void upd(int i, int x) {
        while (i < f.size()) {
            f[i] += x;
            i |= (i + 1);
        }
    }
    int get(int i) {
        int sum = 0;
        while (i >= 0) {
            sum += f[i];
            i %= (i + 1);
            i--;
        }
        return sum;
    }
};
template <typename T>
bool smin(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template <typename T>
bool smax(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n), b(m);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int j = 0; j < m; j++) cin >> b[j], b[j]--;
    int ans = 0;
    vector<int> pref(n + 1);
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i - 1];
    vector<int> nearl(n), nearr(n);
    vector<int> is(n);
    for (int i = 0; i < m; i++) is[b[i]] = 1;
    int cur = -1;
    for (int i = 0; i < n; i++) {
        if (is[i]) cur = i;
        nearl[i] = cur;
    }
    cur = n;
    for (int i = n - 1; i >= 0; i--) {
        if (is[i]) cur = i;
        nearr[i] = cur;
    }
    for (int i = 0; i < n; i++) {
        int i1 = nearl[i];
        if (i1 != -1) {
            int l1 = min(i1, i);
            int l2 = max(i1, i);
            if (pref[l2 + 1] - pref[l1] <= t) {
                smax(ans, l2 - l1 + 1 + (t - pref[l2 + 1] + pref[l1]) / a[i]);
            }
        }
        i1 = nearr[i];
        if (i1 != n) {
            int l1 = min(i1, i);
            int l2 = max(i1, i);
            if (pref[l2 + 1] - pref[l1] <= t) {
                smax(ans, l2 - l1 + 1 + (t - pref[l2 + 1] + pref[l1]) / a[i]);
            }
        }
    }
    cout << ans << '\n';
    return 0;
}