#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <numeric>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <chrono>
#include <random>
#include <unordered_map>
#include <unordered_set>
using namespace std;
using ll = long long;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif;
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n + 1), pref(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        pref[i] = a[i] + pref[i - 1];
    }
    vector<int> b(m);
    for (int i = 0; i < m; ++i)
        cin >> b[i];
    int j = 0;
    ll ans = 0;
    for (int i = 1; i <= n; ++i) {
        if (j < m - 1 && b[j + 1] <= i)
            j++;
        if (b[j] <= i && t >= pref[i - 1] - pref[b[j] - 1]) {
            ans = max(ans, i - b[j] + (t - pref[i - 1] + pref[b[j] - 1]) / a[i]);
        }
    }
    j = m - 1;
    for (int i = n; i >= 1; i--) {
        if (j > 0 && b[j - 1] >= i)
            j--;
        if (b[j] >= i && t >= pref[b[j]] - pref[i]) {
            ans = max(ans, b[j] - i + (t - pref[b[j]] + pref[i]) / a[i]);
        }
    }
    cout << ans;
}
