#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vii = vector<pair<int, int>>;
using vc = vector<char>;
using vb = vector<bool>;
template<typename T>
using ve = vector<T>;
template<typename T1, typename T2>
using pr = pair<T1, T2>;

const int INF = 1e9 + 1;
const long long INFLL = 1e18 + 1;
const int MOD = 1e9 + 7;

inline void fchmin(int &a, int &b) { a = min(a, b); }
inline void fchmax(int &a, int &b) { a = max(a, b); }

template<typename T>
inline bool chmin(T &a, T &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
inline bool chmax(T &a, T &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// #include<ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_pbds;
// using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int reps = 1;

int find(vi &b, int x) {
    int l = 0, r = b.size();
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (b[mid] <= x) l = mid;
        else r = mid;
    }
    if (b[l] <= x) return l;
    else return -1;
}

void solve() {
    int n, m, T; cin >> n >> m >> T;
    vi a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vi b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
    }
    vi pref(n + 1);
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i - 1];
    int ans = 0;
    for (int i = 0; i < n; i++) {
        int r = lower_bound(all(b), i) - b.begin();
        int l = find(b, i);
        if (l != -1 && pref[i] - pref[b[l]] <= T) {
            ans = max(ans, (T - pref[i] + pref[b[l]]) / a[i] + i - b[l]);
        }
        if (r != m && pref[b[r] + 1] - pref[i + 1] <= T) {
            ans = max(ans, (T - pref[b[r] + 1] + pref[i + 1]) / a[i] + b[r] - i);
        }
        // cout << i << ' ' << l << ' ' << r << ' ' << ans << '\n';
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
    #endif

    for (int i = 1; i <= reps; i++) {
        #ifdef LOCAL
        cout << "===== Test #" << i << " ========\n";
        #endif
        solve();
        #ifdef LOCAL
        cout << "==== End test =====\n\n";
        #endif
    }
}