#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

void getAns(int64_t n, int64_t T, vector<int64_t>& a, vector<int64_t>& ans) {
    ans.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        int64_t x = 0, k = 0;
        for (int j = i; x<=T && j>=0; --j) {
            int64_t c = (T-x)/a[j]+k;
            if (c>ans[i]) ans[i] = c;
            x += a[j]; ++k;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int64_t n, m, T;
    cin >> n >> m >> T;
    vector<int64_t> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    vector<int64_t> ans1;
    getAns(n, T, a, ans1);
    vector<int64_t> ans2;
    reverse(a.begin(), a.end());
    getAns(n, T, a, ans2);
    reverse(ans2.begin(), ans2.end());

    int64_t res = 0;
    for (int i = 0; i < m; ++i) {
        int j; cin >> j; --j;
        res = max(res, max(ans1[j], ans2[j]));
    }
    cout << res << '\n';

    return 0;
}
