#ifndef LOCAL
#pragma GCC optimize("O3")
#endif

#include <bits/extc++.h>

using namespace std;


using namespace __gnu_pbds;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
const ll nMax = 2100;
ll a[nMax];
ll pref[nMax];
void solve() {
    ll n, m , T;
    cin >> n >> m >> T;
    for(int i = 0;i  < n ; i++){
        cin >> a[i];
    }
    vector<int> runs(m);
    for(auto& o : runs) cin >> o;
    for(int i =0; i < n; i++) pref[i+1] = pref[i] + a[i];
    ll ans = 0;
    for(int i =0; i < n; i++){
        auto nxt_it = lower_bound(runs.begin(), runs.end(),i+1);
        if(nxt_it != runs.end()){
            auto dist = pref[*nxt_it] - pref[i+1];
            if(dist <=T){
                ll left = (T - dist) / a[i];
                ans = max(ans, left + *nxt_it - (i+1));
            }
        }
        if(nxt_it != runs.begin()){
            --nxt_it;
            auto dist = -pref[*nxt_it-1] + pref[i];
            if(dist <=T){
                ll left = (T - dist) / a[i];
                ans = max(ans, left + i+1 - *nxt_it);
            }
        }
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    int tt=1;
    //cin >> tt;
    while (tt--)solve();
}