#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int maxn = 3e5 + 100;
vector<int> lst(maxn, 0);
vector<int> pref(maxn, 0);
vector<bool> is_good(maxn, false);

int summ(int l, int r) {
    return pref[r] - pref[l - 1];
}

vector<int> left_good(maxn, -1);
vector<int> right_good(maxn, -1);

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(15);
    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 1; i <= n; i++) {
        cin >> lst[i];
        pref[i] = pref[i - 1] + lst[i];
    }
    for (int i = 0; i < m; i++) {
        int num;
        cin >> num;
        is_good[num] = true;
    }
    for (int i = 1; i <= n; i++) {
        if (is_good[i - 1]) {
            left_good[i] = i - 1;
        } else {
            left_good[i] = left_good[i - 1];
        }
    }
    for (int i = n; i >= 1; --i) {
        if (is_good[i + 1]) {
            right_good[i] = i + 1;
        } else {
            right_good[i] = right_good[i + 1];
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        if (is_good[i]) {
            ans = max(ans, t / lst[i]);
        } else {
            int a = left_good[i];
            int b = right_good[i];
            if (a != -1) {
                int q = summ(a, i - 1);
                if (q < t) {
                    ans = max(ans, (t - q) / lst[i] + (i - a));
                }
            }
            if (b != -1) {
                int q = summ(i + 1, b);
                if (q < t) {
                    ans = max(ans, (t - q) / lst[i] + (b - i));
                }
            }
        }
    }
    cout << ans << endl;
}


