#include<bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long long ll;

vector<int> solve(int a[], int n, int k)
{
  vector<int> ans(n);
  ld p[n];
  
  p[0] = a[0];
  for(int i = 1; i < n; i ++)
    p[i] = a[i] + p[i - 1];

  deque<pair<int,pair<ld, ld> > > deq;
  
  for(int i = 0; i < n; i ++)
    {
      while(deq.size() && a[deq.back().first] >= a[i]) deq.pop_back();
      
      ld c1 = k + p[i], m1 = -1;
      c1 /= a[i], m1 /= a[i];
      c1 -= i;
      
      while(deq.size() > 1)
	{
	  int sz = deq.size();
	  ld c2 = deq[sz - 1].second.first, m2 = deq[sz - 1].second.second;
	  ld c3 = deq[sz - 2].second.first, m3 = deq[sz - 2].second.second;
	  
	  if((c3 - c1) / (m1 - m3) <= (c3 - c2) / (m2 - m3))
	    deq.pop_back();
	  else
	    break;
	}
      deq.push_back({i, {c1, m1}});
      
      while(deq.size() > 1)
	{
	  ld c1 = deq[0].second.first, m1 = deq[0].second.second;
	  ld c2 = deq[1].second.first, m2 = deq[1].second.second;
	  
	  if((c2 - c1) / (m1 - m2) <= p[i])
	    deq.pop_front();
	  else
	    break;
	}
      ans[i] = i + deq[0].second.first + p[i] * deq[0].second.second;
    }
  return ans;
}

int main()
{
  int n, m, k;
  cin >> n >> m >> k;

  int a[n];

  for(int i = 0; i < n; i ++)
    cin >> a[i];
  
  vector<int> s1 = solve(a, n, k);
  reverse(a, a + n);
  vector<int> s2 = solve(a, n, k);
  
  int mx = 0;
  while(m--)
    {
      int i;
      cin >> i;
      i--;
      mx = max(mx, max(s1[i], s2[n - i - 1]));
    }
  cout << mx << endl;
 
  return 0; 
}
