#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

int32_t main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m, t;
	cin >> n >> m >> t;
	vector<int>a(n);
	for (int i = 0; i < n; ++i)cin >> a[i];
	vector<int>pref(n + 1);

	for (int i = 1; i <= n; ++i) {
		pref[i] += pref[i - 1] + a[i - 1];
	}
	int ans = 0;
	vector<int>b(m);
	int jpr = -1;
	int jpo = 0;
	for (int i = 0; i < m; ++i) {
		cin >> b[i];
		b[i]--;
	}
	for (int i = 0; i < n; ++i) {
		while (jpo<m && b[jpo]<=i) {
			jpo++;
		}
		while (jpr < m - 1 && b[jpr + 1] <= i) {
			jpr++;
		}
		if (jpo <m) {
			int cnt = t;
			cnt -= pref[b[jpo] + 1] - pref[i+1];
			if (cnt > 0) {
				ans = max(ans, b[jpo] - i + cnt / a[i]);
			}
		}
		if (jpr >= 0) {
			int cnt = t;
			cnt -= pref[i] - pref[b[jpr]];
			if (cnt > 0) {
				ans = max(ans, i - b[jpr] + cnt / a[i]);
			}
		}
	}
	cout << ans;

	return 0;
}