#include <iostream>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <algorithm>
#include <assert.h>
using namespace std;

#define int long long
#define ll long long
#define vi vector<int>
#define pi pair<int, int>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define vpi vector<pi>
#define vvi vector<vi>



signed main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
    

	int n, m, t;
	cin >> n >> m >> t;
	vi vec(n);
	vi pref(n + 1);
	for (int i = 0; i < n; i++) {
		cin >> vec[i];
		pref[i + 1] = pref[i] + vec[i];
	}
	vi tvec(m);
	for (int i = 0; i < m; i++) {
		cin >> tvec[i];
		tvec[i]--;
	}
	int ans = 0;
	
	for (int i = 0; i < n; i++) {
		auto it = lower_bound(all(tvec), i);
		if (it != tvec.end()) {
			int j = *it;
			int ff = (pref[j + 1] - pref[i + 1]);
			if (ff > t) continue;
			ans = max(ans, abs(j - i) + ((t - ff) / vec[i]));
		} 
		if (it != tvec.begin()) {
			it--;
			int j = *it;
			int ff = (pref[i] - pref[j]);
			if (ff > t) continue;
			ans = max(ans, abs(j - i) + ((t - ff) / vec[i]));
		}
	}

	cout << ans;
}
