
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
template <typename t>
ostream& operator<<(ostream& out, const vector<t> &v){
    for(auto x: v)out<<x<<" ";
    return out;
}
template <typename t>
istream& operator>>(istream& in,  vector<t> &v){
    for(auto &x: v)in>>x;
    return in;
}
template <typename t, typename u>
ostream& operator<<(ostream& out, const pair<t, u> p){
    out<<p.first<<" "<<p.second<<"\n";
    return out;
}
template <typename t, typename u>
istream& operator>>(istream& in,  pair<t, u> &p){
    in>>p.first>>p.second;
    return in;
}
ll solve2(ll n, ll m, ll t, vector<ll> v, vector<ll> v1){
    ll idx = 0;
    map<ll, ll> mp;
    for(int i = 0;i<m; i++){
        mp[v1[i]]=1;
    }
    ll cur = 0, sum = 0, ans = 0;
    for(int i = 0; i<n; i++){
        sum+=v[i];
        while(sum>t){
            
            sum-=v[cur];
            cur++;
        }
        if(mp[i]==1){
            if(cur==0){
                ans=max(i+1+(t-sum)/v[cur], ans);
            }
            else{
                ans=max(i+1-cur, ans);
            }
        }
    }
    return ans;
}
void solve () {
    int n, m, t;
    cin>>n>>m>>t;
    vector<ll> v(n), v1(m);
    cin>>v>>v1;
    ll ans = solve2(n, m, t, v, v1);
    reverse(v.begin(), v.end());
    for(int i = 0; i<m; i++){
        v1[i]=n+1-v1[i];
    }
    cout<<max(ans, solve2(n, m, t, v, v1))<<"\n";
}
signed main () {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    cout<<fixed<<setprecision(18);
    ll AnyaSamsonovaGoSex = 1;
    //cin>>AnyaSamsonovaGoSex;
    while(AnyaSamsonovaGoSex--) solve();
}