#include <bits/stdc++.h>

using namespace std;

#define int long long
using ld = long double;
using ll = long long;
using pii = pair<int, int>;

void solve()
{
    int n, m, T;
    cin >> n >> m >> T;
    vector<int> a(n);
    vector<bool> hb(n, false);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i)
    {
        int j;
        cin >> j;
        --j;
        hb[j] = true;
    }
    int ans = 0;

    int cost = -1;
    int len = 0;
    for (int i = 0; i < n; ++i)
    {
        if (hb[i])
        {
            cost = 0;
            len = 0;
        }
        if (cost == -1)
            continue;
        if (cost <= T)
        {
            int var = len + (T - cost) / a[i];
            ans = max(ans, var);
        }
        ++len;
        cost += a[i];
    }

    cost = -1;
    len = 0;
    for (int i = n - 1; i >= 0; --i)
    {
        if (hb[i])
        {
            cost = 0;
            len = 0;
        }
        if (cost == -1)
            continue;
        if (cost <= T)
        {
            int var = len + (T - cost) / a[i];
            ans = max(ans, var);
        }
        ++len;
        cost += a[i];
    }
    cout << ans << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(0);
    ios::sync_with_stdio(0);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}