#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using sll = __int128;

template <typename T>
istream &operator>>(istream &in, pair<T, T> &a){
    in >> a.first >> a.second;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, pair<T, T> &a){
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream &operator>>(istream &in, vector<T> &a){
    for(auto &x : a) in >> x;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector<T> &a){
    for(auto x : a) out << x << ' ';
    return out;
}

void solve(){
    int n, m, T;
    cin >> n >> m >> T;
    vector<ll> a(n + 1);
    ll mx = 0;
    for(int i = 1; i <= n; i++) cin >> a[i];
    vector<ll> pref(n + 1);
    for(int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i];
    vector<int> b(m); cin >> b;
    vector<vector<int>> cl_l(n + 1, vector<int> (21));
    map<int, int> last;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= 20; j++){
            cl_l[i][j] = cl_l[i - 1][j];
        }
        cl_l[i][a[i]] = i;
    }
    last.clear();
    vector<vector<int>> cl_r(n + 2, vector<int> (21, n + 2));
    for(int i = n; i >= 1; i--){
        for(int j = 1; j <= 20; j++){
            cl_r[i][j] = cl_r[i + 1][j];
        }
        cl_r[i][a[i]] = i;
    }
    for(auto pos : b){
        for(int j = 1; j <= 20; j++){
            int l = cl_l[pos][j];
            if(l != 0) mx = max(mx, pos - l + (T - (pref[pos] - pref[l])) / a[l]);
            int r = cl_r[pos][j];
            if(r <= n) mx = max(mx, r - pos + (T - (pref[r - 1] - pref[pos - 1])) / a[r]);
        }
    }
    cout << mx;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test = 1;
//    cin >> test;
    while(test--){
        solve();
    }
}

