#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()
#define siz(x) int(x.size())
#define ceil(a, b) (((a) + (b) - 1) / (b))
const int INF = 2e9 + 7;
const ll LINF = 1e18 + 7;
const int mxN = 3e5 + 10;

ll pref[mxN];
ll get(int l, int r) {
    if(l > r) return 0;
    ll ans = pref[r];
    if(l) ans -= pref[l - 1];
    return ans;
}
void solve() {
    int n, m, T;
    cin >> n >> m >> T;
    vector<ll> a(n), b(m), ans(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i] = (i ? pref[i - 1] : 0) + a[i];
    }
    for(int i = 0; i < n; ++i) {
        int lb = -1, rb = i + 1;
        while(lb + 1 < rb) {
            int mid = (lb + rb) / 2;
            if(get(mid, i) > T) lb = mid;
            else rb = mid;
        }
        if(rb <= i) ans[i] = i - rb + (T - get(rb + 1, i)) / a[rb];
    }
    ll mx = 0;
    for(int i = 0; i < m; ++i) {
        int x;
        cin >> x;
        mx = max(mx, ans[x - 1]);
    }
    cout << mx;
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cout << fixed; cout.precision(8);
#ifdef INEYOK
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}
