#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2,bmi")

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl "\n"
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

constexpr int INF = 2e13;
constexpr int MOD = 1e9 + 7;

struct zp {
    int x;
    int plus;
};

vector<zp> tre;

void push(int v) {
    tre[v * 2].x += tre[v].plus;
    tre[v * 2 + 1].x += tre[v].plus;
    tre[v * 2].plus += tre[v].plus;
    tre[v * 2 + 1].plus += tre[v].plus;
    tre[v].plus = 0;
}

void upd(int v, int l, int r, int tl, int tr, int x) {
    if (tl > r || tr < l) return;
    if (tl >= l && tr <= r) {
        tre[v].x += x;
        tre[v].plus += x;
        return;
    }
    push(v);
    int tm = (tl + tr) / 2;
    upd(v * 2, l, r, tl, tm, x);
    upd(v * 2 + 1, l, r, tm + 1, tr, x);
    tre[v].x = min(tre[v * 2].x, tre[v * 2 + 1].x);
}

int get(int v, int l, int r, int tl, int tr) {
    if (tl > r || tr < l) return INF;
    if (tl >= l && tr <= r) {
        return tre[v].x;
    }
    push(v);
    int tm = (tl + tr) / 2;
    return min(get(v * 2, l, r, tl, tm), get(v * 2 + 1, l, r, tm + 1, tr));
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, m, T;
    cin >> n >> m >> T;
    vector<int> a(n), b(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<bool> bar(n);
    vector<int> pref(n + 1);
    for (int i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
        bar[b[i]] = true;
    }
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i- 1] + a[i - 1];
    }
    int ans = -INF;
    for (int i = 0; i < n; i++) {
        auto id = lower_bound(b.begin(), b.end(), i) - b.begin();
        if (id != m) {
            ans = max(ans, (b[id] - i) + (T - (pref[b[id] + 1] - pref[i + 1])) / a[i]);
        }
        id--;
        if (id == -1) continue;
        ans = max(ans, (i - b[id]) + (T - (pref[i] - pref[b[id]])) / a[i]);
    }
    cout << ans;
}
