#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <random>

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

using namespace std;
using namespace __gnu_pbds;

#define int long long

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n + 1), pr(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pr[i] = pr[i - 1] + a[i];
    }
    vector<int> b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }
    shuffle(b.begin(), b.end(), std::mt19937(std::random_device()()));
    int best = -1;
    for (int i = 0; i < min(m, (int) 1e3); i++) {
        int local_best = -1;
        for (int j = b[i]; j <= n; j++) {
            int sum = 0;
            if (pr[j - 1] - pr[b[i] - 1] > t) {
                break;
            }
            sum = (j - b[i]) + (t - (pr[j - 1] - pr[b[i] - 1])) / a[j];
            local_best = max(local_best, sum);
        }
        for (int j = b[i] - 1; j >= 1; j--) {
            int sum = 0;
            if (pr[b[i]] - pr[j] > t) {
                break;
            }
            sum = (b[i] - j) + (t - (pr[b[i]] - pr[j])) / a[j];
            local_best = max(local_best, sum);
        }
        best = max(best, local_best);
    }
    cout << best << "\n";
}
