#pragma GCC optimize("Ofast,inline")

#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define fi first
#define se second
mt19937 gen(time(0));

const int N = 3e5 + 12;
int a[N], b[N], pref[N];

int get(int l ,int r) {
    if(l > r)
        swap(l, r);
    if(l == 0)
        return pref[r];
    return pref[r] - pref[l-1];
}
int solve(int i, int j, int T) {
    int need = get(i, j);
    if(need > T)
        return 0;
//    cout << need << '\n';
    return abs((i - j)) + 1 + (T - need) / a[j];
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, T;
    cin >> n >> m >> T;
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        if(i) {
            pref[i] = pref[i-1] + a[i];
        } else {
            pref[i] = a[i];
        }
    }
    for(int i = 0; i < m; ++i) {
        cin >> b[i];
        b[i]--;
    }
//    cout << solve(3, 4, T);
//    return 0;
    int ans = 0;
    for(int i = 0; i < n; ++i) {
        int l = -1, r = m;
        while(l + 1 < r) {
            int mid = (l + r) >> 1;
            if(b[mid] >= i) {
                r = mid;
            } else {
                l = mid;
            }
        }
//        cout << i << ' ' << l << ' ' << r << '\n';
        if(r != m)
            ans = max(ans, solve(b[r], i, T));
        if(l != -1)
            ans = max(ans, solve(b[l], i, T));
    }
    cout << ans;
    return 0;
}
