#include <bits/stdc++.h>
#define ln << '\n'
#define ii pair<int, int>
#define F first
#define S second
#define int long long
using namespace std;

const int N = 5e5 + 22;
int n, m, T, a[N], b[N], pr[N];
bool ex[N];
int ans;

int get(deque<ii> &q, int dj, int i) {
    int x, j; tie(x, j) = q[dj];
    return i - j + (T - (pr[i] - pr[j])) / x;
}

void job() {
    deque<ii> q;
    for (int i = 1; i <= n; i++) {
        while (!q.empty() && q.front().F > a[i]) q.pop_front();
        q.push_front({a[i], i});

        while (!q.empty() && (pr[i] - pr[q.back().S]) > T) q.pop_back();
        // while (q.size() >= 2) {
        //     int x1, j1; tie(x1, j1) = q[q.size() - 1];
        //     int x2, j2; tie(x2, j2) = q[q.size() - 2];
        //
        //     int a1 = i - j1 + (x1 / (T - (pr[i] - pr[j1])));
        //     int a2 = i - j2 + (x2 / (T - (pr[i] - pr[j2])));
        //     if (a1 <= a2) q.pop_back();
        //     else break;
        // }
        //
        // if (!q.empty()) ans = max(ans, i - q.back().S + (q.back().F / (T - (pr[i] - pr[q.back().S]))));

        if (!q.empty() && ex[i]) {
            int l = 0, r = q.size() - 1;
            while (l + 6 < r) {
                int md1 = (l + l + r) / 3;
                int md2 = (l + r + r) / 3;
                if (get(q, md1, i) > get(q, md2, i)) l = md1; else r = md2;
            }
            for (int j = l; j <= r; j++) {
                ans = max(ans, get(q, j, i));
            }
        }
    }
}

int brut() {
    int ans = 0;
    for (int i = 1; i <= m; i++) {
        int cur = T;
        for (int j = b[i]; j <= n; j++) {
            cur -= a[j];
            if (cur < 0) break;
            ans = max(ans, j - b[i] + cur / a[j] + 1);
            // if (ans == 3) cout << "!" << i << ' ' << 1 ln;
        }

        cur = T;
        for (int j = b[i]; j >= 1; j--) {
            cur -= a[j];
            if (cur < 0) break;
            ans = max(ans, b[i] - j + cur / a[j] + 1);
            // if (ans == 3) cout << "!" << i << ' ' << 2 ln;
        }
    }
    return ans;
}

int32_t main() {
    srand(time(0));
    cin.tie(0); cout.tie(0); ios::sync_with_stdio(0);
    cin >> n >> m >> T;
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) pr[i] = pr[i - 1] + a[i];
    for (int i = 1; i <= m; i++) {cin >> b[i]; ex[b[i]] = 1;}
// while (1) {
//     for (int i = 1; i <= n; i++) a[i] = rand() % 10 + 1;
//     for (int i = 1; i <= n; i++) ex[i] = 0;
//     for (int i = 1; i <= m; i++) {b[i] = rand() % n + 1; ex[b[i]] = 1;}

    job();
    reverse(a + 1, a + n + 1);
    reverse(ex + 1, ex + n + 1);
    for (int i = 1; i <= n; i++) pr[i] = pr[i - 1] + a[i];
    job();

    // cout ln;
    // for (int i = 1; i <= n; i++) cout << a[i] << ' '; cout ln;
    // for (int i = 1; i <= n; i++) cout << b[i] << ' '; cout ln;
    // cout << ans << ' ' << brut() ln;
    // if (ans != brut()) return 0;
    cout << ans;
// }
    return 0;
}

/*
5 5 14
26 9 91 99 8
2 2 4 1 4

10 10 10
10 8 10 6 4 6 7 9 9 5
2 9 9 3 6 7 6 1 8 6

10 10 10
9 4 6 7 5 4 3 5 1 5
5 4 1 3 2 6 1 2 5 2

10 10 10
10 4 4 9 1 3 2 4 4 10
2 10 9 10 9 2 4 10 4 3
*/