#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

ll inf = (ll)1e18;

template<class T>
ll len(T& a) {
    return (ll)a.size();
}

void solve() {
    ll n, m, t;
    cin >> n >> m >> t;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> b(m);
    for (ll i = 0; i < m; ++i) {
        cin >> b[i];
    }

    vector<vector<ll>> queries(n);
    for (ll i = 1; i < m; ++i) {
        queries[b[i - 1] - 1].push_back(i-1);
        for (ll j = b[i-1]; j < b[i]; ++j) {
            queries[j].push_back(i-1);
            queries[j].push_back(i);
        }
    }
    for (ll i = 0; i < b[0]; ++i) {
        queries[i].push_back(0);
    }
    for (ll i = b.back()-1; i < n; ++i) {
        queries[i].push_back(len(b) - 1);
    }

    vector<ll> pref(n + 1, 0);
    for (ll i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
    }

    ll res = -1;
    for (ll i = 0; i < len(queries); ++i) {
        for (ll j = 0; j < len(queries[i]); ++j) {
            ll start = b[queries[i][j]] - 1;
            ll end = i;

            if (start > end) {
                swap(start, end);
            }
            if (pref[end + 1] - pref[start] > t) {
                continue;
            }
            ll temp = end - start + 1;
            ll rem = t - (pref[end + 1] - pref[start]);
            temp += rem / a[i];

            res = max(res, temp);
        }
    }

    cout << res << "\n";
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
