#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <cmath>
#include <map>
#include <iomanip>
#include <queue>
#include <unordered_map>
using namespace std;
using ll = long long;

void solve() {
	ll n, m, t;
	cin >> n >> m >> t;
	vector<ll> v(n + 1), b(m), use(n + 1);
	vector<ll> pref(n + 1), rpref(n + 2);
	for (ll i = 1; i <= n; ++i)
		cin >> v[i], pref[i] = pref[i - 1] + v[i];
	for (ll i = n; i >= 1; --i)
		rpref[i] = rpref[i + 1] + v[i];
	for (ll i = 0; i < m; ++i) {
		cin >> b[i];
		use[b[i]] = 1;
	}
	ll ans = 0;
	ll last = 0;
	for (ll i = 1; i <= n; ++i) {
		if (use[i])
			last = i;
		if (last == 0 || pref[i] - pref[last - 1] > t) continue;
		ll time = t - (pref[i] - pref[last - 1]);
		ll cnt = i - last + 1;
		cnt += time / v[i];
		ans = max(ans, cnt);
	}
	last = n + 1;
	for (ll i = n; i >= 1; --i) {
		if (use[i])
			last = i;
		if (last == n + 1 || pref[last] - pref[i - 1] > t) continue;
		ll time = t - (pref[last] - pref[i - 1]);
		ll cnt = last - i + 1;
		cnt += time / v[i];
		ans = max(ans, cnt);
	}
	cout << ans << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false); cin.tie(0);
	ll t = 1;
	// cin >> t;
	while (t--)
		solve();
}