#include <bits/stdc++.h>
#define int int64_t
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

inline int MAX(int a, int b) {
    if (a > b)
        return a;
    return b;
}

const int INF = 1e18;

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int32_t n, m, t; cin >> n >> m >> t;

    vector<int32_t> a(n), b(m);
    vector<int> pref(n + 1);

    for (auto &i : a)
        cin >> i;
    for (auto &i : b)
        cin >> i, i--;

    for (int i = 0; i < n; i++)
        pref[i + 1] = pref[i] + a[i];

    int res = 0;
    int32_t r1 = 0, r2 = 0;
    
    for (int32_t st = 0; st < n; st++) {
        int cur_res = -INF;
        int32_t id = lower_bound(all(b), st) - b.begin();

        while (r1 < id && pref[st] - pref[b[r1]] > t)
            r1++;

        #pragma ivdep
        for (int32_t i = r1; i < id; i++) {
            cur_res = MAX(cur_res, pref[b[i]] - (b[i] * a[st]));
        }

        cur_res += st * a[st] - pref[st] + t;
        res = MAX(res, cur_res / a[st]);
    }

    for (int32_t st = 0; st < n; st++) {
        int32_t id = lower_bound(all(b), st) - b.begin();

        while (r2 < m && pref[b[r2] + 1] - pref[st + 1] <= t)
            r2++;
 
        int cur_res = -INF;

        #pragma ivdep
        for (int32_t i = id; i < r2; i++) {
            cur_res = MAX(cur_res, b[i] * a[st] - pref[b[i] + 1]);
        }

        cur_res += pref[st + 1] + t - st * a[st];

        res = MAX(res, cur_res / a[st]);
    }

    cout << res;
}