#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(X) (x).rbegin(), (x).rend()

void solve()
{
    int n, m, T;
    cin >> n >> m >> T;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    vector<int> b(m);
    for (int i = 0; i < m; i++)
    {
        cin >> b[i];
        --b[i];
    }

    ll ans = 0;
    for (int i = 0; i < m; i++)
    {
        int l = i > 0 ? b[i - 1] : -1;
        int r = i < m - 1 ? b[i + 1] : n;

        ll s = 0;
        for (int j = b[i]; j > l; j--)
        {
            ans = max(ans, (T - s) / a[j] + b[i] - j);
            s += a[j];
            if (s > T)
                break;
        }
        s = 0;
        for (int j = b[i]; j < r; j++)
        {
            ans = max(ans, (T - s) / a[j] + j - b[i]);
            s += a[j];
            if (s > T)
                break;
        }
    }
    cout << ans << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("C:/work/Day 2/in.txt", "r", stdin);
    freopen("C:/work/Day 2/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}
