#ifdef _DEBUG
#include <iostream>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cassert>
#else
#include <bits/stdc++.h>
#endif

using namespace std;
#define int int64_t

void solve() {
	int n, m, t;
	cin >> n >> m >> t;
	vector<int> a(n), b(m);
	for (int& i : a) cin >> i;
	for (int& i : b) cin >> i;
	for (int& i : b) --i;
	int ans = 0;
	for (int i = 0; i < m; ++i) {
		int cur_time = 0;
		int cnt = 0;
		for (int j = b[i]; j > 0; --j) {
			if (cur_time + a[j] <= t) {
				++cnt;
			}
			cur_time += a[j];
		}
		ans = max(ans, cnt + max<int>(0, t - cur_time) / a[0]);
	}
	cout << ans << endl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test = 1;
	//cin >> test;

	while (test--) {
		solve();
	}

	return 0;
}