#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, m, t;
vector<ll> a, p;

ll get(ll i, ll j) {
    if (j < i) {
        ll gg = t - p[i + 1] + p[j + 1];
        if (gg >= 0) {
            return gg / a[j] + i - j;
        }
    } else {
        ll gg = t - p[j] + p[i];
        if (gg >= 0) {
            return gg / a[j] + j - i;
        }
    }
    return 0;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m >> t;
    a.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    p.assign(n + 1, 0);
    for (ll i = 1; i <= n; i++) {
        p[i] = p[i - 1] + a[i - 1];
    }
    vector<ll> b(m);
    for (ll i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
    }
    ll ans = 0;
    for (ll j = 0; j < n; j++) {
        ll ind = lower_bound(b.begin(), b.end(), j) - b.begin();
        if (ind > 0) {
            ans = max(ans, get(b[ind - 1], j));
        }
        if (ind < m) {
            ans = max(ans, get(b[ind], j));
        }
    }
    cout << ans;
}