#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n), b(m);
    cin >> a >> b;
    for (int& i : b) i--;

    int ans = 0;

    vector<int> pref(n + 1);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i-1] + a[i-1];
    }

    for (int i = 0; i < n; i++) {
        auto it = lower_bound(b.begin(), b.end(), i);
        if (it != b.end()) {
            int w = *it;
            int ct = pref[w + 1] - pref[i + 1];
            if (ct <= t) {
                ans = max(ans, w - i + (t - ct) / a[i]);
            }
        }

        if (it != b.begin()) {
            --it;
            int w = *it;
            int ct = pref[i] - pref[w];
            if (ct <= t) {
                ans = max(ans, i - w + (t - ct) / a[i]);
            }
        }
    }

    cout << ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}
