#include <bits/stdc++.h>
// #include <bits/extc++.h>

using namespace std;

#define all(a)	a.begin(),a.end()
#define rall(a)	a.rbegin(),a.rend()
#define FastIO	ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

typedef long long			ll;
typedef long double			ld;
typedef unsigned long long	ull;
// typedef _int128_t lll;

template<typename T1, typename T2>
ostream& operator<< (ostream &x, const pair<T1, T2> &pr) { return x << "{" << pr.first << ", " << pr.second << "}"; }
template<typename T> void cerr_cont(const T &cont) { for (auto &it : cont) cerr << it << ' '; }
template<typename T> void print_cont(const T &cont, ostream &x=cout) { for (auto &it : cont) x << it << ' '; }

int n;
int T;

vector<int> a;
vector<ll> pref;

int flt(int lt, int rt) {
	ll sm = pref[rt + 1] - pref[lt];
	if (sm > T) return INT_MIN;
	return rt - lt + 1 + (T - sm) / a[rt];
}

int frt(int lt, int rt) {
	ll sm = pref[rt + 1] - pref[lt];
	if (sm > T) return INT_MIN;
	return rt - lt + 1 + (T - sm) / a[lt];
}

int main() {
	FastIO;
	int m;
	cin >> n >> m >> T;

	a.resize(n);
	for (auto &it : a) cin >> it;
	
	vector<int> b(m);
	for (auto &it : b) {
		cin >> it;
		--it;
	} 

	pref.resize(n + 1);
	pref[0] = 0;
	for (int i = 0; i < n; ++i) pref[i + 1] = pref[i] + a[i];

	int best = 0;

	for (auto i : b) {
		int lt = 0;
		int rt = i;
		while (rt - lt - 1 >= 2) {
			int m1 = lt + (rt - lt) / 3;
			int m2 = rt - (rt - lt) / 3;
			if (flt(m1, i) > frt(m2, i)) rt = m2;
			else lt = m1;
		}
		if (lt + 1 <= rt && flt(lt + 1, i) > flt(lt, i)) lt = lt + 1;
		if (flt(rt, i) > flt(lt, i)) lt = rt;

		best = max(best, flt(lt, i));
	}
	cout << best;
	return 0;
}

