#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const ll INF = 1e18;

vector<ll> a, b, p;
ll n, m, t;

ll get(ll l, ll r) {
    if (!l) return p[r];
    return p[r] - p[l - 1];
};

pair<ll, ll> calc(ll i, ll j) {
    if (i <= j) {
        ll d = get(i, j);
        if (d > t) return {0, -1};
        ll left = t - d;
        ll add = left / a[j];
        left -= add * a[j];
        return {add + (j - i + 1), left};
    }
    else {
        ll d = get(j, i);
        if (d > t) return {0, -1};
        ll left = t - d;
        ll add = left / a[j];
        left -= add * a[j];
        return {add + (i - j + 1), left};
    }
};

/*
 * 4 4 10
2 3 1 3
1 2 3 4
 */

void obla() {
    cin >> n >> m >> t;
    a.resize(n),  p.resize(n);
    b.resize(m);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
    }
    for (int i = 0; i < n; i++) {
        p[i] = a[i];
        if (i > 0) p[i] += p[i - 1];
    }
    ll ans = 0;
    for (auto pos : b) {
        ans = max(ans, calc(pos, pos).first);
    }
    for (int r = 0; r < n; r++) {
        ll i2 = upper_bound(b.begin(), b.end(), r) - b.begin();
        ll i1 = upper_bound(b.begin(), b.end(), r) - b.begin() - 1;
        if (i2 < m) {
            auto res = calc(b[i2], r);
            ans = max(ans, res.first);
        }
        if (i1 > -1) {
            auto res = calc(b[i1], r);
            ans = max(ans, res.first);
        }
    }
    cout << ans << '\n';
}

int main() {
    int t = 1; //cin >> t;
    cin.tie(0);
    ios::sync_with_stdio(0);
    while (t--) {
        obla();
    }
}
