#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

//#pragma GCC optimize("O3")

#define out(x) std::cout << x << ' ';
#define oute(x) std::cout << x << '\n';
#define enter std::cout << '\n';
#define debout(x) std::cout << #x << x << '\n';
#define debvout(x) std::cout << #x << " : "; for (auto i: x) std::cout << x << ' '; std::cout << '\n';
#define all(x) x.begin(), x.end()
using ll = long long;

ll n, m, t;

ll f(ll ind, ll i, std::vector<ll> &inds, std::vector<ll> &pref_sum, std::vector<ll> &a) {
    if (ind < 0 || ind == inds.size()) return -1;
    ll j = inds[ind];
    if (inds[ind] <= i) {
        if (pref_sum[i] - pref_sum[j] > t) return -1;
        return (t - (pref_sum[i] - pref_sum[j])) / a[i] + (i - j);
    }
    else {
        if (pref_sum[j + 1] - pref_sum[i + 1] > t) return -1;
        return (t - (pref_sum[j + 1] - pref_sum[i + 1])) / a[i] + (j - i);
    }
}

void s1nmeee() {
    std::cin >> n >> m >> t;
    std::vector<ll> a(n), inds(m);
    for (ll& i : a) std::cin >> i;
    for (ll& i : inds) {
        std::cin >> i;
        i--;
    }
    std::vector<ll> pref_sum(n + 1);
    for (ll i = 0; i < n; i++) pref_sum[i + 1] = pref_sum[i] + a[i];
    ll ans = 0, ind = 0;
    for (ll i = 0; i < n; i++) {
        while (ind < m - 1 && inds[ind + 1] <= i) ind++;
        ans = std::max({ ans, f(ind, i, inds, pref_sum, a), f(ind + 1, i, inds, pref_sum, a) });
    }
    out(ans)
}

signed main() {
    std::cin.tie(nullptr), std::ios::sync_with_stdio(false);
    ll TT = 1;
    //std::cin >> TT;
    while (TT--) {
        s1nmeee();
        std::cout << '\n';
    }
}