#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using ll = long long;

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

vector<ll> p;

ll get(ll l, ll r) {
    return p[r + 1] - p[l];
}

ll f(ll x, ll i, vector<ll> &a, ll t) {
    if (x <= i) {
        if (get(x, i - 1) > t) {
            return 0;
        }
        return (t - get(x, i - 1)) / a[i] + (i - x);
    } else {
        if (get(i + 1, x) > t) {
            return 0;
        }
        return (t - get(i + 1,x)) / a[i] + (x - i);
    }
}

inline void solve() {
    /*ordered_set<ll> s;
    cout << (*s.find_by_order(2)) << endl;
    cout << s.order_of_key(2) << endl;*/
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<ll> b(m);
    for (ll i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
    }
    ll ans = 0;
    p.resize(n + 1, 0);
    for (ll i = 1; i < n + 1; i++) {
        p[i] = p[i - 1] + a[i - 1];
    }
    for (ll i = 0; i < n; i++) {
        ll tans = 0;
        ll lx = upper_bound(b.begin(), b.end(), i) - b.begin();
        if (lx > 0 && lx < m) {
            tans = max(f(b[lx], i, a, t), f(b[lx - 1], i, a, t));
        } else if (lx < m) {
            tans = f(b[lx], i, a, t);
        } else {
            tans = f(b[lx - 1], i, a, t);
        }
        ans = max(ans, tans);
    }
    cout << ans << endl;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll q = 1;
    // cin >> q;
    while (q--) {
        solve();
    }
}
