#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <climits>
#include <iomanip>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <queue>
#include <random>

#define int long long

#pragma GCC optimize("03,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using ll = long long;
using ld = long double;
using namespace std;

const ll INF = 1e18;

int get_sum(int l, int r, vector<int>& pref) {
	int ans = pref[r];
	if (l != 0) {
		ans -= pref[l - 1];
	}
	return ans;
}

void solve() {
	int n, m, t;
	cin >> n >> m >> t;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<int> b(m);
	for (int i = 0; i < m; i++) {
		cin >> b[i];
		b[i]--;
	}
	vector<int> pref(n);
	pref[0] = a[0];
	for (int i = 1; i < n; i++) {
		pref[i] = pref[i - 1] + a[i];
	}
	int mx = 0;
	for (auto& p : b) {
		for (int i = 0; i < n; i++) {
			if (i == p) {
				mx = max(mx, t / a[i]);
				continue;
			}
			if (i < p) {
				int need = get_sum(i + 1, p, pref);
				if (need > t) {
					continue;
				}
				mx = max(mx, p - i);
				int rem = t - need;
				mx = max(mx, p - i + (rem / a[i]));
			}
			else {
				int need = get_sum(p, i - 1, pref);
				if (need > t) {
					continue;
				}
				mx = max(mx, i - p);
				int rem = t - need;
				mx = max(mx, i - p + (rem / a[i]));
			}
		}
	}
	cout << mx;
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	solve();
	return 0;
}