//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2")
#define _GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forsn(i,s,e) for(ll i = s; i <= e; i++)
#define rforsn(i,s,e) for(ll i = s; i >= e; i--)
#define ln '\n'
#define all(x) x.begin(), x.end()

const ll inf = INT64_MAX;

ll n, m, T;
vector <ll> a, ans;

void solve(ll t, ll i, ll cnt, ll r) {
    if (t < a[i]) {
        ans[r] = max(ans[r], cnt);
        return;
    }
    if (i > 0) {
        solve(t % a[i], i - 1, cnt + t / a[i], r);
        solve(t - a[i], i - 1, cnt + 1, r);
    }
    if (i < n - 1) {
        solve(t % a[i], i + 1, cnt + t / a[i], r);
        solve(t - a[i], i + 1, cnt + 1, r);
    }
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0);

    cin >> n >> m >> T;
    a.resize(n);
    for (ll& i: a)
        cin >> i;
    vector <ll> b(m);
    for (ll& i: b)
        cin >> i;

    ans.assign(n, 0);
    forsn(i, 0, m - 1) {
        solve(T, b[i] - 1, 0, b[i] - 1);
    }

    ll res = 0;
    forsn(i, 0, n - 1) {
        res = max(res, ans[i]);
    }

    cout << res;

    return 0;
}
