#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <queue>

using namespace std;
#define int long long
int n, m, T;
int run(vector <int> &a, vector <int> &b) {
    queue <int> q;
    int s = 0;
    vector <bool> r(n);
    for (int i : b) r[i - 1] = true;
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (!q.empty() && q.back() >= a[i]) {
            while (!q.empty()) q.pop();
            s = 0;
        }
        q.push(a[i]);
        s += a[i];
        while (!q.empty() && s > T) {
            s -= q.front();
            q.pop();
        }
        if (r[i] && !q.empty()) {
            ans = max(ans, (int)q.size() + (T - s) / q.front());
        }
    }
    return ans;
}
signed main() {
    cin >> n >> m >> T;
    vector <int> a(n), b(m);
    for (int &i : a) cin >> i;
    for (int &i : b) cin >> i;
    int a1 = run(a, b);
    reverse(a.begin(), a.end());
    for (long long & i : b) {
        i = n - i + 1;
    }
    int a2 = run(a, b);
    cout << max(a1, a2);
    return 0;
}
