//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll ran(ll l = LLONG_MIN, ll r = LLONG_MAX) {
    return uniform_int_distribution<ll>(l, r)(rnd);
}

void solve() {
    ll n, m, T;
    cin >> n >> m >> T;
    vector<ll> a(n);
    for (auto &x: a) cin >> x;
    ll ans = 0;
    vector<ll> anss(n);
    vector<ll> p(n + 1);
    for (int i = 0; i < n; ++i) p[i + 1] = p[i] + a[i];
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            if (p[j + 1] - p[i] > T) continue;
            anss[i] = max(anss[i], (T - p[j + 1] + p[i]) / a[j] + j - i + 1);
        }
        for (int j = i; j > -1; --j) {
            if (p[i + 1] - p[j] > T) continue;
            anss[i] = max(anss[i], (T - p[i + 1] + p[j]) / a[j] + i - j + 1);
        }
    }
    while (m--) {
        int x;
        cin >> x;
        --x;
        ans = max(ans, anss[x]);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t = 1;
//    cin >> t;
    while (t--) solve(), cout << '\n';
    return 0;
}