#include <iostream>
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main()
{
    ll n, m, T, best = -1;
    cin >> n >> m >> T;
    vector<ll> a(n), b(m), c, ind(n), pref(n + 1);
    for (int i = 0; i < n; ++i){
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    c = a;
    sort(c.begin(), c.end());
    for (int i = 0; i < n; ++i){
        int L = 0, R = n, m;
        while (L + 1 < R){
            m = (L + R) / 2;
            if (c[m] <= a[i]){
                L = m;
            } else{
                R = m;
            }
        }
        ind[L] = i;
    }
    for (int i = 0; i < m; ++i){
        cin >> b[i];
        b[i]--;
    }
    sort(b.begin(), b.end());
    for (int i = 0; i < n; ++i){
        int l = upper_bound(b.begin(), b.end(), ind[i]) - b.begin() - 1;
        int r = lower_bound(b.begin(), b.end(), ind[i]) - b.begin();
        //cout << "test " << i << endl;
        //cout << l << " " << r << endl;
        //cout << (l > -1 ? b[l] : -64) << " " << (r < m ? b[r] : -64) << endl;
        if (l > -1){
            ll score = 0;
            score = ind[i] - b[l];
            score += (T - pref[ind[i]] + pref[b[l]]) / a[ind[i]];
            if (T - pref[ind[i]] + pref[b[l]] > 0){
                //cout << "score1: " << score << endl;
                best = max(best, score);
            }
        }
        if (r < m){
            ll score = 0;
            score = b[r] - ind[i];
            score += (T - pref[b[r] + 1] + pref[ind[i] + 1]) / a[ind[i]];
            if (T - pref[b[r] + 1] + pref[ind[i] + 1] > 0){
                //cout << "score2: " << score << endl;
                best = max(best, score);
            }
        }
    }
    cout << best << endl;
    return 0;
}
