#include <bits/stdc++.h>

using namespace std;
using ll = long long;
ll INF = 1e14;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

struct SegmentTree {
    vector<ll> t;
    vector<ll> a;

    SegmentTree(vector<ll> s) {
        a = s;
        t.resize(2 * s.size());
        build(0, 0, s.size());
    }

    void build(ll v, ll l, ll r) {
        if(r - l == 1) {
            t[v] = a[l];
            return;
        }
        ll m = (r + l) / 2;
        build(lv(v), l, m);
        build(rv(v), m, r);
        t[v] = min(t[lv(v)], t[rv(v)]);
    }

    ll get(ll v, ll l, ll r, ll ql, ll qr) {
        if(ql >= r || l >= qr) {
            return INF;
        }
        if(ql <= l && r <= qr) {
            return t[v];
        }
        ll m = (r + l) / 2;
        return min(get(lv(v), l, m, ql, qr), get(rv(v), m, r, ql, qr));
    }
};

void viperr() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n);
    vector<ll> b(m);
    for(auto &i : a) cin >> i;
    for(auto &i : b) cin >> i;
    vector<ll> pref(n + 1);
    for(ll i = 1;i <= n;i++) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    ll ans = 0;
    for(auto i : b) {
        i--;
        ll ind = i;
        ll sum = 0;
        for(ll j = i;j < n && sum <= t;j++) {
            sum += a[j];
            if(a[j] < a[ind] && sum <= t) {
                ind = j;
            }
            if(sum > t) break;
        }
        ans = max(ans, (t - (pref[ind + 1] - pref[i])) / a[ind] + (ind - i + 1));
        ind = i;
        sum = 0;
        for(ll j = i;j >= 0 && sum <= t;j--) {
            sum += a[j];
            if(a[j] < a[ind] && sum <= t) {
                ind = j;
            }
            if(sum > t) break;
        }
        ans = max(ans, (t - (pref[i + 1] - pref[ind])) / a[ind] + (i - ind + 1));
    }
    cout << ans;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll tt = 1;
    // cin >> tt;
    while(tt--) {
        viperr();
        cout << '\n';
    }
    return 0;
}