#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void build(ll v, vector<pair<ll, ll>> &st, vector<ll> &a, ll l, ll r) {
    if (l == r) {
        st[v] = {a[l], l};
        return;
    }
    ll mid = (l + r) / 2;
    build(v * 2, st, a, l, mid);
    build(v * 2 + 1, st, a, mid + 1, r);
    st[v] = min(st[v * 2], st[v * 2 + 1]);
}

auto get(ll v, vector<pair<ll, ll>> &st, ll lt, ll rt, ll lq, ll rq) {
    if (lt == lq && rt == rq) {
        return st[v];
    }
    ll mid = (lt + rt) / 2;
    if (rq <= mid) {
        return get(v * 2, st, lt, mid, lq, rq);
    }
    if (lq > mid) {
        return get(v * 2 + 1, st, mid + 1, rt, lq, rq);
    }
    auto m1 = get(v * 2, st, lt, mid, lq, mid);
    auto m2 = get(v * 2 + 1, st, mid + 1, rt, mid + 1, rq);
    return min(m1, m2);
}

void solve() {
    ll n, m, T;
    cin >> n >> m >> T;
    vector<ll> a(n), b(m);
    for (ll &i : a) cin >> i;
    for (ll &i : b) {
        cin >> i;
        i--;
    }
    ll prev = 0, ans = 0;
    vector<pair<ll, ll>> st(4 * n);
    build(1, st, a, 0, n - 1);
    for (ll i : b) {
        ll c = T, res1 = 0, k = 0;
        for (ll j = i; j >= prev; j--) {
            res1 = max(res1, k + c / a[j]);
            c -= a[j];
            k++;
            if (c < 0) break;
        }
        c = T;
        ll res2 = 0;
        ll prevm = -1;
        auto [x, pos] = get(1, st, 0, n - 1, i, n - 1);
        //cout << i << ' ' << x << ' ' << pos << '\n';
        for (ll j = i; j <= pos; j++) {
            if (c - a[j] < 0) break;
            res2 = max(res2, j - i + c / a[j]);
            if (res2 > prevm) {
                prevm = res2;
                prev = j;
            }
            c -= a[j];
            //cout << j << ' ' << c << ' ' << res2 << '\n';
        }
        //cout << i << ' ' << res1 << ' ' << res2 << ' ' << prev << '\n';
        ans = max(ans, max(res1, res2));
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}

