#include <iostream>
#include <vector>
#include <math.h>
#include <map>
#include <algorithm>
#include <set>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <string>

typedef long long ll;
typedef long double ld;

using namespace std;

ll const A = 367;
ll const B = 1e9 + 7;
ll o = 0;


ll logpow(ll num, ll deb) {
	ll sum = 1;
	while (deb != 0) {
		if (deb % 2 == 0) {
			num *= num;
			deb /= 2;
		}
		else {
			sum *= num;
			deb--;
		}
	}
	return sum;
}


void solve() {
	ll n, m, t;
	cin >> n >> m >> t;
	vector <ll> field(n+1);
	vector<ll> runer(m+1);
	vector<pair<ll,ll>> hold(m + 1);
	vector<ll> pref(n + 1);
	hold[1].first = 1;
	hold[m].second = n;
	for (ll i = 1; i <= n; i++) {
		cin >> field[i];
		pref[i] = pref[i - 1] + field[i];
	}
	for (ll i = 1; i <= m; i++) {
		cin >> runer[i];
	}
	for(ll i=2;i<=m;i++){
		hold[i - 1].second = runer[i] - 1;
		hold[i].first = runer[i];
		while (pref[runer[i]] - pref[hold[i].first - 1] < pref[hold[i - 1].second] - pref[runer[i - 1] - 1] && hold[i].first-1>runer[i-1]) {
			hold[i].first--;
			hold[i - 1].second--;
		}
	}
	ll ans = 0;
	for (ll i = 1; i <= m; i++) {
		for (ll l = hold[i].first; l <= runer[i]; l++) {
			ans = max(ans, (t - (pref[runer[i]] - pref[l]))/field[l] + (t>= (pref[runer[i]] - pref[l]))*(runer[i]-l));
		}
		for (ll l = hold[i].second; l > runer[i]; l--) {
			ans = max(ans, (t - (pref[l-1] - pref[runer[i]-1])) / field[l] + (t >= (pref[l - 1] - pref[runer[i] - 1])) * (l - runer[i]));
		}
	}
	cout << ans << endl;
}

int main()
{
	ll t = 1;
	//cin>> t;
	while (t--) {
		solve();
	}
}
