#include <bits/stdc++.h>

using namespace std;

void build(vector<int>& A, vector<int>& tree, int n, int t) {
    if (n >= t - 1)
        tree[n] = A[n - t + 1];
    else {
        build(A, tree, 2*n + 1, t);
        build(A, tree, 2*n + 2, t);
        tree[n] = min(tree[2*n + 1], tree[2*n + 2]);
    }
}

int get(vector<int>& tree, int t, int n, int l, int r, int L, int R) {
    if (R <= l || r <= L)
        return 1000000000;
    if (l <= L && r >= R)
        return tree[n];
    else {
        int a = get(tree, t, 2*n + 1, l, r, L, (L + R)/2);
        int b = get(tree, t, 2*n + 2, l, r, (L + R)/2, R);
        return min(a, b);
    }
}

int main()
{
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> A(4*n, 1000000000);
    vector<int> B(m);
    vector<long long> C(n, 0);
    int Min = 1000000000;
    for (int i = 0; i < n; ++i) {
        cin >> A[i];
        Min = min(Min, A[i]);
        if (i == 0)
            C[0] = A[0];
        else
            C[i] = A[i] + C[i-1];
    }
    for (int i = 0; i < m; ++i) {
        cin >> B[i];
        --B[i];
    }

    sort(B.begin(), B.end());
    int T = 1;
    while (T < n)
        T *= 2;
    vector<int> tree (4*n, 1000000000);
    build(A, tree, 0, T);
    if (n == m) {
        cout << t/Min << endl;
    }
    else if (n <= 1000) {
        int cnt;
        int Max = 0;
        for (int i : B) {
            for (int j = 0; j < n; ++j) {
                Min = get(tree, T, 0, min(i, j), max(i, j)+1, 0, T);
                long long sum;
                sum = C[max(i, j)];
                if (min(i, j) != 0)
                    sum -= C[min(i, j) - 1];
                if (t < sum)
                    continue;
                cnt = abs(i - j) + 1;
                cnt += (t - sum) / Min;
                Max = max(Max, cnt);
            }
        }
        cout << Max << endl;
    }
    else if (T <= 20) {
        int cnt;
        int Max = 0;
        for (int i : B) {
            for (int j = max(0, i - 20); j <= min(n-1, i + 20); ++j) {
                Min = get(tree, T, 0, min(i, j), max(i, j)+1, 0, T);
                long long sum;
                sum = C[max(i, j)];
                if (min(i, j) != 0)
                    sum -= C[min(i, j) - 1];
                if (t < sum)
                    continue;
                cnt = abs(i - j) + 1;
                cnt += (t - sum) / Min;
                Max = max(Max, cnt);
            }
        }
        cout << Max << endl;
    }
    else if (A[0] == Min) {
        int k = B[0];
        int cnt = 0;
        while (t >= 0) {
            if (k == 0 && t >= Min) {
                cnt++;
                t -= A[0];
            }
            else if (k > 0 && t >= A[k]) {
                ++cnt;
                t -= A[k];
                --k;
            }
            else
                break;
        }
        cout << cnt << endl;
    }

    return 0;
}
