#include "bits/stdc++.h"
#include "numeric"
using namespace std;

#define forn(i, n) for(ll i=0;i<n;++i)
#define fornn(i, l, r) for(int i=l;i<=r;++i)
#define ford(i, n) for(int i=n-1;i>=0;--i)
#define all(a) (a).begin(),(a).end()
#define rall(a) (a).rbegin(),(a).rend()
#define pb push_back
#define eb emplace_back
#define ff first
#define ss second

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int maxn = 1e5 + 7;
const int logn = 32;
const int mod = 1e9 + 7;

void solve() {
    int n,m; ll t; cin>>n>>m>>t;
    vector<int> a(n);
    vector<int> b(m);
    forn(i,n) cin>>a[i];
    forn(i,m) cin>>b[i];

    vector<ll> dp(n, 0);
    vector<ll> sum(n+1, 0);
    forn(i,n) sum[i+1]=sum[i] + a[i];
    forn(i,n) {
        forn(j,n) {
            ll time = 0;
            if (j<i) time=sum[i+1]-sum[j+1];
            else if (j>i) time=sum[j]-sum[i];
            ll count = max(i,j) - min(i,j);
            if (time>t) continue;
            dp[i]=max({ 0ll, dp[i], (t - time) / a[j] + count });
        }
    }

    ll res = 0;
    forn(i,m) {
        res=max(res,dp[b[i]-1]);
    }
    cout<<res<<endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("C:\\work\\untitled\\a.txt", "r", stdin);
    freopen("C:\\work\\untitled\\out.txt", "w", stdout);

    while (!cin.eof()) {
        solve();
    }
#else
        solve();
#endif

    return 0;
}
