#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solveNN(ll n, ll m, ll T, vector<ll> b, vector<ll> a) {
    vector<ll> pref(n + 1);
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
    }
    ll ans = 0, tmp;
    for (int i : b) {
        for (int j = i; j < n; ++j) {
            if (pref[j] - pref[i] > T) {
                break;
            }
            tmp = (j - i) + (T - pref[j] + pref[i]) / a[j];
            ans = max(ans, tmp);
        }
        for (int j = i; j >= 0; --j) {
            if (pref[i] - pref[j] > T) {
                break;
            }
            tmp = (i - j) + (T - pref[i] + pref[j]) / a[j];
            ans = max(ans, tmp);
        }
    }
    cout << ans << '\n';
}

void solve() {
    ll n, m;
    ll T;
    cin >> n >> m >> T;
    vector<ll> b(m);
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        b[i]--;
    }
    solveNN(n, m, T, b, a);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
