#include <bits/stdc++.h>
#include <bits/extc++.h>

#pragma GCC target("avx2")
#ifndef ABOBA
#pragma GCC optimize("O3")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll inf = 1e18, mod = 1e9 + 7;

void solve() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n), b(m), pref(n + 1), ans(n);
    for (auto &i: a) {
        cin >> i;
    }
    for (auto &i: b) {
        cin >> i;
    }
    for (ll i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
    }
    ll j = 0;
    for (ll i = 0; i < n; ++i) {
        while (j < i && pref[i + 1] - pref[j + 1] > t) ++j;
        ans[i] = i - j + (t - pref[i + 1] + pref[j + 1]) / a[j];
    }
    ll maxx = 0;
    for (ll i = 0; i < m; ++i) {
        maxx = max(maxx, ans[b[i] - 1]);
    }
    cout << maxx;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tt = 1;
    while (tt--) solve();
}