#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> prefsum(3e5);

int get(int l, int r) {
    if (l == 0) {
        return prefsum[r];
    }
    return prefsum[r] - prefsum[l - 1];
}

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    vector<int> b(m);
    for (auto &i : b) {
        cin >> i;
        --i;
    }
    prefsum[0] = a[0];
    for (int i = 1; i < n; ++i) {
        prefsum[i] = a[i] + prefsum[i - 1];
    }
    vector<int> nl(n), nr(n);
    int cnt = -1, pos = 0;
    for (int i = 0; i < n; ++i) {
        if (pos < (int)b.size() && b[pos] == i) {
            ++pos;
            cnt = i;
        }
        nl[i] = cnt;
    }
    cnt = n, pos = m - 1;
    for (int i = n - 1; i >= 0; --i) {
        if (pos >= 0 && b[pos] == i) {
            --pos;
            cnt = i;
        }
        nr[i] = cnt;
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        //cout << i << '\n';
        if (nl[i] == i || nr[i] == i) {
            ans = max(ans, t / a[i]);
            //cout << t / a[i] << ' ';
        }
        if (nl[i] != -1 && get(nl[i], i) <= t) {
            int c1 = i - nl[i] + 1;
            ans = max(ans, c1 + (t - get(nl[i], i)) / a[i]);
            //cout << nl[i] << ' ' << i << ' ' << c1 << ' ' << (t - get(nl[i], i)) << c1 + (t - get(nl[i], i)) / a[i] << ' ';
        }
        if (nr[i] != n && get(i, nr[i]) <= t) {
            int c1 = nr[i] - i + 1;
            ans = max(ans, c1 + (t - get(i, nr[i])) / a[i]);
            //cout << c1 + (t - get(i, nr[i])) / a[i] << ' ';
        }
        //cout << '\n';
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
