#include <iostream>
#include <string>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>


typedef long long ll;
typedef double db;
typedef long double ld;

#define pb push_back
#define sz(s) int(s.size())
#define mp make_pair
#define all(s) s.begin(), s.end()

const int MAX_N = 1e5 + 10;
const int LOG = 20;
const ld EPS = 1e-7;

using namespace std;

int a[MAX_N];
ll pref[MAX_N];
int main () {
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    ll ans_of = -1;
    for (int i = 0; i < m; i++) {
        int start;
        ll ans = 0;
        cin >> start;
        for (int j = 1; j <= n; j++) {
            if (j < start) {
                if (t >= (pref[start] - pref[j - 1])) {
                    ans = max(ans, start - j + 1 + (t -(pref[start] - pref[j - 1])) / a[j]);
                }
            } else {
                if (t >= (pref[j] - pref[start - 1])) {
                    ans = max(ans, j - start + 1 + (t - (pref[j] - pref[start - 1])) / a[j]);
                }
            }
        }
        ans_of = max(ans, ans_of);
    }
    cout << ans_of << endl;
    
    


    
}