#include <bits/stdc++.h>

using namespace std;

using ll = long long;

//#define int long long

const int MAX = 5e5 + 7;
const int mod = 1e9 + 7;

mt19937_64 rng(time(0));

int n, m;
int a[MAX];
int b[MAX];
int c[MAX];
int type[MAX * 3];
int id[MAX * 3];

int to[MAX * 3];
int ptr = 0;

int mem[(1 << 20)][101];

bool win(int mask, int lst) {
    if (lst == ptr + 1) return 0;
    if (mem[mask][lst] != -1) return mem[mask][lst];
    if (type[to[lst]] == 1) {
        if ((mask >> (id[to[lst]] - 1) & 1)) {
            return mem[mask][lst] = win(mask, lst + 1);
        } else {
            bool good = false;
            good |= !win(mask, lst + 1);
            if (b[id[to[lst]]] < a[id[to[lst]]]) {
                good |= win(mask + (1 << (id[to[lst]] - 1)), lst + 1);
            } else {
                good |= !win(mask + (1 << (id[to[lst]] - 1)), lst + 1);
            }
            return mem[mask][lst] = good;
        }
    }
    if (type[to[lst]] == 2) {
        if (!(mask >> (id[to[lst]] - 1) & 1)) {
            return mem[mask][lst] = win(mask, lst + 1);
        } else {
            return mem[mask][lst] = !win(mask, lst + 1);
        }
    }
    if (type[to[lst]] == 3) {
        if ((to[lst + 1] - to[lst]) % 2 == 0) {
            return mem[mask][lst] = win(mask, lst + 1);
        } else {
            return mem[mask][lst] = !win(mask, lst + 1);
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        type[a[i]] = 1;
        id[a[i]] = i;
    }
    for (int i = 1; i <= n; i++) {
        cin >> b[i];
        type[b[i]] = 2;
        id[b[i]] = i;
    }
    for (int i = 1; i <= m; i++) {
        cin >> c[i];
        type[c[i]] = 3;
    }
    ptr = 0;
    for (int i = 1; i <= n * 2 + m; i++) {
        if (type[i] == 1 || type[i] == 2 || (type[i] == 3 && type[i - 1] != 3)) {
            to[++ptr] = i;
        }
    }
    to[ptr + 1] = n * 2 + m + 1;
    for (int mask = (1 << n) - 1; mask >= 0; mask--) {
        mem[mask][ptr + 1] = 0;
        for (int lst = ptr; lst >= 1; lst--) {
            if (type[to[lst]] == 1) {
                if ((mask >> (id[to[lst]] - 1) & 1)) {
                    mem[mask][lst] = mem[mask][lst + 1];
                } else {
                    bool good = false;
                    good |= !mem[mask][lst + 1];
                    if (b[id[to[lst]]] < a[id[to[lst]]]) {
                        good |= mem[mask][lst + 1];
                    } else {
                        good |= !(mem[mask][lst + 1] ^ 1);
                    }
                    mem[mask][lst] = good;
                }
            }
            if (type[to[lst]] == 2) {
                if (!(mask >> (id[to[lst]] - 1) & 1)) {
                    mem[mask][lst] = mem[mask][lst + 1];
                } else {
                    mem[mask][lst] = !mem[mask][lst + 1];
                }
            }
            if (type[to[lst]] == 3) {
                if ((to[lst + 1] - to[lst]) % 2 == 0) {
                    mem[mask][lst] = mem[mask][lst + 1];
                } else {
                    mem[mask][lst] = !mem[mask][lst + 1];
                }
            }
        }
    }
    cout << (mem[0][1] ? "First" : "Second");
}

int32_t main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}