#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, m;
	cin >> n >> m;
	vector<int> a(n), b(n), c(m);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> c[i];
	}
	int x = 2 * n + m + 1, cn = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i] > b[i]) {
			x = min(x, a[i]);
		}
	}
	vector<int> pr(2 * n + m + 1, -1);
	for (int i = 0; i < n; ++i) {
		pr[a[i]] = b[i];
		pr[b[i]] = a[i];
	}
	for (int i = x - 1; i > 0; --i) {
		if (pr[i] > i && pr[i] < x) {
			x = i;
		}
	}
	for (int i = 0; i < m; ++i) {
		if (c[i] < x) {
			++cn;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (a[i] < x && b[i] > x) {
			++cn;
		}
	}
	if (cn % 2 == 0) {
		cout << "First";
	}
	else {
		cout << "Second";
	}

	return 0;
}
