#include <bits/stdc++.h>
using namespace std;

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);


    int n, m;
    cin >> n >> m;
    vector<int> A(n), B(n), C(m);
    for (int& x : A) cin >> x;
    for (int& x : B) cin >> x;
    for (int& x : C) cin >> x;

    set<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.emplace(A[i], B[i]);
    }
    for (int i = 0; i < m; i++) {
        s.emplace(C[i], -1);
    }
    int steps = 0;
    while (!s.empty()) {
        steps ^= 1;
        auto [x, y] = *s.begin();
        s.erase(s.begin());
        if (y == -1) {
            continue;
        }
        if (s.size() % 2 == 1) {
            s.emplace(y, -1);
        }
    }
    cout << (steps ? "First" : "Second");
    return 0;
}