#include <bits/stdc++.h>
#pragma GCC optimize("O3")
using namespace std;
const int INF = 1e9;


int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);


    int n, m;
    cin >> n >> m;
    vector<int> A(n), B(n), C(m);
    for (int &x: A) cin >> x;
    for (int &x: B) cin >> x;
    for (int &x: C) cin >> x;

    map<int, int> mp, pref;
    for (int i = 0; i < n; i++) {
        mp[max(A[i], B[i])] = A[i];
    }
    pref[-1] = -1;
    for (auto [v, x] : mp) {
        pref[v] = max(pref.rbegin()->second, x);
    }
    // max A[i], max(A[i], B[i]) < x && B[i] < x
    int want = INF;
    auto it = --pref.end();
    while (true) {
        while (it->first >= want) --it;
        int pos = it->second;
        if (pos == -1) {
            break;
        }
        want = pos;
    }
    vector<int> T(n + m);
    for (int i = 0; i < n; i++) {
        T[i] = A[i];
    }
    for (int i = 0; i < m; i++) {
        T[i + n] = C[i];
    }
    sort(T.begin(), T.end());
    int steps = 0;
    for (int x : T) {
        steps ^= 1;
        if (x == want) {
            break;
        }    
    }
    cout << (steps ? "First" : "Second");
    return 0;
}