//#pragma GCC optimize("unroll-loops, Ofast")
//#pragma GCC target("sse,sse2,avx,avx2")

#include <bits/stdc++.h>

using namespace std;
mt19937 rnd(25892);
const int inf = 1e9;
int n, m;
vector<int> a, b, c;

void solve() {
    cin >> n >> m;
    a.assign(n, 0), b.assign(n, 0), c.assign(m, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
    }
    sort(c.begin(), c.end());
    vector<pair<int, int>> ab(n);
    for (int i = 0; i < n; ++i) {
        ab[i] = {a[i], b[i]};
    }
    sort(ab.begin(), ab.end());
    vector<int> dp(n, 0);
    dp[n - 1] = 1;
    for (int i = n - 2; i >= 0; --i) {
        int A = ab[i].first;
        int B = ab[i].second;
        int cnt = lower_bound(c.begin(), c.end(), ab[i + 1].first) - upper_bound(c.begin(), c.end(), A);
        if (cnt % 2 == 1) {
            dp[i] = dp[i] | dp[i + 1];
        } else {
            dp[i] = dp[i] | !dp[i + 1];
        }
        if (B < ab[i + 1].first) {
            cnt++;
        }
        if (cnt % 2 == 1) {
            dp[i] = dp[i] | dp[i + 1];
        } else {
            dp[i] = dp[i] | !dp[i + 1];
        }
    }
    int cn = 1;
    for (int i = 0; i < m; ++i) {
        if (c[i] < ab[i].first) {
            cn++;
        }
    }
    if (cn % 2 == 0) {
        if (!dp[0]) {
            cout << "First";
        } else {
            cout << "Second";
        }
    } else {
        if (dp[0]) {
            cout << "First";
        } else {
            cout << "Second";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}
