#include <bits/stdc++.h>

#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long ll;
//#define int ll
#define pb push_back
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int N = 5e5 + 10;

int n, m, a[N], b[N], c[N];
int sec[N];
ordered_set s3;
map<pair<set<int>, set<int>>, bool> mp;

bool win(set<int> s1, set<int> s2) {
    if((int)s1.size() == 0 && (int)s2.size() == 0) return (m % 2) == 1;
    if(mp.find({s1, s2}) != mp.end()) return mp[{s1, s2}];
    int mn1 = INF, mn2 = INF;
    if((int)s1.size() > 0) mn1 = *s1.begin();
    if((int)s2.size() > 0) mn2 = *s2.begin();
    int mn = min(mn1, mn2);
    bool ans = false;
    if(mn1 == mn) {
        s1.erase(mn);
        if(!win(s1, s2)) ans = true;
        else {
            s2.insert(sec[mn]);
            if(!win(s1, s2)) ans = true;
            s2.erase(sec[mn]);
        }
        s1.insert(mn);
    } else if(mn2 == mn) {
        s2.erase(mn);
        if(!win(s1, s2)) ans = true;
        s2.insert(mn);
    }
    mp[{s1, s2}] = ans;
    return ans;
}

void solve() {
    cin >> n >> m;
    for(int i = 1; i <= n; ++i) cin >> a[i];
    for(int i = 1; i <= n; ++i) {
        cin >> b[i];
        sec[a[i]] = b[i];
    }
    for(int i = 1; i <= m; ++i) cin >> c[i];

    set<int> s1, s2;
    for(int i = 1; i <= n; ++i) s1.insert(a[i]);
    for(int i = 1; i <= m; ++i) s3.insert(c[i]);

    int first_move = 0;

    while(m > 0 && *s3.begin() < *s1.begin()) {
        --m;
        s3.erase(s3.begin());
        first_move ^= 1;
    }

    if(first_move == 0) {
        if(win(s1, s2)) cout << "First";
        else cout << "Second";
    } else {
        if(win(s1, s2)) cout << "Second";
        else cout << "First";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    auto start = clock();
#endif
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
#ifdef LOCAL
    auto end = clock();
    cerr << "TIME: " << (end - start) << "ms" << '\n';
#endif
}