#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < m; i++) cin >> c[i];
    sort(c.begin(), c.end());
    int mn = (int) 1e18;
    for (int i = 0; i < n; i++) if (a[i] > b[i]) mn = min(mn, a[i]);
    vector<pair<int, int>> seg;
    if (mn != (int) 1e18) {
        for (int i = 0; i < n; i++)
            if (max(a[i], b[i]) < mn)
                seg.emplace_back(a[i], b[i]);
        n = (int) seg.size();
        if (n == 0) {
            int cnt = 0;
            for (int i = 0; i < m; i++) {
                if (c[i] >= mn) break;
                cnt++;
            }
            cout << (cnt % 2 == 0 ? "First" : "Second");
            return 0;
        }
    } else {
        for (int i = 0; i < n; i++) seg.emplace_back(a[i], b[i]);
    }
    sort(seg.begin(), seg.end());
    for (int i = 0; i < n; i++) {
        a[i] = seg[i].first, b[i] = seg[i].second;
    }
    int dp[n];
    for (int i = n - 1; i >= 0; i--) {
        int cur = 0, move = 0, prev = a[i];
        while (cur + 1 < m && c[cur + 1] <= prev) cur++;
        for (int j = i + 1; j < n; j++) {
            if (a[j] >= a[i] && b[j] <= b[i]) {
                int cnt = 0;
                if (cur < m && c[cur] <= a[j]) {
                    while (cur + 1 < m && c[cur + 1] <= a[j]) cur++, cnt++;
                }
                if (cnt % 2 == 1) move = 1 - move;
                if (dp[j] == 1) move = 1 - move;
            }
        }
        dp[i] = move;
    }
    int move = 0, pA = -1, pB = -1, cur = 0;
    for (int i = 0; i < n; i++) {
        if (a[i] > pB) {
            int cnt = 0;
            if (cur < m && c[cur] <= a[i]) {
                while (cur + 1 < m && c[cur + 1] <= a[i]) cur++, cnt++;
            }
            if (cnt % 2 == 1) move = 1 - move;
            if (dp[i] == 1) move = 1 - move;
            pA = a[i], pB = b[i];
        }
    }
    cout << (move == 1 ? "First" : "Second");
    return 0;
}