#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
using ull = long long;
using ld = long double;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int N = 5e5;
pair<int, int> a[N];
int b[N], n, m;
int used[3 * N + 1];
vector<pair<int, int>> v;

int rec(int pos) {
    if (pos == (int) v.size()) {
        return 0;
    }
    auto [x, i] = v[pos];
    if (i >= 0) {
        if (a[i].first > a[i].second) {
            return 1;
        } else {
            if (rec(pos + 1) == 0) {
                return 1;
            }
            used[a[i].second] = 1;
            if (rec(pos + 1) == 0) {
                used[a[i].second] = 0;
                return 1;
            }
            used[a[i].second] = 0;
        }
    } else {
        if (used[x]) {
            return rec(pos + 1);
        } else {
            return rec(pos + 1) ^ 1;
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        v.emplace_back(a[i].first, i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
        if (a[i].second > a[i].first) {
            v.emplace_back(a[i].second, -i - 1);
        }
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        v.emplace_back(b[i], -i - 1);
    }
    sort(all(v));
    cout << (rec(0) ? "First" : "Second");
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
