#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

auto seed = std::chrono::steady_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

using ll = long long;

#define int ll

using vi = vector<int>;
using pii = pair<int, int>;
using vp = vector<pair<int, int>>;
using vv = vector<vector<int>>;

template<class T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
    int n, m;
    cin >> n >> m;
    vp a(n + m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
    }
    for (int i = n; i < n + m; ++i) {
        cin >> a[i].first;
        a[i].second = a[i].first;
    }
    std::sort(a.rbegin(), a.rend());
    auto srt = a;
    std::reverse(srt.begin(), srt.end());
    vi dp(n + m);
    dp[0] = 1;
    int last = 0;
    vi pref(n + m + 1);
    for (int i = 0; i < n + m; ++i) {
        if (a[i].first > a[i].second || a[i].second < a[i - 1].first && a[i].second != a[i].first) {
        } else if (a[i].first == a[i].second) {
        } else {
            pii c = {a[i].second, -1};
            int j = lower_bound(srt.begin(), srt.end(), c) - srt.begin();
            j = n + m - j - 1;
            pref[j + 1]++;
        }
    }
    for (int i = 1; i < n + m; ++i) {
        pref[i + 1] += pref[i];
        if (a[i].first > a[i].second || a[i].second < a[i - 1].first && a[i].second != a[i].first) {
            dp[i] = 1;
            last = i;
        } else if (a[i].first == a[i].second) {
            dp[i] = 1 ^ dp[i - 1];
        } else {
            if (dp[i - 1] == 0) {
                dp[i] = 1;
            } else {
                pii c = {a[i].second, -1};
                int j = lower_bound(srt.begin(), srt.end(), c) - srt.begin();
                j = n + m - j - 1;
                if (j < last) {
                    dp[i] = dp[i - 1] ^ 1;
                    continue;
                }
                if (pref[i + 1] - pref[j] == 0) {
                    last = i;
                }
                dp[i] = 1;
            }
        }
    }
    if (dp.back()) {
        cout << "First";
    } else {
        cout << "Second";
    };
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
    freopen("C:\\work\\untitled\\output.txt", "w", stdout);
    auto start = std::chrono::steady_clock::now();
#else
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(0);
#endif
    int t_ = 1;
    //cin>>t;
    while (t_--) {
        solve();
    }

#ifdef LOCAL
    auto end = std::chrono::steady_clock::now();
    cout << "\n======\n";
    cout << chrono::duration_cast<chrono::milliseconds>(end - start);
#endif
}
