#pragma GCC optimize("O3")
//#pragma GCC target("avx")

#include <bits/extc++.h>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i];
    }
    sort(c.begin(), c.end());
    {
        vector<int> ord(n);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int i, int j) {
            return a[i] < a[j];
        });
        auto aa = a;
        auto bb = b;
        for (int i = 0; i < n; i++) {
            a[i] = aa[ord[i]];
            b[i] = bb[ord[i]];
        }
    }
    vector<tuple<int, int, int, int>> AA(1 << n);
    for (int mask = (1 << n) - 1; mask >= 0; mask--) {
        tuple<int, int, int, int> mn = {1e9, -1, -1, -1};
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1) {
                mn = min(mn, {b[i], 0, i, 1});
            }
        }
        AA[mask] = mn;
    }
    vector<tuple<int, int, int, int>> BB(n + 1);
    for (int U = 0; U <= n; U++) {
        tuple<int, int, int, int> mn = {1e9, -1, -1, -1};
        for (int i = 0; i < n; i++) {
            if (i >= U) {
                mn = min(mn, {a[i], 0, i, 0});
            }
        }
        BB[U] = mn;
    }
    vector dp(n + 1, vector<bitset<(1 << 20) + 2>>(m + 1));
    for (int x = n; x >= 0; x--) {
        for (int y = m; y >= 0; y--) {
            for (int mask = (1 << n) - 1; mask >= 0; mask--) {
                int U = x + __builtin_popcount(mask);
                if (U > n) {
                    continue;
                }
                if (x == n && y == m) {
                    dp[n][m][0] = 0;
                    continue;
                }
                tuple<int, int, int, int> mn = {1e9, -1, -1, -1};
                mn = min(mn, AA[mask]);
                mn = min(mn, BB[U]);
                if (y < m) {
                    mn = min(mn, {c[y], 1, y, 0});
                }
                if (get<1>(mn) == 1) {
                    dp[x][y][mask] = !dp[x][y + 1][mask];
                } else {
                    int p = get<2>(mn);
                    // cerr << "!! " << p << '\n';
                    if (get<3>(mn) == 1) {
                        dp[x][y][mask] = !dp[x + 1][y][mask ^ (1 << p)];
                    } else {
                        if (dp[x][y][mask ^ (1 << p)] == 0 || dp[x + 1][y][mask] == 0) {
                            dp[x][y][mask] = true;
                        }
                    }
                }
//                assert(dp[x][y][mask] == 0 || dp[x][y][mask] == 1);
            }
        }
    }
    cout << (dp[0][0][0] ? "First" : "Second") << '\n';
    return 0;
}
/*

2 1
5 3
1 2
4

1 2
2
3
4 1

 #include <bits/extc++.h>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i], a[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i], b[i]--;
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i], c[i]--;
    }
    {
        auto aa = a;
        auto bb = b;
        vector<int> ord(n);
        for (int i = 0; i < n; i++) {
            ord[i] = i;
        }
        sort(ord.begin(), ord.end(), [&](int i, int j) {
            return a[i] < a[j];
        });
        for (int i = 0; i < n; i++) {
            a[i] = aa[ord[i]];
            b[i] = bb[ord[i]];
        }
    }
    vector<tuple<int, int, int>> z;
    for (int i = 0; i < n; i++) {
        z.emplace_back(a[i], 0, i);
    }
    for (int i = 0; i < m; i++) {
        z.emplace_back(c[i], 1, i);
    }
    sort(z.begin(), z.end());
    int N = 2 * n + m;
    vector<int> id(N, -1);
    for (int i = 0; i < n; i++) {
        id[b[i]] = id[a[i]] = i;
    }
    vector dp(N, vector<int>(n + 1));
    for (int i = N - 1; i >= 0; i--) {
        for (int cnt = 0; cnt <= n; cnt++) {
            if (cnt > 0 && a[cnt - 1] >= i) {
                break;
            }

        }
    }
    cout << (dp[0][0] ? "First" : "Second") << '\n';
    return 0;
}
/*

2 1
5 3
1 2
4

1 2
2
3
4 1

 */
