#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <fstream>
#include <algorithm>
#include <unordered_map>

using ll = long long;
#define endl '\n'
 #pragma GCC target("avx,avx2,fma")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("O3")
// #pragma GCC optimize("unrool-loops")

using namespace std;

const int N = 1500000 + 1, mod = 1e9 + 7;
int n, m, k, q;
int st = 1;

pair<int, int> a[N];
vector<int> rr;
unordered_map<ll, int> dp;
int solver(int l, int r) {
    if (dp.find(l * 1e9 + r) != dp.end()) return dp[l * 1e9 + r];
    for (int i = l; i < r; i++) {
        if (a[i].second != -1) {
            int xx = solver(i + 1, rr[i]);
            if (xx == -1) {
                return dp[l * 1e9 + r] = ((i - l) % 2);
            }
        }
    }
    return dp[l * 1e9 + r] = -1;
}



#define LOCAL
signed main() {
	ios_base::sync_with_stdio(false);
	cout.tie(0);
	cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif 
    cin >> n >> m;
    for (int i = 0; i < n; i++) cin >> a[i].first;
    for (int i = 0; i < n; i++) cin >> a[i].second; 
    for (int i= n; i < n + m; i++){cin >> a[i].first;a[i].second = -1;}
    sort(a, a + n + m); 
    rr.resize(n + m);
    for (int i = 0; i < n + m; i++) {
        rr[i] =  (lower_bound(a + i, a + n + m, make_pair(a[i].second, -1)) - a);
    }
	int x = solver(0, n + m);
    if (x == 0 || (x == -1 && (n + m) % 2==1)) {cout << "First\n";}
    else {cout << "Second\n";}
}