#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <unordered_set>
#include <algorithm>

using namespace std;

using ll = long long;

#pragma GCC optimaze("Ofast");

vector<unordered_set<int>> gr, grr;

vector<int> us;
vector<int> top;
vector<int> ok;
set<pair<int, int>> ed;
ll n, m, t;

void dfs(int v) {
	us[v] = 1;
	for (int u : gr[v]) {
		if (us[u]) continue;
		dfs(u);
	}
	top.push_back(v);
}

void dfs2(int v, int T) {
	us[v] = T;
	for (int u : grr[v]) {
		if (us[u]) continue;
		if (ed.count({ min(u, v), max(u, v) })) {
			if (ok[v] == ok[u]) dfs2(u, T);
			else continue;
		}
		dfs2(u, T);
	}
}

vector<int> css() {
	int T = 1;
	for (int i = 0; i < n; i++) us[i] = 0;
	for (int i = n - 1; i > -1; i--) {
		if (us[top[i]]) continue;
		dfs2(top[i], T);
		T++;
	}
	return us;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, m;
	cin >> n >> m;
	vector<int> l(n), r(n);
	for (int i = 0; i < n; i++) cin >> l[i];
	for (int i = 0; i < n; i++) cin >> r[i];
	set<pair<int, int>> sel, ser;
	for (int i = 0; i < n; i++) {
		sel.insert({ -l[i], r[i] });
		ser.insert({ -r[i], l[i] });
	}
	set<int> se;
	for (int i = 0; i < m; i++) {
		int x;
		cin >> x;
		se.insert(-x);
	}
	int f = 1;
	while (int(ser.size())) {
		pair<int, int> p = *ser.begin();
		ser.erase(p);
		/*f *= -1;
		sel.erase({ -p.second, -p.first });
		p.first *= -1;
		while (int(se.size()) && -(*se.begin()) > p.second) se.erase(*se.begin());
		while (int(sel.size()) && -(*sel.begin()).first > p.second) {
			pair<int, int> p2 = *sel.begin();
			sel.erase(p2);
			ser.erase({ -p2.second, -p2.first });
		}*/
	}
	if (f == 1) {
		if (int(se.size()) % 2 == 1) cout << "First\n";
		else cout << "Second\n";
	}
	else {
		if (int(se.size()) % 2 == 0) cout << "First\n";
		else cout << "Second\n";
	}
}



