#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <unordered_set>
#include <algorithm>

using namespace std;

using ll = long long;

#pragma GCC optimaze("Ofast");

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, m;
	cin >> n >> m;
	vector<int> l(n), r(n);
	for (int i = 0; i < n; i++) cin >> l[i];
	for (int i = 0; i < n; i++) cin >> r[i];
	set<pair<int, int>> sel;
	vector<pair<int, int>> ser;
	for (int i = 0; i < n; i++) {
		sel.insert({ -l[i], r[i] });
		ser.push_back({ -r[i], l[i] });
	}
	sort(ser.begin(), ser.end());
	vector<int> se(n * 2 + m+1);
	for (int i = 0; i < m; i++) {
		int x;
		cin >> x;
		se[x] = 1;
	}
	int f = 1;
	int R = n - 1;
	int L = n + m+1;
	while (int(sel.size())) {
		pair<int, int> p = *sel.begin();
		L = -p.first;
		sel.erase(p);
		f = -1;
		p.first *= -1;
		while (R != -1 && -ser[R].first > p.first) {
			sel.erase({ -ser[R].second, -ser[R].first });
			se[ser[R].second] = 1;
			R--;
		}

		/*while (int(ser.size()) && -(*ser.begin()).first > p.first) {
			pair<int, int> p2 = *ser.begin();
			ser.erase(p2);
			sel.erase({ -p2.second, -p2.first });
			se[-p2.second]=1;
		}*/
		
	}
	int sz = 0;
	for (int i = 0; i < L; i++) sz += se[i];
	if (f == 1) {
		if (sz % 2 == 1) cout << "First\n";
		else cout << "Second\n";
	}
	else {
		if (sz % 2 == 0) cout << "First\n";
		else cout << "Second\n";
	}
}



