#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#define endl '\n'
#define int long long

using namespace std;

bool gen(vector<pair<int, int>> &a) {
    if ((int)a.size() == 0) {
        return false;
    }
    int ind = 0;
    for (int i = 0; i < (int)a.size(); ++i) {
        if (a[i].first < a[ind].first) {
            ind = i;
        }
    }
    vector<pair<int, int>> b, c;
    b = a;
    if (a[ind].second != -1) {
        b[ind] = {b[ind].second, -1};
        if (!gen(b)) {
            return true;
        }
    }
    for (int i = 0; i < (int)a.size(); ++i) {
        if (i != ind) {
            c.push_back(a[i]);
        }
    }
    if (!gen(c)) {
        return true;
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
    }
    vector<pair<int, int>> cur;
    for (int i = 0; i < n; ++i) {
        cur.push_back({a[i], b[i]});
    }
    for (int i = 0; i < m; ++i) {
        cur.push_back({c[i], -1});
    }
    if (gen(cur)) {
        cout << "First" << endl;
    } else {
        cout << "Second" << endl;
    }
    return 0;
}
