#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#define endl '\n'
#define int long long

using namespace std;

bool gen(vector<pair<int, int>> &a) {
    vector<pair<int, int>> b = a;
    sort(b.begin(), b.end());
    reverse(b.begin(), b.end());
    int ok = 0;
    while (!b.empty() && b.back().second == -1) {
        ok = 1 - ok;
        b.pop_back();
    }
    if (b.empty()) {
        return ok;
    }
    if (ok) {
        b.back() = {b.back().second, -1};
        if (!gen(b)) {
            return true;
        }
        b.pop_back();
        if (!gen(b)) {
            return true;
        }
        return false;
    } else {
        b.back() = {b.back().second, -1};
        if (!gen(b)) {
            return false;
        }
        b.pop_back();
        if (!gen(b)) {
            return false;
        }
        return true;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
    }
    vector<pair<int, int>> cur;
    for (int i = 0; i < n; ++i) {
        cur.push_back({a[i], b[i]});
    }
    for (int i = 0; i < m; ++i) {
        cur.push_back({c[i], -1});
    }
    if (gen(cur)) {
        cout << "First" << endl;
    } else {
        cout << "Second" << endl;
    }
    return 0;
}
