#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}






int main() {
//    cout.setf(ios::fixed); cout.precision(15);
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int n, m;
    cin >> n >> m;
    vector<pii> ab(n); vector<int> c(m);
    for (int i=0; i<n; i++) cin >> ab[i].first;
    for (int i=0; i<n; i++) cin >> ab[i].second;
    for (int i=0; i<m; i++) cin >> c[i];

    if (n==0) {
        if (m%2) cout << "First";
        else cout << "Second";
        return 0;
    }

    sort(ab.begin(), ab.end());
    vector<vector<bool>> dp(n, vector<bool>(1<<n));
    for (int i=n-1; i>=0; i--) {
        int lensuf = n-i;
        for (int tmp1=0; tmp1<(1<<lensuf); tmp1++) {
            int mask = tmp1 << i;
            if (((mask>>i)&1) != 0) continue;
            if (i==n-1) dp[i][mask] = 1;

            if (dp[i][mask]==0) {
                int nxt = mask;
                if ((nxt>>i)&1) nxt ^= (1<<i);
                if (i+1<n && dp[i+1][nxt]) dp[i][mask] = 1;
            }
            if (dp[i][mask]==0) {
                if (ab[i].second < ab.back().first) {
                    int id = n-1;
                    while (id>0 && ab[id-1].first > ab[i].second) id--;

                    int nxt = mask;
                    if ((nxt>>i)&1) nxt ^= (1<<i);
                    for (int j=id; j>i; j--) nxt ^= (1<<j);
                    if (dp[i+1][nxt]) dp[i][mask] = 1;
                }
            }
        }
    }

    vector<int> vals;
    vector<pii> nums;
    for (int i=0; i<n; i++) nums.push_back({ab[i].first, 1});
    for (int i=0; i<m; i++) nums.push_back({c[i], 2});
    sort(nums.begin(), nums.end());
    int now = 2;
    for (int i=0; i<sz(nums); i++) {
        now = 3-now;
        if (nums[i].second==1) vals.push_back(now);
    }

    int mask = 0;
    for (int i=0; i<n; i++) {
        if (vals[i]==2) mask ^= (1<<i);
    }

    if (dp[0][mask]) cout << "First";
    else cout << "Second";



    return 0;
}