//#pragma GCC optimize("O3")
#include <bits/stdc++.h>
//#pragma GCC target("avx, avx2, tune=native")
#define int long long
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define pi pair<int, int>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    if (n == 0) {
        cout << (m % 2 ? "First\n" : "Second\n");
        return;
    }
    vector<int> a(n), b(n), c(m);
    vector<pi> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        p[i].f = a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        p[i].s = b[i];
    }
    p.push_back({1e18, 1e18});
    sort(all(p));
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
    }
    sort(all(c));
    vector<int> toprev(n + 1);
    toprev[0] = lower_bound(all(c), p[0].f) - c.begin();
    toprev[0] %= 2;
    for (int i = 1; i <= n; ++i) {
        toprev[i] = lower_bound(all(c), p[i].f) - lower_bound(all(c), p[i - 1].f);
        toprev[i] %= 2;
    }
    vector<vector<bool>> dp(n + 1);
    for (int i = 1; i <= n; ++i) {
        dp[i].assign((1ll << (i - 1)), 0);
        if (i == n) {
            dp[i].assign((1ll << (i - 1)), 1);
        }
    }
    for (int i = n - 1; i >= 1; --i) {
        for (int mask = 0; mask < (1ll << (i - 1)); ++mask) {
            int cr = toprev[i];
            for (int j = 0; j < n; ++j) {
                if (mask & (1 << j) && p[j].s > p[i - 1].f && p[j].s < p[i].f) {
                    ++cr;
                }
            }
            cr %= 2;
            if (cr) {
                dp[i][mask] = dp[i + 1][mask];
                dp[i][mask] = dp[i][mask] || dp[i + 1][mask | (1 << (i - 1))];
            } else {
                dp[i][mask] = dp[i][mask] || !dp[i + 1][mask];
                dp[i][mask] = dp[i][mask] || !dp[i + 1][mask | (1 << (i - 1))];
            }
        }
    }
    int res = dp[1][0];
    res += toprev[0];
    cout << (res % 2 ? "First\n" : "Second\n");
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
