// Created by rost on 08.03.25.

#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

using pq = priority_queue<int, vector<int>, greater<>>;

vector<int> nxt;
vector<int> c;

int dfs(pq order, int turn, int prev) {
    while (!order.empty() && nxt[order.top()] == -1) {
        turn = 1 - turn;
        order.pop();
    }


    int cCnt = int(lower_bound(c.begin(), c.end(), (order.empty() ? int(1e9) : order.top())) -
                   lower_bound(c.begin(), c.end(), prev));
    if (cCnt & 1)
        turn = 1 - turn;

    if (order.empty()) {
        return 1 - turn;
    }

    int cur = order.top();
    int add = nxt[order.top()];
    order.pop();

    int res = dfs(order, 1 - turn, cur);
    if (res == turn)
        return turn;
    order.push(add);
    res = dfs(order, 1 - turn, cur);
    if (res == turn)
        return turn;

    return 1 - turn;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#endif

    int n, m;
    cin >> n >> m;
    nxt.resize(2 * n + m + 1, -1);
    vector<int> a(n), b(n);
    c.resize(m);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        nxt[a[i]] = b[i];
    }
    for (int i = 0; i < m; ++i)
        cin >> c[i];
    sort(c.begin(), c.end());

    pq order;
    for (int i = 0; i < n; ++i)
        order.push(a[i]);

    int res = dfs(order, 0);
    if (res == 0) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}