#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//using ll = int;
using ld = long double;
using ull = unsigned long long;
#define pb push_back
#define all(vec) vec.begin(), vec.end()
#define eb emplace_back
#ifdef LOCAL
#define deb(x) cout << #x << " = " << x << '\n'
#else
#define deb(x) 52
#endif
const ll inf = 1e9 + 11;
const long long INF = (long long)2e18 + 11;
const ll P = 73;
const ll MOD = 1e9 + 7;


void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> a(n), b(n), c(m);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (ll i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (ll i = 0; i < m; ++i) {
        cin >> c[i];
    }
    vector<ll> p(n);
    for (ll i = 0; i < n; ++i) {
        p[i] = i;
    }
    sort(all(p), [&](ll i, ll j) {
        return a[i] < a[j];
    });
    ll k = 2 * n + m;
    vector<ll> cnt(k + 1);
    for (ll i = 0; i < m; ++i) {
        ++cnt[c[i]];
    }
    for (ll i = 1; i <= k; ++i) {
        cnt[i] += cnt[i - 1];
    }
    auto get = [&](ll l, ll r) -> ll {
        return cnt[r - 1] - cnt[l - 1];
    };
    ll v = get(1, a[0]);
    if (v % 2 == 0) {
        cout << "First";
    } else {
        cout << "Second";
    }
}


int main() {
#ifdef LOCAL
    freopen("C:/work/untitled/input.txt", "r", stdin);
    freopen("C:/work/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}