//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
//#include<ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>

using ll = long long;
using ld = long double;
const ll inf = 1e18;
const ll MOD = 1e9 + 7;

#define all(a) a.begin(), a.end()
#define pb push_back

using namespace std;
using namespace literals;
//using namespace __gnu_pbds;

//using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>
//gp_hash_table<ll, ll> s;

mt19937 rnd;

void solve();
void precalc();

int main() {
#ifdef LOCAL:
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
    const auto start = chrono::steady_clock::now();
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    precalc();
    bool cfmode = false;
    if(cfmode) {
        ll t;
        cin >> t;
        while(t--) {
            solve();
        }
    } else {
        solve();
    }
#ifdef LOCAL:
    const auto end = chrono::steady_clock::now();
    cout << "\n";
    cout << fixed << setprecision(10) << "xxxTIMExxx: " << (end - start) / 1ms;
#endif
}

void precalc() {

}

vector<ll> a;
vector<ll> b;
vector<ll> c;

struct elem {
    ll x, type, num;
};

vector<elem> al;

auto comp = [] (elem t1, elem t2) {
    if(t1.x == t2.x) {
        return t1.type < t2.type;
    }
    return t1.x < t2.x;
};

set<elem, decltype(comp)> cur(comp);

bool rec(ll player) {
    if(cur.size() == 0) {
        if(player == 0) {
            return false;
        } else {
            return true;
        }
    }
    elem t = *cur.begin();
    cur.erase(t);
    if(t.type == 1 || t.type == 0) {
        bool t1 = rec((player + 1) & 1);
        cur.insert(t);
        if(player == 0) {
            return t1;
        } else {
            return !t1;
        }
    } else if(t.type == 0) {
        bool t1 = rec((player + 1) & 1);
        cur.insert({b[t.num], 0, t.num});
        bool t2 = rec((player + 1) & 1);
        cur.erase({b[t.num], 0, t.num});
        cur.insert(t);
        if(player == 0) {
            return t1 | t2;
        } else {
            return !(t1 | t2);
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for(int i = 0; i < n; i++) {
        cin >> b[i];
        if(b[i] < a[i]) {
            b[i] = a[i];
        }
    }
    for(int i = 0; i < m; i++) {
        cin >> c[i];
    }
    for(int i = 0; i < n; i++) {
        elem t;
        t.x = a[i];
        t.type = -1;
        t.num = i;
        cur.insert(t);
    }
    for(int i = 0; i < m; i++) {
        elem t;
        t.x = c[i];
        t.type = 1;
        t.num = i;
        cur.insert(t);
    }
    if(rec(0)) {
        cout << "First";
    } else {
        cout << "Second";
    }
}
