//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
//#include<ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>

using ll = int;
using ld = long double;
const ll inf = 1e18;
const ll MOD = 1e9 + 7;

#define all(a) a.begin(), a.end()
#define pb push_back

using namespace std;
using namespace literals;
//using namespace __gnu_pbds;

//using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>
//gp_hash_table<ll, ll> s;

mt19937 rnd;

void solve();
void precalc();

int main() {
#ifdef LOCAL:
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
    const auto start = chrono::steady_clock::now();
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    precalc();
    bool cfmode = false;
    if(cfmode) {
        ll t;
        cin >> t;
        while(t--) {
            solve();
        }
    } else {
        solve();
    }
#ifdef LOCAL:
    const auto end = chrono::steady_clock::now();
    cout << "\n";
    cout << fixed << setprecision(10) << "xxxTIMExxx: " << (end - start) / 1ms;
#endif
}

void precalc() {

}

vector<ll> a;
vector<ll> b;
vector<ll> c;

vector<pair<ll, pair<ll, ll>> > al;

set<pair<ll, pair<ll, ll>>> cur;

bool rec(ll player) {
    if(cur.size() == 0) {
        return false;
    }
    pair<ll, pair<ll, ll>>  t = *cur.begin();
    cur.erase(t);
    if(t.second.first == 1 || t.second.first == 0) {
        bool t1 = rec((player + 1) & 1);
        cur.insert(t);
        return !t1;
    } else {
        bool t1 = rec((player + 1) & 1);
        if(!t1) {
            cur.insert(t);
            return true;
        }
        cur.insert({b[t.second.second], {0, t.second.second}});
        bool t2 = rec((player + 1) & 1);
        cur.erase({b[t.second.second], {0, t.second.second}});
        cur.insert(t);
        return !t2;
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for(int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for(int i = 0; i < n; i++) {
        cin >> b[i];
        if(b[i] < a[i]) {
            b[i] = a[i];
        }
    }
    for(int i = 0; i < m; i++) {
        cin >> c[i];
    }
    for(int i = 0; i < n; i++) {
        pair<ll, pair<ll, ll>>  t;
        t.first = a[i];
        t.second.first = -1;
        t.second.second = i;
        cur.insert(t);
    }
    for(int i = 0; i < m; i++) {
        pair<ll, pair<ll, ll>>  t;
        t.first = c[i];
        t.second.first = 1;
        t.second.second = i;
        cur.insert(t);
    }
    if(rec(0)) {
        cout << "First";
    } else {
        cout << "Second";
    }
}
