#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);


using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m;
    cin >> n >> m;

    vector<pair<int, int>> a(n);
    vector<int> c(m);

    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        cin >> a[i].second;
    }
    cin >> c;
    vector<vector<pair<int, int>>> tm((1 << n));
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<pair<int, int>> vals;
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                if (a[i].first < a[i].second) {
                    vals.push_back({a[i].first, i});
                    vals.push_back({a[i].second, 1e9});
                } else {
                    vals.push_back({a[i].first, i});
                    vals.push_back({a[i].first, 1e9});
                }
            } else {
                vals.push_back({a[i].first, 1e9});
            }
        }
        for (int i = 0; i < m; ++i) {
            vals.push_back({c[i], 1e9});
        }
        std::sort(vals.begin(), vals.end());
        tm[mask] = vals;
    }

    vector<vector<int>> dp((1 << n), vector<int>(2 * n + m + 1));
    for (int i = 2 * n + m - 1; i >= 0; --i) {
        for (int mask = 0; mask < (1 << n); ++mask) {
            if (i >= tm[mask].size()) continue;
            vector<int> vals;
            int id = tm[mask][i].second;
            if (id == 1e9)vals.push_back(dp[mask][i + 1]);
            else {
                vals.push_back(dp[mask][i + 1]);
                vals.push_back(dp[mask | (1 << id)][i + 1]);
            }
            std::sort(vals.begin(), vals.end());
            int mex = 0;
            for (auto v: vals) mex += (v == mex);

            dp[mask][i] = mex;
        }
    }
    if (dp[0][0]) cout << "First" << "\n";
    else cout << "Second" << '\n';
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}