#include "bits/stdc++.h"

using namespace std;

template<class T>
istream& operator>>(istream &is, vector<T> &vec) {
      for (auto &elem: vec) is >> elem;
      return is;
}
template<class T>
ostream& operator<<(ostream &os, const vector<T> &vec) {
      for (auto &elem: vec) os << elem << ' ';
      os << '\n';
      return os;
}

struct event {
      int pos, type, id;
};

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, m;
      cin >> n >> m;
      vector<int> a(n), b(n), c(m);
      cin >> a >> b >> c;

      vector<pair<int, int>> t;
      for (int i = 0; i < m; ++i) {
            t.push_back({c[i], -1});
      }
      vector<vector<int>> comps;
      vector<event> es;
      for (int i = 0; i < n; ++i) {
            if (a[i] < b[i]) {
                  t.push_back({a[i], i});
            } else {
                  t.push_back({a[i], -100});
            }
      }
      sort(es.begin(), es.end(), [&](auto x, auto y) {
            return x.pos < y.pos;
      });
      std::sort(t.rbegin(), t.rend());
      int now = 0;
      int last = 1e9;
      for (int i = 0; i < t.size(); ++i) {
            if (t[i].second == -1) now ^= 1;
            else if (t[i].second == -100) now = 1, last = -1e9;
            else {
                  if (last > b[t[i].second]) {
                        now = 1;
                  } else {
                        now ^= 1;
                  }
                  last = t[i].first;
            }
//            cout << now << ' ';
      }

      if (now) cout << "First";
      else cout << "Second";
}