#include <bits/stdc++.h>


using namespace std;


using ll = long long;


ostream & operator <<(ostream &os, const pair<int, int> &p) {
    os << "{" << p.first << " " << p.second << "}";
    return os;
}


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


bool f(set<tuple<int, int, int>> &s, const vector<int> &b, const vector<int> &c, int pos) {
    if (int(s.size()) == 1 && pos == int(c.size())) {
        return 0;
    }
    bool win = 0;
    auto v = s.begin();
    int num = get<0>(*v);
    int side = get<1>(*v);
    int id = get<2>(*v);
    s.erase(v);
    auto it = upper_bound(c.begin(), c.end(), get<0>(*s.begin()));
    int dist = int(it - c.begin()) - pos;
    if (dist % 2 == 0) {
        win = win || !f(s, b, c, pos + dist);
    } else {
        win = win || f(s, b, c, pos + dist);
    }
    if (side == 0) {
        s.insert({b.at(id), 1, id});
        it = upper_bound(c.begin(), c.end(), get<0>(*s.begin()));
        dist = int(it - c.begin()) - pos;
        if (dist < 0) {
            dist = 0;
        }
        if (dist % 2 == 0) {
            win = win || !f(s, b, c, pos + dist);
        } else {
            win = win || f(s, b, c, pos + dist);
        }
        s.erase({b.at(id), 1, id});
    }
    s.insert({num, side, id});
    return win;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> b(n), c(m);
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a.at(i).first;
        a.at(i).second = i;
    }
    for (int i = 0; i < n; i++) {
        cin >> b.at(i);
    }
    for (int i = 0; i < m; i++) {
        cin >> c.at(i);
    }
    sort(c.begin(), c.end());
    sort(a.begin(), a.end());
    vector<pair<int, int>> st;
    for (int i = 0; i < n; i++) {
        int id = a.at(i).second;
        int num = b.at(id);
        auto it = lower_bound(a.begin(), a.end(), make_pair(num, -1));
        int p = int(it - a.begin());
        auto itp = upper_bound(st.begin(), st.end(), make_pair(i, n + 1));
        int player;
        if (itp == st.begin()) {
            auto buf = lower_bound(c.begin(), c.end(), a.at(i).first);
            int cnt = i + int(buf - c.begin());
            player = cnt % 2;
        } else {
            itp--;
            player = itp -> second;
        }
        while (!st.empty() && st.back().first >= p) {
            st.pop_back();
        }
        st.push_back({p, player});
    }
    if (st.back().second == 0) {
        cout << "First";
    } else {
        cout << "Second";
    }
    return 0;
}


/*2 2
2 3
6 1
4 5*/


/*1 2
3
4
1 2*/
