#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <experimental/random>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3,unroll-loops")
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;
#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
        cout << "\n";
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> q(n);
    for (int i = 0; i < n; ++i) {
        cin >> q[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> q[i].second;
        q[i].second = max(q[i].second, q[i].first);
    }
    sort(q.begin(), q.end());
    vector<int> cnt(n);
    int flag = 0;
    for (int i = 0; i < m; ++i) {
        int l = -1;
        int r = n;
        int x;
        cin >> x;
        while (r - l > 1) {
            int mi = (l + r) / 2;
            if (q[mi].first > x) {
                r = mi;
            } else {
                l = mi;
            }
        }
        if (l == -1) {
            flag++;
        } else {
            cnt[l]++;
        }
    }
    for (int i = 0; i < n; ++i) {
        int x = q[i].second;
        int l = -1;
        int r = n;
        while (r - l > 1) {
            int mi = (l + r) / 2;
            if (q[mi].first > x) {
                r = mi;
            } else {
                l = mi;
            }
        }
        q[i].second = l;
    }
    for (int i = 0; i < n; ++i) {
        q[i].first = i;
    }
    int pos = -1;
    for (int i = 0; i < n; ++i) {
        if (q[i].first == q[i].second) {
            pos = i;
            break;
        }
    }
    bool p = true;
    while (p) {
        p = false;
        for (int i = pos - 1; i >= 0; --i) {
            if (q[i].second < pos) {
                pos = q[i].first;
                p = true;
                break;
            }
        }
    }
    for (int i = 0; i < pos; ++i) {
        flag += cnt[i];
        flag++;
    }
    if (flag % 2 == 0) {
        cout << "First";
    } else {
        cout << "Second";
    }
}