#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> aa(n);
    vector<int> cc(m);
    for(int i = 0; i < n; i++) cin >> aa[i].first;
    for(int i = 0; i < n; i++) cin >> aa[i].second;
    for(int i = 0; i < m; i++) cin >> cc[i];

    int sz = n * 2 + m;
    vector<vector<int>> g(sz + 1);
    for(auto [a, b] : aa) g[a].push_back(b);
    sort(cc.begin(), cc.end());

    vector<int> poss;
    for(int i = 1; i <= sz; i++) {
        if(binary_search(cc.begin(), cc.end(), i) || g[i].size() > 0) poss.push_back(i);
    }
    poss.push_back(sz + 1);

    set<int> alwWin;
    vector<int> dp(sz + 2);
    dp[sz + 1] = 0;
    for(int ttt = poss.size() - 2; ttt >= 0; ttt--) {
        int i = poss[ttt];
        int nxt = *upper_bound(poss.begin(), poss.end(), i);

        if(g[i].size() > 0) {
            int t = g[i][0];
            if(t < i) {
                dp[i] = 1;
                alwWin.insert(i);
                continue;
            }
        }

        if(dp[nxt] == 0) {
            dp[i] = 1;
            continue;
        }

        if(g[i].size() > 0) {
            int t = g[i][0];
            if(t < i) {
                dp[i] = 1;
                alwWin.insert(i);
                continue;
            }
            auto it = alwWin.lower_bound(t);
            if(it != alwWin.begin()) {
                it--;
                int x = *it;
                if(x < t) {
                    if(dp[nxt] == 0) {
                        dp[i] = 1;
                    }
                    continue;
                }
            }
            dp[i] = 1;
            alwWin.insert(i);
            continue;
        }
    }
    if(dp[poss[0]]) cout << "First\n";
    else cout << "Second\n";
}
