//author: лелутик :3
#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <bitset>
#include <time.h>
#include <cmath>
#include <cassert>
#include <random>
#include <queue>
using namespace std;
#define int long long
#define line cout << "\n"
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define pb push_back
#define ppb pop_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pii pair<int, int>
int n, m;

void solve() {
    vector<pii> cards(n);
    vector<int> c(m);
    vector<int> cnt(n * 2 + m + 2);
    for (int i = 0; i < n; i++) {
        cin >> cards[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> cards[i].second;
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i];
        cnt[c[i]]++;
    }
    sort(all(c));
    sort(all(cards));
    vector<bool> dp(n);
    dp[n - 1] = true;
    for (int i = n - 2; i >= 0; i--) {
        if (cards[i].second < cards[i + 1].first) {
            dp[i] = true;
        } else {
            int calc = 0;
            for (int j = cards[i].first; j < cards[i + 1].first; j++) {
                calc += cnt[j];
            }
            if (calc % 2) {
                if (dp[i + 1]) {
                    dp[i] = true;
                } else {
                    dp[i] = false;
                }
            } else {
                if (!dp[i + 1]) {
                    dp[i] = true;
                } else {
                    dp[i] = false;
                }
            }
        }
    }
    int cur = 0;
    for (int i = 0; i < m; i++) {
        if (c[i] < cards[0].first) {
            cur++;
        }
    }
    if (cur % 2 == 0) {
        if (dp[0]) {
            cout << "First";
        } else {
            cout << "Second";
        }
    } else {
        if (!dp[0]) {
            cout << "First";
        } else {
            cout << "Second";
        }
    }
    line;
}

const int MAXN = 5e5;
int a[MAXN], b[MAXN], c[MAXN];

bool dfs(set<pii> &cur) {
    if (sz(cur) == 0) {
        return false;
    }
    pii f = *cur.begin();
    pii t = f;
    cur.erase(cur.begin());
    bool f1 = dfs(cur);
    if (f.second > 0) {
        f.first = b[f.second];
        f.second = -1;
        cur.insert(f);
        f1 &= dfs(cur);
        cur.erase(f);
    }
    cur.insert(t);
    if (f1) {
        return false;
    } else {
        return true;
    }
}


void solve2() {
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> b[i];
    }
    for (int i = 1; i <= m; i++) {
        cin >> c[i];
    }
    set<pii> st;
    for (int i = 1; i <= n; i++) {
        st.insert({a[i], i});
    }
    for (int i = 1; i <= m; i++) {
        st.insert({c[i], -i});
    }
    bool f = dfs(st);
    if (!f) {
        cout << "Second";
    } else {
        cout << "First";
    }
    line;
}

signed main() {
    fast;


#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif


    int t = 1;
    // cin >> t;
    cin >> n >> m;
    if (m <= 20) {
        solve2();
    } else {
        solve();
    }
}