#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock().now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename T>
using orderet_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ull = unsigned long long;
using uint = unsigned int;
using ld = long double;
using dd = double;

#define int ll

const ll INF = 1e18;

void solve(){
    int n, m;
    cin>>n>>m;
    vector<int> a(n), b(n), c(m);
    for(int i = 0; i < n; ++i) cin>>a[i];
    for(int i = 0; i < n; ++i) cin>>b[i];
    for(int i = 0; i < m; ++i) cin>>c[i];
    vector<pair<int, int>> v;
    for(int i =0 ; i < n; ++i) v.push_back({a[i], b[i]});
    for(int i =0 ; i < m; ++i) v.push_back({c[i], 0});
    sort(v.begin(), v.end());
    int last_good = 1e9;
    for(int i = n + m - 1; i >= 0; --i){
        if(v[i].second == 0) continue;
        if(last_good == 1e9 || v[i].second <= v[last_good].first){
            last_good = i;
        }
    }
    if(last_good % 2 == 0) cout << "First";
    else cout << "Second";
}

signed main(){
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    int t = 1;
    //cin>>t;
    while(t--) solve();
}