#include<bits/stdc++.h>

using namespace std;

const int MAXN = 5e5 + 31;

int dp[MAXN];

vector<pair<int, int>> duo;
vector<int> solo;

int solo_in_seg(int l, int r){
    auto iterr = lower_bound(solo.begin(), solo.end(), r);
    auto iterl = lower_bound(solo.begin(), solo.end(), l);
    return iterr - iterl;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for(int i = 0; i <= n; i++){
        dp[i] = -1;
    }
    vector<int> a(n);
    vector<int> b(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    for(int i = 0; i < n; i++) cin >> b[i];
    for(int i = 0; i < n; i++){
        duo.push_back({a[i], b[i]});
    }
    for(int i = 0; i < m; i++){
        int a;
        cin >> a;
        solo.push_back(a);
    }
    sort(duo.begin(), duo.end());
    sort(solo.begin(), solo.end());
    dp[0] = (1 + solo_in_seg(0, duo[0].first)) % 2;
    for(int i = 0; i < n; i++){
        auto [a, b] = duo[i];
        if(b < a) dp[i + 1] = dp[i];
        else{
            int id = lower_bound(duo.begin(), duo.end(), make_pair(b, -1)) - duo.begin();
            dp[id] = dp[i];
        }
        if(dp[i + 1] == -1){
            int inv = solo_in_seg(a, duo[i + 1].first) % 2;
            inv = 1-inv;
            dp[i + 1] = (dp[i] + inv) % 2;
        }
    }
    if(dp[n]) cout << "First";
    else cout << "Second";
}

