#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define db long double

using namespace std;
//using namespace __gnu_pbds;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

bool rec(vector<pair<int, int>> a, vector<int> b, vector<bool> c) {
    if (a.empty() && b.empty()) return false;

    int mn1 = -1, mn2 = -1;
    for (int i = 0; i < a.size(); ++i) {
        if (mn1 == -1 || a[i].first < a[mn1].first) {
            mn1 = i;
        }
    }

    for (int i = 0; i < b.size(); ++i) {
        if (mn2 == -1 || b[i] < b[mn2]) {
            mn2 = i;
        }
    }

    if (mn2 == -1 || (mn1 != -1 && a[mn1].first < b[mn2])) {
        if (c[mn1]) {
            c[mn1] = false;
            swap(a[mn1].first, a[mn1].second);

            if (!rec(a, b, c)) return true;
        }

        vector<pair<int, int>> na;
        vector<bool> nc;

        for (int i = 0; i < a.size(); ++i) {
            if (i == mn1) continue;

            na.push_back(a[i]);
            nc.push_back(c[i]);
        }

        return !rec(na, b, nc);
    }

    vector<int> nb;

    for (int i = 0; i < b.size(); ++i) {
        if (i == mn2) continue;

        nb.push_back(b[i]);
    }

    return !rec(a, nb, c);
}

void solve() {
    int n, m; cin >> n >> m;

    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i].first;
    for (int i = 0; i < n; ++i) cin >> a[i].second;

    vector<int> b(m);
    for (int i = 0; i < m; ++i) cin >> b[i];

    vector<bool> c(n, true);

    bool ans = rec(a, b, c);

    if (ans) {
        cout << "First";
    } else {
        cout << "Second";
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}