#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define db long double

using namespace std;
//using namespace __gnu_pbds;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, m; cin >> n >> m;

    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i].first;
    for (int i = 0; i < n; ++i) cin >> a[i].second;

    vector<int> b(m);
    for (int i = 0; i < m; ++i) cin >> b[i];

    std::sort(b.begin(), b.end());

    vector<bool> c(n, true);

    vector<vector<bool>> dp(n + 1, vector<bool>(1 << n, false));
    vector<vector<bool>> used(n + 1, vector<bool>(1 << n, false));
    queue<pair<int, int>> q;

    for (int mask = 0; mask < (1 << n); ++mask) {
        int mx = 0;

        for (int i = 0; i < n; ++i) {
            mx = max(mx, a[i].first);
            if ((mask >> i) % 2) mx = max(mx, a[i].second);
        }

        int i = std::lower_bound(b.begin(), b.end(), mx) - b.begin();
        if ((m - i) % 2) {
            dp[n][mask] = true;
        }

        used[n][mask] = true;
        q.emplace(n, mask);
    }

    bool ans = false;
    while (!q.empty()) {
        auto [i, mask] = q.front(); q.pop();

        int val = LLONG_MAX;
        if (i < n) {
            val = a[i].first;
        }

        if ((mask >> i) % 2) {
            int sub_mask = mask - (1 << i);

            val = a[i].second;

            if (!dp[i][sub_mask] && (!used[i][sub_mask] || !dp[i][mask])) {
                used[i][sub_mask] = true;
                q.emplace(i, sub_mask);
                dp[i][sub_mask] = !dp[i][mask];
            }
        }

        int mx = -1, val_mx = 0;
        for (int j = 0; j < n; ++j) {
            if ((mask >> j) % 2) {
                if (a[j].second >= val) continue;

                if (val_mx < a[j].second) {
                    mx = j;
                    val_mx = a[j].second;
                }
            } else {
                if (a[j].first >= val) continue;

                if (val_mx < a[j].first) {
                    mx = j;
                    val_mx = a[j].first;
                }
            }
        }

        if (mx == -1) {
            int idx = std::lower_bound(b.begin(), b.end(),val) - b.begin();

            if (idx % 2) {
                ans = ans | !dp[i][mask];
            } else {
                ans = ans | dp[i][mask];
            }
        } else {
            int idx = std::lower_bound(b.begin(), b.end(),val) - b.begin();
            int idx2 = std::lower_bound(b.begin(), b.end(), val_mx) - b.begin();

            idx -= idx2;

            if (idx % 2) {
                dp[i][mask] = !dp[i][mask];
            }

            if (!dp[mx][mask] && (!used[mx][mask] || !dp[i][mask])) {
                used[mx][mask] = true;
                q.emplace(mx, mask);
                dp[mx][mask] = !dp[i][mask];
            }

            if (idx % 2) {
                dp[i][mask] = !dp[i][mask];
            }
        }
    }

    if (ans) {
        cout << "First";
    } else {
        cout << "Second";
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}