#pragma GCC optimize('Ofast')
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
struct fenw {
    vector<int> f;
    explicit fenw(int n) {
        f.resize(n);
    }
    void upd(int i, int x) {
        while (i < f.size()) {
            f[i] += x;
            i |= (i + 1);
        }
    }
    int get(int i) {
        int sum = 0;
        while (i >= 0) {
            sum += f[i];
            i %= (i + 1);
            i--;
        }
        return sum;
    }
};
template <typename T>
bool smin(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template <typename T>
bool smax(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(2 * n + m + 1);
    vector<int> z(m);
    vector<pair<int, int>> x(n);
    for (int i = 0; i < n; i++) cin >> x[i].first;
    for (int i = 0; i < n; i++) cin >> x[i].second;
    for (int i = 0; i < m; i++) cin >> z[i];
    sort(x.begin(), x.end());
    int cur = 2 * n + m + 1;
    for (int i = n - 1; i >= 0; i--) {
        if (x[i].second < cur) {
            a[x[i].first] = 2;
            cur = x[i].first;
        } else {
            a[x[i].first] = 1;
        }
    }
    for (int i = 0; i < m; i++) a[z[i]] = 1;
    int cnt = 0;
    bool flag = false;
    for (int i = 0; i < 2 * n + m + 1; i++) {
        if (a[i] == 2) {
            flag = true;
            break;
        }
        cnt += a[i];
    }
    if (flag) {
        if (cnt % 2 == 0) {
            cout << "First\n";
        } else {
            cout << "Second\n";
        }
    } else {
        if (cnt % 2 == 1) {
            cout << "First\n";
        } else {
            cout << "Second\n";
        }
    }
    return 0;
}