#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <numeric>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <chrono>
#include <random>
#include <unordered_map>
#include <unordered_set>
using namespace std;
using ll = long long;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

vector<int> a, b, c;

auto cmp = [&](pair<int, int> p1, pair<int, int> p2) {
    int val1 = 0, val2 = 0;
    if (p1.second == 0)
        val1 = a[p1.first];
    if (p1.second == 1)
        val1 = b[p1.first];
    if (p1.second == 2)
        val1 = c[p1.first];
    if (p2.second == 0)
        val2 = a[p2.first];
    if (p2.second == 1)
        val2 = b[p2.first];
    if (p2.second == 2)
        val2 = c[p2.first];
    return val1 < val2;
};

set<pair<int, int>, decltype(cmp)> s(cmp);

bool f() {
    if ((int)s.size() == 1)
        return 1;
    auto t = *s.begin();
    s.erase(t);
    auto ans = !f();
    s.insert(t);
    if (t.second == 0) {
        s.erase({t.first, 0});
        s.insert({t.first, 1});
        ans|=!f();
        s.insert({t.first, 0});
        s.erase({t.first, 1});
    }
    return ans;
}


int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    a.resize(n), b.resize(n), c.resize(m);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < n; ++i)
        cin >> b[i];
    for (int i = 0; i < m; ++i)
        cin >> c[i];
    vector<pair<int, int>> v(n + m);
    for (int i = 0; i < n; ++i)
        v[i] = {i, 0};
    for (int i = n; i < n + m; ++i)
        v[i] = {i - n, 2};
    for (auto el : v)
        s.insert(el);
    bool ans = f();
    if (ans)
        cout << "First";
    else
        cout << "Second";
}
