#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>

using namespace std;

long long n, m;
vector<pair<long long, long long>> v1;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;

	v1.resize(n + m, { -1, -1 });

	for (long long i = 0; i < n; ++i)
		cin >> v1[i].first;
	for (long long i = 0; i < n; ++i)
		cin >> v1[i].second;
	for (long long j = n; j < n + m; ++j)
		cin >> v1[j].first;

	sort(v1.begin(), v1.end());

	vector<long long> dp(n + m);

	dp[n + m - 1] = 1;
	long long x3 = 0, x4 = 0;
	for (long long i = 0; i < n + m; ++i) {
		if (v1[i].second != -1)
			x4 = x3;
		x3 ^= 1;
	}

	if (x4 == 1)
		cout << "Second";
	else
		cout << "First";
	return 0;
}
