#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>

using namespace std;

long long n, m;
vector<long long> v1;
vector<pair<long long, long long>> zap;

bool f(long long x1, vector<long long>& used) {
	while (x1 < 2 * n + m && used[x1] == 0)
		++x1;
	if (x1 >= 2 * n + m)
		return false;
	if (v1[x1] == -1) {
		used[x1] = 0;
		bool b = f(x1 + 1, used);
		used[x1] = 1;
		if (b == true)
			return false;
		else
			return true;
	}
	used[x1] = 0;
	bool b1 = f(x1 + 1, used);
	used[x1] = 1;

	if (b1 == false)
		return true;

	used[x1] = 0;
	used[v1[x1]] = 1;
	bool b2 = f(v1[x1], used);
	used[v1[x1]] = 0;
	used[x1] = 1;

	if (b2 == false)
		return true;
	return false;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;

	v1.resize(2 * n + m, -1);
	zap.resize(n);

	vector<long long> used(2 * n + m, 0);

	for (long long i = 0; i < n; ++i) {
		cin >> zap[i].first;
		--zap[i].first;
		used[zap[i].first] = 1;
	}
	for (long long i = 0; i < n; ++i) {
		cin >> zap[i].second;
		--zap[i].second;
		v1[zap[i].first] = zap[i].second;
	}

	for (long long i = 0; i < m; ++i) {
		long long a;
		cin >> a;
		--a;
		used[a] = 1;
	}

	if (f(0, used))
		cout << "First";
	else
		cout << "Second";
	return 0;
}
