#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>

using namespace std;

long long n, m, x3 = -1;
vector<long long> dp;
vector<pair<long long, long long>> zap;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;

	dp.resize(2 * n + m, 0);
	zap.resize(n);

	vector<long long> used(2 * n + m, 0);

	for (long long i = 0; i < n; ++i) {
		cin >> zap[i].first;
		--zap[i].first;
		used[zap[i].first] = 1;
	}
	for (long long i = 0; i < n; ++i) {
		cin >> zap[i].second;
		--zap[i].second;
	}

	for (long long i = 0; i < m; ++i) {
		long long a;
		cin >> a;
		--a;
		used[a] = 1;
	}

	sort(zap.begin(), zap.end());

	x3 = zap[n - 1].first;

	for (long long i = 0; i < n - 1; ++i) {
		if (zap[i].second < zap[i + 1].first) {
			x3 = zap[i].first;
			break;
		}
	}
	long long x4 = x3;

	for (long long i = 0; i < n; ++i) {
		if (zap[i].first >= x3)
			break;
		if (zap[i].second >= x3)
			continue;
		x4 = zap[i].first;
	}

	long long x5 = 1;

	for (long long i = x4 - 1; i >= 0; --i)
		x5 ^= used[i];

	if (x5 == 1)
		cout << "First";
	else
		cout << "Second";

	return 0;
}
