#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
#include <queue>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

string ANSWER[2] = { "First", "Second" };

void solve()
{
	long long n, m;
	vector<long long> a, b, c;
	cin >> n >> m;
	a.resize(n);
	b.resize(n);
	c.resize(m);
	for (long long i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	for (long long i = 0; i < n; i++)
	{
		cin >> b[i];
	}
	for (long long i = 0; i < m; i++)
	{
		cin >> c[i];
	}

	long long ga = INF, gb = INF;
	for (long long i = 0; i < n; i++)
	{
		if (b[i] < a[i])
		{
			if (a[i] < ga)
			{
				ga = a[i];
				gb = b[i];
			}
		}
	}
	if (ga != INF)
	{
		vector<long long> na, nb, nc;
		for (long long i = 0; i < n; i++)
		{
			if (ga < a[i])
			{
				continue;
			}
			if (ga < b[i] || gb == b[i])
			{
				nc.push_back(a[i]);
			}
			else
			{
				na.push_back(a[i]);
				nb.push_back(b[i]);
			}
		}
		for (long long i = 0; i < m; i++)
		{
			if (ga < c[i])
			{
				continue;
			}
			nc.push_back(c[i]);
		}
		swap(a, na);
		swap(b, nb);
		swap(c, nc);
		n = a.size();
		m = c.size();
	}
	sort(c.begin(), c.end());
	vector<pair<long long, long long>> ab(n);
	for (long long i = 0; i < n; i++)
	{
		ab[i] = { a[i], b[i] };
	}
	sort(ab.begin(), ab.end());
	for (long long i = 0; i < n; i++)
	{
		a[i] = ab[i].first;
		b[i] = ab[i].second;
	}

	vector<long long> na, nb;
	long long preva = INF;
	for (long long i = n - 1; i > -1; i--)
	{
		if (preva < b[i])
		{
			c.push_back(a[i]);
			continue;
		}
		na.push_back(a[i]);
		nb.push_back(b[i]);
		preva = a[i];
	}
	sort(c.begin(), c.end());

	if (!n)
	{
		cout << ANSWER[1 - c.size() % 2] << "\n";
		return;
	}
	long long mna = *min_element(a.begin(), a.end());
	long long ans = 0;
	for (long long i = 0; i < m; i++)
	{
		if (c[i] < mna)
		{
			ans ^= 1;
		}
	}
	cout << ANSWER[ans] << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
