#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int maxn = 5e5 + 10;
vector<pair<int, int>> one;
vector<int> two;
int n, m;
vector<int> will_be(maxn, -1);
vector<bool> could_use(maxn, false);


bool check(int ind, int player) {
    if (ind > 2 * n + m) {
        return false;
    }
    if (!could_use[ind]) {
        return check(ind + 1, player);
    }
    if (will_be[ind] == -1) {
        return !check(ind + 1, (player + 1) % 2);
    }
    if (!check(ind + 1, (player + 1) % 2)) {
        return true;
    }
    if (will_be[ind] < ind && !check(ind + 1, player)) {
        return true;
    }
    if (will_be[ind] > ind) {
        could_use[will_be[ind]] = true;
        bool ans = check(ind + 1, (player + 1) % 2);
        could_use[will_be[ind]] = false;
        if (!ans) {
            return true;
        }
    }
    return false;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(15);
    cin >> n >> m;
    int ans = -1;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        one.push_back({a, 0});
        ans = max(ans, a);
        could_use[a] = true;
    }
    for (int i = 0; i < n; i++) {
        int b;
        cin >> b;
        one[i].second = b;
        will_be[one[i].first] = b;
    }
    int cou = 0;
    for (int i = 0; i < m; i++)  {
        int c;
        cin >> c;
        two.push_back(c);
        if (c < ans) {
            cou++;
        }
        could_use[c] = true;
    }
    if (check(1, 0)) {
        cout << "First" << endl;
    } else {
        cout << "Second" << endl;
    }
}
