#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) int((x).size())
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

mt19937_64 rnd(52);

void answer(bool first_won) {
    if (first_won) {
        cout << "First\n";
    }
    else {
        cout << "Second\n";
    }
    exit(0);
}

vector<int> a, b, c;

bool dfs(vector<pii> nums) {
    if (nums.empty()) {
        return false;
    }
    auto it = min_element(all(nums));
    auto [x, i] = *it;
    nums.erase(it);
    bool won = !dfs(nums);
    if (i != -1) {
        nums.push_back({b[i], -1});
        won = won || (!dfs(nums));
    }
    return won;
}

void solve() {
    int n, m;
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < m; i++) cin >> c[i];
    vector<pii> table;
    for (int i = 0; i < n; i++) {
        table.push_back({a[i], i});
    }
    for (int i = 0; i < m; i++) {
        table.push_back({c[i], -1});
    }
    answer(dfs(table));
    // priority_queue<pii, vector<pii>, greater<>> table;
    // for (int i = 0; i < n; i++) {
    //     table.push({a[i], i});
    // }
    // for (int i = 0; i < m; i++) {
    //     table.push({c[i], -1});
    // }
    // int ragnarok = 1e9;
    // bool first_wins = false;
    // bool first_moves = true;
    // while (table.size()) {
    //     auto [x, i] = table.top();
    //     table.pop();
    //     if (x > ragnarok) {
    //         answer(first_wins);
    //     }
    //     if (i != -1) {
    //         ragnarok = b[i];
    //         first_wins = first_moves;
    //     }
    //     first_moves = !first_moves;
    // }
    // answer(first_wins);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) solve();
}