#include <string>
#include <bitset>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <map>
#include <set>

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

// #define SUBMIT

#ifdef SUBMIT
    #pragma GCC optimize("Ofast,unroll-loops")
#endif

void fast() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cout << setprecision(8) << fixed;
}

ll mod = 1e9 + 7;
ll binpow(ll a, ll n) {
    ll res = 1;
    for (int i = 0; (1ll << i) <= n; ++i, a = a * a % mod) {
        if ((n >> i) & 1) res = res * a % mod;
    }
    return res;
}
vector<int> a, b, c;
int n, m;
bool play(vector<int> &state, int cur) {
    ll mn = 1e18;
    int idx = -1;
    for (int i = 0; i < n; ++i) {
        if (state[i] == 2) continue;
        if (state[i] == 1) {
            if (b[i] < mn) {
                mn = b[i];
                idx = i;
            }
        } else {
            if (a[i] < mn) {
                mn = a[i];
                idx = i;
            }
        }
    }
    if (idx == -1) {
        return (m - cur) % 2 == 1;
    }
    int add = 0;
    while (cur < m && c[cur] < mn) {
        cur++;
        add++;
    }
    if (state[idx] == 1) {
        state[idx] = 2;
        bool res = ((int)play(state, cur) + add) % 2 == 1;
        state[idx] = 1;
        return res;
    } else {
        state[idx] = 2;
        bool res = ((int)play(state, cur) + add) % 2 == 1;
        state[idx] = 1;
        res = (res || ((int)play(state, cur) + add) % 2 == 1);
        state[idx] = 0;
        return res;
    }  
}
void solve() {
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (auto &el : a) cin >> el;
    for (auto &el : b) cin >> el;
    for (auto &el : c) cin >> el;
    sort(all(c));
    vector<int> state(n);
    if (!play(state, 0)) {
        cout << "Second";
    } else {
        cout << "First";
    }
}
int main() {
    fast();
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}