#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<map>
#include<set>
#include<bitset>
#include<algorithm>

using namespace std;

struct card {
	int f, b, p;
	card() {
		f = b = p = 0;
	}
	card(int _f, int _b) {
		f = _f;
		b = _b;
		p = 0;
	}
};

int calc(vector<card> a, set<int> b) {
	if (a.size() + b.size() == 1) {
		return 1;
	}
	int add = 0;
	vector<int> newb;
	while (b.size() != 0 && ((*b.begin()) < (*min_element(a.begin(), a.end(), [&](auto l, auto r) {return l.f < r.f; })).f || a.size() == 0)) {
		b.erase(b.begin());
		add ^= 1;
	}
	int mna = 0;
	for (int i = 0; i < a.size(); ++i) {
		if (a[i].f < a[mna].f) {
			mna = i;
		}
	}
	int ans = 0;
	if (a.size() != 0) {
		if (a[mna].p == 0) {
			swap(a[mna].f, a[mna].b);
			a[mna].p = 1;
			if (calc(a, b) == 0) {
				return 1 ^ add;
			}
		}
		a.erase(a.begin() + mna);
		if (calc(a, b) == 0) {
			return 1 ^ add;
		}
	}
	return add;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, m;
	cin >> n >> m;
	vector<card> a(n);
	set<int> b;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].f;
	}
	for (int i = 0; i < n; ++i) {
		cin >> a[i].b;
	}
	for (int i = 0; i < m; ++i) {
		int x;
		cin >> x;
		b.insert(x);
	}
	cout << (calc(a, b) ? "First" : "Second");
	return 0;
}