// semenInRussia 2025
#pragma GCC optimize("Ofast,unroll-loops")
#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;
#ifndef home
#pragma GCC target("avx2")
#endif

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, m;
  cin >> n >> m;
  vector<int> a(n), b(n), c(m);

  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  for (int i = 0; i < n; i++) {
    cin >> b[i];
  }
  for (int i = 0; i < m; i++) {
    cin >> c[i];
  }

  vector<pair<int, int>> v(n + m);
  for (int i = 0; i < n; i++) {
    v[i] = {a[i], b[i]};
  }
  for (int i = 0; i < m; i++) {
    v[i + m] = {c[i], -1};
  }

  sort(v.rbegin(), v.rend());

  vector<int> dp(n + m + 1);

  dp[0] = 0;
  for (int i = 0; i < n + m; i++) {
    dp[i + 1] = false;
    if (v[i].second != -1) {
      dp[i + 1] |= dp[i];
    }
    dp[i + 1] |= !dp[i];
  }

  bool ans = dp[n + m];
  cout << (ans ? "First" : "Second");
}