#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;


int n, m;
vector<int> v;
vector<pair<int, int>> x;
vector<vector<vector<bool>>> used, win;
set<pair<int, int>> s;


bool f(int id, int p, int h) {
	auto [i, t] = *s.begin();
	if (t == 1) {
		s.erase(s.begin());
		bool res = !f(id, p ^ 1, h ^ 1);
		s.insert({ i, t });
		return res;
	}
	if (id == n - 1)
		return true;
	s.erase(s.begin());
	bool flag1, flag2;
	if ((v[id + 1] - v[id]) % 2 == 0) {
		flag1 = f(id + 1, p, h);
		s.insert({ x[v[id]].second, 1 });
		flag2 = f(id + 1, p, h);
		s.erase({ x[v[id]].second, 1 });
	}
	else {
		flag1 = !f(id + 1, p ^ 1, h);
		s.insert({ x[v[id]].second, 1 });
		flag2 = !f(id + 1, p ^ 1, h);
		s.erase({ x[v[id]].second, 1 });
	}
	//cout << id << ' ' << p << ' ' << h << " || " << flag1 << ' ' << flag2 << '\n';
	s.insert({ i, t });
	return flag1 || flag2;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n >> m;
	x.resize(n + m, { -1, -1 });
	for (int i = 0; i < n; i++)
		cin >> x[i].first;
	for (int i = 0; i < n; i++)
		cin >> x[i].second;
	for (int i = n; i < n + m; i++)
		cin >> x[i].first;
	sort(x.begin(), x.end());
	v.resize(n);
	int id = 0;
	for (int i = 0; i < n + m; i++) {
		if (x[i].second != -1) {
			v[id] = i, id++;
			s.insert({ x[i].first, 0 });
		}
	}
	bool res = f(0, v[0] % 2, (n + m - v[0]) % 2);
	if (v[0] % 2 == 1)
		res = !res;
	if (res)
		cout << "First" << '\n';
	else
		cout << "Second" << '\n';
}