#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = int(1e9) + 7, lg = 20;
const ll inf = ll(2e18) + 36;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#pragma GCC target("avx,avx2")

int n, m;
vector<int> a, b, c;
set <pair <int, int>> cur;
bool rec() {
    if (cur.empty()) {
        return false;
    }
    auto [x, p] = *cur.begin();
    cur.erase(cur.begin());
    if (p >= n) {
        bool win = !rec();
        cur.emplace(x, p);
        return win;
    }
    bool win = !rec();
    if (win) {
        cur.emplace(x, p);
        return true;
    }
    cur.emplace(b[p], p + n);
    win |= !rec();
    cur.erase({b[p], p + n});
    cur.emplace(x, p);
    return win;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (auto &it: a) cin >> it;
    for (auto &it: b) cin >> it;
    for (auto &it: c) cin >> it;
    sort(c.begin(), c.end());
    for (int i = 0; i < n; i++) {
        cur.emplace(a[i], i);
    }
    for (int j = 0; j < m; j++) {
        cur.emplace(c[j], n * 2 + j);
    }
    cout << (rec() ? "First" : "Second");
    return 0;
}
