#pragma GCC optimize("O3, unroll-loops")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <string>
#define int long long

using namespace std;
using ld = long double;

const int INF = 2e15;

struct Card {
	int type;
	int a, b;
	bool isA;
};

bool operator<(Card f, Card s) {
	int v1 = f.a;
	if (!f.isA) {
		v1 = f.b;
	}
	int v2 = s.a;
	if (!s.isA) {
		v2 = s.b;
	}
	return v1 < v2;
}

pair<int, int> cntFir(int gm, int hod, int n, set <Card>& st) {
	int cnt1 = 0, cnt2 = 0;
	for (int mask = 0; mask < (1ll << (n - hod)); mask++) {
		int m = gm * (1ll << (n - hod)) + mask;
		auto tmp = st;
		bool turn = false;
		int num = 0;
		while (!st.empty()) {
			auto c = *st.begin();
			st.erase(st.begin());
			if (c.type == 1) {
				continue;
			}
			if ((m >> num) & 1) {
				st.insert({ 2, c.a, c.b, false });
			}
			num++;
			turn = !turn;
		}
		st = tmp;
		if (turn) {
			cnt1++;
		}
		else {
			cnt2++;
		}
	}
	return { cnt1, cnt2 };
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, m;
	cin >> n >> m;
	vector <pair<int, int>> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first >> arr[i].second;
	}
	vector <int> brr(m);
	for (int i = 0; i < m; i++) {
		cin >> brr[i];
	}
	set <Card> st;
	for (auto el : arr) {
		st.insert({ 2, el.first, el.second, true });
	}
	for (auto el : brr) {
		st.insert({ 1, el, 0, true });
	}
	int gm = 0, cnt = 0;
	bool turn = false;
	auto st2 = st;
	while (!st2.empty()) {
		auto c = *st2.begin();
		st2.erase(c);
		if (c.type == 1) {
			continue;
		}
		auto pr = cntFir(gm, cnt, n, st);
		ld p1, p2;
		cnt++;
		gm *= 2;
		auto pr1 = cntFir(gm, cnt, n, st);
		if (!turn) {
			p1 = (ld)pr1.first / (ld)pr1.second;
		}
		else {
			p1 = (ld)pr1.second / (ld)pr1.first;
		}
		gm++;
		auto pr2 = cntFir(gm, cnt, n, st);
		if (!turn) {
			p2 = (ld)pr2.first / (ld)pr2.second;
		}
		else {
			p2 = (ld)pr2.second / (ld)pr2.first;
		}
		if (p1 > p2) {
			gm--;
		}
		else {
			st.insert({ 2, c.a, c.b, false });
		}
		turn = !turn;
	}
	if (!turn) {
		cout << "First";
	}
	else {
		cout << "Second";
	}
}

