#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <experimental/random>

using namespace __gnu_pbds;
using namespace std;
using ordered_set = tree<long long, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;
using str = string;
#define all(a) a.begin(), a.end()
#define len(a) int(a.size())
#define pb push_back
#define pbb pop_back
#define vc vector
#define F first
#define S second
#define rev reverse
map<int, int> mp;
vector<int> a, b, c;

int rec(set<pair<int, int>> &s, vector<bool> &used, int order) {
    if (s.empty()) {
        return (1 - order);
    }
    auto [val, tp] = *s.begin();
    s.erase({val, tp});
    if (tp == -1) {
        int var = rec(s, used, (1 - order));
        s.insert({val, tp});
        return var;
    } else {
        int id = mp[val];
        int val1 = -1;
        if (!used[id]) {
            used[id] = true;
            s.insert({b[id], 1});
            val1 = rec(s, used, (1 - order));
            s.erase({b[id], 1});
            used[id] = false;
        }
        int val2 = rec(s, used, (1 - order));
        s.insert({val, tp});
        if (val1 == order || val2 == order) {
            return order;
        }
        return (1 - order);
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    a.resize(n), b.resize(n), c.resize(m);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < m; i++) cin >> c[i];
    for (int i = 0; i < n; i++) {
        mp[a[i]] = i, mp[b[i]] = i;
    }
    set<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.insert({a[i], 1});
    }
    for (int i = 0; i < m; i++) s.insert({c[i], -1});
    vector<bool> used(n, false);
    int var = rec(s, used, 0);
    if (var == 0) {
        cout << "First";
    } else {
        cout << "Second";
    }
    return 0;
}
