#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

bool win(set<ll>& m1, set<pair<ll, ll>>& m2) {
	bool xo = false;
	vector<ll> e1;
	while (!m1.empty() && (m2.empty() || *m1.begin() < m2.begin()->first)) {
		ll x = *m1.begin();
		m1.erase(m1.begin());
		e1.push_back(x);
		xo = !xo;
	}
	if (m2.empty()) {
		return !xo;
	}
	auto[a, b] = *m2.begin();
	m2.erase(m2.begin());
	bool b1 = win(m1, m2);
	if (!b1) {
		m2.insert(make_pair(a, b));
		for (auto j : e1) {
			m1.insert(j);
		}
		return b1 == xo;
	}
	m1.insert(b);
	bool b2 = win(m1, m2);
	m1.erase(b);
	m2.insert(make_pair(a, b));
	for (auto j : e1) {
		m1.insert(j);
	}
	return b2 == xo;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<tuple<ll, ll, ll>> all;
	vector<pair<ll, ll>> a(n);
	vector<ll> b(m);
	for (ll i = 0; i < n; i++) {
		cin >> a[i].first;
	}
	for (ll i = 0; i < n; i++) {
		cin >> a[i].second;
		all.emplace_back(a[i].first, a[i].second, 0);
	}
	for (ll i = 0; i < m; i++) {
		cin >> b[i];
		all.emplace_back(b[i], b[i], 1);
	}
	set<pair<ll, ll>> s1;
	set<ll> s2;
	for (ll i = 0; i < n; i++) {
		s1.insert(a[i]);
	}
	for (ll j = 0; j < m; j++) {
		s2.insert(b[j]);
	}
	cout << (win(s2, s1) ? "First" : "Second") << '\n';
	return;
	sort(all.begin(), all.end());
	ll now = 1;
	ll lnow = -1;
	ll le = INF;
	for (auto[s, e, t] : all) {
		if (s > le) {
			break;
		}
		now = 1 - now;
		if (t == 0) {
			if (s > e) {
				lnow = now;
				break;
			}
			le = e;
			lnow = now;
		}
	}
	if (lnow == -1) {
		lnow = now;
	}
	cout << (lnow ? "Second" : "First") << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
