#pragma GCC optmize("Ofast")
#include <bits/stdc++.h>
#define int long long

struct Node
{
    int type;
    int li;
    int off;

    Node(int type, int li, int off) : type(type), li(li), off(off) {};
};

bool cmp(const Node &a, const Node &b)
{
    int now_a = 0;
    int now_b = 0;
    if (a.type == -2)
    {
        now_a = a.li;
    }
    else if (a.type == -1)
    {
        now_a = a.li;
    }
    else
    {
        now_a = a.off;
    }

    if (b.type == -2)
    {
        now_b = b.li;
    }
    else if (b.type == -1)
    {
        now_b = b.li;
    }
    else
    {
        now_b = b.off;
    }
    return now_a < now_b;
}

signed
main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n, m;
    std::cin >> n >> m;

    std::vector<std::pair<int, int>> a(n);
    std::vector<Node> s;
    for (int i = 0; i < n; i++)
    {
        std::cin >> a[i].first;
    }
    for (int i = 0; i < n; i++)
    {
        std::cin >> a[i].second;

        s.push_back(Node(-1, a[i].first, a[i].second));
    }
    std::vector<int> c(m);
    for (int i = 0; i < m; i++)
    {
        std::cin >> c[i];
        s.push_back(Node(-2, c[i], -1));
    }

    std::sort(s.begin(), s.end(), cmp);
    std::vector<int> dp(s.size() + 1);
    dp[s.size()] = 0;
    for (int i = s.size() - 1; i >= 0; i--)
    {
        if (s[i].type == -1)
        {
            dp[i] = 1;
        }
        else
        {
            dp[i] = 1 - dp[i + 1];
        }
    }

    if (dp[0])
    {
        std::cout << "First";
    }
    else
    {
        std::cout << "Second";
    }
}