#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <ctime>
#include <random>
#include <map>
#include <set>
#define ll long long
#define nl '\n'
#define emp emplace_back
#define all(x) x.begin(), x.end()
#define pll pair<ll, ll>
#define pii pair<int, int>
#define popcnt __builtin_popcount
#define ffs __builtin__ffs
#define ss second
#define ff first
//#include <ext/pb_ds/assoc_container.hpp>
//#pragma GCC optimize("O3")
//#pragma GCC target("avx")
//#pragma GCC target("avx2")

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll INF = 1e18;

const ll mod = 998244353;

mt19937 rnd(time(nullptr));

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &x : arr) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &arr) {
    for (auto &x : arr) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

ll n, m;
vector<ll> a, b, c;
map<pll, ll> used;
set<pll> st;

bool gen() {
    if (st.empty() && c.empty()) {
        return false;
    }
    if (st.empty()) {
        return (ll)c.size() % 2;
    }
    if (c.empty() || c.back() > st.begin()->ff) {
        pll pr = *st.begin();
        st.erase(st.begin());
        bool fl1 = !gen();
        bool fl2 = false;
        if (!used[pr]) {
            swap(pr.ff, pr.ss);
            used[pr] = 1;
            st.insert(pr);
            fl2 = !gen();
            st.erase(pr);
            used[pr] = 0;
            swap(pr.ff, pr.ss);
        }
        st.insert(pr);
        return (fl1 || fl2);
    }
    ll last = c.back();
    c.pop_back();
    bool fl = !gen();
    c.emp(last);
    return fl;
}

void solve() {
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    cin >> a;
    cin >> b;
    cin >> c;
    for (ll i = 0; i < n; ++i) {
        st.insert({a[i], b[i]});
    }
    sort(all(c));
    reverse(all(c));
    if (gen()) {
        cout << "First";
    }
    else {
        cout << "Second";
    }
}

int main() {
#ifdef CLOCK
    ll time1 = clock();
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef CLOCK
    cout << clock() - time1 << " ms";
#endif
}