#include <bits/stdc++.h>

#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

using namespace std;
using ll = long long;

const ll infll = (ll) 1e18;
const int inf = (int) 1e9;
const ll MOD = 1e9 + 7;

ll mod(ll a) {
    ll r = a % MOD;
    if (r < 0) {
        return r + MOD;
    }
    return r;
}

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

int c = 0;

bool rec(vector<pair<int, pair<int, bool>>> &a) {
    if (a.empty()) {
        return false;
    }
    sort(all(a), greater<>());
    while (a.back().second.first == -1) {
        a.pop_back();
        c++;
    }
    if (a.empty()) {
        return false;
    }
    auto k = a.back();
    int m = sz(a);
    if (!k.second.second && k.second.first != -1) {
        swap(a[m - 1].second.first, a[m - 1].first);
        a[m - 1].second.second = true;
        if (!rec(a)) {
            swap(a[m - 1].second.first, a[m - 1].first);
            a[m - 1].second.second = false;
            return true;
        }
    }
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, pair<int, bool>>> cards(n);
    int mn = inf, mx = 0;
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].second.first;
        mn = min(mn, cards[i].first);
        mx = max(mx, cards[i].first);
    }
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].first;
        mx = max(mx, cards[i].second.first);
    }
    for (int i = 0; i < m; ++i) {
        int x;
        cin >> x;
        if (x < mn) {
            c++;
            continue;
        }
        if (x > mx) {
            continue;
        }
        cards.push_back({x, {-1, false}});
    }
    if (rec(cards)) {
        if ((c + n) % 2) {
            cout << "Second\n";
        } else {
            cout << "First\n";
        }
    } else {
        if ((c + n) % 2) {
            cout << "First\n";
        } else {
            cout << "Second\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}