#include <bits/stdc++.h>

#define int long long
constexpr int INF = 4e18;

int n, m;
std::vector<int> a, b;
std::vector<std::pair<int, int>> cringe;
std::map<std::pair<size_t, unsigned int>, bool> cash;

bool get(size_t pos, unsigned int mask)
{
    if (cash.count({pos, mask}))
        return cash[{pos, mask}];
    bool RES;
    if (pos == cringe.size())
        RES = false;
    else if (pos == -1) {
        bool res = get(pos + 1, mask);
        int nxt = pos + 1 == cringe.size() ? 2 * n + m + 1 : cringe[pos + 1].first;
        if ((nxt - cringe[pos].first) % 2 == 0)
            RES = res;
        else
            RES = !res;
    } else if (cringe[pos].first == b[cringe[pos].second]) {
        if (mask >> cringe[pos].second & 1) {
            bool res = get(pos + 1, mask);
            int nxt = pos + 1 == cringe.size() ? 2 * n + m + 1 : cringe[pos + 1].first;
            if ((nxt - cringe[pos].first % 2) == 0)
                RES = res;
            else
                RES = !res;
        } else {
            bool res = get(pos + 1, mask);
            int nxt = pos + 1 == cringe.size() ? 2 * n + m + 1 : cringe[pos + 1].first;
            if ((nxt - cringe[pos].first % 2) == 0)
                RES = !res;
            else
                RES = res;
        }
    } else {
        int i = cringe[pos].second;
        if (b[i] < a[i]) {
             RES = true;
        } else {
            bool res1 = get(pos + 1, mask);
            bool res2 = get(pos + 1, mask | (1 << i));
            int nxt = pos + 1 == cringe.size() ? 2 * n + m + 1 : cringe[pos + 1].first;
            if ((nxt - cringe[pos].first % 2) == 0) {
                RES = res1 || res2;
            } else {
                RES = !res1 || !res2;
            }
        }
    }
    cash[{pos, mask}] = RES;
    return RES;
}

void solve()
{
    std::cin >> n >> m;
    a.assign(n, 0);
    b.assign(n, 0);
    cringe.clear();
    cash.clear();
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
        cringe.emplace_back(a[i], i);
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> b[i];
        cringe.emplace_back(b[i], i);
    }
    std::sort(cringe.begin(), cringe.end());
    for (int i = 0; i < m; ++i) {
        int cr;
        std::cin >> cr;
    }
    
    if (get(-1, 0))
        std::cout << "First\n";
    else
        std::cout << "Second\n";
}

signed main()
{
    int t = 1;
#ifdef LOCAL
    freopen("stream/inc.txt", "r", stdin);
    freopen("stream/outc.txt", "w", stdout);
    std::cin >> t;
#else
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#endif
    for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
        solve();
    }
    std::cout.flush();
    return 0;
}