#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using sll = __int128;

template <typename T>
istream &operator>>(istream &in, pair<T, T> &a){
    in >> a.first >> a.second;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, pair<T, T> &a){
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream &operator>>(istream &in, vector<T> &a){
    for(auto &x : a) in >> x;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector<T> &a){
    for(auto x : a) out << x << ' ';
    return out;
}

void solve(){
    int n, m;
    cin >> n >> m;
    int mn = 2e9;
    for(int i = 0; i < n; i++){
        int x; cin >> x;
        mn = min(mn, x);
    }
    for(int i = 0; i < n; i++){
        int x; cin >> x;
    }
    int cnt = 0;
    for(int i = 0; i < m; i++){
        int x; cin >> x;
        cnt += (x < mn);
    }
    cout << (cnt % 2 ? "Second" : "First");
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test = 1;
//    cin >> test;
    while(test--){
        solve();
    }
}

