#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <math.h>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>


using namespace std;
using ll=long long;
const ll inf = 1e6;

ll a[500001];
ll b[500001];
ll c[500001];
ll used[500001];
ll dp[1500001];

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll n, m;
	cin >> n >> m;
	vector<pair<ll, ll> >v;
	vector<pair<ll, ll>> g;
	for (int i = 0; i <= 2 * n + m; ++i) {
		used[i] = -1;
	}
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		g.push_back({ a[i],i });
	}
	for (int i = 1; i <= n; ++i) {
		cin >> b[i];
		v.push_back({ a[i],b[i] });
		g.push_back({ b[i],i });
	}
	for (int i = 1; i <= m; ++i) {
		cin >> c[i];
		v.push_back({ c[i],-1 });
		g.push_back({ c[i],-i });
	}
	sort(v.begin(), v.end());
	reverse(v.begin(), v.end());
	sort(g.begin(), g.end());
	reverse(g.begin(), g.end());
	for (int i = 0; i < g.size(); ++i) {
		if (g[i].second < 0) {
			dp[i + 1] = 1 - dp[i];
			continue;
		}
		if (used[g[i].second] ==-1) {
			used[g[i].second] = i;
			if (a[g[i].second] > b[g[i].second]) {
				dp[i + 1] = 1;
			}
			else {
				dp[i + 1] = 1 - dp[i];
			}
		}
		else {
			if (a[g[i].second] > b[g[i].second]) {
				dp[i + 1] = dp[i];
				continue;
			}
			else {
				if (dp[i] == 0) {
					dp[i + 1] = 1;
				}
				else {
					for (int j = used[g[i].second] + 1; j < i; ++j) {
						if (g[j].second > 0 && max(a[g[j].second],b[g[j].second])<g[used[g[i].second]].first) {
							used[g[i].second] =-1;
						}
					}
					g[i].second = -g[i].second;
					dp[used[g[i].second]] = dp[used[g[i].second] - 1];
					i = used[g[i].second] + 1;
				}
			}
		}
	}
	if (dp[2 * n + m] == 1) {
		cout << "First";
	}
	else {
		cout << "Second";
	}
	
}