#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

struct p1 {
  int a, b, i;
  char is;
};

p1 operator+(p1 a, p1 b) {
  if(a.is == 2) return b;
  if(b.is == 2) return a;

  if(a.a < b.a) return a;
  else return b;
}

struct segt {
  vector<p1> t;
  int sz;

  segt(int n) {
    sz = 1; while(sz < n) sz <<= 1;
    t.resize(sz*2 - 1);
  }

  void bld(vector<p1> &a, int x, int lx, int rx) {
    if(rx-lx == 1) {
      if(lx < a.size()) t[x] = a[lx];
      else t[x] = {0,0,0,2};

      t[x].i = lx;
      return;
    }

    int md = (rx+lx)/2;
    bld(a,x*2+1,lx,md);
    bld(a,x*2+2,md,rx);
    t[x] = t[x*2+1] + t[x*2+2];
  }

  void swap(int i, int x, int lx, int rx) {
    if(rx-lx == 1) {
      std::swap(t[x].a, t[x].b);
      return;
    }

    int md = (rx+lx)/2;
    if(i < md) swap(i,x*2+1,lx,md);
    else swap(i,x*2+2,md,rx);
    t[x] = t[x*2+1] + t[x*2+2];
  }

  void setIs(int i, int v, int x, int lx, int rx) {
    if(rx-lx == 1) {
      t[x].is = v;
      return;
    }

    int md = (rx+lx)/2;
    if(i < md) setIs(i,v,x*2+1,lx,md);
    else setIs(i,v,x*2+2,md,rx);
    t[x] = t[x*2+1] + t[x*2+2];
  }
};

vector<p1> a;
segt t(1);

bool dfs() {

  int mni = t.t[0].i;
  if(t.t[0].is == 2) return 0;

  bool res = 0;
  if(!res && t.t[0].is == 0) {
    t.swap(mni, 0, 0, t.sz); t.setIs(mni, 1, 0, 0, t.sz);
    res |= !dfs();
    t.swap(mni, 0, 0, t.sz); t.setIs(mni, 0, 0, 0, t.sz);
  }
  if(!res) {
    int tmp = t.t[0].is;
    t.setIs(mni, 2, 0, 0, t.sz);
    res |= !dfs();
    t.setIs(mni, tmp, 0, 0, t.sz);
  }
  

  return res;
}

void solve() {

  int n, m; cin >> n >> m;
  a.resize(n+m); for(int i = 0; i < n; ++i)cin >> a[i].a, a[i].is = 0;
  for(int i = 0; i < n; ++i) cin >> a[i].b;
  for(int i = n; i < n+m; ++i) cin >> a[i].a, a[i].is = 1;
  t = segt(n+m); t.bld(a, 0, 0, t.sz);

  cout << (dfs() ? "First" : "Second") << '\n';

  return;
}


signed main() {
  ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef pcms2
  freopen(".in", "r", stdin);
  freopen(".out", "w", stdout);
#endif
  // int tt; cin >> tt; while(tt--)
  solve();

  return 0;
}