#include <bits/stdc++.h>

#ifndef  WILEYNE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
//#pragma GCC target("avx2")

#endif

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
using ordered_set = __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;


using ll = long long;
using ld = long double;

using namespace std;

const int MAX_N = (int) 3e5 + 100;
const double eps = acos(-1);
const int INT_INF = (int) 2e9 + 10;
const int MOD = (int) 1e9 + 7;
auto seet = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rng(seet);


struct Card {
    pair<int, int> p;
    bool can_reversed;

    Card() {}

    Card(const pair<int, int> &_p) {
        p = _p;
        can_reversed = true;
    }

    Card(const int a) {
        p.first = a;
        p.second = INT_INF;
        can_reversed = false;
    }

    void reverse() {
        swap(p.first, p.second);
        can_reversed = false;
    }

    bool operator<(const Card &other) const {
        return p < other.p;
    }
};

int n, m;
map<set<Card>, bool> mp;

bool rek(set<Card> &st) {
    if (st.empty()) {
        return true;
    }
//    if (mp.find(st) != mp.end()) {
//        return mp[st];
//    }
    auto it = st.begin();
    bool f = false;
    if (it->can_reversed) {
        auto c = *it;
        auto c1 = c;
        st.erase(it);
        c.reverse();
        st.insert(c);
        f = !rek(st);
        st.erase(c);
        st.insert(c1);
    }
    if (f) {
        return f;
    }
    it = st.begin();
    auto c = *it;
    st.erase(it);
    f = !rek(st);
    st.insert(c);
    //mp[st] = f;
    return f;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef WILEYNE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> m;
    set<Card> st;
    vector<int> a(n);
    vector<int> b(n);
    vector<int> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
    }
    vector<pair<int, int>> to_press;
    for (int i = 0; i < n; ++i) {
        to_press.emplace_back(a[i], 1);
        to_press.emplace_back(b[i], 1);
    }
    for (int i = 0; i < m; ++i) {
        to_press.emplace_back(c[i], 0);
    }
    sort(to_press.begin(), to_press.end());
    vector<int> c1;
    for (int i = 0; i < (int) to_press.size(); ++i) {
        int u = i;
        while (u < (int) to_press.size() && to_press[u].second == 0) {
            u++;
        }
        if (u != i) {
            int k = u - i;
            if (k % 2 == 0) {
                c1.push_back(to_press[i].first);
                c1.push_back(to_press[u - 1].first);
            } else {
                c1.push_back(to_press[i].first);
            }

            i = u - 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        Card card = Card({a[i], b[i]});
        st.insert(card);
    }
    for (int i = 0; i < (int) c1.size(); ++i) {
        Card card = c1[i];
        st.insert(card);
    }
    bool f = rek(st);
    if (f) {
        cout << "First";
    } else {
        cout << "Second";
    }
    return 0;
}
