#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    vector<int> b(n);
    for (int &i : b) {
        cin >> i;
    }
    vector<int> c(m);
    for (int &i : c) {
        cin >> i;
    }
    int k = m;
    vector<pair<int, int>> evs;
    for (int i = 0; i < n; ++i) {
        if (a[i] > b[i]) {
            k++;
        } else {
            evs.emplace_back(a[i], i);
            evs.emplace_back(b[i], i);
        }
    }
    sort(evs.begin(), evs.end());
    int bal = 0, t = 0;
    bool can = false;
    vector<int> used(n);
    for (auto [pos, i] : evs) {
        if (!used[i]) {
            bal++;
            used[i] = 1;
            t++;
        } else {
            bal--;
            if (bal == 0 && t % 2 == 1) {
                can = true;
            }
            t = 0;
        }
    }
    if (can || (!can && k % 2 == 1)) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
    return 0;
}
