#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
        i--;
    }
    vector<int> b(n);
    for (int &i : b) {
        cin >> i;
        i--;
    }
    vector<int> c(m);
    for (int &i : c) {
        cin >> i;
        i--;
    }
    for (int i = 0; i < n; ++i) {
        if (a[i] > b[i]) {
            b[i] = a[i];
        }
    }
    vector<int> evs(2 * n + m);
    for (int i : a) {
        evs[i] = 2;
    }
    for (int i : b) {
        evs[i] = 3 + (evs[i] == 2);
    }
    for (int i : c) {
        evs[i] = 1;
    }
    int k = 2 * n + m;
    vector<vector<int>> dp(k + 1, vector<int> (2, 0));
    dp[k][1] = 1;
    int pst = 0;
    for (int i = k - 1; i >= 0; --i) {
        if (evs[i] == 0) {
            dp[i] = dp[i + 1];
        } else if (evs[i] == 1) {
            dp[i][0] = dp[i + 1][1];
            dp[i][1] = dp[i + 1][0];
            pst = 1;
        } else if (evs[i] == 2 || evs[i] == 4) {
            if (pst != 2) {
                dp[i][0] = 1;
                dp[i][1] = 0;
            } else {
                dp[i][0] = dp[i + 1][1];
                dp[i][1] = dp[i + 1][0];
            }
            if (evs[i] == 2) {
                pst = 2;
            }
        }
        
        //cout << dp[i][0] << ' ' << dp[i][1] << endl;
    }
    if (dp[0][0]) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
    return 0;
}
//
// Created by olymp on 08.03.2025.
//
