#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
const int inf = 1e8;
struct card
{
    int t, a, b;
};
int main()
{
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (auto& x : a) cin >> x;
    for (auto& x : b) cin >> x;
    for (auto& x : c) cin >> x;
    vector<card> v;
    
    for (int i = 0; i < n; i++)
        v.push_back({1, a[i], b[i]});
    for (int i = 0; i < m; i++)
        v.push_back({0, c[i], 0});


    sort(v.begin(), v.end(), [](card a, card b) {return a.a < b.a;});
    int la = inf, li = n;
    for (int i = v.size() - 1; i >= 0; i--)
    {
        if (!v[i].t) continue;
        if (v[i].a > v[i].b || v[i].b < la)
            la = v[i].a, li = i;
        else
            v[i].b = 0;
    }
    cout << (li & 1 ? "Second" : "First");
    return 0;
}
