//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#pragma GCC optimize("Ofast,unroll-loops")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <random>
using ll = long long;
#define int ll
#define all(a) a.begin(), a.end()

using namespace std;
//using namespace __gnu_pbds;

//using odered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(0);

vector<int> a, b, c;
map<tuple<int, int, vector<int>>, bool> mem;

bool rec(int i, int j, vector<int> v) {
	if (i == a.size() && j == c.size() && v.empty()) return 0;
	if (mem.count({ i, j, v })) return mem[{i, j, v}];
	int mi = 1e9;
	int mc = -1;
	if (i != a.size() && a[i] < mi) {
		mi = a[i];
		mc = 0;
	}
	if (j != c.size() && c[j] < mi) {
		mi = c[j];
		mc = 1;
	}
	if (v.size() && v[0] < mi) {
		mi = v[0];
		mc = 2;
	}
	if (mc == 1) {
		return mem[{i, j, v}] = !rec(i, j + 1, v);
	}
	if (mc == 2) {
		auto v1 = v;
		v1.erase(v1.begin());
		return mem[{i, j, v}] = !rec(i, j, v1);
	}
	if (v.size() > 3) {
		return mem[{i, j, v}] = !rec(i + 1, j, v);
	}
	auto v1 = v;
	v1.insert(lower_bound(all(v1), b[i]), b[i]);
	return mem[{i, j, v}] = !rec(i + 1, j, v) || !rec(i + 1, j, v1);
}

void solve() {
	int n, m;
	cin >> n >> m;
	a.resize(n);
	b.resize(n);
	c.resize(m);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<pair<int, int>> v;
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		v.push_back({ a[i], b[i] });
	}
	sort(all(v));
	for (int i = 0; i < n; i++) {
		a[i] = v[i].first;
		b[i] = v[i].second;
	}
	for (int i = 0; i < m; i++) {
		cin >> c[i];
	}
	sort(all(c));
	cout << (rec(0, 0, {}) ? "First" : "Second");
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif

	int t;
	t = 1;// cin >> t;
	while (t--) {
		solve();
	}
}