#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
//
//struct segtree {
//    ll n;
//    vector<ll> t;
//
//    segtree() {}
//
//    segtree(vector<ll>& in) {
//        n = in.size();
//        t.resize(4 * n);
//        build(0, 0, n - 1, in);
//    }
//
//    void build(ll v, ll tl, ll tr, vector<ll>& in) {
//        if (tl == tr) {
//            t[v] = in[tl];
//            return;
//        }
//        ll tm = (tl + tr) / 2;
//        build(2 * v + 1, tl, tm, in);
//        build(2 * v + 2, tm + 1, tr, in);
//        t[v] = t[2 * v + 1] + t[2 * v + 2];
//    }
//
//    ll get(ll v, ll tl, ll tr, ll l, ll r) {
//        if (l <= tl && tr <= r) {
//            return t[v];
//        }
//        if (tr < l || r < tl) {
//            return 0;
//        }
//        ll tm = (tl + tr) / 2;
//        return get(2 * v + 1, tl, tm, l, r) + get(2 * v + 2, tm + 1, tr, l, r);
//    }
//
//    void upd(ll val, ll idx, ll v, ll tl, ll tr) {
//        if (tl == idx && idx == tr) {
//            t[v] = val;
//            return;
//        }
//        if (tr < idx || idx < tl) {
//            return;
//        }
//        ll tm = (tl + tr) / 2;
//        upd(val, idx, 2 * v + 1, tl, tm);
//        upd(val, idx, 2 * v + 2, tm + 1, tr);
//        t[v] = t[2 * v + 1] + t[2 * v + 2];
//    }
//
//    ll get(ll l, ll r) {
//        return get(0, 0, n - 1, l, r);
//    }
//
//    void upd(ll val, ll idx) {
//        upd(val, idx, 0, 0, n - 1);
//    }
//};
//

// C
const ll INF = 1e18;

void solve() {
    ll n, m; cin >> n >> m;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<ll> b(n);
    for (int i = 0; i < n; i++) cin >> b[i];
    vector<ll> c(m);
    for (int i = 0; i < m; i++) cin >> c[i];

//    sort(c.begin(), c.end());
//    set<pair<ll, ll>> cur;
//    for (int i = 0; i < n; i++) {
//        cur.insert({a[i], i});
//    }
//    vector<ll> cnt((1 << n));
//    for (int mask = 0; mask < (1 << n); mask++) {
//        ll prev_move = 1, prev_x = 0, fold = 0, pastC = -1;
//        ll firMask = 0;
//        while (!cur.empty()) {
//            ll todo = ((mask >> fold) & 1);
//            auto [x, idx] = *cur.begin();
//            cur.erase(cur.begin());
//            ll R = lower_bound(c.begin(), c.end(), x) - c.begin();
//            ll L = max(pastC + 1, lower_bound(c.begin(), c.end(), prev_x) - c.begin());
//            prev_move = (prev_move + max(0ll, R - L) + 1) % 2;
//            prev_x = x;
//            pastC = max(pastC, R - 1);
//            if (todo) {
//                cur.insert({b[idx], idx});
//            }
//        }
//        ll lstMove = (prev_move + (m - pastC - 1)) % 2;
//        if (!lstMove) {
//            cout << "First" << '\n';
//        } else {
//            cout << "Second" << '\n';
//        }
//    }

    vector<vector<ll>> evs;
    for (int i = 0; i < n; i++) {
        evs.push_back({a[i], 0, i});
        if (a[i] < b[i]) {
            evs.push_back({b[i], 1, i});
        }
    }
    for (int i = 0; i < m; i++) {
        evs.push_back({c[i], 2});
    }
    sort(evs.begin(), evs.end());
    ll sz = evs.size();
    vector<vector<ll>> dp(sz + 1, vector<ll> (1 << n, 0));
    for (int i = sz - 1; i >= 0; i--) {
        for (int mask = 0; mask < (1 << n); mask++) {
            ll type = evs[i][1];
            if (type == 1) {
                ll idx = evs[i][2];
                if (!((mask >> idx) & 1)) {
                    continue;
                }
                dp[i][mask] = (1 - dp[i + 1][mask]);
            } else if (type == 0) {
                ll idx = evs[i][2];
                if (((mask >> idx) & 1)) {
                    continue;
                }
                if (a[idx] > b[idx]) {
                    dp[i][mask] = max(1 - dp[i + 1][mask], dp[i + 1][mask]);
                } else {
                    dp[i][mask] = max(1 - dp[i + 1][mask], (1 - dp[i + 1][(mask ^ (1 << idx))]));
                }
            } else {
                dp[i][mask] = (1 - dp[i + 1][mask]);
            }
            // cout << i << " - " << dp[i][0] << '\n';
        }
    }
    if (dp[0][0]) {
        cout << "First" << '\n';
    } else {
        cout << "Second" << '\n';
    }

}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    ll tst = 1;
    while (tst--) {
        solve();
    }
}


//const ll INF = 1e18;
//const ll N = 2005;
//
//vector<ll> g[N], rev[N];
//bool used[N];
//bool reach[N][N];
//
//void dfs_reach(ll v, ll root) {
//    reach[root][v] = true;
//    used[v] = true;
//    for (auto to : g[v]) {
//        if (!used[to]) {
//            dfs_reach(to, root);
//        }
//    }
//}
//
//vector<ll> top;
//void dfs_top(ll v) {
//    used[v] = true;
//    for (auto to : g[v]) {
//        if (!used[to]) {
//            dfs_top(to);
//        }
//    }
//    top.push_back(v);
//}
//
//void solve() {
//    ll n, m, G; cin >> n >> m >> G;
//    for (int i = 0; i < m; i++) {
//        ll u, v; cin >> u >> v;
//        u--; v--;
//        g[u].push_back(v);
//        rev[v].push_back(u);
//    }
//    for (int v = 0; v < n; v++) {
//        for (int i = 0; i < n; i++) {
//            used[i] = false;
//        }
//        dfs_reach(v, v);
//    }
//    for (int i = 0; i < n; i++) {
//        used[i] = false;
//    }
//    for (int i = 0; i < n; i++) {
//        if (!used[i]) {
//            dfs_top(i);
//        }
//    }
////    reverse(top.begin(), top.end());
////    for (auto v : top) {
////        cout << v + 1 << " ";
////    }
////    cout << '\n';
//    vector<ll> num(n);
//    for (int i = 0; i < n; i++) {
//        num[top[i]] = i;
//    }
//    ll need = 0;
//    for (int v = n - 1; v >= 0; v--) {
//        vector<pair<ll, ll>> vs;
//        for (auto to : rev[v]) {
//            vs.push_back({to, to});
//        }
//        sort(vs.begin(), vs.end());
//        for (int i = 0; i < vs.size(); i++) {
//            bool plus = true;
//            for (int j = i - 1; j >= 0; j--) {
//                if (reach[vs[j].second][vs[i].second]) {
//                    plus = false;
//                    break;
//                }
//            }
//            need += plus;
//        }
//    }
//    cout << m - need << '\n';
//    cout << 1 << '\n';
//}
//
//const ll INF = 1e18;
//const ll N = 2005;
//
//ll n, m;
//vector<pair<ll, ll>> g[N];
//bool used[N];
//
//void dfs_dag_reach(ll v, ll block, vector<vector<pair<ll, ll>>>& dag_g) {
//    used[v] = true;
//    for (auto [to, e] : dag_g[v]) {
//        if (e == block) continue;
//        if (!used[to]) {
//            dfs_dag_reach(to, block, dag_g);
//        }
//    }
//}
//
//
//
//void find_dag(vector<pair<ll, ll>>& es, vector<vector<pair<ll, ll>>>& dag_g) {
//    ll need = 0;
//    for (int e = 0; e < m; e++) {
//        for (int i = 0; i < n; i++) {
//            used[i] = false;
//        }
//        ll u = es[e].first, v = es[e].second;
//        dfs_dag_reach(u, e, dag_g);
//        need += used[v];
//    }
//    cout << need << '\n';
//    cout << 1 << '\n';
//}
//
//
////
////bool reach[N][N];
//
//void dfs_reach(ll v, ll block) {
//    used[v] = true;
//    for (auto [to, e] : g[v]) {
//        if (e == block) continue;
//        if (!used[to]) {
//            dfs_reach(to, block);
//        }
//    }
//}
//
//void solve() {
//    ll n, m, G; cin >> n >> m >> G;
//    vector<pair<ll, ll>> es;
//    for (int i = 0; i < m; i++) {
//        ll u, v; cin >> u >> v;
//        u--; v--;
//        g[u].push_back({v, i});
//        es.push_back({u, v});
//    }
//
//    ll need = 0;
//    for (int e = 0; e < m; e++) {
//        for (int i = 0; i < n; i++) {
//            used[i] = false;
//        }
//        ll u = es[e].first, v = es[e].second;
//        g[v].push_back({u, m});
//
//        dfs_reach(u, e);
//        bool ok = false;
//        for (int j = 0; j < n; j++) {
//            if (!used[j]) {
//                ok = true;
//            }
//        }
//
//        g[v].pop_back();
//        if (ok) {
//            cout << u << " " << v << '\n';
//        }
//        need += ok;
//    }
//    cout << need << '\n';
//    cout << 1 << '\n';
//}
//
//
//int main() {
//    ios_base::sync_with_stdio(false); cin.tie(0);
//
//    ll tst = 1;
//    while (tst--) {
//        solve();
//    }
//}