#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cstdint>
using namespace std;
#define int long long

void solution();

int32_t main() {
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solution();
    }
}

void solution() {
    int n, m;
    cin >> n >> m;

    vector<int> a(n), b(n), c(m);
    for (auto &x : a) cin >> x;
    for (auto &x : b) cin >> x;
    for (auto &x : c) cin >> x;

    vector<pair<int, int>> cards;
    for (int i = 0; i < n; ++i) {
        cards.emplace_back(a[i], 0);
    }
    for (int i = 0; i < m; ++i) {
        cards.emplace_back(c[i], 1);
    }

    sort(cards.begin(), cards.end());

    int cnt = 0;
    int num = 0;
    for (int i = 0; i < cards.size(); ++i) {
        if (cards[i].second == 0) num++;
        if (num == n) break;
        cnt++;
    }

    if (cnt % 2 == 0) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}