#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cstdint>
using namespace std;
#define int long long

void solution();

int32_t main() {
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int t = 1;
    // cin >> t;
    while (t--) {
        solution();
    }
}

void solution() {
    int n, m;
    cin >> n >> m;

    vector<int> a(n), b(n), c(m);
    for (auto &x : a) cin >> x;
    for (auto &x : b) cin >> x;
    for (auto &x : c) cin >> x;

    vector<pair<int, int>> cards;
    for (int i = 0; i < n; ++i) {
        cards.emplace_back(a[i], b[i]);
    }
    for (int i = 0; i < m; ++i) {
        cards.emplace_back(c[i], -1);
    }

    sort(cards.begin(), cards.end());

    pair<int, int> cur = {1e9, 1e9};
    for (int i = cards.size() - 1; i >= 0; --i) {
        if (cards[i].second == -1) continue;
        if (cards[i].second > cur.first) continue;
        cur = cards[i];
    }

    int cnt = 0;
    for (int i = 0; cards[i] != cur; ++i) {
        cnt++;
    }

    if (cnt % 2 == 0) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}