//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
//#pragma GCC target("avx2")
using namespace std;
using ll = int;
vector<ll> a, b;

set<pair<ll, ll>> st;

bool Game(ll cnt, ll step) {
    if (cnt == 0) {
        return st.size() % 2 == step;
    }
    auto u = *st.begin();
    bool f1 = true, f2 = false;
    if (u.second < 0) {
        st.erase(st.begin());
        bool e = Game(cnt, (step + 1) % 2);

        f1 &= e;
        f2 |= e;
        st.insert(u);

        if (step && !e) {
            return false;
        }
    } else {
        bool f = false;
        
        st.erase(st.begin());
        bool e = Game(cnt - 1, (step + 1) % 2);
        f1 &= e;
        f2 |= e;

        if (step && !e) {
            f = true;
        }

        st.insert({ b[u.second], -(u.second + 1) });
        e = Game(cnt - 1, (step + 1) % 2);
        f1 &= e;
        f2 |= e;

        if (step && !e) {
            f = true;
        }

        st.erase({ b[u.second], -(u.second + 1) });
        st.insert(u);
        
        if (f) {
            return false;
        }
    }
    return (!step && f2) || (step && f1);
}

void solve() {
    ll n, m;
    cin >> n >> m;
    a.resize(n); b.resize(n);
    vector<ll> c(m);
    for (ll &i : a) {
        cin >> i;
    }
    for (ll &i : b) {
        cin >> i;
    }
    for (ll &i : c) {
        cin >> i;
    }
    for (ll i = 0; i < n; ++i) {
        st.insert({ a[i], i });
    }
    for (ll i = 0; i < m; ++i) {
        st.insert({ c[i], -(i + 1) });
    }
    if (Game(n, 0)) {
        cout << "First" << endl;
    } else {
        cout << "Second" << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
//    cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}

