#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ld = long double;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    for (int i=0; i < n; ++i) {
        cin >> a[i];
    }
    vector <int> b(n);
    for (int i=0; i < n; ++i) {
        cin >> b[i];
    }
    vector <int> c(m);
    for (int i=0; i < m; ++i) {
        cin >> c[i];
    }
    vector <int> q;
    vector <pair <int, int>> d;
    for (int i=0; i < n; ++i) {
        d.emplace_back(a[i], b[i]);
    }
    for (int i=0; i < m; ++i) {
        d.emplace_back(c[i], 0);
    }
    sort(d.begin(), d.end());
    for (pair <int, int> p : d) {
        q.push_back(p.first);
        q.push_back(p.second);
    }
    vector <bool> ans(q.size() + 1);
    ans[q.size()] = false;
    ans[q.size() - 1] = true;
    for (int i=q.size() - 2; i >= 0; --i) {
        if (q[i] == 0) continue;
        if (q[i + 1]) {
            ans[i] = (!ans[i + 1] || !ans[i + 2]);
        } else {
            ans[i] = (!ans[i + 2]);
        }
    }
    if (ans[0]) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
    return 0;
}
