#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ull = unsigned long long;
using ld = long double;
const ull M = 1791791791;
const ull P = 100003;
const int N = 20;
const int maxi = 2 * 20 + 500000;
ull deg[maxi + 1];
vector <pair <int, int>> ab;

unordered_map <ull, bool> dp[N];
bool f(int ind, set <int> s, ull H) {
    if (ind == ab.size()) {
        return s.size() % 2;
    }
    if (dp[ind].find(H) != dp[ind].end()) return dp[ind][H];
    int cnt = 0;
    ull h = H;
    while (!s.empty() && (*s.begin()) < ab[ind].first) {
        cnt++;
        h = (h + M - deg[*s.begin()]) % M;
        s.erase(s.begin());
    }
    if (cnt) {
        if (cnt % 2 == 0) {
            return dp[ind][H] = f(ind, s, h);
        }
        return dp[ind][H] = !f(ind, s, h);
    }
    bool q1 = f(ind + 1, s, h);
    if (!q1) {
        return dp[ind][h] = true;
    }
    h = (h + deg[ab[ind].second]) % M;
    s.insert(ab[ind].second);
    return dp[ind][H] = !f(ind + 1, s, h);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i=0; i < n; ++i) {
        int a;
        cin >> a;
        ab.emplace_back(a, 0);
    }
    for (int i=0; i < n; ++i) {
        cin >> ab[i].second;
    }
    sort(ab.begin(), ab.end());
    set <int> c;
    for (int i=0; i < m; ++i) {
        int w;
        cin >> w;
        c.insert(w);
    }
    ull h = 0;
    deg[0] = 1;
    for (int i=1; i <= maxi; ++i) {
        deg[i] = deg[i - 1] * P % M;
    }
    for (int e : c) {
        h = (h + deg[e]) % M;
    }
    if (f(0, c, h)) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
    return 0;
}
