#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <vector>
#include <map>
#include <cmath>
#include <assert.h>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el;
    }
    return out;
}
const ll INF = 1e18;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, m;
    cin >> n >> m;
    vector<ll> arr(n), brr(n), crr(m);
    cin >> arr >> brr >> crr;
    vector<bool> flip(n);
    set<vector<ll>> all;
    for (ll i = 0; i < n; ++i) {
        all.insert({arr[i], brr[i], i});
    }
    for (ll j = 0; j < m; ++j) {
        all.insert({crr[j], crr[j], -j});
    }
    if ((n + m) % 2) {
        cout << "First";
    } else {
        cout << "Second";
    }
}