#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <climits>
#include <cmath>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()
#define len(v) (ll)v.size()

mt19937 rnd(525252);

const ll INF = 1e9, SZ = 30, MOD = 1e9 + 7;
const ld eps = 1e-8, pi = acosl(-1);

void solve() {
    ll n, m; cin >> n >> m;
    vector<ll>v(2 * n + m, -1);
    vector<ll>a(n), b(n), c(m);
    for (ll i = 0; i < n; ++i){
        cin >> a[i];
        a[i]--;
    }
    for (ll i = 0; i < n; ++i){
        cin >> b[i];
        b[i]--;
        b[i] = max(a[i], b[i]);
        v[a[i]] = b[i];
        v[b[i]] = a[i];
    }
    for (ll j = 0; j < m; ++j){
        cin >> c[j];
        c[j]--;
        v[c[j]] = -2;
    }

    ll cur = len(v) - 1, last = len(v);
    while (cur >= 0){
        if (v[cur] < 0){
            cur--;
            continue;
        }
        if (v[cur] <= cur){
            cur = v[cur];
            last = cur;
        }
        cur--;
    }
    ll pl = 0;
    for (ll i = 0; i <= last; ++i){
        if (v[i] != -1) pl = 1 - pl;
    }
//    for (auto &i : v) cout << i << ' ';
//    cout << '\n' << last << '\n';
    if (!pl) cout << "Second";
    else cout << "First";
}

int main()
{
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

//	freopen("in.txt", "r", stdin);
//	freopen("out.txt", "w", stdout);
//    cin >> t;

    while (t--) {
        solve();
        cout << '\n';
    }
}
