#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <random>
#include <queue>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(3231213214);
const ll INF = 1e18;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	vector<int> b(n);
	vector<int> c(m);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++)
		cin >> b[i];
	for (int i = 0; i < m; i++)
		cin >> c[i];

	
	vector<pair<int, int>> vec;
	for (int i = 0; i < n; i++)
		vec.push_back({ a[i], max(b[i], a[i]) });
	sort(vec.begin(), vec.end());

	set<pair<int, int>> st;
	for (int i = 0; i < n; i++)
		st.insert({ -vec[i].second, i });

	int lst = n * 2 + m;
	vector<bool> good(n, 1);
	for (int i = n - 1; i >= 0; i--) {
		if (!good[i])
			continue;
		lst = vec[i].first;
		while (!st.empty() && -st.begin()->first >= vec[i].first) {
			good[st.begin()->second] = 0;
			st.erase(st.begin());
		}
	}

	int ans = 0, gr = lst;
	for (int i = 0; i < n; i++) {
		if (a[i] <= gr)
			ans++;
	}
	for (auto x : c)
		if (x <= gr)
			ans++;
	cout << (ans % 2 == 1 ? "First" : "Second");
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	solve();
}