#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <tuple>
#include <random>
#include <queue>
#include <cmath>

using namespace std;
using ll = long long;

constexpr int INF = 1e9 + 7;
constexpr ll LINF = 1e18 + 7;


vector<int>cnt;
vector<int>nxt;
vector<int>a, b;
int dfs(int mask, int lst, int mask2) {
    if (mask == 0) {
        if (cnt.back() - lst < 0) return 0;
        return (cnt.back() - lst) & 1;
    }
    int fst = 0, mn = INF;
    for (int i = 0; i < 21; ++i) {
        if ((mask >> i) & 1) {
            int val = -1;
            if ((mask2 >> fst) & 1) val = a[fst];
            else val = b[fst];
            if (val < mn) {
                mn = val; fst = i;
            }
        }
    }
   
    int x = max(0, cnt[mn] - lst);
    if (!((mask2 >> fst) & 1)) {
        int res = dfs(mask - (1 << fst), lst + x, mask2);
        if (res) {
            if (x & 1) return 0;
            else return 1;
        }
        else {
            if (x & 1) return 1;
            return 0;
        }
    }
    int res1 = dfs(mask - (1<<fst), lst + x, mask2 - (1 << fst));
    int res2 = dfs(mask, lst + x, mask2 - (1 << fst));
    if (x & 1) {
        if (res1 || res2) return 0;
        return 1;
    }
    else {
        if (!res1 || !res2) return 1;
        return 0;
    }
    return 0;
}

int main()
{
    int n, m;
    cin >> n >> m;
    vector<int> c(m);
    a.resize(n);
    b.resize(n);
    int sz = 2 * n + m;
    cnt.resize(sz); nxt.resize(sz, -1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; --a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i]; --b[i];
        nxt[a[i]] = b[i];
        nxt[b[i]] = -2;
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i]; --c[i];
    }
    for (int i = 0; i < sz; ++i) {
        if (i > 0) cnt[i] = cnt[i - 1];
        if (nxt[i] == -1) cnt[i]++;
    }
    int mask = (1 << n) - 1;
    if (dfs(mask, 0, (1 << n) - 1)) cout << "First\n";
    else cout << "Second\n";
}
