#include <bits/stdc++.h>
using namespace std;
#ifdef _LOCAL
#define debug(x) cerr << __LINE__ << ' ' << __PRETTY_FUNCTION__ << ": " << x << '\n';
#else
#define debug(...) 238;
#endif
mt19937 rng(238);
mt19937_64 rng64(238);
using ll = long long;
template <typename T, int U>
using ar = array<T, U>;
template <typename T, typename U>
bool chmin(T& x, const U&& y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
template <typename T, typename U>
bool chmax(T& x, const U&& y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

#include <ext/pb_ds/assoc_container.hpp>
template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type,
                                     less<T>,
                                     __gnu_pbds::rb_tree_tag,
                                     __gnu_pbds::tree_order_statistics_node_update>; 

constexpr int Inf = 0x3f3f3f3f;
constexpr ll  inf = 0x3f3f3f3f3f3f3f3f;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n);
    for (int& x : a) {
        cin >> x;
    }   
    for (int& x : b) {
        cin >> x;
    }   
    vector<int> c(m);
    for (int& x : c) {
        cin >> x;
    }

    const auto dfs = [&](auto &&self, int A, int B, int C) -> bool {
        if (B == (1 << n) - 1 && C == (1 << m) - 1) {
            return false;
        }
        int v = Inf, how1, how2;
        for (int i = 0; i < n; ++i) {
            int curv = Inf;
            if (!(B >> i & 1)) {
                if (A >> i & 1) {
                    curv = b[i];
                } else {
                    curv = a[i];
                }
            }
            if (curv < v) {
                v = curv, how1 = i, how2 = 0;
            }
        }
        for (int i = 0; i < m; ++i) {
            int curv = Inf;
            if (!(C >> i & 1)) {
                curv = c[i];
            }
            if (curv < v) {
                v = curv, how1 = i, how2 = 1;
            }
        }
        if (how2 == 1) {
            C |= 1 << how1;
            return 1 ^ self(self, A, B, C);
        }
        if (A >> how1 & 1) {
            B |= 1 << how1;
            return 1 ^ self(self, A, B, C);
        }
        return 1 ^ min(self(self, A | (1 << how1), B, C),
                       self(self, A, B | (1 << how1), C));

    };

    if (dfs(dfs, 0, 0, 0)) {
        cout << "First";
    } else {
        cout << "Second";
    }
}

int main() {
#ifdef _LOCAL
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while (Tc--) {
        solve();
        cout << '\n';
    }

    return 0;
}