#ifdef _MSC_VER
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream& operator>>(istream& is, vector<T>& a) {
	for (auto& i : a) {
		is >> i;
	}
	return is;
}

int32_t main() {
#ifdef LOCAL
	assert(freopen("C:\\Users\\User\\input.txt", "r", stdin));
#else
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int n, m;
	cin >> n >> m;
	vector<array<int, 4>> all;
	vector<pair<int, int>> A(n);
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		A[i].first = a;
	}
	for (int i = 0; i < n; ++i) {
		int b;
		cin >> b;
		A[i].second = b;
	}
	for (int i = 0; i < n; ++i) {
		auto [a, b] = A[i];
		all.push_back({ a, b, i, true });
	}
	for (int i = 0; i < m; ++i) {
		int c;
		cin >> c;
		all.push_back({ c, -1, n + i, true });
	}
	sort(all.begin(), all.end());
	int last = 0;
	for (int i = 0; i < (int)all.size(); ++i) {
		if (all[i][1] != -1) {
			if (i % 2 == 0) {
				last = 0;
			}
			else {
				last = 1;
			}
		}
	}
	if (last == 0) {
		cout << "First\n";
	}
	else {
		cout << "Second\n";
	}
	return 0;
}