#ifdef _MSC_VER
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream& operator>>(istream& is, vector<T>& a) {
	for (auto& i : a) {
		is >> i;
	}
	return is;
}

int32_t main() {
#ifdef LOCAL
	assert(freopen("C:\\Users\\User\\input.txt", "r", stdin));
#else
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int n, m;
	cin >> n >> m;
	set<array<int, 4>> all;
	vector<pair<int, int>> A(n);
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		A[i].first = a;
	}
	for (int i = 0; i < n; ++i) {
		int b;
		cin >> b;
		A[i].second = b;
	}
	for (int i = 0; i < n; ++i) {
		auto [a, b] = A[i];
		all.insert({ a, b, i, true });
	}
	for (int i = 0; i < m; ++i) {
		int c;
		cin >> c;
		all.insert({ c, -1, n + i, true });
	}
	auto calc = [&](auto calc, int player) -> int {
		if (all.empty()) {
			return player ^ 1;
		}
		auto [a, b, i, face] = *all.begin();
		if (b == -1 || !face) {
			all.erase(all.begin());
			int res = calc(calc, player ^ 1);
			all.insert({ a, b, i, face });
			return res;
		}
		else {
			all.erase(all.begin());
			all.insert({ b, a, i, !face });
			vector<int> res;
			res.push_back(calc(calc, player ^ 1));
			all.erase({ b, a, i, !face });
			all.insert({ a, b, i, face });
			all.erase(all.begin());
			res.push_back(calc(calc, player ^ 1));
			all.insert({ a, b, i, face });
			if (res[0] == player || res[1] == player) {
				return player;
			}
			else {
				return player ^ 1;
			}
		}
	};
	if (calc(calc, 0) == 0) {
		cout << "First\n";
	}
	else {
		cout << "Second\n";
	}
	return 0;
}