#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;

#pragma GCC optimize("Ofast")

#define int long long

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;
	vector <int> a(n);
	vector <int> b(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
	}
	vector <int> c(m);
	for (int i = 0; i < m; i++) {
		cin >> c[i];
	}
	vector <pair <int, int>> cs;
	for (int i = 0; i < n; i++) {
		cs.push_back({ 2 * a[i], 1 });
		cs.push_back({ 2 * a[i] + 1, 0 });
	}
	for (int i = 0; i < m; i++) {
		cs.push_back({ 2 * c[i], 0 });
	}
	sort(cs.begin(), cs.end());
	int curr = 0;
	vector <int> win(cs.size() + 1);
	vector <int> los(cs.size() + 1);
	win.back() = 1;
	for (int i = cs.size() - 2; i >= 0; i--) {
		if (cs[i].second == -0) {
			if (los[i + 1]) {
				los[i] = 1;
			}
			else {
				win[i] = 1;
			}
		}
		else {
			int wcnt = win[i + 1] + win[i + 2];
			int lcnt = los[i + 1] + los[i + 2];
			if (lcnt) {
				win[i] = 1;
			}
			else {
				los[i] = 1;
			}
		}
	}

	if (los[0]) {
		cout << "Second";
	}
	else {
		cout << "First";
	}
}