#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

ll inf = (ll)1e18;

template<class T>
ll len(T& a) {
    return (ll)a.size();
}

ll n, m;
vector<ll> a, b, c;

void solve() {
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);

    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    };
    for (ll i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (ll i = 0; i < m; ++i) {
        cin >> c[i];
    }

    gp_hash_table<ll, ll> gp;
    for (ll i = 0; i < n; ++i) {
        gp[a[i]] = b[i];
    }

    priority_queue<ll, vector<ll>, greater<ll>> q;
    for (ll i = 0; i < n; ++i) {
        q.push(a[i]);
    }
    for (ll i = 0; i < m; ++i) {
        q.push(c[i]);
    }

    ll hod = 0;
    while (len(q) > 0) {
        ll value = q.top(); q.pop();

        if (gp.find(value) != gp.end()) {
            if (len(q) % 2 == 1) {
                q.push(gp[value]);
            }
        }
        hod = !hod;
    }

    if (hod == 0) {
        cout << "Second\n";
    } else {
        cout << "First\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
