#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

ll inf = (ll)1e18;

template<class T>
ll len(T& a) {
    return (ll)a.size();
}

void solve() {
    ll n, m;
    cin >> n >> m;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        a[i]--;
    }

    vector<ll> b(n);
    for (ll i = 0; i < n; ++i) {
        cin >> b[i];
        b[i]--;
    }

    gp_hash_table<ll, ll> gp;
    for (ll i = 0; i < n; ++i) {
        gp[a[i]] = b[i];
    }

    vector<ll> c(m);
    for (ll i = 0; i < m; ++i) {
        cin >> c[i];
        c[i]--;
    }

    ll add = 2 * n + m + 1;

    vector<vector<vector<ll>>> gr(add + 1, vector<vector<ll>>(2));
    vector<vector<vector<ll>>> g(add + 1, vector<vector<ll>>(2));

    vector<ll> curr;
    curr.insert(curr.end(), a.begin(), a.end());
    curr.insert(curr.end(), c.begin(), c.end());
    sort(curr.begin(), curr.end());

    for (ll i = 1; i < len(curr); ++i) {
        g[curr[i-1]][0].push_back(curr[i]);
        gr[curr[i]][1].push_back(curr[i-1]);

        g[curr[i-1]][1].push_back(curr[i]);
        gr[curr[i]][0].push_back(curr[i-1]);
    }

    priority_queue<ll, vector<ll>, greater<ll>> q;
    for (ll i = 0; i < len(curr); ++i) {
        if (gp.find(curr[i]) != gp.end()) {
            q.push(gp[curr[i]]);
        }

        ll value = curr[i];
        if (i % 2 == 0 && len(g[curr[i]][0]) > 0) {
            value = g[curr[i]][0][0];
        } else if (i % 2 == 1 && len(g[curr[i]][1]) > 0) {
            value = g[curr[i]][1][0];
        }


        while (len(q) > 0) {
            ll temp = q.top();
            q.pop();

            if (temp < value) {
                    g[curr[i]][0].push_back(temp);
                    gr[temp][1].push_back(curr[i]);

                    if (i + 1 < len(curr)) {
                        g[temp][1].push_back(curr[i + 1]);
                        gr[curr[i + 1]][0].push_back(temp);
                    }
                    g[curr[i]][1].push_back(temp);
                    gr[temp][0].push_back(curr[i]);

                    if (i + 1 < len(curr)) {
                        g[temp][0].push_back(curr[i + 1]);
                        gr[curr[i + 1]][1].push_back(temp);
                    }
            } else {
                q.push(temp);
                break;
            }
        }
    }

    /*cout << "first" << endl;
    for (ll i = 0; i < len(g); ++i) {
        cout << i << ": ";
        for (ll j = 0; j < len(g[i][0]); ++j) {
            cout << g[i][0][j] << " ";
        }
        cout << endl;
    }
    cout << "second" << endl;
    for (ll i = 0; i < len(g); ++i) {
        cout << i << ": ";
        for (ll j = 0; j < len(g[i][1]); ++j) {
            cout << g[i][1][j] << " ";
        }
        cout << endl;
    }*/

    gr[add - 1][0].push_back(curr.back());
    gr[add - 1][1].push_back(curr.back());
    g[add-1][0].push_back(curr.back());
    g[add-1][1].push_back(curr.back());

    for (ll i = 0; i < add - 1; ++i) {
        if (len(g[i][0]) == 0) {
            gr[add - 1][0].push_back(i);
            gr[add - 1][1].push_back(i);
            g[add-1][0].push_back(i);
            g[add-1][1].push_back(i);
            //cout << i << endl;
        }
    }

    /*cout << "first: ";
    for (ll i = 0; i < len(gr); ++i) {
        cout << i << ": ";
        for (ll j = 0; j < len(gr[i][0]); ++j) {
            cout << gr[i][0][j] << " ";
        }
        cout << endl;
    }

    cout << "second: ";
    for (ll i = 0; i < len(gr); ++i) {
        cout << i << ": ";
        for (ll j = 0; j < len(gr[i][1]); ++j) {
            cout << gr[i][1][j] << " ";
        }
        cout << endl;
    }*/

    auto dfs1 = [&](auto foo, ll x, ll curr) -> bool {
        ll res = 0;
        for (ll to : g[x][curr]) {
            res |= (!foo(foo, to, !curr));
        }
        return res;
    };

    if (dfs1(dfs1, curr[0], 0)) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}