#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

ll inf = (ll)1e18;

template<class T>
ll len(T& a) {
    return (ll)a.size();
}

set<ll> curr;
gp_hash_table<ll, ll> gp;

bool find(ll x) {
    if (len(curr) == 0) { return false; }

    ll res = 0;
    if (gp.find(*curr.begin()) != gp.end()) {
        ll temp = *curr.begin();
        curr.erase(curr.begin());
        curr.insert(gp[temp]);
        res |= !find(x + 1);
        curr.erase(gp[temp]);
        curr.insert(temp);
    }
    ll temp = *curr.begin();
    curr.erase(curr.begin());
    res |= !find(x + 1);
    curr.insert(temp);
    return res;
}

void solve() {
    ll n, m;
    cin >> n >> m;

    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> b(n);
    for (ll i = 0; i < n; ++i) {
        cin >> b[i];
    }

    for (ll i = 0; i < n; ++i) {
        gp[a[i]] = b[i];
    }

    vector<ll> c(m);
    for (ll i = 0; i < m; ++i) {
        cin >> c[i];
    }

    for (ll i = 0; i < len(a); ++i) {
        curr.insert(a[i]);
    }
    for (ll i = 0; i < len(c); ++i) {
        curr.insert(c[i]);
    }


    if (find(0)) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
