//#pragma GCC optimize("O3")
//#pragma GCC target("avx, avx2")
#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
#define ALL(X) (X).begin(), (X).end()
#define sz(X) (int)(X.size())

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;

#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

struct node{
	//-1 l
	// 0 point
	// 1 r
	int x, t, ind;
	node(int _x, int _t, int _ind) : x(_x), t(_t), ind(_ind) {}
	node() = default;
	bool operator< (node a) {
		if (x == a.x)
			return t < a.t;
		return x < a.x;
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	vector<int> a(n), b(n);	
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	vector<int> c(m);
	for (int i = 0; i < m; ++i) {
		cin >> c[i];
	}
	vector<node> sl;
	for (int i = 0; i < n; ++i) {
		if (a[i] < b[i]) {
			sl.emplace_back(a[i], -1, i);
			sl.emplace_back(b[i], 1, i);	
		} else {
			sl.emplace_back(a[i], -1, i);
			sl.emplace_back(a[i], 1, i);
		}
	}
	for (int i = 0; i < m; ++i) {
		sl.emplace_back(c[i], 0, -1);
	}
	sort(ALL(sl));
	vector<int> pos(n);
	for (int i = 0; i < sz(sl); ++i) {
		if (sl[i].t == 1) {
			pos[sl[i].ind] = i;
		}
	}
	int lb = sz(sl);
	while (true) {
		int m_i = -1;
		for (int i = 0; i < lb; ++i) {
			if (sl[i].t == -1 && pos[sl[i].ind] < lb) {
				m_i = i;
			}
		}	
		if (m_i == -1) {
			break;
		} 
		lb = m_i;
	}
	if (lb % 2 == 0) {
		cout << "First\n";
	} else {
		cout << "Second\n";
	}
	return 0;
}