#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()
#define coutd cout << fixed << setprecision(20)

using namespace std;
using ll = long long;
using ld = long double;

void ans(int x)
{
    if (x == 1)
    {
        cout << "First";
    } else
    {
        cout << "Second";
    }
    exit(0);
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> b(n);
    vector<int> c(m);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i)
    {
        cin >> c[i];
    }
    /// a[i] > b[i]
    /*vector<pair<int, int>> vs;
    for (int i = 0; i < n; ++i)
    {
        vs.push_back({a[i], b[i]});
    }
    for (int i = 0; i < m; ++i)
    {
        vs.push_back({c[i], -1});
    }
    sort(all(vs));
    for (int i = 0; i < n + m; ++i)
    {
        if (vs[i].second != -1)
        {
            if (i % 2 == 0)
            {
                ans(1);
            } else
            {
                ans(2);
            }
        }
    }
    if ((n + m) % 2 == 0)
    {
        ans(2);
    } else
    {
        ans(1);
    }*/
    /// max(a) < min(b)
    /*if (n == 0)
    {
        if (m % 2 == 1)
        {
            ans(1);
        } else
        {
            ans(2);
        }
    }
    vector<pair<int, int>> vs;
    for (int i = 0; i < n; ++i)
    {
        vs.push_back({a[i], b[i]});
    }
    for (int i = 0; i < m; ++i)
    {
        vs.push_back({c[i], -1});
    }
    sort(all(vs));
    for (int i = n + m - 1; i >= 0; --i)
    {
        if (vs[i].second != -1)
        {
            if (i % 2 == 0)
            {
                ans(1);
            } else
            {
                ans(2);
            }
        }
    }*/
    /// n <= 20
    int N = (1 << n);
    for (int msk = 0; msk < N; ++msk)
    {
        set<pair<int, int>> st;
        for (int i = 0; i < n; ++i)
        {
            st.insert({a[i], i});
        }
        for (int i = 0; i < m; ++i)
        {
            st.insert({c[i], -1});
        }
        int cur = 0;
        while (!st.empty())
        {
            auto p = *st.begin();
            if (p.second == -1)
            {
                st.erase(p);
            } else
            {
                int id = p.second;
                if ((msk >> id) & 1)
                {
                    st.erase(p);
                } else
                {
                    st.erase(p);
                    st.insert({b[id], -1});
                }
            }
            cur = 1 - cur;
        }
        if (cur == 1)
        {
            ans(1);
        } else
        {
            ans(2);
        }
    }

    return 0;
}
