#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()
#define coutd cout << fixed << setprecision(20)

using namespace std;
using ll = long long;
using ld = long double;

void ans(int x)
{
    if (x == 1)
    {
        cout << "First";
    } else
    {
        cout << "Second";
    }
    exit(0);
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> b(n);
    vector<int> c(m);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i)
    {
        cin >> c[i];
    }
    if (n == 0)
    {
        if (m % 2 == 1)
        {
            ans(1);
        } else
        {
            ans(2);
        }
    }
    vector<pair<int, int>> vs;
    vector<int> nvs;
    for (int i = 0; i < n; ++i)
    {
        vs.push_back({a[i], i});
        nvs.push_back(a[i]);
    }
    for (int i = 0; i < m; ++i)
    {
        vs.push_back({c[i], -1});
        nvs.push_back(c[i]);
    }
    sort(all(vs));
    sort(all(nvs));
    int st = -1;
    vector<bool> dp(n + m, 0);
    for (int i = n + m - 1; i >= 0; --i)
    {
        if (vs[i].second != -1)
        {
            dp[i] = 1;
            st = i;
            break;
        }
    }
    for (int i = st - 1; i >= 0; --i)
    {
        dp[i] = 0;
        if (vs[i].second == -1)
        {
            dp[i] = 1 - dp[i + 1];
            continue;
        }
        if (dp[i + 1] == 0)
        {
            dp[i] = 1;
            continue;
        }
        int id = vs[i].second;
        int j = upper_bound(all(nvs), b[id]) - 1 - nvs.begin();
        for (int u = j; u >= i; --u)
        {
            if (vs[u].second != -1)
            {
                if (dp[u] == 0)
                {
                    dp[i] = 1;
                } else
                {
                    dp[i] = 0;
                }
                break;
            }
        }
    }
    if (dp[0])
    {
        ans(1);
    } else
    {
        ans(0);
    }

    return 0;
}
