#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <math.h>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) x.begin(),x.end()
//#pragma GCC optimize("Ofast")
const ll INF = 1e9 + 7;
template<typename T>
void input(vector<T>& arr, size_t size) {
	arr.resize(size);
	for (T& i : arr) {
		cin >> i;
	}
}
template<typename T>
void print(vector<T>& arr) {
	for (T& i : arr) {
		cout << i << ' ';
	}
	cout << '\n';
}

struct node
{
	int a, b, ind;
	node(int a,int b,int ind): a(a),b(b),ind(ind){}
};
bool cmp(node& a, node& b) {
	return a.a < b.a;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<ll> a, b, c;
	vector<node> s;
	input(a, n);
	input(b, n);
	input(c, m);
	for (size_t i = 0; i < n; i++)
	{
		s.push_back(node(a[i], b[i], i));
	}
	sort(all(s),cmp);
	reverse(all(s));
	ll val = INF, ind = -1;
	for (size_t i = 0; i < n; i++)
	{
		if (s[i].b < val) {
			val = s[i].a;
			ind = s[i].ind;
		}
	}
	int cnt = 0;
	for (size_t i = 0; i < n; i++)
	{
		if (a[i] < val)++cnt;
	}
	for (size_t i = 0; i < m; i++)
	{
		if (c[i] < val)++cnt;
	}
	if (cnt & 1) {
		cout << "Second";
	}
	else {
		cout << "First";
	}
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif // _DEBUG
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
#ifdef _DEBUG
	cin >> tt;
#endif // _DEBUG
	while (tt--)
	{
		solve();
#ifdef _DEBUG
		cout << "\n================\n";
#endif // _DEBUG
	}
}