#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begoin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

#define F cout << "First\n";
#define S cout << "Second\n";

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n*2+m);
    vector<int> b(n*2+m);
    for (int i = 0; i < 2 * n + m; ++i) {
        cin >> a[i];
        --a[i];
        b[a[i]] = i;
    }

    int k = n * 2 + m;
    vector<int> dp(k+1, 0);
    dp[k] = 0;
    for (int i = k - 1; i >= 0; --i) {
        if (b[i] >= 2 * n) {
            dp[i] = !dp[i+1];
        } else {
            dp[i] = 1;
        }
    }

    if (dp[0]) {
        F;
    } else {
        S;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
#endif

    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}