//#pragma GCC target("avx, avx2")
#pragma GCC optimize("O3, Ofast, unroll-loops")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <iomanip>
#include <random>
#include <vector>
#include <map>
#include <queue>
#include <deque>
#include <set>


using namespace std;
using ll = long long;
const ll MAX = 1e18;
const ll MIN = -1e18;

#define all(a) a.begin(), a.end()
#define each(x, a) for(auto &x : a)


struct P {
	ll f, s;
};


void solve() {
	ll n, m;
	cin >> n >> m;
	vector<P> ab(n);
	vector<ll> c(m);
	ll mn = MAX;
	for (int i = 0; i < n; ++i) {
		cin >> ab[i].f >> ab[i].s;
	}
	sort(all(ab), [](P x, P y) {
		return x.f < y.f;
		});
	ll low = 0;
	for (int i = 0; i < m; ++i) {
		cin >> c[i];
		low += (c[i] < ab[n - 1].f);
	}
	for (int mask = 0; mask < (1 << n); ++mask) {
		vector<int> d(n);
		ll cnt = 0;
		for (int i = 0; i < n; ++i) {
			d[i] = ((mask >> i) & 1);
			cnt += d[i];
		}
		cnt -= d[n - 1];
		if ((low + cnt + 2 * n + m + cnt + d[n - 1]) % 2) {
			if ((2 * n + m + cnt + d[n - 1]) % 2) {
				cout << "First";
			}
			else {
				cout << "Second";
			}
			return;
		}
	}
}


signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}