//#pragma GCC target("avx, avx2")
#pragma GCC optimize("O3, Ofast, unroll-loops")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <iomanip>
#include <random>
#include <vector>
#include <map>
#include <queue>
#include <deque>
#include <set>


using namespace std;
using ll = long long;
const ll MAX = 1e18;
const ll MIN = -1e18;

#define all(a) a.begin(), a.end()
#define each(x, a) for(auto &x : a)


struct P {
	ll f, s;
};




void solve() {
	ll n, m;
	cin >> n >> m;
	vector<P> ab(n);
	vector<ll> c(m);
	for (int i = 0; i < n; ++i) {
		cin >> ab[i].f;
	}
	for (int i = 0; i < n; ++i) {
		cin >> ab[i].s;
	}
	sort(all(ab), [](P x, P y) {
		return x.f < y.f;
		});
	for (int i = 0; i < m; ++i) {
		cin >> c[i];
	}
	sort(all(c));
	for (int mask = 0; mask < (1 << n); ++mask) {
		vector<int> d(n);
		for (int i = 0; i < n; ++i) {
			d[i] = ((mask >> i) & 1);
		}
		set<pair<ll, ll>> st;
		for (int i = 0; i < n; ++i) {
			if (d[i]) {
				st.insert({ ab[i].f, ab[i].s });
			}
			else {
				st.insert({ ab[i].f, -1 });
			}
		}
		ll j = 0;
		ll cur = 0;
		bool win1 = 1;
		while (!st.empty() && j < m) {
			auto it = st.begin();
			if ((*it).first < c[j]) {
				if (cur % 2 == 1) {
					win1 = 0;
					break;
				}
				cur++;
				if ((*it).second != -1) {
					st.insert({ (*it).second, -1 });
				}
				st.erase(it);
			}
			else {
				cur++;
				j++;
			}
		}
		while (!st.empty()) {
			auto it = st.begin();
			if (cur % 2 == 1) {
				win1 = 0;
				break;
			}
			cur++;
			if ((*it).second != -1) {
				st.insert({ (*it).second, -1 });
			}
			st.erase(it);
		}
		while (j < m) {
			cur++;
			j++;
		}
		if (win1) {
			cout << "First";
			return;
		}
	}
			cout << "Second";
}


signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}