#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define size(t) (int)t.size()
#define pb push_back
#define all(t) t.begin(), t.end()
#define rall(t) t.rbegin(), t.rend()

using namespace std;

const int N = 5e5 + 5;

int a[N], b[N];

int f(int i, vector<pair<int, int>> &v, vector<int> &who) {
    int n = size(v);
    if (i == n - 1) {
        return 1;
    }
    int j = lower_bound(all(v), make_pair(v[i].second, v[i].second)) - v.begin();
    if (j < n) {
        if (j > i)
            who[j] = 3 - who[j];
        else
            who[i + 1] = 3 - who[i + 1];
    }
    int f1 = f(i + 1, v, who);
    if (who[i + 1] != who[i])
        f1 = 1 - f1;
    if (j < n) {
        if (j > i)
            who[j] = 3 - who[j];
        else
            who[i + 1] = 3 - who[i + 1];
    }
    int f2 = f(i + 1, v, who);
    if (who[i + 1] != who[i])
        f2 = 1 - f2;
    return (f1 || f2);
}

void solve() {
    int n, m, i, j;
    cin >> n >> m;
    for (i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (i = 0; i < n; i++) {
        cin >> b[i];
    }
    vector <int> c(m);
    for (i = 0; i < m; i++) {
        cin >> c[i];
    }
    sort(all(c));
    vector <pair<int, int>> v(n);
    for (i = 0; i < n; i++) {
        v[i] = {a[i], b[i]};
    }
    sort(all(v));
    vector <int> who(n);
    for (i = 0; i < n; i++) {
        int cnt = lower_bound(all(c), v[i].first) - c.begin();
        if ((cnt + i) % 2 == 0)
            who[i] = 1;
        else
            who[i] = 2;
    }
    if (f(0, v, who)) {
        cout << (who[0] == 1 ? "First" : "Second");
    }
    else {
        cout << (who[0] == 1 ? "Second" : "First");
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}


