#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include "ext/pb_ds/hash_policy.hpp"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/trie_policy.hpp"
#pragma GCC optimize("O3", "unroll-loops")
using namespace std;
using ll = long long;
const int maxn = 300000 + 52;
struct cd{
    int v, c;
    int ci;
    int mi;
};
const string Sec = "Second", Fir = "First";
bool wn(vector<cd> order, vector<bool> skip, int i, int who){
    while (i < order.size() && skip[i]){
        ++i;
    }
    if( ((i == order.size() - 1) && (who == 0)) || ((i == order.size()) && (who == 1))){
        return 1;
    }
    if( ((i == order.size() - 1) && (who == 1)) || ((i == order.size()) && (who == 0))) {
        return 0;
    }
    if(who == 0) {
        if (order[i].c == 0) {
            return wn(order, skip, i + 1, 1 - who);
        } else {
            bool r1 = wn(order, skip, i + 1, 1 - who);
            skip[order[i].ci] = 1;
            bool r2 = wn(order, skip, i + 1, 1 - who);
           // cerr << i << " " << r2 << endl;
            return r1 || r2;
        }
    }
    else{
        if (order[i].c == 0) {
            return wn(order, skip, i + 1, 1 - who);
        } else {
            bool r1 = wn(order, skip, i + 1, 1 - who);
            skip[order[i].ci] = 1;
            return r1 && wn(order, skip, i + 1, 1 - who);
        }
    }
}


string sol1(vector<int> a, vector<int> b, vector<int> s){
    int n = a.size(), m = s.size();
    vector<cd> initor;
    vector<cd> order;
    vector<int> pos(2 * n+m);
    for(int i = 0; i < n; ++i){
        if(b[i] < a[i]){
            b[i] = a[i];
        }
        initor.push_back({a[i], 1, 2*i+1, 2 * i});
        initor.push_back({b[i], 0, -1, 2*i+1});
    }
    for(int i = 0; i < m; ++i){
        initor.push_back({s[i], 0, -1, 2*(n) + i});
    }
    sort(initor.begin(), initor.end(), [](const auto &a, const auto &b){
        if(a.v == b.v){
            return a.c > b.c;
        }
        return   a.v < b.v;});
    for(int i = 0; i < initor.size(); ++i){
        pos[initor[i].mi] = i;
    }
    for(int i = 0; i < initor.size(); ++i) {
        if (initor[i].c == 1) {
            initor[i].ci = pos[initor[i].ci];
        }
    }
//        for(int i = 0; i < initor.size(); ++i){
//            cout << " i: " << i << " c: " << initor[i].c << " " << " ci " << initor[i].ci << " v: " << initor[i].v << endl;
//
//    }
    vector<bool> skip(2*n+m);
    if(wn(initor, skip, 0 ,0)){
        return Fir;
    }
    return Sec;


}
signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("main.in", "r", stdin);
    freopen("main.out", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), s(m);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int i = 0; i < n; ++i){
        cin >> b[i];
    }
    for(int i = 0; i < m; ++i){
        cin >> s[i];

    }
    cout << sol1(a, b, s);


    return 0;
}
