#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll SZ = 5e5;
ll a[SZ], b[SZ], c[SZ];
ll used[SZ];

void solve() {
	ll n, m;
	cin >> n >> m;
	for (ll i = 0; i < n; i++) cin >> a[i];
	for (ll i = 0; i < n; i++) cin >> b[i];
	for (ll i = 0; i < m; i++) cin >> c[i];
	vector<pii> temp;
	for (ll i = 0; i < n; i++) {
		temp.push_back({ a[i], -1 });
		temp.push_back({ b[i], -1 });
	}
	for (ll i = 0; i < m; i++) {
		temp.push_back({ c[i], i });
	}
	sort(all(temp));
	for (ll i = 1; i < 2 * n + m; i++) {
		if (temp[i].se >= 0 && temp[i - 1].se >= 0 && !used[temp[i - 1].se]) {
			used[temp[i].se] = 1;
			used[temp[i - 1].se] = 1;
		}
	}
	vector<pii> d;
	for (ll i = 0; i < n; i++) d.push_back({ a[i], i });
	for (ll i = 0; i < m; i++) {
		if (!used[i]) {
			d.push_back({ c[i], -1 });
		}
	}
	sort(all(d));
	ll sz = d.size();
	vector<ll> next(sz, -1);
	ll l = -1;
	for (ll i = 0; i < sz; i++) {
		if (d[i].se != -1) {
			if (l != -1) {
				next[l] = i;
			}
			l = i;
		}
	}
	for (ll i = 0; i < sz; i++) {
		if (d[i].se != -1 && (next[i] == -1 || b[d[i].se] < a[d[next[i]].se])) {
			if (i % 2) {
				cout << "Second\n";
			}
			else {
				cout << "First\n";
			}
			return;
		}
	}
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}
