#include <bits/stdc++.h>

using namespace std;
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
        cout << "\n";
    }
}

const int INF = 2e9;

map<pair<set<pair<int, int> >, set<int> >, bool> check;

bool win(set<pair<int, int> > ab, set<int> c) {
    auto &it = check[{ab, c}];
    if (check.find({ab, c}) != check.end()) return check[{ab, c}];
    set<pair<int, int> > s;
    for (auto [i, j] : ab) s.insert({i, j});
    for (auto i : c) s.insert({i, 0});
    if (s.empty()) return 0;

    auto p = *s.begin();
    if (p.S == 0 && c.find(p.F) != c.end()) c.erase(c.find(p.F));
    else ab.erase(ab.find(p));

    int ans = 0;
    ans = !win(ab, c);
    if (p.S > 0) {
        ab.insert({p.S, -p.F});
        if (!win(ab, c)) ans = 1;
    }

    it = ans;
    return ans;
}

void solve() {
   int n, m; cin >> n >> m;
   vector<pair<int, int> > v(n + m), a;
   for (int i = 0; i < n; i++) cin >> v[i].F;
   for (int i = 0; i < n; i++) cin >> v[i].S;
   for (int i = 0; i < n; i++) {
       if (v[i].F > v[i].S)  {
           swap(v[i].F, v[i].S);
           v[i].S = -v[i].S;
       }
   }
   for (int i = n; i < n + m; i++) cin >> v[i].F;

   sort(all(v));
   for (int i = 0; i < n + m; i++) {
       if (v[i].S != 0) a.push_back(v[i]);
       else if (a.empty() || a.back().S == 0 || a.back().S < v[i].F) a.push_back(v[i]);
   }
   for (int i = 0; i < a.size(); i++) {
       if (a[i].S < 0) {
           a[i].S = abs(a[i].S);
           swap(a[i].S, a[i].F);
       }
   }
   sort(rall(a));
   //for (auto [i, j] : a) cout << i << " " << j << endl;

   vector<bool> win(n + m);
   win[0] = 1;
   for (int i = 1; i < a.size(); i++) {
       if (a[i].S == 0) win[i] = !win[i - 1];
       else {
           if (a[i - 1].S != 0 && a[i - 1].S < a[i].S) win[i] = !win[i - 1];
           else win[i] = 1;
       }
   }
   if (win[a.size() - 1]) cout << "First";
   else cout << "Second";
}
