#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <map>

using namespace std;

#define ll long long
#define FOR(i, s, f) for(ll (i) = (s); (i) < (f); (i)++)
const long long INF = 1e9;

bool func(set<pair<ll, ll>> &card){
    ll cnt = 0;
    vector<pair<ll, ll>> arr(0);
    while(card.size() > 1 && (*card.begin()).second == -1){
        cnt++;
        arr.push_back(*card.begin());
        card.erase(card.begin());
    }
    if (card.size() == 1){
        cnt++;
        FOR(i, 0, arr.size()) card.insert(arr[i]);
        return cnt % 2;
    }
    pair<ll, ll> c = (*card.begin());
    bool a, b;
    card.erase(card.begin());
    a = func(card);
    card.insert({c.second, -1});
    b = func(card);
    card.erase({c.second, -1});
    card.insert(c);
    FOR(i, 0, arr.size()) card.insert(arr[i]);
    return (cnt + !(a & b)) % 2;
}

void solve(){
    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> cards(n);
    FOR(i, 0, n){
        ll a;
        cin >> a;
        cards[i].first = a;
    }
    FOR(i, 0, n){
        ll a;
        cin >> a;
        cards[i].second = a;
    }
    FOR(i, 0, m){
        ll x;
        cin >> x;
        cards.push_back({x, -1});
    }
    set<pair<ll, ll>> card;
    for(auto it: cards){
        card.insert(it);
    }
    if (func(card)) cout << "First";
    else cout << "Second";
}

int main() {
    cout.precision(32);
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
