#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <map>

using namespace std;

#define ll long long
#define FOR(i, s, f) for(ll (i) = (s); (i) < (f); (i)++)
const long long INF = 1e9;
const long long MOD = 1e9 + 7;

void solve(){
    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> cards(n + m, {0, -1});
    FOR(i, 0, n) cin >> cards[i].first;
    FOR(i, 0, n) cin >> cards[i].second;
    FOR(i, 0, m) cin >> cards[n + i].first;
    sort(cards.begin(), cards.end());
    ll ind = n - 1;
    while(cards[ind].second == -1) ind--;
    ll cnt = 0;
    for(ll i = ind - 1; i >= 0; i--){
        if (cards[i].second == -1 || (cards[i].second > cards[ind].first && cards[i].first < cards[i].second)){
            cnt++;
            continue;
        }
        ind = i;
        cnt = 0;
    }
    if (ind == 0 || cnt % 2 == 1) cout << "First";
    else cout << "Second";
}

int main() {
    cout.precision(32);
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
