#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>

#define len(v) (int)((v).size())
#define ss second
#define ff first


typedef long long ll;

using namespace std;

const ll inf = 1e12 + 7;

struct card {
	int nx;
	bool fl;

	card() = default;
};


void solve() {
	int n, m;
	cin >> n >> m;
	int k = n * 2 + m;
	vector<card> tp(k);

	vector<int> a(n), b(n), c(n);

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
		tp[a[i]].fl = true;
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		--b[i];
		tp[b[i]].fl = false;
		tp[a[i]].nx = b[i];
		tp[b[i]].nx = -1;
	}
	for (int i = 0; i < m; ++i) {
		cin >> c[i];
		--c[i];
		tp[c[i]].fl = true;
		tp[c[i]].nx = -1;
	}

	vector<bool> dp(k, false);
	dp[k - 1] = true;

	for (int i = k - 2; i >= 0; --i) {
		if (!tp[i].fl) {
			dp[i] = dp[i + 1];
			continue;
		}

		dp[i] = !dp[i + 1];
		if (tp[i].nx != -1) {
			if (tp[i].nx < i) {
				dp[i] = dp[i + 1] || dp[i];
			}
			else {
				dp[i] = dp[i] || dp[i + 1];
			}
		}
	}

	vector<string> res = { "Second\n", "First\n" };
	cout << res[dp[0]];
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);

	int t = 1;
	//	cin >> t;
	while (t--) solve();
}



