#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int long long
#define ff first
#define ss second
#define endl '\n'
#define all(a) (a).begin, (a).end()

const int INF = 1e18 + 123;

int rec(vector<int>& used, int r, vector<pair<int, int>>& a, vector<int>& c, int ka, int kc, int t) {
    if (ka + kc == 0) return 1 - t;
    if (ka == 0) {
        if (kc % 2 == 0) return 1 - t;
        else return t;
    }

    int mn = -1;
    for (int i = 0; i < a.size(); ++i) {
        if (used[i] != 1 && (mn == -1 || a[i].ff < a[mn].ff)) {
            mn = i;
        }
    }

    int rr = lower_bound(c.begin(), c.end(), a[mn].ff) - c.begin();
    if (rr > r) {
        if ((rr - r) % 2 == 1) t = 1 - t;
        r = rr;
        kc -= (rr - r);
    }

    if (used[mn] != 2) {
        used[mn] = 1;
        ka--;
        int ans1 = rec(used, r, a, c, ka, kc, 1 - t);

        used[mn] = 2;
        ka++;
        swap(a[mn].ff, a[mn].ss);
        int ans2 = rec(used, r, a, c, ka, kc, 1 - t);

        swap(a[mn].ff, a[mn].ss);
        used[mn] = 0;

        if (t == 1) {
            return ans1 | ans2;
        } else {
            return ans1 & ans2;
        }
    } else {
        used[mn] = 1;
        ka--;
        int ans1 = rec(used, r, a, c, ka, kc, 1 - t);
        used[mn] = 2;
        return ans1;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> a(n);
    vector<int> c(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].ff;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].ss;
    }

    for (int i = 0; i < m; ++i) {
        cin >> c[i];
    }

    sort(c.begin(), c.end());

    vector<int> used(n);
    int ans = rec(used, 0, a, c, n, m, 1);
    if (ans) {
        cout << "First" << endl;
    } else {
        cout << "Second" << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int qq = 1;
//    cin >> qq;
    while (qq--) {
        solve();
    }
}
