#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifndef DEBUG
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#endif

using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = int;
using pll = std::pair<ll, ll>;
using ld = long double;
using i128 = __int128;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

std::vector<ll> a, b, c;

void upd(ll &aa, ll type, ll bb) {
    if (type == bb) {
        aa = type;
    }
}

void solve() {
    ll n, m;
    std::cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    std::vector<pll> q;
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
        q.push_back({a[i], 1});
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> b[i];
    }
    for (int i = 0; i < m; ++i) {
        std::cin >> c[i];
        q.push_back({c[i], -1});
    }
    std::sort(q.begin(), q.end());
    std::vector<std::vector<ll>> dp(2, std::vector<ll>(n + m));
    dp[0][q.size() - 1] = 0;
    dp[1][q.size() - 1] = 1;
    for (int tt = 0; tt < 2; ++tt) {
        for (int i = q.size() - 2; i >= 0; --i) {
            dp[tt][i] = !tt;
            upd(dp[tt][i], tt, dp[!tt][i + 1]);
            if (q[i].second == 1){
                upd(dp[tt][i], tt, dp[tt][i + 1]);
            }
        }
    }
    if (!dp[0][0]){
        std::cout << "First\n";
    }
    else{
        std::cout << "Second\n";
    }
}

int main() {
#ifdef DEBUG
    std::freopen("/home/olymp/CLionProjects/untitled/input.txt", "r", stdin);
#endif
    std::cin.tie(0)->std::ios::sync_with_stdio(0);
    int tt = 1;
//    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
