#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n);
    cin >> a >> b;
    vector<int> c(m);
    cin >> c;
    sort(c.begin(), c.end());

    vector<int> p(n);
    iota(p.begin(), p.end(), 0ll);
    sort(p.begin(), p.end(), [&](int f, int s) {
        return a[f] < a[s];
    });

    int first = -1;

    for (int i = 0; i < n - 1; i++) {
        if (b[p[i]] < a[p[i]]) {
            first = a[p[i]];
            break;
        }

        if (a[p[i + 1]] > b[p[i]]) {
            first = a[p[i]];
            break;
        }
    }

    int cnt = 0;

    for (int i : c) if (i < first) cnt++;
    for (int i : a) if (i < first) cnt++;
    if (cnt % 2) cout << "Second";
    else cout << "First";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}
