#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n);
    cin >> a >> b;
    vector<int> c(m);
    cin >> c;
    sort(c.begin(), c.end());

    vector<int> p(n);
    iota(p.begin(), p.end(), 0ll);
    sort(p.begin(), p.end(), [&](int f, int s) {
        return a[f] < a[s];
    });

    auto dfs = [&](auto& self, int seg, int mask) -> bool {
        int ca = a[p[seg]];
        int cnt = 0;
        for (int i : a) if (i < ca) cnt++;
        for (int i : c) if (i < ca) cnt++;
        for (int i = 0; i < n; i++) {
            if ((mask & (1 << i)) && b[p[i]] < ca) cnt++;
        }

        if (cnt % 2) {
            // second player turn
            if (seg == n - 1)
                return false;

            return self(self, seg + 1, mask | (1 << seg)) && self(self, seg + 1, mask);
        } else {
            // first player turn
            if (seg == n - 1)
                return true;

            return self(self, seg + 1, mask | (1 << seg)) || self(self, seg + 1, mask);
        }
    };

    if (dfs(dfs, 0, 0)) cout << "First";
    else cout << "Second";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}
