//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#pragma GCC optimize("O3,Ofast,fast-math,unroll-loops")
#pragma GCC target("avx,avx2,fma,sse,sse2,sse3,sse4,sse4.1,sse4.2")
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//#define int long long

struct Fenwick {
    vector<int>a;
    int next(int i) {
        return i&(-i);
    }
    int get(int i) {
        int ans=0;
        for (int j=i;j>0;j-=next(j)) {
            ans+=a[j];
        }
        return ans;
    }

    void upd(int i) {
        for (int j=i;j<a.size();j+=next(j)) {
            a[j]++;
        }
    }

    void minus(int i) {
        for (int j=i;j<a.size();j+=next(j)) {
            a[j]--;
        }
    }
};

bool comp(pair<int, int>a, pair<int, int>b) {
    return a.second<b.second;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    set<int>c;
    vector<pair<int, int>>a(n);
    Fenwick A;
    A.a.resize(2*n+m+100, 0);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        A.upd(a[i].first);
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
    }
    for (int i = 0; i < m; ++i) {
        int x;
        cin >> x;
        c.insert(x);
    }

    sort(a.begin(), a.end(), comp);
    int CNTDF=0;

    int i1=n+1;
    for (int i=0;i<n;++i) {
        if (a[i].first < a[i].second && A.get(a[i].second)-A.get(a[i].first) == 0) {
            i1=i;
            break;
        }
        if (a[i].second < a[i].first) {
            i1=i;
            break;
        }
    }

    for (auto x : c) {
        if (x < a[i1].first) {
            CNTDF++;
        }
    }
    for (auto l : a) {
        if (l.first < a[i1].first) {
            CNTDF++;
        }
    }
    if (CNTDF%2==0) {
        cout<<"First";
    } else {
        cout <<"Second";
    }
    return 0;
}
