#include <bits/stdc++.h>
// #include <bits/extc++.h>

using namespace std;

#define all(a)	a.begin(),a.end()
#define rall(a)	a.rbegin(),a.rend()
#define FastIO	ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

typedef long long			ll;
typedef long double			ld;
typedef unsigned long long	ull;
// typedef _int128_t lll;

template<typename T1, typename T2>
ostream& operator<< (ostream &x, const pair<T1, T2> &pr) { return x << "{" << pr.first << ", " << pr.second << "}"; }
template<typename T> void cerr_cont(const T &cont) { for (auto &it : cont) cerr << it << ' '; }
template<typename T> void print_cont(const T &cont, ostream &x=cout) { for (auto &it : cont) x << it << ' '; }

int main() {
	FastIO;
	int n, m;
	cin >> n >> m;
	vector<pair<int, int>> ab(n);

	for (auto &it : ab) cin >> it.first;
	for (auto &it : ab) cin >> it.second;
	sort(all(ab));

	vector<int> c(m);
	for (auto &it : c) cin >> it;

	ab.emplace_back(2 * n + m + 10, -1);

	vector<int> dir(n);
	for (int i = 0; i < n; ++i) {
		int lt = i;
		int rt = n;
		while (rt - lt > 1) {
			int m = (lt + rt) / 2;
			if (ab[m].first < ab[i].second) lt = m;
			else rt = m;
		}
		dir[i] = rt;
	}

	int lst = n;
	for (int i = n - 1; i >= 0; --i) {
		if (dir[i] == lst) lst = i;
	}

	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (ab[i].first < ab[lst].first) ++cnt;
	}
	for (int i = 0; i < m; ++i) {
		if (c[i] < ab[lst].first) ++cnt;
	}

	cout << ((cnt & 1) ? "Second" : "First");
	
	return 0;
}

