#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <queue>
#include <map>
#include <set>

using namespace std;
map <int, int> a2b;
bool poss(set <int> &a, set <int> &b) {
    if (a.empty() && b.empty()) return false;
    bool win = false;
    if (!a.empty() && !b.empty()) {
        if (*a.begin() < *b.begin()) {
            int c = *a.begin();
            a.erase(a.begin());
            win = !poss(a, b);
            if (win) return true;
            b.insert(a2b[c]);
            win = !poss(a, b);
            a.insert(c);
            b.erase(a2b[c]);
        } else {
            int c = *b.begin();
            b.erase(b.begin());
            win = !poss(a, b);
            b.insert(c);
        }
    }  else if (!a.empty()) {
        int c = *a.begin();
        a.erase(a.begin());
        win = !poss(a, b);
        if (win) return true;
        b.insert(a2b[c]);
        win = !poss(a, b);
        a.insert(c);
        b.erase(a2b[c]);
    } else {
        return !(b.size() % 2);
    }
    return win;
}
signed main() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    set <int> A, C;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        A.insert(a[i]);
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        a2b[a[i]] = b[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
        C.insert(c[i]);
    }
    if (poss(A, C)) {
        cout << "First";
    } else {
        cout << "Second";
    }
    return 0;
}
