#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

//#define int long long

using ll = long long;
using namespace std;

bool get_ans(vector<int> &b, set<pair<int, int>> &d) {
    if (d.empty()) {
        return 0;
    }
    if (d.begin() -> second == -1) {
        auto cur = *d.begin();
        d.erase(d.begin());
        int ans = get_ans(b, d) ^ 1;
        d.insert(cur);
        return ans;
    } else {
        auto cur = *d.begin();
        d.erase(d.begin());
        int ans1 = get_ans(b, d) ^ 1;
        d.insert({b[cur.second], -1});
        int ans2 = get_ans(b, d) ^ 1;
        d.erase({cur.second, -1});
        d.insert(cur);
        return (ans1 || ans2);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    set<pair<int, int>> d;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        d.insert({a[i], i});
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i];
        d.insert({c[i], -1});
    }
    if (get_ans(b, d)) {
       cout << "First\n";
    } else {
        cout << "Second\n";
    }
}

signed main() {
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
    ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
#endif
//    cin >> t;
    while (t--) {
        solve();
    }
}
