#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll ran(ll l=LLONG_MIN, ll r=LLONG_MAX){
    return uniform_int_distribution<ll>(l, r)(rnd);
}

struct node{
    ll numb, type, ind;

    bool operator < (const node b) const{
        return (numb < b.numb);
    }
};

vector<ll> b;

ll rec(set<node> &a){
    if (a.empty()) return 0;
    auto [numb, type, ind] = *a.begin();
    a.erase(a.begin());
    if (type){
        ll fl1 = !rec(a);
        a.insert({numb, type, ind});
        return fl1;
    }else{
        ll fl1 = rec(a);
        a.insert({b[ind], 1, ind});
        ll fl2 = rec(a);
        a.erase({b[ind], 1, ind});
        a.insert({numb, type, ind});
        return !(fl1 & fl2);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> a(n);
    for (auto &x: a) cin >> x;
    b.resize(n);
    for (auto &x: b) cin >> x;
    vector<ll> c(m);
    for (auto &x: c) cin >> x;
    vector<node> table;
    for (int i=0; i<n; ++i) table.push_back({a[i], 1, i});
    for (int i=0; i<m; ++i) table.push_back({c[i], 0, i});
    sort(all(table));
    ll cnt = 0;
    while (!table[cnt].type) ++cnt;
    cout << (((cnt % 2) != (n % 2)) ? "First" : "Second");
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t = 1;
//    cin >> t;
    while (t--) solve(), cout << '\n';
    return 0;
}