#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using vl = vector<ll>;
using vvl = vector<vl>;
using pii = pair<int, int>;
constexpr char nl = '\n';

struct card {
    int x, t, id;
};

struct rt {
    int t, a, b;
};

vi a, b, c;

bool dfs(vector<rt> &vc) {
    if (vc.empty())
        return false;
    if (vc.back().t == 1) {
        auto old = vc.back();
        vc.pop_back();
        bool v = !dfs(vc);
        vc.push_back(old);
        return v;
    } else if (vc.back().t == 2) {
        vector<rt> nw = vc;
        nw.pop_back();
        nw.emplace_back(1, vc.back().b, vc.back().b);
        sort(nw.rbegin(), nw.rend(), [](const rt &i, const rt &j) {
            return i.a < j.a;
        });
        bool v = !dfs(nw);

        auto old = vc.back();
        vc.pop_back();
        v |= !dfs(vc);
        vc.push_back(old);
        return v;
    } else {
        auto old = vc.back();
        vc.back() = {1, vc.back().a, vc.back().b};
        bool v = !dfs(vc);
        vc.back() = old;

        vc.pop_back();
        v |= !dfs(vc);
        vc.push_back(old);
        return v;
    }
}

signed main() {
    ios::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    vector<card> cs(2 * n + m);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        cs[i] = {a[i], 1, i};
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        cs[n + i] = {b[i], 2, i};
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
        cs[2 * n + i] = {c[i], 3, i};
    }
    sort(cs.begin(), cs.end(), [](const card &i, const card &j) {
        return i.x < j.x;
    });
    int can = 1;
    for (int i = 0; i < 2 * n + m; ++i) {
        if (cs[i].t == 3) {
            can ^= 1;
        } else
            break;
    }
    if (can)
        cout << "First";
    else
        cout << "Second";

//    vector<card> cs2;
//    for (int i = 0; i < 2 * n + m; ++i) {
//        if (!cs2.empty() && cs2.back().t == 3 && cs[i].t == 3) {
//            cs2.pop_back();
//        } else {
//            cs2.push_back(cs[i]);
//        }
//    }
//    vector<rt> cs3;
//    for (auto cr: cs2) {
//        if (cr.t == 3) {
//            cs3.emplace_back(1, cr.x, cr.x);
//        } else if (cr.t == 1) {
//            if (a[cr.id] < b[cr.id]) {
//                cs3.emplace_back(2, a[cr.id], b[cr.id]);
//            } else {
//                cs3.emplace_back(3, a[cr.id], b[cr.id]);
//            }
//        }
//    }
//    reverse(cs3.begin(), cs3.end());
//    if (dfs(cs3))
//        cout << "First";
//    else
//        cout << "Second";
//    if (n > 0 || m % 2)
//        cout << "First";
//    else
//        cout << "Second";
}
