#include "bits/stdc++.h"
using namespace std;

#define forn(i,n) for(int i=0;i<n;++i)
#define fornn(i,l,r) for(int i=l;i<=r;++i)
#define ford(i,n) for(int i=n-1;i>=0;--i)
#define all(a) (a).begin(),(a).end()
#define rall(a) (a).rbegin(),(a).rend()
#define pb push_back
#define eb emplace_back
#define ff first
#define ss second

using ll = long long;
using ld = long double;
using pii = pair<int,int>;
using pll = pair<ll,ll>;

const int maxn=1e5+7;
const int logn = 32;
const int mod = 1e9 + 7;

int n,m;
vector<pii> a;
vector<int> b;

void solve() {
    cin>>n>>m;
    a.assign(n,{});
    b.assign(m,{});
    forn(i,n) cin>>a[i].ff;
    forn(i,n) cin>>a[i].ss;
    forn(i,m) cin>>b[i];

    vector<pair<int,int>> cur;
    for(auto i:a) cur.pb(i);
    for(auto i:b) cur.pb({i,-1});
    int state=0;
    while (n+m) {
        int pos=0;
        forn(i,(int)cur.size()) {
            if (cur[i].ff==-1) continue;
            if (cur[pos].ff==-1) pos=i;
            if (cur[pos].ff>cur[i].ff) pos=i;
        }
        if (cur[pos].ff==-1) break;

        if (cur[pos].ss==-1) {
            m--;
            cur[pos].ff=-1;
        } else {
            n--;
            if (n+m%2==1)
                cur[pos].ff=cur[pos].ss, cur[pos].ss=-1, m++;
            else
                cur[pos].ff=cur[pos].ss=-1;
        }

        state^=1;
    }

    if (state==0) cout<<"Second";
    else cout<<"First";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

#ifdef LOCAL
    freopen("C:\\work\\untitled\\c.txt", "r", stdin);
    freopen("C:\\work\\untitled\\out.txt", "w", stdout);

    while (!cin.eof()) {
        solve();
        cout<<endl;
    }
#else
    solve();
#endif

    return 0;
}
