#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) x.begin(),x.end()
#define mem(x, y) memset(x, y, sizeof x)
#define sz(x) int(x.size())

set <pair <int, int>> s;
map <set <pair <int, int>>, int> memo;

bool solve() {
	if (s.empty()) return 0;
	if (!memo.count(s)) {
		auto x = *s.begin();
		s.erase(s.begin());
		bool res = !solve();
		
		if (x.second != -1) {
			s.insert({x.second, -1});
			res |= (!solve());
			s.erase({x.second, -1});
		}
		
		s.insert(x);
		memo[s] = res;
	}
	return memo[s];
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	
	int n, m;
	cin >> n >> m;
	
	vector <int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		s.insert({a[i], x});
	}
	
	for (int i = 0; i < m; i++) {
		int x;
		cin >> x;
		s.insert({x, -1});
	}
	
	cout << (solve() ? "First" : "Second");
			
	return 0;
}
