#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solveN(int n, int m, vector<ll> a, vector<ll> b, vector<ll> c) {
    int l = 2 * n + m;

    vector<int> ev(l);
    for (int i = 0; i < n; ++i) {
        ev[a[i]] = 1;
    }
    for (int i = 0; i < n; ++i) {
        ev[b[i]] = 2;
    }
    for (int i = 0; i < m; ++i) {
        ev[c[i]] = 3;
    }

    vector<int> match(l);
    for (int i = 0; i < n; ++i) {
        match[a[i]] = b[i];
    }

    vector<int> w(l + 1, false);

    int lst = -1;
    for (int i = l - 1; i >= 0; --i) {
        if (ev[i] == 2) {
            w[i] = w[i + 1];
            continue;
        }
        if (ev[i] == 1) {
            if (lst == -1 || match[i] < lst) {
                lst = i;
                w[i] = true;
                continue;
            }
            w[i] = !w[i + 1];
            continue;
        }
        w[i] = !w[i + 1];
    }
    cout << (w[0] ? "First\n" : "Second\n");
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> a(n), b(n), c(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        --b[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
        --c[i];
    }
    solveN(n, m, a, b, c);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
