#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define ld long double
#define F first
#define S second
mt19937 rnd1(chrono::high_resolution_clock::now().time_since_epoch().count());
mt19937 rnd(100);


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, m;
    cin >> n >> m;
    if (!n) {
        if (m % 2)
            cout << "First";
        else
            cout << "Second";
        return 0;
    }

    vector<pair<ll, ll>> a(n);
    vector<ll> b(m);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first, a[i].first *= 2;

    for (int i = 0; i < n; ++i) {
        cin >> a[i].second, a[i].second *= 2;
        if (a[i].second < a[i].first)
            a[i].second = a[i].first + 1;
    }

    for (int i = 0; i < m; ++i)
        cin >> b[i], b[i] *= 2;

    vector<pair<ll, ll>> arr; // Позиция, парный номер границы
    for (int i = 0; i < n; ++i) {
        arr.emplace_back(a[i].first, i);
        arr.emplace_back(a[i].second, i);
    }

    for (int i = 0; i < m; ++i)
        arr.emplace_back(b[i], -1);

    sort(arr.begin(), arr.end());
    set<ll> open;
    ll last = -2, cnt = 0;
    for (auto p: arr) {
        cnt += !open.count(p.second);
        if (p.second != -1) {
            if (!open.count(p.second)) {
                open.insert(p.second);
                last = p.second;
            } else if (p.second == last) {
                break;
            }
        }
    }

    cout << (cnt % 2 == 1 ? "First" : "Second");

    return 0;
}

/*
2 1
5 3
1 2
4

1 2
2
3
4 1

*/
/*
Если кому-то попалась a>b, он победил.
Можно удалить все карты, лицевая сторона которых превышает максимальную такую а, а те, у которых обратная, сделать обычными.

Если есть отрезок аб не пересекающийся с другими, то тот, кто до него первым дойдет - победит.
Аналогично, обрезаем ситуации.
Получается, все отрезки пересекаются с какими-то другими.

Идем слева направа, периодически удаляя отрезочки и вставляя точки.

Я утверждаю что за полоску покрытия мы определим победителя.
Если правая граница отрезка включена в другой отрезок, то нам на нее пофиг.

Берем отрезок, правая граница которого не лежит в каком-либо отрезке и в него не включен какой-либо отрезок.
Допустим он достался нам.
Тогда мы победили.
Удалим все границы лежащие в "нижних" отрезках.


Так. Еще раз. Алгоритм.
Удаляем ситуации A > B.
Есть набор точек и отрезков на прямой.

Храним их в стеке.
Идем слева направа.
Есть последний открытый отрезок.
Если он закрылся, удаляем все правые границы появившиеся с тех пор, а левые делаем точками.
Смотрим на четность количества точек до момента появления этого отрезка.

Можно a>b не удалять, а заменять на b = a + 0.5

3-5
4-6



*/
/*
Ребра делятся на два типа.
Внутри КСС и между КСС.

Они не влияют друг на друга.
Из каждой категории мы удалим максимум.

Вторая задача.
Дан орграф без циклов.
Сколько ребер можно зашифровать, чтобы по информации что в нем нет циклов, он расшифровывался однозначно?



*/
/*
5 3
1 2
4


2
3
4 1
*/
/*


*/
/*


*/