#include <bits/stdc++.h>
#include <bits/extc++.h>

#pragma GCC target("avx2")
#ifndef ABOBA
#pragma GCC optimize("O3")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll inf = 1e18, mod = 1e9 + 7;

vector<ll> a, b, c;

ll gr(vector<ll> a1, vector<ll> b1, vector<ll> c1, vector<ll> used) {
    if (a1.empty() && b1.empty() && c1.empty()) return 0;
    unordered_set<ll> mex;
    ll maxx = -inf;
    for (ll i = 0; i < a1.size(); ++i) {
        if (!used[i]) maxx = max(maxx, a1[i]);
        else maxx = max(maxx, b1[i]);
    }
    if (!c1.empty()) {
        maxx = max(maxx, *std::max_element(c1.begin(), c1.end()));
    }
    for (ll i = 0; i < a1.size(); ++i) {
        if (a1[i] == maxx && !used[i]) {
            used[i] = 1;
            mex.emplace(gr(a1, b1, c1, used));
            used[i] = 0;
        }
        if ((a1[i] == maxx && !used[i]) && (b1[i] == maxx && used[i])) {
            ll tmp1 = a1[i], tmp2 = b1[i], tmp3 = used[i];
            a1.erase(a1.begin() + i);
            b1.erase(b1.begin() + i);
            used.erase(used.begin() + i);
            mex.emplace(gr(a1, b1, c1, used));
            a1.emplace(a1.begin() + i, tmp1);
            b1.emplace(b1.begin() + i, tmp2);
            used.emplace(used.begin() + i, tmp3);
        }
    }
    for (ll i = 0; i < c1.size(); ++i) {
        if (c1[i] == maxx) {
            ll tmp = c1[i];
            c1.erase(c1.begin() + i);
            mex.emplace(gr(a1, b1, c1, used));
            c1.emplace(c1.begin() + i, tmp);
        }
    }
    ll ans = 0;
    while (mex.contains(ans)) ++ans;
    return ans;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    a.resize(n), b.resize(n), c.resize(m);
    vector<ll> used(n);
    for (auto &i: a) {
        cin >> i;
        i = -i;
    }
    for (auto &i: b) {
        cin >> i;
        i = -i;
    }
    for (auto &i: c) {
        cin >> i;
        i = -i;
    }
    cout << (gr(a, b, c, used) ? "First" : "Second");
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tt = 1;
    while (tt--) solve();
}