#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(vec) vec.begin(), vec.end()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fi first
#define se second
#define int ll

mt19937_64 rnd;

ll INF = 1e9;
ll mod = 1e9+7;

int n, m;

vector<int> a;
vector<int> b;
vector<int> c;
vector<int> used;
vector<int> used2;

bool calc() {
    int ind1 = -1, ind2 = -1;
    int crd = 0, crd2 = 0;
    for (int i = 1; i <= n; i++) {
        if (used[i] == 2) continue;
        if (used[i] == 0) {
            if (ind1 == -1 || a[i] < crd) {
                crd = a[i];
                ind1 = i;
            }
        } else {
            if (ind1 == -1 || b[i] < crd) {
                crd = b[i];
                ind1 = i;
            }
        }
    }
    for (int i = 1; i <= m; i++) {
        if (used2[i]) continue;
        if (ind2 == -1 || c[i] < crd2) {
            crd2 = c[i];
            ind2 = i;
        }
    }
    if (ind1 == -1 && ind2 == -1) return false;
    if (ind1 == -1 || ind1 != -1 && ind2 != -1 && crd2 < crd) {
        used2[ind2] = 1;
        int ans = calc();
        used2[ind2] = 0;
        if (ans) return false;
        return true;
    } else {
        int pol = used[ind1];
        if (pol == 0) {
            used[ind1] = 1;
            int ans = calc();
            used[ind1] = 0;
            if (!ans) return true;
        }
        used[ind1] = 2;
        int ans = calc();
        used[ind1] = pol;
        if (!ans) return true;
    }
    return false;
}

void solve() {
    cin >> n >> m;
    a.resize(n + 1);
    b.resize(n + 1);
    c.resize(m + 1);

    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) cin >> b[i];
    for (int i = 1; i <= m; i++) cin >> c[i];

    used.resize(n + 1);
    used2.resize(m + 1);

    vector<pii> mas;
    for (int i = 1; i <= n; i++) mas.push_back({a[i], 1});
    for (int i = 1; i <= m; i++) mas.push_back({c[i], 2});
    sort(all(mas));

    vector<int> dp(2 * n + m + 100);
    for (int i = 0; i < mas.size(); i++) {
        if (mas[i].second == 1) dp[i + 1] = 1;
        else {
            if (dp[i] == 0) dp[i + 1] = 1;
        }
    }
    if (dp[n + m] == 1) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    //cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
