#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_map>
#include <map>
#include <random>
#include <chrono>

#define int long long

using namespace std;

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    vector<int> pow(30);
    pow[0] = 1;
    for (int i = 1; i < 30; i++) {
        pow[i] = 2*pow[i-1];
    }
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> b(n);
    vector<int> c(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i];
    }
    vector<pair<int, int>> d(n+m);
    for (int i = 0; i < n; i++) {
        d[i] = {a[i], b[i]};
    }
    for (int i = n; i < n+m; i++) {
        d[i] = {c[i], 0};
    }
    sort(d.begin(), d.end());
    for (int i = 0; i < n+m; i++) {
        if (d[i].second != 0) {
            if (i % 2 == 0) {
                cout << "Second";
            } else {
                cout << "First";
            }
            return 0;
        }
    }
    return 0;
}


/*
5 3 10
4 5 2 7 1
1 2 4

4 2 11
4 5 7 10
2 3
 */