#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_map>
#include <map>
#include <random>
#include <chrono>

#define int long long

using namespace std;

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> b(n);
    vector<int> c(m);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        a[i] = x;
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        b[i] = x;
    }
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        c[i] = x;
    }
    vector<pair<int, int>> cards(n+m);
    for (int i = 0; i < n; i++) {
        cards[i] = {a[i], b[i]};
    }
    for (int i = n; i < n+m; i++) {
        cards[i] = {c[i-n], 0};
    }
    sort(cards.begin(), cards.end());
    vector<pair<int, int>> d(n);
    for (int i = 0; i < n; i++) {
        d[i] = {a[i], b[i]};
    }
    sort(d.begin(), d.end());
    //идём с конца и определяем какого типа двойка
    pair<int, int> last = d[n-1];
    for (int i = n-2; i >= 0; i--) {
        if (d[i].second < last.first) {
            last = d[i];
        }
    }
    for (int i = 0; i < n+m; i++) {
        if (cards[i] == last) {
            if (i % 2 == 0) {
                cout << "First";
            } else {
                cout << "Second";
            }
            return 0;
        }
    }
    return 0;
}

//последняя двойка определяет победителя
//предпоследняя двойка может "что-то поменять"
// только если число на второй стороне меньше числа на
// лицевой стороне следующей двойки тогда выигрывает тот у
// кого определяющая двойка
//
