#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define int ll

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, m0, k0, q; cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    for (int&u : a) cin >> u;
    sort(all(a));
    int rest = m0 * k0;
    vector<int> suff(n);
    suff[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--) suff[i] = suff[i + 1] + a[i];
    vector<int> vls;
    vector<int> pref(n + 1);
    for (int i = 0; i < n; i++) pref[i + 1] = pref[i] + a[i];
    for (int i = 0; i < n; i++) {
        if (i + 1 < n) {
            int L = -1, R = min(rest, m0);
            while (R - L > 1) {
                int M = (L + R) / 2;
                int l1 = i, r1 = n;
                while (r1 - l1 > 1) {
                    int m1 = (l1 + r1) / 2;
                    if (a[m1] - a[i] + M <= m0) l1 = m1;
                    else r1 = m1;
                }
                int S = M + pref[l1 + 1] - pref[i + 1] - (a[i] - M) * (l1 - i) + (n - l1 - 1) * m0;
                if (S >= rest) R = M;
                else L = M; 
            }
            rest -= R;
            vls.pb(a[i] - R);
        }
    }
    vls.pb(a[n - 1] - rest);
    for (int u : vls) cout << u << ' ';
    cout << '\n';

    auto calc_pref = [&](int m, int k, int x) {
        if (x == 0) return 0ll;
        int L = -1, R = m * k;
        while (R - L > 1) {
            int M = (L + R) / 2;
            int l1 = -1, r1 = x - 1;
            while (r1 - l1 > 1) {
                int m1 = (l1 + r1) / 2;
                if (a[x - 1] - a[m1] > m) {
                    l1 = m1;
                    continue;
                }
                int sm = pref[x] - pref[m1];
                if (sm - a[m1] * (x - m1) <= M) r1 = m1;
                else l1 = m1;
            }
            int alr = pref[x] - pref[r1] - (x - r1) * a[r1];
            int dop = (M - alr) / (x - r1);
            int value = max(a[x - 1] - m, a[r1] - dop);

            l1 = x; r1 = n;
            while (r1 - l1 > 1) {
                int m1 = (l1 + r1) / 2;
                if (a[m1] - value > m) r1 = m1;
                else l1 = m1;
            }
            int cando = pref[r1] - pref[x] - value * (r1 - x) + m * (n - r1);
            if (cando + M >= m * k) R = M;
            else L = M;
        }
        return R;
    };  

    // for (int i = 0; i < n; i++) {
    //     cout << a[i] - (calc_pref(m0, k0, i + 1) - calc_pref(m0, k0, i)) << ' ';
    // }
    // cout << '\n';

    while (q--) {
        int t; cin >> t;
        if (t == 1) {
            int m, k, x; cin >> m >> k >> x;
            x--;
            cout << a[x] - (calc_pref(m, k, x + 1) - calc_pref(m, k, x)) << '\n';
        }
    }
}

signed main() {
    int tt = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else
        cin.tie(0)->sync_with_stdio(false);
    #endif  

    while (tt--) {
        solve();
    }

    return 0;
}