#ifdef LOCAL
#pragma optimize("", off)
#include "localstd1.h"
#else
#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/allocator.h>
#pragma GCC target("avx2,bmi,bmi2")
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(a) (a).begin(), (a).end()

vector<ll> get(vector<ll> a, ll m, ll k) {
	while (m--) {
		sort(all(a), greater<ll>());
		for (int i = 0; i < k; i++) a[i]--;
	}
	sort(all(a), greater<ll>());
	return a;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m, k, q; cin >> n >> m >> k >> q;
	vector<ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<ll> b = get(a, m, k);
	sort(all(a), greater<ll>());
	for (int i = 0; i < k; i++) a[i] -= m;
	int l = k - 2, r = k;
	ll sum = a[k - 1];
	int cnt = 1;

	auto mn_el = [&]() {return sum / cnt; };
	auto mx_el = [&]() {return sum / cnt + bool(sum % cnt); };

	while (true) {
		if (r < n && mn_el() < a[r]) {
			sum += a[r];
			cnt++;
			r++;
		}
		else if (l >= 0 && mx_el() > a[l]) {
			sum += a[l];
			cnt++;
			l--;
		}
		else {
			break;
		}
	}
	
	for (int i = 0; i <= n; i++) {
		if (l < i && i < r) {
			a[i] = mx_el();
			sum -= mx_el();
			cnt--;
		}
	}

	reverse(all(b));
	for (int i = 0; i < n; i++) {
		cout << b[i] << ' ';
	}

	return 0;
}