#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

bool ch(ll x, vector<ll>& a, ll m0, ll k0) {
	ll cn = 0;
	for (auto i : a) {
		cn += max(0ll, min(m0, i - x));
	}
	return cn >= m0 * k0;
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	ll n, m0, k0, q;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	ll lt = -2e9, rt = 2e9;
	while (rt - lt > 1) {
		ll md = (lt + rt) / 2;
		if (ch(md, a, m0, k0)) {
			lt = md;
		}
		else {
			rt = md;
		}
	}
	ll cn = k0 * m0;
	vector<ll> v;
	for (int i = 0; i < n; ++i) {
		ll y = min(cn, max(0ll, min(m0, a[i] - lt)));
		v.push_back(a[i] - y);
		cn -= y;
	}
	sort(v.begin(), v.end());
	for (auto i : v) {
		cout << i << ' ';
	}

	return 0;
}
