#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rng(time(0));

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    int n, m, k, q;
    cin >> n >> m >> k >> q;

    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }

    a[0] = -3e9;
    sort(a.begin() + 1, a.end());

    int fl = 0;
    for (int i = n - 1; i >= 1; --i) {
        if (a[i] < a[n]) {
            fl = i;
            break;
        }
    }

    vector<int> del(n + 2);
    int last = a[n];
    for ( ; ; ) {
        int diff = last - a[fl];
        int len = n - fl;

        if (len * diff > m) {
            int cdiff = m / len;
            last -= cdiff;
            del[fl + 1] += cdiff;

            diff = m - cdiff * len;
            del[fl + 1] += 1;
            del[fl + diff + 1] -= 1;
            m = 0;
        } else {
            last -= diff;
            del[fl + 1] += diff;
            m -= len * diff;
        }

        if (!m) break;

        while (fl > 0 && a[fl] >= last) {
            --fl;
        }
    }

    int cur_del = 0;
    for (int i = 1; i <= n; ++i) {
        cur_del += del[i];
        a[i] -= cur_del;
    }

    sort(a.begin() + 1, a.end());

    for (int i = 1; i <= n; ++i) {
        cout << a[i] << " \n"[i == n];
    }

    return 0;
}
