#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <iomanip>
#include <string>
#include <numeric>
#include <random>
#include <cmath>
using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18;



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, k0, q; ll m0;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	sort(a.begin(), a.end());
	reverse(a.begin(), a.end());
	vector<ll> dp(n, 0);
	ll pref = a[0];
	for (int i = 1; i < n; ++i) {
		dp[i] = pref - a[i] * i;
		pref += a[i];
	}
	int pos = distance(dp.begin(), prev(upper_bound(dp.begin(), dp.end(), m0)));
	ll ost = m0 - dp[pos];
	ll add = ost / (pos + 1);
	int pref_cnt = ost % (pos + 1);
	vector<ll> ans(n);
	for (int i = 0; i < pref_cnt; ++i)
		ans[i] = a[pos] - add - 1;
	for (int i = pref_cnt; i <= pos; ++i)
		ans[i] = a[pos] - add;
	for (int i = pos + 1; i < n; ++i)
		ans[i] = a[i];
	sort(ans.begin(), ans.end());
	for (auto el : ans) cout << el << " ";
	cout << "\n";

	for (int _ = 0; _ < q; ++_) {
		int type, k, x; ll m;
		cin >> type >> m >> k >> x;
		int pos = distance(dp.begin(), prev(upper_bound(dp.begin(), dp.end(), m)));
		ll ost = m - dp[pos];
		ll add = ost / (pos + 1);
		int pref_cnt = ost % (pos + 1);
		if (x <= n - pos - 1) {
			cout << a[n - x] << "\n";
		}
		else if (x <= n - pos - 1 + pref_cnt) {
			cout << a[pos] - add - 1 << "\n";
		}
		else {
			cout << a[pos] - add << "\n";
		}
	}

	return 0;
}
