#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
using ull = long long;
using ld = long double;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int N = 2e5;
int a[N], n;
int pref[N + 1];

int f(int m, int k, int x) {
    m -= (pref[n] - pref[x]) - a[x] * (n - x);
    if (m <= 0) {
        return a[x];
    }
    int l = a[0] - m - 1, r = a[n - 1];
    while (r - l > 1) {
        int y = (l + r) / 2;
        int pos = lower_bound(a, a + n, y) - a;
        int m1 = m - (pref[n] - pref[pos]) + y * (n - pos);
        if (m1 < 0) {
            l = y;
        } else if (m1 >= (n - pos)) {
            r = y - 1;
        } else {
            r = y;
            l = y - 1;
        }
    }
    int pos = lower_bound(a, a + n, r) - a;
    int m1 = m - (pref[n] - pref[pos]) + r * (n - pos);
    if (m1 >= n - x) {
        return r - 1;
    }
    return r;
}

void solve() {
    int m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a, a + n);
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
    }
    for (int i = 0; i < n; ++i) {
        cout << f(m0, k0, n - 1 - i) << ' ';
    }
    cout << '\n';
    for (int i = 0; i < q; ++i) {
        int t, m, k, x;
        cin >> t >> m >> k >> x;
        cout << f(m, k, n - 1 - (x - 1)) << '\n';
    }
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
