#include <bits/extc++.h>

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    if (m0 == 0) {
        for (int i = 0; i < n; i++) {
            cout << a[i] << " \n"[i == n - 1];
        }
        return 0;
    }
    vector<int> s(n);
    s[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        s[i] += s[i + 1];
    }
    auto f = [&](int x) -> int {
        int i = (int)(lower_bound(a.begin(), a.end(), x) - a.begin());
        if (i == n) {
            return 0;
        }
        int cnt = n - i;
        int kill = s[i] - cnt * x;
        return kill;
    };
    int lx = -1, rx = 1e9 + 52;
    while (rx - lx > 1) {
        int x = (lx + rx) >> 1;
        int kill = f(x);
        if (kill <= m0) {
            rx = x;
        } else {
            lx = x;
        }
    }
    m0 -= f(rx);
    for (auto &z : a) {
        if (z > rx) {
            z = rx;
        }
    }
    {
        int i = n - 1;
        while (m0--) {
            a[i]--;
            i--;
        }
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < n; i++) {
        cout << a[i] << " \n"[i == n - 1];
    }
    return 0;
}
