#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <iomanip>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <random>
using namespace std;

#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define pub push_back
#define pob pop_back
#define for0(i,n) for(ll i = 0; i < ll(n); i++)

typedef long long ll;
typedef double long dl;
typedef vector<ll> vll;
typedef vector<pair<ll,ll>> vpll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<int> vi;
typedef vector<pair<int,int>> vpi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


template<typename T1, typename T2>
ostream& operator <<(ostream& out, pair<T1, T2>& a){
    out << a.fi << " " << a.se << endl;
    return out;
}

template<typename T1, typename T2>
istream& operator <<(istream& in, pair<T1, T2>& a){
    in >> a.fi >> a.se;
    return in;
}

template<typename T>
istream& operator >>(istream& in, vector<T>& a){
    for(T& ai : a) in >> ai;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T>& a){
    for(T& ai : a) out << ai << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<vector<T>>& a){
    for(vector<T>& ai : a){
        for(T& aii : ai) in >> aii;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<vector<T>>& a){
    for(vector<T>& ai : a){
        for(T& aii : ai) out << aii << " ";
        out << endl;
    }
    return out;
}

void solve(){
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vll a(n);
    cin >> a;
    multiset<ll, greater<ll>> am;
    for0(i,n){
        am.insert(a[i]);
    }
    for(int im = 0; im < m; im++){
        auto it = am.begin();
        ll ai = (*it) - 1;
        am.erase(it);
        am.insert(ai);
    }
    a.clear();
    for(const ll& ai : am) a.pub(ai);
    cout << a << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
