#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <unordered_set>
#include <algorithm>

using namespace std;

using ll = long long;

#pragma GCC optimaze("Ofast");

vector<unordered_set<int>> gr, grr;

vector<int> us;
vector<int> top;
vector<int> ok;
set<pair<int, int>> ed;
ll n, m, t;

void dfs(int v, vector<vector<int>>& gr, vector<vector<int>>& gr2, vector<int>& us, int& cnt) {
	us[v] = 1;
	for (int u : gr[v]) {
		if (us[u]) continue;
		if (int(gr[v].size()) == 1) {
			cnt++;
			dfs(u, gr, gr2, us, cnt);
		}
		else if (int(gr2[u].size()) == 1) {
			cnt++;
			dfs(u, gr, gr2, us, cnt);
		}
	}
	for (int u : gr2[v]) {
		if (us[u]) continue;
		if (int(gr2[v].size()) == 1) {
			cnt++;
			dfs(u, gr, gr2, us, cnt);
		}
		else if (int(gr[u].size()) == 1) {
			cnt++;
			dfs(u, gr, gr2, us, cnt);
		}
	}
}

pair<ll, ll> an(vector<vector<int>>& gr) {
	int md = 0;
	int n = int(gr.size());
	for (int i = 0; i < n; i++) md = max(md, int(gr[i].size()));
	if (md == 1) {
		return { m - 1, m - 1 };
	}
	vector<vector<int>> gr2(n);
	for (int i = 0; i < n; i++) {
		for (int u : gr[i]) gr2[u].push_back(i);
	}
	vector<int> us(n);
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		if (us[i]) continue;
		dfs(i, gr, gr2, us, cnt);

	}
	return { cnt, 1 };
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll n, m, k, q;
	cin >> n >> m >> k >> q;
	vector<ll> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	sort(a.begin(), a.end());
	reverse(a.begin(), a.end());
	ll ma = a[0];
	ll L = 0;
	while (true) {
		if (L == n - 1) {
			ma -= m / (L + 1);
			m %= (L + 1);
			for (int i = 0; i < (L + 1) - m; i++) cout << ma << ' ';
			for (int i = 0; i < m; i++) cout << ma - 1 << ' ';
			for (int i = L + 1; i < n; i++) cout << a[i] << ' ';
			return 0;
		}
		if ((a[L + 1] - a[L]) * (L + 1) > m) {
			ma -= m / (L + 1);
			m %= (L + 1);
			for (int i = 0; i < (L + 1) - m; i++) cout << ma << ' ';
			for (int i = 0; i < m; i++) cout << ma - 1 << ' ';
			for (int i = L + 1; i < n; i++) cout << a[i] << ' ';
			return 0;
		}
		m -= (a[L + 1] - a[L]) * (L + 1);
		ma = a[L + 1];
		L++;
	}

}



