#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")
#endif

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;

const int mod = 10;

struct Modular {
    int x;

    Modular(int x = 0): x(x) {}

    friend Modular operator+(Modular a, Modular b) {
        int res = a.x + b.x;
        return res - (res >= mod ? mod : 0);
    }

    friend Modular operator-(Modular a, Modular b) {
        int res = a.x - b.x;
        return res + (res < 0 ? mod : 0);
    }

    friend Modular operator*(Modular a, Modular b) {
        return ll(a.x) * b.x % mod;
    }
};

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    map<ll, ll> cnt;
    for(int i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        cnt[x]++;
    }
    while (m) {
        auto [x, y] = *cnt.rbegin();
        auto a = x;
        if (y == n) {
            a -= m / y;
            cnt.erase(x);
            cnt[a - 1] = m % y;
            cnt[a] = y - cnt[a - 1];
            m = 0;
        } else {
            auto [x1, y1] = *++cnt.rbegin();
            if(m >= (x - x1) * y) {
                cnt[x1] += y;
                cnt.erase(x);
                m -= (x - x1) * y;
            } else {
                a -= m / y;
                cnt.erase(--cnt.end());
                cnt[a - 1] = m % y;
                cnt[a] = y - cnt[a - 1];
                m = 0;
            }
        }
    }
    vector<int> ar;
    for(auto[x, y]: cnt) {
        for(int i = 0; i < y; ++i) {
            cout << x << ' ';
        }
    }

}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("C:\\Users\\User\\aboab\\input.txt", "r", stdin);
#endif
    solve();
}