// Created by rost on 08.03.25.

#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

const ll INF = (ll) 1e18 + 11;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#endif

    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    ll l = -(1e9 + 7), r = (1e9 + 7), m;
    while (r - l > 1) {
        m = l + (r - l) / 2;

        ll cnt = 0;
        for (int i = 0; i < n; ++i)
            cnt += max(0ll, a[i] - m);

        if (cnt <= m0) {
            r = m;
        } else {
            l = m;
        }
    }
    cerr << r << '\n';
    ll rem = m0;
    for (int i = 0; i < n; ++i) {
        rem -= max(0ll, a[i] - r);
        a[i] = min(a[i], r);
    }

    for (int i = 0; i < n; ++i) {
        if (a[i] == r && rem != 0) {
            --rem;
            --a[i];
        }
    }

    sort(a.begin(), a.end());

    for (int i = 0; i < n; ++i) {
        cout << a[i] << ' ';
    }
    cout << '\n';

}