#include <bits/stdc++.h>
using namespace std;
#define int long long

struct segtree {
    segtree *L, *R;
    int l, r, md, lz;
    segtree(int lb, int rb, vector < int > &a) {
        l = lb; r = rb; md = (l + r) / 2; lz = 0;
        if (l == r) { lz = a[l]; return; }
        L = new segtree(l, md, a);
        R = new segtree(md + 1, r, a);
    }
    void push() {
        if (l != r) {
            L -> lz += lz;
            R -> lz += lz;
            lz = 0;
        }
    };
    int get(int p) {
        push();
        if (l == r) return lz;
        return (p <= md ? L : R) -> get(p);
    };
    void add(int lb, int rb, int x) {
        push();
        if (l > rb || r < lb) return;
        if (lb <= l && r <= rb) {
            lz += x;
            push();
            return;
        }
        L -> add(lb, rb, x);
        R -> add(lb, rb, x);
    };
};

main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector < int > a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(begin(a), end(a));


    segtree *tree = new segtree(0, n - 1, a);
    for (int i = n - 1; i > 0; i--) {
        int dt = tree -> get(i) - tree -> get(i - 1);
        int k = n - i;
        int ops = dt * k, ost = 0;
        if (m0 < ops) {
            ops = (m0 / k) * k;
            ost = m0 - ops;
        }
        int d = ops / k;
        tree -> add(i, n - 1, -d);
        m0 -= ops;
        tree -> add(i, i + ost - 1, -1);
    }
    int d = m0 / n;
    tree -> add(0, n - 1, -d);
    int ost = m0 - d * n;
    tree -> add(0, ost - 1, -1);
    for (int i = 0; i < n; i++) cout << tree -> get(i) << ' ';
}

