#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//using ll = int;
using ld = long double;
using ull = unsigned long long;
#define pb push_back
#define all(vec) vec.begin(), vec.end()
#define eb emplace_back
#ifdef LOCAL
#define deb(x) cout << #x << " = " << x << '\n'
#else
#define deb(x) 52
#endif
const ll inf = 1e9 + 11;
const long long INF = (long long)2e18 + 11;
const ll P = 73;
const ll MOD = 1e9 + 7;


void solve() {
    ll n, m, k, q;
    cin >> n >> m >> k >> q;
    auto get_ans = [&](vector<ll> a) -> vector<ll> {
        sort(all(a));
        vector<ll> suf(n + 1);
        for (ll i = n - 1; i >= 0; --i) {
            suf[i] = suf[i + 1] + a[i];
        }
        ll l = (ll)-1e11, r = (ll)1e11;
        auto f = [&](ll x) -> ll {
            ll ind = lower_bound(all(a), x) - a.begin();
            return suf[ind] - (n - ind) * x;
        };
        while (r - l > 1) {
            ll mid = (r + l) >> 1;
            if (f(mid) <= m) {
                r = mid;
            } else {
                l = mid;
            }
        }
        for (ll &i : a) {
            if (i > r) {
                i = r;
            }
        }
        ll need = m - f(r);
        sort(all(a));
        for (ll i = n - 1; i >= n - need && i >= 0; --i) {
            --a[i];
        }
        sort(all(a));
        return a;
    };
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> res = get_ans(a);
    for (ll i : res) {
        cout << i << ' ';
    }
}


int main() {
#ifdef LOCAL
    freopen("C:/work/untitled/input.txt", "r", stdin);
    freopen("C:/work/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}