#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//using ll = int;
using ld = long double;
using ull = unsigned long long;
#define pb push_back
#define all(vec) vec.begin(), vec.end()
#define eb emplace_back
#ifdef LOCAL
#define deb(x) cout << #x << " = " << x << '\n'
#else
#define deb(x) 52
#endif
const ll inf = 1e9 + 11;
const long long INF = (long long)2e18 + 11;
const ll P = 73;
const ll MOD = 1e9 + 7;


void solve() {
    auto get_ans = [&](vector<ll> &a, ll m) -> void {
        ll n = (ll)a.size();
        sort(all(a));
        vector<ll> suf(n + 1);
        for (ll i = n - 1; i >= 0; --i) {
            suf[i] = suf[i + 1] + a[i];
        }
        ll l = (ll)-1e12, r = (ll)1e12;
        auto f = [&](ll x) -> ll {
            ll ind = lower_bound(all(a), x) - a.begin();
            return suf[ind] - (n - ind) * x;
        };
        while (r - l > 1) {
            ll mid = (r + l) >> 1;
            if (f(mid) <= m) {
                r = mid;
            } else {
                l = mid;
            }
        }
        for (ll &i : a) {
            if (i > r) {
                i = r;
            }
        }
        ll need = m - f(r);
        sort(all(a));
        for (ll i = n - 1; i >= n - need && i >= 0; --i) {
            --a[i];
        }
        sort(all(a));
    };
    auto rec_get_ans = [&](auto &rec_get_ans, vector<ll> &a, ll m, ll k) -> void {
        if (k == 1) {
            get_ans(a, m);
            return;
        }
        ll n = (ll)a.size();
        sort(all(a));
        vector<ll> suf(n + 1);
        for (ll i = n - 1; i >= 0; --i) {
            suf[i] = suf[i + 1] + a[i];
        }
        auto f = [&](ll x) -> ll {
            ll ind = upper_bound(all(a), x) - a.begin();
            ll cnt = n - ind;
            ll sum = suf[ind] - cnt * x;
            if (a.back() - x <= (sum == 0 ? 0 : (sum - 1) / k + 1)) {
                return (sum == 0 ? 0 : (sum - 1) / k + 1);
            } else {
                return a.back() - x;
            }
        };
        ll l = (ll)-1e12, r = (ll)1e12;
        while (r - l > 1) {
            ll mid = (r + l) >> 1;
            if (f(mid) <= m) {
                r = mid;
            } else {
                l = mid;
            }
        }
        ll need = m - f(r);
        ll ind = upper_bound(all(a), r) - a.begin();
        ll cnt = n - ind;
        ll sum = suf[ind] - cnt * r;
        if (a.back() - r <= (sum == 0 ? 0 : (sum - 1) / k + 1)) {
            for (ll &i : a) {
                if (i > r) {
                    i = r;
                }
            }
            ll t = (k - sum % k) % k;
            for (ll &i : a) {
                if (t == 0) {
                    break;
                }
                if (i == r) {
                    i = r - 1;
                    --t;
                }
            }
        } else {
            ll cnt_op = a.back() - r;
            a.pop_back();
            rec_get_ans(rec_get_ans, a, cnt_op, k - 1);
            a.pb(r);
            //vector<ll> b(a.begin(), a.begin() + n - 1);
            //b = rec_get_ans(rec_get_ans, b, cnt_op, k - 1);
            //b.pb(r);
            //a = b;
        }
        priority_queue<ll> pq(all(a));
        vector<ll> vec;
        while (need--) {
            for (ll i = 0; i < k; ++i) {
                vec.pb(pq.top() - 1);
                pq.pop();
            }
            for (ll i : vec) {
                pq.push(i);
            }
            vec.clear();
        }
        a.clear();
        while (!pq.empty()) {
            a.pb(pq.top());
            pq.pop();
        }
        sort(all(a));
    };
    ll n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    rec_get_ans(rec_get_ans, a, m, k);
    sort(all(a));
    for (ll i : a) {
        cout << i << ' ';
    }
}


int main() {
#ifdef LOCAL
    freopen("C:/work/untitled/input.txt", "r", stdin);
    freopen("C:/work/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}