#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <string>
#include <vector>
#include <chrono>
#include <random>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>
#include <set>
#define endl '\n'
#define mp make_pair

using namespace std;
using i64 = long long;
using ld = long double;

const i64 INF = 1e18 + 5;

mt19937 rnd(29);

i64 gcd_ext(i64 a, i64 b, i64& x, i64& y) {
	if (b == 0) {
		x = 1; y = 0;
		return a;
	}
	i64 x1 = 0, y1 = 0;
	i64 c = gcd_ext(b, a % b, x1, y1);
	x = y1, y = (-y1 * (a / b) + x1);
	return c;
}

i64 gcd(i64 a, i64 b) {
	while (b) swap(b, a %= b);
	return a;
}

const i64 S = 2e5 + 10;
i64 a[S];
set <pair<i64, i64>> d;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	i64 n, m0, k0, q; cin >> n >> m0 >> k0 >> q;

	for (i64 x = 1; x <= n; ++x) {
		cin >> a[x];
	}

	while (q--) {
		i64 t; cin >> t;
		if (t == 1) {
			i64 m, k, x; cin >> m >> k >> x;
		}
		else if (t == 2) {
			i64 p, u; cin >> p >> u;
		}
		else {
			i64 m, k, l, r; cin >> m >> k >> l >> r;
		}
	}

	sort(a + 1, a + n + 1);
	a[0] = -2e9 - 5;

	i64 from = n;

	for (i64 x = n; x >= 1; --x) {
		if (a[x] > a[x - 1]) {
			if ((n - x + 1) * (a[x] - a[x - 1]) <= m0) {
				m0 -= (n - x + 1) * (a[x] - a[x - 1]);
				from = x;
			}
			else {
				i64 minus = m0 / (n - x + 1), left = m0 % (n - x + 1);
				for (i64 y = 1; y < x; ++y) {
					cout << a[y] << " ";
				}
				if (left == 0) {
					for (i64 y = x; y <= n; ++y) {
						cout << a[x] - minus << " ";
					}
				}
				else {
					for (i64 y = x; y <= n; ++y) {
						if (y <= x + left - 1) cout << a[x] - minus - 1 << " ";
						else cout << a[x] - minus << " ";
					}
				}
				exit(0);
			}
		}
	}
}