#include <iostream>
#include <vector>
#include <math.h>
#include <cmath>
#include <algorithm>
#include <set>

using ll = long long;
using ld = long double;

#define int ll
#define pii pair<int, int>
#define all(obj) obj.begin(), obj.end()
#define rall(obj) obj.rbegin(), obj.rend()
#define pb push_back

const int inf = 1e9;
const int INF = 1e18;

using namespace std;

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int>a(n);
    for (int i=0; i<n; i++) {
        cin >> a[i];
    }
    
    multiset<int>s;
    for(int i=0; i<n; i++) {
        s.insert(a[i]);
    }

    for (int ii=0; ii<m0; ii++) {
        vector<int>h;
        for (int i=0; i<k0; i++) {
            h.pb(*prev(s.end()));
            s.erase(prev(s.end()));
        }
        for (auto i:h) {
            s.insert(i-1);
        }
    }
    for (int i=0; i<n; i++) {
        cout << (*s.begin()) << " ";
        s.erase(s.begin());
    }
    cout << "\n";
    while(q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int m, k, x;
            cin >> m >> k >> x;
            multiset<int>s;
            for(int i=0; i<n; i++) {
                s.insert(a[i]);
            }
            for (int ii=0; ii<m; ii++) {
                vector<int>h;
                for (int i=0; i<k; i++) {
                    h.pb(*prev(s.end()));
                    s.erase(prev(s.end()));
                }
                for (auto i:h) {
                    s.insert(i-1);
                }
            }
            auto u = s.begin();
            for (int i=0; i<k-1; i++) {
                u = next(u);
            }
            cout << (*u) << "\n";
        }
        else if (t == 2) {
            int p, v;
            cin >> p >> v;
            p--;
            a[p] = v;
        }
        else {
            int m, k, l, r;
            cin >> m >> k >> l >> r;
            l--; r--;
            multiset<int>s;
            for(int i=0; i<n; i++) {
                s.insert(a[i]);
            }
            for (int ii=0; ii<m; ii++) {
                vector<int>h;
                for (int i=0; i<k; i++) {
                    h.pb(*prev(s.end()));
                    s.erase(prev(s.end()));
                }
                for (auto i:h) {
                    s.insert(i-1);
                }
            }
            int ans = 0;
            auto u = s.begin();
            for (int i=0; i<l; i++) {
                u = next(u);
            }
            for (int i=0; i<=r-l; i++) {
                ans += (*u);
                u = next(u);
            }
            cout << ans << "\n";
        }
    }
}