#include <iostream>
#include <algorithm>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <chrono>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define allv(x) (x).begin(), (x).end()
#define allv_rev(x) (x).rbegin(), (x).rend()
#define lolset(x) memset(x, 0, sizeof (x))
#define lolfill(x, v) fill(x, x + sizeof(x) / sizeof(*x), v)
#define sz(x) ((ll)(x).size())
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<ll, ll>;
using pll = pair<ll, ll>;
mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());
template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &i : v)
        is >> i;
    return is;
}




#ifdef DEBUG
const ll MAXN = 0, INF = 1e3;
#else
const ll MAXN = 0, INF = 2e9 + 1e6 * 228;
#define cerr if (0) cerr
#endif


vector<ll> a;
ll n, m, k;


signed one() {
    ll _;
    cin >> n >> m >> k >> _;
    a.resize(n);
    cin >> a;


    sort(allv_rev(a));
    ll lb = -INF, rb = INF;
    while (rb - lb > 1) {
        ll mb = (lb + rb) / 2;
        ll sum = 0;
        ll i;
        for (i = 0; i < n; i++) {
            if (a[i] < mb) break;
            sum += a[i] - mb;
        }
        if (sum > m)
            lb = mb;
        else
            rb = mb;
    }
    ll i, sum = 0;
    for (i = 0; i < n; i++) {
        if (a[i] < rb) break;
        sum += a[i] - rb;
    }
    ll cnt_m1 = m - sum;
    assert(cnt_m1 < i);
    assert(m >= sum);
    for (ll j = n - 1; j >= i; j--)
        cout << a[i] << ' ';
    for (ll j = 0; j < cnt_m1; j++)
        cout << rb - 1 << ' ';
    for (ll j = cnt_m1; j < i; j++)
        cout << rb << ' ';
    cout << endl;
    return 0;
}



signed main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    signed t;
    t = 1;
    while (t--) {
        signed retcode = one();
        if (retcode) return retcode;
    }
    return 0;
}
