#include <bits/stdc++.h>

using namespace std;

int n, m0, k0, q;
vector<long long> arr, tree;

void upd(int i, long long x) {
    while(i < tree.size()) {
        tree[i] += x;
        i = i | (i + 1);
    }
}

long long pref(int i) {
    long long ans = 0;
    while(i >= 0) {
        ans += tree[i];
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m0 >> k0 >> q;
    arr.resize(n);
    for(int i = 0; i < n; i++) cin >> arr[i];
    sort(arr.begin(), arr.end());

    tree.resize(n);
    upd(0, arr[0]);
    for(int i = 1; i < n; i++) upd(i, arr[i] - arr[i - 1]);
    while(m0--) {
        int mn = pref(n - k0);
        int L = 0, R = n;
        while(R - L > 1) {
            int M = (L + R) / 2;
            int xx = pref(M);
            if(xx > mn) R = M;
            else L = M;
        }
        int lenS = n - R;
        upd(R, -1);

        L = -1; R = n - 1;
        while(R - L > 1) {
            int M = (L + R) / 2;
            int xx = pref(M);
            if(xx >= mn) R = M;
            else L = M;
        }
        int rem = k0 - lenS;
        upd(R, -1);
        upd(R + rem, 1);
    }
    for(int i = 0; i < n; i++) cout << pref(i) << ' ';
    cout << '\n';

    while(q--) {
        assert(false);
    }
}
