#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << __LINE__ << ": " << (#x) << " = " << (x) << endl
#else
#define debug(...) 42
#endif

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef __int128 LL;
#define all(x) (x).begin(), (x).end()
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
istream &operator >>(istream &in, vector<T> &a) {
    for (auto &elem : a) {
        in >> elem;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, const vector<T> &a) {
    for (const auto &elem : a) {
        out << elem << ' ';
    }
    return out;
}

int n, m, k, q;
vector<int> a;

void solve() {
    assert(q == 0);
    ll left = -1e17, right = 1e17;
    while (right - left > 1) {
        ll mid = (left + right) / 2;
        ll rem = 1ll * m * k;
        for (int num : a) {
            if (num - mid > m) {
                rem = -1;
                break;
            }
            rem -= max(num - mid, 0ll);
            if (rem < 0) { break; }
        }
        rem < 0 ? left = mid : right = mid;
    }
    vector<ll> res;
    ll rem = 1ll * m * k, cur = right, cnt = 0;
    sort(all(a));
    int i = n;
    while (i > 0 && a[i - 1] >= cur) {
        rem -= a[i - 1] - cur;
        cnt++;
        i--;
    }
    while (res.size() < n) {
        // cout << "! " << cur << ' ' << cnt << ' ' << rem << ' ' << i << '\n';
        if (rem >= cnt) {
            rem -= cnt;
            cur--;
            while (i > 0 && a[i - 1] >= cur) {
                cnt++;
                i--;
            }
        } else {
            res.push_back(cur);
            cnt--;
        }
    }
    ranges::reverse(res);
    cout << res << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k >> q;
    a.resize(n);
    cin >> a;
    solve();
}