#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T>& v);
template<typename T>
ostream& operator<<(ostream& out, vector<T>& v);
template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p);
template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p);

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& x : v) in >> x;
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v) {
    for (T& x : v) out << x << " ";
    return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2>& p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2>& p) {
    out << p.first << " " << p.second;
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int n, m0, k0, q;
vector<int> a;

void solve() {
    if (k0 == 1) {
        ll sum = 0;
        for (int i = 0; i < n; i++) {
            sum += a[i];
            if (i + 1 < n && sum - (ll)(i + 1) * a[i + 1] <= m0) continue;
            ll x = (sum - m0) / (i + 1);
            if ((sum - m0) % (i + 1) != 0) x++;
//            cout << i << ": " << sum << " " << x << "\n";
            for (int j = 0; j <= i; j++) a[j] = x;
            m0 -= sum - (ll)(i + 1) * x;
            break;
        }
        for (int i = 0; i < m0; i++) {
            a[i]--;
        }
        sort(all(a));
        for (int x : a) cout << x << " ";
        return;
    }
}

signed main() {
#ifndef LOCAL
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
#endif

    cin >> n >> m0 >> k0 >> q;
    a.resize(n);
    cin >> a;
    sort(rall(a));

    if (q == 0) {
        solve();
    }
}