#include <iostream>
#include <random>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;
using ll = long long;
using ull = unsigned long long;

constexpr int maxn = 2e5 + 10;

int n, m0, k0, q;
int arr[maxn];

void solve() {
    cin >> n >> m0 >> k0 >> q;
    for (int i = 0; i < n; ++i) cin >> arr[i];
    sort(arr, arr + n);
    for (int i = 0; i < m0; ++i) {
        for (int j = n - k0; j < n; ++j) --arr[j];
        sort(arr, arr + n);
    }
    for (int i = 0; i < n; ++i) cout << arr[i] << " ";
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
#ifdef TEST
    freopen("input.txt", "r", stdin);
#else
#endif
#endif
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}

//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < n; ++j) dists[j] = 0;
//        dfs(i, 0);
//        dfs2(i);
//    }
//    int cnt = 0;
//    for (int i = 0; i < m; ++i) cnt += need[i];
//    cout << 0 << "\n";