#pragma GCC optimize('Ofast')
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
struct fenw {
    vector<int> f;
    explicit fenw(int n) {
        f.resize(n);
    }
    void upd(int i, int x) {
        while (i < f.size()) {
            f[i] += x;
            i |= (i + 1);
        }
    }
    int get(int i) {
        int sum = 0;
        while (i >= 0) {
            sum += f[i];
            i &= (i + 1);
            i--;
        }
        return sum;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};
template <typename T>
bool smin(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template <typename T>
bool smax(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(a.begin(), a.end());
    if (k == n) {
        for (int i = 0; i < n; i++) a[i] -= m;
        for (auto e : a) cout << e << ' ';
        cout << '\n';
        return 0;
    }
    vector<int> b(n + 1);
    b[0] = a[0];
    for (int i = 1; i < n; i++) b[i] = a[i] - a[i - 1];
    vector<int> nznl(n + 1), nznr(n + 1);
    for (int i = 1; i < n; i++) {
        if (b[i] != 0) {
            nznl[i] = i;
        } else {
            nznl[i] = nznl[i - 1];
        }
    }
    nznr[n] = n;
    for (int i = n - 1; i >= 0; i--) {
        if (b[i] != 0) {
            nznr[i] = i;
        } else {
            nznr[i] = nznr[i + 1];
        }
    }
    fenw f(n + 1);
    for (int i = 0; i < n; i++) f.upd(i, b[i]);
    while (m > 0) {
        if (f.get(n - k, n - k) > 0) {
            int x = f.get(n - k, n - k);
            if (x >= m) {
                f.upd(n - k, -m);
                m = 0;
            } else {
                f.upd(n - k, -x);
                m -= x;
            }
        } else {
            int ll = 0, lr = n - k;
            while (lr - ll > 1) {
                int lm = (ll + lr) / 2;
                if (f.get(lm, n - k) == 0) {
                    lr = lm;
                } else {
                    ll = lm;
                }
            }
            int rl = n - k, rr = n;
            while (rr - rl > 1) {
                int rm = (rl + rr) / 2;
                if (f.get(n - k, rm) == 0) {
                    rl = rm;
                } else {
                    rr = rm;
                }
            }
            int x1 = f.get(ll, ll), x2 = f.get(rr, rr);
            if (ll == 0) x1 = 1e10;
            if (rr == n) x2 = 1e10;
            int i2 = rr + ll - n + k;
            if (i2 > n - k) {
                int xx = min(x1, 2 * x2);
                if (xx >= m) {
                    f.upd(ll, -m);
                    f.upd(rr, -(m + 1) / 2);
                    f.upd(i2, m % 2);
                } else {
                    f.upd(ll, -xx);
                    f.upd(rr, -(xx + 1) / 2);
                    f.upd(i2, xx % 2);
                }
            } else if (i2 == n - k) {
                int xx = min(2 * x1, 2 * x2);
                if (xx >= m) {
                    f.upd(ll, -m);
                    f.upd(rr, -(m + 1) / 2);
                    f.upd(i2, m % 2);
                } else {
                    f.upd(ll, -xx);
                    f.upd(rr, -(xx + 1) / 2);
                    f.upd(i2, xx % 2);
                }
            } else {
                int xx = min(2 * x1, x2);
                if (xx >= m) {
                    f.upd(ll, -m);
                    f.upd(rr, -(m + 1) / 2);
                    f.upd(i2, m % 2);
                } else {
                    f.upd(ll, -xx);
                    f.upd(rr, -(xx + 1) / 2);
                    f.upd(i2, xx % 2);
                }
            }
        }
    }
    int cur = 0;
    for (int i = 0; i < n; i++) {
        cur += f.get(i, i);
        cout << cur << ' ';
    }
    return 0;
}