#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vii = vector<pair<int, int>>;
using vc = vector<char>;
using vb = vector<bool>;
template<typename T>
using ve = vector<T>;
template<typename T1, typename T2>
using pr = pair<T1, T2>;

const int INF = 1e9 + 1;
const long long INFLL = 1e18 + 1;
const int MOD = 1e9 + 7;

inline void fchmin(int &a, int &b) { a = min(a, b); }
inline void fchmax(int &a, int &b) { a = max(a, b); }

template<typename T>
inline bool chmin(T &a, T &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
inline bool chmax(T &a, T &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// #include<ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_pbds;
// using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int reps = 1;

int find(vi &b, int h) {
    int l = 0, r = b.size();
    while (r - l > 1) {
        int mid = (r + l) / 2;
        if (b[mid] < h) l = mid;
        else r = mid;
    }
    if (b[0] >= h) return -1;
    else return l;
}

void solve() {
    int n, m, k, q; cin >> n >> m >> k >> q;
    vi a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(all(a));
    vi b = a;
    vi pref(n + 1);
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i - 1];
    // for (int i = 0; i < n; i++) a[i] -= m;
    int l = a[0] - m, r = a[n - 1] + 1;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        int ind = lower_bound(all(a), mid + m) - a.begin();
        int ind2 = find(b, mid);
        int summ = m * (n - ind) + pref[ind] - pref[ind2 + 1] - mid * (ind - ind2 - 1);
        if (summ / k >= m) l = mid;
        else r = mid;
    }
    int ind = lower_bound(all(a), l + m) - a.begin();
    int ind2 = find(b, l);
    int summ = m * (n - ind) + pref[ind] - pref[ind2 + 1] - l * (ind - ind2 - 1);
    int diff = summ - m * k;
    vi res(n);
    for (int i = n - 1; i >= 0; i--) {
        if (a[i] <= l) res[i] = a[i];
        else if (a[i] - m > l) res[i] = a[i] - m;
        else if (diff) { res[i] = l + 1; diff--; }
        else res[i] = l;
    }
    for (auto el : res) cout << el << ' ';
    cout << '\n';
    while (q--) {
        int t; cin >> t;
        if (t == 1) {
            cin >> m >> k; int x; cin >> x; x--;
            l = a[0] - m; r = a[n - 1] + 1;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                int ind = lower_bound(all(a), mid + m) - a.begin();
                int ind2 = find(b, mid);
                int summ = m * (n - ind) + pref[ind] - pref[ind2 + 1] - mid * (ind - ind2 - 1);
                if (summ / k >= m) l = mid;
                else r = mid;
            }
            ind = lower_bound(all(a), l + m) - a.begin();
            ind2 = find(b, l);
            summ = m * (n - ind) + pref[ind] - pref[ind2 + 1] - l * (ind - ind2 - 1);
            diff = summ - m * k;
            int ind3 = upper_bound(all(a), l + m) - a.begin();
            if (a[x] <= l) cout << a[x] << '\n';
            else if (a[x] - m > l) cout << a[x] - m << '\n';
            else if (ind3 - x - 1 >= diff) cout << l << '\n';
            else cout << l + 1 << '\n';
        } else if (t == 3) {
            cin >> m >> k; int x; cin >> l, r; cin >> l >> r; l--; r--;
            l = a[0] - m; r = a[n - 1] + 1;
            while (r - l > 1) {
                int mid = (r + l) / 2;
                int ind = lower_bound(all(a), mid + m) - a.begin();
                int ind2 = find(b, mid);
                int summ = m * (n - ind) + pref[ind] - pref[ind2 + 1] - mid * (ind - ind2 - 1);
                if (summ / k >= m) l = mid;
                else r = mid;
            }
            ind = lower_bound(all(a), l + m) - a.begin();
            ind2 = find(b, l);
            summ = m * (n - ind) + pref[ind] - pref[ind2 + 1] - l * (ind - ind2 - 1);
            diff = summ - m * k;
            int ind3 = upper_bound(all(a), l + m) - a.begin();
            int ans = 0;
            if (l <= ind2) ans += pref[ind2 + 1] - pref[l];
            int ind4 = upper_bound(all(a), l + m) - a.begin();
            if (ind4 <= r) ans += pref[r + 1] - pref[ind4] - m * (r + 1 - ind4);
            ans += (min(ind3 - 1 - diff, r) - max(l, ind2 + 1)) * l + (l + 1) * (diff - max(0LL, r - ind4));
            cout << ans << '\n';
        }
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
    #endif

    for (int i = 1; i <= reps; i++) {
        #ifdef LOCAL
        cout << "===== Test #" << i << " ========\n";
        #endif
        solve();
        #ifdef LOCAL
        cout << "==== End test =====\n\n";
        #endif
    }
}