#include <bits/stdc++.h>

using namespace std;

vector<long long> a;
long long n, m, k, q;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> k >> q;
    a.resize(n);
    for (auto &elem : a) cin >> elem;
    sort(a.begin(), a.end());
    long long am = m * k;
    long long left = -2e9, right = 2e9;
    while (right - left > 1) {
        long long mid = (left + right) / 2;
        long long s = 0;
        for (int i = 0; i < n; i++) {
            s += min(max(0ll, a[i] - mid), m);
        }
        if (s < am) right = mid;
        else left = mid;
    }
    vector<long long> ready, not_ready;
    for (int i = 0; i < n; i++) {
        long long delta = min(max(0ll, a[i] - right), m);
        a[i] -= delta, am -= delta;
        if (delta == m) ready.push_back(a[i]);
        else not_ready.push_back(a[i]);
    }
    sort(not_ready.begin(), not_ready.end());
    int nrsz = not_ready.size();
    for (int i = nrsz - 1; i > nrsz - am - 1; i--) not_ready[i]--;
    for (auto elem : not_ready)
        ready.push_back(elem);
    a = ready;
    sort(a.begin(), a.end());
    for (auto elem : a) cout << elem << ' ';
    cout << '\n';
}
