#include <bits/stdc++.h>
#define int long long

using namespace std;

const int inf = 1e18;

void solve() {
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    unordered_map<int, int> cnt;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ++cnt[a[i]];
    }
    sort(a.rbegin(), a.rend());
    vector<tuple<int, int, int>> ev;
    ev.push_back({0, a[0], cnt[a[0]]});
    int sum = 0, h = a[0], c = cnt[a[0]];
    for (int i = c; i < n; ) {
        int d = h - a[i];
        int add = d * i;
        sum += add;
        h = a[i];
        c = c + cnt[a[i]];
        ev.push_back({sum, h, c});
        i = c;
    }
    auto query = [&](int x, int m) {
        int i = upper_bound(ev.begin(), ev.end(), make_tuple(m, inf, inf)) - ev.begin() - 1;
        auto [ms, h, w] = ev[i];
        int dm = m - ms;
        if (a[n - x] < h) {
            return a[n - x];
        }
        int f = dm / w;
        int ans = h - f;
        dm %= w;
        if (w - (n - x) <= dm) {
            return ans - 1;
        } else {
            return ans;
        }
    };
    for (int i = 1; i <= n; ++i) {
        cout << query(i, m0) << ' ';
    }
    cout << '\n';
    for (int qi = 0; qi < q; ++qi) {
        int tp, m, k, x; cin >> tp >> m >> k >> x;
        cout << query(x, m) << '\n';
    }
}

signed main(void) {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0); cout.tie(0);
    int n = 1;
    for (int i = 0; i < n; ++i) {
        solve();
    }
}