#include <bits/stdc++.h>

using namespace std;

#define int long long
using ld = long double;
using ll = long long;
using pii = pair<int, int>;

struct nmset
{
    map<int, int> cnt;
    int ma()
    {
        return cnt.rbegin()->first;
    }
    int m2()
    {
        auto it = cnt.rbegin();
        if (it->first != cnt.begin()->first)
        {
            --it;
            return it->first;
        }
        return LLONG_MIN;
    }
    void insert(const int &el)
    {
        ++cnt[el];
    }
    void insert(const int &el, const int &c)
    {
        cnt[el] += c;
    }
    void erase(const int &el)
    {
        --cnt[el];
        if (cnt[el] == 0)
            cnt.erase(el);
    }
    void erase(const int &el, const int &c)
    {
        cnt[el] -= c;
        assert(cnt[el] >= 0);
        if (cnt[el] == 0)
        {
            cnt.erase(el);
        }
    }
};

void solve()
{
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    nmset se;
    for (int i = 0; i < n; ++i)
    {
        int el;
        cin >> el;
        se.insert(el);
    }
    while (m > 0)
    {
        int mx = se.ma();
        int m2 = se.m2();
        int mx_cnt = se.cnt[mx];
        int max_move = m / mx_cnt;
        int min_el = mx - max_move;
        if (min_el <= m2)
        {
            se.erase(mx, mx_cnt);
            se.insert(m2, mx_cnt);
            int diff = mx - m2;
            m -= diff * mx_cnt;
        }
        else
        {
            se.erase(mx, mx_cnt);
            m -= max_move * mx_cnt;
            assert(m < mx_cnt);
            int ne = mx - max_move;
            se.insert(ne, mx_cnt - m);
            se.insert(ne - 1, m);
            m = 0;
        }
    }
    for (const auto [val, cnt] : se.cnt)
    {
        for (int i = 0; i < cnt; ++i)
        {
            cout << val << " ";
        }
    }
    cout << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(0);
    ios::sync_with_stdio(0);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}