#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <array>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()

ll del(ll a, ll b) {
	ll x = a / b;
	while (b * x > a) x--;
	return x;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m0, k0, q;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	sort(all(a));
	map<ll, ll> mp;
	for (ll x : a) mp[x]++;
	ll now = 0;
	auto it = mp.begin();
	ll cntit = n;
	while (now < m0) {
		it = mp.begin();
		cntit = n;
		while (cntit < k0) {
			it--;
			cntit += it->second;
		}
		while (cntit - it->second >= k0) {
			cntit -= it->second;
			it++;
		}
		ll l = 0, r = m0 - now;
		while (l + 1 < r) {
			ll mid = (l + r) / 2;
			ll mn = del(-(k0 - cntit + it->second) * mid, it->second) + it->first;
			ll mx = del(-(k0 - cntit + it->second) * mid + it->second - 1, it->second) + it->first;
			auto jt = it, kt = it;
			kt++;
			bool ok = 0;
			if (kt != mp.end()) {
				ok |= (kt->first - mid <= mx);
			}
			if (jt != mp.begin()) {
				jt--;
				ok |= (jt->first >= mn);
			}
			if (ok) r = mid;
			else l = mid;
		}
		ll nowit = it->first;
		ll mn = del(-(k0 - cntit + it->second) * r, it->second) + it->first;
		ll mx = del(-(k0 - cntit + it->second) * r + it->second - 1, it->second) + it->first;
		ll cntmx = (it->first * it->second - (k0 - cntit + it->second) * r) - mn * it->second;
		map<ll, ll> nmp;
		nmp[mn] += it->second - cntmx;
		nmp[mx] += cntmx;
		for (auto p : mp) {
			if (p.first < it->first) nmp[p.first] += p.second;
			else if (p.first > it->first) {
				nmp[p.first - r] += p.second;
			}
		}
		mp.swap(nmp);
		now += r;
	}
	vector<ll> b;
	for (auto p : mp) {
		for (ll x = 0; x < p.second; x++) {
			b.push_back(p.first);
		}
	}
	for (ll x : b) cout << x << " ";
	cout << "\n";
	return 0;
}