#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <array>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()

ll del(ll a, ll b) {
	ll x = a / b;
	while (b * x > a) x--;
	return x;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m0, k0, q;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	sort(all(a));
	vector<ll> pra(n + 1, 0);
	for (ll i = 0; i < n; i++) pra[i + 1] = pra[i] + a[i];
	ll cnt = k0 * m0;
	vector<ll> b(n);
	for (ll i = n - 1; i >= 0; i--) {
		ll l = a[i] - m0 - 1, r = a[i];
		while (l + 1 < r) {
			ll mid = (l + r) / 2;
			ll u = lower_bound(all(a), mid) - a.begin();
			if (cnt >= (pra[i + 1] - pra[u]) - mid * (i + 1 - u)) r = mid;
			else l = mid;
		}
		b[i] = r;
		cnt -= a[i] - b[i];
	}
	for (ll x : b) cout << x << " ";
	cout << "\n";
	return 0;
}