//#ifdef ONLINE_JUDGE
#pragma GCC optimize("O3")
//#endif

#include <bits/stdc++.h>
//#include <random>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;
using ll = long long;

//template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

//int new_tnode(ll x, int tl, int tr, int l = 0, int r = 0);

//template<class T>
//struct TNode {
//    T x;
//    int tl, tr;
//    int l = 0;
//    int r = 0;
//    T def;
//    function<T(T, T)> sum;
//
//    TNode(T x, T def, function<T(T, T)> sum, int tl, int tr, int l = 0, int r = 0) :
//            x(x), def(def), sum(sum), tl(tl), tr(tr), l(l), r(r) {
//
//    }
//    // TNode() = default;
//    TNode get_l() const {
//        return l ? l : TNode<T>(def, tl, (tl + tr) / 2);
//    }
//    TNode get_r() const {
//        return r ? r : TNode<T>(def, (tl + tr) / 2, tr);
//    }
//
//    T get(int ll, int rr) {
//        if (tr <= ll || rr <= tl) return def;
//        if (ll <= tl && tr <= rr) return x;
//        return sum(get_l().get(ll, rr), get_r().get(ll, rr));
//    }
//
//    void insert(int i, T y) {
//        if (tl == i && i + 1 == tr) {
//            x = y;
//        }
//        int tm = (tl + tr) / 2;
//        if (i < tm) {
//            get_l().insert(i, y);
//        } else {
//            get_r().insert(i, y);
//        }
//        x = sum(get_l().x, get_r().x);
//    }
//
//};

//vector<TNode> tn(1);

//int new_tnode(ll x, int tl, int tr, int l, int r) {
//    tn.emplace_back(x, tl, tr, l, r);
//    return (int) tn.size() - 1;
//}

//template<class T>
//struct Tree {
//    TNode<T> root;
//    int n, N;
//    T def;
//    function<T(T, T)> sum;
//    Tree(int n, T def, function<T(T, T)> sum): n(n), def(def), sum(sum) {
//        int st = 0;
//        while ((1 << st) < n) ++st;
//        N = (1 << st);
//        root = TNode<T>(def, sum, 0, N);
//    }
//};

//#define int long long

int n, N;
vector<int> tree;
vector<int> lazy;

void push(int v) {
    if (v >= N) return;
    tree[v * 2] += lazy[v];
    lazy[v * 2] += lazy[v];
    tree[v * 2 + 1] += lazy[v];
    lazy[v * 2 + 1] += lazy[v];
    lazy[v] = 0;
}

int get(int i, int v, int tl, int tr) {
    int tm = (tl + tr) / 2;
    if (tl + 1 == tr) {
        return tree[v];
    }
    push(v);
    if (i < tm) {
        return get(i, v * 2, tl, tm);
    } else {
        return get(i, v * 2 + 1, tm, tr);
    }
}

int get(int i) {
    return get(i, 1, 0, N);
}

void add(int l, int r, int x, int v, int tl, int tr) {
    push(v);
    if (l >= tr || tl >= r) return;
    if (l <= tl && tr <= r) {
        tree[v] += x;
        lazy[v] += x;
        return;
    }
    int tm = (tl + tr) / 2;
    add(l, r, x, v * 2, tl, tm);
    add(l, r, x, v * 2 + 1, tm, tr);
}

void add(int l, int r) {
    add(l, r, -1, 1, 0, N);
}

void solve() {
    int m, k, q;
    cin >> n >> m >> k >> q;
    int st = 0;
    while ((1 << st) < n) ++st;
    N = (1 << st);
    tree.resize(2 * N);
    lazy.resize(2 * N);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    std::sort(a.rbegin(), a.rend());
    for (int i = 0; i < n; ++i) {
        tree[i + N] = a[i];
    }
//    map<int, pair<int, int>> mp;
//    for (int i = 0; i < n; ++i) {
//        if (mp.find(a[i]) == mp.end()) {
//            mp[a[i]] = {i, i};
//        } else {
//            mp[a[i]] = {mp[a[i]].first, i};
//        }
//    }
    for (int _ = 0; _ < m; ++_) {
        int i = k - 1;
        int c = get(i);
        int l = -1, r = i;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (get(m) == c) {
                r = m;
            } else {
                l = m;
            }
        }
        int st = r;
        l = i, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (get(m) == c) {
                l = m;
            } else {
                r = m;
            }
        }
//        for (int i = 0; i < n; ++i) {
//            cout << get(i) << ' ';
//        }
        cout << '\n';
        int end = l;
        add(0, st);
        int cnt = k - st;
        add(end - cnt + 1, end + 1);
    }
    for (int i = n - 1; i >= 0; --i) {
        cout << get(i) << ' ';
    }
}

signed main() {
//#ifdef ONLINE_JUDGE
    ios::sync_with_stdio(false);
cin.tie(nullptr);
//#endif
    int t = 1;
//    cin >> t;
    for (int test = 0; test < t; ++test) {
        solve();
        cout << '\n';
    }
   // cerr << clock() / 1000.0;
    return 0;
}
