#pragma GCC optimize("O3")
#include <bits/extc++.h>
using namespace std;
// using namespace __gnu_pbds;
using Int = long long;
using Uint = unsigned long long;
using Real = long double;
using Int128 = __int128;
using Uint128 = __uint128_t;
// #define _KOSHKA56692
#ifdef _KOSHKA56692
const int MAX = 1e8;
char mem[MAX];
int mempos = 0;
void *operator new(size_t sz) {
    void *res = mem + mempos;
    mempos += sz;
    return res;
}
void operator delete(void *) {}
void operator delete(void *, size_t) {}
#endif
/*
template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
*/
istream &operator>>(istream &in, Int128 &num) { Int R; in >> R; num = R; return in; }
ostream &operator<<(ostream &out, const Int128 &num) { out << Int(num); return out; }
istream &operator>>(istream &in, Uint128 &num) { Uint R; in >> R; num = R; return in; }
ostream &operator<<(ostream &out, const Uint128 &num) { out << Uint(num); return out; }

signed main() {
    ios::sync_with_stdio(false), cin.tie(0);
    cout.setf(ios::fixed), cout.precision(20);
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<pair<int, int>> arr(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].first;
        arr[i].second = -i;
    }
    priority_queue<pair<int, int>> st(arr.begin(), arr.end());
    for (int i = 0; i < m; ++i) {
        auto el = top();
        st.pop();
        st.insert({el.first - 1, el.second});
    }
    vector<int> rrr;
    for (auto el : st) {
        rrr.push_back(-el.first);
    }
    for (int x = 0; x < n; ++x) {
        cout << rrr[x] << '\n';
    }
   return 0;
}
