#include <bits/stdc++.h>

using namespace std;
typedef long long ll;


void solve() {
    ll n, m, k, q;
    cin >> n >> m >> k >> q;
    if (k != 1) cout << 1/0;
    vector<ll> a(n);
    for (auto & i : a) cin >> i;
    ll l = -1e18, r = 1e18;
    while (r - l > 1) {
        ll mid = (r + l) / 2;
        ll minused = 0;
        for (ll i = 0; i < n; ++i) {
            if (a[i] < mid) continue;
            minused += min(m, a[i] - mid);
        }
        if (minused > m * k) l = mid;
        else r = mid;
    }
    ll overload = -m * k;
    for (ll i = 0; i < n; ++i) {
        if (a[i] < l) continue;
        overload += min(m, a[i] - l);
    }
    vector<ll> answer(n);
    for (ll i = 0; i < n; ++i) {
        if (a[i] < l) answer[i] = a[i];
        else {
            if (a[i] > l + m) answer[i] = a[i] - m;
            else {
                answer[i] = l + (overload > 0);
                overload = max(0ll, overload - 1);
            }
        }
    }
    sort(answer.begin(), answer.end());
    for (auto i : answer) cout << i << " ";
    cout << "\n";
    
    sort(a.begin(), a.end());
    a.push_back(-1e12);
    ++n;
    vector<ll> pref(n, a[0]);
    for (ll i = 1; i < n; ++i) pref[i] = pref[i - 1] + a[i];
    vector<ll> preff(n, 0);
    for (ll i = 1; i < n; ++i) preff[i] = pref[i - 1] - (a[i] * i);
    while (q--) {
        ll t; cin >> t;
        if (t != 1) cout << 1/0;
        ll mj, kj, xj;
        cin >> mj >> kj >> xj;
        if (kj != 1) cout << 1/0;
        ll i = upper_bound(preff.begin(), preff.end(), mj) - preff.begin();
        ll mini = a[i] + (preff[i] - mj) / i;
        ll more = (preff[i] - mj) % i;
        --xj;
        if (xj < more) cout << mini + 1 << "\n";
        else if (xj < i) cout << mini << "\n";
        else cout << a[xj] << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) solve();
}
