#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, m0, k0, q;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector<ll> sa = arr;
	sort(sa.begin(), sa.end());
	vector<ll> psa(1, 0);
	for (ll i = 0; i < n; i++) {
		psa.push_back(psa.back() + sa[i]);
	}
	ll sc = m0 * k0;
	ll l = -1, r = n - 1;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		if (psa.back() - psa[mid + 1] - sa[mid] * (n - mid - 1) > sc) {
			l = mid;
		} else {
			r = mid;
		}
	}
	for (ll i = 0; i < n; i++) {
		if (i <= l) {
			cout << sa[i] << ' ';
		} else {
			ll ost = sc - (psa.back() - psa[r + 1] - sa[r] * (n - r - 1));
			ll nx = sa[r];
			nx -= ost / (n - r);
			ost %= n - r;
			if (i < r + ost) {
				cout << nx - 1 << ' ';
			} else {
				cout << nx << ' ';
			}
		}
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
