#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MINC = -2'000'000'001, MAXC = 1'000'000'000;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, m0, k0, q;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector<ll> sa = arr;
	sort(sa.begin(), sa.end());
	vector<ll> psa(1, 0);
	for (ll i = 0; i < n; i++) {
		psa.push_back(psa.back() + sa[i]);
	}
	ll sc = m0 * k0;
	ll l = MINC, r = MAXC;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		ll colbm = sa.end() - lower_bound(sa.begin(), sa.end(), mid + m0);
		ll colgood = sa.end() - lower_bound(sa.begin(), sa.end(), mid);
		if (psa[n - colbm] - psa[n - colgood] - mid * (colgood - colbm) + colbm * m0 > sc) {
			l = mid;
		} else {
			r = mid;
		}
	}
	ll colbm = sa.end() - lower_bound(sa.begin(), sa.end(), r + m0);
	ll colgood = sa.end() - lower_bound(sa.begin(), sa.end(), r);
	ll num = 0;
	for (ll i = 0; i < n; i++) {
		if (sa[i] < r) {
			cout << sa[i] << ' ';
		} else {
			ll ost = sc - (psa[n - colbm] - psa[n - colgood] - r * (colgood - colbm) + colbm * m0);
			if (num < ost) {
				cout << max(r - 1, sa[i] - m0) << ' ';
			} else {
				cout << max(r, sa[i] - m0) << ' ';
			}
			num++;
		}
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
