#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ld = long double;

// struct node {
//     int push;
//     int x, y;
//     node * L, R;
//     node(int _x) {
//         push = 0;
//         x = _x;
//         y = rng();
//         L = nullptr;
//         R = nullptr;
//     }
// };

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector <int> a(n);
    for (int i=0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    ll L = n - 1;
    for (; L >= 1 && (a[L] - a[L - 1]) * (n - L) <= m; --L) {
        m -= (a[L] - a[L - 1]) * (n - L);
    }
    for (int x=0; x < L; ++x) {
        cout << a[x] << " ";
    }
    ll e = a[L] - m / (n - L);
    m %= n - L;
    for (int x=L; x < L + m; ++x) {
        cout << e - 1 << " ";
    }
    for (int x=L + m; x < n; ++x) {
        cout << e << " ";
    }
    cout << "\n";
    while (q--) {
        int type;
        cin >> type;
        cin >> m >> k;
        int x;
        cin >> x;
        x--;
        L = n - 1;
        for (; L >= 1 && (a[L] - a[L - 1]) * (n - L) <= m; --L) {
            m -= (a[L] - a[L - 1]) * (n - L);
        }
        if (x < L) {
            cout << a[x] << "\n";
            continue;
        }
        ll e = a[L] - m / (n - L);
        m %= n - L;
        if (x < L + m) {
            cout << e - 1 << "\n";
        } else {
            cout << e << "\n";
        }
    }
    return 0;
}
