#include <bits/stdc++.h>
#define int long long

using namespace std;

int cnt(vector <int> arr, int n, int m) {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (arr[i] > m) {
            ans += (arr[i] - m);
        }
    }
    return ans;
}

void solve(vector <int> arr, n, m0, maxa) {
    int l = -1e10, r = maxa;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (cnt(arr, n, m) <= m0) {
            r = m;
        } else {
            l = m;
        }
    }
    int c = m0;
    for (int i = 0; i < n; ++i) {
        if (arr[i] > r) {
            c -= (arr[i] - r);
            arr[i] = r;
        }
    }
    sort(arr.begin(), arr.end());
    for (int i = n - 1; i >= n - c; --i) {
        arr[i]--;
    }
    sort(arr.begin(), arr.end());
    for (int x : arr) {
        cout << x  << " ";
    }
    cout << endl;
}

signed main() {
    int n, m0, k0, q;
    cin >> n >> m0 >> k0>> q;
    vector <int> arr(n);
    int maxa = -1e9;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        maxa = max(maxa, arr[i]);
    }
    solve(arr, n, m0, maxa);
    vector <int> suf(n + 1);
    suf[n] = 0;
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = suf[i + 1] + arr[i];
    }
    while (q--) {
        int mj, kj, ind;
        cin >> mj >> kj >> ind;
        int l = -1e10, r = maxa;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (arr[ind - 1] <= m) {
                r = m;
                continue;
            }
            if (suf[ind] - (m + 1) * (n - ind) + arr[ind - 1] - m <= mj) {
                r = m;
            } else {
                l = m;
            }
        }
        cout << r << endl;
    }
    return 0;
}
