#include <bits/stdc++.h>
#define ln << '\n'
#define int long long
using namespace std;

const int N = 2e5 + 22;
int n, m, k, q, a[N];
int lvl[N * 4], rvl[N * 4], otr_push[N * 4];

void build(int v, int l, int r) {
    int md = (l + r) >> 1;

    if (l == r) {
        lvl[v] = rvl[v] = a[l];
    } else {
        build(v + v, l, md);
        build(v + v + 1, md + 1, r);
        lvl[v] = lvl[v + v];
        rvl[v] = rvl[v + v + 1];
    }
}

void push(int v, int l, int r) {
    if (otr_push[v] != 0) {
        if (l != r) otr_push[v + v] += otr_push[v], lvl[v + v] += otr_push[v], rvl[v + v] += otr_push[v];
        if (l != r) otr_push[v + v + 1] += otr_push[v], lvl[v + v + 1] += otr_push[v], rvl[v + v + 1] += otr_push[v];
        otr_push[v] = 0;
    }
}

int get(int v, int l, int r, int ps) {
    push(v, l, r);
    if (l == r) return lvl[v];
    int md = (l + r) >> 1;
    if (ps <= md) return get(v + v, l, md, ps);
    return get(v + v + 1, md + 1, r, ps);
    // return a[ps];
}

void add(int v, int l, int r, int _l, int _r, int x) {
    push(v, l, r);
    if (_l > _r) return;
    if (l == _l && r == _r) {
        otr_push[v] += x;
        lvl[v] += x;
        rvl[v] += x;
        push(v, l, r);
        return;
    }

    int md = (l + r) >> 1;
    add(v + v, l, md, _l, min(_r, md), x);
    add(v + v + 1, md + 1, r, max(_l, md + 1), _r, x);
    lvl[v] = lvl[v + v];
    rvl[v] = rvl[v + v + 1];
    // for (int i = _l; i <= _r; i++) a[i] += x;
}

int find_leftest_ps(int v, int l, int r, int x) {
    push(v, l, r);
    int md = (l + r) >> 1;
    if (l == r) return l;
    if (rvl[v + v] >= x) return find_leftest_ps(v + v, l, md, x);
    return find_leftest_ps(v + v + 1, md + 1, r, x);
    // for (int i = 1; i <= n; i++)
    //     if (a[i] == x)
    //         return i;
}

int find_rightest_ps(int v, int l, int r, int x) {
    push(v, l, r);
    int md = (l + r) >> 1;
    if (l == r) return l;
    if (lvl[v + v + 1] <= x) return find_rightest_ps(v + v + 1, md + 1, r, x);
    return find_rightest_ps(v + v, l, md, x);
    // for (int i = n; i >= 1; i--)
    //     if (a[i] == x)
    //         return i;
}

int32_t main() {
    cin.tie(0); cout.tie(0); ios::sync_with_stdio(0);
    cin >> n >> m >> k >> q;
    for (int i = 1; i <= n; i++) cin >> a[i];
    sort(a + 1, a + n + 1);
    build(1, 1, n);
    for (int i = 1; i <= m; i++) {
        int L = n - k + 1;
        int R = n;

        int first_block = get(1, 1, n, L);
        int l = find_leftest_ps(1, 1, n, first_block);
        int r = find_rightest_ps(1, 1, n, first_block);

        int intersection = max(0ll, r - L + 1);
        add(1, 1, n, L + intersection, R, -1);
        add(1, 1, n, l, l + intersection - 1, -1);
    }
    for (int i = 1; i <= n; i++) cout << get(1, 1, n, i) << ' ';
    return 0;
}

/*
*/