#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
using namespace __gnu_pbds;
using ord_set = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, m, k, Q;
    cin >> n >> m >> k >> Q;
    vector<int> a(n);
    struct node{
        pair<int, int> a;
        node(int v, int i) {
            a = {v, i};
        }
        bool operator<(const node &other) const {
            if (a.first == other.a.first) {
                return a.second > other.a.second;
            }
            return a.first < other.a.first;
        }
    };
    priority_queue<node, vector<node>> q;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        q.push({a[i], i});
    }
    while (m--) {
        vector<node> b;
        int cnt = k;
        while (cnt--) {
            b.push_back(q.top());
            a[b.back().a.second]--;
            b.back().a.first--;
            q.pop();
        }
        for (auto u : b) {
            q.push(u);
        }
    }
    sort(a.begin(), a.end());
    for (int x : a) {
        cout << x << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
}
