#include <bits/stdc++.h>

using namespace std;
#define int long long
#define F first
#define S second

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    if (k != 1) {
        set<pair<int, int>> s;
        for (int i = 0; i < n; ++i) {
            s.insert({-a[i], i});
        }
        for (int i = 0; i < m; ++i) {
            vector<int> c;
            for (int j = 0; j < k; ++j) {
                auto [x, id] = *s.begin();
                s.erase(s.begin());
                c.push_back(id);
            }
            for (auto j: c) {
                a[j]--;
                s.insert({-a[j], j});
            }
        }
        sort(a.begin(), a.end());
        for (auto i: a) {
            cout << i << " ";
        }
    } else {

        int l = -1e9 - 7, r = 1e9 + 7;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int sum = 0;
            for (int i = 0; i < n; ++i) {
                if (a[i] > mid) {
                    sum += a[i] - mid;
                }
            }
            if (sum > m) {
                l = mid;
            } else {
                r = mid;
            }
        }

        for (int i = 0; i < n; ++i) {
            if (a[i] > r) {
                m -= a[i] - r;
                a[i] = r;
            }
        }

        sort(a.rbegin(), a.rend());
        for (int i = 0; i < m; ++i) {
            --a[i];
        }
        sort(a.begin(), a.end());
        for (auto i: a) {
            cout << i << " ";
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
