#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()
#define coutd cout << fixed << setprecision(20)

using namespace std;
using ll = long long;
using ld = long double;


int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    multiset<ll> b;
    for (ll x : a) b.insert(x);
    for (int i = 0; i < m; ++i)
    {
        vector<ll> d;
        auto it = (--b.end());
        int cnt = 0;
        while (true)
        {
            d.push_back(*it);
            --it;
            ++cnt;
            if (cnt == k) break;
        }
        for (ll x : d)
        {
            b.erase(b.find(x));
            b.insert(x - 1);
        }
    }
    for (ll x : b) cout << x << ' ';

    return 0;
}
