#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()
#define coutd cout << fixed << setprecision(20)

using namespace std;
using ll = long long;
using ld = long double;

const ll IINF = 2e9;

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    sort(all(a));
    ll l = -IINF, r = IINF;
    while (r - l > 1)
    {
        ll mid = (l + r) / 2;
        ll sum = 0;
        for (int i = 0; i < n; ++i)
        {
            if (a[i] >= mid)
            {
                sum += a[i] - mid;
            }
        }
        if (sum > m)
        {
            l = mid;
        } else
        {
            r = mid;
        }
    }
    ll sum = 0;
    for (int i = 0; i < n; ++i)
    {
        if (a[i] >= r)
        {
            sum += a[i] - r;
        }
    }
    int cntr = m - sum;
    for (ll x : a)
    {
        if (x < r)
        {
            cout << x << ' ';
        } else
        {
            if (cntr > 0)
            {
                cout << r - 1 << ' ';
                --cntr;
            } else
            {
                cout << r << ' ';
            }
        }
    }

    return 0;
}
