#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
#define db long double
#define MX LLONG_MAX
#define MN LLONG_MIN
#define gcd(a, b) __gcd(a, b)
#define lcm(a, b) (a / gcd(a, b) * b)

using namespace std;
using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

bool check(int x, int m, int k, const vector<int>& v, const int n) {
    int sum = 0;
    for (int i = 0; i < n; i++) {
        sum += max(0LL, v[i] - x);
    }

    return sum <= m * k;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m, k, q;
    cin >> n >> m >> k >> q;

    int mx = MN;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        mx = max(mx, v[i]);
    }

    int r = mx, l = mx - m;
    while (r - l > 1) {
        int mid = (l + r) / 2;

        if (check(mid, m, k, v, n)) {
            r = mid;
        } else {
            l = mid + 1;
        }
    }

    int x;
    if (check(r, m, k, v, n)) {
        x = r;
    } else {
        x = l;
    }

    int sum = 0;
    for (int i = 0; i < n; i++) {
        if (v[i] > x) {
            sum += v[i] - x;
            v[i] = x;
        }
    }

    sum = m * k - sum;
    sort(v.begin(), v.end());

    int ind = n - 1;
    while (sum--) {
        v[ind--]--;
    }

    sort(v.begin(), v.end());
    for (int i = 0; i < n; i++) {
        cout << v[i] << " ";
    }
}

/*
8 3 2 0
3 1 2 -1 0 2 -1 4
*/
