//#pragma GCC optimize("O3,unroll-loops")
#include <vector>
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define segl i*2+1, l, (r + l) / 2
#define segr i*2+2, (r + l) / 2, r

const long long MOD = 1e9 + 7;
const int maxn = 2e5 + 5;

template<typename T, typename K>
istream& operator>>(istream& a, pair<T, K>& b) {
    a >> b.first >> b.second;
    return a;
}

template<typename T>
istream& operator>>(istream& a, vector<T>& b) {
    for(auto&i : b)
        a >> i;
    return a;
}

template<typename T, typename K>
ostream& operator<<(ostream& a, pair<T, K>& b) {
    a << b.first << ' ' << b.second;
    return a;
}

template<typename T>
ostream& operator<<(ostream& a, vector<T>& b) {
    for(auto& i : b)
        a << i << ' ';
    return a;
}

/*
                               .
                              .#.
                             .z@z.
                            .z#@#z.
                           .z#@@@#z.
                          .z#@@@@@#z.
                            `^#@#^`
                              .@.
                              .@.
                            ._z@z_.
                        ._z@#^` `^#@z_.
                       @#^`         `^#@
                       @               @
                       @z_.         ._z@
                        `^#@z_.  ._z@#^`
                    ._z@#^` `^#@#^`  `^#@z_.
                ._z@#^`                    `^#@z_.
      ._z#z_. .@#^`                            `^#@.  ._z#z_.
    ._z###@@@#^`                                  `^#@@@@@###z_.
  ._z###@@@@@#^`                                  `^#@@@@@@###z_.
 ._z###@@@@@#^`                                    `^#@@@@@@@###z_.
.zz###@@###^^`                                      ``^^###@@@@@##zz..
 */

void stSolve(int n, int m, int k, int q) {
    vector<int> a(n);
    cin >> a;
    multiset<int> msk(a.begin(), a.end());
    for(int i = 0; i<m; ++i) {
        int nw = *(--msk.end()) - 1;
        msk.erase(--msk.end());
        msk.insert(nw);
    }
    for(auto v : msk) {
        cout << v << ' ';
    }
}

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    if(k != 1 || q != 0) {
        cout << -1;
        return;
    }
    if(n*m<=100000000) {
        stSolve(n, m, k, q);
        return;
    }
    vector<int> a(n);
    cin >> a;
    sort(a.begin(), a.end());
    vector<int> sum(n + 1, 0);
    for(int i = 0; i<n; ++i) {
        sum[i + 1] += sum[i];
        sum[i + 1] += a[i];
    }
    if(m == 0) {
        cout << a;
        return;
    }
    int l = -2e9 - 6, r = a[n-k];
    int trg = sum[n] - m*k;
    int sf = n;
    if(k == n) {
        sf = 0;
    } else {
        for (int i = n - 1; i >= n - k; --i) {
            if (a[i] - m >= a[n-k-1]) {
                sf = i;
            }
        }
    }
    while(r - l > 1) {
        int mg = (r + l) / 2;
        int cur = 0;
        int c = upper_bound(a.begin(), a.end(), mg) - a.begin();
        cur = sum[c] - sum[0] + mg*(sf - c) + (sum[n] - sum[sf] - (n-sf)*m); // <-- Source? Filmmaker
        //cout << mg << ' ' << cur << ' ' << trg << endl;
        if(cur > trg) {
            r = mg;
        } else {
            //cout << "Cur <= trg, setting " << mg << '\n';
            l = mg;
        }
    }

    int c = upper_bound(a.begin(), a.end(), l) - a.begin();
    //cout << trg << ' ' << (sum[c] - sum[0] + l*(sf - c) + (sum[n] - sum[sf] - (n-sf)*m)) << ' ' << l << '\n';
    int addition = trg - (sum[c] - sum[0] + l*(sf - c) + (sum[n] - sum[sf] - (n - sf)*m));
    if(addition > sf - c) {
        exit(228);
    }
    for(int i = sf; i<n; ++i) {
        a[i] -= m;
    }
    for(int i = c; i<sf; ++i) {
        a[i] = l;
    }
    for(int i = sf - 1; addition > 0 && i >= 0; --i, --addition) {
        a[i]++;
    }
    cout << a << '\n';

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
