#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll SZ = 5e5;

void solve() {
	ll n, m, k, q;
	cin >> n >> m >> k >> q;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) cin >> a[i];
	sort(all(a));
	bool f = true;
	for (ll i = n - 1; i > 0; i--) {
		if (m > (a[i] - a[i - 1]) * (n - i)) {
			m -= (a[i] - a[i - 1]) * (n - i);
		}
		else {
			f = false;
			a[i] -= m / (n - i);
			m %= (n - i);
			for (ll j = i + 1; j < n; j++) a[j] = a[i];
			break;
		}
	}
	if (f) {
		a[0] -= m / n;
		m %= n;
		for (ll j = 1; j < n; j++) a[j] = a[0];
	}
	priority_queue<ll> pq;
	for (ll i = 0; i < n; i++) pq.push(a[i]);
	for (ll i = 0; i < m; i++) {
		ll c = pq.top();
		c--;
		pq.pop();
		pq.push(c);
	}
	a = {};
	for (ll i = 0; i < n; i++) {
		a.push_back(pq.top());
		pq.pop();
	}
	sort(all(a));
	for (ll i = 0; i < n; i++) cout << a[i] << ' ';
	cout << '\n';
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}
