#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(X) (x).rbegin(), (x).rend()

void solve()
{
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;

    vector<ll> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    sort(all(a));
    vector<array<int, 3>> qs(n + q);
    for (int i = 0; i < n; i++)
        qs[i] = {m0, i, i};
    for (int i = 0; i < q; i++)
    {
        int t, m, k, x;
        cin >> t >> m >> k >> x;

        qs[n + i] = {m, x, n + i};
    }
    vector<ll> pref(n + 1);
    partial_sum(all(a), pref.begin() + 1);

    vector<int> ans(n + q);
    for (auto [m, x, id] : qs)
    {
        ll l = -1e10;
        ll r = 1e10;

        while (r - l > 1)
        {
            ll mid = (l + r) / 2;

            int i = upper_bound(all(a), mid) - a.begin();
            int cnt = i;
            ll d = max(0ll, (pref[n] - pref[i]) - (mid + 1) * (n - i));
            cnt += min(d, (ll)n - i);

            if (cnt >= x)
                r = mid;
            else
                l = mid;
        }
        ans[id] = r;
    }

    for (int i = 0; i < n; i++)
        cout << ans[i] << ' ';
    cout << '\n';
    for (int i = n; i < n + q; i++)
        cout << ans[i] << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("C:/work/Day 2/in.txt", "r", stdin);
    freopen("C:/work/Day 2/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}
