#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double

const int maxn = 2e5;
const int inf = 2e9;

const int LOG = 30;
const int N = 2e3;
const ld eps = 1e-12;

inline void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    for(int &i: a) cin >> i;

    sort(rall(a));
//    for(int i = n - 1; i > -1; i--) cout << a[i] << ' ';
//    cout << '\n';

    int l = -inf, r = a[0] + 1;
    while(l + 1 < r) {
        int mid = (l + r) / 2;

        int h = 0;
        for(int i = 0; i < n; i++) {
            h += max((int)0, a[i] - mid);
        }

        if(h >= m) {
            l = mid;
        } else {
            r = mid;
        }
    }

    int cur = 0;
    for(int i =0; i < n; i++) {
        cur += max((int)0, a[i] - l);
        a[i] = min(l, a[i]);
    }

    cur -= m;

    for(int i = 0; i < cur; i++) {
        a[i] += 1;
    }
    reverse(all(a));
    for(int i = 0; i < n; i++) {
        cout << a[i] << ' ';
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt = 1;
    //cin >> tt;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    while (tt--) {
        solve();
    }
    return 0;
}
