#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<class T>
using kekset = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

#define int int64_t
#define endl '\n'

void solve() {
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    for (int& x : a) cin >> x;
    set<pair<int, int>> st;
    for (int x = 1; x <= n; ++x) { // n * m * n * log n
        vector<int> ac = a;
        for (int i = 0; i < n; ++i) st.emplace(a[i], i);
        for (int rep = 0; rep < m0; ++rep) {
            auto [x, i] = *st.rbegin();
            ac[i]--;
            st.emplace(ac[i], i);
        }
        nth_element(ac.begin(), ac.begin() + x - 1, ac.end());
        cout << ac[x - 1] << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    //cin >> test;

    while (test--) {
        solve();
    }

    return 0;
}