#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

const int maxn = 200005;
int fenw[maxn];

void add(int i, int x) {
    for(; i < maxn; i += i & -i)
        fenw[i] += x;
}

int get(int i) {
    int res = 0;
    for (; i > 0; i -= i & -i)
        res += fenw[i];

    return res;
}

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    cin >> a;
    sort(a.begin(), a.end());

    for (int i = 0; i < n; i++) {
        add(i + 1, a[i]);
        add(i + 2, -a[i]);
    }

    while (m--) {
        int e = get(n - k + 1);
        int lx = 1, rx = n;
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (get(mx) >= e) rx = mx;
            else lx = mx + 1;
        }
        int pos1 = lx - 1;
        lx = 1, rx = n + 1;
        while (lx < rx) {
            int mx = lx + (rx - lx) / 2;
            if (get(mx) > e) rx = mx;
            else lx = mx + 1;
        }
        int pos2 = lx - 1;
        int cnt = n - pos2;
        int left = k - cnt;
        add(pos1 + 1, -1);
        add(pos1 + left + 1, 1);

        add(pos2 + 1, -1);
    }

    for (int i = 1; i <= n; i++) {
        cout << get(i) << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}
