#include <bits/stdc++.h>
using namespace std;
#define int long long
//#pragma GCC optimize("O3,unroll-loops")

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

const int maxn = 200005;
int fenw[maxn];

void add(int i, int x) {
    for(; i < maxn; i += i & -i)
        fenw[i] += x;
}

int get(int i) {
    int res = 0;
    for (; i > 0; i -= i & -i)
        res += fenw[i];

    return res;
}

int a[maxn];
int pref[maxn];

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    sort(a + 1, a + n + 1);

    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i];
    }

    auto find = [&](int m, int x) {
        int lx = -1e10;
        int rx = a[n];

        while (lx <= rx) {
            int mx = lx + (rx - lx) / 2;
            int pos = upper_bound(a + 1, a + n + 1, mx) - a;
            int cur = pref[n] - pref[pos - 1] - mx * (n - pos + 1);
            int left = m - cur;
            if (left < 0) {
                lx = mx + 1;
                continue;
            }

            pos = lower_bound(a + 1, a + n + 1, mx) - a;
            int cnt = n - pos + 1;
            if (cnt < left) {
                rx = mx - 1;
                continue;
            }

            if (x < pos)
                return a[x];

            if (x < pos + left) {
                return mx - 1;
            }

            return mx;
        }
        exit(-1);
    };

    for (int i = 1; i <= n; i++) {
        cout << find(m, i) << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}
