#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;

int main(int, char**) {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n, m, k, q;
    cin >> n >> m >> k >> q;
    assert(q == 0);
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());

    // for (ll i = 0; i < n; ++i) {
    //     cerr << a[i] << " ";
    // }
    // cerr << endl;

    ll L = -1e9 - 1;
    ll R = 1e9 + 1;
    while (R - L > 1) {
        ll M = (L + R) / 2;
        vector<ll> b = a;
        ll cnt = 0;
        for (ll i = n - 1; i >= 0; --i) {
            if (b[i] < M) continue;
            cnt += min(m, b[i] - M);
            b[i] -= min(m, b[i] - M);
        }
        if (cnt >= m * k) {
            L = M;
        } else {
            R = M;
        }
    }
    ll cnt = 0;
    vector<ll> b = a;
    for (ll i = n - 1; i >= 0; --i) {
        if (b[i] <= L) continue;
        cnt += min(m, b[i] - L);
        b[i] -= min(m, b[i] - L);
    }
    sort(b.begin(), b.end());
    ll danger = lower_bound(a.begin(), a.end(), L) - a.begin();
    ll it = danger;
    while (cnt > m * k) {
        b[it++]++;
        cnt--;
    }
    sort(b.begin(), b.end());
    for (ll i = 0; i < n; ++i) {
        cout << b[i] << " ";
    }
    cout << endl;


    return 0;
}
