#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define ld long double
#define F first
#define S second
mt19937 rnd(100);

vector<ll> pref;

ll sum(ll l, ll r) {
    return pref[r] - pref[l];
}

const ll inf = 4'000'000'000'000'000'000ll;

vector<ll> solve(vector<ll> arr, ll k, ll m) {
    ll n = arr.size();
    pref.resize(n + 1);
    for (int i = 0; i < n; ++i)
        pref[i + 1] = pref[i] + arr[i];

    ll can = m, dop;
    ll l = -inf, r = inf, mid;
    while (r - l > 1) {
        mid = (r + l) / 2;
        ll l1 = -1, r1 = n, mid1;
        while (r1 - l1 > 1) {
            mid1 = (r1 + l1) / 2;
            if (arr[mid1] <= mid)
                l1 = mid1;
            else
                r1 = mid1;
        }

        ll need = sum(r1, n) - mid * (n - r1);
        if (need > can)
            l = mid;
        else
            r = mid, dop = can - need;
    }

    ll will = r;
    auto arr1 = arr;
    for (int i = 0; i < n; ++i) {
        if (!dop)
            arr1[i] = min(arr1[i], will);
        else {
            if (arr1[i] > will - 1) {
                dop--;
                arr1[i] = will - 1;
            }
        }
    }

    /*
    cout << '\n';
    while (q--) {
        cin >> t;
        if (t == 1) {
            cin >> m >> k >> x, x--; // Иксовая порядковая статистика при m вычитаниях по k

            ll can = m, dop;
            ll l = -inf, r = inf, mid;
            while (r - l > 1) {
                mid = (r + l) / 2;
                ll l1 = -1, r1 = n, mid1;
                while (r1 - l1 > 1) {
                    mid1 = (r1 + l1) / 2;
                    if (arr[mid1] <= mid)
                        l1 = mid1;
                    else
                        r1 = mid1;
                }

                ll need = sum(r1, n) - mid * (n - r1);
                if (need > can)
                    l = mid;
                else
                    r = mid, dop = can - need;
            }

            ll will = r;

            l = -1, r = n;
            while (r - l > 1) {
                mid = (r + l) / 2;
                if (arr[mid] <= will - 1)
                    l = mid;
                else
                    r = mid;
            }

            if (x <= l)
                cout << arr[x] << '\n';
            else
                cout << will - (x <= l + dop) << '\n';
        } else
            exit(-1);
    }*/

    return arr1;
}

void gen(vector<ll> &arr, ll &m, ll &k) {
    arr.resize(rnd() % 12 + 2);
    for (ll &i: arr)
        i = rnd() % 20 - 10;

    k = 1;
    m = rnd() % 20;
    sort(arr.begin(), arr.end());
}

vector<ll> correct(vector<ll> arr, ll k, ll m) {
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < k; ++j)
            arr[arr.size() - j - 1]--;

        sort(arr.begin(), arr.end());
    }

    return arr;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, m, k, q, t, x;
    vector<ll> arr;


    cin >> n >> m >> k >> q;
    if (q != 0)
        exit(-1);

    arr.resize(n);
    pref.resize(n + 1);
    for (int i = 0; i < n; ++i)
        cin >> arr[i];

    sort(arr.begin(), arr.end());
    auto arr1 = solve(arr, k, m);
    for (ll i: arr1)
        cout << i << ' ';

    return 0;


    ll _ = 1;
    while (cout << (_++) << endl) {
        gen(arr, m, k);

        auto my = solve(arr, k, m);
        auto need = correct(arr, k, m);
        if (my != need) {
            cout << "\n\n\n" << arr.size() << ' ' << m << ' ' << k << ' ' << 0 << '\n';
            for (ll i: arr)
                cout << i << ' ';

            cout << "\n\n\n";
            for (ll i: my)
                cout << i << ' ';

            cout << '\n';
            for (ll i: need)
                cout << i << ' ';
            cout << "\n";
            return 0;
        }
    }
}

/*
2 9 1 0
0 2


*/
/*

*/
/*

*/
/*

*/
/*

*/
/*


*/
/*


*/