#include <bits/stdc++.h>

using namespace std;

constexpr int maxn = 5e3 + 5;

int dp[maxn][maxn];

int l_a[maxn], v_a[maxn];

int l_b[maxn], v_b[maxn];

int nxt_a[maxn][maxn];

int nxt_b[maxn][maxn];

void solve() {
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    for (int i = 0; i < n; ++i) {
        cin >> l_a[i] >> v_a[i];
        v_a[i]--;
    }
    for (int i = 0; i < m; ++i) {
        cin >> l_b[i] >> v_b[i];
        v_b[i]--;
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j < k; ++j) {
            nxt_a[i][j] = n;
        }
        for (int j = i; j < n; ++j) {
            nxt_a[i][v_a[j]] = min(nxt_a[i][v_a[j]], j);
        }
    }
    for (int i = 0; i <= m; ++i) {
        for (int j = 0; j < k; ++j) {
            nxt_b[i][j] = m;
        }
        for (int j = i; j < m; ++j) {
            nxt_b[i][v_b[j]] = min(nxt_b[i][v_b[j]], j);
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (v_a[i] != v_b[j]) {
                continue;
            }
            vector<int> inds_a = {i}, inds_b = {j};
            while (nxt_a[inds_a.back() + 1][v_a[i]] != n) {
                inds_a.push_back(nxt_a[inds_a.back() + 1][v_a[i]]);
            }
            while (nxt_b[inds_b.back() + 1][v_a[i]] != m) {
                inds_b.push_back(nxt_b[inds_b.back() + 1][v_a[i]]);
            }
            int x = 0, y = 0;
            int pos_i = 0, pos_j = 0;
            int ord = 0;
            while (pos_i < (int)inds_a.size() && pos_j < (int)inds_b.size()) {
                int i_nw = inds_a[pos_i], j_nw = inds_b[pos_j];
                if (ord == 0) {
                    for (int v = 0; v < k; ++v) {
                        if (v != v_a[i] && nxt_a[i_nw + 1][v] != n && nxt_b[j_nw + 1][v] != m && !dp[nxt_a[i_nw + 1][v]][nxt_b[j_nw + 1][v]]) {
                            dp[i][j] = 1;
                            break;
                        }
                    }
                    if (dp[i][j]) {
                        break;
                    }
                } else {
                    bool check = true;
                    for (int v = 0; v < k; ++v) {
                        if (v != v_a[i] && nxt_a[i_nw + 1][v] != n && nxt_b[j_nw + 1][v] != m && !dp[nxt_a[i_nw + 1][v]][nxt_b[j_nw + 1][v]]) {
                            check = false;
                            break;
                        }
                    }
                    if (!check) {
                        break;
                    }
                }
                int len = min(l_a[i_nw] - x, l_b[j_nw] - y);
                if ((pos_i + 1 == (int)inds_a.size() && x + len == l_a[i_nw]) || (pos_j + 1 == (int)inds_b.size() && y + len == l_b[j_nw])) {
                    if (ord == 0) {
                        if (len % 2 == 0) {
                            dp[i][j] = 1;
                        }
                    } else {
                        if (len % 2 == 1) {
                            dp[i][j] = 1;
                        }
                    }
                    break;
                } else {
                    if (len % 2 == 1) {
                        ord ^= 1;
                    }
                    x += len;
                    if (x == l_a[i_nw]) {
                        x = 0;
                        pos_i++;
                    }
                    y += len;
                    if (y == l_b[j_nw]) {
                        y = 0;
                        pos_j++;
                    }
                }
            }
        }
    }
    while (q--) {
        int x, y;
        cin >> x >> y;
        int i = 0, j = 0;
        while (l_a[i] <= x) {
            x -= l_a[i];
            i++;
        }
        while (l_b[j] <= y) {
            y -= l_b[j];
            j++;
        }
        int ans = 0;
        for (int v = 0; v < k; ++v) {
            if (v != v_a[i] && nxt_a[i][v] != n && nxt_b[j][v] != m && !dp[nxt_a[i][v]][nxt_b[j][v]]) {
                ans = 1;
            }
        }
        if (!ans) {
            vector<int> inds_a = {i}, inds_b = {j};
            while (nxt_a[inds_a.back() + 1][v_a[i]] != n) {
                inds_a.push_back(nxt_a[inds_a.back() + 1][v_a[i]]);
            }
            while (nxt_b[inds_b.back() + 1][v_a[i]] != m) {
                inds_b.push_back(nxt_b[inds_b.back() + 1][v_a[i]]);
            }
            int pos_i = 0, pos_j = 0;
            int ord = 1;
            while (pos_i < (int)inds_a.size() && pos_j < (int)inds_b.size()) {
                int i_nw = inds_a[pos_i], j_nw = inds_b[pos_j];
                if (ord == 0) {
                    for (int v = 0; v < k; ++v) {
                        if (v != v_a[i] && nxt_a[i_nw + 1][v] != n && nxt_b[j_nw + 1][v] != m && !dp[nxt_a[i_nw + 1][v]][nxt_b[j_nw + 1][v]]) {
                            ans = 1;
                            break;
                        }
                    }
                    if (ans) {
                        break;
                    }
                } else {
                    bool check = true;
                    for (int v = 0; v < k; ++v) {
                        if (v != v_a[i] && nxt_a[i_nw + 1][v] != n && nxt_b[j_nw + 1][v] != m && !dp[nxt_a[i_nw + 1][v]][nxt_b[j_nw + 1][v]]) {
                            check = false;
                            break;
                        }
                    }
                    if (!check) {
                        break;
                    }
                }
                int len = min(l_a[i_nw] - x, l_b[j_nw] - y);
                if ((pos_i + 1 == (int)inds_a.size() && x + len == l_a[i_nw]) || (pos_j + 1 == (int)inds_b.size() && y + len == l_b[j_nw])) {
                    if (ord == 0) {
                        if (len % 2 == 0) {
                            ans = 1;
                        }
                    } else {
                        if (len % 2 == 1) {
                            ans = 1;
                        }
                    }
                    break;
                } else {
                    if (len % 2 == 1) {
                        ord ^= 1;
                    }
                    x += len;
                    if (x == l_a[i_nw]) {
                        x = 0;
                        pos_i++;
                    }
                    y += len;
                    if (y == l_b[j_nw]) {
                        y = 0;
                        pos_j++;
                    }
                }
            }
        }
        if (ans) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
