#include <bits/stdc++.h>

using namespace std;

constexpr int maxn = 1605;

int dp[maxn][maxn];

int dp_fast[maxn][maxn];

int cnt[maxn][maxn];

int l_a[maxn], v_a[maxn];

int l_b[maxn], v_b[maxn];

int pr_sum_a[maxn];

int pr_sum_b[maxn];

int pr_sum_color_a[maxn];

int pr_sum_color_b[maxn];

int nxt_a[maxn][maxn];

int nxt_b[maxn][maxn];

constexpr int maxq = 1e6 + 6;

pair<int, int> xy[maxq];

int ans[maxq];

vector<int> qs[maxn][maxn];

void solve() {
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    for (int i = 0; i < n; ++i) {
        cin >> l_a[i] >> v_a[i];
        pr_sum_a[i + 1] = pr_sum_a[i] + l_a[i];
        v_a[i]--;
    }
    for (int i = 0; i < m; ++i) {
        cin >> l_b[i] >> v_b[i];
        pr_sum_b[i + 1] = pr_sum_b[i] + l_b[i];
        v_b[i]--;
    }
    vector<int> cnt_a(k);
    for (int i = 0; i < n; ++i) {
        pr_sum_color_a[i] = cnt_a[v_a[i]];
        cnt_a[v_a[i]] += l_a[i];
    }
    vector<int> cnt_b(k);
    for (int i = 0; i < m; ++i) {
        pr_sum_color_b[i] = cnt_b[v_b[i]];
        cnt_b[v_b[i]] += l_b[i];
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j < k; ++j) {
            nxt_a[i][j] = n;
        }
        for (int j = i; j < n; ++j) {
            nxt_a[i][v_a[j]] = min(nxt_a[i][v_a[j]], j);
        }
    }
    for (int i = 0; i <= m; ++i) {
        for (int j = 0; j < k; ++j) {
            nxt_b[i][j] = m;
        }
        for (int j = i; j < m; ++j) {
            nxt_b[i][v_b[j]] = min(nxt_b[i][v_b[j]], j);
        }
    }
    for (int iq = 0; iq < q; ++iq) {
        int x, y;
        cin >> x >> y;
        int i = upper_bound(pr_sum_a, pr_sum_a + n + 1, x) - pr_sum_a - 1;
        int j = upper_bound(pr_sum_b, pr_sum_b + m + 1, y) - pr_sum_b - 1;
        x -= pr_sum_a[i];
        y -= pr_sum_b[j];
        xy[iq] = make_pair(x, y);
        qs[i][j].push_back(iq);
    }
    auto check_move = [&](int i, int j, int v) -> bool {
        return nxt_a[i + 1][v] != n && nxt_b[j + 1][v] != m && !dp[nxt_a[i + 1][v]][nxt_b[j + 1][v]];
    };
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (j == m - 1) {
                cnt[i][j] = 0;
            } else {
                cnt[i][j] = cnt[i][j + 1];
                if (check_move(i, j + 1, v_b[j + 1])) {
                    cnt[i][j]--;
                }
                if (check_move(i, j, v_b[j + 1])) {
                    cnt[i][j]++;
                }
            }
            if (v_a[i] != v_b[j]) {
                continue;
            }
            if (cnt[i][j] > 1 || (cnt[i][j] == 1 && !check_move(i, j, v_a[i]))) {
                dp_fast[i][j] = 1;
                dp[i][j] = 1;
            } else {
                int ic = n, jc = m;
                for (int i2 = i; i2 < n; ++i2) {
                    for (int j2 = j; j2 < m; ++j2) {
                        if (dp_fast[i2][j2] && v_a[i2] == v_a[i]) {
                            int vl1 = pr_sum_color_a[i] - pr_sum_color_b[j];
                            int vl2 = pr_sum_color_a[i2] - pr_sum_color_b[j2];
                            if (vl1 < vl2 + l_a[i2] && vl1 > vl2 - l_b[j2]) {
                                if (ic > i2 || (ic == i2 && jc > j2)) {
                                    ic = i2;
                                    jc = j2;
                                }
                            }
                        }
                    }
                }
                if (ic == n || jc == m) {
                    int len = min(cnt_a[v_a[i]] - pr_sum_color_a[i], cnt_b[v_a[i]] - pr_sum_color_b[j]);
                    if (len % 2 == 0) {
                        dp[i][j] = 1;
                    }
                } else {
                    int len = max(pr_sum_color_a[ic] - pr_sum_color_a[i], pr_sum_color_b[jc] - pr_sum_color_b[j]);
                    if (len % 2 == 0) {
                        dp[i][j] = 1;
                    }
                }
            }
            for (auto iq : qs[i][j]) {
                if (dp_fast[i][j]) {
                    ans[iq] = 1;
                } else {
                    auto [x, y] = xy[iq];
                    int ic = n, jc = m;
                    for (int i2 = i; i2 < n; ++i2) {
                        for (int j2 = j; j2 < m; ++j2) {
                            if (dp_fast[i2][j2] && v_a[i2] == v_a[i]) {
                                int vl1 = pr_sum_color_a[i] - pr_sum_color_b[j] + x - y;
                                int vl2 = pr_sum_color_a[i2] - pr_sum_color_b[j2];
                                if (vl1 < vl2 + l_a[i2] && vl1 > vl2 - l_b[j2]) {
                                    if (ic > i2 || (ic == i2 && jc > j2)) {
                                        ic = i2;
                                        jc = j2;
                                    }
                                }
                            }
                        }
                    }
                    if (ic == n || jc == m) {
                        int len = min(cnt_a[v_a[i]] - pr_sum_color_a[i] - x, cnt_b[v_a[i]] - pr_sum_color_b[j] - y);
                        if (len % 2 == 1) {
                            ans[iq] = 1;
                        }
                    } else {
                        int len = max(pr_sum_color_a[ic] - pr_sum_color_a[i] - x, pr_sum_color_b[jc] - pr_sum_color_b[j] - y);
                        if (len % 2 == 1) {
                            ans[iq] = 1;
                        }
                    }
                }
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        if (ans[i]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
