#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int N, n, M, m, k, q;
	cin >> N >> n >> M >> m >> k >> q;
	vector<int> a, b;
	for (int i = 0; i < n; ++i) {
		int l, x;
		cin >> l >> x;
		for (int j = 0; j < l; ++j) {
			a.push_back(x);
		}
	}
	for (int i = 0; i < m; ++i) {
		int l, x;
		cin >> l >> x;
		for (int j = 0; j < l; ++j) {
			b.push_back(x);
		}
	}
	vector<vector<int>> dp(N + 2, vector<int> (M + 2));
	for (int i = 0; i <= M + 1; ++i) {
		dp[N + 1][i] = 1;
	}
	for (int j = 0; j <= N + 1; ++j) {
		dp[j][M + 1] = 1;
	}
	vector<vector<int>> nta(N + 1, vector<int> (k+1, N)), ntb(M + 1, vector<int> (k+1, M));
	for (int i = N - 1; i >= 0; --i) {
		nta[i] = nta[i + 1];
		nta[i][a[i]] = i;
	}
	for (int i = M - 1; i >= 0; --i) {
		ntb[i] = ntb[i + 1];	
		ntb[i][b[i]] = i;
	}
	for (int i = N - 1; i >= 0; --i) {
		for (int j = M - 1; j >= 0; --j) {
			dp[i][j] = dp[i + 1][j + 1];
			if (a[i] != b[j]) {
				dp[i][j] -= dp[nta[i + 1][a[i]] + 1][ntb[j + 1][a[i]] + 1] == 0;
				dp[i][j] += dp[nta[i][a[i]] + 1][ntb[j + 1][a[i]] + 1] == 0;
				dp[i][j] -= dp[nta[i + 1][b[j]] + 1][ntb[j + 1][b[j]] + 1] == 0;
				dp[i][j] += dp[nta[i][b[j]] + 1][ntb[j][b[j]] + 1] == 0;
			}
			else {
				dp[i][j] += dp[i + 1][j + 1] == 0;
				dp[i][j] -= dp[nta[i + 1][a[i]] + 1][ntb[j + 1][b[j]] + 1] == 0;
			}
		}
	}
	for (int i = 0; i < q; ++i) {
		int x, y;
		cin >> x >> y;
		if (dp[x][y] > 0) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}

	return 0;
}
