#include <bits/stdc++.h>

using namespace std;
#define int long long

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<int> la(n), lb(m), va(n), vb(m), pa(n), pb(m);
    for (int i = 0; i < n; i++)
        cin >> la[i] >> va[i];
    for (int i = 0; i < m; i++)
        cin >> lb[i] >> vb[i];
    for (int i = 0; i < n; i++)
        pa[i] = (i > 0 ? pa[i - 1] : 0) + la[i];
    for (int i = 0; i < m; i++)
        pb[i] = (i > 0 ? pb[i - 1] : 0) + lb[i];
    bool dp[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            dp[i][j] = false;
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (i + 1 < n && j + 1 < m && dp[i + 1][j + 1])
                dp[i][j] = true;
            if (va[i] != vb[j]) {
                if ((i + 1 < n && dp[i + 1][j]) || (j + 1 < m && dp[i][j + 1]))
                    dp[i][j] = true;
            } else {
                bool good = i + 1 < n && j + 1 < m && dp[i + 1][j + 1];
                if (good || min(va[i], vb[j]) % 2 == 1)
                    dp[i][j] = true;
            }
        }
    }
    for (int i = 0; i < q; i++) {
        int x, y;
        cin >> x >> y;
        int l = -1, r = n - 1, i1, i2;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (pa[mid] < x) l = mid;
            else r = mid;
        }
        i1 = r, l = -1, r = m - 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (pb[mid] < y) l = mid;
            else r = mid;
        }
        i2 = r;
        bool good = false;
        int c1 = pa[i1] - x, c2 = pb[i2] - y;
        if (va[i1] == vb[i2]) {
            if ((i1 + 1 < n && i2 + 1 < m && dp[i1 + 1][i2 + 1]) || min(c1, c2) % 2 == 1)
                good = true;
        } else {
            if (i1 + 1 < n && i2 + 1 < m && dp[i1 + 1][i2 + 1])
                good = true;
            for (int j = i2 + 1; j < m; j++) {
                if (va[i1] == vb[j]) {
                    if ((i1 + 1 < n && j + 1 < m && dp[i1 + 1][j + 1]) || min(c1, vb[j]) % 2 == 1)
                        good = true;
                    break;
                }
            }
            for (int j = i1 + 1; j < n; j++) {
                if (va[j] == vb[i2]) {
                    if ((j + 1 < n && i2 + 1 < m && dp[j + 1][i2 + 1]) || min(va[j], c2) % 2 == 1)
                        good = true;
                    break;
                }
            }
        }
        cout << (good ? "Yes\n" : "No\n");
    }
    return 0;
}