#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
using namespace std;
using ll = long long;
using ld = long double;
const ll INF = 1e18;


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int N, M, n, m, k, q;
	cin >> N >> n >> M >> m >> k >> q;
	vector<int> a(N), b(M);
	vector<int> va(n), vb(m), la(n), lb(m);
	int i = 0;
	for (int _ = 0; _ < n; ++_) {
		int l, v;
		cin >> l >> v;
		va[_] = v;
		la[_] = l;
		for (int j = 0; j < l; ++j) {
			a[i] = v;
			i++;
		}
	}
	i = 0;
	
	for (int _ = 0; _ < m; ++_) {
		int l, v;
		cin >> l >> v;
		vb[_] = v;
		lb[_] = l;
		for (int j = 0; j < l; ++j) {
			b[i] = v;
			i++;
		}
	}
	vector<vector<bool>> dp(n + 1, vector<bool>(m + 1, false));
	vector<vector<bool>> dp1(n + 1, vector<bool>(m + 1, false));
	for (int i = n - 1; i >= 0; --i) {
		vector<int> ind_a(k + 1, -1);
		for (int pos = i; pos < n; ++pos) {
			if (ind_a[va[pos]] == -1)
				ind_a[va[pos]] = pos;
		}
		vector<int> ind_b(k + 1, -1);
		vector<int> cnt(k + 1, 0);
		int all_cnt = 0;
		for (int j = m - 1; j >= 0; --j) {
			
			if (va[i] == vb[j]) {
				dp[i][j] = (all_cnt > 0);
				dp1[i][j] = (all_cnt > 0);
				if (!dp[i][j]) {
					int len = min(la[i], lb[j]);
					if (len % 2 == 1)
						dp[i][j] = true;
				}
			}
			if (ind_b[vb[j]] == -1) {
				if (ind_a[vb[j]] != -1 && !dp[ind_a[vb[j]] + 1][j + 1]) {
					all_cnt++;
					cnt[vb[j]]++;
				}
				ind_b[vb[j]] = j;
			}
			else {
				all_cnt -= cnt[vb[j]];
				cnt[vb[j]] = 0;
				if (ind_a[vb[j]] != -1 && !dp[ind_a[vb[j]] + 1][j + 1]) {
					all_cnt++;
					cnt[vb[j]]++;
				}
				ind_b[vb[j]] = j;
			}
		}
	}
	//cout << dp1[0][0] << "\n";
	vector<int> prefa(n), prefb(m);
	prefa[0] = la[0]; prefb[0] = lb[0];
	for (int i = 1; i < n; ++i) {
		prefa[i] = prefa[i - 1] + la[i];
	}
	for (int i = 1; i < m; ++i) {
		prefb[i] = prefb[i - 1] + lb[i];
	}
	//cout << dp[N - 1][M - 1];
	for (int _ = 0; _ < q; ++_) {
		int x, y;
		cin >> x >> y;
		int i = distance(prefa.begin(), lower_bound(prefa.begin(), prefa.end(), x + 1));
		int j = distance(prefb.begin(), lower_bound(prefb.begin(), prefb.end(), y + 1));
		int leni = prefa[i] - x;
		int lenj = prefb[j] - y;
		if (dp1[i][j]) {
			cout << "Yes\n";
		}
		else {
			cout << i << " " << j << " " << leni << " " << lenj << "\n";
			if (min(leni, lenj) % 2 == 1) cout << "Yes\n";
			else cout << "No\n";
		}
	}

	return 0;
}