#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

// #define int long long

template <typename T>
using ordered_set =
    tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)((x).size()))

using ll = long long;
using ld = long double;

const ll INF = 3e18;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<int> a, b;
    vector<vector<int>> nxta(N + 1, vector<int>(k, N));
    vector<vector<int>> nxtb(M + 1, vector<int>(k, M));
    for (int i = 0; i < n; ++i) {
        int l, v;
        cin >> l >> v;
        --v;
        for (int j = 0; j < l; ++j) {
            a.push_back(v);
        }
    }
     for (int i = 0; i < m; ++i) {
        int l, v;
        cin >> l >> v;
        --v;
        for (int j = 0; j < l; ++j) {
            b.push_back(v);
        }
    }
    for (int i = N - 1; ~i; --i) {
        nxta[i] = nxta[i + 1];
        nxta[i][a[i]] = i;
    }
    for (int i = M - 1; ~i; --i) {
        nxtb[i] = nxtb[i + 1];
        nxtb[i][b[i]] = i;
    }
    vector<vector<bool>> dp(N + 1, vector<bool>(M + 1));
    for (int i = N - 1; ~i; --i) {
        for (int j = M - 1; ~j; --j) {
            for (int t = i; t < N; ++t) {
                int val = a[t];
                if (nxta[i][val] < N && nxtb[j][val] < M && !dp[nxta[i][val] + 1][nxtb[j][val] + 1]) {
                    dp[i][j] = true;
                }
            }
            for (int t = j; t < M; ++t) {
                int val = b[t];
                if (nxta[i][val] < N && nxtb[j][val] < M && !dp[nxta[i][val] + 1][nxtb[j][val] + 1]) {
                    dp[i][j] = true;
                }
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        int x, y;
        cin >> x >> y;
        if (dp[x][y]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
#ifdef LOCALEGOR
    freopen("INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}