#include <bits/extc++.h>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int k, q;
    vector<int> n(2), N(2);
    cin >> N[0] >> n[0] >> N[1] >> n[1] >> k >> q;
    vector<vector<int>> a(2);
    vector<int> all;
    for (int t = 0; t < 2; t++) {
        for (int i = 0; i < n[t]; i++) {
            int l, v;
            cin >> l >> v;
            while (l--) {
                a[t].push_back(v);
            }
            all.push_back(v);
        }
    }
    {
        sort(all.begin(), all.end());
        all.resize(unique(all.begin(), all.end()) - all.begin());
        for (int t = 0; t < 2; t++) {
            for (int i = 0; i < N[t]; i++) {
                a[t][i] = (int)(lower_bound(all.begin(), all.end(), a[t][i]) - all.begin());
            }
        }
        k = (int)all.size();
    }
    vector jump(2, vector<vector<int>>(k));
    for (int t = 0; t < 2; t++) {
        for (int c = 0; c < k; c++) {
            jump[t][c].resize(N[t] + 1);
        }
    }
    for (int t = 0; t < 2; t++) {
        vector<int> last(k, -1);
        for (int i = N[t] - 1; i >= 0; i--) {
            for (int c = 0; c < k; c++) {
                jump[t][c][i] = last[c];
            }
            last[a[t][i]] = i;
        }
        for (int c = 0; c < k; c++) {
            jump[t][c][N[t]] = last[c];
        }
    }
    vector dp(N[0], vector<int>(N[1]));
    for (int i = N[0] - 1; i >= 0; i--) {
        for (int j = N[1] - 1; j >= 0; j--) {
            if (a[0][i] != a[1][j]) {
                continue;
            }
            for (int c = 0; c < k; c++) {
                int ii = jump[0][c][i];
                int jj = jump[1][c][j];
                if (ii != -1 && jj != -1 && !dp[ii][jj]) {
                    dp[i][j] = 1;
                    break;
                }
            }
        }
    }
    while (q--) {
        int x, y;
        cin >> x >> y;
        x = (x == 0 ? N[0] : x - 1);
        y = (y == 0 ? N[1] : y - 1);
        bool win = false;
        for (int c = 0; c < k; c++) {
            int ii = jump[0][c][x];
            int jj = jump[1][c][y];
            if (ii != -1 && jj != -1 && !dp[ii][jj]) {
                win = true;
                break;
            }
        }
        cout << (win ? "Yes" : "No") << '\n';
    }
    return 0;
}
/*

5 1 5 1 1 9
5 1
5 1
0 0
0 1
0 2
1 0
1 1
1 2
2 0
2 1
2 2
2 1

 */