#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rand1(ll a, ll b) {
    return uniform_int_distribution<ll> (a, b) (gen);
}

void solve() {
    ll n, nc, m, mc, k, q;
    cin >> n >> nc >> m >> mc >> k >> q;
    vector<ll> a, b;
    for (ll i = 0; i < nc; i++) {
        ll len, x;
        cin >> len >> x;
        for (ll j = 0; j < len; j++) a.push_back(x);
    }
    for (ll i = 0; i < mc; i++) {
        ll len, x;
        cin >> len >> x;
        for (ll j = 0; j < len; j++) b.push_back(x);
    }
    vector<vector<ll>> dp(n + 1, vector<ll> (m + 1, 0));
    vector<ll> nxta(k + 1, n);
    for (ll i = n - 1; i >= 0; i--) {
        vector<ll> nxtb(k + 1, m);
        for (ll j = m - 1; j >= 0; j--) {
            if (a[i] != b[j]) {
                dp[i][j] = 0;
                continue;
            }
            dp[i][j] = 1 - dp[nxta[a[i]]][nxtb[b[j]]];
            nxtb[b[j]] = j;
        }
        nxta[a[i]] = i;
    }
    while (q--) {
        ll x, y;
        cin >> x >> y;
        cout << ((dp[x][y]) ? "Yes" : "No") << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t12 = 1;
//    cin >> t12;
    while (t12--) {
        solve();
        cout << '\n';
    }
    return 0;
}