#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

#define ll long long

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, n1, m, m1, k, q;
    cin >> n >> n1 >> m >> m1 >> k >> q;
    vector<ll> a;
    for (ll i = 0; i < n1; i++) {
        ll k1, x;
        cin >> k1 >> x;
        while (k1--) {
            a.push_back(x);
        }
    }
    vector<ll> b;
    for (ll i = 0; i < m1; i++) {
        ll k1, x;
        cin >> k1 >> x;
        while (k1--) {
            b.push_back(x);
        }
    }
    vector<vector<ll>> ind1(k + 1);
    for (ll i = 0; i < a.size(); i++) {
        ind1[a[i]].push_back(i);
    }
    vector<vector<ll>> ind2(k + 1);
    for (ll i = 0; i < b.size(); i++) {
        ind2[b[i]].push_back(i);
    }
    vector<vector<bool>> dp(n, vector<bool>(m));
    for (ll i1 = n - 1; i1 >= 0; i1--) {
        for (ll j1 = m - 1; j1 >= 0; j1--) {
            ll f = 0;
            for (ll i = 0; i <= k; i++) {
                auto it1 = lower_bound(ind1[i].begin(), ind1[i].end(), i1);
                auto it2 = lower_bound(ind2[i].begin(), ind2[i].end(), j1);
                if (it1 == ind1[i].end() || it2 == ind2[i].end()) {
                    continue;
                }
                ll x1 = *it1 + 1;
                ll y1 = *it2 + 1;
                if (x1 >= a.size() || y1 >= b.size()) {
                    f = 1;
                    break;
                }
                if (!dp[x1][y1]) {
                    f = 1;
                    break;
                }
            }
            if (f == 1) {
                dp[i1][j1] = true;
            }
        }
    }
    while (q--) {
        ll x, y;
        cin >> x >> y;
        if (dp[x][y]) {
            cout << "Yes" << '\n';
        } else {
            cout << "No" << '\n';
        }
    }
}