#include <bits/stdc++.h>

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using namespace std;

const int maxN = 5010;

int N, n, M, m, k, q, dp[maxN][maxN];
vector<int> a, b;

int solve(int i, int j) {
    if (dp[i][j] != -1) {
        return dp[i][j];
    }
    if (i >= N || j >= M) {
        return dp[i][j] = 0;
    }
    dp[i][j] = 0;
    for (int c = 1; c <= k; c++) {
        int ni = i, nj = j;
        while (ni < N && a[ni] != c) {
            ni++;
        }
        while (nj < M && b[nj] != c) {
            nj++;
        }
        if (ni < N && nj < M) {
            dp[i][j] |= !solve(ni + 1, nj + 1);
        }
    }
    return dp[i][j];
}

void solve_case() {
    cin >> N >> n >> M >> m >> k >> q;
    for (int i = 0; i < n; i++) {
        int l, v; cin >> l >> v;
        for (int j = 0; j < l; j++) {
            a.push_back(v);
        }
    }
    for (int i = 0; i < m; i++) {
        int l, v; cin >> l >> v;
        for (int j = 0; j < l; j++) {
            b.push_back(v);
        }
    }
    memset(dp, -1, sizeof dp);
    while (q--) {
        int x, y; cin >> x >> y;
        cout << (solve(x, y) ? "Yes" : "No") << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve_case();
    }
}