#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int inf = 1e9;

signed main()
{
    int nn, n, mm, m, k, q;
    cin >> n >> nn >> m >> mm >> k >> q;
    vector<int> a, b;
    for(int i = 0; i < nn; ++i){
        int l, v;
        cin >> l >> v;
        for(int j = 0; j < l; ++j)
            a.push_back(v - 1);
    }
    for(int i = 0; i < mm; ++i){
        int l, v;
        cin >> l >> v;
        for(int j = 0; j < l; ++j)
            b.push_back(v - 1);
    }
    vector<vector<int>> na(n + 1), nb(m + 1);
    for(int i = n; i >= 0; --i){
        na[i].resize(k);
        if(i == n) for(int j = 0; j < k; ++j) na[i][j] = inf;
        else{
            for(int j = 0; j < k; ++j){
                if(j == a[i]) na[i][j] = i + 1;
                else na[i][j] = na[i + 1][j];
            }
        }
    }
    for(int i = m; i >= 0; --i){
        nb[i].resize(k);
        if(i == m) for(int j = 0; j < k; ++j) nb[i][j] = inf;
        else{
            for(int j = 0; j < k; ++j){
                if(j == b[i]) nb[i][j] = i + 1;
                else nb[i][j] = nb[i + 1][j];
            }
        }
    }
    vector<vector<bool>> dp;
    dp.resize(n + 1);
    for(int i = 0; i <= n; ++i){
        dp[i].resize(m + 1);
    }
    for(int i = n; i >= 0; --i) for(int j = m; j >= 0; --j){
        for(int c = 0; c < k; ++c){
            if(na[i][c] < inf && nb[j][c] < inf && !dp[na[i][c]][nb[j][c]]){
                dp[i][j] = 1;
                break;
            }
        }
    }
    for(int i = 0; i < q; ++i){
        int x, y;
        cin >> x >> y;
        if(dp[x][y]) cout << "Yes" << endl;
        else cout << "No" << endl;
    }
}