#ifdef ONPC
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;


mt19937_64 rng(chrono::steady_clock().now().time_since_epoch().count());

const int MAXN = 5050;

int a[MAXN], b[MAXN];
int apos = 0, bpos = 0;

int nxta[MAXN][MAXN], nxtb[MAXN][MAXN];

int dp[MAXN][MAXN][2];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;

    for (int i = 0; i < n; i++) {
        int l, v;
        cin >> l >> v;
        for (int j = 0; j < l; j++) a[++apos] = v;
    }
    for (int i = 0; i < m; i++) {
        int l, v;
        cin >> l >> v;
        for (int j = 0; j < l; j++) b[++bpos] = v;
    }

    for (int i = 1; i <= k; i++) nxta[N + 1][i] = N + 1;
    for (int i = N; i >= 1; i--) {
        for (int j = 1; j <= k; j++) nxta[i][j] = nxta[i + 1][j];
        nxta[i][a[i]] = i;
    }
    for (int i = 1; i <= k; i++) nxtb[M + 1][i] = M + 1;
    for (int i = M; i >= 1; i--) {
        for (int j = 1; j <= k; j++) nxtb[i][j] = nxtb[i + 1][j];
        nxtb[i][b[i]] = i;
    }

    for (int i = N + 1; i >= 1; i--) {
        for (int j = M + 1; j >= 1; j--) {
            if (i == N + 1 || j == M + 1) {
                dp[i][j][0] = dp[i][j][1] = 0;
                continue;
            }

            if (a[i] != b[j]) {
                int nb = nxtb[j][a[i]];
                if (nb != M + 1) dp[i][j][0] = dp[i][nb][0];

                int na = nxta[i][b[j]];
                if (na != N + 1) dp[i][j][1] = dp[na][j][1];
            } else {
                if (!dp[i + 1][j + 1][1]) dp[i][j][0] = 1;
                if (!dp[i + 1][j + 1][0]) dp[i][j][1] = 1;
            }
        }
    }

    for (int i = 0; i < q; i++) {
        int x, y;
        cin >> x >> y;
        cout << (dp[x + 1][y + 1][0] ? "Yes\n" : "No\n");
    }

    return 0;
}
