#include<bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 331, INF = 1e9 + 7;

vector<int> a;
vector<int> b;

unordered_map<int, int> nxta[MAXN];
unordered_map<int, int> nxtb[MAXN];
unordered_set<int> all;

int was[MAXN][MAXN];
int res[MAXN][MAXN];
int N, n, M, m, k, q;

void solve(int ida, int idb){
    if(was[ida][idb]) return;
    was[ida][idb] = 1;
    if(ida == N || idb == M){
        res[ida][idb] = 0;
        return;
    }
    bool has_lose = 0;
    for(auto x : all){
        int nwa = nxta[ida][x]+1;
        int nwb = nxtb[idb][x]+1;
        if(nwa >= INF || nwb >= INF) continue;
        solve(nwa, nwb);
        if(!res[nwa][nwb]){
            has_lose = 1;
            break;
        }
    }
    res[ida][idb] = has_lose;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> N >> n >> M >> m >> k >> q;
    for(int i = 0; i < n; i++){
        int l, v;
        cin >> l >> v;
        all.insert(v);
        while(l--) a.push_back(v);
    }
    for(int i = 0; i < m; i++){
        int l, v;
        cin >> l >> v;
        all.insert(v);
        while(l--) b.push_back(v);
    }
    for(int i = 0; i < N; i++){
        for(auto x : all){
            nxta[i][x] = INF;
        }
        for(int j = i; j < N; j++){
            nxta[i][a[j]] = min(nxta[i][a[j]], j);
        }
    }
    for(int i = 0; i < M; i++){
        for(auto x : all){
            nxtb[i][x] = INF;
        }
        for(int j = i; j < M; j++){
            nxtb[i][b[j]] = min(nxtb[i][b[j]], j);
        }
    }
    for(int i = 0; i < N; i++){
        for(int j = 0; j < M; j++){
            if(!was[i][j]) solve(i, j);
            //cout << i << " " << j << res[i][j] << "\n";
        }
    }
    while(q--){
        int l, r;
        cin >> l >> r;
        if(res[l][r]) cout << "Yes\n";
        else cout << "No\n";
    }
}
