#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define db long double

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int k;
vector<int> a, b;
vector<vector<int>> pos1, pos2;
vector<unordered_map<int, bool>> dp;

bool rec(int i, int j) {
    if (dp[i].find(j) != dp[i].end()) return dp[i][j];

    dp[i][j] = false;
    for (int val = 1; val <= k; ++val) {
        int p1 = lower_bound(pos1[val].begin(), pos1[val].end(), i) - pos1[val].begin();
        int p2 = lower_bound(pos2[val].begin(), pos2[val].end(), j) - pos2[val].begin();

        if (p1 < pos1[val].size() && p2 < pos2[val].size()) {
            int x = pos1[val][p1] + 1;
            int y = pos2[val][p2] + 1;

            if (!rec(x, y)) {
                return dp[i][j] = true;
            }
        }
    }

    return false;
}

void solve() {
    int N, n, M, m, q; cin >> N >> n >> M >> m >> k >> q;

    for (int i = 0; i < n; ++i) {
        int l, v; cin >> l >> v;

        while (l--) a.push_back(v);
    }

    for (int i = 0; i < m; ++i) {
        int l, v; cin >> l >> v;

        while (l--) b.push_back(v);
    }

    pos1.resize(k + 1), pos2.resize(k + 1);
    for (int i = 0; i < N; ++i) {
        pos1[a[i]].push_back(i);
    }

    for (int i = 0; i < M; ++i) {
        pos2[b[i]].push_back(i);
    }

    dp.resize(N + 1);
    for (int i = 0; i < q; ++i) {
        int x, y; cin >> x >> y;

        if (rec(x, y)) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}