// #pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

// #pragma GCC target("sse4.2,bmi,bmi2,popcnt,lzcnt,avx2")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef __int128_t d128;
typedef int dgt;
typedef pair<dgt, dgt> pdd;
const dgt MOD = 1e9 + 7;
const dgt INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;
const ld EPS = 1e-9;

// typedef tree<dgt, null_type, less<dgt>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define all(x) x.begin(), x.end()

template<typename T1, typename T2>
istream& operator >> (istream&, pair<T1, T2>&);

template<typename T1, typename T2>
ostream& operator << (ostream&, const pair<T1, T2>&);

template<typename T>
istream& operator >> (istream& is, vector<T>& arr) {
    for (T& el: arr)
        is >> el;
    return is;
}

template<typename T>
ostream& operator << (ostream& os, const vector<T>& arr) {
    for (const T& el: arr)
        os << el << ' ';
    return os;
}

template<typename T1, typename T2>
istream& operator >> (istream& is, pair<T1, T2>& pr) {
    return is >> pr.first >> pr.second;
}

template<typename T1, typename T2>
ostream& operator << (ostream& os, const pair<T1, T2>& pr) {
    return os << pr.first << ' ' << pr.second;
}


void solve() {
    dgt N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<dgt> a, b;
    for (dgt i = 0; i < n; ++i) {
        dgt l, v;
        cin >> l >> v;
        for (; l > 0; --l, a.push_back(v));
    }
    for (dgt i = 0; i < m; ++i) {
        dgt l, v;
        cin >> l >> v;
        for (; l > 0; --l, b.push_back(v));
    }
    vector<vector<bool>> ans(N + 1, vector<bool>(M + 1, true));
    ans[N].assign(M + 1, false);
    for (dgt i = 0; i <= N; ++i)
        ans[i][M] = false;
    vector<dgt> pos_y(k + 1, -1);
    for (dgt y = M - 1; y >= 0; --y) {
        pos_y[b[y]] = y;
        vector<dgt> pos_x(k + 1, -1);
        set<dgt> zer;
        dgt cnt = 0;
        for (dgt x = N - 1; x >= 0; --x) {
            pos_x[a[x]] = x;
            zer.erase(a[x]);
            if (pos_y[a[x]] != -1 && !ans[pos_x[a[x]] + 1][pos_y[a[x]] + 1])
                zer.insert(a[x]);
            ans[x][y] = (zer.size() > 0);
        }
    }
    for (; q > 0; --q) {
        dgt x, y;
        cin >> x >> y;
        if (ans[x][y])
            cout << "Yes\n";
        else
            cout << "No\n";
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int reps = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif

    for (int i = 0; i < reps; ++i) {
#ifdef LOCAL
        cout << "Test case #" << i << " ===========================\n";
#endif
        solve();
#ifdef LOCAL
        cout << "End test ===============================\n";
#endif
    }

    return 0;
}

// g++ -std=c++23 -Wall -Wextra -Wshadow -O2 -DLOCAL -D_GLIBCXX_DEBUG -D_GLIBCXX_DEBUG_PEDANTIC -fsanitize=address,undefined
