//#pragma GCC optimize("O3, Ofast, unroll-loops, inline, no-stack-protector")
#include <bits/stdc++.h>
//#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using pii = pair<int, int>;

vector<vector<int>> dp;
vector<int> a, b;
vector<vector<int>> ax, bx;
int cnt;

int gen(int ptr1, int ptr2) {
    if (ptr1 >= a.size() || ptr2 >= b.size()) return 0;
    if (dp[ptr1][ptr2] != -1) return dp[ptr1][ptr2];
    dp[ptr1][ptr2] = 0;
    for (int i = 0; i < cnt; ++i) {
        int ida = std::lower_bound(ax[i].begin(), ax[i].end(), ptr1) - ax[i].begin();
        if (ida == ax[i].size()) continue;
        int xa = ax[i][ida];
        int idb = std::lower_bound(bx[i].begin(), bx[i].end(), ptr2) - bx[i].begin();
        if (idb == bx[i].size()) continue;
        int xb = bx[i][idb];
        if (gen(xa + 1, xb + 1) == 0) {
            return dp[ptr1][ptr2] = 1;
        }
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    a.resize(N);
    b.resize(M);
    dp.resize(N, vector<int> (M, -1));
    vector<int> c;
    int ptr = 0;
    for (int i = 0; i < n; ++i) {
        int l, v;
        cin >> l >> v;
        c.push_back(v);
        for (int j = 0; j < l; ++j) {
            a[ptr] = v;
            ++ptr;
        }
    }
    ptr = 0;
    for (int i = 0; i < m; ++i) {
        int l, v;
        cin >> l >> v;
        c.push_back(v);
        for (int j = 0; j < l; ++j) {
            b[ptr] = v;
            ++ptr;
        }
    }
    std::sort(c.begin(), c.end());
    c.resize(std::unique(c.begin(), c.end()) - c.begin());
    unordered_map<int, int> mp;
    for (int i = 0; i < c.size(); ++i) {
        mp[c[i]] = i;
    }
    cnt = c.size();
    for (int i = 0; i < N; ++i) a[i] = mp[a[i]];
    for (int i = 0; i < M; ++i) b[i] = mp[b[i]];
    ax.resize(cnt);
    bx.resize(cnt);
    for (int i = 0; i < N; ++i) {
        ax[a[i]].push_back(i);
    }
    for (int i = 0; i < M; ++i) {
        bx[b[i]].push_back(i);
    }
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < M; ++j) {
            if (dp[i][j] == -1) gen(i, j);
        }
    }
    while (q --> 0) {
        int x, y;
        cin >> x >> y;
        if (dp[x][y]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}
