#ifndef LOCAL
#pragma GCC optimize("O3")
#endif

#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
const ll nMax = 5010;
bool dp[nMax][nMax];
int nxt1[nMax], nxt2[nMax];
bool canMove[nMax];
bool ans[nMax][nMax];
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    ll N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<int> a, b;
    int l1,l2;
    int tmp;
    cin >> l1 >> tmp;

    for(int i = 0; l1 && i < 600;i++){
        a.push_back(1);
        l1--;
    }

    for (int i = 0; i < n-1; i++) {
        int l, v;
        cin >> l >> v;
        for (int i = 0; i < l; i++)a.push_back(v);
    }
    cin >> l2 >> tmp;
    for(int i = 0; l2 && i < 600;i++){
        b.push_back(1);
        l2--;
    }
    for (int i = 0; i < m-1; i++) {
        int l, v;
        cin >> l >> v;
        for (int i = 0; i < l; i++)b.push_back(v);
    }
    memset(nxt1, -1, sizeof nxt1);
    set<int>  lose;
    for (int j = a.size() - 1; j >= 0; j--) {
        lose.clear();
        int num = a[j];
        memset(nxt2, -1, sizeof nxt2);
        for (int i = b.size() - 1; i >= 0; i--) {
            if (a[j] != b[i]) {
                lose.erase(b[i]);
                if((nxt1[b[i]] != -1 && !dp[nxt1[b[i]]][i]))lose.insert(b[i]);
                nxt2[b[i]]=i;
                continue;
            }
            if(lose.size())ans[j][i]=true;
            if(lose.size() || (nxt1[num] != -1 && nxt2[num] != -1 && !dp[nxt1[num]][nxt2[num]]))
                dp[j][i] = 1;
            else ans[j][i] = 1;
            nxt2[num]=i;
        }
        nxt1[a[j]] = j;
    }

    for(int i = 0; i < q; i++){
        int l,r;
        cin >> l >> r;
        if(l>=l1 && r >=l2){
            cout << (ans[l-l1][r-l2]? "Yes" : "No")<< '\n';
            continue;
        }
        bool inv = false;
        if(l <l1 && r < l2){
            int dist = min(l1-l,l2-r);
            l+=dist;
            r+=dist;
            inv = dist % 2;
        }
        l = max(l,l1);
        r = max(r,l2);
        cout << (ans[l-l1][r-l2]^inv ? "Yes" : "No") << '\n';
    }
}