#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) int((x).size())
using ld = long double;
using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;

void solve();

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
int N, n, M, m, k, q;
vector<pii> a, b;
vector<int> A, B;

int closest_a(int i, int x) {
    for (int j = i; j < N; j++) {
        if (A[j] == x) {
            return j;
        }
    }
    return N;
};

int closest_b(int i, int x) {
    for (int j = i; j < M; j++) {
        if (B[j] == x) {
            return j;
        }
    }
    return M;
};

#define MAX_MEMO 3000
int memo[MAX_MEMO][MAX_MEMO];
bool dp(int la, int lb) {
    if (la == N) return false;
    if (lb == M) return false;
    if (memo[la][lb] != -1) return memo[la][lb];
    if (A[la] == B[lb]) {
        return memo[la][lb] = !dp(la + 1, lb + 1);
    }
    else {
        return memo[la][lb] = dp(la + 1, lb) || dp(la, lb + 1);
    }
}

void solve() {
    for (int i = 0; i < MAX_MEMO; i++) {
        fill(memo[i], memo[i] + MAX_MEMO, -1);
    }
    cin >> N >> n >> M >> m >> k >> q;
    for (int i = 0; i < n; i++) {
        int l, v;
        cin >> l >> v;
        a.push_back({l, v});
        while (l--) {
            A.push_back(v);
        }
    }
    for (int i = 0; i < n; i++) {
        int l, v;
        cin >> l >> v;
        b.push_back({l, v});
        while (l--) {
            B.push_back(v);
        }
    }
    while (q--) {
        int x, y;
        cin >> x >> y;
        if (dp(x, y)) {
            cout << "Yes\n";
        }
        else {
            cout << "No\n";
        }
    }
}