#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<map>
#include<set>
#include<bitset>
#include<algorithm>

using namespace std;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int N, n, M, m, k, q;
	cin >> N >> n >> M >> m >> k >> q;
	vector<int> a;
	vector<int> b;
	for (int i = 0; i < n; ++i) {
		int l, v;
		cin >> l >> v;
		for (int j = 0; j < l; ++j) {
			a.push_back(v);
		}
	}
	for (int i = 0; i < m; ++i) {
		int l, v;
		cin >> l >> v;
		for (int j = 0; j < l; ++j) {
			b.push_back(v);
		}
	}
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	vector<vector<int>> dp(N + 1, vector<int>(M + 1));
	for (int i = 1; i <= N; ++i) {
		for (int j = 1; j <= M; ++j) {
			dp[i][j] = max(max(dp[i - 1][j], dp[i][j - 1]), dp[i - 1][j - 1] + (a[i - 1] == b[j - 1]));
		}
	}
	for (int i = 0; i < q; ++i) {
		int x, y;
		cin >> x >> y;
		if (dp[N - x][M - y] % 2) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
	return 0;
}