#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <random>
#include <chrono>
using namespace std;
typedef int ll;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll N, n, M, m, k, q;
	cin >> N >> n >> M >> m >> k >> q;
	vector<ll> l1(n), v1(n), l2(m), v2(m), a, b;
	for (ll i = 0; i < n; ++i) {
		cin >> l1[i] >> v1[i];
		--v1[i];
		for (ll j = 0; j < l1[i]; ++j) a.push_back(v1[i]);
	}
	for (ll i = 0; i < m; ++i) {
		cin >> l2[i] >> v2[i];
		--v2[i];
		for (ll j = 0; j < l2[i]; ++j) b.push_back(v2[i]);
	}
	vector<vector<ll>> r1(N + 1, vector<ll>(k, N)), r2(M + 1, vector<ll>(k, M));
	for (ll i = N - 1; i >= 0; --i) {
		r1[i] = r1[i + 1];
		r1[i][a[i]] = i;
	}
	for (ll i = M - 1; i >= 0; --i) {
		r2[i] = r2[i + 1];
		r2[i][b[i]] = i;
	}
	vector<vector<ll>> dp(N + 1, vector<ll>(M + 1, 0));
	for (ll i = N - 1; i >= 0; --i) {
		for (ll j = M - 1; j >= 0; --j) {
			for (ll l = 0; l < k; ++l) {
				if (r1[i][l] == N || r2[j][l] == M) continue;
				if (dp[r1[i][l] + 1][r2[j][l] + 1] == 0) dp[i][j] = 1;
			}
		}
	}
	while (q--) {
		ll x, y;
		cin >> x >> y;
		if (dp[x][y]) cout << "Yes\n";
		else cout << "No\n";
	}
	cout << endl;
	return 0;
}