#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define int long long
constexpr int INF = 1e18;
constexpr int MOD = 1e9 + 7;
//mt19937_64 rnd(0);

void solve() {
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<int> a(N);
    int ia = 0;
    vector<int> b(M);
    int ib = 0;
    for (int i = 0; i < n; ++i) {
        int l, v;
        cin >> l >> v;
        v--;
        for (int j = 0; j < l; ++j) {
            a[ia] = v;
            ia++;
        }
    }
    for (int i = 0; i < m; ++i) {
        int l, v;
        cin >> l >> v;
        v--;
        for (int j = 0; j < l; ++j) {
            b[ib] = v;
            ib++;
        }
    }

    vector<int> nxta(k, N), nxtb(k, M);
    vector<vector<bool>> win(N, vector<bool> (M, true));
    vector<vector<int>> cnt(N, vector<int>(M, INF));
    
    for (int i = 0; i < N; ++i) {
        win[i][M - 1] = true;
        cnt[i][M - 1] = 1;
    }
    for (int i = 0; i < M; ++i) {
        win[N - 1][i] = true;
        cnt[N - 1][i] = 1;
    }
    nxta[a[N - 1]] = N - 1;
    for (int i = N - 2; i >= 0; --i) {
        nxtb.assign(k, M);
        nxtb[b[M - 1]] = M - 1;
        for (int j = M - 2; j >= 0; --j) {
            bool fl = true;
            int c1 = INF, c2 = INF;
            for (int u = 0; u < k; ++u) {
                if (nxta[u] != N && nxtb[u] != M && win[nxta[u]][nxtb[u]]) {
                    fl = false;
                    c1 = min(c1, cnt[nxta[u]][nxtb[u]]);
                }
                if (nxta[u] != N && nxtb[u] != M) {
                    c2 = min(c2, cnt[nxta[u]][nxtb[u]]);
                }
            }
            win[i][j] = fl;
            if (!fl) {
                cnt[i][j] = c1 + 1;
            } else {
                cnt[i][j] = c2 + 1;
            }
            nxtb[b[j]] = j;
        }
        nxta[a[i]] = i;
    }
    for (int i = 0; i < q; ++i) {
        cin >> ia >> ib;
        if (win[ia][ib]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
#ifdef MULTY
    cin >> t;
#endif
    while (t--) {
        solve();
    }

    return 0;
}