#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
using ll = long long;
using ull = unsigned long long;

template<class T>
bool chmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool chmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

mt19937 rnd(1337);

constexpr int inf = 1e18;

void solve() {
    int n, ln, m, lm, k, q;
    cin >> n >> ln >> m >> lm >> k >> q;
    vector<int> a, b;
    for (int i = 0, l, x; i < ln; ++i) {
        cin >> l >> x;
        --x;
        while (l--)
            a.push_back(x);
    }
    for (int i = 0, l, x; i < lm; ++i) {
        cin >> l >> x;
        --x;
        while (l--)
            b.push_back(x);
    }
//    int n, m, k, q;
//    cin >> n >> m >> k >> q;
//    vector<int> a(n);
//    for (int &i : a)
//        cin >> i, --i;
//    vector<int> b(m);
//    for (int &i : b)
//        cin >> i, --i;
    vector<vector<int>> an(n + 1), bn(m + 1);
    vector<int> next(k, n);
    for (int i = n - 1; i >= 0; --i) {
        an[i + 1] = next;
        next[a[i]] = i;
    }
    an[0] = next;
    next.assign(k, m);
    for (int i = m - 1; i >= 0; --i) {
        bn[i + 1] = next;
        next[b[i]] = i;
    }
    bn[0] = next;
    map<pair<int, int>, int> mp;
    for (int i = n - 1; i >= 0; --i)
        for (int j = m - 1; j >= 0; --j) {
            bool f = true;
            for (int z = 0; f && z < k; ++z)
                if (an[i + 1][z] < n && bn[j + 1][z] < m)
                    f &= mp[{an[i + 1][z], bn[j + 1][z]}];
            mp[{i, j}] = !f;
        }
    while (q--) {
        int x, y;
        cin >> x >> y;
        bool f = false;
        for (int z = 0; z < k; ++z)
            if (an[x][z] < n && bn[y][z] < m)
                f |= !mp[{an[x][z], bn[y][z]}];
        cout << (f ? "Yes" : "No") << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
//     cin >> t;
    while (t--) solve();
//    cerr << fixed << setprecision(10) << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
}
