#include <iostream>
#include <vector>

void solve()
{
    int N, n, M, m, k, q;
    std::cin >> N >> n >> M >> m >> k >> q;
    std::vector<int> a;
    for (int i = 0; i < n; ++i) {
        int l, v;
        std::cin >> l >> v;
        for (int j = 0; j < l; ++j)
            a.push_back(v);
    }
    std::vector<int> b;
    for (int i = 0; i < m; ++i) {
        int l, v;
        std::cin >> l >> v;
        for (int j = 0; j < l; ++j)
            b.push_back(v);
    }
    std::vector<std::vector<char>> dp(N + 2, std::vector<char>(M + 2, 1));
    int cnt = 0;
    std::vector<int> nxta(k + 1, N + 1);
    for (int i = N; i >= 0; --i) {
        std::vector<int> nxtb(k + 1, M + 1);
        for (int j = M; j >= 0; --j) {
            dp[i][j] = cnt != 0;
            if (j != 0) {
                cnt -= 1 - dp[nxta[b[j - 1]]][nxtb[b[j - 1]]];
                nxtb[b[j - 1]] = j;
                cnt += 1 - dp[nxta[b[j - 1]]][nxtb[b[j - 1]]];
            }
        }
        if (i != 0)
            nxta[a[i - 1]] = i;
        cnt = 0;
    }
    for (; q > 0; --q) {
        int x, y;
        std::cin >> x >> y;
        if (dp[x][y])
            std::cout << "Yes\n";
        else
            std::cout << "No\n";
    }
}

int main()
{
    int t = 1;
#ifdef LOCAL
    freopen("stream/ina.txt", "r", stdin);
    freopen("stream/outa.txt", "w", stdout);
    std::cin >> t;
#else
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#endif
    for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
        solve();
    }
    std::cout.flush();
    return 0;
}