#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<random>
#include<chrono>
#include<set>
#include<deque>
//#define int long long
#define ll long long
#define ld long double
using namespace std;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

void solve() {
	int N, n, M, m, K, q;
	cin >> N >> n >> M >> m >> K >> q;
	deque<pair<int,int>> A(n);
	for (int i = 0; i < n; i++) {
		int a, b;
		cin >> b >> a;
		A[i] = { b, a };
		/*
		if (b % 2 == 0) {
			A.push_back(a);
			A.push_back(a);
		}
		else {
			A.push_back(a);
		}*/
	}
	deque<pair<int,int>> B(m);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> b >> a;
		B[i] = { b, a };
		/*
		if (b % 2 == 0) {
			B.push_back(a);
			B.push_back(a);
		}
		else {
			B.push_back(a);
		}*/
		
	}
	vector<int> prefa1(n + 1), prefb1(m + 1);
	for (int i = 0; i < n; i++) {
		prefa1[i + 1] = prefa1[i] + A[i].first;
	}
	for (int i = 0; i < m; i++) {
		prefb1[i + 1] = prefb1[i] + B[i].first;
	}
	set<int> st1;
	for (int i = 0; i <= n; i++) {
		st1.insert(prefa1[i]);
	}
	for (int i = 0; i <= m; i++) {
		st1.insert(prefb1[i]);
	}
	vector<pair<int, int>> Q(q);
	for (int rep = 0; rep < q; rep++) {
		int a, b;
		cin >> a >> b;
		Q[rep] = { a, b };
		st1.insert(a);
		st1.insert(b);
	}
	vector<int> st;
	for (auto p : st1)st.push_back(p);
	deque<pair<int, int>> nA;
	int l = 0;
	while (A.size()) {
		if (l + 1 < st.size() && st[l + 1] - st[l] >= A.front().first) {
			nA.push_back(A.front());
			A.pop_front();
		}
		else{
			A.front().first -= st[l + 1] - st[l];
			nA.push_back({ st[l + 1] - st[l], A.front().second });
		}
		l++;
	}
	deque<pair<int, int>> nB;
	l = 0;
	while (B.size()) {
		if (l + 1 < st.size() && st[l + 1] - st[l] >= B.front().first) {
			nB.push_back(B.front());
			B.pop_front();
		}
		else {
			B.front().first -= st[l + 1] - st[l];
			nB.push_back({ st[l + 1] - st[l] , B.front().second });
		}
		l++;
	}
	A = nA;
	B = nB;
	N = A.size();
	M = B.size();
	n = N;
	m = M;
	for (int i = 0; i < n; i++) {
		//cout << A[i].first << " " << A[i].second << " | ";
	}
	//cout << "\n";
	for (int i = 0; i < m; i++) {
		//cout << B[i].first << " " << B[i].second << " | ";
	}
	//cout << "\n";
	vector<vector<pair<bool, bool>>> dp(N + 1, vector<pair<bool, bool>>(M + 1, { 0,0 }));

	vector<pair<int, int>> fi1(K + 1, { -1, -1 });
	for (int i = N - 1; i >= 0; i--) {
		fi1[A[i].second].first = i;
		vector<pair<int, int>> fi = fi1;
		for (int j = M - 1; j >= 0; j--) {
			fi[B[j].second].second = j;
			for (int k = 1; k <= K; k++) {
				if (k == B[j].second && B[j].second == A[i].second) {
					if (fi[k].first != -1 && fi[k].second != -1) {
						if (B[j].first % 2 == A[i].first % 2) {
							dp[i][j].first = dp[i][j].first || !dp[fi[k].first + 1][fi[k].second + 1].second;
							dp[i][j].second = dp[i][j].second || !dp[fi[k].first + 1][fi[k].second + 1].first;
						}
						else {
							dp[i][j].first = dp[i][j].first || dp[fi[k].first + 1][fi[k].second + 1].first;
							dp[i][j].second = dp[i][j].second || dp[fi[k].first + 1][fi[k].second + 1].second;
						}
					}
				}
				else if (k == B[j].second) {
					if (fi[k].first != -1 && fi[k].second != -1) {
						if (B[j].first % 2) {
							dp[i][j].first = dp[i][j].first || !dp[fi[k].first + 1][fi[k].second + 1].second;
							dp[i][j].second = dp[i][j].second || !dp[fi[k].first + 1][fi[k].second + 1].first;
						}
						else {
							dp[i][j].first = dp[i][j].first || dp[fi[k].first + 1][fi[k].second + 1].first;
							dp[i][j].second = dp[i][j].second || dp[fi[k].first + 1][fi[k].second + 1].second;
						}
					}
				}
				else if (k == A[i].second) {
					if (fi[k].first != -1 && fi[k].second != -1) {
						if (A[i].first % 2) {
							dp[i][j].first = dp[i][j].first || !dp[fi[k].first + 1][fi[k].second + 1].second;
							dp[i][j].second = dp[i][j].second || !dp[fi[k].first + 1][fi[k].second + 1].first;
						}
						else {
							dp[i][j].first = dp[i][j].first || dp[fi[k].first + 1][fi[k].second + 1].first;
							dp[i][j].second = dp[i][j].second || dp[fi[k].first + 1][fi[k].second + 1].second;
						}
					}
				}
				else {
					if (fi[k].first != -1 && fi[k].second != -1) {
						dp[i][j].first = dp[i][j].first || !dp[fi[k].first + 1][fi[k].second + 1].second;
						dp[i][j].second = dp[i][j].second || !dp[fi[k].first + 1][fi[k].second + 1].first;
					}
				}
			}
		}
	}
	for (int i = 0; i <= N; i++) {
		for (int j = 0; j <= M; j++) {
			//cout << dp[i][j].first << " ";
		}
		//cout << "\n";
	}
	vector<int> prefa(n + 1), prefb(m + 1);
	for (int i = 0; i < n; i++) {
		prefa[i + 1] = prefa[i] + A[i].first;
	}
	for (int i = 0; i < m; i++) {
		prefb[i + 1] = prefb[i] + B[i].first;
	}
	for (int rep = 0; rep < q; rep++) {
		int a, b;
		a = Q[rep].first;
		b = Q[rep].second;
		int i = prev(upper_bound(prefa.begin(), prefa.end(), a)) - prefa.begin();
		int j = prev(upper_bound(prefb.begin(), prefb.end(), b)) - prefb.begin();

		cout << (dp[i][j].first	 ? "Yes" : "No") << "\n";
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	//cin >> t;
	t = 1;
	while (t--) {
		solve();
	}
}
