#include <bits/stdc++.h>
using namespace std;
#ifdef _LOCAL
#define debug(x) cerr << __LINE__ << ' ' << __PRETTY_FUNCTION__ << ": " << x << '\n';
#else
#define debug(...) 238;
#endif
mt19937 rng(238);
mt19937_64 rng64(238);
using ll = long long;
template <typename T, int U>
using ar = array<T, U>;
template <typename T, typename U>
bool chmin(T& x, const U&& y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
template <typename T, typename U>
bool chmax(T& x, const U&& y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

#include <ext/pb_ds/assoc_container.hpp>
template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type,
                                     less<T>,
                                     __gnu_pbds::rb_tree_tag,
                                     __gnu_pbds::tree_order_statistics_node_update>; 
constexpr int Inf = 0x3f3f3f3f;
constexpr ll inf = 1144000000000000000;

const int maxn = 404;
vector<int> g[maxn * maxn + 1];
int used[maxn * maxn + 1];

void dfs(int v) {
    for (int i : g[v]) {
        if (!used[i]) {
            used[v] = 1;
        }
    }
}

void solve() {
    int n, N, m, M, k, q;
    cin >> n >> N >> m >> M >> k >> q;
    vector<int> a, b;
    for (int i = 0; i < N; ++i) {
        int l, v;
        cin >> l >> v;
        while (l--) {
            a.push_back(v);
        }
    }
    for (int i = 0; i < M; ++i) {
        int l, v;
        cin >> l >> v;
        while (l--) {
            b.push_back(v);
        }
    }
    
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int v = 1; v <= k; ++v) {
                int y = i;
                for (; y < n; ++y) {
                    if (a[y] == v) {
                        break;
                    }
                }
                int z = j;
                for (; z < m; ++z) {
                    if (b[z] == v) {
                        break;
                    }
                }
                if (y < n && z < m) {
                    g[i * maxn + j].push_back((y + 1) * maxn + (z + 1));
                }
            }
        }
    }
    for (int i = maxn * maxn; ~i; --i) {
        dfs(i);
    }
    while (q--) {
        int x, y;
        cin >> x >> y;
        if (used[x * maxn + y]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

int main() {
#ifdef _LOCAL
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while (Tc--) {
        solve();
        cout << '\n';
    }

    return 0;
}