#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define size(t) (int)t.size()
#define pb push_back
#define all(t) t.begin(), t.end()
#define rall(t) t.rbegin(), t.rend()

using namespace std;

const int T = 5005;

int w[T][T];
int nxta[T], nxtb[T];

void solve() {
    int N, n, M, m, k, q, i, j, x, y;
    cin >> N >> n >> M >> m >> k >> q;
    vector <int> a, b;
    for (i = 0; i < n; i++) {
        cin >> j >> x;
        while (j--)
            a.pb(x);
    }
    for (i = 0; i < m; i++) {
        cin >> j >> x;
        while (j--)
            b.pb(x);
    }
    nxta[N - 1] = N;
    for (i = N - 2; i >= 0; i--) {
        if (a[i] == a[i + 1])
            nxta[i] = nxta[i + 1];
        else
            nxta[i] = i + 1;
    }
    nxtb[M - 1] = M;
    for (i = M - 2; i >= 0; i--) {
        if (b[i] == b[i + 1])
            nxtb[i] = nxtb[i + 1];
        else
            nxtb[i] = i + 1;
    }
    w[1][1] = (a[N - 1] == b[M - 1]);
    for (i = 2; i <= max(N, M); i++) {
        if (i <= N) {
            for (j = 1; j <= min(i, M); j++) {
                if (a[N - i] == b[M - j]) {
                    w[i][j] = 1 - w[i - 1][j - 1];
                }
                else {
                    w[i][j] = (w[N - nxta[N - i]][j] || w[i][M - nxtb[M - j]]);
                }
            }
        }
        if (i <= M) {
            for (j = 1; j <= min(i, N); j++) {
                if (a[N - j] == b[M - i]) {
                    w[j][i] = 1 - w[j - 1][i - 1];
                }
                else {
                    w[j][i] = (w[N - nxta[N - j]][i] || w[j][M - nxtb[M - i]]);
                }
            }
        }
    }
    while (q--) {
        cin >> x >> y;
        i = N - x;
        j = M - y;
        if (w[i][j]) {
            cout << "Yes\n";
        }
        else {
            cout << "No\n";
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
