#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>

using namespace std;
using ll = long long int;
using ull = unsigned long long int;

#define all(x) (x).begin(), (x).end()
#define rall(X) (x).rbegin(), (x).rend()

void solve()
{
    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;

    vector<int> a(N);
    vector<int> b(M);

    int cur = 0;
    for (int i = 0; i < n; i++)
    {
        int l, v;
        cin >> l >> v;
        
        for (int j = 0; j < l; j++)
            a[cur + j] = v;
        cur += l;
    }

    cur = 0;
    for (int i = 0; i < m; i++)
    {
        int l, v;
        cin >> l >> v;
        
        for (int j = 0; j < l; j++)
            b[cur + j] = v;
        cur += l;
    }

    vector dp(N + 1, vector<bool>(M + 1));
    unordered_map<int, int> f1;
    for (int i = N - 1; i >= 0; i--)
    {
        f1[a[i]] = i;
        unordered_map<int, int> f2;
        for (int j = M - 1; j >= 0; j--)
        {
            f2[b[j]] = j;

            if (f1.size() < f2.size())
            {
                for (auto [x, y] : f1)
                {
                    if (f2.count(x) == 0)
                        continue;
                    if (!dp[y + 1][f2[x] + 1])
                    {
                        dp[i][j] = true;
                        break;
                    }
                }
            }
            else
            {
                for (auto [x, y] : f2)
                {
                    if (f1.count(x) == 0)
                        continue;
                    if (!dp[f1[x] + 1][y + 1])
                    {
                        dp[i][j] = true;
                        break;
                    }
                } 
            }
        }
    }

    while (q--)
    {
        int x, y;
        cin >> x >> y;

        if (dp[x][y])
            cout << "Yes\n";
        else
            cout << "No\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("C:/work/Day 1/in.txt", "r", stdin);
    freopen("C:/work/Day 1/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}
