#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

typedef long long ll;

using namespace std;

void fio() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
}

void solveA() {
    int maxX, n, maxY, m, k, nQ;
    cin >> maxX >> n >> maxY >> m >> k >> nQ;
    vector<pair<int, int>> a(n);
    vector<int> sumA(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].second--;
        sumA[i + 1] = a[i].first + sumA[i];
    }
    vector<int> sumB(m + 1, 0);
    vector<pair<int, int>> b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i].first >> b[i].second;
        b[i].second--;
        sumB[i + 1] = sumB[i] + b[i].first;
    }
    vector<vector<int>> cntA(n, vector<int>(k, 0));
    vector<int> cur(k, 0);
    for (int i = n - 1; i >= 0; i--) {
        cur[a[i].second] += a[i].first;
        cntA[i] = cur;
    }
    vector<vector<int>> cntB(m, vector<int>(k, 0));
    cur.assign(k, 0);
    for (int j = m - 1; j >= 0; j--) {
        cur[b[j].second] += b[j].first;
        cntB[j] = cur;
    }
    int qI, qJ;
    int posI, posJ;
    for (int i = 0; i < nQ; i++) {
        cin >> qI >> qJ;
        posI = std::upper_bound(sumA.begin(), sumA.end(), qI) - sumA.begin() - 1;
        posJ = std::upper_bound(sumB.begin(), sumB.end(), qJ) - sumB.begin() - 1;
        bool res = min(cntA[posI][a[posI].second] - qI + sumA[posI], cntB[posJ][b[posJ].second] - qJ + sumB[posJ]) % 2 == 1;
        for (int j = 0; j < k; j++) {
            if (res) {
                break;
            }
            if (j != a[posI].second) {
                res = min(cntB[posJ][j], cntA[posI][j]) % 2 == 1;
            }
        }
        if (res) {
            cout << "Yes" << '\n';
        } else {
            cout << "No" << '\n';
        }
    }
}

int main() {
    fio();
    solveA();
    return 0;
}
/*
5 5 5 5 1 9
1 1
1 1
1 1
1 1
1 1
1 1
1 1
1 1
1 1
1 1
0 0
0 1
0 2
1 0
1 1
1 2
2 0
2 1
2 2
 */