
#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double

const int maxn = 2e5;
const int LOG = 30;
const int N = 2e3;
const ld eps = 1e-12;

inline void solve() {
    int n, n1, m, m1, k, q;
    cin >> n >> n1 >> m >> m1 >> k >> q;
    vector<int> a, b;
    for (int i = 0; i < n1; i++) {
        int l, v;
        cin >> l >> v;
        while (l--) a.pb(v - 1);
    }
    for (int i = 0; i < m1; i++) {
        int l, v;
        cin >> l >> v;
        while (l--) b.pb(v - 1);
    }

    vector<vector<int>> dp(n + 1, vector<int>(m + 1, 0));
    for (int i = n - 1; i > -1; i--) {
        for (int j = m - 1; j > -1; j--) {
            if (a[i] == b[j]) {
                vector<int> ban(k);
                dp[i][j] = 0;

                int u = 0;
                for (int o = i + 1; o < n; o++) {
                    if(ban[a[o]]) continue;
                    ban[a[o]] = 1;
                    u += 1;

                    if (dp[o][j + 1] == 0) {
                        dp[i][j] = 1;
                        break;
                    }
                }
                if(u == 0) {
                    dp[i][j] = 1;
                }
            }
        }
    }

    while (q--) {
        int l, r;
        cin >> l >> r;
        if (dp[l][r] == 1) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt = 1;
    //cin >> tt;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    while (tt--) {
        solve();
    }
    return 0;
}
