#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>

#define len(v) (int)((v).size())
#define ss second
#define ff first


typedef long long ll;

using namespace std;

void solve() {
	int N, n, M, m, k, q;
	cin >> N >> n >> M >> m >> k >> q;

	vector<int> a(N), b(M);
	for (int i = 0; i < n; ++i) {
		int li, vi;
		cin >> li >> vi;

		while (li--) {
			a.push_back(vi);
		}
	}
	for (int i = 0; i < m; ++i) {
		int li, vi;
		cin >> li >> vi;

		while (li--) {
			b.push_back(vi);
		}
	}

	vector<map<int, int>> ls(M + 1);
	vector<vector<bool>> dp(N + 1, vector<bool>(M + 1, false));

	for (int i = M - 1; i >= 0; --i) {
		ls[i] = ls[i + 1];
		ls[i][b[i]] = i;
	}

	for (int i = N - 1; i >= 0; --i) {
		for (int j = M - 1; j >= 0; --j) {
			for (int fs = i; fs < N; ++fs) {
				if (ls[j].find(a[fs]) == ls[j].end()) continue;
				dp[i][j] = dp[i][j] || (!dp[i + 1][ls[j][a[fs]] + 1]);
			}
		}
	}

	for (int i = 0; i < q; ++i) {
		int x, y;
		cin >> x >> y;

		if (dp[x][y]) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);

	int t = 1;
 //   cin >> t;
	while (t--) solve();
}



