#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll INF = 1e9 + 5;

void solve() {
    ll n1, n, m1, m, k, q;
    cin >> n1 >> n >> m1 >> m >> k >> q;
    vector<ll> a, b;
    for (ll i = 0; i < n; ++i) {
        ll l, v;
        cin >> l >> v;
        for (ll j = 0; j < l; ++j) {
            a.push_back(v - 1);
        }
    }
    for (ll i = 0; i < m; ++i) {
        ll l, v;
        cin >> l >> v;
        for (ll j = 0; j < l; ++j) {
            b.push_back(v - 1);
        }
    }

    vector<vector<ll>> next_a(n1 + 1, vector<ll> (k, -1)), next_b(m1 + 1, vector<ll> (k, -1));
    for (ll i = n1 - 1; i >= 0; --i) {
        next_a[i] = next_a[i + 1];
        next_a[i][a[i]] = i;
    }
    for (ll i = m1 - 1; i >= 0; --i) {
        next_b[i] = next_b[i + 1];
        next_b[i][b[i]] = i;
    }

    vector<vector<ll>> dp(n1 + 1, vector<ll> (m1 + 1, 0));
    for (ll i = n1; i > 0; --i) {
        for (ll j = m1; j > 0; --j) {
            if (dp[i][j] == 0 && a[i - 1] == b[j - 1]) {
                ll v = a[i - 1];
                //cout << i << ' ' << j << "  ";
                for (ll i1 = i - 1; i1 >= 0 && next_a[i1][v] == i - 1; --i1) {
                    for (ll j1 = j - 1; j1 >= 0 && next_b[j1][v] == j - 1; --j1) {
                        //cout << i1 << ' ' << j1 << "  ";
                        dp[i1][j1] = 1;
                    }
                }
                //cout << '\n';
            }
        }
    }

    for (ll i = 0; i < q; ++i) {
        ll x, y;
        cin >> x >> y;
        if (dp[x][y] == 1) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
