#ifdef ONPC
    #define _GLIBCXX_DEBUG
#endif // ONPC

#include <bits/stdc++.h>

#define watch(x) cerr << #x << ": " << x << endl;

using namespace std;

#define all(v) begin(v), end(v)

typedef long long ll;

typedef pair<int, int> Pint;
typedef pair<ll, ll> Pll;

const int inf = 1e9 + 10;

const int maxn = 1600 + 10;

bool dp[maxn][maxn], suff[maxn][maxn], last[maxn][maxn];
Pint prc[maxn][maxn];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int N, n, M, m, k, q;
    cin >> N >> n >> M >> m >> k >> q;
    vector<Pint> a(n), b(n);
    for (auto &[i, j] : a) {
        cin >> i >> j;
    }
    for (auto &[i, j] : b) {
        cin >> i >> j;
    }

//    for (int i = n - 1; i >= 0; --i) {
//        for (int j = m - 1; j >= 0; --j) {
//            if (a[i].second == b[j].second) {
//                if (suff[i + 1][j + 1])
//            }
//        }
//    }

    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= m; ++j) {
            prc[i][j] = {inf, inf};
        }
    }
    for (int i = n - 1; i >= 0; --i) {
        for (int j = m - 1; j >= 0; --j) {
            if (a[i].second == b[j].second) {
                prc[i][j] = {i, j};
            } else {
                prc[i][j] = min(prc[i + 1][j], prc[i][j + 1]);
            }
        }
    }

    vector<ll> prefa(n + 1), prefb(m + 1);
    prefa[0] = 0, prefb[0] = 0;
    for (int i = 0; i < n; ++i) {
        prefa[i + 1] = prefa[i] + a[i].first;
    }
    for (int j = 0; j < m; ++j) {
        prefb[j + 1] = prefb[j] + b[j].first;
    }

//    vector<bool> col(m + 1, true);
//    for (int i = n - 1; i >= 0; --i) {
//        bool lose = true;
//        int pi = n, pj = m;
//        for (int j = i + 1; j < n; ++j) {
//            if (a[j].second == a[i].second) {
//                pi = j;
//                break;
//            }
//        }
//        for (int j = m - 1; j >= 0; --j) {
//            if (a[i].second == b[j].second) {
//                dp[i][j] = !lose || (pi < n && pj < m && !dp[pi][pj]);
//                col[j] = !dp[i][j];
//                pj = j;
//            } else {
//                dp[i][j] = true;
//                lose &= col[j];
//            }
//        }
//    }

    vector<Pll> cnt(k + 1);
    for (auto &[i, j] : a) {
        cnt[j].first += i;
    }
    for (auto &[i, j] : b) {
        cnt[j].second += i;
    }

    vector<vector<ll>> pka(k + 1, vector<ll>(n + 1)), pkb(k + 1, vector<ll>(m + 1));
    for (int i = 0; i < n; ++i) {
        pka[a[i].second][i + 1] = a[i].first;
    }
    for (int i = 0; i < m; ++i) {
        pkb[b[i].second][i + 1] = b[i].first;
    }
    for (int p = 1; p <= k; ++p) {
        for (int i = 1; i <= n; ++i) {
            pka[p][i] += pka[p][i - 1];
        }
        for (int j = 1; j <= m; ++j) {
            pkb[p][j] += pkb[p][j - 1];
        }
    }

    while (q--) {
        int x, y;
        cin >> x >> y;
        int i = upper_bound(all(prefa), x) - prefa.begin() - 1;
        int j = upper_bound(all(prefb), y) - prefb.begin() - 1;
        x -= prefa[i], y -= prefb[j];
        vector<Pll> cur(k + 1);
        bool win = false;
//        watch(i); watch(j); watch(a[i].second); watch(x); watch(y);
        for (int p = 1; p <= k; ++p) {
//            watch(pka[])
//            watch(cnt[p].first); watch(pka[p][i]);
            cur[p] = {cnt[p].first - pka[p][i], cnt[p].second - pkb[p][j]};
            if (a[i].second == p) {
                cur[p].first -= x;
                cur[p].second -= y;
            }
//            watch(cur[p].first); watch(cur[p].second);
            win |= min(cur[p].first, cur[p].second) % 2 == 1;
        }
//        watch(win);
        cout << (win ? "Yes" : "No") << '\n';
    }

    return 0;
}
