#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<cstdio>
#include<unordered_set>
#include<unordered_map>
#include<iomanip>
#include<random>
#include<bitset>
#include<ctime>

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;

ll gcd(ll a, ll b) {
	return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}
mt19937 mt(time(0));
const int N = 2e3 + 2, inf = 1e9 + 100, mod = 1e9 + 7, mod2 = 998244353, P = 257;
const ll llinf = 1e18 + 100;
int n, m, a[N];
ll dp[N][N];

void solve() {
	cin >> n >> m;
	for (int i = 0; i < m; ++i) cin >> a[i];
	reverse(a, a + m);
	for (int i = 0; i <= m; ++i) {
		fill(dp[i], dp[i] + n + 1, -llinf);
	}
	dp[0][0] = 0;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j <= n; ++j) {
			if (j + 1 <= n) dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] + a[i]);
			if (j) dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] - a[i]);
		}
	}
	ll ans = -llinf;
	for (int i = 0; i <= n; ++i) ans = max(ans, dp[m][i]);
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
		cout.flush();
	}
	return 0;
}