#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		n = min(n, m);
		vector<int> x(m);
		for (int i = 0; i < m; ++i) {
			cin >> x[i];
		}
		int cn = 400 * m;
		vector<vector<int>> mn(m + 1, vector<int>(2 * cn + 1, 1e9)), mx(m + 1, vector<int> (2* cn + 1, -1e9));
		mn[0][0] = 0;
		mx[0][0] = 0;
		for (int i = 0; i < m; ++i) {
			for (int a = -cn; a <= cn; ++a) {
				mn[i + 1][a + cn] = min(mn[i + 1][a + cn], (x[i] - mx[i][a + cn]));
				mx[i + 1][a + cn] = max(mx[i + 1][a + cn], (x[i] - mn[i][a + cn]));
				if (x[i] - a >= -cn && x[i] - a <= cn) {
					mn[i + 1][x[i] - a + cn] = min(mn[i + 1][x[i] - a + cn], mn[i][a + cn]);
					mx[i + 1][x[i] - a + cn] = max(mx[i + 1][x[i] - a + cn], mx[i][a + cn]);
				}
			}
		}
		int rs = -1e9;
		for (int i = -cn; i <= cn; ++i) {
			rs = max(rs, mx[m][i + cn] + i);
		}
		cout << rs << '\n';
	}

	return 0;
}
