#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		n = min(n, m);
		vector<int> x(m);
		for (int i = 0; i < m; ++i) {
			cin >> x[i];
		}
		int cn = m * 400;
		vector<int> mn(2 * cn + 1, 1e9), mx(2 * cn + 1, -1e9);
		mn[cn] = 0;
		mx[cn] = 0;
		for (int i = 0; i < m; ++i) {
			vector<int> cmn(2 * cn + 1, 1e9), cmx(2 * cn + 1, -1e9);
			for (int a = -cn; a <= cn; ++a) {
				cmn[a + cn] = min(cmn[a + cn], (x[i] - mx[a + cn]));
				cmx[a + cn] = max(cmx[a + cn], (x[i] - mn[a + cn]));
				if (x[i] - a >= -cn && x[i] - a <= cn) {
					cmn[x[i] - a + cn] = min(cmn[x[i] - a + cn], mn[a + cn]);
					cmx[x[i] - a + cn] = max(cmx[x[i] - a + cn], mx[a + cn]);
				}
			}
			swap(cmn, mn);
			swap(cmx, mx);
		}
		int rs = -1e9;
		for (int i = -cn; i <= cn; ++i) {
			rs = max(rs, mx[i + cn] + i);
		}
		cout << rs << '\n';
	}

	return 0;
}
