#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);
	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		n = min(n, m);
		vector<int> x(m);
		for (int i = 0; i < m; ++i) {
			cin >> x[i];
		}
		reverse(x.begin(), x.end());
		vector<vector<ll>> dp(m + 1, vector<ll> (n + 1, -1e15));
		dp[0][0] = 0;
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j <= n; ++j) {
				if (j < n) {
					dp[i + 1][j + 1] = max(dp[i][j] + x[i], dp[i + 1][j + 1]);
				}
				if (j > 0) {
					dp[i + 1][j - 1] = max(dp[i][j] - x[i], dp[i + 1][j - 1]);
				}
			}
		}
		cout << *max_element(dp[m].begin(), dp[m].end()) << '\n';
	}

	return 0;
}
