#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;
const ll mod = 1e9 + 7;

void solve() {
    ll n, m; cin >> n >> m;
    vector<ll> a(n);
    vector<ll> x(m);
    for(int i = 0; i < m; i++) cin >> x[i];
    multiset<ll> s;
    for(int i = 0; i < n; i++) s.insert(a[i]);
    for(int i = 0; i < m; i++) {
        ll mn = *s.begin();
        s.erase(s.begin());
        s.insert(x[i] - mn);
    }
    ll sum = 0;
    for(ll el : s) sum += el;
    cout << sum << "\n";
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
