#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template <typename T>
using ordered_set =
    tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)((x).size()))

using ll = long long;
using ld = long double;

const ll INF = 3e18;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i  < m; ++i) {
        cin >> x[i];
    }
    vector<multiset<int>> s;
    multiset<int> tmp;
    for (int i = 0; i < n; ++i) {
        tmp.insert(0);
    }
    s.push_back(tmp);
    for (int i = 0; i < m; ++i) {
    vector<multiset<int>> ns;

        for (auto j : s) {
            auto jj = j;
            {
                int val = *j.begin();
                j.extract(val);
                val = x[i] - val;
                j.insert(val);
                ns.push_back(j);
            }
            j = jj;
             {
                int val = *j.rbegin();
                j.extract(val);
                val = x[i] - val;
                j.insert(val);
                ns.push_back(j);
            }
        }
        s.swap(ns);
    }
    int ans = -INF;
    for (auto j : s) {
        int t  = 0;
        for (int k : j) t += k;
        ans = max(ans, t);
    }
    cout << ans << '\n';
}

signed main() {
#ifdef LOCALEGOR
    freopen("INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#endif
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}