#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template <typename T>
using ordered_set =
    tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)((x).size()))

using ll = long long;
using ld = long double;

const ll INF = 3e18;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
    }
    reverse(all(x));
    int res = 0;
    int pl = n;
    vector<int> mx(m + 1, -INF);
    for (int i = m - 1; ~i; --i) {
        mx[i] = max(mx[i + 1], x[i]);
    }
    for (int i = 0; i < m; ++i) {
        if (!pl) {
            res -= x[i];
            ++pl;
            continue;
        }
        if (pl == n) {
            res += x[i];
            --pl;
            continue;
        }
        if (i == m - 1) {
            res += x[i];

        } else {
            if (pl == 1) {
                if (x[i + 1] > x[i]) {
                    res -= x[i];
                    ++pl;
                } else {
                    res += x[i];
                    --pl;
                }
            }
        }
    }
    cout << res << '\n';
}

signed main() {
#ifdef LOCALEGOR
    freopen("INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#endif
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}