#include <bits/stdc++.h>
#define int long long
#define all(v) (v).begin(), (v).end()

using namespace std;

template<class C> using vec = vector<C>;
using vi = vector<int>;
using pii = pair<int, int>;
using vpi = vec<pii>;

const int inf = LLONG_MAX >> 1;

void solve() {
    int n, m;
    cin >> n >> m;
    n = min(n, 100ll);
    vi a(m);
    for (auto& x : a) cin >> x;
    vec<vi> dp(m + 1, vi(n + 1, -inf));
    dp[m][n] = 0;
    for (int i = m - 1; i >= 0; i--) {
        // make +
        for (int j = 1; j <= n; j++) {
            dp[i][j - 1] = max(dp[i][j - 1], dp[i + 1][j] + a[i]);
        }
        // make -
        for (int j = 0; j < n; j++) {
            dp[i][j + 1] = max(dp[i][j + 1], dp[i + 1][j] - a[i]);
        }
    }
    cout << *max_element(all(dp[0])) << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
}