#include<bits/stdc++.h>
#define int long long
using namespace std;

const int INF = 1e18;
const int K = 500;

void solve() {
    int n, m, s = 0, ans = -INF;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; i++) cin >> x[i];
    vector<vector<int>> dp(2 * K + 1, vector<int>(2 * K + 1)), dp2;
    dp[K][K] = 1;
    dp2 = dp;
    dp2[K][K] = 0;
    for (int i = 0; i < m; i++) {
        for (int v1 = 0; v1 <= 2 * K; v1++) {
            for (int v2 = 0; v2 <= 2 * K; v2++) {
                if (dp[v1][v2]) {
                    dp2[x[i] - v1 + K][v2] = 1;
                    dp2[v1][x[i] - v2 + K] = 1;
                }
            }
        }
        for (int v1 = 0; v1 <= 2 * K; v1++) {
            for (int v2 = 0; v2 <= 2 * K; v2++) {
                dp[v1][v2] = dp2[v1][v2];
                dp2[v1][v2] = 0;
            }
        }
    }
    for (int v1 = 0; v1 <= 2 * K; v1++) {
        for (int v2 = 0; v2 <= 2 * K; v2++) {
            if (dp[v1][v2]) {
                ans = max(ans, v1 + v2 - 2 * K);
            }
        }
    }
    cout << ans;
}

int32_t main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    int tt;
    cin >> tt;
    while (tt--) {
        solve();
        cout << '\n';
    }
}
