#include <bits/extc++.h>

#define int long long

using namespace std;

constexpr int INF = 1e10;

void solve1() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    if (n == 1) {
        cout << (m % 2 == 0 ? 0 : x[0]) << '\n';
        return;
    }
    if (m <= n) {
        cout << x[0] * m << '\n';
        return;
    }
    if (n % 2 != m % 2) {
        cout << x[0] * (n - 1) << '\n';
    } else {
        cout << x[0] * n << '\n';
    }
}

void solve2() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    int ans = -INF * n;
    for (int mask = 0; mask < (1 << m); mask++) {
        vector<int> a(n);
        for (int i = 0; i < m; i++) {
            int j = ((mask >> i) & 1);
            a[j] = x[i] - a[j];
        }
        ans = max(ans, a[0] + a[1]);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve2();
    }
    return 0;
}