#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>

using namespace std;

using ll = long long;

#pragma GCC optimaze("Ofast");

vector<vector<int>> gr;
vector<ll> s;

void dfs(int v, ll& su, ll x) {
	if (s[v] <= x) return;
	su++;
	for (int u : gr[v]) dfs(u, su, x);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int q;
	cin >> q;
	while (q--) {
		ll n, m;
		cin >> n >> m;
		vector<ll> x(m);
		for (int i = 0; i < m; i++) cin >> x[i];
		reverse(x.begin(), x.end());
		vector<vector<ll>> dp(n + 1, vector<ll>(m + 1, -1e18));
		dp[n][0] = 0;
		for (int j = 1; j <= m; j++) {
			for (int i = 0; i <= n; i++) {
				if (i && dp[i-1][j-1]!=-1e18) dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] - x[j - 1]);
				if (i != n && dp[i+1][j-1]!=-1e18) dp[i][j] = max(dp[i][j], dp[i + 1][j - 1] + x[j - 1]);
				//cout << dp[i][j] << ' ';
			}
			//cout << "\n";
		}
		ll ma = 0;
		for (int i = 0; i <= n; i++) ma = max(ma, dp[i][m]);
		cout << ma << "\n";
	}
}



