#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#define endl '\n'
#define int long long

using namespace std;

int md = 4e9;

int twoinone(int a, int b) {
    return a * md + b;
}

pair<int, int> oneintwo(int a) {
    return {a / md, a % md};
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<int> a(m);
        for (int i = 0; i < m; ++i) {
            cin >> a[i];
        }
        vector<pair<int, int>> d;
        d.push_back({0, 0});
        for (int i = 0; i < m; ++i) {
            vector<pair<int, int>> w;
            for (int j = 0; j < (int)d.size(); ++j) {
                int u = d[j].first;
                int v = d[j].second;
                int q1 = a[i] - u;
                int w1 = v;
                if (q1 > w1) {
                    swap(q1, w1);
                }
                int q2 = u;
                int w2 = a[i] - v;
                if (q2 > w2) {
                    swap(q2, w2);
                }
                w.push_back({q1, w1});
                w.push_back({q2, w2});
            }
            d.clear();
            sort(w.begin(), w.end());
            vector<bool> stupid((int)w.size(), false);
            for (int j = 0; j < (int)w.size(); ++j) {
                for (int k = j + 1; k < (int)w.size(); ++k) {
                    if (w[j].second >= w[k].second) {
                        stupid[k] = true;
                    }
                }
            }
            for (int j = 0; j < (int)w.size(); ++j) {
                if (!stupid[j]) {
                    d.push_back(w[j]);
                }
            }
        }
        int ans = -2e9;
        for (auto it = d.begin(); it != d.end(); ++it) {
            ans = max(ans, (it -> first));
        }
        cout << ans << endl;
    }
    return 0;
}
