#ifndef SEREGA
#include <bits/allocator.h>
#pragma GCC target("avx2,popcnt")
#pragma GCC optimize("O3,no-stack-protector")
#endif
#include <bits/stdc++.h>
using namespace std;
#define int int64_t


int n, m;
vector<int> x;
vector<int> a;
int answer = 0;
map<pair<vector<int>, int>, int> cache;
int dfs(vector<int> &ssf, int index) {
    if (cache.contains({ssf, index})) return cache[{ssf, index}];
    if (index == m) {
        return accumulate(ssf.begin(), ssf.end(), int(0));
    }
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        ssf[i] = x[index] - ssf[i];
        mx = max(mx, dfs(ssf, index + 1));
        ssf[i] = x[index] - ssf[i];
    }
    return cache[{ssf, index}] = mx;
}
void solve() {
    cin >> n >> m;
    x.assign(m, {});
    a.assign(n, {});
    map<int, int> cnt;
    for (int i = 0; i < m; ++i) {
        cin >> x[i];
        cnt[x[i]]++;
    }
    if (m <= n) {
        cout << accumulate(x.begin(), x.end(), 0ll) << '\n';
        return;
    }
    if (cnt.size() == 1) {
        cout << ((m - n) & 1 ? x[0] * (n - 1) : x[0] * n) << '\n';
        return;
    }
    vector<pair<int, int>> cnts(cnt.begin(), cnt.end());
    sort(cnts.begin(), cnts.end(), [](auto &l, auto &r) {
        return l.first > r.first;
    });
    int mx = cnts[0].first;
    int mxcnt = cnts[0].second;
    int smx = cnts[1].first;
    int smxcnt = cnts[1].second;
    if (mxcnt >= n) {
        int ans = mx * n;
        mxcnt -= n;
        if (mxcnt & 1) {
            ans -= mx;
            if (smxcnt & 1) {
                ans += smx;
            }
        } else {
            if (smxcnt & 1) {
                ans = ans - mx + (smx - mx);
            }
        }
        cout << ans << '\n';
        return;
    } else {
        int ans = mx * mxcnt;
        n -= mxcnt;
        if (smxcnt <= n) {
            ans += smx * smxcnt;
        } else if (cnt.size() == 1) {
            ans += ((m - n) & 1 ? smx * (n - 1) : smx * n);
        }
        cout << ans << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    cin >> t;
    while (t--) solve();
}