#include <bits/stdc++.h>

using ll = long long;
using ld = long double;

#define int ll
#define pii pair<int, int>
#define all(obj) obj.begin(), obj.end()
#define rall(obj) obj.rbegin(), obj.rend()

using namespace std;

const ll INF = 1e18;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int>a(m);
    for (int i=0; i<m; i++) {
        cin >> a[i];
    }
    reverse(all(a));

    vector<vector<int>>dp(m+1, vector<int>(n+1, -INF));
    dp[0][0] = 0;
    dp[1][1] = a[0];
    

    for (int len=2; len<=m; len++) {
        for (int bal = (len%2); bal <= min(n, len); bal += 2) {
            if (bal == 0) {
                dp[len][0] = dp[len-1][1] - a[len-1];
            }
            else if (bal == n) {
                dp[len][n] = dp[len-1][n-1] + a[len-1];
            }
            else {
                dp[len][bal] = max(dp[len-1][bal-1] + a[len-1], dp[len-1][bal+1] - a[len-1]);
            }
        }
    }

    int ans = -INF;
    for (int bal = m%2; bal <= min(n, m); bal += 2) {
        ans = max(ans, dp[m][bal]);
    }
    cout << ans << "\n";
}

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}