#ifdef ONPC
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;


mt19937_64 rng(chrono::steady_clock().now().time_since_epoch().count());

bool chmax(ll& a, ll b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const int MAXN = 2020;

int x[MAXN];
ll dp[MAXN][MAXN];
const ll INF = 1e18;

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= m; i++) cin >> x[i];
    reverse(x + 1, x + m + 1);

    for (int i = 0; i <= m; i++) for (int j = 0; j <= n; j++) dp[i][j] = -INF;

    dp[0][0] = 0;
    for (int i = 1; i <= m; i++) {
        for (int open = 0; open <= n; open++) {
            if (open != 0) chmax(dp[i][open], dp[i - 1][open - 1] + x[i]);
            if (open != n) chmax(dp[i][open], dp[i - 1][open + 1] - x[i]);
        }
    }

    ll ans = -INF;
    for (int open = 0; open <= n; open++) chmax(ans, dp[m][open]);

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();

    return 0;
}
