#include <bits/stdc++.h>


using namespace std;


using ll = long long;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


pair<ll, ll> maxx(const pair<ll, ll> &a, const pair<ll, ll> &b) {
    if (a.first + a.second > b.first + b.second) {
        return a;
    }
    return b;
}


pair<ll, ll> minn(const pair<ll, ll> &a, const pair<ll, ll> &b) {
    if (a.first + a.second > b.first + b.second) {
        return b;
    }
    return a;
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> x(m + 1, 0);
    for (int i = 1; i <= m; i++) {
        cin >> x.at(i);
    }
    vector<vector<pair<ll, ll>>> mn(m + 1, vector<pair<ll, ll>>(m + 1, {0, 0}));
    mn.at(1).at(0) = {x.at(1), 0};
    vector<vector<pair<ll, ll>>> mx(m + 1, vector<pair<ll, ll>>(m + 1, {0, 0}));
    mx.at(1).at(0) = {x.at(1), 0};
    for (int i = 1; i < m; i++) {
        for (int j = 0; j <= i - 1; j++) {
            mx.at(i + 1).at(j) = maxx(mx.at(i + 1).at(j), {-(mn.at(i).at(j).first - x.at(i + 1)), mn.at(i).at(j).second});
            mn.at(i + 1).at(j) = minn(mn.at(i + 1).at(j), {-(mx.at(i).at(j).first - x.at(i + 1)), mx.at(i).at(j).second});
            mx.at(i + 1).at(i) = maxx(mx.at(i + 1).at(i), {-(mn.at(i).at(j).second - x.at(i + 1)), mn.at(i).at(j).first});
            mn.at(i + 1).at(i) = minn(mn.at(i + 1).at(i), {-(mx.at(i).at(j).second - x.at(i + 1)), mx.at(i).at(j).first});
        }
    }
    ll ans = 0;
    for (int j = 0; j < m; j++) {
        ans = max(ans, mx.at(m).at(j).first + mx.at(m).at(j).second);
    }
    cout << ans << '\n';
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
