#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<long long> arr(m);
    for(int i = 0; i < m; i++) cin >> arr[i];
    vector<vector<long long>> dp(n + 1, vector<long long>(1 << m, LLONG_MIN / 2));
    dp[0][0] = 0;
    for(int i = 1; i <= n; i++) {
        for(int mask = 0; mask < (1 << m); mask++) {
            int m2 = mask;
            dp[i][mask] = dp[i - 1][mask];
            while(m2 > 0) {
                long long cs = 0;
                for(int j = 0; j < m; j++) {
                    if((m2 >> j) & 1) cs = arr[j] - cs;
                }
                // cout << ">> " << bitset<10>(m2) << ' ' << cs << '\n';
                dp[i][mask] = max(dp[i][mask], dp[i - 1][mask ^ m2] + cs);
                m2 = (m2 - 1) & mask;
            }
        }
    }
    long long ans = dp.back().back();
    cout << ans << '\n';
}

/*
a = x1 - a
a = x2 - a = x2 - (x1 - a) = x2 - x1 + a = x2 - x1
a = x3 - a = x3 - (x2 - x1) = x3 - x2 + x1
a = x4 - a = x4 - (x3 - x2 + x1) = x4 - x3 + x2 - x1
*/

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while(t--) solve();
}
