#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock().now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename T>
using orderet_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ull = unsigned long long;
using uint = unsigned int;
using ld = long double;
using dd = double;

#define int ll

void solve(){
    int n, m;
    cin>>n>>m;
    set<pair<int, int>> st= {{0, 0}};
    for(int i = 0; i < m; ++i){
        int x;
        cin>>x;
        set<pair<int, int>> st1;
        for(auto [a, b]: st){
            st1.insert({x-a, b});
            st1.insert({a, x-b});
        }
        st = st1;
    }
    int ans = -2e18;
    for(auto c: st) ans = max(ans, c.first + c.second);
    cout << ans << "\n";
}

signed main(){
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    int t = 1;
    cin>>t;
    while(t--) solve();
}