#include <bits/stdc++.h>
#define pb push_back
#define int long long

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

pi mp(int x, int y) {
    return make_pair(x, y);
}

const int INF = 1e18;
const int N = 800;

void solve() {
    int n, m;
    cin >> n >> m;

    vi x(m);
    for (int i = 0; i < m; ++i) cin >> x[i];

    vector<vector<vi>> dp(2, vector<vi>(2 * N + 1, vi(2 * N + 1)));
    dp[1][N][N] = 1;
    // cout << "|gf" << endl;
    for (int i = 0; i < m; ++i) {
        // cout << "I " << i << endl;
        for (int j = 0; j <= 2 * N; ++j) {
            for (int k = 0; k <= 2 * N; ++k) {
                dp[i & 1][j][k] = 0;
            }
        }

        // cout << "i " << i << endl;

        for (int aa = 0; aa <= 2 * N; ++aa) {
            for (int bb = 0; bb <= 2 * N; ++bb) {

                int a = aa - N;
                int b = bb - N;

                int as = x[i] - a + N;
                int bs = x[i] - b + N;

                if (as >= 0 && as <= 2 * N) {
                    dp[i & 1][aa][bb] |= dp[(i & 1) ^ 1][as][bb];
                }

                if (bs >= 0 && bs <= 2 * N) {
                    dp[i & 1][aa][bb] |= dp[(i & 1) ^ 1][aa][bs];
                }
            }
        }

        // cout << "q " << i << endl;
    }
    // cout << "f " << endl;
    int ans = -INF;

    for (int aa = 0; aa <= 2 * N; ++aa) {
        for (int bb = 0; bb <= 2 * N; ++bb) {
            int a = aa - N;
            int b = bb - N;

            if (dp[(m - 1) & 1][aa][bb]) ans = max(ans, a + b);
        }
    }

    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}