#include <bits/stdc++.h>
#define pb push_back

using namespace std;
using vi = vector<int>;
using pi = pair<int, int>;

const int INF = 1e9;
const int N = 800;
const int M = 400;


void solve() {
    int n, m;
    cin >> n >> m;

    vi x(m);

    for (int i = 0; i < m; ++i) cin >> x[i];

    queue<pair<int, pi>> q;

    q.push({0, {0, 0}});

    int ans = -INF;

    while (!q.empty()) {
        auto [id, pr] = q.front();
        auto [a, b] = pr;
        q.pop();

        if (id == m) {
            ans = max(ans, a + b);
            continue;
        } 

        q.push({id + 1, {x[id] - a, b}});
        q.push({id + 1, {a, x[id] - b}});
    }
    
    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}