#include <bits/stdc++.h>
using namespace std;
#define int int64_t
const int MAXN = 300001;
const int INF = int(1e9) * int(1e5);
vector<int> md(MAXN * 4);
vector<int> tr(MAXN * 4);
void build(int u, int l, int r) {
    if (l == r) {
        tr[u] = 0;
        md[u] = 0;
    }
    else {
        build(u * 2, l, (l + r) / 2);
        build(u * 2 + 1, (l + r) / 2 + 1, r);
        tr[u] = 0;
        md[u] = 0;
    }
}
void push(int u, int l, int r) {
    tr[u] += md[u];
    if (l != r) {
        md[u * 2] += md[u];
        md[u * 2 + 1] += md[u];
    }
    md[u] = 0;
}
int get(int u, int l, int r, int l2, int r2) {
    push(u, l2, r2);
    if (l > r2 || r < l2) {
        return INF;
    }
    if (l <= l2 && r2 <= r) {
        return tr[u];
    }
    return min(get(u * 2, l, r, l2, (l2 + r2) / 2),
               get(u * 2 + 1, l, r, (l2 + r2) / 2 + 1, r2));
}
void upd(int u, int l, int r, int l2, int r2, int x) {
    push(u, l2, r2);
    if (l > r2 || r < l2) {
        return;
    }
    if (l <= l2 && r2 <= r) {
        md[u] += x;
        push(u, l2, r2);
        return;
    }
    upd(u * 2, l, r, l2, (l2 + r2) / 2, x);
    upd(u * 2 + 1, l, r, (l2 + r2) / 2 + 1, r2, x);
    tr[u] = min(tr[u * 2], tr[u * 2 + 1]);
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> dp(n + 1, INF);
    dp[n] = 0;
    multiset<int> s;
    vector<int> x(m);
    bool ff = true;
    int ansans = 0;
    for (int i = 0; i < m; i++) {
        cin >> x[i];
        if (n == 1) {
            if ((m - i) % 2 == 1) {
                ansans += x[i];
            }
            else {
                ansans -= x[i];
            }
        }
        if (x[i] < 0) {
            ff = false;
        }
    }
    if (n == 1) {
        cout << ansans << '\n';
        return;
    }
    x.push_back(-1);
    reverse(x.begin(), x.end());
    build(1, 1, m);
    int cur = 0;
    int ans = 0;
    multiset<pair<int, int>> sg;
    for (int i = 1; i <= m; i++) {
        cur++;
        upd(1, i, m, 1, m, 1);
        sg.insert({x[i], -i});
        if (cur <= n) {
            ans += x[i];
        }
        else {
            cur -= 2;
            ans += x[i];
            while (sg.size() > 0) {
                auto it = sg.begin();
                int ind = (*it).second;
                ind *= -1;
                upd(1, ind, m, 1, m, -2);
                if (get(1, 1, m, 1, m) < 0) {
                    upd(1, ind, m, 1, m, +2);
                    sg.erase(it);
                }
                else {
                    ans -= x[ind] * 2ll;
                    sg.erase(it);
                    break;
                }
            }
        }
    }
    cout << ans << '\n';
}
int32_t main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
