#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using ordered_set = __gnu_pbds::tree<int, __gnu_pbds::null_type, less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

mt19937 rnd(time(0));

inline void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    for (auto &x: a) cin >> x;
    vector<vector<int>> dp(m + 1, vector<int>(n + 1, -1e9));
    reverse(all(a));
    dp[0][n] = 0;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j <= n; j++) {
            if ((j + 1) <= n) {
                dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] - a[i]);
            }
            if (j - 1 >= 0) {
                dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] + a[i]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; i++) {
        ans = max(ans, dp.back()[i]);
    }
    cout << ans << "\n";
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
}