#include <string>
#include <bitset>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

void fast() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cout << setprecision(8) << fixed;
}

ll mod = 1e9 + 7;
ll binpow(ll a, ll n) {
    ll res = 1;
    for (int i = 0; (1ll << i) <= n; ++i, a = a * a % mod) {
        if ((n >> i) & 1) res = res * a % mod;
    }
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> a(m);
    for (auto &el : a) cin >> el;
    priority_queue<ll> elems;
    for (int i = 0; i < n; ++i) {
        elems.push(0);
    }
    for (int i = 0; i < m; ++i) {
        int el = -elems.top();
        elems.pop();
        elems.push(-a[i] + el);
    }
    ll ans = 0;
    while (!elems.empty()) {
        ans -= elems.top();
        elems.pop();
    }
    cout << ans << '\n';
}   
int main() {
    fast();
    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}