#include <string>
#include <bitset>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

void fast() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cout << setprecision(8) << fixed;
}

ll mod = 1e9 + 7;
ll binpow(ll a, ll n) {
    ll res = 1;
    for (int i = 0; (1ll << i) <= n; ++i, a = a * a % mod) {
        if ((n >> i) & 1) res = res * a % mod;
    }
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> a(m);
    for (auto &el : a) cin >> el;
    ll ans = 0;
    for (ll i = 0; i < (1 << m); ++i) {
        ll cp = i;
        ll f = 0, s = 0;
        for (int j = 0; j < m; ++j) {
            if (cp & 1) {
                s = a[j] - s;
            } else {
                f = a[j] - f;
            }
            cp >>= 1;
        }
        ans = max(ans, f + s);
    }
    cout << ans << '\n';
}   
int main() {
    fast();
    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}