#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pii = pair<ll, ll>;
#define all(a) a.begin(), a.end()

const ll INF = 1e18;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> a(m);
    for (ll i = 0; i < m; ++i) {
        cin >> a[i];
    }
    reverse(all(a));
    vector<vector<ll>> dp(m + 1, vector<ll>(n + 1, -INF));
    dp[0][n] = 0;
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j <= n; ++j) if (dp[i][j] != -INF) {
            if (j - 1 >= 0)
                dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] + a[i]);
            if (j + 1 <= n)
                dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] - a[i]);
        }
    }
    ll ans = -INF;
    for (ll i = 0; i <= n; ++i)
        ans = max(ans, dp[m][i]);
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}

