// semenInRussia 2025
#include <cassert>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

const int N = 405, S = 600;
int offset = 405 * 405 * 2;
long long dp[N][S * 3][2];

const int64_t inf = 1e18;

template <typename T> void setmin(T &v, T p) { v = min(v, p); }
template <typename T> void setmax(T &v, T p) { v = max(v, p); }

void solve() {
  int n, m;
  cin >> n >> m;
  vector<int> x(m);

  for (int i = 0; i <= m; i++) {
    for (int j = 0; j < S * 3; j++) {
      dp[i][j][0] = +inf;
      dp[i][j][1] = -inf;
    }
  }

  for (auto &v : x) {
    cin >> v;
  }

  dp[0][offset][offset] = true;
  for (int i = 0; i < m; i++) {
    for (int a = -S; a < S; a++) {
      if (dp[i][a + offset][0] != +inf) {
        setmin(dp[i + 1][a + x[i] + offset][0], (x[i] - dp[i][a][0]));
        setmin(dp[i + 1][a + x[i] + offset][0], (x[i] - dp[i][a][1]));
        setmax(dp[i + 1][a + x[i] + offset][1], (x[i] - dp[i][a][0]));
        setmax(dp[i + 1][a + x[i] + offset][1], (x[i] - dp[i][a][1]));
      }
    }
  }

  long long ans = -1e18 - 100;
  for (long long a = -S; a < S; a++) {
    ans = max(dp[m][a][1] + a, ans);
  }

  cout << ans << "\n";
}

int main() {
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}