#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = int(1e9) + 7, lg = 20;
const ll inf = ll(2e18) + 36;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct Fast {
    void main() {
        int n, m;
        cin >> n >> m;
        vector<int> x(m);
        ll add = 0;
        for (auto &it: x) {
            cin >> it;
            add += abs(it);
        }
        ll S = add * 2 + 10;
        vector<ll> mn(S, inf), mx(S, -inf), mnt(S, inf), mxt(S, -inf), mne = mn, mxe = mx;
        mn[add] = mx[add] = 0;
        for (ll i = 0; i < m; i++) {
            for (ll j = 0; j < S; j++) {
                if (x[i] - (j - add) + add >= 0 && x[i] - (j - add) + add < S) {
                    mnt[x[i] - (j - add) + add] = min(mnt[x[i] - (j - add) + add], mn[j]);
                    mxt[x[i] - (j - add) + add] = max(mxt[x[i] - (j - add) + add], mx[j]);
                }
                mnt[j] = min(mnt[j], x[i] - mx[j]);
                mxt[j] = max(mxt[j], x[i] - mn[j]);
            }
            mn = mnt;
            mx = mxt;
            mnt = mne;
            mxt = mxe;
        }
        ll ans = -inf;
        for (ll i = 0; i < S; i++) {
            ans = max(ans, mx[i] + i - add);
        }
        cout << ans;
    }
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int testC;
    cin >> testC;
    while (testC--) {
        Fast().main();
        cout << '\n';
    }
    return 0;
}
