//#pragma GCC optimize("O3, unroll_loops")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <string>
#define int long long

using namespace std;

const int INF = 2e15, CNST = 1e5;

void solve() {
	int n, m;
	cin >> n >> m;
	vector <int> brr(m);
	for (int i = 0; i < m; i++) {
		cin >> brr[i];
	}
	vector <int> dp1(2 * CNST + 1, -INF), dp2(2 * CNST + 1, INF);
	dp1[0 + CNST] = brr[0];
	dp2[0 + CNST] = brr[0];
	dp1[brr[0] + CNST] = 0;
	dp2[brr[0] + CNST] = 0;
	vector <int> ndp1(2 * CNST + 1, -INF), ndp2(2 * CNST + 1, INF);
	for (int i = 0; i < m - 1; i++) {
		for (int a = -CNST; a <= CNST; a++) {
			if (dp2[a + CNST] != INF) {
				ndp1[a + CNST] = max(ndp1[a + CNST], brr[i + 1] - dp2[a + CNST]);
				ndp2[brr[i + 1] - a + CNST] = min(ndp2[brr[i + 1] - a + CNST], dp2[a + CNST]);
			}
			if (dp1[a + CNST] != -INF) {
				ndp1[brr[i + 1] - a + CNST] = max(ndp1[brr[i + 1] - a + CNST], dp1[a + CNST]);
				ndp2[a + CNST] = min(ndp2[a + CNST], brr[i + 1] - dp1[a + CNST]);
			}
		}
		swap(dp1, ndp1);
		swap(dp2, ndp2);
		ndp1.assign(2 * CNST + 1, -INF);
		ndp2.assign(2 * CNST + 1, INF);
	}
	int ans = -INF;
	for (int a = -CNST; a <= CNST; a++) {
		ans = max(ans, dp1[a + CNST] + a);
	}
	cout << ans << '\n';
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
