#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define itn int
#define int long long
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)
#define pii pair<int, int>
#define ff first
#define ss second
#define sz(a) (int)(a).size()
#define ll long long
#define ld long double

mt19937 rnd(time(0));

const int N = 1000;

int vsp[N + 1][N + 1];
int vsp1[N + 1][N + 1];

vector <itn> a, b;

void solve(){
    int n, m;
    cin >> n >> m;
    a.resize(2);
    b.resize(m);
    for (auto &x: b){
        cin >> x;
    }

    vsp1[N / 2][N / 2] = 1;

    for (itn i = 0; i < m; ++i){
        for (itn j = 0; j < N; ++j){
            for (itn k = 0; k < N; ++k){
                if (vsp1[j][k] == 0) continue;
                if (b[i] - k + N <= N) {
//                    cerr << i << ' ' << j << ' ' << b[i] - k + N << '\n';
                    vsp[j][b[i] - k + N] |= vsp1[j][k];
                }
                if (b[i] - j + N <= N) {
//                    cerr << i << ' ' << (b[i] - j + N) << ' ' << k << '\n';
                    vsp[(b[i] - j) + N][k] |= vsp1[j][k];
                }
            }
        }
        swap(vsp, vsp1);
        for (int j = 0; j < N; ++j){
            fill(all(vsp[j]), 0);
        }
    }
    int ans = 0;
    for (int i = 0; i < N; ++i){
        for (int j = 0; j < N; ++j){
            if (vsp1[i][j])
                ans = max(ans, i + j - N);
        }
    }
    cout << ans << '\n';
}

signed main(){
    cin.tie(nullptr) ->sync_with_stdio(false);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;
    while (t--){
        solve();
    }
}