#include <iostream>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <algorithm>
#include <assert.h>
using namespace std;

#define int long long
#define ll long long
#define vi vector<int>
#define pi pair<int, int>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define vpi vector<pi>
#define vvi vector<vi>

bool cmp(int a, int b) {
	return abs(a) < abs(b);
}

signed main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n, m;
		cin >> n >> m;
		vi vec(m);
		for (int i = 0; i < m; i++) {
			cin >> vec[i];
		}
		reverse(all(vec));
		multiset<int> slopes;
		int tt = 0;
		int ns = 1;
		for (int i = 0; i < m; i++) {
			tt -= vec[i];
			slopes.insert(-2 * vec[i]);

			if (i % 2 == 0) {
				tt -= *slopes.begin();
				slopes.erase(slopes.begin());
			}

			if (slopes.size() * 2 + (1 - (i & 1)) > n) {
				slopes.erase(slopes.find(*slopes.rbegin()));
			}
		}
		int ans = tt;
		int i = 0;
		for (int el : slopes) {
			tt -= el;
			ans = max(ans, tt);
		}
		cout << ans << '\n';
	}
}