#include <bits/stdc++.h>

using namespace std;

#define int long long
using ld = long double;
using ll = long long;
using pii = pair<int, int>;

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<int> x(m);
    for (int i = 0; i < m; ++i)
    {
        cin >> x[i];
    }
    reverse(x.begin(), x.end());
    if (m <= n)
    {
        int su = 0;
        for (int i = 0; i < m; ++i)
        {
            su += x[i];
        }
        cout << su << '\n';
        return;
    }
    int v = m - n;
    int pl = v / 2 + n;
    int mi = v - (v / 2);
    vector<pii> arr(m);
    for (int i = 0; i < m; ++i)
    {
        arr[i] = {x[i], i};
    }
    sort(arr.begin(), arr.end());
    vector<int> needed(m);
    for (int i = 0; i < mi; ++i)
    {
        needed[arr[i].second] = -1;
    }
    for (int i = 0; i < pl; ++i)
    {
        needed[arr[m - 1 - i].second] = 1;
    }
    set<pii> mis;
    set<pii> pls;
    for (int i = 0; i < m; ++i)
    {
        if (needed[i] == -1)
        {
            mis.insert({x[i], i});
        }
        else
        {
            pls.insert({x[i], i});
        }
        if (pls.size() < mis.size())
        {
            int j = i;
            // придется увеличить pl
            mis.erase({x[j], j});
            pls.insert({x[j], j});
        }
        if (pls.size() > mis.size() + n)
        {
            int j = i;
            // придется уменьшить pl
            pls.erase({x[j], j});
            mis.insert({x[j], j});
        }
    }
    int ans = 0;
    for (const auto [v, i] : mis)
    {
        ans -= v;
    }
    for (const auto [v, i] : pls)
    {
        ans += v;
    }
    cout << ans << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(0);
    ios::sync_with_stdio(0);

    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}