#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <array>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
const ll INF = 1e18;
void solve() {
	ll n, m;
	cin >> n >> m;
	vector<ll> x(m);
	for (ll i = 0; i < m; i++) {
		cin >> x[i];
	}
	reverse(all(x));
	ll res = 0;
	for (ll t : x) res += t;
	x.resize(n + m + 5, 0);
	ll l = 1, r = n;
	set<pair<ll, ll>> st;
	for (ll i = l; i <= r; i++) {
		st.insert({ x[i], i });
	}
	while (r < m) {
		res -= st.begin()->first * 2;
		st.erase(st.begin());
		st.insert({ x[r + 1], r + 1 });
		st.insert({ x[r + 2], r + 2 });
		st.erase({ x[l], l });
		st.erase({ x[l + 1], l + 1 });
		l += 2, r += 2;
	}
	cout << res << "\n";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}