#include <bits/allocator.h>
#pragma GCC optimize("O3,Ofast,no-stack-protector,unroll-loops,inline")
#pragma GCC target("avx2,popcnt,lzcnt,bmi2")
#include <bits/stdc++.h>
using ll = long long;
using namespace std;
const ll inf = 1e18 + 10ll;
int n, m;

ll get_ans(vector <ll> &a) {
    vector <vector <ll>> dp(2, vector <ll>(n + 1, -inf));
    int cur_bal = n;
    ll ans = 0ll;
    for (int j = 0; j < m; j++) {
        if (a[j] < 0) {
            if (cur_bal + 1 <= n) {
                cur_bal++;
                ans -= a[j];
            } else {
                cur_bal--;
                ans += a[j];
            }
        } else {
            if (cur_bal - 1 > -1) {
                cur_bal--;
                ans += a[j];
            } else {
                cur_bal++;
                ans -= a[j];
            }
        }
    }
    return ans;
}

void solve() {
    cin >> n >> m;
    vector <ll> a(m, 0);
    set <ll> val;
    int fl = 1;
    for (int i = 0; i < m; i++) {
        cin >> a[i];
        if (a[i] < 0) fl = 0;
        val.insert(a[i]);
    }
    if (fl) {
        if (n >= m) {
            cout << m * a[0] << endl;
            return;
        }
        if ((int) val.size() == 1) {
            ll ans = 1ll * (n - 1) * a[0];
            ans += ((m - (n - 1)) % 2 == 1 ? a[0] : 0ll);
            cout << ans << endl;
            return;
        }
    }
    reverse(a.begin(), a.end());
    ll ans = get_ans(a);
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    cin >> test;
    for (int i = 0; i < test; i++) {
        solve();
    }
}
