#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pp = pair<ll, ll>;
using ld = long double;

template <typename T>
istream &operator>>(istream &s, vector<T> &a)
{
    for (T &el : a)
    {
        s >> el;
    }
    return s;
}

template <typename T>
ostream &operator<<(ostream &s, vector<T> &a)
{
    for (T el : a)
    {
        s << el << ' ';
    }
    s << '\n';
    return s;
}

const ll maxm = 401, maxn = 2;
const ll inf = 1e18;

ll dp[maxm][1 << maxn];

void solve()
{
    ll n, m;
    cin >> n >> m;
    vector<ll> arr(m);
    cin >> arr;
    vector<ll> tmp(n);
    ll i = 0;
    for (ll el : arr)
    {
        tmp[i] = el - tmp[i];
        i = min(i + 1, n - 1);
    }
    ll ans = 0;
    for (ll el : tmp)
    {
        ans += el;
    }
    cout << ans << '\n';
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t;
    cin >> t;
    while (t--)
    {
        solve();
    }
}