#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1'000'000'000'000'000'000;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<ll> arr(m);
	for (ll i = 0; i < m; i++) {
		cin >> arr[i];
	}
	vector<ll> dp(n + 1, -INF);
	for (ll i = 0; i <= n; i++) {
		dp[i] = 0;
	}
	for (auto i : arr) {
		vector<ll> ndp(n + 1, -INF);
		for (ll co = 0; co <= n; co++) {
			if (dp[co] != -INF) {
				if (co < n) {
					assign_max(ndp[co + 1], dp[co] + i);
				}
				if (co > 0) {
					assign_max(ndp[co - 1], dp[co] - i);
				}
			}
		}
		dp = ndp;
	}
	cout << dp.back() << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	for (ll i = 0; i < t; i++) {
		solve();
	}
}
