#pragma GCC optmize("Ofast")
#include <bits/stdc++.h>
#define int long long

const int MAXN = 3 * 1e5 + 1;

signed main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int t;
    std::cin >> t;

    while (t--)
    {
        int n, m;
        std::cin >> n >> m;

        std::vector<int> x(m);
        for (int i = 0; i < m; i++)
        {
            std::cin >> x[i];
        }
        std::reverse(x.begin(), x.end());

        std::vector<std::vector<int>> dp(m, std::vector<int>(n + 1, -1e18));

        dp[0][n - 1] = x[0];
        for (int i = 1; i < m; i++)
        {
            for (int j = 0; j <= n; j++)
            {
                if (j > 0 && dp[i - 1][j - 1] != -1e18)
                {
                    dp[i][j] = std::max(dp[i][j], dp[i - 1][j - 1] - x[i]);
                }

                if (j < n && dp[i - 1][j + 1] != -1e18)
                {
                    dp[i][j] = std::max(dp[i][j], dp[i - 1][j + 1] + x[i]);
                }
            }
        }

        int max = -1e18;

        for (int i = 0; i <= n; i++)
        {
            max = std::max(max, dp[m - 1][i]);
        }
        std::cout << max << std ::endl;
    }
}