#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second
const ll inf = 1e9 + 7;
vector<ll> tree;
void build(ll v, ll l, ll r, vector<ll> &a) {
    if (r - l == 1) {
        tree[v] = a[l];
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v + 1, l, m, a);
    build(2 * v + 2, m, r, a);
}

void update(ll v, ll l, ll r, ll ql, ll qr, ll x) {
    if (l >= qr || r <= ql) {
        return;
    }
    if (l >= ql && r <= qr) {
        tree[v] = x;
        return;
    }
    ll m = (l + r) / 2;
    update(2 * v + 1, l, m , ql, qr, x);
    update(2 * v + 2, m, r, ql, qr, x);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}



void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> a(m);
    for(int i = 0; i < m; ++i) {
        cin >> a[i];
    }
    const ll sum = 2 * 400 * 400 + 2;
    vector<ll> dp(sum, -inf);
    ll zer = 400 * 400;
    dp[zer] = a[0];
    dp[zer + a[0]] = 0;
    for(int i = 1; i < m; ++i) {
        vector<ll> ndp(sum, -inf);
        for(int j = 0; j < sum; ++j) {
            if (dp[j] != -inf) {
                ndp[j] = max(ndp[j], -dp[j] + a[i]);
                ll real = j - zer;
                ll nw = j - 2 * real + a[i];
                if (nw >= 0 && nw < sum) {
                    ndp[nw] = max(ndp[nw], dp[j]);
                }
            }
        }
        dp = ndp;
    }
    ll mx = 0;
    for(int i = 0; i < sum; ++i) {
        if (dp[i] != -inf) {
            //cout << i - zer << ' ' << dp[i][j] << ' ' << j << '\n';
            mx = max(mx, i - zer + dp[i]);
        }
    }
    cout << mx;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll T = 1;
    cin >> T;
    while(T--) {
        solve();
        cout << '\n';
    }
    return 0;
}
