#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define fi first
#define se second
const ll inf = 1e17 + 7;
vector<ll> tree;
void build(ll v, ll l, ll r, vector<ll> &a) {
    if (r - l == 1) {
        tree[v] = a[l];
        return;
    }
    ll m = (l + r) / 2;
    build(2 * v + 1, l, m, a);
    build(2 * v + 2, m, r, a);
}

void update(ll v, ll l, ll r, ll ql, ll qr, ll x) {
    if (l >= qr || r <= ql) {
        return;
    }
    if (l >= ql && r <= qr) {
        tree[v] = x;
        return;
    }
    ll m = (l + r) / 2;
    update(2 * v + 1, l, m , ql, qr, x);
    update(2 * v + 2, m, r, ql, qr, x);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

vector<ll> col, h;

void dfs(ll v, ll color, vector<vector<ll>> &g) {
    col[v] = color;
    if (v == 0) {
        ll cnt = 0;
        for(auto u : g[v]) {
            h[u] = h[v] + 1;
            cnt++;
            dfs(u, cnt, g);
        }
    } else {
        for(auto u : g[v]) {
            h[u] = h[v] + 1;
            dfs(u, color, g);
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> a(m);
    set<ll> st;
    for(int i = 0; i < m; ++i) {
        cin >> a[i];
        st.insert(a[i]);
    }
    if ((int)st.size() == 2) {
        ll ch1 = 0, ch2 = 0;
        for(int i = 0; i < m; ++i) {
            if (a[i] == *st.begin()) {
                ch1++;
            } else {
                ch2++;
            }
        }
        ll cnt0 = 0, cnt1 = n;
        ll res = 0;
        for(int i = 0; i < m; ++i) {
            if (a[i] == *st.begin()) {
                ch1--;
                if (cnt1 - 1 >= ch2) {
                    cnt1--;
                    cnt0++;
                    res += a[i];
                } else {
                    cnt0--;
                    cnt1++;
                    res -= a[i];
                }
            } else {
                ch2--;
                if (cnt1 > 0) {
                    cnt1--;
                    cnt0++;
                    res += a[i];
                } else {
                    cnt0--;
                    cnt1++;
                    res -= a[i];
                }
            }
        }
        cout << res;
    } else {
        ll cnt0 = 0, cnt1 = n;
        ll res = 0;
        for(int i = 0; i < m; ++i) {
            if (cnt1 > 0) {
                cnt1--;
                cnt0++;
                res += a[i];
            } else {
                cnt0--;
                cnt1++;
                res -= a[i];
            }
        }
        cout << res;
    }

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll T = 1;
    cin >> T;
    while(T--) {
        solve();
        cout << '\n';
    }
    return 0;
}
