#include <iostream>
#include <vector>

#define int long long
constexpr int INF = 4e18;

void solve()
{
    int n, m;
    std::cin >> n >> m;
    std::vector<int> x(m);
    for (int i = 0; i < m; ++i)
        std::cin >> x[i];
    int res = -INF;
    for (int mask = 0; mask < 1 << m; ++mask) {
        int val1 = 0, val2 = 0;
        for (int i = 0; i < m; ++i) {
            if (mask >> i & 1)
                val1 = x[i] - val1;
            else
                val2 = x[i] - val2;
        }
        res = std::max(res, val1 + val2);
    }
    std::cout << res << '\n';
}

signed main()
{
    int t = 1;
#ifdef LOCAL
    freopen("stream/inb.txt", "r", stdin);
    freopen("stream/outb.txt", "w", stdout);
    std::cin >> t;
#else
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cin >> t;
#endif
    for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
        solve();
    }
    std::cout.flush();
    return 0;
}