#include <bits/stdc++.h>

using namespace std;
#define int int64_t
const int INF = 1e18;
void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> x(m + 1);
    for (int i = 1; i <= m; i++) {
        cin >> x[i];
    }
    bool dp[m + 1][m * 20 + 1][m * 20 + 1];
    for (int i = 0; i <= m; i++) {
        for (int s1 = 0; s1 <= 20 * m; s1++) {
            for (int s2 = 0; s2 <= 20 * m; s2++) {
                dp[i][s1][s2] = false;
            }
        }
    }
    dp[0][10 * m][10 * m] = true;
    for (int pr = 1; pr <= m; pr++) {
        for (int s1 = 0; s1 <= 20 * m; s1++) {
            for (int s2 = 0; s2 <= 20 * m; s2++) {
                if (dp[pr - 1][s1][s2] == false) {
                    continue;
                }
                s1 -= (10 * m);
                s2 -= (10 * m);
                dp[pr][x[pr] - s1 + (10 * m)][s2 + (10 * m)] = true;
                dp[pr][10 * m + s1][x[pr] - s2 + (10 * m)] = true;
            }
        }
    }
    int ans = -INF;
    for (int s1 = 0; s1 <= 20 * m; s1++) {
        for (int s2 = 0; s2 <= 20 * m; s2++) {
            if (dp[m][s1][s2] == false) {
                continue;
            }
            ans = min(ans, s1 - (10 * m) + s2 - (10 * m));
        }
    }
    cout << ans << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}


