#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<random>
#include<chrono>
#include<set>
#include<deque>
#define int long long
#define ll long long
#define ld long double
using namespace std;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> v(m);
	for (int i = 0; i < m; i++) {
		cin >> v[i];
	}
	reverse(v.begin(), v.end());
	vector<vector<int>> dp(m + 1, vector<int>(n + 1, -1e18));
	dp[0][n] = 0;
	for (int i = 0; i < m; i++) {
		for (int j = 0; j <= n; j++) {
			if (j) {
				dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] + v[i]);
			}
			if (j + 1 <= n) {
				dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] - v[i]);
			}
		}
	}
	cout << *max_element(dp[m].begin(), dp[m].end());

}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	cin >> t;
	//t = 1;
	while (t--) {
		solve();
	}
}
