#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
using ll = long long;

typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int inf = 1e9 + 7;
const ll inf_ = 1e18 + 7;
const int mod = 998244353;

struct Fast {
    void solve() {
        int n, m;
        cin >> n >> m;
        vector<int> b(m);
        for (auto &i: b) cin >> i;
        reverse(b.begin(), b.end());
        int ans = -inf_;
        vector<vector<vector<int>>> dp(m + 1, vector<vector<int>>(2, vector<int>(2, -inf_)));
        dp[0][0][0] = 0;
        for (int i = 1; i <= m; i++) {
            dp[i][0][0] = max({dp[i - 1][0][1] - b[i - 1], dp[i - 1][1][0] - b[i - 1]});
            dp[i][1][0] = max({dp[i - 1][1][1] - b[i - 1], dp[i - 1][0][0] + b[i - 1]});
            dp[i][0][1] = max({dp[i - 1][1][1] - b[i - 1], dp[i - 1][0][0] + b[i - 1]});
            dp[i][1][1] = max({dp[i - 1][1][0] + b[i - 1], dp[i - 1][0][1] + b[i - 1]});
        }
        ans = max({ans, dp.back()[0][0], dp.back()[1][0], dp.back()[0][1], dp.back()[1][1]});
        cout << ans;
    }
};

signed main() {
    int __ = 1;
    cin >> __;
    while (__--) {
        Fast().solve();
        cout << '\n';
    }
    return 0;
}
