#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cstdint>
using namespace std;
#define int long long

void solution();

int32_t main() {
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int t;
    cin >> t;
    while (t--) {
        solution();
    }
}


void solution() {
    int n, m;
    cin >> n >> m;

    vector<int> a(m);
    for (auto &x : a) {
        cin >> x;
    }

    reverse(a.begin(), a.end());

    vector<vector<int>> dp(m + 1, vector<int>(n + 1, -1e18));
    dp[0][n] = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (j > 0) {
                dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] + a[i]);
            }
            if (j < n) {
                dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] - a[i]);
            }
        }
    }

    cout << *max_element(dp.back().begin(), dp.back().end()) << '\n';
}