#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cstdint>
using namespace std;
#define int long long

void solution();

int32_t main() {
#ifdef LOCAL
    freopen("test", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int t;
    cin >> t;
    while (t--) {
        solution();
    }
}


void solution() {
    int n, m;
    cin >> n >> m;

    vector<int> a(m);
    for (auto &x : a) {
        cin >> x;
    }

    reverse(a.begin(), a.end());

    int sm = 0;
    int cnt = n;
    for (int i = 0; i < m; ++i) {
        if (cnt) {
            sm += a[i];
            cnt--;
        } else {
            sm -= a[i];
            cnt++;
        }
    }

    cout << sm << '\n';
}