#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

//#include <ext/pb_ds/assoc_containe.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template <class T> order_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//find_by_orede, order_of_key

#define int long long
#define all(a) (a).begin(), (a).end()

#pragma GCC optimize ("O3")
#pragma GCC target ("avx2")


const int inf = 1e18;


void solve() {
	int n, m; cin >> n >> m;
	vector<int> x(m);
	for (int& i : x) cin >> i;

	int res = -inf;
	for (int mask = 0; mask < (1 << m); ++mask) {
		int a = 0, b = 0;

		for (int i = 0; i < m; ++i) {
			if ((mask >> i) & 1) a = x[i] - a;
			else b = x[i] - b;
		}

		res = max(res, a + b);
	}
	cout << res << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t; cin >> t;
	while (t--) solve();
}