#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ld = long double;

int n, m;
ll f(int mask, vector <ll> & x) {
    int q = 0, w = 0;
    ll res = 0;
    for (int i=0; i < m; ++i) {
        if ((mask >> i) & 1) {
            if (q) {
                res -= x[i];
            } else {
                res += x[i];
            }
            q = 1 - q;
        } else {
            if (w) {
                res -= x[i];
            } else {
                res += x[i];
            }
            w = 1 - w;
        }
    }
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int ttt;
    cin >> ttt;
    while (ttt--) {
        cin >> n >> m;
        vector <ll> x(m);
        for (int i=0; i < m; ++i) {
            cin >> x[i];
        }
        reverse(x.begin(), x.end());
        ll ans = f(0, x);
        for (int mask=1; mask < (1 << m); ++mask) {
            ans = max(ans, f(mask, x));
        }
        cout << ans << "\n";
    }
    return 0;
}
