#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <climits>
#include <cmath>
#include <iomanip>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()
#define len(v) (ll)v.size()

mt19937 rnd(525252);

const ll INF = 1e9, SZ = 5e3, MOD = 1e9 + 7;
const ld eps = 1e-8, pi = acosl(-1);


void solve() {
    ll n, m; cin >> n >> m;
    vector<ll>x(m, 0);
    for (auto &i : x) cin >> i;
    if (n == 1){
        ll cur = 0;
        for (ll i = m - 1; i >= 0; --i){
            if ((m - i) % 2) cur += x[i];
            else cur -= x[i];
        }
        cout << cur;
        return;
    }
    vector<vector<vector<ll>>>dp(m + 1, vector<vector<ll>>(2, vector<ll>(2, 0)));
    if (m % 2 == 0){
        for (ll i = 2; i <= m; i += 2){
            dp[i][0][0] = max({dp[i-2][0][0] - x[i-2] + x[i-1],
                               dp[i-2][1][1] + x[i-2] + x[i - 1]});
            dp[i][1][1] = max({dp[i-2][1][1] + x[i-2] - x[i - 1],
                               dp[i-2][0][0] - x[i-2] - x[i - 1]});
        }
    }
    else{
        dp[1][0][0] = x[0];
        dp[1][1][1] = -x[0];
        for (ll i = 3; i <= m; i += 2){
            dp[i][0][0] = max({dp[i-2][0][0] - x[i-2] + x[i - 1],
                               dp[i-2][1][1] + x[i-2] + x[i - 1]});
            dp[i][1][1] = max({dp[i-2][1][1] + x[i-2] - x[i - 1],
                               dp[i-2][0][0] - x[i-2] - x[i - 1]});
        }
    }
    
    cout << dp[m][0][0];
}

int main()
{
	ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
//	freopen("in.txt", "r", stdin);
//	freopen("out.txt", "w", stdout);
    cin >> t;

	while (t--) {
		solve();
		cout << '\n';
	}
}
