#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using ll = long long;
using pii = pair<int, int>;
using ld = long double;

const int INF = 1e18;
const int MOD = 1e9 + 7;

int divup(int a, int b) {
    if (a % b == 0) return a / b;
    return a/ b + 1;
}

void wr(vector<int> a) {
    for (int i : a) cout << i << ' ';
    cout << '\n';
}
void wr(vector<pii> a) {
    for (pii i : a) cout << "{" << i.first << ", " << i.second << "} ";
    cout << '\n';
}


struct fenv {
    int n;
    vector<int> v;
    fenv (int n): n(n) {
        v.resize(n + 1, 0);
    }
    void add(int ind, int x) {
        for (int i = ind + 1; i <= n; i += i&-i) v[i] += x;
    }
    int pref(int r) {
        int res = 0;
        for (int i = r; i > 0; i -= i&-i) res += v[i];
        return res;
    }
};

void solve() {
    int n, m; cin >> n >> m;
    vector<int> x(m);
    for (int &i : x) cin >> i;
    reverse(all(x));
    if (n == 1) {
        int sum = 0;
        for (int i = 0; i < m; i++) {
            if (i % 2 == 0) sum += x[i];
            else sum -= x[i];
        }
        cout << sum << '\n';
        return;
    }
    vector<int> dp(n + 1, -INF);
    dp[0] = 0;
    for (int i = 0; i < m; i++) {
        vector<int> nw(n + 1, -INF);
        nw[0] = dp[1] - x[i];
        nw[n] = dp[n - 1] + x[i];
        for (int j = 1; j < n; j++) {
            nw[j] = max(dp[j - 1] + x[i], dp[j + 1] - x[i]);
        }
        //wr(nw);
        dp = nw;
    }
    int mx = -INF;
    for (int i = 0; i <= n; i++) {
        mx = max(mx, dp[i]);
    }
    cout << mx << '\n';
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1; cin >> tt;
    while (tt--) {
        //solve();
        int n, m; cin >> n >> m;
        vector<int> x(m);
        for (int &i : x) cin >> i;
        if (m % 2 == 0) cout << 0;
        else cout << -x[0];
        cout << '\n';
    }
}