#pragma GCC optimize("Ofast,inline")

#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define fi first
#define se second
mt19937 gen(time(0));

const int N = 4e2 + 12;
pair <int,int> dp[2][2*N*N];
int x[N];
int n, m;

void solve() {
    cin >> n >> m;
    for(int i = 0; i < m; ++i) {
        cin >> x[i];
    }
    for(int i = 0; i <= 1; ++i) {
        for(int was = -400 * m; was <= 400 * m; ++was) {
            dp[i][was+400*m] = {1e18, -1e18};
        }
    }
    dp[0][400*m] = {0, 0};
    for(int i = 0; i < m; ++i) {
        int f = (i % 2);
        for(int was = -400 * m; was <= 400 * m; ++was) {
            dp[1-f][was+400*m] = {1e18, -1e18};
        }
        for(int was = -400 * i; was <= 400 * i; ++was) {
            int nxt = x[i] - was;

            dp[1-f][nxt+400*m].fi = min(dp[1-f][nxt+400*m].fi, dp[f][was+400*m].fi);
            dp[1-f][nxt+400*m].se = max(dp[1-f][nxt+400*m].se, dp[f][was+400*m].se);

            dp[1-f][was+400*m].fi = min(dp[1-f][was+400*m].fi, x[i] - dp[f][was+400*m].se);
            dp[1-f][was+400*m].se = max(dp[1-f][was+400*m].se, x[i] - dp[f][was+400*m].fi);
        }
    }
    int ans = -1e18;
    for(int a = -400 * m; a <= 400 * m; ++a) {
        ans = max(ans, dp[m%2][a+400*m].se + a);
    }
    cout << ans << '\n';
    return;
}
int solve2() {
    int ans = -1e18;
    for(int mask = 0; mask < (1 << m); ++mask) {
        int a = 0, b = 0;
        for(int i = 0; i < m; ++i) {
            if(mask & (1 << i)) {
                a = x[i] - a;
            } else {
                b = x[i] - b;
            }
        }
        ans = max(ans, a + b);
    }
    return ans;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int qq;
    cin >> qq;
    while(qq--) {
        solve();
    }
//    while(true) {
//        n = 2;
//        m = gen() % 3;
//        m++;
//        for(int i = 0; i < m; ++i) {
//            x[i] = gen() % 5;
//        }
//        if(solve() != solve2()) {
//            cout << n << ' ' << m << '\n';
//            for(int i = 0; i < m; ++i) {
//                cout << x[i] << ' ';
//            }
//            cout << '\n';
//            cout << solve() << ' ' << solve2();
//            return 0;
//        }
//    }
    return 0;
}
