#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

#define int long long
const int oo = 1e18;

bool get_bit(int x, int d) {
	return x >> d & 1;
}

void solution() {
	int n, m;
	cin >> n >> m;
	vector <int> x(m);
	for (int i = 0; i < m; i++) {
		cin >> x[i];
	}
	vector <vector <int>> dp(1 << n, vector <int>(m + 1, -oo));
	for (int mask = 0; mask < (1 << n); mask++) {
		dp[mask][0] = 0;
	}
	for (int j = 0; j < m; j++) {
		for (int mask = 0; mask < (1 << n); mask++) {
			for (int i = 0; i < n; i++) {
				int nmask = mask ^ (1 << i);
				if (get_bit(mask, i)) {
					dp[nmask][j + 1] = max(dp[nmask][j + 1], dp[mask][j] + x[j]);
				} else {
					dp[nmask][j + 1] = max(dp[nmask][j + 1], dp[mask][j] - x[j]);
				}
			}
		}
	}
	cout << dp[0][m];
}

signed main() {
	int t;
	cin >> t;
	while (t--) {
		solution();
		cout << '\n';
	}
}