#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

//using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ld = long double;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18;
const int Max = 10;
ll ans;
int n, m;
vector<ll> x;

void make(int pos, ll a, ll b, int cnta, int cntb)
{
    if (pos == m)
    {
        if (cnta == 0 && cntb == 0)
        {
            ans = max(ans, a + b);
        }
        return;
    }
    if (cnta == cntb)
    {
        make(pos + 1, x[pos] - a, b, 1 - cnta, cntb);
        return;
    }
    if (cnta == 0)
    {
        if ((m - 1 - pos) % 2 == 0)
        {
            make(pos + 1, a, x[pos] - b, cnta, 1 - cntb);
        } else
        {
            make(pos + 1, x[pos] - a, b, 1 - cnta, cntb);
            make(pos + 1, a, x[pos] - b, cnta, 1 - cntb);
        }
    } else
    {
        if ((m - 1 - pos) % 2 == 1)
        {
            make(pos + 1, a, x[pos] - b, cnta, 1 - cntb);
            make(pos + 1, x[pos] - a, b, 1 - cnta, cntb);
        } else
        {
            make(pos + 1, a, x[pos] - b, cnta, 1 - cntb);
            make(pos + 1, x[pos] - a, b, 1 - cnta, cntb);
        }
    }
}

void solve()
{
    cin >> n >> m;
    x.assign(m, 0);
    for (int i = 0; i < m; ++i)
    {
        cin >> x[i];
    }
    vector<ll> a(n, 0);
    /*ans = -INF;
    for (int i = 0; i < 2; ++i)
    {
        for (int j = 0; j < 2; ++j)
        {
            make(0, 0, 0, i, j);
        }
    }
    cout << ans << '\n';*/
    /*int N = (1 << n);
    vector<vector<ll>> dp(m + 1, vector<ll>(N, 0));
    for (int i = 1; i <= m; ++i)
    {
        for (int msk = 0; msk < N; ++msk)
        {
            dp[i][msk] = -INF;
        }
        for (int msk = 0; msk < N; ++msk)
        {
            for (int j = 0; j < n; ++j)
            {
                ll cur = dp[i - 1][msk];
                if ((msk >> j) & 1)
                {
                    cur += x[i - 1];
                } else
                {
                    cur -= x[i - 1];
                }
                int nmsk = (msk ^ (1 << j));
                dp[i][nmsk] = max(dp[i][nmsk], cur);
            }
        }
    }
    ll mx = dp[m][0];
    cout << mx << '\n';*/
    vector<vector<ll>> dp(m + 1, vector<ll>(n + 1, 0));
    for (int i = 1; i <= m; ++i)
    {
        for (int msk = 0; msk <= n; ++msk)
        {
            dp[i][msk] = -INF;
        }
        for (int msk = 0; msk <= n; ++msk)
        {
            if (msk == 0)
            {
                ll cur = dp[i - 1][msk];
                cur -= x[i - 1];
                int nmsk = msk + 1;
                dp[i][nmsk] = max(dp[i][nmsk], cur);
                continue;
            }
            if (msk == n)
            {
                ll cur = dp[i - 1][msk];
                cur += x[i - 1];
                int nmsk = msk - 1;
                dp[i][nmsk] = max(dp[i][nmsk], cur);
                continue;
            }
            ll cur = dp[i - 1][msk];
            dp[i][msk + 1] = max(dp[i][msk + 1], cur - x[i - 1]);
            dp[i][msk - 1] = max(dp[i][msk - 1], cur + x[i - 1]);
        }
    }
    ll mx = dp[m][0];
    cout << mx << '\n';
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }

    return 0;
}
