#ifndef LOCAL
  // #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#ifndef LOCAL
  // #pragma GCC target("avx,avx2,fma")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

const int maxn = 30;
int t = 1;
int n, m;
mt19937 rng(2);

ll Calc(const vector<ll>& a, const bitset<maxn>& moves) {
  vector<ll> b(2);
  for (int i = 0; i < m; ++i) {
    if (moves[i] == 0) {
      b[0] = a[i] - b[0];
    } else {
      b[1] = a[i] - b[1];
    }
  }
  return b[0] + b[1];
}

int gen(int l, int r) {
  uniform_int_distribution<int> u(l, r);
  return u(rng);
}

void solve() {
  cin >> n >> m;
  vector<ll> a(m);
  for (auto& it : a) cin >> it;
  ll ans = 0;
  ll best = 0;
  bitset<maxn> moves;
  double time_case = 1e3 / t;
  auto s = clock();
  long double temp = 98;
  while ((clock() - s) < time_case) {
    auto mv = moves;
    mv.flip(rng() % m);
    ll cur = Calc(a, mv);
    if (cur > ans || gen(1, temp) > temp / 2) {
      ans = cur;
      best = max(best, cur);
      mv = moves;
    }
    temp *= 0.7;
  }
  cout << best << '\n';
}

signed main() {
  cin.tie(0)->sync_with_stdio(0);
  cin >> t;
  for (int i = 0; i < t; ++i) {
    solve();
  }
}