#ifndef LOCAL
  #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#ifndef LOCAL
  #pragma GCC target("avx,avx2,fma")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

void solve() {
  int n, m;
  cin >> n >> m;
  vector<ll> a(m);
  for (auto& it : a) cin >> it;
  set<pair<ll, ll>> dp, ndp;
  dp.insert({0, 0});
  for (int i = 0; i < m; ++i) {
    for (auto [j, k] : dp) {
      ndp.insert({a[i] - j, k});
      ndp.insert({j, a[i] - k});
    }
    dp = ndp;
    ndp.clear();
  }
  ll ans = -1e17;
  for (auto [i, j] : dp) ans = max(ans, i + j);
  cout << ans << '\n';
}

signed main() {
  // freopen("in", "r", stdin);
  cin.tie(0)->sync_with_stdio(0);
  int t = 1;
  cin >> t;
  for (int i = 0; i < t; ++i) {
    solve();
  }
}