#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <math.h>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) x.begin(),x.end()
#pragma GCC optimize("Ofast")
const ll INF = 1e9 + 7;
template<typename T>
void input(vector<T>& arr, size_t size) {
	arr.resize(size);
	for (T& i : arr) {
		cin >> i;
	}
}
template<typename T>
void print(vector<T>& arr) {
	for (T& i : arr) {
		cout << i << ' ';
	}
	cout << '\n';
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<ll> x(m);
	ll ans = 0, c = 0;
	for (ll i = 0; i < m; i++)
	{
		cin >> x[i];
	}
	ans = -(INF * INF);
	for (size_t i = 0; i < (1 << m); i++)
	{
		ll a = 0, b = 0;
		for (size_t j = 0; j < m; j++)
		{
			if ((i >> j) & 1) {
				a = x[j] - a;
			}
			else {
				b = x[j] - b;
			}
		}
		ans = max(ans, a + b);
	}
	cout << ans << '\n';
}

int main() {
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
#endif // _DEBUG
	ios::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	cin >> tt;
#ifdef _DEBUG
#endif // _DEBUG
	while (tt--)
	{
		solve();
#ifdef _DEBUG
		cout << "\n================\n";
#endif // _DEBUG
	}
}