#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/hash_policy.hpp>
using namespace std;
using namespace __gnu_pbds;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begoin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

#define mp make_pair

struct hs {
    const size_t  operator()(pair<int, int> v) const {
        return 1ll * (v.first >> 30) ^ v.second;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;

    vector<int> x(m);
    for (auto &i: x) {
        cin >> i;
    }

//    set<pair<ll, ll>> dp;
    gp_hash_table<pair<int, int>, int, hs> dp;
    dp[mp(0,0)] = 1;
    for (int i = 0; i < m; ++i) {
        gp_hash_table<pair<int, int>, int, hs> ndp;
        for (auto [p, v1]: dp) {
            auto [x1, x2] = p;

            ndp.insert(mp(mp(x1, x[i] - x2), 1));
            ndp.insert(mp(mp(x[i] - x1, x2), 1));
        }

        swap(dp,ndp);
    }

    int ans = -INFi;
    for (auto [p, v1]: dp) {
        auto [x1, x2] = p;

        ans = max(ans, x1 + x2);
    }

    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
#endif

    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}