//#pragma GCC target("avx, avx2")
#pragma GCC optimize("O3, Ofast, unroll-loops")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <iomanip>
#include <random>
#include <vector>
#include <map>


using namespace std;
using ll = long long;
const ll MAX = 1e18;
const ll MIN = -1e18;

#define all(a) a.begin(), a.end()
#define each(x, a) for(auto &x : a)


struct P {
	ll f, s;
};



void solve() {
	ll n, m;
	cin >> n >> m;
	vector<P> a(m);
	for (int i = 0; i < m; ++i) {
		cin >> a[i].f;
		a[i].s = i;
	}
	if (n != 2) {
		cout << "123\n";
		return;
	}
	reverse(all(a));
	ll ans = MIN;
	for (int mask = 0; mask < (1 << m); ++mask) {
		vector<ll> d(m, 0);
		for (int j = 0; j < m; ++j) {
			d[j] = ((mask >> j) & 1);
		}
		ll cur = 0;
		ll f = 1;
		for (int i = 0; i < m; ++i) {
			if (!d[i]) continue;
			cur += f * a[i].f;
			f *= -1;
		}
		f = 1;
		for (int i = 0; i < m; ++i) {
			if (d[i]) continue;
			cur += f * a[i].f;
			f *= -1;
		}
		ans = max(ans, cur);
	}
	cout << ans;
}


signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll t = 1;
	 cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}