#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) x.begin(), x.end()
#define ff first
#define ss second

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (ll i = 0; i < m; ++i) {
        cin >> x[i];
    }
    set<pll> s;
    s.emplace(0, 0);
    for (ll i = 0; i < m; ++i) {
        set<pll> news;
        for (auto [a, b] : s) {
            news.emplace(x[i] - a, b);
            news.emplace(a, x[i] - b);
        }
        s = news;
    }
    ll ans = LLONG_MIN;
    for (auto [a, b] : s) {
        ans = max(ans, a + b);
    }
    cout << ans << endl;
}

signed main() {
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
