#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define size(t) (int)t.size()
#define pb push_back
#define all(t) t.begin(), t.end()
#define rall(t) t.rbegin(), t.rend()

using namespace std;

const int N = 3e5 + 5, T = (1 << 21) + 7;

ll t[T], psh[T], dp[10][10];
int a[N], R;

void build(int v = 0, int l = 0, int r = R) {
    if (l == r) {
        t[v] = 0;
        return;
    }
    int lt = v * 2 + 1, rt = lt + 1, m = (l + r) / 2;
    build(lt, l, m);
    build(rt, m + 1, r);
    t[v] = 0;
}

void push(int v, int l, int r) {
    if (psh[v] == 0)
        return;
    int lt = v * 2 + 1, rt = lt + 1, m = (l + r) / 2;
    t[lt] += psh[v];
    t[rt] += psh[v];
    psh[lt] += psh[v];
    psh[rt] += psh[v];
    psh[v] = 0;
}

ll get(int p, int v = 0, int l = 0, int r = R) {
    if (l == p && r == p) {
        return t[v];
    }
    push(v, l, r);
    int lt = v * 2 + 1, rt = lt + 1, m = (l + r) / 2;
    if (p <= m)
        return get(p, lt, l, m);
    else
        return get(p, rt, m + 1, r);
}

void update(int ql, int qr, ll x, int v = 0, int l = 0, int r = R) {
    if (r < ql || qr < l) {
        return;
    }
    if (ql <= l && r <= qr) {
        t[v] += x;
        psh[v] += x;
        return;
    }
    push(v, l, r);
    int lt = v * 2 + 1, rt = lt + 1, m = (l + r) / 2;
    update(ql, qr, x, lt, l, m);
    update(ql, qr, x, rt, m + 1, r);
    t[v] = t[lt] + t[rt];
}

void solve() {
    int n, m, i, j;
    cin >> n >> m;
    int mx = 0;
    for (i = 1; i <= m; i++) {
        cin >> a[i];
        mx = max(mx, a[i]);
    }
    int l = m, r = m + n;
    R = 2 * m + n + 7;
    build();
    for (i = 1; i <= m; i++) {
        if (a[i] < mx) {
            l --;
            r --;
            update(l, l, -get(l) + get(l + 2) + a[i]);
            update(l + 1, r, -a[i]);
        }
        else {
            l ++;
            r ++;
            update(r, r, -get(r) + get(r - 2) - a[i]);
            update(l, r - 1, a[i]);
        }
        /*
        for (j = l; j <= r; j++) {
            cout << get(j) << ' ';
        }
        cout << '\n';
        */
    }
    /*
    for (i = 1; i <= m; i++) {
        dp[i][0] = dp[i - 1][1] + a[i];
        for (j = 1; j < n; j++) {
            dp[i][j] = max(dp[i - 1][j - 1] - a[i], dp[i - 1][j + 1] + a[i]);
        }
        dp[i][n] = dp[i - 1][n - 1] - a[i];
    }
    for (i = 0; i <= m; i++) {
        for (j = 0; j <= n; j++) {
            cout << dp[i][j] << ' ';
        }
        cout << '\n';
    }
    */
    cout << get(l) << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}


