#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include "ext/pb_ds/hash_policy.hpp"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/trie_policy.hpp"
#pragma GCC optimize("O3", "unroll-loops")
using namespace std;
using ll = long long;
const ll inf = 1e15;
struct qq{
    ll v = -inf;
};
struct solve{
    void run(){
        int n, m;
        cin >> n >> m;
        vector<ll> v(m);
        vector<unordered_map<ll, qq>> dp(m, unordered_map<ll, qq>());
        for(int i = 0; i < m; ++i){
            cin >> v[i];
        }
        reverse(v.begin(), v.end());
        if(n == 1){
            int res = 0;
            for(int i = 0; i < m; ++i){
                if(i%2 == 0){
                    res += v[i];
                }
                else{
                    res -= v[i];
                }
            }
            cout << res << "\n";
            return;
        }
        dp[0][1].v = v[0];
        vector<int> recalc_from;
        recalc_from.push_back(0);
        recalc_from.push_back(2);
        vector<int> new_rec;
        for(int i = 1; i < m; ++i){
            sort(recalc_from.begin(), recalc_from.end(), greater<ll>());
            ll cur_max = -1e18;
            while (!recalc_from.empty()){
                int ind = recalc_from.back();
                recalc_from.pop_back();
                // cout << "calced " << ind << endl;
                if(ind == 0){
                    dp[i][0].v = dp[i-1][1].v - v[i];
                }
                else if(ind == n){
                    dp[i][n].v = dp[i-1][n-1].v + v[i];
                }
                else{
                    dp[i][ind].v = max(dp[i-1][ind-1].v + v[i], dp[i-1][ind+1].v - v[i]);

                }
                if(dp[i][ind].v > cur_max){
                    cur_max = dp[i][ind].v;
                    if(ind - 1 >= 0){
                        new_rec.push_back(ind - 1);

                    }
                    if(ind + 1 <= n){
                        new_rec.push_back(ind + 1);
                    }
                }
            }
            swap(recalc_from, new_rec);
        }
        ll res = -inf;
        for(int i = 0; i <= n; ++i){
            res = max(res, dp[m-1][i].v);
        }
        cout << res << "\n";

    }
};

int main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(0);

#ifdef LOCAL
    freopen("main.in", "r", stdin);
    freopen("main.out", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--){
        solve().run();
    }

    return 0;
}
