#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (int i = 0; i < m; i++) {
        cin >> x[i];
    }
    ll mx = -1e18;
    for (int mask = 0; mask <= (1 << m); mask++) {
        vector<ll> v1, v2;
        for (int i = 0; i < m; i++) {
            if ((mask >> i) & 1) v1.push_back(x[i]);
            else v2.push_back(x[i]);
        }
        sort(v1.begin(), v1.end());
        sort(v2.begin(), v2.end());
        ll ans1 = 0, ans2 = 0;
        if (v1.empty() || v2.empty() || (int)v1.size() + (int)v2.size() != m) continue;
        for (int i = 0; i < (int)v1.size(); i++) {
            ans1 = v1[i] - ans1;
        }
        for (int i = 0; i < (int)v2.size(); i++) {
            ans2 = v2[i] - ans2;
        }
        mx = max(mx, ans1 + ans2);
    }
    cout << mx;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cout << '\n';
    }
    return 0;
}
