#include <iostream>
#include <vector>
#include <string>
#include <numeric>
#include <algorithm>
#include <unordered_map>
#include <map>
#include <set>
#include <unordered_set>

using namespace std;

using ll = long long;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t; cin >> t;
	while (t--) {
		ll n, m; cin >> n >> m;
		vector<ll> vec(m);
		for (int i = 0; i < m; i++) cin >> vec[i];
		reverse(vec.begin(), vec.end());
		vector<vector<ll>> dp(m + 1, vector<ll>(n + 1, -3e18));
		dp[0][0] = 0;
		for (int i = 0; i < m; i++) {
			for (int j = 0; j <= n; j++) {
				if (j < n) {
					dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] + vec[i]);
				}
				if (j > 0) {
					dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] - vec[i]);
				}
			}
		}
		ll ans = -3e18;
		for (auto p : dp[m]) ans = max(ans, p);
		cout << ans << endl;
	}
}