#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>

#define len(v) (int)((v).size())
#define ss second
#define ff first


typedef long long ll;

using namespace std;

const ll inf = 1e18;

void solve() {
	int n, m;
	cin >> n >> m;

	vector<int> x(m);
	for (int i = 0; i < m; ++i) {
		cin >> x[i];
	}

	reverse(x.begin(), x.end());

	vector<vector<ll>> dp(m + 1, vector<ll>(n + 1, -inf));

	dp[0][0] = 0ll;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n; ++j) {
			dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] + x[i]);
		}
		for (int j = 1; j <= n; ++j) {
			dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] - x[i]);
		}
	}

	ll ans = -inf;
	for (int i = 0; i <= n; ++i) {
		ans = max(ans, dp[m][i]);
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);

	int t = 1;
	   cin >> t;
	while (t--) solve();
}



