#define LOCAL
//#define SUKA
#ifdef SUKA
#pragma GCC optimize("O3")
#define GCC optimize("unroll-loops")
#endif
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr << #x << " = " << x << "\n";
#else
#define debug(x)
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using lll = __int128;
using ld = long double;

void solve() {
    int n,k;
    cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0;i<n;i++) {
        cin >> a[i];
    }
    int idx = std::max_element(a.begin(), a.end()) - a.begin();
    ll mx = *std::max_element(a.begin(), a.end());
    ll res = 0;
    for (int i = 0;i<n;i++) {
        if (i < idx) res = max(res, a[i] + i + 1);
        else if (i > idx) res = max(res, a[i] + i);
    }
    cout << mx + 1 + res;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}
