#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifndef DEBUG
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#endif

using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using pll = std::pair<ll, ll>;
using ld = long double;
using i128 = __int128;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    ll n, m;
    std::cin >> n >> m;
    std::vector<ll> dp(1001, -1e9), dp1(1001, 1e9);
    dp[500] = 0;
    dp1[500] = 0;
    for (int i = 0; i < m; ++i) {
        ll x;
        std::cin >> x;
        auto dp2 = std::vector<ll>(1001, -1e9), dp3 = std::vector<ll>(1001, 1e9);
        for (int j = -500; j <= 500; ++j) {
            if (dp[j + 500] != -1e9){
                dp3[j + 500] = std::min(dp3[j + 500], x - dp[j + 500]);
            }
            if (dp1[j + 500] != 1e9){
                dp2[j + 500] = std::max(dp2[j + 500], x - dp1[j + 500]);
            }
            if (-500 <= x - j && x - j <= 500){
                if (dp[j + 500] != -1e9) {
                    dp2[x - j + 500] = std::max(dp2[x - j + 500], dp[j + 500]);
                }
                if (dp1[j + 500] != 1e9) {
                    dp3[x - j + 500] = std::min(dp3[x - j + 500], dp1[j + 500]);
                }
            }
        }
        dp = dp2, dp1 = dp3;
    }
    ll ans = -1e9;
    for (int i = 0; i <= 1000; ++i) {
        ans = std::max(ans, i - 500 + dp[i]);
    }
    std::cout << ans << '\n';
}

int main() {
#ifdef DEBUG
    std::freopen("/home/olymp/CLionProjects/untitled/input.txt", "r", stdin);
#endif
    std::cin.tie(0)->std::ios::sync_with_stdio(0);
    int tt = 1;
    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
