#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll inf = 1e15;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (ll i = 0; i < m; i++) {
        cin >> x[i];
    }
    reverse(x.begin(), x.end());
    vector<vector<ll>> dp(m + 1, vector<ll>(n + 1, -inf));
    dp[0][n] = 0;
    for (ll i = 0; i < m; i++) {
        for (ll j = 0; j <= n; j++) {
            if (j > 0) {
                dp[i + 1][j - 1] = max(dp[i + 1][j - 1], dp[i][j] + x[i]);
            }
            if (j < n) {
                dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] - x[i]);
            }
        }
    }
    ll ans = -inf;
    for (ll i = 0; i <= n; i++) {
        ans = max(ans, dp[m][i]);
    }
    cout << ans << '\n';
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}
