#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi2")

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
template <typename T>
using ordered_set = __gnu_pbds::tree <T, __gnu_pbds::null_type, less <T>,
        __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template <typename T>
int sz(const T &x) {
    return static_cast <int> (x.size());
}

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int MAXN = 2e5;
const ll INF = 4e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-8;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector <ll> x(m);
        for (auto& i : x) {
            cin >> i;
        }
        if (n == 1) {
            ll ans = 0;
            for (int i = 0; i < m; i++) {
                ans = x[i] - ans;
            }
            cout << ans << '\n';
            continue;
        }
        vector <pair <int, int>> x_and_idx(m);
        for (int i = 0; i < m; i++) {
            x_and_idx[i] = {x[i], i};
        }
        sort(x_and_idx.begin(), x_and_idx.end());
        ll ans = 0;
        for (int i = 0; i < min(m, n - 2); i++) {
            ans += x_and_idx[i].first;
            x[x_and_idx[i].second] = INF;
        }
        vector <int> new_x;
        for (auto i : x) {
            if (i != INF) {
                new_x.emplace_back(i);
            }
        }
        if (!new_x.empty()) {
            ans += new_x.back();
            new_x.pop_back();
        }
        for (int i = sz(new_x) - 1; i >= 1; i -= 2) {
            ans += max(new_x[i], new_x[i - 1]) - min(new_x[i], new_x[i - 1]);
        }
        if (!new_x.empty() && sz(new_x) % 2) {
            ans += new_x[0];
        }
        cout << ans << '\n';
    }
    return 0;
}
