#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <climits>
#include <iomanip>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <queue>
#include <random>

#define int long long

#pragma GCC optimize("03,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using ll = long long;
using ld = long double;
using namespace std;

const ll INF = 1e18;


void solve() {
    int n, m;
    cin >> n >> m;
    multiset<int> val;
    int s = 0;
    for (int i = 0; i < n; i++){
        val.insert(0);
    }
    while (m--){
        int x;
        cin >> x;
        int el = *val.begin();
        s -= el;
        s += (x - el);
        val.insert(x - el);
        val.erase(val.find(el));
    }
    cout << s << "\n";
}


signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--){
        solve();
    }
    return 0;
}