#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
#include <climits>
#include <iomanip>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <string>
#include <queue>
#include <random>

#define int long long

#pragma GCC optimize("03,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using ll = long long;
using ld = long double;
using namespace std;

const ll INF = 1e18;


void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(m);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
	}
	reverse(a.begin(), a.end());
	if (n == 1) {
		int ans = 0;
		for (int i = 0; i < m; i++) {
			if (i % 2 == 0) {
				ans += a[i];
			}
			else {
				ans -= a[i];
			}
		}
		cout << ans;
		return;
	}
	multiset<int> pl;
	int cur = a[0];
	int bal = 1;
	for (int i = 1; i < m; i++) {
		if (bal != n) {
			cur += a[i];
			pl.insert(a[i]);
			bal++;
		}
		else {
			int val = *pl.begin();
			if (a[i] > val) {
				cur -= 2 * val;
				cur += a[i];
				pl.erase(pl.find(val));
				pl.insert(a[i]);
				bal--;
			}
			else {
				bal--;
				cur -= a[i];
			}
		}
	}
	cout << cur << "\n";
}


signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}