#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;


int main(int, char**) {
    cout << setprecision(15) << fixed;
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vector<ll> x(m);
        for (auto& el : x) {
            cin >> el;
        }
        set<pair<ll, ll>> dp;
        dp.insert({0, 0});
        for (ll i = 0; i < m; ++i) {
            set<pair<ll, ll>> newdp;
            for (auto [a, b] : dp) {
                newdp.insert({x[i] - a, b});
                newdp.insert({a, x[i] - b});
            }
            dp = newdp;
        }
        ll ans = -INF;
        for (auto [a, b] : dp) {
            ans = max(ans, a + b);
        }
        cout << ans << "\n";
    }



    return 0;
}
