#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
using ll = long long;
const ll inf = 1e18 + 52;


void solve() {
    int n, k;
    cin >> k >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll ans = -inf;
    for (int msk = 0; msk <= (1 << n); msk++) {
        ll s1 = 0;
        ll s2 = 0;
        for (int i = 0; i < n; i++) {
            if ((msk >> i) & 1) {
                s1 = a[i] - s1;
            }
            else {
                s2 = a[i] - s2;
            }
        }
        //cout << msk << " " << s1 << " " << s2 << endl;
        ans = max(ans, s1 + s2);
    }
    cout << ans << endl;
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }


}