#include <bits/stdc++.h>
#define fi first
#define se second
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;

const ll mod = 1e9+7;

ll bpow(ll a, ll n) {
    ll res = 1;
    while (n) {
        res *= a;
        if (n & 1) a *= a;
        n /= 2;
    }
    return res;
}

const int N = 5e5+52;
const int M = 2e3+52;

ll a[N];

void altay() {
    int n, m;
    cin >> n >> m;
    map<pair<ll,ll>, bool> dp[m+2];

    dp[0][{0,0}] = 1;
    for (int i = 1; i <= m; i++) {
        ll b;
        cin >> b;
        for (auto it : dp[i-1]) {
            dp[i][{b-it.fi.fi,it.fi.se}] = 1;
            dp[i][{it.fi.fi,b-it.fi.se}] = 1;
        }
    }

    ll ans = -1e18;
    for (auto it : dp[m]) {
        ans = max(ans, it.fi.fi + it.fi.se);
    }

    cout << ans << "\n";
 }

int main() {

    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        altay();
    }

    return 0;
}
