#ifdef ONPC
    #define _GLIBCXX_DEBUG
#endif // ONPC

#include <bits/stdc++.h>

#define watch(x) cerr << #x << ": " << x << endl;

using namespace std;

#define all(v) begin(v), end(v)

typedef long long ll;

typedef pair<int, int> Pint;
typedef pair<ll, ll> Pll;

const int inf = 1e9 + 10;
const ll INF = ll(1e18) + 10;

const int maxn = 1600 + 10;

template<class T>
bool chmax(T &a, const T &b) {
    return (a < b ? a = b, true : false);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> x(m + 2);
    for (int i = 1; i <= m; ++i) {
        cin >> x[i];
    }
    reverse(all(x));

    vector<vector<vector<ll>>> dp(m + 1, vector<vector<ll>>(n + 1, vector<ll>(n + 1, -INF)));
    dp[0][n][0] = 0;
    for (int i = 1; i <= m; ++i) {
        for (int p = 0; p <= n; ++p) {
            int q = n - p;
            ll cur = 0;
            for (int j = i; j > 0; --j) {
                cur += x[j] * (j & 1 ? +1 : -1);
                if (p - 1 >= 0 && q + 1 <= n) {
                    if (j & 1) {
                        chmax(dp[i][p][q], dp[j - 1][p - 1][q + 1] - cur);
                    } else {
                        chmax(dp[i][p][q], dp[j - 1][p - 1][q + 1] + cur);
                    }
                }
                if (p + 1 <= n && q - 1 >= 0) {
                    if (j & 1) {
                        chmax(dp[i][p][q], dp[j - 1][p + 1][q - 1] + cur);
                    } else {
                        chmax(dp[i][p][q], dp[j - 1][p + 1][q - 1] - cur);
                    }
                }
            }
        }
    }

    ll ans = -INF;
    for (int i = 0; i <= n; ++i) {
        chmax(ans, dp[m][i][n - i]);
    }

//    for (int i = 0; i <= m; ++i) {
//        ll cur = -INF;
//        for (int j = 0; j <= n; ++j) {
//            if (chmax(cur, dp[i][j][n - j])) {
//                watch(j);
//            }
//        }
//        watch(cur);
//    }

    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
