#include <bits/stdc++.h>

using namespace std;

#define int long long

mt19937 rnd(14);

const int MAXN = 3e5 + 5;

vector<int> p(MAXN), mn(MAXN, 1000000000000), k(MAXN), s(MAXN), h(MAXN);
vector<vector<int>> g(MAXN);
map<int, vector<int>> mx;
vector<int> ccc;

void setk(int v, int x) {
    ccc.emplace_back(s[v]);
    k[v] = x;
    for (auto &i : g[v]) {
        setk(i, x);
    }
}

void dfs(int v) {
    mn[v] = min(mn[p[v]], s[v]);
    h[v] = h[p[v]] + 1;
    for (auto &i : g[v]) {
        dfs(i);
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        p[i] = x;
        g[x].emplace_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (auto &i : g[0]) {
        ccc.clear();
        setk(i, i);
        mx[i] = ccc;
    }
    for (auto &i : mx) {
        for (int j = 1; j < (int)i.second.size(); ++j) {
            i.second[j] = max(i.second[j],i.second[j - 1]);
        }
    }
    for (auto &i : g[0]) {
        dfs(i);
    }
    while (q--) {
        int x;
        cin >> x;
        --x;
        if (x == 0) {
            cout << 0 << '\n';
            return;
        }
        int curk = k[x];
        int c = mn[x];
        int sum = h[x], maxi = 0;
        for (auto &i : mx) {
            if (i.first == curk) {
                continue;
            }
            int l = -1, r = i.second.size();
            while (r - l > 1) {
                int mid = (r + l) / 2;
                if (i.second[mid] < c) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            sum += r;
            maxi = max(maxi, r);
        }
        cout << sum - maxi << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
