#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(vec) vec.begin(), vec.end()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fi first
#define se second
#define int ll

mt19937_64 rnd;

ll INF = 1e9;

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> x(m);
    for (auto &now : x) cin >> now;
    if (n == 1) {
        ll ans = 0;
        for (auto now : x) ans = now - ans;
        cout << ans << "\n";
    } else if (n == 2) {
        ll ans = -INF;
        for (int mask = 0; mask < (1 << m); mask++) {
            bitset<18> M = mask;
            ll a1 = 0, a2 = 0;
            for (int i = 0; i < m; i++) {
                if (M[i]) {
                    a1 = x[i] - a1;
                } else {
                    a2 = x[i] - a2;
                }
            }
            ans = max(ans, a1 + a2);
        }
        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
