#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

const int maxn = 3e5;
vector<int> g[maxn];
int s[maxn], rs[maxn], p[maxn], cy[maxn];

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, q;
	cin >> n >> q;
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
		g[p[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	set<pair<int, int>> st, cn;
	st.insert({ s[0], 0 });
	int cr = 0;
	while (!st.empty()) {
		auto v = (*st.rbegin()).second;
		st.erase(*st.rbegin());
		for (auto u : g[v]) {
			st.insert({ s[u], u });
		}
		int u = v;
		while (u != 0) {
			u = p[u];
			cn.erase({ cy[u], u });
		}
		rs[v] = cr;
		if (!cn.empty()) {
			rs[v] -= (*cn.rbegin()).first;
		}
		u = v;
		while (u != 0) {
			u = p[u];
			cy[u] += 1;
			cn.insert({ cy[u], u });
		}
		cy[v] = 1;
		cn.insert({ 1, v });
		++cr;
	}
	for (int i = 0; i < q; ++i) {
		int f;
		cin >> f;
		cout << rs[f-1] << ' ';
	}

	return 0;
}
