#include <bits/stdc++.h>

using namespace std;
const int MAXN = 3e5 + 1;
vector<int> g[MAXN], queries;
int parent[MAXN], s[MAXN], ans[MAXN], val[MAXN];


int add[MAXN];
multiset<int> vals;


void gather(int u) {
    for (int v : g[u]) {
        gather(v);
        add[u] += add[v];
        add[v] = 0;
    }
    val[u] += add[u];
    if (u != 1) vals.insert(val[u]);
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        parent[i] = p;
        g[p].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        ans[i] = MAXN;
        cin >> s[i];
    }
    while (q--) {
        int v;
        cin >> v;
        ans[v] = -1;
        queries.push_back(v);
    }

    int timer = 0;
    set<pair<int, int>, greater<>> rm = {{0, 1}};
    while (!rm.empty()) {
        auto [_, u] = *rm.begin();
        rm.erase(rm.begin());
        for (int v: g[u]) {
            rm.emplace(s[v], v);
        }

        if (ans[u] == -1) {
            vals.clear();
            gather(1);
            add[1] = 0;
            int v = parent[u];
            while (v > 1) {
                vals.erase(vals.find(val[v]));
                v = parent[v];
            }
            ans[u] = timer;
            if (!vals.empty())  {
                ans[u] -= *vals.rbegin();
            }
            v = u;
            while (v > 1) {
                val[v]++;
                vals.insert(val[v]);
                v = parent[v];
            }
        } else {
            add[u]++;
        }
        timer++;
    }


    for (int v : queries) {
        cout << ans[v] << " ";
    }
    return 0;
}
