#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 3e5 + 1;

int par[N], s[N];
vector<vector<int>> g(N);
int depth[N];

void dfs(int v) {
    for (auto& u: g[v]) {
        depth[u] = depth[v] + 1;
        dfs(u);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    int r1 = -1, r2 = -1;
    for (int i = 2; i <= n; ++i) {
        cin >> par[i];
        g[par[i]].push_back(i);

        if (par[i] == 1) {
            if (r1 == -1) r1 = i;
            else r2 = i;
        }
    }

    for (int i = 1; i <= n; ++i) {
        cin >> s[i];
    }

    dfs(1);

    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;

        cout << depth[v] - depth[1] << "\n";
    }

    return 0;
}
