#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = (int) 1e5 * 3 + 10;

vector<int> g[N];

int p[N], s[N], ans[N], comp[N], cur = 0;

vector<int> tour;

void gfs(int v) {
    comp[v] = cur;
    for (auto u: g[v])
        if (u != p[v])
            gfs(u);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    p[0] = -1;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        --p[i], g[p[i]].emplace_back(i);
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    for (auto v: g[0])
        ++cur, gfs(v);
    vector<int> neigh = g[0];
    int ver = 0;
    while ((int) tour.size() < n) {
        tour.emplace_back(ver);
        ver = -1;
        for (auto u: neigh) {
            if (ver == -1 || s[u] > s[ver])
                ver = u;
        }
        vector<int> new_neigh;
        for (auto u: neigh) {
            if (u != ver) new_neigh.emplace_back(u);
            else for (auto uu: g[u]) new_neigh.emplace_back(uu);
        }
        neigh = new_neigh;
    }
    int cnt[n + 1];
    for (int i = 0; i <= n; i++) cnt[i] = 0;
    for (int i = 0; i < n; i++) {
        if (i > 0)
            cnt[comp[tour[i]]]++;
        int mx = 0;
        for (int j = 1; j <= cur; j++)
            if (j != comp[tour[i]])
                mx = max(mx, cnt[j]);
        ans[tour[i]] = i - mx;
    }
    for (int i = 0; i < q; i++) {
        int v;
        cin >> v;
        cout << ans[v - 1] << " ";
    }
    return 0;
}