#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = (int) 1e5 * 3 + 10;

vector<int> g[N];

int p[N], s[N], ans[N], cur = 0;

int t[4 * N], add[4 * N];

void push(int v, int l, int r) {
    if (add[v] == 0) return;
    t[v] += add[v];
    if (l != r)
        add[v * 2] += add[v], add[v * 2 + 1] += add[v];
    add[v] = 0;
}

void update(int v, int l, int r, int tl, int tr, int val) {
    push(v, l, r);
    if (l > tr || r < tl)
        return;
    if (l >= tl && r <= tr) {
        add[v] += val;
        push(v, l, r);
        return;
    }
    int mid = (l + r) / 2;
    update(v * 2, l, mid, tl, tr, val);
    update(v * 2 + 1, mid + 1, r, tl, tr, val);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int get_max() {
    push(1, 0, N - 1);
    return t[1];
}

int head[N], cnt[N], sz[N], how_many = 0;

void calc(int v) {
    sz[v] = 1;
    for (auto u: g[v])
        calc(u), sz[v] += sz[u];
}

void dfs(int v) {
    cnt[v] = how_many++;
    for (auto &u: g[v])
        if (sz[u] > sz[g[v][0]])
            swap(u, g[v][0]);
    for (auto u: g[v]) {
        if (u == g[v][0])
            head[u] = head[v];
        else head[u] = u;
        dfs(u);
    }
}

void Add(int v, int val) {
    while (true) {
        update(1, 0, N - 1, cnt[head[v]], cnt[v], val);
        if (p[head[v]] == -1) break;
        v = p[head[v]];
    }
}

vector<int> tour;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    p[0] = -1;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        --p[i], g[p[i]].emplace_back(i);
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    head[0] = 0;
    calc(0), dfs(0);
    set<pair<int, int>> neigh;
    for (auto u: g[0])
        neigh.insert({s[u], u});
    int ver = 0;
    while ((int) tour.size() < n) {
        tour.emplace_back(ver);
        if (!neigh.empty()) {
            ver = neigh.rbegin()->second;
            neigh.erase({s[ver], ver});
            for (auto u: g[ver])
                neigh.insert({s[u], u});
        }
    }
    for (int i: tour) {
        Add(i, -(int) 1e15);
        ans[i] = cur - (get_max() < -(int) 1e10 ? 0 : get_max());
        cur++;
        Add(i, (int) 1e15 + 1);
    }
    for (int i = 0; i < q; i++) {
        int v;
        cin >> v;
        cout << ans[v - 1] << " ";
    }
    return 0;
}