#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

// #define int long long

template <typename T>
using ordered_set =
    tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)((x).size()))

using ll = long long;
using ld = long double;

const ll INF = 3e18;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int N = 3e5 + 31;

vector<int> g[N];
int s[N];
int par[N];
int depth[N];
int ppar[N];
int ans[N];
int cnt;

void dfs(int v, int c, int pp) {
    ppar[v] = pp;
    if (s[v] >= c)
        ++cnt;
    for (int u : g[v]) {
        dfs(u, c, pp);
    }
}

void solve() {
    int n;
    cin >> n;
    int q;
    cin >> q;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        par[i] = p;
        g[p].push_back(i);
        depth[i] = depth[p] + 1;
        assert(p < i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        --s[i];
    }
    for (int u : g[0]) {
        cnt = 0;
        dfs(u, s[u], u);
        cnt = (n - s[u]) - cnt;
        ans[u] = cnt;
    }
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        --v;
        if (v == 0) cout << 0 << ' ';
        else cout << ans[ppar[v]] + depth[v] << ' ';
    }
}

signed main() {
#ifdef LOCALEGOR
    freopen("INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}