#include <bits/stdc++.h>
#define all(v) (v).begin(), (v).end()

using namespace std;

template<class C> using vec = vector<C>;
using vi = vector<int>;
using pii = pair<int, int>;
using vpi = vec<pii>;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, tt;
    cin >> n >> tt;
    vi p(n);
    vi pot;
    vec<vi> g(n);
    for (int i = 1; i < n; i++) {
        int pr;
        cin >> pr;
        pr--;
        if (pr == 0) {
            pot.push_back(i);
        }
        g[pr].push_back(i);
    }
    vi s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    vi old_s = s;
    vi ans(n, n);
    for (int i : pot) {
        s = old_s;
        s[i] = 0;
        priority_queue<pii> q;
        q.emplace(s[0], 0);
        int d = 0;
        while (!q.empty()) {
            int v = q.top().second;
            ans[v] = min(ans[v], d++);
            q.pop();
            for (auto& to : g[v]) {
                q.emplace(s[to], to);
            }
        }
    }
    while (tt--) {
        int u;
        cin >> u;
        u--;
        cout << ans[u] << ' ';
    }
}