#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <iomanip>
#include <map>
#include <set>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <fstream>
#include <random>
using namespace std;

#define all(x) x.begin(), x.end()
#define fi first
#define se second
#define pub push_back
#define pob pop_back
#define for0(i,n) for(ll i = 0; i < ll(n); i++)

typedef long long ll;
typedef double long dl;
typedef vector<ll> vll;
typedef vector<pair<ll,ll>> vpll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<int> vi;
typedef vector<pair<int,int>> vpi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef tree<ll, null_type, less_equal<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_multiset;


template<typename T1, typename T2>
ostream& operator <<(ostream& out, pair<T1, T2>& a){
    out << a.fi << " " << a.se << endl;
    return out;
}

template<typename T1, typename T2>
istream& operator <<(istream& in, pair<T1, T2>& a){
    in >> a.fi >> a.se;
    return in;
}

template<typename T>
istream& operator >>(istream& in, vector<T>& a){
    for(T& ai : a) in >> ai;
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<T>& a){
    for(T& ai : a) out << ai << " ";
    return out;
}

template<typename T>
istream& operator >>(istream& in, vector<vector<T>>& a){
    for(vector<T>& ai : a){
        for(T& aii : ai) in >> aii;
    }
    return in;
}

template<typename T>
ostream& operator <<(ostream& out, vector<vector<T>>& a){
    for(vector<T>& ai : a){
        for(T& aii : ai) out << aii << " ";
        out << endl;
    }
    return out;
}

int n, q;
vvi g;
vi pr;
vi mnpath;
vi a;
vi dist;
const int INF = 1e9 + 7;

void dfs(int v, int mnpathval=INF, int d = 0){
    mnpathval = min(mnpathval, a[v]);
    mnpath[v] = mnpathval;
    dist[v] = d;
    for (int u : g[v]){
        dfs(u, mnpathval, d+1);
    }
}

void solve(){
    cin >> n >> q;
    g = vvi(n);
    pr = vi(n);
    a = vi(n);
    mnpath = vi(n);
    dist = vi(n);
    for(int i = 1; i < n; i++){
        int p;
        cin >> p;
        p--;
        g[p].pub(i);
        pr[i] = p;
    }
    cin >> a;
    dfs(0);
    while(q--){
        int v;
        cin >> v;
        v--;
        cout << dist[v] << endl;
    }
}

int main()
{
    srand(42);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
