#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>

using namespace std;

using ll = long long;

#pragma GCC optimaze("Ofast");

vector<vector<int>> gr;
vector<ll> s;

void dfs(int v, ll& su, ll x) {
	if (s[v] <= x) return;
	su++;
	for (int u : gr[v]) dfs(u, su, x);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	ll n, q;
	cin >> n >> q;
	gr.resize(n);
	vector<int> p(n, -1);
	s.resize(n);
	for (int i = 1; i < n; i++) {
		int x;
		cin >> x;
		x--;
		p[i] = x;
		gr[x].push_back(i);
	}
	for (int i = 0; i < n; i++) cin >> s[i];
	while (q--) {
		int v;
		cin >> v;
		v--;
		int V = v;
		v = p[v];
		ll su = 0;
		ll ma = 0;
		int la = V;
		while (v != -1) {
			su++;
			for (int u : gr[v]) {
				if (u == la) continue;
				ll su2=0;
				dfs(u, su2, s[V]);
				ma = max(ma, su2);
				su += su2;
			}
			la = v;
			v = p[v];
		}
		cout << su - ma << " ";
	}
}



