#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}


vector<vector<int>> g;
int timer = 0;
vector<int> tin, tout, siz;
void dfs1(int v) {
    tin[v] = timer++;
    siz[v] = 1;
    for (int nxt:g[v]) {
        dfs1(nxt);
        siz[v] += siz[nxt];
    }
    tout[v] = timer++;
}
bool check(int a, int b) {
    return tin[a]<=tin[b] && tout[a]>=tout[b];
}


vector<int> nums;
vector<int> anses;
void dfs(int v, int add, int mx) {
    anses[v] = add - mx;
    sort(g[v].begin(), g[v].end(), [&](int a, int b){
        return nums[a] > nums[b];
    });

    add++;
    for (int nxt:g[v]) {
        dfs(nxt, add, mx);
        add += siz[nxt];
        mx = max(mx, siz[nxt]);
    }
}


int main() {
//    cout.setf(ios::fixed); cout.precision(15);
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int n, qq;
    cin >> n >> qq;
    g.resize(n); tin.resize(n); tout.resize(n); siz.resize(n);
    for (int i=1; i<n; i++) {
        int x; cin >> x; x--;
        g[x].push_back(i);
    }
    dfs1(0);
    nums.resize(n);
    for (int i=0; i<n; i++) cin >> nums[i];

    anses.resize(n);
    dfs(0, 0, 0);

    for (int i=0; i<qq; i++) {
        int x; cin >> x; x--;
        cout << anses[x] << ' ';
    }



    return 0;
}