//#pragma GCC optimize("O3")
#include <bits/stdc++.h>
//#pragma GCC target("avx, avx2, tune=native")
#define int long long
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
#define pi pair<int, int>


using namespace std;

vector<vector<int>> g;
vector<int> tin, tout;
int T = 0;

void precalc(int u, int p) {
    tin[u] = T++;
    for (auto& v : g[u]) {
        if (v == p) continue;
        precalc(v, u);
    }
    tout[u] = T++;
}

vector<int> sum, val;
int cur = 0, res = 0;

void dfs(int u, int p) {
    sum[u] = val[u];
    if (u == cur) return;
    for (auto& v : g[u]) {
        if (v == p) continue;
        dfs(v, u);
        sum[u] += sum[v];
    }
    if (!(tin[u] <= tin[cur] && tout[u] >= tout[cur])) res = max(res, sum[u]);
}

void solve() {
    int n, q;
    cin >> n >> q;
    g.assign(n, {});
    tin.assign(n, 0);
    tout.assign(n, 0);
    vector<int> s(n), col(n);
    int c = 0;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        if (p == 0) {
            col[i] = c++;
        } else {
            col[i] = col[p];
        }
        g[p].push_back(i);
    }
    precalc(0, 0);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        s[i] = -s[i];
    }
    set<pi> st;
    vector<int> pos(n);
    int cnt = 0;
    st.insert({0, 0});
    while (!st.empty()) {
        int u = st.begin()->s;
        pos[u] = cnt++;
        st.erase(st.begin());
        for (auto& v : g[u]) {
            st.insert({s[v], v});
        }
    }

    for (int i = 0; i < q; ++i) {
        int u;
        cin >> u;
        --u;
        val.assign(n, 0);
        sum.assign(n, 0);
        for (int j = 0; j < n; ++j) {
            val[j] = pos[j] < pos[u];
        }
        cur = u;
        res = 0;
        dfs(0, 0);
        cout << pos[u] - res << " \n"[i == q - 1];
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
