#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define vi vector<ll>
#define vii vector<vi>
#define vip vector<pair<ll, ll>>
#define viip vector<vip>
#define endl '\n'
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll N = 3e5;

vii g(N);
vi ans(N, N - 1), s(N), sz(N);

void dfs1(ll v) {
    sz[v] = 1;
    vip gg;
    for (ll to: g[v]) {
        gg.pb({s[to], to});
    }
    sort(rall(gg));
    for (ll i = 0; i < g[v].size(); i++) {
        g[v][i] = gg[i].second;
    }
    for (ll to : g[v]) {
        dfs1(to);
        sz[v] += sz[to];
    }
}

void dfs2(ll v, ll sum, ll mx) {
    ans[v] = sum - mx;
    sum++;
    for (ll to : g[v]) {
        dfs2(to, sum, mx);
        sum += sz[to];
        mx = max(mx, sz[to]);
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    for (ll i = 1; i < n; i++) {
        ll x;
        cin >> x;
        x--;
        g[x].pb(i);
    }
    for (ll i = 0; i < n; i++) {
        cin >> s[i];
    }
    dfs1(0);
    dfs2(0, 0, 0);
    while (q--) {
        ll v;
        cin >> v;
        v--;
        cout << ans[v] << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
