#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//using ll = int;
using ld = long double;
using ull = unsigned long long;
#define pb push_back
#define all(vec) vec.begin(), vec.end()
#define eb emplace_back
#ifdef LOCAL
#define deb(x) cout << #x << " = " << x << '\n'
#else
#define deb(x) 52
#endif
const ll inf = 1e9 + 11;
const long long INF = (long long)2e18 + 11;
const ll P = 73;
const ll MOD = 1e9 + 7;


const ll N = 3e5;
vector<ll> graph[N];
ll a[N];
ll tin[N], tout[N], par[N], sum[N];
ll timer = 0;


void dfs(ll v, ll p) {
    tin[v] = timer++;
    for (ll u : graph[v]) {
        if (u != p) {
            par[u] = v;
            dfs(u, v);
        }
    }
    tout[v] = timer;
}


bool anc(ll v, ll u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}


void solve() {
    ll n, q;
    cin >> n >> q;
    ll x;
    for (ll i = 1; i < n; ++i) {
        cin >> x;
        --x;
        graph[x].pb(i);
    }
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    dfs(0, -1);
    par[0] = -1;
    set<pair<ll, ll>> s;
    for (ll u : graph[0]) {
        s.insert({a[u], u});
    }
    vector<ll> ans(n);
    ll cur = 1;
    while (!s.empty()) {
        pair<ll, ll> p = *s.rbegin();
        s.erase(p);
        ll v = p.second;
        ll mx = 0;
        for (ll u = 0; u < n; ++u) {
            if (!anc(u, v)) {
                mx = max(mx, sum[u]);
            }
        }
        ans[v] = cur - mx;
        for (ll u : graph[v]) {
            s.insert({a[u], u});
        }
        ++cur;
        while (v != -1) {
            ++sum[v];
            v = par[v];
        }
    }
    for (ll i = 0; i < q; ++i) {
        ll v;
        cin >> v;
        --v;
        cout << ans[v] << ' ';
    }
}


int main() {
#ifdef LOCAL
    freopen("C:/work/untitled/input.txt", "r", stdin);
    freopen("C:/work/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}