//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")
#include <bits/stdc++.h>
//#include<ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>

using ll = long long;
using ld = long double;
const ll inf = 1e18;

#define all(a) a.begin(), a.end()
#define pb push_back

using namespace std;
using namespace literals;
//using namespace __gnu_pbds;

//using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>
//gp_hash_table<ll, ll> s;

mt19937 rnd;

void solve();
void precalc();

int main() {
#ifdef LOCAL:
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
    const auto start = chrono::steady_clock::now();
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    precalc();
    bool cfmode = false;
    if(cfmode) {
        ll t;
        cin >> t;
        while(t--) {
            solve();
        }
    } else {
        solve();
    }
#ifdef LOCAL:
    const auto end = chrono::steady_clock::now();
    cout << "\n";
    cout << fixed << setprecision(10) << "xxxTIMExxx: " << (end - start) / 1ms;
#endif
}

void precalc() {

}

vector<ll> p;
vector<vector<ll>> g;
vector<ll> colors;

void dfs(ll v, ll color) {
    if(color == 0) {
        color = v;
    }
    colors[v] = color;
    for(auto i : g[v]) {
        if(i != p[v]) {
            dfs(i, color);
        }
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> s;
    g.assign(n, {});
    p.assign(n, -1);
    colors.resize(n, 0);
    for(int i = 1; i < n; i++) {
        ll x;
        cin >> x;
        x--;
        g[i].pb(x);
        g[x].pb(i);
        p[i] = x;
    }
    s.assign(n, 0);
    for(int i = 0; i < n; i++) {
        cin >> s[i];
    }
    vector<ll> tour;
    set<pair<ll, ll>> s1;
    s1.insert({s[0], 0LL});
    while(s1.size() > 0) {
        ll x = s1.rbegin()->second;
        s1.erase(*s1.rbegin());
        tour.pb(x);
        for(auto i : g[x]) {
            if(i != p[x]) {
                s1.insert({s[i], i});
            }
        }
    }
    dfs(0, 0);
    vector<bool> was(n, false);
    vector<ll> qt(q);
    for(int i = 0; i < q; i++) {
        cin >> qt[i];
        qt[i]--;
        was[qt[i]] = true;
    }
    vector<ll> sum(2 * n, 0);
    set<pair<ll, ll>> cnt;
    for(auto i : colors) {
        cnt.insert({0, i});
    }
    map<ll, ll> answers;
    for(int i = 0; i < tour.size(); i++) {
        if(i != 0) {
            cnt.erase({sum[colors[tour[i]]], colors[tour[i]]});
            sum[colors[tour[i]]]++;
            cnt.insert({sum[colors[tour[i]]], colors[tour[i]]});
        }
        if(was[tour[i]]) {
            if(cnt.rbegin()->second != colors[tour[i]]) {
                answers[tour[i]] = i - cnt.rbegin()->first;
            } else {
                pair<ll, ll> t = *cnt.rbegin();
                cnt.erase(t);
                if(cnt.size() == 0) {
                    answers[tour[i]] = i;
                } else {
                    answers[tour[i]] = i - cnt.rbegin()->first;
                    cnt.insert(t);
                }
            }
        }
    }
    for(int i = 0; i < q; i++) {
        cout << answers[qt[i]] << " ";
    }
}
