#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;
    vector<vector<int>> g(n);
    for (int v = 1; v < n; v++) {
        int u;
        cin >> u;
        u--;
        g[u].emplace_back(v);
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    vector<int> tin(n), tout(n);
    int timer = 0;
    auto dfs = [&](auto &&self, int v) -> void {
        tin[v] = timer++;
        for (auto &u: g[v]) {
            self(self, u);
        }
        tout[v] = timer++;
    };
    dfs(dfs, 0);
    vector<int> order;
    set<pair<int, int>> flex;
    for (auto &v: g[0]) {
        flex.emplace(s[v], v);
    }
    for (int root = 0; root != -1;) {
        order.emplace_back(root);
        if (flex.empty()) {
            break;
        }
        int cand = flex.rbegin()->second;
        flex.erase(*flex.rbegin());
        for (auto &v: g[cand]) {
            flex.emplace(s[v], v);
        }
        swap(cand, root);
    }
    vector<int> ans(n, n + 1);
    for (int i = 0; i < n; i++) {
        int v = order[i];
        int was = 0;
        for (int j = 0; j < n; j++) {
            int u = order[j];
            if (tin[v] <= tin[u] && tout[v] >= tout[u]) {
                was++;
            } else {
                ans[u] = min(ans[u], j - was);
            }
        }
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << ans[v] << ' ';
    }
    cout << '\n';
    return 0;
}
