#include <bits/stdc++.h>

using ll = long long;
using namespace std;
int mod = 1e9 + 7;
struct mod_int {
    int v = 0;
    mod_int(int nv = 0) {
        v = nv;
        if (v < 0 || v >= mod) {
            v = (v % mod + mod) % mod;
        }
    }
};
mod_int operator + (mod_int v1, mod_int v2) {
    return (v1.v + v2.v >= mod ? v1.v + v2.v - mod : v1.v + v2.v);
}
mod_int operator -(mod_int v1, mod_int v2) {
    return (v1.v - v2.v < 0 ? v1.v - v2.v + mod : v1.v - v2.v);
}
mod_int operator *(mod_int v1, mod_int v2) {
    return (1LL * v1.v * v2.v) % mod;
}
bool operator == (mod_int v1, mod_int v2) {
    return v1.v == v2.v;
}
bool operator < (mod_int v1, mod_int v2) {
    return v1.v < v2.v;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector <vector <int>> gr(n);
    vector <int> prev(n, - 1);
    for (int i = 1; i < n; ++i) {
        int p;;
        cin >> p;
        --p;
        prev[i] = p;
        gr[p].push_back(i);
    }
    vector <int> val(n);
    for (int i = 0; i < n; ++i) {
        cin >> val[i];
    }
    set <pair <int, int>> now{};
    now.emplace(- val[0], 0);
    vector <int> ind(n);
    int time = 0;
    vector <int> p{};
    while (!now.empty()) {
        int num = now.begin()->second;
        p.push_back(num);
        ind[num] = time;
        ++time;
        now.erase(now.begin());
        for (auto next : gr[num]) {
//            cout << next + 1 << ' ' << num << '\n';
            now.insert({- val[next], next});
        }
    }
//    for (auto num : p) {
//        cout << num + 1 << ' ';
//    }
//    cout << '\n';
    vector <int> ans = ind;
    vector <int> counter(n, 0);
    for (int num : p) {
        int cur = prev[num], last = num;
        while (cur != - 1) {
            for (auto next : gr[cur]) {
                if (next != last) {
//                    cout << num + 1 << " " << next + 1 << '\n';
                    ans[num] = min(ans[num], ind[num] - counter[next]);
                }
            }
            cur = prev[cur];
            last = prev[last];
        }
        cur = num;
        while (cur != - 1) {
            ++counter[cur];
            cur = prev[cur];
        }
    }
    for (int i = 0; i < q; ++i) {
        int num;
        cin >> num;
        --num;
        cout << ans[num] << ' ';
    }
    cout << '\n';
}
signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
