#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

const int inf = 1e9;

vector<vector<int>> g;
vector<int> s;

int dfs(int v, int c)
{
    if(s[v] <= c) return 0;
    int ans = 1;
    for(int u : g[v]){
        ans += dfs(u, c);
    }
    return ans;
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> p(n);
    p[0] = 0;
    g.resize(n);
    for(int i = 1; i < n; ++i){
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    s.resize(n);
    for(int &x : s) cin >> x;
    s[0] = 0;
    vector<int> ans;
    for(int i = 0; i < q; ++i){
        int v;
        cin >> v;
        --v;
        int sum = 0, maxx = 0;
        while(v != 0){
            int x = s[v];
            while(s[v] >= x){
                for(int u : g[p[v]]) if(u != v){
                    int z = dfs(u, x);
                    sum += z + 1;
                    maxx = max(maxx, z);
                }
                v = p[v];
            }
        }
        ans.push_back(sum - maxx);
    }
    for(int x : ans) cout << x << ' ';
    cout << endl;
}