#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long
#define db long double

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

vector<vector<int>> g;

void solve() {
    int n, q; cin >> n >> q;

    g.resize(n + 1);
    for (int i = 2; i <= n; ++i) {
        int x; cin >> x;
        g[x].push_back(i);
    }

    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i) cin >> a[i];

    vector<int> ans(n + 1);

    int cur = 0, root = 1;
    set<pair<int, int>> child;

    for (int u : g[1]) {
        child.insert({-a[u], u});
    }

    while (!child.empty()) {
        ans[root] = cur++;

        auto [wt, i] = *child.begin(); child.erase(child.begin());

        root = i;
        for (int u : g[root]) {
            child.insert({-a[u], u});
        }
    }

    ans[root] = cur;

    for (int i = 1; i <= n; ++i) {
        if (ans[i] > 1) {
            ans[i]--;
        }
    }

    for (int i = 0; i < q; ++i) {
        int v; cin >> v;

        cout << ans[v] << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}