#include <bits/stdc++.h>

using namespace std;

void solve();

//#pragma GCC optimize("O3","Ofast","fastmath","unroll-loops")
//#pragma GCC target("avx2","sse4.2","bmi","lzcnt","popcnt")
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}

#define int long long
#define endl '\n'
const int N = 3e5 + 10, INF = 2e18, MOD = 1e9 + 7;
vector<int> gr[N];

int tin[N], tout[N], timer = 0;
bool used[N];
int par[N];
int cnt[N];
int mpar[N];
int sz[N];
void dfs(int v, int mp = 0) {
    tin[v] = timer++;
    mpar[v] = mp;
    sz[v]=1;
    for (auto to: gr[v]) {
        par[to] = v;
        if (v == 0)mp = to;
        dfs(to, mp);
        sz[v]+=sz[to];
    }
    tout[v] = timer++;
}

set<pair<int,int>> ck;
int aval[N];
int num=0;
void dfs2(int v) {
    aval[v]=num+ck.begin()->first;
    for (auto to: gr[v]) {
        num++;
        dfs2(to);
        ck.insert({-sz[to],to});
    }
    for(auto to:gr[v]){
        ck.erase({-sz[to],to});
    }
}

bool upper(int f, int s) {
    return tin[f] <= tin[s] && tout[f] >= tout[s];
}

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        gr[p].push_back(i);
    }
    vector<int> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for(int i=0;i<n;i++){
        vector<pair<int,int>> val;
        for(auto to:gr[i]){
            val.emplace_back(s[to],to);
        }
        sort(val.rbegin(),val.rend());
        gr[i].clear();
        for(auto [f,s]:val){
            gr[i].push_back(s);
        }
    }
    vector<int> ans(n, 0), val(n, 0);
    dfs(0);
    dfs2(0);
    for (int i = 0; i < q; i++) {
        int v;
        cin >> v;
        v--;
        cout << aval[v] << " ";
    }
    cout << endl;
}