#ifndef LOCAL
#include <bits/stdc++.h>
#endif
using namespace std;
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector")
#pragma GCC target("avx2")

#define int int64_t
const int inf=1e18;

#ifdef LOCAL
#include "algo/debug.h"
#else
template <typename... Args>
void dummy(Args&&... args){}
#define ps dummy
#endif

#define f first
#define s second
template<class T> using V = vector<T>; 
using vi = V<int>;
using vb = V<bool>;
using vs = V<string>;

#define all(x) begin(x), end(x)
#define rall(x) rbegin(x), rend(x) 
#define len(x) (int)((x).size())
#define rsz resize
#define ins insert
#define ft front()
#define bk back()
#define pb push_back
#define eb emplace_back
#define pf push_front
#define lb lower_bound
#define ub upper_bound
#define ai2 array<int,2>
#define ai3 array<int,3>
#define ai4 array<int,4>
#define ai5 array<int,5>
template<class T> int lwb(const V<T>& a, const T& b) { return lb(all(a),b)-begin(a); }
template<class T> int upb(const V<T>& a, const T& b) { return ub(all(a),b)-begin(a); }
template<class T> bool ckmin(T& a, const T& b) { return a > b ? a=b, true : false; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a=b, true : false; }
#define pct __builtin_popcountll
#define ctz __builtin_ctzll
#define clz __builtin_clzll
constexpr int p2(int x) { return (int)1 << x; }
constexpr int bits(int x) { return x == 0 ? 0 : 63-clz(x); } // floor(log2(x)) 
template<class T>void UNIQUE(V<T>& v) { sort(all(v)); v.erase(unique(all(v)),end(v)); }
template<class T,class U>void erase(T& t, const U& u) { auto it = t.find(u); assert(it != end(t)); t.erase(it); }
template<class F> struct y_combinator_result {
    F f;
    template<class T> explicit y_combinator_result(T &&f): f(std::forward<T>(f)) {}
    template<class ...Args> decltype(auto) operator()(Args &&...args) { return f(std::ref(*this), std::forward<Args>(args)...); }
};
template<class Fun> decltype(auto) yy(Fun &&fun) { return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun)); }

const int N = 3e5;
vi g[N];
vi s;
int timer;
vi tin, tout;

// int count_greater_in_canopy(int u, int x) {
    // assert(s[u] != x);
    // if (s[u] < x) return 0;
    // int res = 1;
    // for (int v : g[u]) {
        // res += count_greater_in_canopy(v, x); 
    // }
    // return res;
// }

void dfs(int u) {
    tin[u] = timer++;
    for (int v : g[u]) {
        dfs(v);
    }
    tout[u] = timer;
}

struct Seg {
    int n;
    V<vi> t, from_left;
    void build(const vi& a, int u = 0, int l = 0, int r = -1) {
        if (r == -1) r=n;
        if (r - l == 1) {
            t[u] = { a[l] };
            return;
        }
        int m = (l + r) / 2;
        build(a, 2 * u + 1, l, m);
        build(a, 2 * u + 2, m, r);
        t[u] = vi(r - l);
        from_left[u] = vi(r - l + 1);
        merge(all(t[2 * u + 1]), all(t[2 * u + 2]), begin(t[u]));
        int i = 0, j = 0;
        while (i < len(t[2 * u + 1]) || j < len(t[2 * u + 2])) {
            from_left[u][i + j + 1] = from_left[u][i + j];
            if (j == len(t[2 * u + 2]) || (i < m - l && t[2 * u + 1][i] < t[2 * u + 2][j])) {
                from_left[u][i + j + 1]++;
                i++;
            } else {
                j++;
            }
        }
    }
    Seg(int n, const vi& a):n(n){
        int siz=1;
        while(siz<2*n)siz*=2;
        t = from_left = V<vi>(siz);
        build(a);
    }
    int upper_bound(int L,int R,int x,int cnt = -1,int u=0,int l=0,int r=-1){
        if (cnt == -1) {
            cnt = upb(t[u], x);
        }
        if (r == -1) r=n;
        if(r<=L||R<=l)return 0;
        if(L<=l&&r<=R)return cnt;
        int m=(l+r)/2;
        return upper_bound(L, R, x, from_left[u][cnt], 2 * u + 1, l, m) + upper_bound(L, R, x, cnt - from_left[u][cnt], 2 * u + 2, m, r);
    }
    int count_greater(int L, int R, int x) {
        return R - L - upper_bound(L, R, x);
    }
};

void solve() {
    int n, q; cin >> n >> q;
    vi par(n), dep(n);
    par[0] = -1;
    for (int i = 1; i < n; i++) {
        int p; cin >> p; p--;
        par[i] = p;
        dep[i] = dep[p] + 1;
        g[p].pb(i);
    }
    s = vi(n);
    for (int& i : s) cin >> i;

    tin = tout = vi(n);
    dfs(0);
    vi a(n);
    for (int u = 0; u < n; u++) a[tin[u]] = s[u];
    Seg t(n, a); 

    if (q <= 100 || p2(*max_element(all(dep))) <= n) {
        for (int i = 0; i < q; i++) {
            int qry; cin >> qry; qry--;
            vi path;
            do {
                path.pb(qry);
                qry = par[qry];
            } while (qry != -1);
            reverse(all(path));

            vi suf_min(len(path) + 1, inf);
            for (int i = len(path) - 1; i >= 0; i--) {
                suf_min[i] = min(suf_min[i + 1], s[path[i]]);
            }

            int mx_siz = 0, tot_siz = 0;
            for (int i = 0; i < len(path) - 1; i++) {
                tot_siz++;
                int u = path[i];
                for (int v : g[u]) if (v != path[i + 1]) {
                    int cnt = t.count_greater(tin[v], tout[v], suf_min[i + 1]);
                    tot_siz += cnt;
                    ckmax(mx_siz, cnt);
                }
            }

            cout << tot_siz - mx_siz << " \n"[i == q - 1];
        }

    } else {
        V<vi> root_orders;
        for (int u = 0; u < n; u++) {
            int old_key = s[u];
            s[u] = 0;

            root_orders.eb();
            set<ai2> q;
            q.ins({ s[0], 0 }); 
            while (len(q)) {
                auto [key, u] = *rbegin(q);
                q.erase(prev(end(q)));
                root_orders.bk.pb(u);
                for (int v : g[u]) {
                    q.ins({ s[v], v });
                }
            }

            s[u] = old_key;
        }

        vi min_pos(n, n);
        for (auto list : root_orders) {
            for (int i = 0; i < n; i++) {
                ckmin(min_pos[list[i]], i);
            }
        }

        for (int i = 0; i < q; i++) {
            int u; cin >> u; u--;
            cout << min_pos[u] << " \n"[i == q - 1];
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    solve();
    return 0;
}
