#include <bits/stdc++.h>
#define int long long

using namespace std;

const int inf = 2e9;

vector<vector<pair<int, int>>> g;
vector<int> pp;
void dfs(int v, int p = -1, int d = 0) {
    if (d == 1) {
        pp[v] = v;
    } else if (d > 1) {
        pp[v] = pp[p];
    }
    for (auto [f, u]: g[v]) {
        dfs(u, v, d + 1);
    }
}

void solve() {
    int n, k; cin >> n >> k;
    vector<int> p(n), s(n);
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i]; --p[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        if (i != 0) {
            g[p[i]].push_back({-s[i], i});
        }
    }
    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
    }
    pp.resize(n, -1);
    dfs(0);
    unordered_map<int, int> cnt;
    multiset<int> cntl;
    vector<int> ans(n, inf);
    ans[0] = 0;
    set<pair<int, int>> q;
    q.insert({s[0], 0});
    for (int i = 0; !q.empty(); ++i) {
        int v = q.begin()->second;
        q.erase(q.begin());
        if (pp[v] != -1) {
            int mx = 0;
            cntl.extract(cnt[pp[v]]);
            if (!cntl.empty()) {
                mx = *(--cntl.end());
            }
            cntl.insert(cnt[pp[v]]);
            ans[v] = min(ans[v], i - mx);
        }
        for (auto [f, u]: g[v]) {
            q.insert({f, u});
        }
        if (pp[v] != -1) {
            cntl.extract(cnt[pp[v]]);
            cntl.insert(++cnt[pp[v]]);
        }
    }
    for (int i = 0; i < k; ++i) {
        int x; cin >> x;
        cout << ans[x - 1] << ' ';
    }
    cout << '\n';
}

signed main(void) {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}