#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
#include <queue>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

long long n;
vector<long long> g[300000], par, val;

void solve()
{
	long long q;
	cin >> n >> q;
	par.resize(n, -1);
	for (long long i = 1; i < n; i++)
	{
		long long pv;
		cin >> pv;
		pv--;
		g[pv].push_back(i);
		par[i] = pv;
	}
	val.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> val[i];
	}

	priority_queue<pair<long long, long long>> st;
	vector<long long> ord;
	ord.reserve(n);
	ord.push_back(0);
	for (auto& i : g[0])
	{
		st.push({ val[i], i });
	}
	while (st.size())
	{
		long long ver = st.top().second;
		ord.push_back(ver);
		st.pop();
		for (auto& i : g[ver])
		{
			st.push({ val[i], i });
		}
	}

	vector<long long> ans(n, -1);
	vector<long long> sum(n);
	vector<bool> on_path(n);
	long long day = 0;
	for (auto& ver : ord)
	{
		long long cur = ver;
		while (cur != -1)
		{
			sum[cur]++;
			on_path[cur] = true;
			cur = par[cur];
		}

		long long best = 0;
		for (auto& i : ord)
		{
			if (!on_path[i])
			{
				best = max(best, sum[i]);
			}
			on_path[i] = false;
			if (i == ver)
			{
				break;
			}
		}
		ans[ver] = day - best;
		day++;
	}
	while (q--)
	{
		long long ver;
		cin >> ver;
		ver--;
		cout << ans[ver] << " ";
	}
	cout << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int t = 1;
	//cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}

/*

























*/
