#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define int ll
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using ordered_set = __gnu_pbds::tree<int, __gnu_pbds::null_type, less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

mt19937 rnd(time(0));

const int MAXN = 3e5 + 52;
vector<int> g[MAXN];
vector<int> g1[MAXN];
int s[MAXN];
int ans[MAXN];
int p[MAXN];

struct CMP {
    int a;

    bool operator<(CMP b) {
        return s[a] > s[b.a];
    }

};

void count(int n) {
    set<pii> al;
    for (auto &x: g[0]) al.insert({-s[x], x});
    for (int _ = 0; _ < n - 1; _++) {
        int u = (*al.begin()).second;
        ans[u] = min(ans[u], _ + 1);
        al.erase(al.begin());
        for (auto &u1: g[u])
            al.insert({-s[u1], u1});
    }
}

bool comp(int a, int b) {
    return s[a] > s[b];
}

inline void solve() {
    fill(ans + 1, ans + MAXN, 1e9);
    int n, q;
    cin >> n >> q;
    vector<int> al;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        if (p[i] == 0) {
            al.push_back(i);
        }
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    sort(all(al), comp);
    while (al.size() > 200) al.pop_back();
    for (int &i: al) {
        if (p[i] == 0) {
            int tmp = s[i];
            s[i] = 0;
            count(n);
            s[i] = tmp;
        }
    }
    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << ans[v] << " ";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}