#ifdef LOCAL
// #define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) int((x).size())
using ld = long double;
using ll = int64_t;
using ull = uint64_t;
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;

void solve();

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}

int n, q;
vector<vector<int>> g;
vector<int> s;
vector<int> p;
vector<int> queries;
vector<int> ans;
vector<int> initial_order;

struct cmp {
    bool operator()(const int a, const int b) const {
        return s[a] > s[b];
    }
};

vector<int> simulate() {
    vector<int> order(n);
    int root = 0;
    vector<set<int, cmp>> leika(n);
    for (int i = 0; i < n; i++) {
        for (int j : g[i]) {
            leika[i].insert(j);
        }
    }
    int t = 0;
    while (!leika[0].empty()) {
        int v = *leika[0].begin();
        leika[0].erase(leika[0].begin());
        order[root] = t;
        ++t;
        root = v;
        if (leika[0].size() < leika[v].size()) {
            swap(leika[0], leika[v]);
        }
        leika[0].insert(all(leika[v]));
        leika[v].clear();
    }
    order[root] = t;
    return order;
}

void get_all_subtree(int v, vector<int>& res) {
    res.push_back(v);
    for (int u : g[v]) {
        get_all_subtree(u, res);
    }
}

void dfs(int v, int saved) {
    int my_order = initial_order[v];
    int before = 0;
    int z = v;
    while (z != 0) {
        for (int u : g[p[z]]) {
            if (u != z) {
                int now_before = 0;
                vector<int> is;
                get_all_subtree(u, is);
                for (int i : is) {
                    if (initial_order[i] < my_order) {
                        now_before++;
                    }
                }
                before = max(now_before, before);
            }
        }
        z = p[z];
    }
    saved = max(saved, before);
    if (queries[v] != -1) {
        ans[queries[v]] = initial_order[v] - saved;
    }
    for (int u : g[v]) {
        dfs(u, saved);
    }
}

void solve() {
    cin >> n >> q;
    p.resize(n, -1);
    g.resize(n);
    s.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) cin >> s[i];
    queries.resize(n, -1);
    ans.resize(q);
    for (int i = 0; i < q; i++) {
        int v;
        cin >> v;
        v--;
        queries[v] = i;
    }
    initial_order = simulate();
    for (int u : g[0]) {
        dfs(u, 0);
    }
    for (int i = 0; i < q; i++) {
        cout << ans[i] << ' ';
    }
    // for (int i = 0; i < q; i++) {
    //     int v = queries[i];
    //     int mn = n;
    //     for (int u = 0; u < n; u++) {
    //         int su = s[u];
    //         s[u] = 0;
    //         vector<int> order = simulate();
    //         mn = min(mn, int(find(all(order), v) - order.begin()));
    //         s[u] = su;
    //     }
    //     cout << mn << '\n';
    // }
}