#include<bits/stdc++.h>

using namespace std;

const int N = 3e5 + 10;
vector<int> child[N];
int p[N], ans[N], s[N], in[N], out[N], sz[N];
int emit = 0;

void dfs(int v)
{
  in[v] = emit++;
  for(int c : child[v])
    dfs(c);
  out[v] = emit;
}

int main()
{
  int n, q;
  cin >> n >> q;

  for(int i = 2; i <= n; i ++)
    {
      cin >> p[i];
      child[p[i]].push_back(i);
    }

  for(int i = 1; i <= n; i ++)
    cin >> s[i];

  dfs(1);
  
  set<pair<int,int> > st;
  st.insert({s[1],1});

  vector<int> ord;
  while(st.size())
    {
      int v = st.rbegin()->second;
      st.erase(--st.end());
      ord.push_back(v);
      for(int c : child[v])
	st.insert({s[c], c});
    }


  int bef = 0;
  for(int v : ord)
    {
      ans[v] = bef++;

      int mx = 0;
      int u = p[v];
      sz[v] = 1;
      while(u != 0)
	{
	  sz[u]++;
	  for(int c : child[u])
	    if(!(in[c] <= in[v] && out[v] <= out[c]))
		mx = max(mx, sz[c]);
	  u = p[u];
	}
      
      ans[v] -= mx;
    }

  while(q--)
    {
      int v;
      cin >> v;
      cout << ans[v] << ' ';
    }
  cout << endl;
  return 0;
}
