#include<bits/stdc++.h>

using namespace std;

const int N = 3e5 + 10;
vector<int> child[N];
int p[N], ans[N], s[N], in[N], out[N], sz[N], mx[N][2];
int emit = 0;

void dfs(int v)
{
  in[v] = emit++;
  for(int c : child[v])
    dfs(c);
  out[v] = emit;
}

int main()
{
  int n, q;
  cin >> n >> q;

  for(int i = 2; i <= n; i ++)
    {
      cin >> p[i];
      child[p[i]].push_back(i);
    }

  for(int i = 1; i <= n; i ++)
    cin >> s[i];

  dfs(1);
  
  set<pair<int,int> > st;
  st.insert({s[1],1});

  vector<int> ord;
  while(st.size())
    {
      int v = st.rbegin()->second;
      st.erase(--st.end());
      ord.push_back(v);
      for(int c : child[v])
	st.insert({s[c], c});
    }


  int bef = 0;
  for(int v : ord)
    {
      ans[v] = bef++;

      int dec = 0;
      int u = p[v], tmp = v;
      
      while(u != 0)
	{
	  if(mx[u][0] == tmp)
	    dec = max(dec, sz[mx[u][1]]);
	  else
	    dec = max(dec, sz[mx[u][0]]);
	  u = p[u];
	  tmp = p[tmp];
	}

      ans[v] -= dec;
      u = v;
      while(u != 0)
	{
	  sz[u]++;
	  int w = p[u];
	  if(mx[w][0] != u && mx[w][1] != u)
	    if(sz[u] > sz[mx[w][1]]) mx[w][1] = u;
	  
	  if(sz[mx[w][0]] < sz[mx[w][1]])
	    swap(mx[w][0], mx[w][1]);
	  u = w;
	}
    }

  while(q--)
    {
      int v;
      cin >> v;
      cout << ans[v] << ' ';
    }
  cout << endl;
  return 0;
}
