#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<map>
#include<set>
#include<bitset>
#include<algorithm>
#include<functional>

using namespace std;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, q;
	cin >> n >> q;
	vector<vector<int>> _g(n);
	for (int i = 1; i < n; ++i) {
		int p;
		cin >> p;
		p--;
		_g[p].push_back(i);
		_g[i].push_back(p);
	}
	vector<int> ss(n);
	for (int i = 0; i < n; ++i) {
		cin >> ss[i];
	}
	vector<int> ans(n, 1e9);
	ans[0] = 0;
	for (int i = 0; i < n; ++i) {
		vector<int> s = ss;
		int cnt = 0;
		vector<vector<int>> g = _g;
		int root = 0;
		s[i] = 0;
		vector<int> visited(n);
		while (cnt != n - 1) {
			++cnt;
			int nroot = -1;
			for (auto u : _g[root]) {
				if ((nroot == -1 || s[u] > s[nroot]) && !visited[u]) {
					nroot = u;
				}
			}
			ans[nroot] = min(ans[nroot], cnt);			
			for (auto u : _g[root]) {
				if (u != nroot && s[u] != 0) {
					_g[nroot].push_back(u);
					_g[u].push_back(nroot);
				}
			}
			visited[root] = 1;
			root = nroot;
		}
	}
	for (int i = 0; i < q; ++i) {
		int x;
		cin >> x;
		x--;
		cout << ans[x] << ' ';
	}
	return 0;
}