#include <bits/stdc++.h>
//#define int long long

using namespace std;
using ll = long long;
using ld = long double;
const int INF = 1e18;
const int MOD = 1e9 + 7;
const int N = 3e5 + 69;

vector<multiset<pair<int, int>>> g;
bool vis[N];
int ans[N];
int s[N];
vector<multiset<pair<int, int>>> gwas;
void dfs(int v, int tnow = 0) {
    ans[v] = tnow;
    vis[v] = true;
    pair<int, int> now = {-1, -1};
    while (!g[v].empty()) {
        auto [x, u] = *g[v].rbegin();
        if (vis[u]) g[v].erase(g[v].find({x, u}));
        else {
            now = {x, u};
            break;
        }
    }
    if (now.second == -1) return;
    int newv = now.second;
    if (g[v].size() > g[newv].size()) swap(g[newv], g[v]);
    for (auto [x, u] : g[v]) {
        if (vis[u] || u == newv || u == v) continue;
        g[newv].insert({x, u});
    }
    g[v].clear();
    dfs(newv, tnow + 1);
}

bitset<N> onway;
int ansdel = 0;
int dfs2(int v, int t, int par = -1) {
    if (ans[v] >= t) return 0;
    int now = 0;
    if (!onway[v]) now = 1;
    for (auto [x, u] : g[v]) {
        if (u == par) continue;
        int other = dfs2(u, t, v);
        if (onway[v] && !onway[u]) ansdel = max(ansdel, other);
        now += other;
    }
    return now;
}

vector<int> mainpar;
void dfs3(int v, int mainp, int p = -1) {
    mainpar[v] = mainp;
    for (auto [x, u] : g[v]) {
        if (u != p) dfs3(u, mainp, v);
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> par(n);
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v;
        --v;
        par[i] = v;
    }
    for (int i = 0; i < n; ++i) cin >> s[i];
    for (int i = 1; i < n; ++i) {
        g[par[i]].insert({s[i], i});
    }
    gwas = g;
    dfs(0);
    swap(g, gwas);
    gwas.clear();
    map<int, int> forans;
    for (auto [x, u] : g[0]) {
        onway.reset();
        int now = u;
        while (now) {
            onway[now] = true;
            now = par[now];
        }
        onway[0] = true;
        ansdel = 0;
        dfs2(0, ans[u]);
        forans[u] = ansdel;
        dfs3(u, u, 0);
    }
    while (q--) {
        int v;
        cin >> v;
        --v;
        cout << ans[v] - forans[mainpar[v]] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
