//#pragma GCC optimize("O3, unroll_loops, no_stack_protector")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <string>
#define int long long

using namespace std;

const int INF = 2e15;

vector <int> tin, tout;
int tim = 0;

void dfs(int v, int p, vector <multiset <int>> &g, vector <int>& brr, vector <int>& sum) {
	tin[v] = tim++;
	for (auto u : g[v]) {
		if (u != p) {
			dfs(u, v, g, brr, sum);
			sum[v] += sum[u];
		}
	}
	sum[v] += brr[v];
	tout[v] = tim++;
}

bool isPrev(int p, int v) {
	return tin[p] <= tin[v] && tout[v] <= tout[p];
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, q;
	cin >> n >> q;
	tin.assign(n, 0);
	tout.assign(n, 0);
	vector <int> p(n, -1);
	vector <multiset<int>> g(n);
	vector <int> col(n);
	int c = 1;
	for (int i = 1; i < n; i++) {
		cin >> p[i];
		p[i]--;
		if (p[i] == 0) {
			col[i] = c;
			c++;
		}
		else {
			col[i] = col[p[i]];
		}
		g[i].insert(p[i]);
		g[p[i]].insert(i);
	}
	vector <int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector <int> que;
	set <pair<int, int>> st;
	st.insert({ -arr[0], 0 });
	while (!st.empty()) {
		int v = st.begin()->second;
		que.push_back(v);
		st.erase({ -arr[v], v });
		for (auto el : g[v]) {
			st.insert({ -arr[el], el });
			g[el].erase(v);
		}
	}
	vector <int> cnt(c);
	st = {};
	for (int i = 1; i < c; i++) {
		st.insert({ 0, i });
	}
	vector <pair<pair<int, int>, pair<int, int>>> pref(n);
	for (int i = 1; i < n; i++) {
		st.erase({ cnt[col[que[i]]], col[que[i]] });
		cnt[col[que[i]]]--;
		st.insert({ cnt[col[que[i]]], col[que[i]] });

		auto maxi1 = *st.begin();
		st.erase(st.begin());
		auto maxi2 = *st.begin();
		st.insert(maxi1);
		pref[i] = { maxi1, maxi2 };
	}
	vector <int> num(n);
	for (int i = 0; i < n; i++) {
		num[que[i]] = i;
	}
	for (int _ = 0; _ < q; _++) {
		int v;
		cin >> v;
		v--;
		if (v == 0) {
			cout << 0 << ' ';
			continue;
		}
		int ans = num[v];
		if (col[v] == pref[ans].first.second) {
			ans -= -pref[ans].second.first;
		}
		else {
			ans -= -pref[ans].first.first;
		}
		cout << ans << ' ';
	}
}
