/* Варинат
1) тупняк
2) Бамбуки
3) Малое кол-во начальников
 */

#include <bits/stdc++.h>

using namespace std;

using ld = long double;
using ll = long long;
using pii = pair<int, int>;

void solve()
{
    int n, q;
    cin >> n >> q;
    vector<vector<int>> g(n);
    vector<int> s(n);
    vector<int> ti(n, -1); // для каждой вершины момент времени, когда она корень без изменений

    for (int i = 1; i < n; ++i)
    {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }

    for (int i = 0; i < n; ++i)
        cin >> s[i];

    int ct = 0;
    int cur = 0;
    set<pii> av;
    while (true)
    {
        assert(ti[cur] == -1);
        ti[cur] = ct;
        for (const auto &u : g[cur])
        {
            av.insert({s[u], u});
        }
        if (av.empty())
            break;
        auto it = av.rbegin();
        cur = it->second;
        av.erase({s[cur], cur});
        ++ct;
    }

    int ans = 0;

    // (ок, количество вершин в поддеревее)
    function<int(int, int)> dfs = [&](int v, int qv) -> int
    {
        if (v == qv)
            return -1LL;
        bool ok = true;
        int cnt = 0;
        if (ti[v] < ti[qv])
            ++cnt;
        for (const auto &u : g[v])
        {
            auto res = dfs(u, qv);
            if (res == -1)
            {
                ok = false;
            }
            else
            {
                cnt += res;
            }
        }
        if (ok)
        {
            ans = max(ans, cnt);
            return cnt;
        }
        else
        {
            return -1;
        }
    };

    for (int qq = 0; qq < q; ++qq)
    {
        int v;
        cin >> v;
        --v;
        ans = 0;
        dfs(0, v);
        int res = ti[v] - ans;
        cout << res << ' ';
    }
    cout << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(0);
    ios::sync_with_stdio(0);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}