#include <bits/stdc++.h>

using namespace std;

// #define int long long
using ld = long double;
using ll = long long;
using pii = pair<int, int>;

int n, q;
constexpr int logn = 20;
vector<vector<int>> g;
vector<int> ans;
vector<int> s;
vector<int> ti;
vector<vector<int>> hp; // родитель данной высоты
vector<int> val;
vector<int> h;

void dfs(int v)
{
    for (const auto &u : g[v])
    {
        h[u] = h[v] + 1;
        dfs(u);
    }
}

void dfs2(int v, int h, int p)
{
    hp[v][h] = p;
    for (const auto &u : g[v])
    {
        dfs2(u, h, p);
    }
}

bool cmp(const int &a, const int &b)
{
    return ti[a] < ti[b];
}

int get_other(int u)
{
    int p = hp[u][h[u] - 1];
    if (u == g[p][0])
    {
        if (g[p].size() >= 2)
        {
            return g[p][1];
        }
        return -1;
    }
    return g[p][0];
}

void solve()
{
    cin >> n >> q;
    g.resize(n);
    ans.resize(n);
    s.resize(n);
    ti.resize(n, -1);
    hp.resize(n, vector<int>(logn + 1, -1));
    h.resize(n);

    for (int i = 1; i < n; ++i)
    {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }
    for (int i = 0; i < n; ++i)
        cin >> s[i];

    int ct = 0;
    int cur = 0;
    set<pii> av;
    while (true)
    {
        assert(ti[cur] == -1);
        ti[cur] = ct;
        for (const auto &u : g[cur])
        {
            av.insert({s[u], u});
        }
        if (av.empty())
            break;
        auto it = av.rbegin();
        cur = it->second;
        av.erase({s[cur], cur});
        ++ct;
    }

    vector<int> arr(n);
    for (int i = 0; i < n; ++i)
    {
        arr[i] = i;
    }
    sort(arr.begin(), arr.end(), cmp);

    h[0] = 0;
    dfs(0);
    for (int i = 0; i < n; ++i)
    {
        dfs2(i, h[i], i);
    }

    for (int H = 0; H <= logn; ++H)
    {
        val = vector<int>(n, 0);
        for (const auto &v : arr)
        {
            if (h[v] <= H)
                continue;
            int p = hp[v][H];
            int u = hp[v][H + 1];
            int other_u = get_other(u);
            if (other_u != -1)
            {
                ans[v] = max(ans[v], val[other_u]);
            }
            val[u] += 1;
        }
    }

    for (int qq = 0; qq < q; ++qq)
    {
        int v;
        cin >> v;
        --v;
        int res = ti[v] - ans[v];
        cout << res << ' ';
    }
    cout << '\n';
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(0);
    ios::sync_with_stdio(0);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}