#include <iostream>
#include <vector>
#include <queue>
using pair = std::pair<long long, long long>;
int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin.sync_with_stdio(false);
    long long n, q, i, v;
    std::cin >> n >> q;
    std::vector<long long> p(n + 1);
    std::vector<std::vector<long long>> g(n + 1);
    for(i = 2; i <= n; ++i) {
        std::cin >> p[i];
        g[p[i]].push_back(i);
    }
    std::vector<long long> s(n + 1);
    for(i = 1; i <= n; ++i) {
        std::cin >> s[i];
    }
    std::priority_queue<pair> queue;
    queue.push(pair{s[1], 1});
    std::vector<long long> pos(n + 1);
    std::vector<long long> indexes;
    while(!queue.empty()) {
        auto [w, v] = queue.top();
        queue.pop();
        pos[v] = indexes.size();
        indexes.push_back(v);
        for(long long u : g[v]) {
            queue.push(pair{s[u], u});
        }
    }
    std::vector<long long> ans(n + 1, 0);
    std::vector<long long> query(q);
    for(i = 0; i < q; ++i) {
        std::cin >> query[i];
    }
    std::vector<std::vector<long long>> children(n + 1);
    std::vector<long long> weight(n + 1);
    long long maxminus = 0;
    for(i = 0; i < n; ++i) {
        maxminus = 0;
        v = indexes[i];
        while(v) {
            for(long long u : children[p[v]]) {
                if(u != v) {
                    maxminus = std::max(maxminus, weight[u]);
                }
            }
            v = p[v];
        }
        v = indexes[i];
        ans[v] = i - maxminus;
        if(p[v]) {
            children[p[v]].push_back(v);
        }
        while(v) {
            ++weight[v];
            v = p[v];
        }
    }
    for(i = 0; i < q; ++i) {
        if(i) std::cout << ' ';
        std::cout << ans[query[i]];
    }
    std::cout << '\n';
}