#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll INF = 1e15;

vector<vector<int>> g;
vector<int> s, depth;

void dfs0(int v) {
    for (auto i : g[v]) {
        depth[i] = depth[v] + 1;
        dfs0(i);
    }
}

int dfs(int v, int mini) {
    if (s[v] < mini) return 0;
    int answer = 1;
    for (auto i : g[v]) {
        answer += dfs(i, mini);
    }
    return answer;
}

void solve() {
    int n, q;
    cin >> n >> q;
    g.assign(n, {});
    vector<int> parent(n, 0);
    for (int i = 1; i < n; ++i) {
        int pp; cin >> pp; --pp;
        g[pp].push_back(i);
        parent[i] = pp;
    }
    depth.assign(n, 0);
    dfs0(0);
    s.assign(n, 0);
    for (int i = 0; i < n; ++i) cin >> s[i];
    while (q--) {
        int v;
        cin >> v;
        --v;
        vector<int> bother;
        int now = v;
        int mini = s[v];
        while (parent[now] != now) {
            for (auto i : g[parent[now]]) {
                if (i == now) continue;
                bother.push_back(dfs(i, mini));
            }
            now = parent[now];
            mini = min(mini, s[now]);
        }
        int s = 0;
        for (int i = 0; i < bother.size(); ++i) s += bother[i];
        if (bother.size() > 0) s -= *max_element(bother.begin(), bother.end());
        cout << s + depth[v] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    // cin >> t;
    while (t--) solve();
}
