#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define rs resize
#define pb push_back
#define ff first
#define ss second
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef long double ld;
typedef long long ll;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T>
istream &operator >>(istream &in, pair<T, T> &a) {
    in >> a.ff >> a.ss;
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, pair<T, T> &a) {
    out << a.ff << " " << a.ss;
    return out;
}

template<typename T>
istream &operator >>(istream &in, vector<T> &a) {
    for (auto &i : a) in >> i;
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &a) {
    for (auto i : a) cout << i << " ";
    return out;
}

const int maxn = 3e5 + 10;
vector<int> g[maxn];
int c[maxn], f[maxn], mn[maxn];

int x;
void dfs_f(int v, int p) {
    if (c[v] == x) {
        f[v] = 2;
        mn[v] = x;
        return;
    }

    f[v] = 0;
    for (auto i : g[v]) {
        if (i != p) {
            dfs_f(i, v);

            if (f[i]) {
                f[v] = 1;
                mn[v] = min(mn[i], c[i]);
            }
        }
    }
}

int ans = 0, mx = 0;
int dfs_cnt(int v, int p, int fl, int fn) {
    if (fl == 0 && c[v] < fn) return 0;
    if (f[v] == 2) return 0;

    int sm = 1;
    for (auto i : g[v]) {
        if (i != p) {
            if (!f[i]) {
                int a = dfs_cnt(i, v, 0, mn[v]);
                sm += a;

                if (fl) {
                    mx = max(mx, a); ans += a;
                }
            } else {
                ans++;
                int a = dfs_cnt(i, v, 1, mn[v]);
            }
        }
    }

    if (fl) sm = 0;
    return sm;
}

void solve() {
    int n, q; cin >> n >> q;
    for (int i = 1; i <= n - 1; i++) {
        int a; cin >> a;
        a--;

        g[a].pb(i); g[i].pb(a);
    }
    for (int i = 0; i < n; i++) cin >> c[i];

    for (int i = 0; i < q; i++) {
        int a; cin >> a;
        a--;

        x = c[a];
        dfs_f(0, -1);

         ans = mx = 0;
         dfs_cnt(0, -1, 1, x);

         cout << ans - mx << " ";
    }
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double tim = clock();
#endif

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "-------------------\n";
#endif
    }

#ifdef LOCAL
    cout << (double)(clock() - tim) / CLOCKS_PER_SEC;
#endif
}
