#include <bits/stdc++.h>
// #pragma GCC optimize("O3")
// #pragma GCC target("avx2")
#define LOCAL

// std::mt19937 rnd(time(0));

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    #ifdef LOCAL
        std::freopen("input.txt", "r", stdin);
        std::freopen("output.txt", "w", stdout);
    #endif

    int t = 1;
    // std::cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}

std::vector <std::vector <int>> edges;
std::vector <int> parents;
std::vector <int> s;

std::map <int, int> quest;
std::vector <int> res;
std::vector <int> weight;

class V {
 public:
    int id;
    int val;

    bool operator < (const V& other) const {
        return val < other.val;
    }
};

std::vector <int> h;
inline void dfs(int curV, int prevV) {
    for (int nextV : edges[curV]) {
        if (nextV == prevV) continue;

        h[nextV] = h[curV] + 1;
        dfs(nextV, curV);
    }
}

void solve() {
    int n, q;
    std::cin >> n >> q;

    parents.resize(n, -1);

    edges.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        std::cin >> p;

        --p;

        edges[i].push_back(p);
        edges[p].push_back(i);

        parents[i] = p;
    }

    s.resize(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> s[i];
    }

    h.resize(n);
    dfs(0, -1);

    for (int i = 0; i < q; ++i) {
        int v;
        std::cin >> v;

        --v;

        std::cout << h[v] << '\n';
    }
}
