#include <bits/stdc++.h>
// #pragma GCC optimize("O3")
// #pragma GCC target("avx2")
#define LOCAL

// std::mt19937 rnd(time(0));

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

#ifdef LOCAL
    std::freopen("input.txt", "r", stdin);
    std::freopen("output.txt", "w", stdout);
#endif

    int t = 1;
    // std::cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}

std::vector <std::vector <int>> edges;
std::vector <int> parents;
std::vector <int> s;

std::vector <int> weight;

class V {
 public:
    int id;
    int val;

    bool operator < (const V& other) const {
        return val < other.val;
    }
};

inline int calc(int curV, int prevV, int curS) {
    if (s[curV] <= curS) return 0;

    int res = 1;

    for (auto nextV : edges[curV]) {
        if (nextV == prevV) continue;

        res += calc(nextV, curV, curS);
    }

    return res;
}

void solve() {
    int n, q;
    std::cin >> n >> q;

    parents.resize(n, -1);

    edges.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        std::cin >> p;

        --p;

        edges[i].push_back(p);
        edges[p].push_back(i);

        parents[i] = p;
    }

    s.resize(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> s[i];
    }

    for (int i = 0; i < q; ++i) {
        int u;
        std::cin >> u;

        --u;

        int min = s[u];

        int maxD = 0;

        long long size = 0;

        int curV = u;
        while (parents[curV] != -1) {
            for (auto nextV : edges[parents[curV]]) {
                if (nextV == curV || nextV == parents[parents[curV]]) continue;
                int curC = calc(nextV, parents[curV], min);
                size += curC;
                maxD = std::max(maxD, curC);
            }
            min = std::min(min, s[parents[curV]]);
            curV = parents[curV];
            size += 1;
        }

        std::cout << size - maxD << ' ';
    }
}
