#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <ctime>
#include <random>
#include <map>
#include <set>
#define ll long long
#define nl '\n'
#define emp emplace_back
#define all(x) x.begin(), x.end()
#define pll pair<ll, ll>
#define pii pair<int, int>
#define popcnt __builtin_popcount
#define ffs __builtin__ffs
#define ss second
#define ff first
//#include <ext/pb_ds/assoc_container.hpp>
//#pragma GCC optimize("O3")
//#pragma GCC target("avx");
//#pragma GCC target("avx2");

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll INF = 1e18;

const ll mod = 998244353;

mt19937 rnd(time(nullptr));

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &x : arr) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &arr) {
    for (auto &x : arr) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

ll n, q;
vector<vector<ll>> g;
vector<ll> s;
vector<ll> ans;

void solve() {
    cin >> n >> q;
    g.resize(n);
    s.resize(n);
    ans.resize(n, INF);
    for (ll i = 1; i < n; ++i) {
        ll p;
        cin >> p;
        --p;
        g[p].emp(i);
    }
    cin >> s;
    for (ll i = 0; i < n; ++i) {
        ll last = s[i];
        s[i] = 0;
        set<pll> st;
        for (auto u : g[0]) {
            st.insert({s[u], u});
        }
        vector<ll> dist(n, INF);
        dist[0] = 0;
        ll t = 1;
        while (!st.empty()) {
            auto it = --st.end();
            ll u = it->ss;
            dist[u] = t++;
            st.erase(it);
            for (auto v : g[u]) {
                st.insert({s[v], v});
            }
        }
        for (ll j = 0; j < n; ++j) {
            ans[j] = min(ans[j], dist[j]);
        }
        s[i] = last;
    }
    while (q--) {
        ll x;
        cin >> x;
        cout << ans[x - 1] << ' ';
    }
}

int main() {
#ifdef CLOCK
    ll time1 = clock();
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef CLOCK
    cout << clock() - time1 << " ms";
#endif
}