#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using sll = __int128;

template <typename T>
istream &operator>>(istream &in, pair<T, T> &a){
    in >> a.first >> a.second;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, pair<T, T> &a){
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream &operator>>(istream &in, vector<T> &a){
    for(auto &x : a) in >> x;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector<T> &a){
    for(auto x : a) out << x << ' ';
    return out;
}

vector<vector<int>> g;
vector<int> d;

void dfs(int vi){
    for(auto to : g[vi]){
        d[to] = d[vi] + 1;
        dfs(to);
    }
}

int check(int x, vector<int> &s, int cancel){
    int main = 1;
    int cnt = 0;
    int prev = s[cancel];
    s[cancel] = 0;
    set<pair<int, int>> st;
    while(main != x){
        for(auto to : g[main]){
            st.insert({-s[to], to});
        }
        main = (*st.begin()).second;
        st.erase(st.begin());
        cnt++;
    }
    s[cancel] = prev;
    return cnt;
}

void solve(){
    int n, q;
    cin >> n >> q;
    g.resize(n + 1);
    d.resize(n + 1);
    for(int i = 2; i <= n; i++){
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    vector<int> s(n + 1);
    for(int i = 1; i <= n; i++) cin >> s[i];
    dfs(1);
    while(q--){
        int x;
        cin >> x;
        int res = 2e9;
        for(int i = 2; i <= n; i++){
            if(i == x) continue;
            res = min(res, check(x, s, i));
//            cout << x << ' ' << i << ' ' << check(x, s, i) << '\n';
        }
        cout << res << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test = 1;
//    cin >> test;
    while(test--){
        solve();
    }
}

