#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using sll = __int128;

template <typename T>
istream &operator>>(istream &in, pair<T, T> &a){
    in >> a.first >> a.second;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, pair<T, T> &a){
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream &operator>>(istream &in, vector<T> &a){
    for(auto &x : a) in >> x;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector<T> &a){
    for(auto x : a) out << x << ' ';
    return out;
}

vector<vector<int>> g;

vector<pair<int, int>> check(vector<int> &s, vector<int> &pr){
    int main = 1;
    int cnt = -1;
    set<pair<int, int>> st;
    st.insert({-s[1], 1});
    vector<pair<int, int>> qu;
    while(!st.empty()){
        main = (*st.begin()).second;
        st.erase(st.begin());
        qu.push_back({main, pr[main]});
        for(auto to : g[main]){
            st.insert({-s[to], to});
        }
        cnt++;
    }
    return qu;
}

void solve(){
    int n, q;
    cin >> n >> q;
    g.resize(n + 1);
    vector<int> pr(n + 1);
    for(int i = 2; i <= n; i++){
        int p; cin >> p;
        if(p == 1) pr[i] = i;
        else pr[i] = pr[p];
        g[p].push_back(i);
    }
    vector<int> s(n + 1);
    for(int i = 1; i <= n; i++) cin >> s[i];
    auto qu = check(s, pr);
    vector<int> pos(n + 1);
    for(int i = 1; i < qu.size(); i++){
        pos[qu[i].first] = i;
    }
    int mx = 0;
    map<int, int> mp;
    set<pair<int, int>> st;
    vector<int> pref(size(qu) + 2);
    for(int i = 1; i < qu.size(); i++){
        auto [x, y] = qu[i];
        if(st.find({mp[y], y}) != st.end()) st.erase({mp[y], y});
        mp[y]++;
        st.insert({mp[y], y});
        if(pr[x] == (*st.begin()).second){
            if(size(st) == 1) {
                pref[i] = 0;
            } else {
                pref[i] = (*(++st.begin())).first;
            }
        } else {
            pref[i] = (*st.begin()).first;
        }
    }
    while(q--){
        int x; cin >> x;
        cout << pos[x] - pref[pos[x]] << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test = 1;
//    cin >> test;
    while(test--){
        solve();
    }
}

