#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

//#include <ext/pb_ds/assoc_containe.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template <class T> order_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//find_by_orede, order_of_key

#define int long long
#define all(a) (a).begin(), (a).end()

#pragma GCC optimize ("O3")
#pragma GCC target ("avx2")


const int inf = 1e18;



vector<vector<int>> g;

vector<int> h, s;

void dfs(int v, int p) {
	h[v] = h[p] + 1;
	for (int u : g[v]) dfs(u, v);
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif


	int n, q; cin >> n >> q;
	s.resize(n);
	h.resize(n);

	vector<vector<int>> x(n);
	vector<int> p(n);

	g.resize(n);
	h.resize(n);

	for (int i = 1; i < n; ++i) {
		cin >> p[i]; --p[i];
		g[p[i]].push_back(i);

		if (p[p[i]]) p[i] = p[p[i]];
	}

	vector<int> st;
	for (int i = 0; i < n; ++i) {
		cin >> s[i];

		if (i) {
			if (p[i]) {
				s[i] = max(-s[i], x[p[i]].back());
				x[p[i]].push_back(s[i]);
			}
			else {
				s[i] = -s[i];

				x[i].push_back(s[i]);
				st.push_back(i);
			}
		}
	}
	dfs(0, 0);

	while (q--) {
		int v; cin >> v; --v;
		if (v == 0) {
			cout << 0 << ' '; continue;
		}
		int sm = 0, mx = 0;
		for (int u : st) {
			if (p[v] == u) continue;
			int cur = (lower_bound(all(x[u]), s[v]) - x[u].begin());
			mx = max(mx, cur);
			sm += cur;
		}
		cout << h[v] - 1 + sm - mx << ' ';
	}
}