#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int maxn = 1e3 + 1;
vector<vector<int>> g(maxn);

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 2, p; i <= n; ++i) {
        cin >> p;
        g[p].push_back(i);
    }
    vector<int> s(n + 1), ans(n + 1,1e9);
    for (int i = 0; i < n; ++i) cin >> s[i + 1];

    for (int i = 1; i <= n; ++i) {
        std::sort(g[i].begin(), g[i].end(), [&](int a, int b) {
            return s[a] > s[b];
        });
    }
    for (int del = 1; del <= n; del++) {
        int root = 1;
        auto gnew = g;
        auto snew = s;
        snew[del] = 0;
        auto get = [&](){
            int res = -1;
            for (auto v : gnew[root]) {
                if (res == -1 || snew[res] < snew[v]) res = v;
            }
            return res;
        };
        for (int i = 0;; ++i) {
            ans[root] = min(ans[root], i);
            if (gnew[root].empty()) break;
            int newroot = get();
            for (auto v : gnew[root]) {
                if (v != newroot) gnew[newroot].push_back(v);
            }
            root = newroot;
        }
    }
    for (int i = 0; i < q; ++i) {
        int u;
        cin >> u;
        cout << ans[u] << ' ';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
