#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> a;
vector<vector<pair<int, int>>> vals;
vector<int> ansval, ansbest;
vector<vector<tuple<int, int, int>>> qs;
vector<int> depth;

void prec(int v) {
    for (auto to : g[v]) {
        depth[to] = depth[v] + 1;
        prec(to);
    }
}

vector<tuple<int, int, int>> va;
vector<int> counts;
int vtot = 0;

void dfs(int v) {
    int vsum = 0;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        dfs(to);
        vsum += vals[to].size();
        for (auto& [qval, qid, qto] : qs[to])
            qs[v].push_back({ min(qval, a[to]), qid, i });
        qs[to].clear();
    }
    va.reserve(vsum);
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        vtot += vals[to].size();
        for (auto& [k, val] : vals[to])
            va.push_back({ min(k, a[to]), i, val });
        vtot += 1;
        if (vtot > 2 * g.size()) {
            exit(10);
        }
        vtot -= vals[to].size();
        va.push_back({ a[to], i, 1 });
        vals[to].clear();
    }
    counts.assign(g[v].size(), 0ll);
    sort(va.begin(), va.end());
    sort(qs[v].begin(), qs[v].end());
    int qptr = qs[v].size() - 1;
    int tot = 0;
    if (va.size() == 0)
        return;
    int begt = get<0>(va.back());
    while (qptr >= 0 && get<0>(qs[v][qptr]) > begt)
        qptr -= 1;
    int best = -1, secbest = -1;
    for (int i = va.size() - 1; i >= 0;) {
        int curt = get<0>(va[i]);
        int curcnt = 0;
        while (i >= 0 && get<0>(va[i]) == curt) {
            auto [t, to, val] = va[i];
            counts[to] += val;
            if (to != best) {
                if (counts[to] > counts[best]) {
                    int tmp = to;
                    swap(tmp, best);
                    if (secbest == -1 || secbest == to || counts[tmp] > counts[secbest])
                        swap(tmp, secbest);
                } else {
                    if (counts[to] > counts[secbest]) {
                        secbest = to;
                    }
                }
            }
            curcnt += val;
            --i;
        }
        tot += curcnt;
        vals[v].push_back({ curt, curcnt });
        int prevt = (i >= 0 ? get<0>(va[i]) : -1ll);
        while (qptr >= 0 && get<0>(qs[v][qptr]) <= curt && get<0>(qs[v][qptr]) > prevt) {
            auto [qt, qid, qto] = qs[v][qptr];
            ansval[qid] += tot - counts[qto];
            if (best != qto)
                ansbest[qid] = max(ansbest[qid], counts[best]);
            else if (secbest != -1 && best == qto)
                ansbest[qid] = max(ansbest[qid], counts[secbest]);
            --qptr;
        }
    }
    // int qtot = 0, vtot = 0;
    // for (int i = 0; i < g.size(); ++i) {
    //     qtot += qs[i].size();
    //     vtot += vals[i].size();
    // }
    // if (qtot > qall || vtot > g.size()) {
    //     exit(10);
    // }
    va.clear();
    counts.clear();
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, q;
    cin >> n >> q;
    g.resize(n);
    vector<int> p(n);
    p[0] = -1;
    for (int i = 1; i < n; ++i) {
        int pi;
        cin >> pi;
        --pi;
        g[pi].push_back(i);
        p[i] = pi;
    }
    a.resize(n);
    for (auto& el : a)
        cin >> el;
    depth.resize(n, 0);
    prec(0);
    qs.resize(n), vals.resize(n), ansval.resize(q), ansbest.resize(q);
    vtot = 0;
    vector<int> previd(n);
    for (int v = 0; v < n; ++v) {
        for (int i = 0; i < g[v].size(); ++i)
            previd[g[v][i]] = i;
    }
    for (int qid = 0; qid < q; ++qid) {
        int v;
        cin >> v;
        --v;
        int cur = a[v];
        int curv = p[v];
        int prv = v;
        ansval[qid] += depth[v];
        if (curv != -1) {
            qs[curv].push_back({ cur, qid, previd[prv] });
        }
        // while (curv != -1) {
        //     ansval[qid] += 1;
        //     qs[curv].push_back({ cur, qid, prv });
        //     cur = min(cur, a[curv]);
        //     prv = curv;
        //     curv = p[curv];
        // }
    }
    dfs(0);
    for (int qid = 0; qid < q; ++qid)
        cout << ansval[qid] - ansbest[qid] << ' ';
    // while (q--) {
    //     int v;
    //     cin >> v;
    //     --v;
    //     int cur = a[v];
    //     int curv = p[v];
    //     int prv = v;
    //     int ans = 0, best = 0;
    //     while (curv != -1) {
    //         ans += 1;
    //         for (auto to : g[curv]) {
    //             if (to == prv)
    //                 continue;
    //         }
    //         prv = curv;
    //         curv = p[curv];
    //     }
    //     cout << ans - best << ' ';
    // }
}