#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

ll inf = (ll)1e18;

template<class T>
ll len(T& a) {
    return (ll)a.size();
}

ll n, q;
vector<vector<ll>> g;
vector<ll> s;
vector<ll> queries;
vector<ll> h;

void dfs(ll x, ll c) {
    h[x] = c;
    for (ll to : g[x]) {
        dfs(to, c);
    }
}

void solve() {
    cin >> n >> q;
    h.resize(n, 0);
    ll x;
    g.resize(n);
    s.resize(n);
    h.resize(n);
    queries.resize(q);
    for (ll i = 1; i < n; ++i) {
        cin >> x;
        x--;
        g[x].push_back(i);
    }
    for (ll i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (ll i = 0; i < q; ++i) {
        cin >> queries[i];
        queries[i]--;
    }

    vector<ll> topsort;
    priority_queue<pair<ll, ll>> que;
    que.push({s[0], 0});
    while (!que.empty()) {
        pair<ll, ll> temp = que.top(); que.pop();
        topsort.push_back(temp.second);
        for (ll to : g[temp.second]) {
            que.push({s[to], to});
        }
    }

    ll curr = 1;
    for (ll to : g[0]) {
        dfs(to, curr++);
    }
    h[0] = 0;
    for (ll i = 0; i < q; ++i) {
        if (queries[i] == 0) {
            cout << 0 << "\n";
            continue;
        }
        map<ll, ll> cnt;
        for (ll j = 1; j < len(topsort); ++j) {
            if (topsort[j] == queries[i]) {
                ll value = 0;
                for (const auto& [key, valuee] : cnt) {
                    if (key == h[topsort[j]]) { continue; }
                    if (key == 0) { continue; }
                    value = max(value, valuee);
                }
                cout << j - value << "\n";
                break;
            }
            cnt[h[topsort[j]]]++;
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}