#include <bits/stdc++.h>

using namespace std;
#define int long long

vector<vector<int>> g;
vector<vector<int>> bup;
vector<int> tin, tout;
int t = 0;
const int K = 20;

void dfs(int v, int p) {
    tin[v] = t++;
    bup[0][v] = p;
    for (int i = 1; i < K; ++i) {
        bup[i][v] = bup[i - 1][bup[i - 1][v]];
    }
    for (auto u: g[v]) {
        dfs(u, v);
    }
    tout[v] = t++;
}

bool anc(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v) {
    if (anc(u, v)) {
        return u;
    }
    if (anc(v, u)) {
        return u;
    }
    for (int i = K - 1; i >= 0; --i) {
        if (!anc(bup[i][v], u)) {
            v = bup[i][v];
        }
    }
    return v;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    g.resize(n);
    bup.assign(K, vector<int> (n));
    tin.resize(n);
    tout.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
    }
    vector<int> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    dfs(0, 0);
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        --v;

        set<pair<int, int>, greater<>> a;
        a.insert({s[0], 0ll});
        int res = 0;
        map<int, int> mp;
        while (a.begin()->second != v) {
            ++res;
            auto [z, x] = *a.begin();
            a.erase(a.begin());
            mp[lca(v, x)]++;
            for (auto u: g[x]) {
                a.insert({s[u], u});
            }
        }
        int mx = 0;
        for (auto x : mp) {
            if (x.first != v) {
                mx = max(mx, x.second);
            }
        }

        cout << res - mx << "\n";
    }
    return 0;
}
