#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <bitset>
#include <unordered_map>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <random>

#define all(v) v.begin(), v.end()
#define len(v) (int)v.size()

//using namespace __gnu_pbds;
using namespace std;
using ll = long long;
using ld = long double;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

vector<int> pr;
vector<vector<int>> g;
vector<vector<int>> ng0;
vector<vector<int>> ng1;
vector<int> s;
vector<int> dp0;
vector<int> dp1;

int dfs1(int v, int c)
{
    if (s[v] < c) return 0;
    int cnt = 1;
    for (int u : g[v])
    {
        cnt += dfs1(u, c);
    }
    return cnt;
}

void dfs(int v, int p)
{
    if (p != -1)
    {
        {
            vector<int> cnts;
            int mx = 0;
            ll sum = 0;
            for (int u : ng0[p])
            {
                if (u == v) continue;
                if (s[u] > s[v])
                {
                    ng0[v].push_back(u);
                }
                cnts.push_back(dfs1(u, s[v]));
                sum += cnts.back();
                mx = max(mx, cnts.back());
            }
            dp0[v] = dp0[p] + sum + 1;
        }
        {
            vector<int> cnts;
            int mx = 0, mxi = -1;
            ll sum = 0;
            for (int u : ng1[p])
            {
                if (u == v) continue;
                cnts.push_back(dfs1(u, s[v]));
                sum += cnts.back();
                if (mx < cnts.back())
                {
                    mx = cnts.back();
                    mxi = u;
                }
            }
            if (dp1[p] + sum + 1 < dp0[p] + sum + 1 - mx)
            {
                dp1[v] = dp1[p] + sum + 1;
                for (int u : ng1[p])
                {
                    if (u == v) continue;
                    ng1[v].push_back(u);
                }
            } else
            {
                dp1[v] = dp0[p] + sum + 1 - mx;
                for (int u : ng1[p])
                {
                    if (u == v) continue;
                    if (mxi == u) continue;
                    ng1[v].push_back(u);
                }
            }
        }
        //cout << v << ' ' << dp0[v] << ' ' << dp1[v] << '\n';
    } else
    {
        dp0[v] = 0;
        dp1[v] = 0;
    }
    for (int u : g[v])
    {
        dfs(u, v);
    }
}

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n, q;
    cin >> n >> q;
    pr.resize(n);
    g.resize(n);
    ng0.resize(n);
    ng1.resize(n);
    s.resize(n);
    dp0.resize(n);
    dp1.resize(n);
    pr[0] = -1;
    for (int i = 1; i < n; ++i)
    {
        cin >> pr[i];
        --pr[i];
        g[pr[i]].push_back(i);
        ng0[pr[i]].push_back(i);
        ng1[pr[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> s[i];
    }
    dfs(0, -1);
    for (int i = 0; i < q; ++i)
    {
        int v;
        cin >> v;
        --v;
        cout << dp1[v] << ' ';
    }

    return 0;
}
