#pragma GNU optimize("O3")
#pragma GNU optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define in insert
#define int long long
#define ll long long
#define inf 1000000000000000000
#define N 300000

vector<int> gr[N];
int a[N], p[N], s[N], sz[N];
int n, m;

void pre_DFS(int v){
    sz[v] = 1;
    for(int &u: gr[v]){
        pre_DFS(u);
        sz[v] += sz[u];
        if(sz[u] > sz[gr[v][0]]) swap(u, gr[v][0]);
    }
}

int T = 0, tin[N], tout[N], head[N];
void DFS(int v){
    tin[v] = T++;
    for(int u: gr[v]){
        if(u == gr[v][0]) head[u] = head[v];
        else head[u] = u;
        DFS(u);
    }
    tout[v] = T;
}

bool anc(int u, int v){
    return (tin[u] < tin[v]) && (tout[u] > tout[v]);
}

struct node{
    node *ls = 0, *rs = 0;
    int l, r, s = 0, ma = 0;

    node(){};

    node(int l, int r): l(l), r(r){
        if(r - l == 1) ;
        else{
            ls = new node(l, (l + r) / 2);
            rs = new node((l + r) / 2, r);
        }
    }

    void push(){
        if(ls != 0){
            ls->s += s;
            rs->s += s;
        }
        ma += s;
        s = 0;
    }

    void recalc(){
        ma = max(ls->ma, rs->ma);
    }

    void add(int L, int R){
        push();
        if(L <= l && r <= R){ s++; push(); return ; }
        if(R <= l || r <= L) return;
        ls->add(L, R), rs->add(L, R);
        recalc();
    }

    int get(int L, int R){
        push();
        if(L <= l && r <= R){  return ma; }
        if(r <= L || l >= R) return 0;
        return max(ls->get(L, R), rs->get(L, R));
    }

    void print(){
        push();
//            cout <<  l << ' ' << r << ' ' << ma << ' ';
        if(ls == 0){
            return ;
        }
        ls->print(); rs->print();
    }
} root;

int get(int v){
//    return root.get(tout[v], n);
    int res = 0, pr = v;
    while(v != -1){
        res = max(res, max(root.get(tout[pr], n), root.get(tin[v] + 1, tin[pr])));
        pr = head[v];
        v = p[head[v]];
    }
    return res;
}

void add(int v){
    while(v != -1){
        root.add(tin[head[v]], tin[v] + 1);
//        cout << tin[head[v]] << ' ' << tin[v] + 1 << endl;
        v = p[head[v]];
    }
}

void tup(){
    int q;
    cin >> n >> q;
    for(int i = 1; i < n; i++){
        int u; cin >> u; u--;
        p[i] = u;
        gr[u].pb(i);
    }
    for(int i = 0; i < n; i++) cin >> s[i];
    pre_DFS(0);
    DFS(0);
    root = node(0, n);
    p[0] = -1;

    set< pair<int,int> > h;
    h.in({-s[0], 0});
    vector<int> ans(n);
    int t = 0;
    while(h.size()){
//        cout << t << endl;
        pair<int, int> dd = *h.begin();
//        cout << 5 << endl;
        int d = dd.first, i = dd.second;
//        cout << d << ' ' << i + 1 << endl;
        h.erase(h.begin());
//        cout << 6 << endl;
        ans[i] = t++ - get(i);
//        cout << 7 << endl;
        add(i);
//        cout << "S: "; root.print(); cout << endl;
//        cout << 8 << endl;
        for(int u: gr[i]){
            h.in({-s[u], u});
        }
    }
    ans[0] = 0;
//    for(int i: ans) cout << i << ' '; cout << endl;

    while(q--){
        int u; cin >> u; u--;
        cout << ans[u] << ' ';
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    tup();
}