
#include <iostream>
#include <limits>
#include <chrono>
#include <random>
#include <iomanip>
#include <algorithm>
#include <chrono>
#include <random>
#include <math.h>
#include <set>
using namespace std;
#define int long long
const int maxn = 3e5 + 1;
int t = 0;
int tin[maxn], tout[maxn], min_v[maxn],deep[maxn];
vector <int> g[maxn];
void dfs(int u, int min_val, vector <int>& weight,int deep_now) {
	deep[u] = deep_now;
	tin[u] = t++;
	int val = min(min_val, weight[u]);
	min_v[u] = val;
	for (auto el : g[u]) {
		dfs(el, val, weight,deep_now + 1);
	}
	tout[u] = t;
}
void dfs2(int u, int min_val, vector <int>& w, vector <int>& dp, int z) {
	min_val = min(min_val, w[u]);
	if (min_val > z)dp[u]++;
	for (auto el : g[u]) {
		dfs2(el, min_val, w, dp, z);
		dp[u] += dp[el];
	}

}
bool dfs1(int u, int& min_val, vector <int>& dp, vector <int>& color, int last, vector <int>& w) {
	if (u == last) {
		min_val = w[u];
		return 1;
	}
	int pos = -1;
	for (auto el : g[u]) {
		if (dfs1(el, min_val, dp, color, last, w)) {
			pos = el;
			break;
		}
	}



	return 0;
}
signed main()
{
	int n, q;
	cin >> n >> q;
	vector <int> p(n, -1);
	for (int i = 1;i < n;i++) {
		int pi;
		cin >> pi;
		pi--;
		p[i] = pi;
		g[pi].push_back(i);
	}
	vector <int> w(n);
	for (int i = 0;i < n;i++) {
		cin >> w[i];
	}
	dfs(0, w[0], w, 0);
	vector <int> ans;
	while (q--) {
		int vert;
		cin >> vert;
		vert--;
		cout << deep[vert] << "\n";
		
	}
}
