#include<bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
using namespace std;

//#define int long long
struct segtree {
    vector<int> t, p;

    void sz(int n) {
        t.resize(4 * n);
        p.resize(4 * n);
    }

    void push(int v, int l, int r) {
        if (l + 1 == r) {
            t[v] += p[v];
            p[v] = 0;
            return;
        }
        p[2 * v + 1] += p[v];
        p[2 * v + 2] += p[v];
        t[v] += p[v];
        p[v] = 0;
    }

    void upd(int v, int l, int r, int ql, int qr, int x) {
        push(v, l, r);
        if (r <= ql || qr <= l) return;
        if (l >= ql && r <= qr) {
            p[v] += x;
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        upd(2 * v + 1, l, m, ql, qr, x);
        upd(2 * v + 2, m, r, ql, qr, x);
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }

    int get() {
        return t[0];
    }
};

int maxn = 3e5;
vector<vector<int>> g(maxn);
vector<int> s(maxn), d(maxn), ti(maxn), tin(maxn), tout(maxn), sz(maxn), pr(maxn), rt(maxn);

void gs(int i) {
    sz[i] = 1;
    for (int j: g[i]) {
        gs(j);
        sz[i] += sz[j];
    }
}

void bl(int i) {
    int u = 0;
    for (int j = 0; j < (int) g[i].size(); ++j) {
        if (sz[g[i][j]] > sz[g[i][u]]) u = j;
    }
    if (!g[i].empty())
        swap(g[i][u], g[i][0]);
    for (int j = 0; j < (int) g[i].size(); ++j) {
        int j1 = g[i][j];
        if (j == 0) {
            rt[j1] = rt[i];
            bl(j1);
        } else {
            rt[j1] = j1;
            bl(j1);
        }
    }
}

segtree t;
int yy = 0;
int uu = 0;

void dfs(int i, set<pair<int, int>> &kd) {
    ti[i] = yy++;
    if (kd.empty()) return;
    int u = (*kd.rbegin()).second;
    kd.erase(*kd.rbegin());
    for (int j: g[u]) {
        kd.insert({s[j], j});
    }
    dfs(u, kd);
}

void dfs2(int i, int p = -1) {
    tin[i] = uu++;
    pr[i] = p;
    for (int j: g[i]) {
        dfs2(j, i);
    }
    tout[i] = uu;
}

bool isp(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int get() {
    return t.get();
}

int n;

void upd(int v, int x) {
    while (v != -1) {
        t.upd(0, 0, n, tin[rt[v]], tin[v] + 1, x);
        v = pr[rt[v]];
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    int q;
    cin >> n >> q;
    for (int i = 0; i < n - 1; ++i) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i + 1);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }

    vector<array<int, 3>> v(n);
    set<pair<int, int>> kd;
    gs(0);
    bl(0);
    dfs2(0);
    t.sz(n);
    for (int j: g[0]) kd.insert({s[j], j});
    dfs(0, kd);
    for (int i = 0; i < n; ++i) v[i] = {ti[i], i, 0};
    //for(int i = 0; i < n; ++i) cout << ti[i] << ' ';
    for (int i = 1; i <= q; ++i) {
        int x;
        cin >> x;
        x--;
        v[x][2] = i;
    }
    vector<int> ans(q);
    sort(v.begin(), v.end());
    for (int i = 0; i < n; ++i) {
        if (v[i][2]) {
            upd(v[i][1], -1e9);
            ans[v[i][2] - 1] = ti[v[i][1]] - max(0, get());
            upd(v[i][1], 1e9);
        }
        upd(v[i][1], 1);
    }
    for (int i: ans) cout << i << ' ';
    return 0;

}
