#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ld long double
#define all(x) (x).begin(), (x).end()

vector<int> h;
vector<vector<int>> g;

void dfs(int v, int p){
    if (p == -1) h[v] = 0;
    else h[v] = h[p] + 1;
    for (int to: g[v]){
        if (to == p) continue;
        dfs(to, v);
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vector<int> p(n), s(n);
    g.resize(n);
    h.resize(n);
    for (int i = 1; i < n; i++){
        cin >> p[i];
        p[i]--;
        g[i].push_back(p[i]);
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; i++){
        cin >> s[i];
    }
    dfs(0, -1);
    for (int i = 0; i < q; i++){
        int v;
        cin >> v;
        v--;
        cout << h[v] << ' ';
    }
}
