#include<bits/stdc++.h>
//#include<ext/pb_ds/assoc_container.hpp>
#define ll long long

using namespace std;
//using namespace __gnu_pbds;


ll n, q;
vector<ll> s, v, sum, pos, ans, color, pp;
vector<vector<ll>> a;
set<ll> seset;
vector<bool> used;

void input() {
    cin >> n >> q;
    pp = {-1};
    a.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll p;
        cin >> p;
        pp.push_back(p - 1);
        a[p - 1].push_back(i + 1);
        a[i + 1].push_back(p - 1);
    }
    s.resize(n);
    v.resize(q);
    for (ll i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (ll i = 0; i < q; i++) {
        cin >> v[i];
    }
}

void dfs(ll u, ll cl) {
    sum[u] = 0;
    if (cl < pos[u]) {
        return;
    }
    sum[u] = 1;
    for (ll i = 0; i < a[u].size(); i++) {
        if (sum[a[u][i]] == -1) {
            dfs(a[u][i], cl);
            sum[u] += sum[a[u][i]];
        }
    }
}

void dfs2(ll u) {
    for (ll i = 0; i < a[u].size(); i++) {
        if (!used[a[u][i]]) {
            seset.insert(-sum[a[u][i]]);
        }
    }
}

void solve() {
    pos.resize(n);
    pos[0] = 1;
    set<pair<ll, ll>> ses;
    used.assign(n, false);
    used[0] = true;
    for (ll i = 0; i < a[0].size(); i++) {
        used[a[0][i]] = true;
        ses.insert({-s[a[0][i]], a[0][i]});
    }
    ll cnt = 1;
    vector<ll> order = {0};
    while (ses.size() > 0) {
        cnt++;
        ll u = ses.begin() -> second;
        pos[u] = cnt;
        order.push_back(u);
        ses.erase(ses.begin());
        for (ll i = 0; i < a[u].size(); i++) {
            if (!used[a[u][i]]) {
                used[a[u][i]] = true;
                ses.insert({-s[a[u][i]], a[u][i]});
            }
        }
    }
    ans.resize(q);
    for (ll i = 0; i < q; i++) {
        ll tk = v[i] - 1;
        sum.assign(n, -1);
        dfs(0, pos[tk]);
        ll r = tk;
        vector<ll> preds;
        while (true) {
            r = pp[r];
            if (r == -1) {
                break;
            }
            preds.push_back(r);
        }
        seset.clear();
        used.assign(n, false);
        used[tk] = true;
        for (ll i = 0; i < preds.size(); i++) {
            used[preds[i]] = true;
        }
        for (ll i = 0; i < preds.size(); i++) {
            dfs2(preds[i]);
        }
        if (seset.size() == 0) {
            ans[i] = pos[tk] - 1;
        } else {
            ans[i] = pos[tk] - 1 + *seset.begin();
        }
    }
}

void output() {
    for (ll i = 0; i < q; i++) {
        cout << ans[i] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}
