#include<bits/stdc++.h>
using namespace std;

vector<int>ans;

bool comp(int a, int b)
{
    return(ans[a] < ans[b]);
}
vector<int>sz;
bool comp_sz(int a, int b)
{
    return(sz[a] > sz[b]);
}
void dfs_sz(int v, vector<vector<int>>&gr)
{
    sz[v] = 1;
    for(int i: gr[v])
    {
        dfs_sz(i, gr);
        sz[v] += sz[i];
    }
    sort(gr[v].begin(), gr[v].end(), comp_sz);
}
vector<int>tin; int t; vector<int>head;
void dfs_tin(int v, vector<vector<int>>&gr)
{
    tin[v] = t;
    t++;
    for(int i: gr[v])
    {
        if(i == gr[v][0])
        {
            head[i] = head[v];
        }
        else
        {
            head[i] = i;
        }
        dfs_tin(i, gr);
    }
}

vector<int>tree;
vector<int>add;
void push(int v)
{
    add[2 * v + 1] += add[v];
    add[2 * v + 2] += add[v];
    add[v] = 0;
}
vector<int>p;
void update(int v, vector<int>&tree, int l, int r, int ql, int qr, int val)
{
    if(ql >= r || l >= qr)
    {
        return;
    }
    if(ql <= l && r <= qr)
    {
        add[v] += val;
        return;
    }
    push(v);
    int mid = (r + l)/2;
    update(2 * v + 1, tree, l, mid, ql, qr, val);
    update(2 * v + 2, tree, mid, r, ql, qr, val);
    tree[v] = max(tree[2 * v + 1] + add[2 * v + 2], tree[2 * v + 2] + add[2 * v + 2]);
}

int gt(int v, vector<int>&tree, int l, int r, int ql, int qr)
{
    if(ql >= r || l >= qr || qr <= ql)
    {
        return 0;
    }
    if(ql <= l && r <= qr)
    {
        return tree[v] + add[v];
    }
    push(v);
    int mid = (r + l)/2;
    int resl = gt(2 * v + 1, tree, l, mid, ql, qr);
    int resr = gt(2 * v + 2, tree, mid, r, ql, qr);
    tree[v] = max(tree[2 * v + 1] + add[2 * v + 2], tree[2 * v + 2] + add[2 * v + 2]);
    return max(resl, resr);
}

void upd_v(int v, int n)
{
    while(v != -1)
    {
        update(0, tree, 0, n, tin[head[v]], tin[v] + 1, 1);
        v = p[head[v]];
    }
}

int get_v(int v, int n)
{
    int a = gt(0, tree, 0, n, tin[v] + 1, n);
    while((v != -1 && p[head[v]] != -1))
    {
        a = max(a, gt(0, tree, 0, n, tin[p[head[v]]] + 1, tin[head[v]]));
        v = p[head[v]];
    }
    return a;
}

signed main()
{
    int n, q;
    cin >> n >> q;
    vector<vector<int>>gr(n);
    p.assign(n, -1);
    for(int i = 1; i < n; i++)
    {
        cin >> p[i];
        p[i]--;
        gr[p[i]].push_back(i);
    }
    vector<int>s(n);
    for(int i = 0; i < n; i++)
    {
        cin >> s[i];
    }
    set<pair<int, int>>prior;
    ans.assign(n, 0);
    prior.insert({s[0], 0});
    pair<int, int>v;
    int d = 0;
    while(not(prior.empty()))
    {
        v = *prior.rbegin();
        prior.erase(v);
        ans[v.second] = d;
        d++;
        for(auto i: gr[v.second])
        {
            prior.insert({s[i], i});
        }
    }
    vector<int>quest(n, -1);
    vector<int>pr(n);
    vector<int>print(q);
    for(int i = 0; i < n; i++)
    {
        pr[i] = i;
    }
    for(int i = 0; i < q; i++)
    {
        cin >> d;
        d--;
        quest[d] = i;
    }
    tree.assign(4 * n, 0);
    sort(pr.begin(), pr.end(), comp);
    tin.assign(n, 0);
    add.assign(4 * n, 0);
    sz.assign(n, 0);
    head.assign(n, 0);
    dfs_sz(0, gr);
    t = 0;
    dfs_tin(0, gr);
    for(int i = 0; i < n; i++)
    {
        if(quest[pr[i]] != -1)
        {
            print[quest[pr[i]]] = ans[pr[i]] - get_v(pr[i], n);
        }       
        upd_v(pr[i], n);
    }
    for(int i: print)
    {
        cout << i << " ";
    }
}