#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using ll = long long;

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll inf = 1e18;

vector<ll> s;
vector<vector<ll>> g;
vector<ll> p;
vector<ll> d;
vector<ll> h;
vector<ll> tin, tout;

ll tmr = 0;

void dfs(ll v, ll prev) {
    if (prev != -1) {
        h[v] = h[prev] + 1;
    } else {
        h[v] = 0;
    }
    tin[v] = tmr;
    for (auto i : g[v]) {
        if (i != prev) {
            tmr++;
            dfs(i, v);
        }
    }
    tout[v] = tmr;
    tmr++;
}

bool is_anc(ll u, ll v) {
    return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

void dfs1(ll v, ll prev, ll bv) {
    if (v == bv) {
        d[v] = 0;
        return;
    }
    for (auto i : g[v]) {
        if (i != prev && s[i] > s[bv]) {
            dfs1(i, v, bv);
            d[v] += d[i];
        }
    }
    if (s[v] > s[bv]) {
        d[v]++;
    }
}

inline void solve() {
    ll n, q;
    cin >> n >> q;
    s.resize(n);
    p.resize(n);
    g.resize(n);
    d.resize(n);
    h.resize(n);
    tin.resize(n);
    tout.resize(n);
    for (ll i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[i].push_back(p[i]);
        g[p[i]].push_back(i);
    }
    for (ll i = 0; i < n; i++) {
        cin >> s[i];
    }
    dfs(0, -1);
    for (ll _ = 0; _ < q; _++) {
        ll x;
        cin >> x;
        x--;
        d = vector<ll>(n, 0);
        dfs1(0, -1, x);
        ll res = d[0];
        for (ll i = 0; i < n; i++) {
            if (!is_anc(i, x) && !is_anc(x, i)) {
                res = min(res, d[0] - d[i]);
            }
        }
        cout << res << endl;
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll q = 1;
    // cin >> q;
    while (q--) {
        solve();
    }
}
