#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pi;

#define int ll
#define pb push_back
#define pf push_front
#define in insert
#define f first
#define s second

mt19937_64 rnd;

const int inf = 1e17, N = 4e5, mod = 1e9 + 7;

vector<vector<int>> g(N);
vector<int> s(N), p(N);
vector<bool> used(N);

void init(int u){
  for(int v : g[u]) if(v != p[u]){
    p[v] = u;
    init(v);
  }
}

int dpt(int u, int val){
  int sum = 0;
  for(int v : g[u]) if(v != p[u] && s[v] > val) sum += dpt(v, val);
  return sum + 1;
}

int calc(int u){
  int sum = 0, mx = 0, prev = s[u];
  while(u){
    used[u] = 1;
    u = p[u];
    if(!u){
      break;
    }
    for(int v : g[u]) if(!used[v] && v != p[u] && s[v] > prev){
      int mem = dpt(v, prev);
      sum += mem;
      mx = max(mx, mem);
    }
    sum++;
    prev = min(s[u], prev);
  }
  return sum - mx;
}

signed main(){
  int n, q;
  cin >> n >> q;
  for(int i = 2; i <= n; i++){
    int p;
    cin >> p;
    g[p].pb(i);
  }
  vector<int> mi(n + 1);
  for(int i = 1; i <= n; i++){
    cin >> s[i];
    mi[s[i]] = i;
  }
  init(1);
  while(q--){
    int v;
    cin >> v;
    cout << calc(v) << ' ';
    for(int i = 1; i <= n; i++) used[i] = 0;
  }
  return 0;
}