#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>

#define int long long

using namespace std;


void dfs(int v, vector<int>& p, vector<vector<int>>& pot, vector<int>& more, vector<int>& s, int u) {
    if (s[v] > s[u]) {
        more[v] = 1;
    }
    else {
        more[v] = 0;
    }
    if (pot[v].empty()) {
        return;
    }
    for (auto i: pot[v]) {
        dfs(i, p, pot, more, s, u);
        more[v] += more[i];
    }
}

signed main() {
    int n, q;
    cin >> n >> q;
    vector<int> p(n), s(n), v(q);
    vector<vector<int>> pot(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        pot[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
        int u = v[i] - 1;
        unordered_map<int, int> pred;
        int now = u;
        while (now != 0) {
            now = p[now];
            pred[now] = 1;
        }
        set<vector<int>> st;
        int ans = 1e9;
        for (int can = 1; can < n; ++can) {
            if (can != u) {
                int cnt = 0;
                now = 0;
                while (now != u) {
                    for (auto i: pot[now]) {
                        if (i != can) {
                            st.insert({-s[i], i});
                        }

                    }
                    now = (*st.begin())[1];
                    ++cnt;
                    st.erase(st.begin());
                }
                ans = min(ans, cnt);
            }
        }
        cout << ans << " ";
    }
}

