#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;

int n, q;
vector<int> p;
vector<int> shortp;
vector<vector<int>> g;
vector<int> s;
vector<tuple<int, int, int>> qs;
vector<int> ans;
vector<int> sz;
vector<int> szdown1;
vector<int> szdown2;


void dfs(ll v, ll shp) {
    shortp[v] = shp;
    for (auto to : g[v]) {
        dfs(to, shp);
    }
}


int main(int, char**) {
    cout << setprecision(15) << fixed;
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    cin >> n >> q;
    p.assign(n, -1);
    g.resize(n);
    sz.assign(n, 0);
    szdown1.assign(n, 0);
    szdown2.assign(n, 0);
    s.resize(n);
    ans.resize(q);
    qs.resize(q);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].emplace_back(i);
    }
    shortp = p;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    map<int, int> mp;
    for (int i = 0; i < q; ++i) {
        cin >> get<1>(qs[i]);
        get<1>(qs[i])--;
        get<0>(qs[i]) = s[get<1>(qs[i])];
        get<2>(qs[i]) = i;
        mp[get<1>(qs[i])] = i;
    }

    for (auto to : g[0]) {
        dfs(to, to);
    }



    set<pair<int, int>> que;
    que.insert({ s[0], 0 });
    int cnt = 0;
    while (!que.empty()) {
        auto [ss, v] = *(--que.end());
        que.erase(--que.end());
        cnt++;
        int res;
        int u = shortp[v];
        if (u != -1) sz[u]++;
        int biggest = 0;
        while (u != -1 && p[u] != -1) {
            sz[p[u]]++;
            if (sz[u] > szdown1[p[u]]) {
                szdown1[p[u]] = sz[u];
            } else if (sz[u] == szdown1[p[u]]) {
                szdown2[p[u]] = sz[u];
            } else if (sz[u] >= szdown2[p[u]]) {
                szdown2[p[u]] = sz[u];
            }
            biggest = max(biggest, (sz[u] == szdown1[p[u]] ? szdown2[p[u]] : szdown1[p[u]]));
            u = p[u];
        }
        if (mp.find(v) != mp.end()) {
            ans[mp[v]] = cnt - biggest - 1;
        }

        for (auto to : g[v]) {
            que.insert({s[to], to});
        }
    }
    for (auto el : ans) {
        cout << el << " ";
    }




    return 0;
}
