#include<bits/stdc++.h>
using ll = long long;
using d = double;
using ld = long double;
using ull = unsigned long long;
using namespace std;
#define all(x) x.begin(), x.end()
// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx2")
const int maxn = 3e5 + 2;
int h[maxn];
void dfs(int v, int p, vector<vector<int>>& g, vector<int>& s, vector<vector<int>>& bag) {
    if (p == -1) {
        h[v] = 0;
    } else {
        h[v] = h[p] + 1;
    }
    for (auto to : g[v]) {
        if (to == p) continue;
        dfs(to, v, g, s, bag);
        for (auto el : bag[to]) bag[v].push_back(el);
    }
    bag[v].push_back(s[v]);
}
int solve() {
    int n, q;
    cin >> n >> q;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
        g[i].push_back(p);
    }
    vector<vector<int>> bag(n);
    vector<int> s(n);
    for (int i = 0; i < n; ++i) cin >> s[i];
    dfs(0, -1, g, s, bag);
    for (auto el : g[0]) reverse(all(bag[el]));
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        v--;
        int ourbag = 0;
        for (auto el : g[0]) {
            for (int j = 0; j < bag[el].size(); ++j) {
                if (bag[el][j] == s[v]) {
                    ourbag = el;
                    break;
                }
            }
        }
        ll total = 0;
        ll mx = 0;
        for (auto el : g[0]) {
            if (el == ourbag) continue;
            ll curr = 0;
            int j = 0;
            while (j < (int)bag[el].size() && bag[el][j] > s[v]) {
                curr++;
                j++;
            }
            mx = max(mx, curr);
            total += curr;
        }
        cout << h[v] + total - mx << '\n';
    }
    return 0;
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
