#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define int ll

const int N = 3e5 + 10;
int s[N];
vector<list<int>> g;

int dfs(vector<list<int>> &a, int u, int v, int c, int h = 0) {
    if (u == v) return h;

    int z = (a[u].front() == c ? a[u].back() : a[u].front());
    for (auto to : a[u]) {
        if (to == c) continue;
        if (s[to] > s[z]) z = to;
    }

    for (auto to : a[u]) {
        if (to != z) {
            a[z].push_back(to);
        }
    }

    return dfs(a, z, v, c, h + 1);
}

void solve() {
    int n, q;
    cin >> n >> q;

    g.resize(n + 1);

    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].emplace_back(i);
    }

    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }

    while (q--) {
        int v;
        cin >> v;

        int ans = 1e9;
        for (int i = 0; i <= n; i++) {
            if (i == v) continue;
            auto a = g;
            ans = min(ans, dfs(a, 1, v, i));
        }
        cout << ans << " ";
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
#ifdef local
    freopen("i.txt", "r", stdin);
    freopen("o.txt", "w", stdout);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
