#include <bits/stdc++.h>

using namespace std;
using ll = long long;
ll INF = 1e14;
ll MOD = 1e9 + 7;

vector<unordered_set<ll>> g;
vector<ll> s;

ll dfs(ll v, ll i, ll p, unordered_set<ll> pr, ll to, ll cnt) {
    if(v == to) {
        return cnt;
    }
    for(auto d : pr) {
        g[v].insert(d);
    }
    if(g[v].empty()) return cnt;
    ll best = *g[v].begin();
    for(auto u : g[v]) {
        if(u != p && (u != i || best == i)) {
            if(s[best] < s[u] || best == i) {
                best = u;
            }
        }
    }
    unordered_set<ll> nw = g[v];
    nw.erase(best);
    return dfs(best, i, p, nw, to, cnt + 1);
}

void solve() {
    ll n, q;
    cin >> n >> q;
    g.resize(n);
    for(ll i = 1;i < n;i++) {
        ll x;
        cin >> x;
        g[x - 1].insert(i);
    }
    s.resize(n);
    for(auto &i : s) cin >> i;
    while(q--) {
        ll v;
        cin >> v;
        ll ans = INF;
        for(ll i = 0;i < n;i++) {
            vector<unordered_set<ll>> gol = g;
            ans = min(ans, dfs(0, i, 0, {}, v - 1, 0));
            g = gol;
        }
        cout << ans << ' ';
    }   
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
    ll tt = 1;
    // cin >> tt;
    while(tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}