#include <bits/stdc++.h>

using namespace std;
using ll = long long;
ll INF = 1e14;
ll MOD = 1e9 + 7;

vector<vector<ll>> g;
vector<ll> s;
set<ll> d;
vector<ll> ans;

void dfs(ll v, ll p, ll cnt) {
    auto it = d.lower_bound(s[v]);
    while(it != d.end() && *it > s[v]) {
        cnt++;
        d.erase(it);
        it = d.lower_bound(s[v]);
    }
    ans[v] += cnt;
    for(auto u : g[v]) {
        if(u != p) {
            dfs(u, v, cnt + 1);
        }
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    g.resize(n);
    ans.resize(n);
    vector<ll> p(n);
    for(ll i = 1;i < n;i++) {
        ll x;
        cin >> x;
        g[x - 1].push_back(i);
        p[i] = x - 1;
    }
    s.resize(n);
    for(auto &i : s) cin >> i;
    ll sq = 0;
    ll j = -1, mx = 0;
    vector<ll> dd;
    for(ll i = 0;i < n;i++) {
        if(p[i] == 0 && g[i].empty()) {
            d.insert(s[i]);
            dd.push_back(s[i]);
            if(s[i] > mx) j = i;
        }
        if(p[i] == 0 && g[i].size()) {
            sq = i;
        }
    }
    sort(dd.begin(), dd.end());
    dfs(sq, sq, 1);
    for(ll i = 1;i < n;i++) {
        if(p[i] == 0 && g[i].empty()) {
            ans[i] = dd.size() - (lower_bound(dd.begin(), dd.end(), s[i]) - dd.begin());
        }
        else {
            ans[i] -= lower_bound(dd.begin(), dd.end(), s[i]) != dd.end();
        }
    }
    while(q--) {
        ll v;
        cin >> v;
        v--;
        cout << ans[v] << ' ';
    }
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
    ll tt = 1;
    // cin >> tt;
    while(tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}