#include <bits/stdc++.h>

using namespace std;
using ll = long long;
ll t = 0;
const ll MAXN = 100;
ll tin[MAXN], tout[MAXN];

void dfs(ll v, vector<vector<ll>> &g) {
    tin[v] = t++;
    for (ll u : g[v]) {
        dfs(u, g);
    }
    tout[v] = t++;
}

bool is(ll a, ll b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<vector<ll>> gg(n);
    for (ll i = 1; i < n; i++) {
        ll p;
        cin >> p;
        p--;
        gg[p].push_back(i);
    }
    vector<ll> s(n);
    for (ll &i : s) cin >> i;
    dfs(0, gg);
    while (q--) {
        ll x;
        cin >> x;
        x--;
        ll ans = n - 1;
        for (ll ban = 1; ban < n; ban++) {
            if (ban == x || is(ban, x)) continue;
            ll king = 0, res = 0;
            vector<vector<ll>> g = gg;
            while (x != king) {
                //cout << king << '\n';
                res++;
                ll maxu = -1, maxx = 0;
                for (ll u : g[king]) {
                    if (u == ban) continue;
                    if (s[u] > maxx) {
                        maxu = u;
                        maxx = s[u];
                    }
                }
                for (ll u : g[king]) {
                    if (u == maxu) continue;
                    g[maxu].push_back(u);
                }
                king = maxu;
            }
            ans = min(ans, res);
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}

