#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
using ll = long long;
const int inf = 1e9 + 52;


signed main() {
    int n, q;
    cin >> n >> q;
    vector<vector<int>> m;
    vector<int> pos(n);
    vector<int> pref(n);
    vector<int> pred(n);
    vector<int> a(n);
    vector<int> dl(n);
    for (int i = 1; i < n; i++) {
        cin >> pred[i];
        pred[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    pref[0] = inf;
    pos[0] = -1;
    for (int i = 1; i < n; i++) {
        if (pred[i] == 0) {
            pos[i] = m.size();
            pref[i] = a[i];
            dl[i] = 1;
            m.push_back({a[i]});
        }
        else {
            pos[i] = pos[pred[i]];
            pref[i] = min(pref[pred[i]], a[i]);
            dl[i] = dl[pred[i]] + 1;
            m[pos[i]].push_back(pref[i]);
        }
        
    }
    vector<int> all = pref;
    all[0] = -1;
    sort(all.begin(), all.end());
    for (int i = 0; i < m.size(); i++) {
        sort(m[i].begin(), m[i].end());
    }
    while (q--) {
        int x;
        cin >> x;
        x--;
        if (x == 0) {
            cout << 0 << " ";
            continue;
        }
        int all_b = n - (lower_bound(all.begin(), all.end(), pref[x]) - all.begin());
        int my_b = m[pos[x]].size() - (lower_bound(m[pos[x]].begin(), m[pos[x]].end(), pref[x]) - m[pos[x]].begin());
        cout << all_b - my_b + dl[x] << " ";
    }
    cout << endl;
}