#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
using ll = long long;
const int inf = 1e9 + 52;


signed main() {
    int n, q;
    cin >> n >> q;
    vector<vector<int>> pes;
    vector<int> pos(n);
    vector<int> dl(n);
    vector<int> pref(n);
    vector<int> pred(n);
    pref[0] = inf;
    for (int i = 1; i < n; i++) {
        cin >> pred[i];
        pred[i]--;
    }
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    dl[0] = 0;
    for (int i = 1; i < n; i++) {
        dl[i] = dl[pred[i]] + 1;
        pref[i] = min(pref[pred[i]], a[i]);
        if (!pred[i]) {
            pos[i] = pes.size();
            pes.push_back({});
        }
        else {
            pos[i] = pos[pred[i]];
        }
        pes[pos[i]].push_back(pref[i]);
    }
    vector<int> all = pref;
    sort(all.begin(), all.end());
    vector<int> bg(n + 1, 0);
    for (int i = 0; i < n - 1; i++) {
        bg[all[i]] = max((int)(all.size() - i - 1), bg[all[i]]);
    }
    for (int i = 0; i < pes.size(); i++) {
        sort(pes[i].begin(), pes[i].end());
    }

    while (q--) {
        int x;
        cin >> x;
        x--;
        if (!x) {
            cout << 0 << " ";
            continue;
        }
        int bgn = pes[pos[x]].size() - (lower_bound(pes[pos[x]].begin(), pes[pos[x]].end(), pref[x]) - pes[pos[x]].begin());
        cout << bg[pref[x]] - bgn + dl[x] << " ";
    }
}