#include <bits/stdc++.h>

using namespace std;

#define int long long

mt19937 rnd(14);

const int MAXN = 3e5 + 5;

vector<int> p(MAXN, -1), s(MAXN), path;
vector<bool> used(MAXN);
vector<vector<int>> g(MAXN);

void getpath(int x) {
    path.emplace_back(x);
    used[x] = true;
    while (p[x] != -1) {
        x = p[x];
        path.emplace_back(x);
        used[x] = true;
    }
}

int dfs(int v, int x) {
    if (s[v] <= s[x]) {
        return 0;
    }
    int cnt = 1;
    for (auto &i : g[v]) {
        if (i != p[v]) {
            cnt += dfs(i, x);
        }
    }
    return cnt;
}

void solve() {
    int n, q;
    cin >> n >> q;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].emplace_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    while (q--) {
        int x;
        cin >> x;
        --x;
        path.clear();
        used.assign(MAXN, false);
        getpath(x);
        int cnt = path.size() - 1, cur = x;
        for (int i = 1; i < (int)path.size(); ++i) {
            for (auto &j : g[path[i]]) {
                if (!used[j]) {
                    cnt += dfs(j, cur);
                }
            }
            if (s[path[i]] < s[cur]) {
                cur = path[i];
            }
        }
        int mx = 0;
        cur = x;
        for (int i = 1; i < (int)path.size(); ++i) {
            for (auto &j : g[path[i]]) {
                if (!used[j]) {
                    mx = max(mx, dfs(j, cur));
                }
            }
            if (s[path[i]] < s[cur]) {
                cur = path[i];
            }
        }
        cout << cnt - mx << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    freopen("inp.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}