#include <bits/stdc++.h>
using namespace std;
using ll = long long;

vector<ll>mpf,s,depth;
vector<ll>mx1,mx2;
vector<ll>par;
vector<ll>pred;
vector<vector<ll>>G;

void dfs(ll v){
    for (auto u:G[v]){
        depth[u]=depth[v]+1;
        if (v==0){
            pred[u]=u;
        }
        else{
            pred[u]=pred[v];
        }
        mpf[u]=min(mpf[v],s[u]);
        if (mpf[u]>=mx1[depth[u]-1]){
            par[depth[u]-1]=u;
            mx2[depth[u]-1]=mx1[depth[u]-1];
            mx1[depth[u]-1]=mpf[u];
        }
        else if (mpf[u]>mx2[depth[u]-1]){
            mx2[depth[u]-1]=mpf[u];
        }
        dfs(u);
    }
}

int main() {
    ll i,j,n,q;
    cin>>n>>q;
    G.assign(n,{});
    mpf.assign(n,0);
    mx1.assign(3e5,-1);
    mx2.assign(3e5,-1);
    s.assign(n,0);
    pred.assign(n,0);
    par.assign(3e5,0);
    for (i=1;i<n;i++){
        ll p;
        cin>>p;
        p--;
        G[p].push_back(i);
    }
    for (i=0;i<n;i++){
        cin>>s[i];
    }
    depth[0]=0;
    s[0]=n+1;
    mpf[0]=n+1;
    dfs(0);
    vector<ll>Z;
    for (i=0;i<n;i++){
        Z.push_back(mpf[i]);
    }
    sort(Z.begin(),Z.end());
    while (q--){
        ll qi;
        cin>>qi;
        qi--;
        if (qi==0){
            cout<<0<<'\n';
        }
        else{
            ll l=-1,r=3e5;
            while (r-l>1){
                ll mid=(l+r)/2;
                if (mx1[mid]>mpf[qi]){
                    if (par[mid]==pred[qi]){
                        if (mx2[mid]>mpf[qi]){
                            l=mid;
                        }
                        else{
                            r=mid;
                        }
                    }
                    else{
                        l=mid;
                    }
                }
                else{
                    r=mid;
                }
            }
            ll l1=0,r1=n;
            while (r1-l1>1){
                ll mid=(l1+r1)/2;
                if (Z[mid]>mpf[qi]){
                    r1=mid;
                }
                else{
                    l1=mid;
                }
            }
            cout<<r1-r-1<<'\n';
        }
    }
    return 0;
}