#include <bits/stdc++.h>
#define int long long
using namespace std;

int calc(int n, const vector<int>& A, const vector<bool>& take) {
    int extra = 0;
    int total = 0;
    for (int i = 0; i < n; i++) {
        extra += 1;
        if (take[i]) {
            total += A[i] + extra;
            extra = 0;
        }
    }
    return total;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<int> A(n), B(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
        B[i] = i;
    }
    sort(B.rbegin(), B.rend(), [&](int i, int j) {
        return make_pair(A[i], i) < make_pair(A[j], j);
    });
    vector<bool> take(n);
    for (int i = 0; i < k; i++) {
        take[B[i]] = true;
    }
    int res = calc(n, A, take);
    if (!take[n - 1]) {
        for (int i = 0; i < n - 1; i++) {
            if (take[i]) {
                swap(take[i], take[n - 1]);
                res = max(res, calc(n, A, take));
                swap(take[i], take[n - 1]);
            }
        }
    }
    cout << res;
    return 0;
}

