#include <bits/stdc++.h>
#define int long long
using namespace std;

int calc(int n, const vector<int>& A, const vector<bool>& take) {
    int extra = 0;
    int total = 0;
    for (int i = 0; i < n; i++) {
        extra += 1;
        if (take[i]) {
            total += A[i] + extra;
            extra = 0;
        }
    }
    return total;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<int> A(n), B(n);
    for (int i = 0; i < n; i++) {
        cin >> A[i];
        B[i] = i;
    }
    sort(B.rbegin(), B.rend(), [&](int i, int j) {
        return make_pair(A[i], i) < make_pair(A[j], j);
    });
    vector<bool> take(n);
    for (int i = 0; i < k; i++) {
        take[B[i]] = true;
    }
    int res = calc(n, A, take);
    int last = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (take[i]) {
            last = i;
            break;
        }
    }
    if (last == n - 1) {
        cout << res;
        return 0;
    }
    int ans = res;
    for (int i = last + 1; i < n; i++) {
        ans = max(ans, res + A[i] + (i - last) - A[B[k - 1]]);
    }
    cout << ans;
    return 0;
}

