#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

template <typename T>
using ordered_set =
    tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)((x).size()))

using ll = long long;
using ld = long double;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

// struct S {
//     int n;
//     vector<int> a, t;
//     S() {}
//     S(vector<int> a) : a(a), n(sz(a)), t(4 * n) {
//         build(1, 0, n - 1);
//     }
//     void build(int node, int l, int r) {
//         if (l == r) {
//             t[node] = a[l];
//             return;
//         }
//         int m = (l + r) >> 1;
//         build(2 * node)
//     }
// };

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n), b(n);
    set<array<int, 3>> bst;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[i] = a[i];
        a[i] += i + 1;
        bst.insert({a[i], 1, i});
    }
    vector<set<int>> per(n);
    vector<int> who(n, -1);
    vector<bool> used(n);
    for (int i = 0; i < k; ++i) {
        auto [val, free, idx] = *bst.rbegin();
        used[idx] = true;
        if (!free) {
            per[who[idx]].erase(idx);
            who[idx] = idx;
            per[idx].insert(idx);
            bst.erase({val, free, idx});
            continue;
        }
        // free=1
        int t;
        for (int j = idx; ~j && who[j] == -1; --j) {
            who[j] = idx;
            per[idx].insert(j);
            bst.erase({a[j], 1, j});
            t = j;
        }
        for (int j = t; j <= idx; ++j) {
            a[j] -= (j - t);
            if (!used[j]) {
                bst.insert({a[j], 0, j});
            }
        }
        for (int j = idx + 1; j < n; ++j) {
            if (who[j] != -1) {
                bst.erase({a[j], 0, j});
                a[j] -= (idx - t + 1);
                if (!used[j]) {
                    bst.insert({a[j], 0, j});
                }
            } else {
                bst.erase({a[j], 1, j});
                a[j] -= (idx - t + 1);
                if (!used[j]) {
                    bst.insert({a[j], 1, j});
                }
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (sz(per[i])) {
            ans += b[i] + sz(per[i]);
        }
    }
    cout << ans << '\n';
}

signed main() {
#ifdef LOCALEGOR
    freopen("INPUT.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#endif
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}