#ifndef SEREGA
#include <bits/allocator.h>
#pragma GCC target("avx2,popcnt")
#pragma GCC optimize("O3,no-stack-protector,unroll-loops")
#endif
#include <bits/stdc++.h>
using namespace std;
#define int int64_t

int answer = -123;
vector<vector<vector<int>>> pathres;
void dfs(vector<vector<int>> path, vector<int> a, int already, int left) {
    if (left == 0) {
        if (already > answer) {
            answer = already;
            pathres.clear();
            pathres = {path};
        } else if (already == answer)  {
            pathres.push_back(path);
        }
        return;
    }
    if (left == 1) {
        int mx = INT_MIN;
        for (int i = 0; i < (int)a.size(); ++i) {
            mx = max(mx, a[i] + i + 1);
        }
        path.push_back(a);
        dfs(path, {{}}, already + mx, left - 1);
        path.pop_back();
        return;
    }
    for (int mask = 1; mask < (1ll << a.size()); ++mask) {
        vector<int> todfs, now;
        if (mask == (1ll << a.size()) - 1 && left != 1) continue;
        for (int bit = 0; bit < (int)a.size(); ++bit) {
            if (mask >> bit & 1) {
                now.push_back(a[bit]);
            } else {
                todfs.push_back(a[bit]);
            }
        }
        int mx = INT_MIN;
        for (int i = 0; i < (int)now.size(); ++i) {
            mx = max(mx, now[i] + i + 1);
        }
        path.push_back(now);
        dfs(path, todfs, already + mx, left - 1);
        path.pop_back();
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cout << a[i] + i + 1 << ' ';
    }
    cout << endl;
    dfs({}, a, 0, k);
    cout << answer << '\n';
    for (auto &i : pathres) {
        cout << '[';
        for (auto &vec : i) {
            for (int j : vec) {
                cout << j << ' ';
            }
            cout << "][";
        }
        cout << endl;
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}