#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")
#endif

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;

const int mod = 10;

struct Modular {
    int x;

    Modular(int x = 0): x(x) {}

    friend Modular operator+(Modular a, Modular b) {
        int res = a.x + b.x;
        return res - (res >= mod ? mod : 0);
    }

    friend Modular operator-(Modular a, Modular b) {
        int res = a.x - b.x;
        return res + (res < 0 ? mod : 0);
    }

    friend Modular operator*(Modular a, Modular b) {
        return ll(a.x) * b.x % mod;
    }
};

const int maxn = 1e3;
ll a[maxn];
ll dp[maxn + 1][maxn + 1];

void solve() {
    int n, k;
    cin >> n >> k;
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for(int i = 1; i <= n; ++i) {
        dp[0][i] = max(dp[0][i - 1], a[i - 1] + i);
    }
    for(int i = 1; i < k; ++i){
        for(int j = i + 1; j <= n; ++j){
            ll mx = a[j - 1];
            ll add = 1;
            for(int j1 = j - 1; j1 >= i; --j1) {
                dp[i][j] = max(dp[i][j], dp[i - 1][j1] + mx + add);
                mx = max(mx, a[j1 - 1] - add);
                ++add;
            }
        }
    }
    cout << dp[k - 1][n];
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("C:\\Users\\User\\aboab\\input.txt", "r", stdin);
#endif
    solve();
}