#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
using namespace std;

#define ll long long
#define ull unsigned long long
#define db double
#define str string
#define vc vector
#define its(a) (a).begin(), (a).end()
#define itsr(a) (a).rbegin(), (a).rend()
#define tstr(a) to_string((a))
#define INF ((ll)1e18)

void solve() {
    ll n, k; cin >> n >> k;
    vc<ll> a(n);
    vc<pair<ll, ll>> v;
    for (int i = 0;i < n;++i) {
        cin >> a[i];
        v.push_back({ a[i], i });
    }
    sort(itsr(v));
    vc<ll> stop(n);
    for (int i = 0;i < k;++i) stop[v[i].second] = 1;
    ll cur = 1;
    ll ans = 0;
    for (int i = 0;i < n;++i) {
        if (stop[i]) {
            ans += cur + a[i];
            cur = 1;
        }
        else {
            ++cur;
        }
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll _t = 1;
    //cin >> _t;
    while (_t--)
        solve();
}
