#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <string>
#include <vector>
#include <chrono>
#include <random>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>
#define endl '\n'

using namespace std;
using i64 = long long;
using ld = long double;

mt19937 rnd(29);

const i64 S = 5e5 + 10;
vector <pair<i64, i64>> a, b;
i64 taken[S];

int main() {
	#ifdef _DEBUG
		freopen("input.txt", "r", stdin);
	#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	i64 n, k; cin >> n >> k;
	a.resize(n);
	b.resize(n);

	for (i64 x = 0; x < n; ++x) {
		cin >> a[x].first;
		a[x].second = x;
	}

	b = a;

	sort(a.begin(), a.end());

	if (k == 1) {
		i64 mx = 0;
		for (i64 x = 0; x < a.size(); ++x) {
			mx = max(mx, a[x].first + a[x].second + 1);
		}
		cout << mx;
		exit(0);
	}
	else {
		i64 ans = 0, mxRight = 0, sumLeft = 0, itog = 0;
		for (i64 x = a.size() - 1; x >= a.size() - k + 1; --x) {
			ans += (a[x].first + 1);
			taken[a[x].second] = 1;
			mxRight = max(mxRight, a[x].second);
		}
		sumLeft = mxRight - (k - 2);
		i64 notCount = 0;
		for (i64 x = 0; x < a.size(); ++x) {
			if (!taken[x]) {
				if (x < mxRight) {
					itog = max(itog, ans + (b[x].first + 1) + (sumLeft - 1));
				}
				else {
					itog = max(itog, ans + (b[x].first + notCount + 1));
				}
				notCount += 1;
			}
		}
		cout << itog;
		exit(0);
	}
}