#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

int n, k;
vector<ll> a;
vector<ll> cur, cnt;

ll f(int id) {
    if (id == n) {
        ll z = 0;
        for (int i = 0; i < k; ++i) z += cur[i];
        return z;
    }
    ll res = 0;
    for (int i = 0; i < k; ++i) {
        cnt[i]++;
        ll was = cur[i];
        cur[i] = max(cur[i], a[id] + cnt[i]);
        res = max(res, f(id + 1));
        cur[i] = was;
        cnt[i]--;
    }
    return res;
}

void solve() {
    cin >> n >> k;
    a.resize(n);
    cur.resize(k);
    cnt.resize(k);
    for (ll &e : a) cin >> e;
    cout << f(0);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();
}