#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock().now().time_since_epoch().count();
mt19937 rnd(seed);

template<typename T>
using orderet_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using ll = long long;
using ull = unsigned long long;
using uint = unsigned int;
using ld = long double;
using dd = double;

#define int ll

bool cmp(pair<int, int> a, pair<int, int> b){
    return a.second < b.second;
}
void solve(){
    int n, k;
    cin>>n>>k;
    vector<pair<int, int>> v(n);
    for(int i = 0; i < n; ++i){
        cin>>v[i].first;
        v[i].second = i;
    }
    vector<pair<int, int>> a = v;
    int ans1 = n + a.back().first;
    a.pop_back();
    sort(a.begin(), a.end());
    for(int i = 0; i < k-1; ++i){
        ans1 += v[i].first;
    }
    sort(v.begin(), v.end());
    int ans = k-1;
    for(int i = 0; i < k-1; ++i){
        ans += v.back().first;
        v.pop_back();
    }
    sort(v.begin(), v.end(), cmp);
    int opt = -1e18;
    for(int i = 0; i < n - k + 1; ++i){
        opt = max(opt, v[i].first + n - k + 1 - i);
    }
    cout << max(ans1, ans + opt);
}

signed main(){
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    int t = 1;
    //cin>>t;
    while(t--) solve();
}