#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <random>
#include <ctime>
#include <chrono>
#include <cassert>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

void solve()
{
	long long n, k;
	cin >> n >> k;
	vector<long long> v(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}
	multiset<long long> st;
	long long ans = 0, sum = 0;
	for (long long i = 0; i < n; i++)
	{
		if (st.size() != k - 1)
		{
			st.insert(v[i]);
			sum += v[i];
			continue;
		}

		ans = max(ans, sum + v[i] + i + 1);
		st.insert(v[i]);
		sum += v[i];
		sum -= *st.begin();
		st.erase(st.begin());
	}
	cout << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*

























*/
