#include <string>
#include <bitset>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <set>

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

void fast() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cout << setprecision(8) << fixed;
}

ll mod = 1e9 + 7;
ll binpow(ll a, ll n) {
    ll res = 1;
    for (int i = 0; (1ll << i) <= n; ++i, a = a * a % mod) {
        if ((n >> i) & 1) res = res * a % mod;
    }
    return res;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    set<pair<int, int>> b;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b.emplace(a[i], i);
    }
    while (sz(b) != k) {
        b.erase(b.begin());
    }
    ll ans = 0;
    int cur = n + 1;
    int last = 0;
    for (int i = n - 1; i >= 0; --i) {
        cur--;
        if (a[i] + cur >= b.begin()->first) {
            ans += a[i];
            last = max(last, cur);
            b.erase(make_pair(a[i], i));
            k--;
            cur = 0;
        }
        if (k == 0) break;
    }
    while (k != 0) {
        last = max(b.rbegin()->second + 1, last);
        ans += b.rbegin()->first;
        b.erase(--b.end());
        k--;
    }
    ans += last;
    cout << ans;
}
int main() {
    fast();
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}