#include<iostream>
#include<vector>
#include<string>
#include<cmath>
#include<map>
#include<set>
#include<bitset>
#include<algorithm>
#include<queue>

using namespace std;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int64_t n, k;
	cin >> n >> k;
	vector<int64_t> a(n);
	for (int64_t i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<int64_t> p(n);
	sort(p.begin(), p.end(), [&](auto l, auto r) {return a[l] > a[r]; });
	int64_t res = 0;
	vector<pair<int64_t, int64_t>> seg = { {0, 0} };
	vector<int64_t> x(n);
	for (int64_t i = 0; i < n; ++i) {
		if (i >= seg.back().first) {
			x[i] = a[i] + i - seg.back().first + 1;
		}
		else {
			x[i] = a[i];
		}
	}
	for (int64_t c = 0; c < k; ++c) {
		pair<int64_t, int64_t> best{ 0, -1 };
		for (int64_t i = 0; i < n; ++i) {
			/*if (!p[i]) {*/
			if (best.second == -1 || best.first < x[i]) {
				best.first = x[i];
				best.second = i;
			}
			/*}*/
		}
		int64_t i = best.second;
		p[i] = 1;
		x[i] = -1e9;
		if (i >= seg.back().first) {
			int ps = seg.back().first;
			seg.emplace_back(i + 1, a[i] + i - seg.back().first + 1);
			for (int i = ps; i < seg.back().first; ++i) {
				if (!p[i]) {
					x[i] = a[i];
				}
			}
			for (int i = seg.back().first; i < n; ++i) {
				x[i] -= (seg.back().first - ps);
			}
			res += seg.back().second;
		}
		else {
			int64_t l = 0, r = seg.size();
			while (r - l > 1) {
				int64_t middle = (l + r) / 2;
				if (seg[middle].first < i) {
					l = middle;
				}
				else {
					r = middle;
				}
			}
			res -= seg[r].second;
			seg[r].second--;
			res += a[i] + 1 + seg[r].second;
		}
	}
	cout << res << '\n';
	return 0;
}