// semenInRussia 2025
#include <algorithm>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;

const int N = 100;
int pw[N];

int main() {
  int n, k;
  cin >> n >> k;

  vector<int> a(n);
  for (int &x : a) {
    cin >> x;
  }

  pw[0] = 1;
  for (int i = 1; i < N; i++) {
    pw[i] = pw[i - 1] * k;
  }

  int64_t ans = 0;
  vector<int> bst;

  int S = pw[n];
  cerr << "S=" << S << "\n";

  for (int b = 0; b < S; b++) {
    vector<vector<int>> buf(k);
    for (int j = 0; j < n; j++) {
      int c = (b / pw[j]) % k;
      buf[c].push_back((int)buf[c].size() + 1 + a[j]);
    }
    bool ok = true;
    for (auto &row : buf) {
      if (row.empty()) {
        ok = false;
      }
    }
    if (!ok) {
      continue;
    }
    int64_t cost = 0;
    for (auto &row : buf) {
      cost += *max_element(row.begin(), row.end());
    }
    ans = max(cost, ans);
  }

  for (int c : bst) {
    cout << c << "\n";
  }

  cout << ans;
}