// semenInRussia 2025
#pragma GCC optimize("Ofast,unroll-loops")
#include <algorithm>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;
#pragma GCC target("avx2")

const int N = 100;
int pw[N];

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  cout.tie(nullptr);
  int n, k;
  cin >> n >> k;

  vector<int> a(n);
  for (int &x : a) {
    cin >> x;
  }

  pw[0] = 1;
  for (int i = 1; i <= n; i++) {
    pw[i] = pw[i - 1] * k;
  }

  int64_t ans = 0;
  vector<int> bst;

  int S = pw[n];

  vector<int> mx(k), sz(k);

  for (int b = 0; b < S; b++) {
    for (int i = 0; i < k; i++) {
      mx[i] = sz[i] = 0;
    }
    for (int j = 0; j < n; j++) {
      int c = (b / pw[j]) % k;
      mx[c] = max(mx[c], sz[c] + 1 + a[j]);
      sz[c]++;
    }
    bool ok = true;
    for (int j = 0; j < k; j++) {
      if (sz[j] == 0) {
        ok = false;
      }
    }
    if (!ok) {
      continue;
    }
    int64_t cost = 0;
    for (auto &row : mx) {
      cost += row;
    }
    ans = max(cost, ans);
  }

  for (int c : bst) {
    cout << c << "\n";
  }

  cout << ans;
}