#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = int(1e9) + 7, lg = 20;
const ll inf = ll(2e18) + 36;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (auto &it: a) cin >> it;
    vector<pair<ll, ll>> b;
    for (ll i = 0; i < n; i++) {
        b.emplace_back(a[i], i);
    }
    sort(b.rbegin(), b.rend());
    vector<bool> is(n);
    ll ans = 0;
    for (ll i = 0; i < k - 1; i++) {
        is[b[i].second] = true;
        ans += b[i].first + 1;
    }
    vector<ll> pf(n);
    for (ll i = 0; i < n; i++) {
        pf[i] = (i ? pf[i - 1] : 0) + is[i];
    }
    ll best = 0;
    for (ll i = 0; i < n; i++) {
        if (is[i]) continue;
        best = max(best, (i + 1 - pf[i]) + a[i]);
    }
    cout << ans + best;
    return 0;
}
