#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <array>
#include <queue>

using namespace std;
typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, k;
	cin >> n >> k;
	vector<ll> a(n);
	for (ll i = 0; i < n; i++) cin >> a[i];
	multiset<ll> st;
	ll sm = 0;
	for (ll i = 0; i < k - 1; i++) {
		st.insert(a[i]);
		sm += a[i];
	}
	ll ans = 0;
	for (ll i = k - 1; i < n; i++) {
		ans = max(ans, sm + a[i] + (i + 1));
		st.insert(a[i]);
		sm += a[i];
		sm -= *st.begin();
		st.erase(st.begin());
	}
	cout << ans << "\n";
	return 0;
}