#include <iostream>
#include <vector>
#include <queue>
struct element {
    long long factor = 0;
    long long size = 0;
    long long max = 0;
    const bool operator<(const element &other) const {
        return this->factor < other.factor;
    }
    element(long long a) {
        size = 1;
        max = a + size;
        factor = size - max;
    }
};
int main() {
    std::cin.tie(0);
    std::cout.tie(0);
    std::cin.sync_with_stdio(false);
    long long n, k, s, i;
    s = 0;
    std::cin >> n >> k;
    std::vector<long long> a(n);
    for(i = 0; i < n; ++i) {
        std::cin >> a[i];
    }
    std::priority_queue<element> q;
    for(i = 0; i < k; ++i) {
        q.push(element(a[i]));
    }
    for(i = k; i < n; ++i) {
        element e = q.top();
        q.pop();
        ++e.size;
        e.max = std::max(e.max, a[i] + e.size);
        e.factor = e.size - e.max;
        q.push(e);
    }
    while(!q.empty()) {
        element e = q.top();
        q.pop();
        s += e.max;
    }
    std::cout << s << '\n';
}