#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
using Int = long long;
using Uint = unsigned long long;
using Real = long double;
using Int128 = __int128;
using Uint128 = __uint128_t;
// #define _KOSHKA56692
#ifdef _KOSHKA56692
const int MAX = 1e8;
char mem[MAX];
int mempos = 0;
void *operator new(size_t sz) {
    void *res = mem + mempos;
    mempos += sz;
    return res;
}
void operator delete(void *) {}
void operator delete(void *, size_t) {}
#endif
template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;
istream &operator>>(istream &in, Int128 &num) { Int R; in >> R; num = R; return in; }
ostream &operator<<(ostream &out, const Int128 &num) { out << Int(num); return out; }
istream &operator>>(istream &in, Uint128 &num) { Uint R; in >> R; num = R; return in; }
ostream &operator<<(ostream &out, const Uint128 &num) { out << Uint(num); return out; }

signed main() {
    ios::sync_with_stdio(false), cin.tie(0);
    cout.setf(ios::fixed), cout.precision(20);
    int n, k;
    cin >> n >> k;
    vector<Int> arr(n);
    for (auto &el : arr) {
        cin >> el;
    }
    Int answ = 0;
    auto rec = [&](auto &&rec, vector<int> ixs, int cnt) -> Int {
        if (cnt == 1) {
            Int mx = 0;
            for (int i = 0; i < ixs.size(); ++i) {
                mx = max(mx, arr[ixs[i]] + i + 1); 
            }
            return mx;
        }
        Int answ = 0;
        for (int mask = 1; mask < (1 << ixs.size()); ++mask) {
            auto cpy = ixs;
            int del = 0;
            for (int i = 0; i < ixs.size(); ++i) {
                del += ((mask >> i) & 1);
            }
            if (int(ixs.size()) - del >= cnt) {
                Int mx = 0;
                vector<int> ixx;
                int cc = 1;
                for (int i = 0; i < ixs.size(); ++i) {
                    if ((mask >> i) & 1) {
                        mx = max(mx, arr[ixs[i]] + cc);
                        ++cc;
                        ixx.push_back(i);
                    }
                }
                reverse(ixx.begin(), ixx.end());
                for (auto el : ixx) {
                    cpy.erase(cpy.begin() + el);
                }
                Int re = rec(rec, cpy, cnt - 1) + mx;
                answ = max(answ, re);
            }
        }
        return answ;
    };
    vector<int> ixs(n);
    iota(ixs.begin(), ixs.end(), 0);
    cout << rec(rec, ixs, k) << '\n';
    return 0;
}
