#include <bits/stdc++.h>

#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()

using namespace std;
using ll = long long;
using ld = long double;

const ll infll = (ll) 1e18;
const int inf = (int) 1e9;
const ll MOD = 1e9 + 7;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

ll mod(ll a) {
    ll r = a % MOD;
    if (r < 0) {
        return r + MOD;
    }
    return r;
}

vector<ll> a;
int n, k;

void solve() {
    cin >> n >> k;
    a.resize(n);
    for (auto &x : a) cin >> x;
    ll ans = 0;
    if (k == 1) {
        for (int i = 0; i < n; ++i) {
            ans = max(ans, a[i] + i + 1);
        }
        cout << ans << '\n';
        return;
    }
    vector<bool> choose(n);
    vector<ll> v(n);
    vector<int> last(n, -1), g(n);
    vector<pair<ll, int>> b(n);
    for (int i = 0; i < n; ++i) {
        b[i].first = a[i];
        b[i].second = i;
    }
    sort(all(b), greater<>());
    for (int i = 0; i < k; ++i) {
        choose[b[i].second] = true;
    }
    int d = 1;
    int ind = -1;
    for (int i = 0; i < n; ++i) {
        if (choose[i]) {
            v[i] = a[i] + d;
            ans += a[i] + d;
            d = 1;
            last[i] = ind;
            ind = i;
        } else {
            d++;
        }
    }
    vector<ll> c;
    for (int i = last[b[k - 1].second] + 1; i <= b[k - 1].second; ++i) {
        c.push_back(a[i]);
    }
    for (int i = ind + 1; i < n; ++i) {
        c.push_back(a[i]);
    }
    ans -= v[b[k - 1].second];
    ll mx = 0;
    for (int j = 0; j < c.size(); ++j) {
        mx = max(mx, c[j] + j + 1);
    }
    ans += mx;
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}