#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using sll = __int128;

template <typename T>
istream &operator>>(istream &in, pair<T, T> &a){
    in >> a.first >> a.second;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, pair<T, T> &a){
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream &operator>>(istream &in, vector<T> &a){
    for(auto &x : a) in >> x;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector<T> &a){
    for(auto x : a) out << x << ' ';
    return out;
}

vector<vector<int>> g;
vector<int> d;

void dfs(int vi){
    for(auto to : g[vi]){
        d[to] = d[vi] + 1;
        dfs(to);
    }
}

int check(int x, vector<int> &s, int cancel){
    int main = 1;
    int cnt = 0;
    int prev = s[cancel];
    s[cancel] = 0;
    set<pair<int, int>> st;
    while(main != x){
        for(auto to : g[main]){
            st.insert({-s[to], to});
        }
        main = (*st.begin()).second;
        st.erase(st.begin());
        cnt++;
    }
    s[cancel] = prev;
    return cnt;
}

void solve(){
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    cin >> a;
    vector<pair<int, int>> ind(n);
    for(int i = 0; i < n; i++){
        ind[i] = {a[i], i};
    }
    sort(ind.begin(), ind.end(), greater<>());
    vector<int> mx;
    for(int i = 0; i < k - 1; i++){
        mx.push_back({ind[i].second});
    }
    sort(mx.begin(), mx.end());
//    cout << mx << '\n';
    ll x = 0;
    ll ans = 0;
    int l = 0;
    int cnt = 0;
    for(int i = 0; i < n; i++){
        if(l < mx.size() && i == mx[l]){
            ans += a[i] + 1;
            l++;
        } else {
            cnt++;
            x = max(x, a[i] + cnt);
        }
    }
//    cout << ans << ' ' << x << '\n';
    cout << ans + x;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test = 1;
//    cin >> test;
    while(test--){
        solve();
    }
}

