#include "bits/stdc++.h"

using namespace std;

#define int long long

void solve() {
    int n, k;
    cin >> n >> k;

    vector<int> s(n);

    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    vector<int> d;
    vector<int> used(k + 1);

    int res = 0;

    function<void(int, int)> rec = [&](int cnt, int gr) {
        if (cnt == n && gr == k) {
            map<int, int> was;
            map<int, int> maxes;

            for (int i = 0; i < n; i++) {
                was[d[i]]++;
                maxes[d[i]] = max(maxes[d[i]], s[i] + was[d[i]]);
            }

            int sum = 0;

            for (auto i: maxes) {
                sum += i.second;
            }
            res = max(res, sum);
            return;
        }

        if (cnt > n)
            return;

        for (int i = 1; i <= k; i++) {
            if (used[i] && n - cnt >= k - gr) {
                used[i]++;
                if (used[i] == 1) {
                    gr++;
                }
                d.emplace_back(i);
                rec(cnt + 1, gr);
                d.pop_back();
                used[i]--;
                if (used[i] == 0) {
                    gr--;
                }
            } else if (!used[i]) {
                used[i]++;
                if (used[i] == 1) {
                    gr++;
                }
                d.emplace_back(i);
                rec(cnt + 1, gr);
                d.pop_back();
                used[i]--;
                if (used[i] == 0) {
                    gr--;
                }
            }
        }
    };

    rec(0, 0);

    cout << res;
}
signed main() {
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int akbalin = 1;
    //    cin >> akbalin;

    for (int i = 1; i <= akbalin; i++) {
        solve();
    }
}