#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ld = long double;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector <ll> a(n);
    vector <pair <ll, int>> b(n);
    for (int i=0; i < n; ++i) {
        cin >> a[i];
        b[i] = {a[i], i};
    }
    ll ans = k - 1;
    sort(b.begin(), b.end());
    vector <bool> was(n);
    for (int i=0; i < k - 1; ++i) {
        ans += b[n - 1 - i].first;
        was[b[n - 1 - i].second] = true;
    }
    ll m = 0;
    for (int i=0, j = 0; i < n; ++i) if (!was[i]) {
        j++;
        m = max(m, a[i] + j);
    }
    cout << ans + m << "\n";
    return 0;
}
