#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ld = long double;

ll ans = 0;
int n, k;

void f(int i, const vector <ll> & a, vector <ll> & r, vector <ll> & sz) {
    if (i == n) {
        ll cur = 0;
        for (int c=0; c < k; ++c) {
            if (sz[c] == 0) {
                return;
            }
            cur += r[c];
        }
        ans = max(ans, cur);
        return;
    }
    for (int c=0; c < k; ++c) {
        ll old = r[c];
        sz[c]++;
        r[c] = max(r[c], sz[c] + a[i]);
        f(i + 1, a, r, sz);
        sz[c]--;
        r[c] = old;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> k;
    vector <ll> a(n);
    for (int i=0; i < n; ++i) {
        cin >> a[i];
    }
    vector <ll> r(k), sz(k);
    f(0, a, r, sz);
    cout << ans << "\n";
    return 0;
}
