#include <iostream>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <vector>
#include <map>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

template<typename T>
istream& operator>>(istream& in, vector<T>& arr) {
    for (ll i = 0; i < (ll)arr.size(); ++i) {
        in >> arr[i];
    }
    return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr) {
    for (auto el : arr) {
        out << el << " ";
    }
    return out;
}

vector<vector<ll>> g;
vector<bool> used;
vector<ll> dist;

void dfs(ll v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u]) {
            dist[u] = dist[v] + 1;
            dfs(u);
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, k;
    cin >> n >> k;
    vector<ll> arr(n);
    cin >> arr;
    ll cntt = 0;
    ll mx = 0;
    for (auto el : arr) {
        mx = max(mx, el);
    }
    for (auto el : arr) {
        if (el == mx) ++cntt;
    }
    ll cnt = k - 1, ans = 0;
    for (ll i = 0; i < cnt; ++i) {
        ans += arr[i] + 1;
    }
    ll cur = 0;
    for (ll i = cnt; i < n; ++i) {
        cur = max(cur, arr[i] + i + 1 - cnt);
    }
    ans += cur;
    ll ans2 = 0;
    ll i = n - 1;
    for (; n - i <= cnt; --i) {
        ans2 += arr[i] + 1;
    }
    cur = 0;
    while (i >= 0) {
        cur = max(cur, arr[i] + i + 1);
        --i;
    }
    ans2 += cur;
    if (cntt > 1) {
        ++ans, ++ans2;
    }
    cout << max(ans, ans2);
}