#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <climits>
#include <cmath>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()
#define len(v) (ll)v.size()

mt19937 rnd(525252);

const ll INF = 1e18, SZ = 1e6, MOD = 1e9 + 7;
const ld eps = 1e-8, pi = acosl(-1);

ll ans = 0;

void gen(vector<ll>&v, vector<ll>&arr, ll pos, ll k){
    if (pos == len(v)){
        vector<ll>cnt(k), ind(k, 0);
        for (ll i = 0; i < len(arr); ++i){
            cnt[arr[i]] = max(cnt[arr[i]], v[i] + ++ind[arr[i]]);
        }
        ll sum = 0;
        for (auto &i : cnt) sum += i;

//        for (auto &i : arr) cout << i << ' ';
//        cout << '\n' << sum << '\n';

        ans = max(ans, sum);
        return;
    }
    for (ll i = 0; i < k; ++i){
        arr[pos] = i;
        gen(v, arr, pos + 1, k);
    }
}

void solve() {
	ll n, k; cin >> n >> k;
    vector<ll>v(n);
    vector<ll>arr(n);
    for (auto &i : v) cin >> i;
    gen(v, arr, 0, k);
    cout << ans;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	cout.precision(20);
	ll t = 1;

//	freopen("in.txt", "r", stdin);
//	freopen("out.txt", "w", stdout);
//    cin >> t;

	while (t--) {
		solve();
		cout << '\n';
	}
}
