#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
    int n, k;
    cin >> n >> k;
    vector<long long> v(n);
    vector<int> col(n, -1);
    set<pair<long long, int>> st;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        st.insert({v[i], i});
    }
    long long ans = 0;
    int cl = 0;
    for (int i = 0; i < k; i++) {
        auto [x, id] = *(st.rbegin());
        st.erase({x, id});
        col[id] = cl++;
    }
    cl--;
    for (int i = n - 1; i >= 0; i--) {
        if (col[i] == -1) {
            col[i] = cl;
        } else {
            break;
        }
    }
    long long t = 0, p = 1;
    for (int i = 0; i < n; i++) {
        if (col[i] == -1) {
            ans++;
        } else if (col[i] != cl) {
            ans += v[i] + 1;
        } else {
            t = max(t, v[i] + p);
            p++;
        }
    }
    cout << ans + t;

    return 0;
}