#ifdef _MSC_VER
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream& operator>>(istream& is, vector<T>& a) {
	for (auto& i : a) {
		is >> i;
	}
	return is;
}

mt19937 rng(228);

int32_t main() {
#ifdef LOCAL
	assert(freopen("C:\\Users\\User\\input.txt", "r", stdin));
#else
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	cin >> a;
	vector<int> b = a;
	sort(b.begin(), b.end());
	b.resize(unique(b.begin(), b.end()) - b.begin());
	vector<int> cnt(b.size());
	for (int i = 0; i < n; ++i) {
		int x = lower_bound(b.begin(), b.end(), a[i]) - b.begin();
		++cnt[x];
	}
	vector<pair<int, int>> bb;
	for (int i = 0; i < (int)b.size(); ++i) {
		bb.push_back({ b[i], cnt[i] });
	}
	sort(bb.begin(), bb.end(), [](const pair<int, int>& p, const pair<int, int>& q) {
		return p.first + p.second < q.first + q.second;
		});
	vector<pair<int, int>> nbb;
	while ((int)bb.size() + (int)nbb.size() < k) {
		auto [x, y] = bb.back();
		bb.pop_back();
		if (y - 1 >= 1) {
			bb.push_back({ x, y - 1 });
		}
		nbb.push_back({ x, 1 });
	}
	for (auto [x, y] : nbb) {
		bb.push_back({ x, y });
	}
	sort(bb.begin(), bb.end(), [](const pair<int, int>& p, const pair<int, int>& q) {
		return p.first + p.second > q.first + q.second;
		});
	ll ans = 0;
	for (int i = 0; i < k; ++i) {
		auto [x, y] = bb[i];
		ans += x + y;
	}
	cout << ans << "\n";
	return 0;
}