
// #pragma GCC optmize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

typedef long long ll;
typedef long double ld;

template <typename T>
void sort(T &s) {
    sort(all(s));
}

const int inf = 2e9 + 2000;
const ll infll = 2e18 + 2000;
const int R = (1 << 20);
mt19937 rnd(26);

template <typename T>
struct point {
    T x, y;
    point(T x, T y) : x(x), y(y) {}
    point(point a, point b) : x(b.x - a.x), y(b.y - a.y) {}

    point operator + (point &o) const {
        return {x + o.x, y + o.y};
    }

    point operator * (const T k) const {
        return {x * k, y * k};
    }

    T operator * (const point &o) const {
        return x * o.x + y * o.y;
    }

    T operator % (const point &o) const {
        return x * o.y - y * o.x;
    }

    T len2() {
        return x * x + y * y;
    }

    ld len() {
        return sqrt(x * x + y * y);
    }
};



void solve() {
    int n, k;
    cin >> n >> k;

    vector<pair<ll, int> > pa;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pa.emplace_back(a[i], i);
    }
    sort(rall(pa));

    int le = -1;
    ll res = 0;
    for (int i = 0; i < k - 1; ++i) {
        res += pa[i].first;
        le = max(le, pa[i].second);
    }

    if (le == n - 1) {
        res += pa[k - 1].first;
        res += n;
    } else {
        res += le + 1;
        ll ma = -inf;
        for (ll i = le + 1; i < n; ++i) {
            ma = max(ma, a[i] + i - le);
        }
        res += ma;
    }

    cout << res;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int tt = 1;
    // cin >> tt;

    while (tt--) {
        solve();
    }
}
