#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend();

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<string> vs;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<ull> vull;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef vector<pll> vpll;
typedef pair<double, double> pdd;
typedef long double ld;
typedef vector<ld> vld;
typedef vector<pair<ld, ld>> vpld;
typedef string str;
typedef set<ll> sll;
typedef set<int> si;
typedef set<str> ss;
typedef set<pii> spii;
typedef multiset<int> msi;
typedef multiset<ll> msll;
typedef multiset<str> mss;
typedef multiset<pii> mspii;
typedef multiset<pll> mspll;
typedef vector<vector<int>> vvi;
typedef vector<vector<ll>> vvll;
typedef queue<int> qi;
typedef queue<ll> qll;
typedef queue<pair<ll, ll>> qpll;

using namespace __gnu_pbds;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<class T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

// ordered_set<ll> oset;
// oset.insert(2);
// oset.insert(5);
// oset.insert(100);
// cout << oset.order_of_key(15) << endl;
// *oset.find_by_order(1); -> 5
// gp_hash_table<ll, ll> gp;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (T &i : a) in >> i;
    return in;
}
 
template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &a) {
    in >> a.fi >> a.se;
    return in;
}
 
template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &a) {
    out << a.fi << " " << a.se;
    return out;
}
 
template<typename T1, typename T2>
istream &operator>>(istream &in, vector<pair<T1, T2>> &a) {
    for (pair<T1, T2> &i : a) in >> i.fi >> i.se;
    return in;
}
 
template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto i : a) {
        out << i << " ";
    }
    return out;
}
 
template<typename T1, typename T2>
ostream &operator<<(ostream &out, vector<pair<T1, T2>> &a) {
    for (pair<T1, T2> i : a) out << i.fi << " " << i.se << endl;
    return out;
}
 
template<typename T1>
ostream &operator<<(ostream &out, vector<vector<T1>> &a) {
    for (vector<T1> i : a) {
        for (T1 j : i) out << j << " ";
        out << endl;
    }
    return out;
}

template<typename T1, typename T2>
inline T1 min(T1 a, T2 b) {
    b = (T1) b;
    return a > b ? b : a;
}
 
template<typename T1, typename T2>
inline T1 max(T1 a, T2 b) {
    b = (T1) b;
    return a > b ? a : b;
}
 
template<typename T1, typename T2>
inline void amin(T1 &a, T2 b) {
    a = min(a, b);
}
 
template<typename T1, typename T2>
inline void amax(T1 &a, T2 b) {
    a = max(a, b);
}

double getTime() {
    return clock() / (double) CLOCKS_PER_SEC;
}

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll rndlr(ll l, ll r) {
    ll a = rnd() % (r - l + 1) + l;
    return a;
}

ll n, k;
vll a;

ll good() {
    ll ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        if (__builtin_popcount(mask) != k) {
            continue;
        }
        ll mx = 0;
        ll add = 1;
        ll subans = 0;
        for (int bit = n - 1; bit >= 0; --bit) {
            int real = n - 1 - bit;
            mx = max(mx, a[real] + add);
            if ((mask >> bit) & 1) {
                subans += mx;
                add = 1;
                mx = 0;
                continue;
            }
            add++;
        }
        ans = max(ans, subans);
    }
    return ans;
}

ll bad() {
    vector<int> order(n);
    iota(all(order), 0);
    sort(all(order), [&](int fi, int se) {
        if (a[fi] != a[se]) {
            return a[fi] > a[se];
        }
        return fi < se;
    });
    ll ind_min = order[k - 1];
    // cout << "ind_min=" << ind_min << endl;
    unordered_set<int> use;
    for (int i = 0; i < k; ++i) {
        use.insert(order[i]);
    }
    ll ans = 0;
    ll add = 1;
    ll mx = 0;
    vi used(n, false);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (cnt == k - 1) {
            break;
        }
        if (ind_min == i) {
            continue;
        }
        if (use.find(i) == use.end()) {
            used[i] = true;
            mx = max(mx, a[i] + add);
            add++;
        } else {
            mx = max(mx, a[i] + add);
            cnt++;
            used[i] = true;
            ans += mx;
            add = 1;
            mx = 0;
        }
        if (cnt == k - 1) {
            break;
        }
    }
    mx = 0;
    add = 1;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            mx = max(mx, a[i] + add);
            add++;
        }
    }
    ans += mx;
    return ans;
}

void gen() {
    n = rndlr(1, 5);
    k = rndlr(1, n);
    a.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        a[i] = rndlr(1, 10);
    }
}

void stress() {
    int test = 0;
    while (true) {
        gen();
        ll bad_ans = bad();
        ll good_ans = good();
        if (bad_ans != good_ans) {
            cout << "ERROR\n";
            cout << "n=" << n << " k=" << k << " a=" << a << endl;
            cout << "bad: " << bad_ans << endl;
            cout << "Good: " << good_ans << endl;
            break;
        }
        test++;
        if (test % 10000 == 0) {
            cout << "OK: " << test << endl;
        }
    }
}

void solve() {
    // stress();
    cin >> n >> k;
    a.assign(n, 0);
    cin >> a;
    cout << bad() << "\n";
    // cout << good() << "\n";
    // ll mx = 0;
    // int add = 1;
    // for (int i = k - 1; i < n; ++i) {
    //     mx = max(mx, a[i] + add);
    //     add++;
    // }
    // ans += mx;
    // cout << ans << "\n";
}

int main() {
    setlocale(LC_ALL, "Russian");
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout.precision(12);
    cout << fixed;
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
