#ifndef LOCAL
  // #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#ifndef LOCAL
  // #pragma GCC target("avx,avx2,fma")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

void solve() {
  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (auto& it : a) {
    cin >> it;
  }

  ll ans = 0;

  vector<vector<int>> b(k);

  function<void(int)> brute = [&](int i) {
    if (i == n) {
      for (auto& seq : b) {
        if (seq.empty()) return;
      }
      ll cur = 0;
      for (auto& seq : b) {
        int mx = 0;
        for (int j = 0; j < (int)seq.size(); ++j) {
          mx = max(mx, seq[j] + j + 1);
        }
        cur += mx;
      }
      ans = max(ans, cur);
      return;
    }
    for (int j = 0; j < k; ++j) {
      b[j].push_back(a[i]);
      brute(i + 1);
      b[j].pop_back();
    }
  };

  brute(0);

  cout << ans << '\n';
}

signed main() {
  cin.tie(0)->sync_with_stdio(0);
  int t = 1;
  // cin >> t;
  while (t --> 0) {
    solve();
  }
}