#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#define len(x) (int)x.size()
#define all(x) x.begoin(), x.end()
const ll INF = 1e18;
const int INFi = 1e9;

struct sp {
    int n;
    vector<int> ln;
    vector<vector<ll>> t;

    sp(vector<ll> &a) {
        n = len(a);

        ln.resize(n + 1);
        t.resize(25, vector<ll>(n));

        ln[1] = 0;
        for (int i = 2; i <= n; ++i) {
            ln[i] = ln[i>>1] + 1;
        }

        for (int i = 0; i < n; ++i) {
            t[0][i] = a[i] + i;
        }
        for (int k = 0; k + 1 < 25; ++k) {
            for (int i = 0; i + (1 << k) < n; ++i) {
                t[k+1][i] = max(t[k][i], t[k][i + (1 << k)]);
            }
        }
    }

    ll mx(int l, int r) {
        ++r;
        int lg = ln[r-l];
        return max(t[lg][l], t[lg][r - (1 << lg)]);
    }
};

vector<vector<ll>> dp;

void divide(int l, int r, int tl, int tr, int k, sp &T) {
    if (l > r) return;
    int m = (l + r) / 2;
    int t = tl;
    for (int i = tl; i <= min(m, tr); ++i) {
        ll val = dp[i-1][k-1] + T.mx(i,m) - i + 1;
        if (dp[m][k] < val) {
            dp[m][k] = val;
            t = i;
        }
    }
    divide(l,m-1,tl,t,k,T);
    divide(m+1,r,t,tr,k,T);
}

void solve() {
    int n, k;
    cin >> n >> k;

    vector<ll> a(n+1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }

    sp T(a);

    dp.resize(n+1, vector<ll>(k+1, -INF));
    dp[0][0] = 0;
    for (int i = 1; i <= k; ++i) {
        divide(1,n,1,n,i,T);
    }

    cout << dp[n][k] << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt","w", stdout);
#endif

    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}