#include <bits/stdc++.h>

using ll = long long;

using namespace std;

struct Node {
    ll k, s;
};

vector<Node> tree;

Node op(Node a, Node b) {
    return {a.k + b.k, a.s + b.s};
}

void upd(ll u, ll v, ll x, ll lx, ll rx) {
    if (rx - lx == 1) {
        tree[x].s += v;
        tree[x].k += 1;
        return;
    }
    ll m = (lx + rx) / 2;
    if (u < m) {
        upd(u, v, 2 * x + 1, lx, m);
    } else {
        upd(u, v, 2 * x + 2, m, rx);
    }
    tree[x] = op(tree[2 * x + 1], tree[2 * x + 2]);
}

Node get(ll l, ll r, ll x, ll lx, ll rx) {
    if (l >= rx || lx >= r) {
        return {0, 0};
    }
    if (lx >= l && rx <= r) {
        return tree[x];
    }
    ll m = (lx + rx) / 2;
    return op(get(l, r, 2 * x + 1, lx, m), get(l, r, 2 * x + 2, m, rx));
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> A(n);
    map<ll, ll> Mp, Mp1;
    for (ll i = 0; i < n; i++) {
        cin >> A[i];
        Mp[A[i]] = 1;
    }
    ll f = 0;
    for (auto i : Mp) {
        Mp[i.first] = f;
        Mp1[f] = i.first;
        f++;
    }
    ll n1 = pow(2, ceil(log2(f)));
    tree.assign(2 * n1 - 1, {0, 0});
    for (ll i = 0; i < k - 1; i++) {
        upd(Mp[A[i]], A[i], 0, 0, n1);
    }
    ll ans = 0;
    for (ll i = k - 1; i < n; i++) {
        ll l = 0, r = f;
        while (r - l > 1) {
            ll m = (l + r) / 2;
            Node s = get(m, f, 0, 0, n1);
            if (s.k >= k - 1) {
                l = m;
            } else {
                r = m;
            }
        }
        auto rd = get(l, f, 0, 0, n1);
        ll b = rd.s - (rd.k - (k - 1)) * Mp1[l];
        //cout << Mp1[l] << ' ' << rd.k << ' ' << rd.s << '\n';
        //cout << i << ' ' << l << ' ' << rd.s << ' ' << rd.k << '\n';
        ll d = i + 1 + b + A[i];
        ans = max(ans, d);
        upd(Mp[A[i]], A[i], 0, 0, n1);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    //cin >> t;
    for (ll i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
