#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifndef DEBUG
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#endif

using namespace __gnu_pbds;

template <typename T>
using oset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using pll = std::pair<ll, ll>;
using ld = long double;
using i128 = __int128;

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

void solve(){
    ll n, k;
    std::cin >> n >> k;
    std::vector<pll> a(n);
    std::vector<ll> used(n);
    ll sum = 0;
    ll daln = 0;
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i].first;
        a[i].second = -i;
    }
    auto srt = a;
    std::sort(srt.begin(), srt.end());
    ll add = 1e9;
    for (int i = ll(srt.size()) - 1, h = 0; h < k; --i, ++h) {
        sum += srt[i].first;
        daln = std::max(daln, -srt[i].second);
        used[-srt[i].second] = 1;
        add = std::min(add, srt[i].first + 1);
    }
    sum -= add;
    sum += k;
    for (int i = 0; i < daln; ++i) {
        sum += !used[i];
    }
    for (int i = daln + 1; i < n; ++i) {
        add = std::max(add, a[i].first + i - daln + 1);
    }
    sum += add;
    std::cout << sum;
}

int main() {
#ifdef DEBUG
    std::freopen("/home/olymp/CLionProjects/untitled/input.txt", "r", stdin);
#endif
    std::cin.tie(0) -> std::ios::sync_with_stdio(0);
    int tt = 1;
//    std::cin >> tt;
    while (tt--){
        solve();
    }
}
