#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <tuple>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int INF = 2 * 1e9;
const ll MAX = 1e15;
const ll MIN = -1e15;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-7;




void solve() {
    int n, k; cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    ll cur = k, sum = 0;
    multiset<int> ok;
    for (int i = 0; i < k; i++) sum += a[i], ok.insert(a[i]);

    for (int i = k; i < n; i++) {
        int mn = *ok.begin();
        if (a[i] + i + 1 + sum - mn > sum + cur) {
            sum -= mn;
            sum += a[i];
            cur = i + 1;
            ok.erase(ok.begin());
            ok.insert(a[i]);
        }
    }
    cout << sum + cur << endl;
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
