#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,bmi2")

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
template <typename T>
using ordered_set = __gnu_pbds::tree <T, __gnu_pbds::null_type, less <T>,
        __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template <typename T>
int sz(const T &x) {
    return static_cast <int> (x.size());
}

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int MAXN = 2e5;
const int INF = 2e9;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-8;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector <ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (k == 1) {
        ll ans = 0;
        for (int i = 0; i < n; i++) {
            ans = max(ans, a[i] + i + 1);
        }
        cout << ans;
        return 0;
    }
    ll k_best_sum = 0;
    multiset <int> k_best;
    for (int i = 0; i < k - 1; i++) {
        k_best.insert(a[i]);
        k_best_sum += a[i];
    }
    ll ans = 0;
    for (int i = k - 1; i < n; i++) {
        ans = max(ans, k_best_sum + a[i] + i + 1);
        if (*k_best.begin() < a[i]) {
            k_best_sum -= *k_best.begin();
            k_best.erase(k_best.begin());
            k_best.insert(a[i]);
            k_best_sum += a[i];
        }
    }
    cout << ans;
    return 0;
}
