#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int n, k;
    if (!(cin >> n >> k)) {
        return 0;
    }
    vector<ll> a(n + 1);
    for (int i = 1; i <= n; ++i) {
        ll x;
        cin >> x;
        a[i] = x;
    }

    if (k == 1) {
        ll res = 0;
        for (int i = 1; i <= n; ++i) {
            ll val = a[i] + i;
            if (val > res) res = val;
        }
        cout << res;
        return 0;
    }


    priority_queue<ll, vector<ll>, greater<ll>> minHeap;
    ll sumTop = 0;
    ll res = 0;

    for (int i = 1; i < k; ++i) {
        sumTop += a[i];
        minHeap.push(a[i]);
    }

    for (int i = k; i <= n; ++i) {

        ll current = a[i] + sumTop + i;
        if (current > res) res = current;

        if (!minHeap.empty()) {
            if ((int)minHeap.size() < k-1) {

                minHeap.push(a[i]);
                sumTop += a[i];
            } else if (k - 1 > 0) {

                ll minVal = minHeap.top();
                if (a[i] > minVal) {
                    minHeap.pop();
                    sumTop -= minVal;
                    minHeap.push(a[i]);
                    sumTop += a[i];
                }
            }
        } else {

        }
    }
    cout << res;
}
