#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define endl '\n'
#define int long long
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()

#ifdef local
    #define dbg(x) cout << __LINE__ << " : " << (#x) << " = " << x << endl;
#else
    #pragma GCC optimize("03")
    #define dbg(x) ;
#endif

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    vector<pair<int, int>> b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = make_pair(a[i], i);
    }
    sort(all(b), [](pair<int, int> &a, pair<int, int> &b) {
        if (a.first == b.first) {
            return a.second < b.second;
        }
        return a.first > b.first;
    });
    vector<int> vis(n);
    int ans = 0;
    for (int i = 0; i < k - 1; i++) {
        ans += b[i].first + 1;
        vis[b[i].second]++;
    }
    int get = 0, cnt = 0;
    for (int i = 0; i < n; i++) {
        if (!vis[i]) {
            cnt++;
            get = max(get, a[i] + cnt);
        }
    }
    cout << ans + get << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    #ifdef local
        freopen("in.txt", "r", stdin);
    #endif
    solve();
    return 0;
}
