#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = 1e18;

void solveInc(int n, int k, vector<ll> a) {
    ll sum = n;
    sort(a.begin(), a.end() - 1);
    for (int i = n - k; i < n; ++i) {
        sum += a[i];
    }
    cout << sum << '\n';
}

void solvek2(int n, int k, vector<ll> a) {
    ll ans = 0;
    vector<ll> pm(n + 1);
    for (int i = 0; i < n; ++i) {
        pm[i + 1] = max(pm[i], a[i]);
    }
    for (int ls = 0; ls < n; ++ls) {
        ans = max(ans, pm[ls] + a[ls] + ls + 1);
    }
    cout << ans << '\n';
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    if (k == 2) {
        solvek2(n, k, a);
        return;
    }

    bool inc = true;
    for (int i = 0; i + 1 < n; ++i) {
        if (a[i + 1] < a[i] - 1) {
            inc = false;
        }
    }
    if (inc) {
        solveInc(n, k, a);
        return;
    }

    cout << "0\n";

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
