#include <bits/stdc++.h>

using namespace std;

#define int long long

mt19937 rnd(14);

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.first > b.first || a.first == b.first && a.second < b.second;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (auto &i: a) {
        cin >> i;
    }
    deque<pair<int, int>> b;
    for (int i = 0; i < n; ++i) {
        b.emplace_back(a[i], i);
    }
    sort(b.begin(), b.end(), cmp);
    vector<bool> used(n);
    while (k > 1) {
        used[b[0].second] = true;
        b.pop_front();
        --k;
    }
    int cnt = 1, mx = 0, mxpos = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            if (mx < a[i] + cnt) {
                mx = a[i] + cnt;
                mxpos = i;
            }
            ++cnt;
        }
    }
    used[mxpos] = true;
    int ans = 0;
    cnt = 1;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            ++cnt;
        } else {
            ans += a[i] + cnt;
            cnt = 1;
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
