#include <bits/stdc++.h>
using namespace std;

void outer_sum(int& a, int& b) {
    if (a == 0) {
        a = b;
    } else if (b == 0) {

    } else if (b == a) {

    } else {
        a = -1;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int N, n, M, m, k, Q, q, r;
    cin >> N >> n >> M >> m >> k >> Q;
    vector<int> la{0}, lb{0}, va{-1}, vb{-1};
    for (int i = 0; i < n; i++) {
        cin >> q >> r;
        r--;
        la.push_back(la.back() + q);
        va.push_back(r);
    }
    for (int i = 0; i < m; i++) {
        cin >> q >> r;
        r--;
        lb.push_back(lb.back() + q);
        vb.push_back(r);
    }
    vector<int> cnt, cnta(n + 1), cntb(m + 1);
    cnt.assign(k, 0);
    for (int i = n; i > 0; i--) {
        cnt[va[i]] += la[i] - la[i - 1];
        cnta[i] = cnt[va[i]];
    }
    cnt.assign(k, 0);
    for (int i = m; i > 0; i--) {
        cnt[vb[i]] += lb[i] - lb[i - 1];
        cntb[i] = cnt[vb[i]];
    }
    vector<int> u(m, 0);
    vector<vector<bool>> who_wins(n + 1, vector<bool>(m + 1, false)); //false is for Alice, true is for Bob
    for (int i = n; i > 0; i--) {
        int not_winner(0);
        for (int j = m; j > 0; j--) {
            outer_sum(not_winner, u[j]);
            if (va[i] == vb[j]) { //only these states can be recorded as wins for Alice or for Bob

                if ((not_winner == 0) || (va[i] == not_winner)) { //Bob actually won.
                    if (min(cnta[i], cntb[j]) % 2 == 0) { //otherwise Alice starves Bob and Bob hasn't won on the full segment.
                        outer_sum(u[j], va[i]);
                        outer_sum(not_winner, va[i]);
                    }
                    who_wins[i][j] = true;
                }
            }
        }
    }
    for (int i = 0; i < Q; i++) {
        cin >> q >> r;
        int s(lower_bound(la.begin(), la.end(), q + 1) - la.begin());
        int t(lower_bound(lb.begin(), lb.end(), r + 1) - lb.begin());
        int q1(q - la[s - 1]), r1(r - lb[t - 1]);
        //cout << s << " " << t << " " << q1 << " " << r1 << " " << cnta[s] << " " << cntb[t] << endl;
        if (!who_wins[s][t]) {
            cout << "Yes" << endl;
        } else if (min(cnta[s] - q1, cntb[t] - r1) % 2 == 1) {
            cout << "Yes" << endl;
        } else {
            cout << "No" << endl;
        }
    }
}
