#ifdef LOCAL
#pragma optimize("", off)
#include "localstd1.h"
#else
#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/allocator.h>
#pragma GCC target("avx2,bmi,bmi2")
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(a) (a).begin(), (a).end()

struct Node {
	vector<int> e;
	int banned = -1;
	int vers = -1;
};
vector<Node> graph;

void dfs(int u, int vers) {
	if (graph[u].vers == vers) return;
	graph[u].vers = vers;
	for (int to : graph[u].e) if (to != graph[u].banned) {
		dfs(to, vers);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m; cin >> n >> m;
	graph.assign(n, {});
	for (int i = 0; i < m; i++) {
		int u, v; cin >> u >> v; u--; v--;
		graph[u].e.push_back(v);
	}

	int cnt = 0;
	int vers = 0;
	for (int i = 0; i < n; i++) {
		for (int to : graph[i].e) {
			graph[i].banned = to;
			dfs(i, vers);
			graph[i].banned = -1;
			if (graph[to].vers == vers) {
				cnt++;
			}
			vers++;
		}
	}
	cout << cnt << '\n';
	cout << 1;
	
	return 0;
}