#ifdef LOCAL
#pragma optimize("", off)
#include "localstd1.h"
#else
#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/allocator.h>
#pragma GCC target("avx2,bmi,bmi2")
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(a) (a).begin(), (a).end()

void to_good(vector<pair<int, int>>& segs) {
	sort(all(segs));
	segs.erase(unique(all(segs), [](pair<int, int> l, pair<int, int> r) {return l.first == r.first; }), segs.end());
	vector<pair<int, int>> res;
	int tr = -1;
	for (auto [l, r] : segs) {
		if (r > tr) {
			res.push_back({ l, r });
			tr = r;
		}
	}
	swap(res, segs);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	
	int n, m, g; cin >> n >> m >> g;
	vector<pair<int, int>> segs;
	for (int i = 0; i < m; i++) {
		int u, v; cin >> u >> v; u--; v--;
		if (u + 1 != v) segs.push_back({ u, v - 1 });
	}

	to_good(segs);

	int last = -1, cnt = 0;
	for (auto [l, r] : segs) {
		if (l > last) {
			last = r;
			cnt++;
		}
	}
	cout << n - 1 - cnt;

	return 0;
}