#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <random>
#include <map>
#include <queue>

using namespace std;
using ll = long long;

const int maxn = 2000;
const ll mod = 1e9 + 7;
vector<int> gr[maxn];
int us[maxn];

void dfs(int v) {
	us[v] = 1;
	for (auto u : gr[v]) {
		if (!us[u]) {
			dfs(u);
		}
	}
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, m, g;
	cin >> n >> m >> g;
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		gr[u].push_back(v);
		gr[v].push_back(u);
	}
	int cn = 0;
	for (int i = 0; i < n; ++i) {
		if (!us[i]) {
			++cn;
			dfs(i);
		}
	}

	cout << 0 << '\n' << 1;

	return 0;
}
