#include <bits/stdc++.h>
#define int long long
using namespace std;
vector<vector<int>> gr;
vector<int> vst;
vector<int> tp;
int ans = 0;
void dfs(int v, int ok, int z) {
    vst[v] = 1;
    ans += ok;
    for (auto x : gr[v]) {
        if (!vst[x]) dfs(x, 1, z);
    }
    if (z) tp.push_back(v);
}
const int N = 2001;
int p[N];
int h[N];
int get(int v) {
    if (v == p[v]) return v;
    return p[v] = get(p[v]);
}
void unite(int u, int v) {
    if (h[u] < h[v]) swap(u, v);
    h[u] = max(h[u], h[v] + 1);
    p[v] = u;
}
void dfs(int v) {
    vst[v] = 1;
    for (auto x : gr[v]) {
        if (!vst[x]) dfs(x);
    }
}
int r[N][N];
map<pair<int, int>, vector<pair<int, int>>> gg;
map<pair<int, int>, int> vs;
void dfs2(pair<int, int> e) {
    vs[e] = 1;
    for (auto x :gg[e]) {
        if (!vs[x]) dfs2(x);
    }
}
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, g; cin >> n >> m >> g;
    vector<int> iz(n), in(n);
    for (int i = 0; i < n; i++) {
        p[i] = i;
        h[i] = 1;
    }
    gr.resize(n); vst.resize(n);
    vector<int> deg1(n), deg2(n);

    for (int i = 0; i < m; i++) {
        int u, v; cin >> u >>v;
        u--; v--;
        gr[u].push_back(v);
        deg1[u]++; deg2[v]++;
        iz[u] = v;
        in[v] = u;
    }
    set<pair<int, int>> e;
    vector<tuple<int, int, int, int>> ys;

    for (int i = 0; i < n; i++) {
        if (deg1[i] == 1 && deg2[i] == 1) {
            e.insert({i, iz[i]});
            e.insert({in[i], i});
            gg[{i, iz[i]}].push_back({in[i], i});
            gg[{in[i], i}].push_back({i, iz[i]});
        }
    }
    int ans = e.size();
    for (auto& [pr, v]: gg) {
        if (!vs[pr]) {
            dfs2(pr);
            ans--;
        }
    }
    cout << ans << '\n';
    cout << 1 << '\n';
    return 0;
}
