// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

mt19937 rnd(69); // chrono::steady_clock::now().time_since_epoch().count()
#define all(x) x.begin(), x.end()
// #define int long long
const int INF = 1e9 + 69;
const int MOD = 1e9 + 7;
const int p = 31;
#define ull unsigned long long
#define ld long double
#pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2")

vector<vector<int>> graph;
vector<int> used;
int n, m;
int cur_t = 1;

void dfs(int v) {
    used[v] = cur_t;
    for (auto u : graph[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    int g, ans, ans_pos, u, v;
    cin >> n >> m >> g;
    graph.resize(n, {});
    vector<pair<int, int>> edges(m);
    for (int i = 0; i < m; i++) {
        cin >> u >> v;
        u--;
        v--;
        edges[i].first = u;
        edges[i].second = v;
        graph[u].push_back(v);
    }
    used.resize(n, 0);
    ans = m - n;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            cur_t++;
            dfs(i);
            ans++;
        }
    }
    for (int i = 0; i < m; i++) {
        if (used[edges[i].first] != used[edges[i].second]) {
            ans--;
        }
    }
    cout << ans << " " << 0 << endl;
    return 0;
}
// test
