#include<bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#define int long long
vector<vector<int>> g;
vector<int> color;
int timer = 1;

void dfs(int v) {
    color[v] = timer;
    for (auto u : g[v]) {
        if (color[u] != color[v]) {
            dfs(u);
        }
    }
}


bool cmp(pair<int, int> a, pair<int, int>  b) {
    if (a.first != b.first) {
        return a.first > b.first;
    }
    return a.second < b.second;
}

signed main() {
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
    cout.precision(20);
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n, m, gg;
    cin >> n >> m >> gg;
    g.resize(n);
    color.resize(n);
    vector<pair<int, int>> edge;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        edge.push_back({a - 1, b - 1});
    }
    sort(edge.begin(), edge.end(), cmp);
    vector<pair<int, int>> e1;
    int mn = 1e9 + 1;
    for (int i = 0; i < m; i++) {
        if (edge[i].second < mn) {
            g[edge[i].first].push_back(edge[i].second);
            g[edge[i].second].push_back(edge[i].first);
        } else {
            e1.push_back(edge[i]);
        }
        mn = min(mn, edge[i].second);
    }
    for (int i = 0; i < n; i++) {
        if (!color[i]) {
            dfs(i);
            timer++;
        }
    }
    int ans = 0;
    for (auto [a, b] : e1) {
        if (color[a] == color[b]) {
            ans++;
        }
    }
    cout << ans << '\n' << 1 << '\n';
}