#include <bits/extc++.h>

using namespace std;

int M;

vector<vector<tuple<int, int, int>>> g;

vector<int> ord, used;

void dfs1(int v) {
    used[v] = 1;
    for (auto [u, i, f] : g[v]) {
        int b = ((M >> i) & 1);
        if (b == 1 && f == 0) {
            continue;
        }
        if (b == 0 && f == 1) {
            continue;
        }
        if (!used[u]) {
            dfs1(u);
        }
    }
    ord.push_back(v);
}

vector<int> c;

void dfs2(int v, int col) {
    c[v] = col;
    for (auto [u, i, f] : g[v]) {
        int b = ((M >> i) & 1);
        if (b == 1 && f == 1) {
            continue;
        }
        if (b == 0 && f == 0) {
            continue;
        }
        if (c[u] == -1) {
            dfs2(u, col);
        }
    }
}

bool f(const vector<int> &s, const vector<int> &t, int n) {
    {
        vector<int> zz(n, -1);
        for (int i = 0; i < n; i++) {
            if (zz[s[i]] == -1) {
                zz[s[i]] = t[i];
            }
            if (t[i] != zz[s[i]]) {
                return false;
            }
        }
    }
    vector<int> zz(n, -1);
    for (int i = 0; i < n; i++) {
        if (zz[t[i]] == -1) {
            zz[t[i]] = s[i];
        }
        if (s[i] != zz[t[i]]) {
            return false;
        }
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, G;
    cin >> n >> m >> G;
    g.resize(n);
    c.resize(n);
    used.resize(n);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u, v--, u--;
        g[v].emplace_back(u, i, 0);
        g[u].emplace_back(v, i, 1);
    }
    auto kek = [&](int mask) {
        M = mask;
        ord.clear();
        used.assign(n, 0);
        c.assign(n, -1);
        for (int v = 0; v < n; v++) {
            if (!used[v]) {
                dfs1(v);
            }
        }
        reverse(ord.begin(), ord.end());
        int col = 0;
        for (int v : ord) {
            if (c[v] == -1) {
                dfs2(v, col);
                col++;
            }
        }
        return c;
    };
    vector<int> dp(1 << m);
    auto I = kek(0);
//    for (int i = 0; i < n; i++) {
//        cerr << I[i] << ' ';
//    }
//    cerr << '\n';
    for (int mask = 1; mask < (1 << m); mask++) {
        auto now = kek(mask);
        if (f(now, I, n)) {
            dp[mask] = 1;
//            cerr << bitset<6>(mask).to_string() << '\n';
//            for (int i = 0; i < n; i++) {
//                cerr << now[i] << ' ';
//            }
//            cerr << '\n';
        }
    }
    for (int mask = 0; mask < (1 << m); mask++) {
        for (int i = 0; i < m; i++) {
            if ((mask >> i) & 1) {
                dp[mask] |= dp[mask ^ (1 << i)];
            }
        }
    }
    pair<int, int> ans = {m + 52, -1};
    for (int mask = 1; mask < (1 << m); mask++) {
        int ch = __builtin_popcount(mask);
        int r = ((1 << m) - 1) ^ mask;
        if (!dp[r]) {
            if (ans.first > ch) {
                ans = {ch, 1};
            } else if (ans.first == ch) {
                ans.second++;
            }
        }
    }
    cout << m - ans.first << '\n' << ans.second << '\n';
    return 0;
}
/*

5 6 0
1 2
1 5
2 3
3 4
3 5
4 2


 */