#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <unordered_set>
#include <algorithm>

using namespace std;

using ll = long long;

#pragma GCC optimaze("Ofast");

vector<unordered_set<int>> gr, grr;

vector<int> us;
vector<int> top;
vector<int> ok;
set<pair<int, int>> ed;
ll n, m, t;

void dfs(int v) {
	us[v] = 1;
	for (int u : gr[v]) {
		if (us[u]) continue;
		dfs(u);
	}
	top.push_back(v);
}

void dfs2(int v, int T) {
	us[v] = T;
	for (int u : grr[v]) {
		if (us[u]) continue;
		if (ed.count({ min(u, v), max(u, v) })) {
			if (ok[v] == ok[u]) dfs2(u, T);
			else continue;
		}
		dfs2(u, T);
	}
}

vector<int> css() {
	int T = 1;
	for (int i = 0; i < n; i++) us[i] = 0;
	top.clear();
	//
	dfs(0);
	//
	for (int i = 0; i < n; i++) us[i] = 0;
	for (int i = n - 1; i > -1; i--) {
		if (us[top[i]]) continue;
		dfs2(top[i], T);
		T++;
	}
	return us;
}

pair<ll, ll> an(vector<vector<int>>& gr) {
	int md = 0;
	int n = int(gr.size());
	for (int i = 0; i < n; i++) md = max(md, int(gr[i].size()));
	if (md == 1) {
		return { m - 1, m - 1 };
	}
	set<pair<int, int>> se;
	vector<vector<int>> gr2(n);
	for (int i = 0; i < n; i++) {
		for (int u : gr[i]) gr2[u].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		if (int(gr[i].size()) == 1) {
			if (se.count({ min(i, gr[i][0]), max(i, gr[i][0]) })) continue;
			se.insert({ min(i, gr[i][0]), max(i, gr[i][0]) });
			gr[gr[i][0]].push_back(i);
			gr2[i].push_back(gr[i][0]);
		}
		if (int(gr2[i].size()) == 1) {
			if (se.count({ min(i, gr2[i][0]), max(i, gr2[i][0]) })) continue;
			se.insert({ min(i, gr2[i][0]), max(i, gr2[i][0]) });
			gr2[gr2[i][0]].push_back(i);
			gr[i].push_back(gr2[i][0]);
		}
	}
	return { int(se.size()), 1 };
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cin >> n >> m >> t;
	gr.resize(n);
	grr.resize(n);
	us.resize(n);
	vector<pair<int, int>> e;
	vector<int> use(m);
	vector<vector<int>> gr(n);
	for (int i = 0; i < m; i++) {
		int A, B;
		cin >> A >> B;
		A--;
		B--;
		gr[A].push_back(B);
	}
	pair<int, int> ans = an(gr);
	cout << ans.first << ' ' << ans.second << "\n";
}



