#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rand1(ll a, ll b) {
    return uniform_int_distribution<ll> (a, b) (gen);
}

bool cyc = false;
ll st = -1;

void dfs(ll v, vector<ll> &vis, vector<vector<ll>> &g) {
    vis[v] = 1;
    for (auto &u : g[v]) {
        if (vis[u] == 2) continue;
        if (vis[u] == 1) {
            if (st == u) cyc = true;
        } else {
            dfs(u, vis, g);
        }
    }
    vis[v] = 2;
}

void solve() {
    ll n, m, gn;
    cin >> n >> m >> gn;
    vector<pair<ll, ll>> edges;
    for (ll i = 0; i < m; i++) {
        ll x, y;
        cin >> x >> y;
        x--;
        y--;
        edges.push_back({x, y});
    }
    cout << n - 1 << "\n" << n;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t12 = 1;
//    cin >> t12;
    while (t12--) {
        solve();
        cout << '\n';
    }
    return 0;
}