#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

// #define FILE
// #define int long long

const int N = 2000;
int m;
vector<vector<short int>> g(N);
vector<int> otv;
map<pair<int, int>, int> ind;


void dfs(int st, int v) {
    if (ind[{st, v}]) {
        otv[ind[{st, v}]]++;
    }
    for (auto x : g[v]) {
        dfs(st, x);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef FILE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int gg;
    int n;
    cin >> n >> m >> gg;
    otv.resize(m + 1);
    vector<pair<int, int>> r;
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y; x--; y--;
        g[x].push_back(y);
        r.push_back({x, y});
        ind[{x, y}] = i + 1;
    }
    for (int i = 0; i < n; ++i) {
        dfs(i, i);
    }
    int ans = 0;
    for (int i = 1; i <= m; ++i) {
        if (otv[i] > 1) ans++;
    }
    cout << ans << " " << 1 << endl;
    return 0;

}