#include <bits/stdc++.h>

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using namespace std;

const int N = 2010;

vector<pair<int, int>> g[N];
bool used[N];

void dfs(int v, int block_id) {
    used[v] = true;
    for (auto [u, id] : g[v]) {
        if (used[u] || id == block_id) {
            continue;
        }
        dfs(u, block_id);
    }
}

void solve_case() {
    int n, m, G; cin >> n >> m >> G;
    for (int i = 0; i < m; i++) {
        int u, v; cin >> u >> v;
        g[u].push_back({v, i});
    }
    int mx = 0;
    for (int v = 1; v <= n; v++) {
        for (auto [u, id] : g[v]) {
            memset(used, false, sizeof used);
            dfs(v, id);
            if (used[u]) {
                mx++;
            }
        }
    }
    cout << mx << '\n';
    cout << "1\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve_case();
    }
}