#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <numeric>

using namespace std;

#define ll long long 
#define vc vector
#define str string
#define sz(a) (a).size()
#define its(a) (a).begin(), (a).end()
#define itsr(a) (a).rbegin(), (a).rend()
#define scan(a) for (auto &_i:(a)) cin >> _i;

void solve() {
	ll n, m, G; cin >> n >> m >> G;
	ll cnt = 0;
	vc<ll> used(n);
	vc<pair<ll, ll>> vt;
	for (int i = 0;i < m;++i) {
		ll u, v; cin >> u >> v;
		vt.push_back({ u - 1, v - 1 });
	}
	sort(its(vt), [](auto a, auto b) -> bool {
		return a.second - a.first < b.second - b.first;
		});

	vc<ll> comp(n);
	iota(its(comp), 0);

	vc<vc<ll>> g(n);
	auto dfs = [&](auto dfs, int u) -> void {
		for (auto v : g[u]) {
			if (comp[v] > comp[u]) {
				comp[v] = comp[u];
				dfs(dfs, v);
			}
		}
		};
	for (auto [u, v] : vt) {
		if (comp[u] == comp[v]) ++cnt; 
		else {
			g[u].push_back(v);
			dfs(dfs, u);
		}
	}

	cout << cnt << "\n1";
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll _t = 1;
	//cin >> _t;
	while (_t--)
		solve();
}
