#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <array>
#include <iomanip>
using namespace std;
using ll = long long;
using ld = long double;
#define endl '\n'
const int mod = 1e9 + 7;
vector<int> ord; vector<int> used;
void dfs1(int v, vector<vector<int>> &g, pair<int, int> edg) {
	used[v] = 1;
	for (auto to : g[v]) {
		if (v == edg.first && to == edg.second) continue;
		if (!used[to]) dfs1(to, g, edg);
	}
	ord.push_back(v);
}
void dfs2(int v, int col, vector<vector<int>> &tg, pair<int, int> edg) {
	used[v] = col;
	for (auto to : tg[v]) {
		if (v == edg.second && to == edg.first) continue;
		if (!used[to]) dfs2(to, col, tg, edg);
	}
}
bool cycle(int v, int pr, vector<vector<int>> &g, int tp) {
	cout << used[v] << " " << v << " start_dfs\n";
	used[v] = tp;
	for (auto to : g[v]) {
		if (!used[to]) {
			bool byl = cycle(to, v, g, tp);
			if (byl) return 1;
			continue;
		}
		cout << to << " " << v << " bad_edge\n";
		if (to != pr && used[v] == used[to]) return 1;
	}
	return 0;
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	vector<vector<int>> g, tg, g1;
	int n, m, groop; cin >> n >> m >> groop; g.resize(n); tg.resize(n);
	for (int i = 0; i < m; i++) {
		int u, v; cin >> u >> v; u--; v--; g[u].push_back(v); tg[v].push_back(u);
	}
	int cnt = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < g[i].size(); j++) {
			int u = i, v = g[i][j]; g[i].erase(g[i].begin() + j); g[v].push_back(u);
			tg[i].push_back(v);
			int ps = 0;
			for (; ps < tg[v].size() && tg[v][ps] != u; ps++);
			tg[v].erase(tg[v].begin() + ps);
			used.assign(n, 0); ord.clear();
			for (int p = 0; p < n; p++) {
				if (!used[p]) dfs1(p, g, { -1, -1 });
			}
			reverse(ord.begin(), ord.end()); used.assign(n, 0); int t = 1;
			for (int p = 0; p < n; p++) {
				if (!used[ord[p]]) dfs2(ord[p], t++, tg, { -1, -1 });
			}
			if (t != n + 1) cnt++;
			g[i].insert(g[i].begin() + j, v); g[v].pop_back(); tg[i].pop_back(); tg[v].insert(tg[v].begin() + ps, i);
		}
	}
	cout << cnt << "\n" << 1;
	return 0;
}
