#include <bits/stdc++.h>
#pragma GCC optimize("Ofast", "inline")
#include <ext/pb_ds/assoc_container.hpp>

#define pii pair <int, int>
#define fi first
#define se second
#define pb push_back
#define int int64_t
#define pw(x) (int64_t(1)<<x)

using namespace std;
using namespace __gnu_pbds;

typedef tree <int, null_type, less_equal <int>, rb_tree_tag, tree_order_statistics_node_update> oset;

mt19937 gen(time(0));

const int N = 2e3 + 50;

int fup[N], tin[N], timer = 1;
set <pii> ban;
vector <int> g[N];

vector <int> order;
bool used[N];
vector <int> gr[N];

void topsort (int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (!used[to]) {
            topsort(to);
        }
    }
    order.pb(v);
}

int cl[N], color = 1;
int ans = 0;

void get_ans (int v) {
    cl[v] = 1;
    for (auto to : g[v]) {
        if (!cl[to]) {
            get_ans(to);
        }
        else if (cl[to])
    }
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, group;
    cin >> n >> m >> group;
    vector <pii> edges;
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
        gr[y].pb(x);
        edges.pb({x, y});
    }
    for (int i = 0; i < n; ++i) {
        sort(g[i].begin(), g[i].end());
    }
    vector <vector <int>> dist(n, vector <int> (n, INF));
    for (int i = 0; i < n; ++i) {
        queue <int> q;
        q.push(i);
        dist[i][i] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (auto to : g[v]) {
                if (dist[i][to] > dist[i][v] + 1) {
                    dist[i][to] = dist[i][v] + 1;
                    q.push(to);
                }
            }
        }
    }
    int k = 0;
    for (int i = 0; i < n; ++i) {
        for (auto to : g[i]) {
            for (auto TO : g[i]) {
                if (dist[TO][to] != INF) {
                    k++;
                    break;
                }
            }
        }
    }
    cout << k << '\n' << -1;
}
