#include <bits/stdc++.h>

using ll = long long;
using namespace std;

void dfs(ll num, vector <vector <ll>> &gr, vector <ll> &topsort, vector <ll> &vis) {
    vis[num] = 1;
    for (ll next : gr[num]) {
        if (!vis[next]) {
            dfs(next, gr, topsort, vis);
        }
    }
    topsort.push_back(num);
}
const ll len = 2000;
void dfs1(ll num, vector <vector <ll>> &gr, vector <ll> &vis, ll &ans, vector <bitset <len>> &now) {
    vis[num] = 1;
    now[num][num] = 1;
    vector <ll> list{};
    for (ll next : gr[num]) {
        if (!vis[next]) {
            dfs1(next, gr, vis, ans, now);
            now[num] |= now[next];
        } else {
            list.push_back(next);
        }
    }
    for (ll next : list) {
        if (now[num][next]) {
            ++ans;
        }
    }
}
void solve() {
    ll n, m, g;
    cin >> n >> m >> g;
    vector <vector <ll>> gr(n);
    for (ll i = 0; i < m; ++i) {
        ll a, b;
        cin >> a >> b;
        --a;
        --b;
        gr[a].push_back(b);
    }
    vector <bitset <len>> now(n);
    vector <ll> topsort{}, vis(n, 0);
    for (ll i = 0; i < n; ++i) {
        if (!vis[i]) {
            dfs(i, gr, topsort, vis);
        }
    }
    ll ans = 0;
    reverse(topsort.begin(), topsort.end());
    fill(vis.begin(), vis.end(), 0);
    for (ll num : topsort) {
        if (!vis[num]) {
            dfs1(num, gr, vis, ans, now);
        }
    }
    cout << ans << " " << 1 << '\n';
}
signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    solve();
}
