#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <experimental/random>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3,unroll-loops")
using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using str = string;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;
const ll INF = 1e18, MOD = 1e9 + 7;
#define int long long

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
    //cin >> _;
    while (_--) {
        solve();
        cout << "\n";
    }
}

vector<vector<int>> g;
vector<bool> us;

void dfs(int u) {
    us[u] = true;
    for (auto to: g[u]) {
        if (!us[to]) {
            dfs(to);
        }
    }
}

void solve() {
    int n, m, gg;
    cin >> n >> m >> gg;
    vector<pair<int, int>> edge;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        edge.push_back({u, v});
    }
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        g.clear();
        g.resize(n);
        us.clear();
        us.resize(n);
        for (int j = 0; j < m; ++j) {
            if (j != i) {
                g[edge[j].first].push_back(edge[i].second);
            }
        }
        dfs(edge[i].first);
        if (us[edge[i].second]) {
            cnt++;
        }
    }
    cout << cnt << " 1";
}