#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()

using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

void dfs(int s, vector<vector<int>> &g, vector<int> &u, vector<int> &t) {
    u[s] = 1;
    for (int i: g[s]) {
        if (!u[i]) {
            dfs(i, g, u, t);
        }
    }
    t.push_back(s);
}

void dfs(int s, vector<vector<int>> &g, vector<int> &u) {
    for (int i: g[s]) {
        if (u[i] == -1) {
            u[i] = u[s];
            dfs(i, g, u);
        }
    }
}

vector<int> get(int n, int m, vector<pair<int, int>> &e, int ind) {
    vector<vector<int>> g(n), g1(n);
    for (int i = 0; i < m; i++) {
        auto [a, b] = e[i];
        if (!((ind >> i) & 1)) {
            g[a].push_back(b);
            g1[b].push_back(a);
        } else {
            g[b].push_back(a);
            g1[a].push_back(b);
        }
    }
    vector<int> u(n), t;
    for (int i = 0; i < n; i++) {
        if (!u[i])
            dfs(i, g1, u, t);
    }
    reverse(all(t));
    vector<int> u1(n, -1);
    int cnt = 0;
    for (int i: t) {
        if (u1[i] == -1) {
            u1[i] = cnt++;
            dfs(i, g, u1);
        }
    }
    vector<int> mn(cnt, 1e9);
    for (int i = 0; i < n; i++)
        mn[u1[i]] = min(mn[u1[i]], i);
    for (int i = 0; i < n; i++)
        u1[i] = mn[u1[i]];
    return u1;
}

void solve() {
    int n, m, G;
    cin >> n >> m >> G;
    vector<vector<int>> g(n);
    vector<pair<int, int>> e;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        e.push_back({a - 1, b - 1});
        g[a - 1].push_back(b - 1);
    }
    auto u = get(n, m, e, 0);
    vector<int> s((1 << m));
    for (int i = 0; i < (1 << m); i++)
        s[i] = u == get(n, m, e, i);
    vector<vector<int>> dp(m + 1, vector<int>(1 << m));
    dp[0] = s;
    for (int i = 1; i <= m; i++) {
        for (int j = 0; j < (1 << m); j++) {
            if ((j >> (i - 1)) & 1)
                dp[i][j] += dp[i - 1][j ^ (1 << (i - 1))];
            dp[i][j] += dp[i - 1][j];
        }
    }
    int mx = 0, cnt = 0;
    for (int mask = 0; mask < (1 << m); mask++) {
        if (dp[m][mask] == 1) {
            int c = 0;
            for (int i = 0; i < m; i++)
                c += ((mask >> i) & 1);
            mx = max(mx, c);
        }
    }
    for (int mask = 0; mask < (1 << m); mask++) {
        if (dp[m][mask] == 1) {
            int c = 0;
            for (int i = 0; i < m; i++)
                c += ((mask >> i) & 1);
            if (c == mx) {
                cnt++;
            }
        }
    }
    cout << mx << ' ' << cnt << '\n';
}