#include <bits/stdc++.h>
#include "ext/pb_ds/assoc_container.hpp"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

#define all(a) a.begin(), a.end()

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBCXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}

const ll MOD = 1e9 + 9;

void solve() {
    int n, m, G;
    cin >> n >> m >> G;
    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
    }
    vector<vector<ll>> cnt(n, vector<ll>(n));
    for (int i = 0; i < n; i++) {
        cnt[i][i] = 1;
        for (int j = 0; j < n; j++) {
            for (int k: g[j]) {
                cnt[i][k] += cnt[i][j];
                cnt[i][k] %= MOD;
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j: g[i]) {
            if (cnt[i][j] != 1)
                ans++;
        }
    }
    cout << ans << " 1" << '\n';
}