#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m, g; cin >> n >> m >> g;
    vector<vector<int>> graph(n);
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        graph[u].emplace_back(v);
    }
    int64_t ans = 0;
    for (int u = 0; u < n; ++u) {
        for (auto v : graph[u]) {
            vector<bool> can(n, false);
            queue<int> q;
            for (auto h : graph[u]) if (h!=v) q.push(h);
            while (!q.empty()) {
                int i = q.front(); q.pop();
                can[i] = true;
                for (auto j : graph[i]) {
                    if (!can[j]) q.push(j);
                }
            }
            ans += can[v];
        }
    }
    cout << ans << ' ' << 1 << '\n';

    return 0;
}
