#include <bits/stdc++.h>
#define int long long

using namespace std;

const int inf = 1e18;

vector<vector<int>> g, g0;
vector<vector<int>> used;
vector<int> us;
vector<pair<int, int>> e;
int n, m;
void dfs1(int v, int s) {
    used[s][v] = true;
    for (auto u: g[v]) {
        if (!used[s][u]) {
            dfs1(u, s);
        }
    }
}
void dfs2(int v) {
    us[v] = true;
    for (auto u: g0[v]) {
        if (!us[u]) {
            dfs2(u);
        }
    }
}
int cnt(int mask) {
    g.assign(n, {});
    g0.assign(n, {});
    used.assign(n, vector<int>(n, 0));
    us.assign(n, 0);
    for (int i = 0; i < m; ++i) {
        auto [v, u] = e[i];
        if ((mask >> i) & 1) {
            g[u].push_back(v);
        } else {
            g[v].push_back(u);
        }
    }
    for (int i = 0; i < n; ++i) {
        dfs1(i, i);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (used[i][j] && used[j][i]) {
                g0[i].push_back(j);
                g0[j].push_back(i);
            }
        }
    }
    int c = 0;
    for (int i = 0; i < n; ++i) {
        if (!us[i]) {
            ++c;
            dfs2(i);
        }
    }
    return c;
}

void solve() {
    n, m, grp; cin >> n >> m >> grp;
    e.resize(m);
    for (int i = 0; i < m; ++i) {
        int v, u; cin >> v >> u;
        e[i] = {v - 1, u - 1};
    }
    int ans = 0, d, da = cnt(0);
    vector<int> pr;
    for (int mask = 1; mask < (1 << m); ++mask) {
        int cc= cnt(mask);
        if (cc == da) {
            pr.push_back(mask);
        }
    }
    for (int mask = 0; mask < (1 << m); ++mask) {
        bool good = true;
        for (auto k: pr) {
            if (mask | k == mask) {
                good = false;
                break;
            }
        }
        if (good) {
            ans = max(ans, (int) __builtin_popcount(mask));
        }
    }
    cout << ans << '\n';
    cout << 1 << '\n';
}

signed main(void) {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0); cout.tie(0);
    int n = 1;
    for (int i = 0; i < n; ++i) {
        solve();
    }
}