#ifndef LOCAL
#pragma GCC optimize("O3")
#endif

#include <bits/extc++.h>

using namespace std;


using namespace __gnu_pbds;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
const ll nMax = 2000;
vector<int> g[nMax];
vector<int> gr[nMax];
vector<int> gf[nMax];
bitset<nMax> avail[nMax];
const int mod = 1e9 + 7;
void dfs(int v,int gy){
    avail[gy][v] = true;
    for(auto u : gr[v]){
        if(avail[gy][u])continue;
        dfs(u,gy);
    }
}
void solve() {
    ll n, m, gg;
    cin >> n >>  m >> gg;
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        gr[v].push_back(u);
        gf[u].push_back(v);
        gf[v].push_back(u);
    }
    int amt = 0;
    for(int i =1; i <=n; i++)dfs(i,i);
    for(int i =1; i <=n; i++){
        for(auto u : gr[i])if(avail[i][u])amt++;
    }
    ll ans = 1;
    for(int i = 0; i < amt; i++){
        ans = (ans * 2) % mod;
    }
    cout << amt << '\n' << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    int tt=1;
    //cin >> tt;
    while (tt--)solve();
}