#ifndef LOCAL
#pragma GCC optimize("O3")
#endif

#include <bits/extc++.h>

using namespace std;


using namespace __gnu_pbds;
using oset = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
const ll nMax = 2000 + 228;
const ll mod = 1e9 + 7;
ll a[nMax];
ll diff[nMax];
ll longestway[nMax][nMax];
ll pows[nMax];
vector<int> g[nMax];
ll sinks[nMax];
ll basesinks[nMax];
bool used[nMax];

void dfs1(int v) {
    used[v] = true;
    for (auto u: g[v]) {
        if (used[u])continue;
        sinks[u]++;
        dfs1(u);
    }
}

void dfs(int v, int par) {
    sinks[v] = -1e9;
    for (auto u: g[v]) {
        sinks[u]--;
        longestway[par][u] = max(longestway[par][u], longestway[par][v] + 1);
        if (sinks[u] == 0)dfs(u, par);
    }
}

void solve() {
    pows[0] = 1;
    for (int i = 1; i < nMax; i++)pows[i] = (2 * pows[i - 1]) % mod;
    ll n, m, gg;
    cin >> n >> m >> gg;
    set<pair<int, int>> segs;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        if (v - u != 1 && !(v == n - 1 && u == 0))segs.insert({u, v});
        g[u].push_back(v);
        basesinks[v]++;
    }
    vector<pair<int, int> > segs2;
    for (auto o: segs)segs2.push_back(o);
    for (auto o: segs2) {
        for (auto u: segs2) {
            if (u == o)continue;
            if (o.first < o.second)
                if (o.first <= u.first && o.second >= u.second && u.first < u.second)segs.erase(u);
                else if ((u.second > u.first && o.first < u.first) || (u.second > u.first && o.second > u.second) ||
                         (u.second < u.first))
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++)used[j] = sinks[j] = 0;
        dfs1(i);
        dfs(i, i);
    }
    int amt = 0;
    for (int i = 0; i < n; i++) {
        for (auto u: g[i]) {
            if (longestway[i][u] > 1)amt++;
        }
    }
    ll ans = 1;
    for (int i = 0; i < amt; i++) {
        ans *= 2;
        ans %= mod;
    }
    cout << amt << ' ' << 1;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);
    int tt = 1;
    //cin >> tt;
    while (tt--)solve();
}