#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <random>
#include <chrono>
using namespace std;
typedef long long ll;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
ll n, m, G;
vector<vector<ll>> g;
vector<ll> u;
void dfs(ll v) {
	u[v] = 1;
	for (auto to : g[v]) {
		if (!u[to]) dfs(to);
	}
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> m >> G;
	g.resize(n);
	vector<pair<ll, ll>> e;
	for (ll i = 0; i < m; ++i) {
		ll u, v;
		cin >> u >> v;
		g[--u].push_back(--v);
		e.push_back({ u, v });
	}
	ll ans = 0;
	vector<vector<ll>> g0 = g;
	for (ll i = 0; i < m; ++i) {
		g.assign(n, {});
		for (ll j = 0; j < m; ++j) {
			if (j != i) g[e[j].first].push_back(e[j].second);
		}
		u.assign(n, 0);
		dfs(e[i].first);
		if (u[e[i].second]) ++ans;
	}
	cout << ans << "\n1";
	cout << endl;
	return 0;
}