#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
#define int long long
constexpr int INF = 1e18;
constexpr int MOD = 1e9 + 7;
//mt19937_64 rnd(0);

vector<vector<int>> g, gr, kond;
vector<int> order, order2, num;
vector<int> used;
int c = 0;

void topsort(int v) {
    used[v] = c;
    for (auto to : gr[v]) {
        if (used[to] != c) {
            topsort(to);
        }
    }
    order.push_back(v);
}

void nw(int v, vector<vector<int>> &gr2) {
    used[v] = c;
    for (auto to : gr2[v]) {
        if (used[to] != c) {
            nw(to, gr2);
        }
    }
    order2.push_back(v);
}

void solve() {
    int n, m, group;
    cin >> n >> m >> group;
    g.assign(n, {});
    gr.assign(n, {});
    used.assign(n, c);
    vector<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        edges.push_back({u, v});
        g[u].push_back(v);
        gr[v].push_back(u);
    }
    c++;
    for (int i = 0; i < n; ++i) {
        if (used[i] != c) {
            topsort(i);
        }
    }
    int ans = 0, cnt = 0;
    for (int mask = 0; mask < (1 << m); ++mask) {
        vector<vector<int>> gr2(n);
        vector<pair<int, int>> dilya;
        for (int i = 0; i < m; ++i) {
            if ((mask >> i) & 1) {
                dilya.push_back(edges[i]);
            } else {
                gr2[edges[i].second].push_back(edges[i].first);
            }
        }
        int tmp = 0;
        for (int mask2 = 0; mask2 < (1 << dilya.size()); ++mask2) {
            for (int i = 0; i < dilya.size(); ++i) {
                if ((mask2 >> i) & 1) {
                    gr2[dilya[i].second].push_back(dilya[i].first);
                } else {
                    gr2[dilya[i].first].push_back(dilya[i].second);
                }
            }
            order2.clear();
            c++;
            for (int i = 0; i < n; ++i) {
                if (used[i] != c) {
                    nw(i, gr2);
                }
            }
            for (int i = 0; i < dilya.size(); ++i) {
                if ((mask2 >> i) & 1) {
                    gr2[dilya[i].second].pop_back();
                } else {
                    gr2[dilya[i].first].pop_back();
                }
            }
            if (order == order2) {
                tmp++;
            }
        }
        if (tmp == 1) {
            if (ans < dilya.size()) {
                ans = dilya.size();
                cnt = 1;
            } else if (ans == dilya.size()) {
                cnt++;
            }
        }
    }
    cout << ans << "\n" << cnt % MOD << "\n";
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
#ifdef MULTY
    cin >> t;
#endif
    while (t--) {
        solve();
    }

    return 0;
}