#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

int get(int u, int p, vector<vector<int>>& v,vector<int>&used) {
	used[u] = 1;
	int cnt = 0;
	for (int x : v[u]) {
		if (x != p) {
			if (x < p) {
				if (used[x] == 1) {
					cnt++;
				}
			}
			else {
				if (used[x] != 2) {
					cnt += get(x, u, v, used);
				}
			}
		}
	}
	used[u] = 2;
	return cnt;
}



bool comp(pair<int, int>a, pair<int, int> b) {
	if (a.first != b.first) {
		return a.first > b.first;
	}
	return a.second < b.second;
}
int32_t main() {
	int n, m, g;
	cin >> n >> m >> g;
	vector<vector<int>>v(n);
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		v[x].push_back(y);
		v[y].push_back(x);
	}
	vector<int>used(n);
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		if (used[i] == 0) {
			ans += get(i, i, v, used);
		}
	}
	cout << ans << '\n' << 1;
	return 0;
}