//#pragma GCC optimize("O3,unroll-loops,inline")

#include <bits/allocator.h>

//#pragma GCC target("avx2,popcnt")

#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
using ll = long long;
using ull = unsigned long long;

mt19937 rnd(228);

vector<int> o, pl;
vector<bool> used;
vector<vector<int>> gr, rg;
vector<int> c;

void topsort(int v) {
    used[v] = 1;
    for (int u : gr[v])
        if (!used[u])
            topsort(u);
    pl[v] = o.size();
    o.push_back(v);
}

void hui(int v, int t) {
    c[v] = t;
    for (int u : rg[v])
        if (c[u] == -1)
            hui(u, t);
}

vector<int> r() {
    int n = gr.size();
    c.assign(n, -1);
    pl.assign(n, 0);
    used.assign(n, false);
    o.clear();
    for (int i = 0; i < n; ++i)
        if (!used[i])
            topsort(i);
    rg.assign(n, vector<int>());
    for (int i = 0; i < n; ++i)
        for (int j : gr[i])
            rg[j].push_back(i);
    int cnt = 0;
    reverse(all(o));
    for (int i : o)
        if (c[i] == -1)
            hui(i, cnt++);
    return c;
}

bool check(vector<int> a, vector<int> b) {
    int n = a.size();
    vector<int> next(a.size(), -1);
    for (int i = 0; i < n; ++i)
        if (next[a[i]] != -1 && next[a[i]] != b[i])
            return false;
        else
            next[a[i]] = b[i];
    return true;
}

void solve() {
    int n, m, g;
    cin >> n >> m >> g;
    vector<pair<int, int>> e;
    for (int i = 0, u, v; i < m; ++i) {
        cin >> u >> v;
        --u, --v;
        e.push_back({u, v});
    }
    gr.resize(n);
    for (int i = 0; i < m; ++i)
        gr[e[i].first].push_back(e[i].second);
    auto cc = r();
    int ans = 0, cnt = 0;
    vector<int> bad(1 << m, true);
    for (int mask = 0; mask < (1 << m); ++mask) {
        for (int i = 0; i < n; ++i)
            gr[i].clear();
        for (int i = 0; i < m; ++i)
            if (mask & (1 << i))
                gr[e[i].second].push_back(e[i].first);
            else
                gr[e[i].first].push_back(e[i].second);
        auto ccc = r();
        if (check(ccc, cc) && check(cc, ccc))
            bad[mask] = false;
    }
    bad[0] = 1;
    for (int mask = 0; mask < (1 << m); ++mask) {
        for (int i = 0; i < m; ++i)
            if (mask & (1 << i))
                bad[mask] &= bad[mask ^ (1 << i)];
        if (bad[mask]) {
            if (ans < __builtin_popcount(mask)) {
                ans = __builtin_popcount(mask);
                cnt = 0;
            }
            if (ans == __builtin_popcount(mask)) {
                ++cnt;
            }
        }
    }
    cout << ans << '\n' << cnt;
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
//     cin >> t;
    while (t--) solve();
//    cerr << fixed << setprecision(10) << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
}
