#include <bits/stdc++.h>
using namespace std;

vector<int> used;

void dfs(int v, int id, vector<vector<pair<int, int>>> & g) {
    used[v] = 1;
    for (auto & [u, w] : g[v]) {
        if (!used[u] && w != id) {
            dfs(u, id, g);
        }
    }
}

bool check(int n, int m, int id, vector<vector<pair<int, int>>> & g) {
    used.assign(n, 0);
    dfs(0, id, g);
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        cnt += used[i];
    }
    return cnt == n;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m, G; cin >> n >> m >> G;
    used.resize(n);
    vector<vector<pair<int, int>>> g(n), invg(n);
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        g[u - 1].push_back({v - 1, i});
        invg[v - 1].push_back({u - 1, i});
    }
    int ans = m;
    for (int i = 0; i < m; ++i) {
        if (check(n, m, i, invg)) {
            --ans;
        }
    }
    cout << ans << " " << 1 << "\n";
    return 0;
}
