#include <bits/stdc++.h>

using ll = long long;

using namespace std;

#define int ll

int ans;

vector<vector<pair<int, int>>> g;
vector<int> cnt;
vector<int> used;

vector<int> dfs(int v) {
    vector<int> longest;
    for (auto [u, i] : g[v]) {
        if (!used[i]) {
            auto lol = dfs(u);
            lol.push_back(i);
            if (lol.size() > longest.size()) {
                swap(lol, longest);
            }
        }
    }
    return longest;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int n, m, gr;
    cin >> n >> m >> gr;
    assert(gr == 3 || gr == 4);
    ans = m;
    g.resize(n);
    cnt.assign(n, 0);
    used.assign(m, 0);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back({u, i});
        cnt[u]++;
    }
    for (int i = 0; i < n; i++) {
        if (cnt[i] == 0) {
            for (auto x : dfs(i)) {
                used[x] = 1;
            }
        }
    }
    ans -= accumulate(used.begin(), used.end(), int(0));
    cout << ans << " " << 1;

    cout << "\n";
    return 0;
}