#include <bits/stdc++.h>

using ll = long long;

using namespace std;

#define int ll

int ans;

vector<vector<pair<int, int>>> g;
vector<vector<pair<int, int>>> gr;
vector<int> cnt;
vector<int> used;
vector<pair<int, int>> edges;

const int INF = LLONG_MAX / 2;


signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int n, m, group;
    cin >> n >> m >> group;
    assert(group == 3 || group == 4);
    ans = 0;
    g.resize(n);
    gr.resize(n);
    used.assign(m, 0);
    vector<int> clown(m, 0);
    vector<vector<int>> mt(n, vector<int>(n));
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        edges.push_back({v, u});
        g[v].push_back({u, i});
        gr[u].push_back({v, i});
        mt[v][u] = i + 1;
    }
    for (int i = 0; i < n; i++) {
        vector<int> dp(n, -INF);
        vector<int> prev(n, -1);

        dp[i] = 0;

        int mx = i;

        for (int u = 0; u < n; u++) {
            for (auto [v, i] : gr[u]) {
                if (dp[v] != -INF && dp[v] + 1 > dp[u]) {
                    dp[u] = dp[v] + 1;
                    prev[u] = i;
                    if (dp[u] > dp[mx]) {
                        mx = u;
                    }
                }
            }
        }
        vector<int> usd(m);
        for (int u = 0; u < n; u++) {
            if (dp[u] != -INF && dp[u] > 1 && mt[i][u]) {
                int cur = u;
                while (prev[cur] != -1 && !usd[prev[cur]]) {
                    usd[prev[cur]] = 1;
                    cur = edges[prev[cur]].first;
                }
                clown[mt[i][u] - 1] = 1;
            }
        }
        for (int i = 0; i < m; i++) {
            used[i] |= usd[i];
        }
    }

    ans -= accumulate(used.begin(), used.end(), int(0));
    cout << accumulate(clown.begin(), clown.end(), int(0)) << " " << 1;

    cout << "\n";
    return 0;
}