#include <bits/extc++.h>
using namespace std;
#define int long long
const int MAX_N = 2007;
vector<int> g[MAX_N], ng[MAX_N];
pair<int, int> sp[MAX_N];
bitset<MAX_N> rw[MAX_N];
int cn[MAX_N][MAX_N];
int p[MAX_N], np[MAX_N];
void dfs(int v, int root){
    rw[root][v] = true;
    for(auto u:g[v]){
        if(rw[root][u]){
            continue;
        }
        dfs(u, root);
    }
}
void dfs_s(int v, int root){
    //cout << v << " " << root << " ad\n";
    rw[root][v] = true;
    for(auto u:ng[v]){
        //cout << u << " " << root << " w\n";
        if(rw[root][u]){
            //cout << u << " " << root << " d\n";
            continue;
        }
        dfs_s(u, root);
    }
}
void solve(){
    int n, m, G;
    cin >> n >> m >> G;
    for(int i = 0; i < m; i++){
        int u, v;
        cin >> u >> v;
        u--;v--;
        g[u].push_back(v);
        sp[i] = {u, v};
    }
    for(int i = 0; i < n; i++){
        rw[i][i] = true;
        dfs(i, i);
    }
    for(int i = 0; i < n; i++){
        p[i] = i;
    }
    for(int i = 0; i < n; i++){
        for(int j = i + 1; j < n; j++){
            if(rw[i][j] && rw[j][i]){
                p[j] = p[i];
            }
        }
    }
    int mx = -1, cntmx = 0;
    for(int i = 0; i < (1 << m); i++){
        int cnt = 0;
        for(int j = 0; j < m; j++){
            cnt += (i >> j) & 1;
        }
        bool nf = true;
        for(int j = 1; j < (1 << cnt); j++){
            for(int l = 0; l < n; l++){
                ng[l].clear();
                rw[l] = 0;
            }
            int k = 0;
            for(int e = 0; e < m; e++){
                if((i >> e) & 1){
                    //cout << e << " " << j << " " << k << "\n";
                    if((j >> k) & 1){
                        //cout << sp[e].second << " " << sp[e].first << "\n";
                        ng[sp[e].second].push_back(sp[e].first);
                    }
                    else{
                        ng[sp[e].first].push_back(sp[e].second);
                    }
                    k++;
                }
                else{
                    ng[sp[e].first].push_back(sp[e].second);
                }
            }
            for(int u = 0; u < n; u++){
                dfs_s(u, u);
            }
            for(int u = 0; u < n; u++){
                np[u] = u;
            }
            for(int u = 0; u < n; u++){
                for(int y = u + 1; y < n; y++){
                    if(rw[u][y] && rw[y][u]){
                        np[y] = np[u];
                    }
                }
            }
            //cout << i << " " << j << "\n";
            //cout << rw[1][2] << " " << rw[2][1] << "\n";
            /*for(int v = 0; v < n; v++){
                cout << v << ": ";
                for(auto u:ng[v]){
                    cout << u << " ";
                }
                cout << "\n";
            }*/
            bool f = true;
            for(int u = 0; u < n; u++){
                //cout << np[u] << " ";
                if(p[u] != np[u]){
                    f = false;
                }
            }
            //cout  << "\n";
            if(f){
                nf = false;
                break;
            }
        }
        if(nf){
            if(cnt > mx){
                mx = cnt;
                cntmx = 0;
            }
            if(cnt == mx){
                cntmx++;
            }
        }
    }
    cout << mx << "\n" << cntmx << "\n";
}
signed main() {
    ios::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int tim = clock();
    int tt =  1;
    //cin >> tt;
    while(tt--){
        solve();
    }
    //cout << (long double)(clock() - tim) / CLOCKS_PER_SEC << "\n";
}
/*
5 4 0
1 2
2 3
3 4
4 5
 */