#include <bits/stdc++.h>
// #pragma GCC optimize("O3")
// #pragma GCC target("avx2")
#define LOCAL

// std::mt19937 rnd(time(0));

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    #ifdef LOCAL
        std::freopen("input.txt", "r", stdin);
        std::freopen("output.txt", "w", stdout);
    #endif

    int t = 1;
    // std::cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}

int rec(int curState, int who, std::vector <int>& a, std::vector <int>& b, int n) {
    if (curState == n) return 0;

    if (b[curState] < a[curState]) {
        return 1;
    } else {
        int r1 = rec(curState + 1, (a[curState + 1] - a[curState] + who) & 1, a, b, n);
        if (((a[curState + 1] - a[curState] + who) & 1) != who) r1 = 1 - r1;

        for (auto &i : a) {
            if (b[curState] < i) {
                ++i;
            }
        }
        for (auto &j : b) {
            if (b[curState] < j) {
                ++j;
            }
        }

        int r2 = rec(curState + 1, (a[curState + 1] - a[curState] + who) & 1, a, b, n);
        if (((a[curState + 1] - a[curState] + who) & 1) != who) r2 = 1 - r2;

        for (auto &i : a) {
            if (b[curState] < i) {
                --i;
            }
        }
        for (auto &j : b) {
            if (b[curState] < j) {
                --j;
            }
        }

        return r1 || r2;
    }
}

void solve() {
    int n, m;
    std::cin >> n >> m;

    std::vector <int> type(2 * n + m);

    std::vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
        --a[i];
        type[a[i]] = 1;
    }

    std::vector <int> b(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> b[i];
        --b[i];
        type[b[i]] = 2;
    }

    std::vector <int> c(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> c[i];
        --c[i];
        type[c[i]] = 3;
    }

    std::ranges::sort(a);
    std::ranges::sort(b);
    std::ranges::sort(c);

    if (n <= 20) {
        a.push_back(2 * n + m);
        int r = rec(0, 0, a, b, n);
        if (((a[0] & 1) && !r) || (!(a[0] & 1) && r)) {
            std::cout << "First";
        } else {
            std::cout << "Second";
        }
        return;
    }
}