#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag,
        tree_order_statistics_node_update>;
template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag,
        tree_order_statistics_node_update>;

#define int long long

vector<vector<int>> g, gr;
vector<int> used, ord;

void dfs(int v) {
    used[v] = 1;
    for (auto to: g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    ord.push_back(v);
}

int curr = 1;
vector<int> cmp;

void dfs1(int v) {
    cmp[v] = curr;
    for (auto to: gr[v]) {
        if (!cmp[to]) {
            dfs1(to);
        }
    }
}

bool eq(vector<int> a, vector<int> b) {
    int n = a.size();
    vector<int> c(n + 1), d(n + 1);
    for (int i = 0; i < n; ++i) {
        if (c[a[i]] == 0) {
            c[a[i]] = b[i];
        }
        if (c[a[i]] != b[i]) {
            return false;
        }
        if (d[b[i]] == 0) {
            d[b[i]] = a[i];
        }
        if (d[b[i]] != a[i]) {
            return false;
        }
    }
    return true;
}

signed main() {
    int n, m, g1;
    cin >> n >> m >> g1;
    vector<pair<int, int>> ed;
    g.resize(n), gr.resize(n);
    used.resize(n, 0);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        ed.emplace_back(u - 1, v - 1);
        g[u - 1].push_back(v - 1);
        gr[v - 1].push_back(u - 1);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }
    reverse(ord.begin(), ord.end());
    cmp.assign(n, 0);
    for (auto to: ord) {
        if (!cmp[to]) {
            dfs1(to);
            curr++;
        }
    }
    vector<int> tr = cmp;
    vector<int> ban(1 << m, 0);
    for (int mask = 1; mask < (1 << m); ++mask) {
        g.assign(n, {});
        gr.assign(n, {});
        vector<int> rev(m);
        for (int j = 0; j < m; ++j) {
            if ((1 << j) & mask) {
                rev[j] = 1;
            }
        }
        for (int j = 0; j < m; ++j) {
            if (rev[j]) {
                g[ed[j].second].push_back(ed[j].first);
                gr[ed[j].first].push_back(ed[j].second);
            } else {
                g[ed[j].first].push_back(ed[j].second);
                gr[ed[j].second].push_back(ed[j].first);
            }
        }
        ord.clear();
        used.assign(n, 0);
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs(i);
            }
        }
        reverse(ord.begin(), ord.end());
        cmp.assign(n, 0);
        curr = 1;
        for (auto to: ord) {
            if (cmp[to] == 0) {
                dfs1(to);
                curr++;
            }
        }
        if (eq(tr, cmp)) {
            ban[mask] = 1;
        }
    }
    vector<int> gd(1 << m);
    int ans = 0;
    vector<int> answer(m + 1);
    for (int mask = 0; mask < (1 << m); ++mask) {
        int cnt = 0;
        gd[mask] = 1;
        for (int j = 0; j < m; ++j) {
            if ((1 << j) & mask) {
                cnt++;
                if (gd[mask - (1 << j)] == 0) {
                    gd[mask] = 0;
                }
            }
        }
        if (ban[mask] == 1) {
            gd[mask] = 0;
        }
        if (gd[mask]) {
            ans = max(ans, cnt);
            answer[cnt]++;
        }
    }
    cout << ans << "\n" << answer[ans];
    return 0;
}
