#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag,
        tree_order_statistics_node_update>;
template<class T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag,
        tree_order_statistics_node_update>;

#define int long long

vector<vector<int>> g;
vector<int> used;

void dfs(int v) {
    used[v] = 1;
    for (auto to: g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
}

signed main() {
    int n, m, g1;
    cin >> n >> m >> g1;
    vector<pair<int, int>> ed;
    g.resize(n);
    used.resize(n, 0);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        ed.emplace_back(u - 1, v - 1);
        g[u - 1].push_back(v - 1);
    }
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        g.assign(n, {});
        used.assign(n, 0);
        for (int j = 0; j < m; ++j) {
            if (i == j) {
                continue;
            }
            g[ed[j].first].push_back(ed[j].second);
        }
        int s = ed[i].first, t = ed[i].second;
        dfs(s);
        if (used[t]) {
            cnt++;
        }
    }
    cout << cnt << "\n" << 1;
    return 0;
}
