#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <random>
#include <queue>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(3231213214);
const ll INF = 1e18, MOD = 1e9 + 7;

void solve() {
	int n, m, G;
	cin >> n >> m >> G;
	vector<int> cnt(n + 1);
	for (int i = 1; i <= m; i++) {
		int u, v;
		cin >> u >> v;
		cnt[v]++;
	}

	int ans = m - (n - 1) + 1;
	ll ans2 = 1;
	for (int i = 1; i <= n; i++) {
		if (cnt[i] == 0)
			ans--;
		else
			ans2 = ans2 * cnt[i] % MOD;
	}
	cout << ans << ' ' << ans2;
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	solve();
}