
#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using pll = pair<ll, ll>;
#define ve vector
#define pb push_back
#define all(a) a.begin(), a.end()
#define first f
#define second s
using ld = double;
#define int ll
mt19937 rnd(321932);

template<class A>
istream &operator>>(istream &in, ve<A> &a) {
    for (auto &x: a)
        in >> x;
    return in;
}

template<class A>
ostream &operator<<(ostream &out, ve<A> a) {
    for (auto &x: a)
        out << x << ' ';
    return out << '\n';
}

ve<int> x;

struct lct {
    int n;

    struct func {
        ld a, b;

        int get(int i) const {
            return (floor)(a * x[i] + b);
        }
    };

    ve<func> t;

    void add(int v, int l, int r, func nw) {
        int m = (l + r) / 2;
        auto &old = t[v];
        if (old.get(m) < nw.get(m))
            swap(old, nw);
        if (l + 1 == r)
            return;
        if (nw.get(l) >= old.get(l))
            add(2 * v + 1, l, m, nw);
        else if (nw.get(r - 1) >= old.get(r - 1))
            add(2 * v + 2, m, r, nw);
    }

    void add(ld a, ld b) {
        add(0, 0, n, {a, b});
    }

    void add(int v, int l, int r, int ql, int qr, func nw) {
        if (l >= qr || ql >= r)
            return;
        if (ql <= l && r <= qr) {
            add(v, l, r, nw);
            return;
        }
        int m = (l + r) / 2;
        add(2 * v + 1, l, m, ql, qr, nw);
        add(2 * v + 2, m, r, ql, qr, nw);
    }

    void add(int l, int r, ld a, ld b) {
        add(0, 0, n, l, r, {a, b});
    }

    int get(int v, int l, int r, int i) {
        if (l + 1 == r)
            return t[v].get(i);
        int m = (l + r) / 2;
        if (i < m)
            return max(t[v].get(i), get(2 * v + 1, l, m, i));
        else
            return max(t[v].get(i), get(2 * v + 2, m, r, i));
    }

    int get(int i) {
        return (int) get(0, 0, n, i);
    }

    lct() {
        n = x.size();
        t.assign(4 * n, {0, -1e18});
    }
};
ve<set<int>> g;
ve<set<int>> _g;
ve<int> top;
ve<int> used;
int timer = 0;
void dfs(int v) {
    used[v] = timer;
    for (auto &u : g[v]) {
        if (used[u] != timer)
            dfs(u);
    }
    top.pb(v);
}

void _dfs(int v, ve<int> &cmp, int t) {
    cmp[v] = t;
    used[v] = timer;
    for (auto &u : _g[v]) {
        if (used[u] != timer)
            _dfs(u, cmp, t);
    }
}

int find_cmp(int i) {
    int n= g.size();
    g[i].erase((i+1) % n);
    _g[(i+1)%n].erase(i);
    ve<int> cmp(n);
    ++timer;
    top.clear();
    for (int i = 0; i < n; ++i) {
        if (used[i] != timer)
            dfs(i);
    }
    ++timer;
    int cnt = 0;
    for (auto &u : top) {
        if (used[u] != timer) {
            _dfs(u, cmp, cnt++);
        }
    }
    g[i].insert((i+1) % n);
    _g[(i+1)%n].insert(i);
    if (cmp[i] == cmp[(i+1) % n])
        return 0;
    else
        return 1;
}

int32_t main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, G;
    cin >> n >> m >> G;
    g.resize(n);
    _g = g;
    used.assign(n, -1);
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        g[x-1].insert(y-1);
        _g[y-1].insert(x-1);
    }

    int ans = 0;
    for (int i = 0; i < n; ++i)
        ans += find_cmp(i);
    if (ans > 0)
        cout << 1 << ' ' << ans << '\n';
    else
        cout << 0 << ' ' << 1 << '\n';
}
