#pragma GCC optimize("Ofast,inline")

#include <bits/stdc++.h>

using namespace std;

//#define int int64_t
#define fi first
#define se second
mt19937 gen(time(0));

const int N = 2e3 + 12;

int sz[N], pr[N];
int get(int v) {
    return (pr[v] == v ? v : pr[v] = get(pr[v]));
}
void unite(int v, int u) {
    if(sz[v] < sz[u])
        swap(v, u);
    sz[v] += sz[u];
    pr[u] = v;
    return;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, G2;
    cin >> n >> m >> G2;
    vector <pair<int,int>> e;
    for(int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        e.push_back({v, u});
    }
    sort(e.begin(), e.end(), [&](pair <int,int> x, pair <int,int> y) {
        return x.se - x.fi < e.se - y.fi;
    });
    for(int i = 1; i <= n; ++i) {
        pr[i] = i;
        sz[i] = 1;
    }
    int ans = 0;
    for(auto [v, u] : e) {
        v = get(v), u = get(u);
        if(v == u)
            continue;
        ans++;
        unite(v, u);
    }
    cout << ans << ' ' << 1;
    return 0;
}
