// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
// #include <ext/pb_ds/assoc_container.hpp>
// #pragma GCC target("avx2")

using namespace std;
// using namespace __gnu_pbds;

#define int long long
// #define ordered_set tree<int, null_type, less<int>, tree_order_statistics_node_update, rb_tree_tag>

const int mod = 1e9 + 7;
mt19937_64 rnd(1329);


vector<int> comps(vector<vector<int>> &gr) {
    int n = gr.size();
    vector<int> ord;
    vector<bool> used(n);
    auto dfs = [&](auto dfs, int v) -> void {
        used[v] = 1;
        for (auto e : gr[v]) {
            if (used[e]) continue;
            dfs(dfs, e);
        }
        ord.push_back(v);
    };
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        dfs(dfs, i);
    }
    reverse(ord.begin(), ord.end());
    vector<vector<int>> rgr(n);
    for (int i = 0; i < n; ++i) {
        for (auto e : gr[i]) {
            rgr[e].push_back(i);
        }
    }
    vector<int> ans(n);
    int curc = 0;
    used.clear(); used.resize(n);
    for (auto i : ord) {
        if (used[i]) {
            continue;
        }
        curc++;
        vector<int> cur;
        cur.push_back(i);
        used[i] = 1;
        while (cur.size()) {
            int v = cur.back(); cur.pop_back();
            ans[v] = curc;
            for (auto e : rgr[v]) {
                if (used[e]) continue;
                used[e] = 1;
                cur.push_back(e);
            }
        }
    }
    return ans;
}

pair<int, int> solve_s_c_stupid(vector<vector<int>> &gr) {
    int n = gr.size();
    vector<pair<int, int>> edges;
    for (int i = 0; i < n; ++i) {
        // cout << "lol " << i << ' ';
        // for (auto e : gr[i]) cout << e << ' '; cout << endl;
        for (auto e : gr[i]) {
            edges.push_back({i, e});
        }
    }
    int m = edges.size();
    pair<int, int> ans = {0, 1};
    vector<bool> ok(1 << m);
    ok[0] = 1;
    for (int mask = 1; mask < (1 << m); ++mask) {
        int t = __builtin_popcount(mask);
        // if (t < ans.first) continue;
        bool tok = 1;
        for (int i = 0; i < m; ++i) {
            if ((mask >> i) & 1) {
                // cout << "EDGE ";
                // cout << edges[i].first << ' ' << edges[i].second << '\n';
                // for (auto e : gr[edges[i].first]) cout << e << ' '; cout << endl;
                for (int j = 0; ; ++j) {
                    if (gr[edges[i].first][j] == edges[i].second) {
                        gr[edges[i].first].erase(gr[edges[i].first].begin() + j);
                        break;
                    }
                }
                gr[edges[i].second].push_back(edges[i].first);
                if (!ok[(mask ^ (1 << i))]) {
                    tok = 0;
                }
            }
        }
        if (!tok) {
            for (int i = 0; i < m; ++i) {
                if ((mask >> i) & 1) {
                    for (int j = 0; ; ++j) {
                        if (gr[edges[i].second][j] == edges[i].first) {
                            gr[edges[i].second].erase(gr[edges[i].second].begin() + j);
                            break;
                        }
                    }
                    gr[edges[i].first].push_back(edges[i].second);
                }
            }
            continue;
        }
        vector<int> tt = comps(gr);
        // cout << mask << endl;
        // for (auto e : tt) cout << e << ' '; cout << endl;
        if (*max_element(tt.begin(), tt.end()) != 1) {
            if (t > ans.first) {
                ans.first = t;
                ans.second = 0;
            }
            if (t == ans.first) ans.second++;
            ok[mask] = 1;
        }
        
        for (int i = 0; i < m; ++i) {
            if ((mask >> i) & 1) {
                for (int j = 0; ; ++j) {
                    if (gr[edges[i].second][j] == edges[i].first) {
                        gr[edges[i].second].erase(gr[edges[i].second].begin() + j);
                        break;
                    }
                }
                gr[edges[i].first].push_back(edges[i].second);
            }
        }
    }
    return ans;
}

pair<int, int> solve_s_c(vector<vector<int>> &gr) {
    int n = gr.size();
    vector<pair<int, int>> edges;
    for (int i = 0; i < n; ++i) {
        for (auto e : gr[i]) {
            edges.push_back({i, e});
        }
    }
    vector<int> lol(n);
    for (int i = 0; i < n; ++i) lol[i] = rnd();

    int m = edges.size();
    map<int, bool> ct;
    int ans1 = 0, ans2 = 1;
    for (auto e : edges) {
        for (int i = 0; i < gr[e.first].size(); ++i) {
            if (gr[e.first][i] == e.second) {
                swap(gr[e.first][i], gr[e.first].back());
                gr[e.first].pop_back();
                break;
            }
        }
        vector<bool> used(n);
        used[e.first] = 1;
        vector<int> cur;
        cur.push_back(e.first);
        while (cur.size()) {
            int v = cur.back(); cur.pop_back();
            // cout << v << '\n';
            if (v == e.second) break;
            for (auto e : gr[v]) {
                if (!used[e]) {
                    used[e] = 1;
                    cur.push_back(e);
                }
            }
        }
        gr[e.first].push_back(e.second);
        if (used[e.second]) continue;
        gr[e.second].push_back(e.first);
        ans1++;
        continue;
        int hsh = 0;
        for (int i = 0; i < n; ++i) {
            if (used[i] == used[0]) {
                hsh ^= lol[i];
            }
        }
        // cout << e.first << ' ' << e.second << ' ' << hsh << '\n';
        // for (auto e : used) cout << e << ' '; cout << '\n';
        if (ct[hsh]) {
            ans2 *= 2;
            if (ans2 >= mod) ans2 -= mod;
        }
        else {
            ans1++;
        }
    }

    return {ans1, ans2};
}

pair<int, int> solve_single_comp(vector<int> comp, vector<vector<int>> &g) {
    map<int, int> kek;
    for (auto e : comp) kek[e] = kek.size();
    vector<vector<int>> gr(comp.size());
    for (int i = 0; i < comp.size(); ++i) {
        for (auto e : g[comp[i]]) {
            if (kek.find(e) == kek.end()) continue;
            gr[i].push_back(kek[e]);
        }
    }
    return solve_s_c_stupid(gr);
}


vector<vector<int>> lolkek;

pair<int, int> solve_kek(vector<vector<int>> gr) {
    int n = gr.size();
    int ans = 0;
    int ans2 = 1;
    for (int i = 0; i < n; ++i) {
        sort(gr[i].begin(), gr[i].end());
        vector<bool> used(n);
        used[i] = 1;
        for (auto e : gr[i]) {
            if (used[e]) {
                ans += lolkek[i][e];
                continue;
            }
            ans += lolkek[i][e] - 1;
            ans2 *= lolkek[i][e];
            ans2 %= mod;
            vector<int> cur;
            cur.push_back(e);
            used[e] = 1;
            while (cur.size()) {
                int v = cur.back();
                cur.pop_back();
                for (auto e : gr[v]) {
                    if (!used[e]) {
                        used[e] = 1;
                        cur.push_back(e);
                    }
                }
            }
        }
    }
    return {ans, ans2};
}

pair<int, int> solve_lol(vector<vector<int>> &gr, vector<int> &c) {
    int n = gr.size();
    vector<vector<int>> ngr(*max_element(c.begin(), c.end()) + 1);
    // vector<vector<int>> used(n, vector<bool>(n));
    lolkek.clear(); lolkek.resize(n, vector<int>(n));
    for (int i = 0; i < n; ++i) lolkek[i][i] = 1;
    for (int i = 0; i < n; ++i) {
        for (auto e : gr[i]) {
            if (!lolkek[c[i]][c[e]]) {
                ngr[c[i]].push_back(c[e]);
            }
            lolkek[c[i]][c[e]]++;
        }
    }
    return solve_kek(ngr);
}

void solve() {
    int n, m, g;
    cin >> n >> m >> g;
    vector<vector<int>> gr(n);
    vector<pair<int, int>> edges(m);
    int tans = n;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        edges[i] = {a - 1, b - 1};
        gr[a - 1].push_back(b - 1);
        if (b != a + 1 && !(a == n && b == 1)) {
            if (a < b) tans = min(tans, b - a);
            else tans = min(tans, b + n - a);
        }
    }
    cout << n - 1 << '\n' << tans;
    // vector<int> c = comps(gr);
    // for (auto &e : c) --e;
    // // for (auto e : c) cout << e << ' ';
    // pair<int, int> tkek = solve_lol(gr, c);
    // int ans = tkek.first;
    // int T = *max_element(c.begin(), c.end());
    // vector<vector<int>> cmps(T + 1);
    // for (int i = 0; i < n; ++i) cmps[c[i]].push_back(i);
    // int ans2 = tkek.second;
    // for (auto e : cmps) {
    //     pair<int, int> kek = solve_single_comp(e, gr);
    //     ans += kek.first;
    //     ans2 *= kek.second;
    //     ans2 %= mod;
    // }
    // cout << ans << '\n' << ans2 << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}