#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define size(t) (int)t.size()
#define pb push_back
#define all(t) t.begin(), t.end()
#define rall(t) t.rbegin(), t.rend()

using namespace std;

const int N = 2002;
const int MOD = 1e9 + 7;

vector <int> g[2][N];
vector <int> order;
pair<int, int> e[N];
int used[N], cmp[N];

void dfs_o(int i) {
    used[i] = 1;
    for (auto j:g[0][i]) {
        if (!used[j])
            dfs_o(j);
    }
    order.pb(i);
}

void dfs(int i, int c) {
    cmp[i] = c;
    for (auto j:g[1][i]) {
        if (!cmp[j])
            dfs(j, c);
    }
}

mt19937 rnd(time(0));

void solve() {
    int n, m, gr, i, j, k;
    cin >> n >> m >> gr;
    for (k = 0; k < m; k++) {
        cin >> e[k].first >> e[k].second;
        e[k].first --;
        e[k].second --;
    }
    int mask, sub, mxp = (1 << m);
    vector <ll> re(n + 1), b(mxp);
    for (i = 0; i <= n; i++) {
        re[i] = rnd();
    }
    for (mask = 0; mask < mxp; mask++) {
        for (i = 0; i < n; i++) {
            g[0][i].clear();
            g[1][i].clear();
            used[i] = 0;
            cmp[i] = 0;
        }
        for (k = 0; k < m; k++) {
            i = e[k].first; j = e[k].second;
            if ((mask >> k) & 1)
                swap(i, j);
            g[0][i].pb(j);
            g[1][j].pb(i);
        }
        order.clear();
        for (i = 0; i < n; i++) {
            if (!used[i])
                dfs_o(i);
        }
        reverse(all(order));
        int c = 1;
        for (auto i:order) {
            if (!cmp[i])
                dfs(i, c++);
        }
        map <int, int> mp;
        int ptr = 1;
        for (i = 0; i < n; i++) {
            if (mp[cmp[i]] == 0)
                mp[cmp[i]] = ptr++;
        }
        for (i = 0; i < n; i++) {
            cmp[i] = mp[cmp[i]];
        }
        for (i = 0; i < n; i++) {
            b[mask] ^= (re[cmp[i]] * re[i]);
        }
    }
    vector <vector<int>> v(m + 1);
    vector <int> bad;
    v[0].pb(0);
    for (mask = 1; mask < mxp; mask++) {
        v[__builtin_popcount(mask)].pb(mask);
        if (b[mask] == b[0])
            bad.pb(mask);
    }
    int l = -1, r = m + 1, p;
    while (r - l > 1) {
        p = (l + r) / 2;
        int f2 = 0;
        for (auto x:v[p]) {
            int flag = 1;
            for (auto y:bad) {
                if ((x | y) == x) {
                    flag = 0;
                    break;
                }
            }
            if (flag) {
                f2 = 1;
                break;
            }
        }
        if (f2) {
            l = p;
        }
        else {
            r = p;
        }
    }
    p = l;
    int ans = 0;
    for (auto x:v[p]) {
        int flag = 1;
        for (auto y:bad) {
            if ((x | y) == x) {
                flag = 0;
                break;
            }
        }
        ans += flag;
    }
    cout << p << '\n' << ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
