#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <cmath>
#include <map>
#include <iomanip>
#include <queue>
#include <unordered_map>
using namespace std;
using ll = long long;
const ll MOD = 1e9 + 7;
vector<vector<ll>> gr;

void solve() {
	ll n, m, g;
	cin >> n >> m >> g;
	vector<ll> pows(2002);
	pows[0] = 1;
	for (ll i = 1; i < pows.size(); ++i)
		pows[i] = (pows[i - 1] * 2) % MOD;
	pows[0] = 0;
	gr.resize(n);
	ll cnt = 0;
	for (ll i = 0; i < m; ++i) {
		ll a, b;
		cin >> a >> b;
		--a;--b;
		gr[a].push_back(a);
		if (b != a + 1)
			++cnt;
	}
	cout << cnt << endl << pows[cnt] << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false); cin.tie(0);
	ll t = 1;
	// cin >> t;
	while (t--)
		solve();
}