#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <tuple>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int INF = 2 * 1e9;
const ll MAX = 1e15;
const ll MIN = -1e15;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-7;

#define int long long

vector<set<int>> g, dist;
vector<bool> used;

void dfs(int u) {
    used[u] = true;
    for (int v : g[u]) {
        if (!used[v]) dfs(v);
    }
}

void solve() {
    int n, m, q; cin >> n >> m >> q;
    g.assign(n, {});
    vector<pii> edge;
    int ans = 0, cnt = 0;
    for (int i = 0; i < m; i++) {
        int u, v; cin >> u >> v;
        u--, v--;
        g[u].insert(v);
        edge.emplace_back(u, v); 
    }
    for (auto [u, v] : edge) {
        g[u].erase(v);
        g[v].insert(u);
        used.assign(n, false);
        dfs(u);
        if (find(used.begin(), used.end(), true) == used.end()) ans++;

        cout << ans << endl << 1 << endl;
    }


}
signed main() {

    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1; //cin >> t;
    while (t--) solve();
}
