#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll ans;
vector<bool> used;

void dfs(vector<vector<ll>> &g, ll v) {
    used[v] = true;

    for (auto &to: g[v]) {
        if (used[to]) {
            ans++;
        } else {
            dfs(g, to);
        }
    }
}

ll solve(vector<vector<ll>> &g) {
    ll n = ll(g.size());
    for (auto &i: g) {
        sort(i.begin(), i.end());
    }
    used.assign(n, false);
    for (ll i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(g, i);
        }
    }
    return ans;
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, m, hz;
    cin >> n >> m >> hz;
    vector<vector<ll>> g(n);
    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
    }
    cout << solve(g) << '\n' << 1;
}