#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n, m, hz;
    cin >> n >> m >> hz;
    vector<bool> pid(n);
    for (ll i = 0; i < m; i++) {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        if (u == i && v == (i + 1) % n) {
            continue;
        }
        pid[u] = true;
        pid[v] = true;
    }
    if (m == n) {
        cout << n - 1 << '\n' << n;
        return 0;
    }
    ll ans = 0, ans1 = 1;
    for (ll i = 0; i < n; i++) {
        if (pid[i]) {
            ll x = i;
            ll len = 0;
            do {
                len++;
                x = (x + 1) % n;
            } while (!pid[x]);
            ans++;
            ans1 *= len;
        }
    }
    cout << n - ans << '\n' << ans1;
}