#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(vec) vec.begin(), vec.end()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fi first
#define se second
#define int ll

mt19937_64 rnd;

ll INF = 1e9;
ll mod = 1e9+7;

vector<vector<int>> g;
vector<vector<int>> gr;
vector<int> used;
vector<int> cp;
vector<int> cpy;

vector<pii> rebs;

vector<int> tp;
vector<int> tpy;

int comp = 1;

void topsort(int v) {
    used[v] = 1;
    for (auto now : g[v]) {
        if (!used[now]) topsort(now);
    }
    tp.push_back(v);
}

void topsort2(int v) {
    used[v] = 1;
    for (auto now : g[v]) {
        if (!used[now]) topsort2(now);
    }
    tpy.push_back(v);
}

void dfs(int v) {
    cp[v] = comp;
    for (auto now : gr[v]) {
        if (!cp[now]) dfs(now);
    }
}

void dfs2(int v) {
    cpy[v] = comp;
    for (auto now : gr[v]) {
        if (!cpy[now]) dfs2(now);
    }
}


void solve() {
    ll n, m, t;
    cin >> n >> m >> t;
    g.resize(n + 1);
    gr.resize(n + 1);
    used.resize(n + 1);
    cp.resize(n + 1);
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        reb.push_back({u, v});
        g[u].push_back(v);
        gr[v].push_back(u);
    }
    for (int i = 1; i <= n; i++) {
        if (!used[i]) topsort(i);
    }
    reverse(all(tp));
    for (auto now : tp) {
        if (!cp[now]) {
            dfs(now);
            comp++;
        }
    }
    ll ans = 0, calc = 1;
    for (int mask = 0; mask < (1 << m); mask++) {
        bitset<20> MS = mask;
        g.clear();
        gr.clear();
        g.resize(n + 1);
        gr.resize(n + 1);
        used.assign(n + 1, 0);
        cpy.assign(n + 1, 0);
        tpy.clear();
        comp = 0;
        for (int i = 0; i < m; i++) {
            auto [u, v] = rebs[i];
            if (MS[i]) {
                g[u].push_back(v);
                gr[v].push_back(u);
            } else {
                g[v].push_back(u);
                gr[u].push_back(v);
            }
        }

        for (int i = 1; i <= n; i++) {
            if (!used[i]) topsort2(i);
        }
        reverse(all(tpy));
        for (auto now : tpy) {
            if (!cpy[now]) {
                dfs2(now);
                comp++;
            }
        }

        bool f = true;

        for (auto [u, v] : rebs) {
            if (cp[u] == cp[v]) {
                if (cpy[u] != cpy[v]) {
                    f = false;
                    break;
                }
            } else {
                if (cpy[u] == cpy[v]) {
                    f = false;
                    break;
                }
            }
        }

        if (f) {
            ll k = 0;
            for (int i = 0; i < m; i++) {
                if (!MS[i]) k++;
            }
            if (k > ans) {
                ans = k;
                calc = 1;
            } else if (k == ans) calc++;
        }

    }
    cout << ans << " " << calc << '\n';
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);
    //cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
