#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<queue>
#include<deque>
#include<stack>
#include<cmath>
#include<algorithm>
#include<cstdio>
#include<unordered_set>
#include<unordered_map>
#include<iomanip>
#include<random>
#include<bitset>
#include<ctime>

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using uint = unsigned int;

ll gcd(ll a, ll b) {
	return b == 0 ? a : gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}
mt19937 mt(time(0));
const int N = 3e5 + 2, inf = 1e9 + 100, mod = 1e9 + 7, mod2 = 998244353, P = 257;
const ll llinf = 1e18 + 100;
int n, m, a[N];
ll t, pr[N];
int prv[N], nxt[N];;

void solve() {
	cin >> n >> m >> t;
	for (int i = 0; i < n; ++i) cin >> a[i], pr[i + 1] = pr[i] + a[i];
	fill(prv, prv + n, -1);
	fill(nxt, nxt + n, n);
	for (int i = 0; i < m; ++i) {
		int x;
		cin >> x;
		--x;
		prv[x] = x;
		nxt[x] = x;
	}
	for (int i = 1; i < n; ++i) prv[i] = prv[i] == i ? i : prv[i - 1];
	for (int i = n - 2; i >= 0; --i) nxt[i] = nxt[i] == i ? i : nxt[i + 1];
	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		int l = prv[i], r = nxt[i];
		if (l != -1) {
			ll len = pr[i + 1] - pr[l];
			if (len <= t) ans = max(ans, (t - len) / a[i] + (i - l + 1));
		}
		if (r != n) {
			ll len = pr[r + 1] - pr[i];
			if (len <= t) ans = max(ans, (t - len) / a[i] + (r - i + 1));
		}
	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
		cout.flush();
	}
	return 0;
}