#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define int long long

const int MAX = 1e5 + 7;
const int mod = 1e9 + 7;

mt19937_64 rng(time(0));

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n + 1);
    vector<int> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] += pref[i - 1] + a[i];
    }
    int res = 0;
    while (m--) {
        int x;
        cin >> x;
        for (int i = 1; i <= x; i++) {
            if (pref[x] - pref[i - 1] <= t) {
                res = max(res, x - i + 1 + (t - (pref[x] - pref[i - 1])) / a[i]);
            }
        }
        for (int i = x; i <= n; i++) {
            if (pref[i] - pref[x - 1] <= t) {
                res = max(res, i - x + 1 + (t - (pref[i] - pref[x - 1])) / a[i]);
            }
        }
    }
    cout << res;
}

int32_t main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}