#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define int long long

const int MAX = 3e5 + 7;
const int mod = 1e5 + 7;

mt19937_64 rng(time(0));

template <typename T>
bool umx(T& a, T b) {
    return (a <= b ? a = b, 1 : 0);
}

int n, m, t;
int a[MAX];
int pref[MAX];

int f(int i, int j) {
    int need = i;
    if (i > j) {
        swap(i, j);
    }
    if (pref[j] - pref[i - 1] > t) return 0;
    return j - i + 1 + (t - (pref[j] - pref[i - 1])) / a[need];
}

void solve() {
    cin >> n >> m >> t;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] += pref[i - 1] + a[i];
    }
    vector<bool> can(n + 1, 0);
    while (m--) {
        int x;
        cin >> x;
        can[x] = 1;
    }
    int l = 0, r = 2e9;
    while (l < r) {
        int mid = (l + r) / 2;
        bool cann = false;
        int p = 1;
        for (int i = 1; i <= n; i++) {
            while (f(p, i) < mid && p < i) {
                p++;
            }
            if (can[i]) cann |= (f(p, i) >= mid);
        }
        p = n;
        for (int i = n; i >= 1; i--) {
            while (f(p, i) < mid && p > i) {
                p--;
            }
            if (can[i]) cann |= (f(p, i) >= mid);
        }
        if (cann) {
            l = mid + 1;
        } else {
            r = mid;
        }
    }
    cout << l - 1 << '\n';
}

int32_t main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}