#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
using ull = long long;
using ld = long double;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int N = 3e5;
int a[N], b[N], n, m, T, ans;
int pref[N + 1];

void solve() {
    cin >> n >> m >> T;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++i) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        --b[i];
    }
    for (int pos = 0; pos < n; ++pos) {
        auto it = lower_bound(b, b + m, pos) - b;
        if (it < m) {
            int sum = pref[b[it] + 1] - pref[pos];
            if (sum <= T) {
                ans = max(ans, b[it] - pos + 1 + (T - sum) / a[pos]);
            }
        }
        --it;
        if (it >= 0) {
            int sum = pref[pos + 1] - pref[b[it]];
            if (sum <= T) {
                ans = max(ans, pos - b[it] + 1 + (T - sum) / a[pos]);
            }
        }
    }
    cout << ans;
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
