#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

auto seed = std::chrono::steady_clock::now().time_since_epoch().count();
mt19937 rnd(seed);

using ll = long long;

#define int ll

using vi = vector<int>;
using pii = pair<int, int>;
using vp = vector<pair<int, int>>;
using vv = vector<vector<int>>;

template<class T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vi a(n);
    vi b(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        b[i]--;
    }
    b.push_back(-1);
    b.push_back(n);
    std::sort(b.begin(), b.end());
    ll mx = 0;
    vi sml(n);
    vi smr(n);

    int l = 0;
    int tec = 0;
    for (int i = 0; i < n; ++i) {

        tec += a[i];
        while (tec > t) {
            tec -= a[l++];
        }
        sml[i] = l;
    }

    int r = n - 1;
    tec = 0;
    for (int i = n - 1; i >= 0; --i) {
        tec += a[i];
        while (tec > t) {
            tec -= a[r--];
        }
        smr[i] = r;
    }

    vi pr(n + 1);
    for (int i = 0; i < n; ++i) {
        pr[i + 1] = pr[i] + a[i];
    }
    for (int i = 0; i < n; ++i) {
        int j = *--lower_bound(b.begin(), b.end(), i);
        if (j != -1) {
            if (smr[j] >= i) {
                mx = max(mx, i - j + 1 + (t - (pr[i + 1] - pr[j])) / a[i]);
            }
        }
        j = *lower_bound(b.begin(), b.end(), i);
        if (j != n) {
            if (sml[j] <= i) {
                mx = max(mx, j - i + 1 + (t - (pr[j + 1] - pr[i])) / a[i]);
            }
        }
    }
    cout << mx;
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
    freopen("C:\\work\\untitled\\output.txt", "w", stdout);
    auto start = std::chrono::steady_clock::now();
#else
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(0);
#endif
    int t_ = 1;
    //cin>>t;
    while (t_--) {
        solve();
    }

#ifdef LOCAL
    auto end = std::chrono::steady_clock::now();
    cout << "\n======\n";
    cout << chrono::duration_cast<chrono::milliseconds>(end - start);
#endif
}
