#include <bits/extc++.h>

#define SET_MAX(a, b) (((b) > (a)) && ((a) = (b), true))

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, T;
    cin >> n >> m >> T;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    auto p = a;
    for (int i = 1; i < n; i++) {
        p[i] += p[i - 1];
    }
    auto get = [&](int i, int j) {
        return p[j] - (i == 0 ? 0 : p[i - 1]);
    };
    int ans = 0;
    while (m--) {
        int i;
        cin >> i, i--;
        int cur = 0;
        for (int j = 0; j < n; j++) {
            if (j < i) {
                int s = get(j + 1, i);
                if (s <= T) {
                    SET_MAX(cur, i - j + (T - s) / a[j]);
                }
            } else if (i == j) {
                SET_MAX(cur, T / a[i]);
            } else {
                int s = get(i, j - 1);
                if (s <= T) {
                    SET_MAX(cur, j - i + (T - s) / a[j]);
                }
            }
        }
        SET_MAX(ans, cur);
    }
    cout << ans << '\n';
    return 0;
}
