#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
template <typename T>
ll sz(T& a) {
    return (ll)a.size();
}





int main() {
//    cout.setf(ios::fixed); cout.precision(15);
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef manix888
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    int n, m; ll t;
    cin >> n >> m >> t;
    vector<ll> nums(n);
    for (int i=0; i<n; i++) cin >> nums[i];

    vector<int> lefts(n); lefts[0] = 0;
    for (int i=1; i<n; i++) {
        if (nums[i-1]<=nums[i]) lefts[i] = lefts[i-1];
        else lefts[i] = i;
    }
    vector<int> rights(n); rights[n-1] = n-1;
    for (int i=n-2; i>=0; i--) {
        if (nums[i]>=nums[i+1]) rights[i] = rights[i+1];
        else rights[i] = i;
    }

    vector<ll> prefs(n+1);
    for (int i=1; i<=n; i++) prefs[i] = prefs[i-1] + nums[i-1];


    ll mxans = -1e18;
    while (m--) {
        int st; cin >> st; st--;
        // left
        {
            int fin = lefts[st];
            if (prefs[st+1]-prefs[fin] > t) {
                if (nums[st]>t) mxans=max(mxans, 0ll);
                else {
                    int l=fin, r=st;
                    while (l+1 < r) {
                        int mid = (l+r) / 2;
                        if (prefs[st+1]-prefs[mid] <= t) r=mid;
                        else l=mid;
                    }
                    mxans = max(mxans, (ll)st-r+1);
                }
            }
            else {
                ll ans = st-fin+1;
                ll ost = t - (prefs[st+1]-prefs[fin]);
                ans += ost/nums[fin];
                mxans = max(ans, mxans);
            }
        }
        // right
        {
            int fin = rights[st];
            if (prefs[fin+1]-prefs[st] > t) {
                if (nums[st]>t) mxans = max(mxans, 0ll);
                else {
                    int l=st, r=fin;
                    while (l+1 < r) {
                        int mid = (l+r) / 2;
                        if (prefs[mid+1]-prefs[st] <= t) l=mid;
                        else r=mid;
                    }
                    mxans = max(mxans, (ll)l-st+1);
                }
            }
            else {
                ll ans = fin-st+1;
                ll ost = t - (prefs[fin+1]-prefs[st]);
                ans += ost/nums[fin];
                mxans = max(ans, mxans);
            }
        }
    }

    cout << mxans;


    return 0;
}