#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rand1(ll a, ll b) {
    return uniform_int_distribution<ll> (a, b) (gen);
}

void solve() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n);
    for (auto &i : a) cin >> i;
    vector<ll> b(m + 2);
    b[0] = -1;
    b[m + 1] = n;
    for (ll i = 1; i <= m; i++) {
        cin >> b[i];
        b[i]--;
    }
    ll res = 0;
    for (ll i = 1; i <= m; i++) {
        ll csum = 0;
        res = max(res, (t - (t % a[b[i]])) / a[b[i]]);
        for (ll j = b[i] - 1; j >= max(0LL, b[i - 1]) && csum <= t; j--) {
            csum += a[j + 1];
            if (csum > t) continue;
            res = max(res, b[i] - j + (t - csum - ((t - csum) % a[j])) / a[j]);
        }
        csum = 0;
        for (ll j = b[i] + 1; j <= min(b[i + 1], n - 1) && csum <= t; j++) {
            csum += a[j - 1];
            if (csum > t) continue;
            res = max(res, j - b[i] + (t - csum - ((t - csum) % a[j])) / a[j]);
        }
    }
    cout << res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t12 = 1;
//    cin >> t12;
    while (t12--) {
        solve();
        cout << '\n';
    }
    return 0;
}