#include <iostream>
#include <algorithm>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <chrono>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define allv(x) (x).begin(), (x).end()
#define allv_rev(x) (x).rbegin(), (x).rend()
#define lolset(x) memset(x, 0, sizeof (x))
#define lolfill(x, v) fill(x, x + sizeof(x) / sizeof(*x), v)
#define sz(x) ((ll)(x).size())
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<ll, ll>;
using pll = pair<ll, ll>;
mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());
template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &i : v)
        is >> i;
    return is;
}




#ifdef DEBUG
const ll MAXN = 57, INF = 1e6;
#else
const ll MAXN = 3e5 + 10, INF = 1e9 + 1e6 * 228;
#define cerr if (0) cerr
#endif



signed one() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n), b(m);
    cin >> a >> b;
    for (ll &i : b) i--;
    int ans = 0;
    ll cur_pref = 0, cur_cnt = 0;
    for (ll i = 0, j = 0; i < n; i++) {
        if (j + 1 < m && b[j + 1] == i) {
            j++;
            cur_pref = 0;
            cur_cnt = 0;
        }
        cur_pref += a[i];
        cur_cnt++;
        if (cur_pref <= t && b[j] <= i)
            smax(ans, cur_cnt + (t - cur_pref) / a[i]);
    }
    reverse(allv(a));
    reverse(allv(b));
    for (ll &i : b)
        i = n - 1 - i;
    cur_pref = 0;
    cur_cnt = 0;
    for (ll i = 0, j = 0; i < n; i++) {
        if (j + 1 < m && b[j] == i) {
            j++;
            cur_pref = 0;
            cur_cnt = 0;
        }
        cur_pref += a[i];
        cur_cnt++;
        if (cur_pref <= t && b[j] <= i)
            smax(ans, cur_cnt + (t - cur_pref) / a[i]);
    }
    cout << ans << endl;
    return 0;
}



signed main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    signed t;
    t = 1;
    while (t--) {
        signed retcode = one();
        if (retcode) return retcode;
    }
    return 0;
}
