#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC Optimize("O3")
//#pragma GCC Optimize("unroll-loops")
//#pragma GCC target("avx,avx2,bmi")

//using namespace __gnu_pbds;
using namespace std;

//template <class T> using ordered_set = tree<T, null_type, less<T> ,rb_tree_tag,tree_order_statistics_node_update>;
//struct h{
//    size_t operator ()(const pair<int,int>& a) const{
//        return ((size_t)a.first << 32) + a.second;
//    }
//};
void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin>>t;
    while (t--) {
        solve();
    }
    return 0;
}

#define int long long
#define endl '\n'
const int INF = 2e9;
const int MAXN = 3e5+1;
const int MOD = 1e9 + 7;

int tree[MAXN * 4];
int ad[MAXN * 4];
int a[MAXN];
int pref[MAXN];

void build(int t, int l, int r, int k) {
    if (r - l == 1) {
        tree[t] = a[l] * k + pref[l] - l * a[l];
        return;
    }
    int m = (r + l) / 2;
    build(t * 2, l, m,k);
    build(t * 2 + 1, m, r,k);
    tree[t] = min(tree[t * 2], tree[t * 2 + 1]);
}

void push(int t) {
    if (ad[t] != 0) {
        tree[t * 2] += ad[t];
        tree[t * 2 + 1] += ad[t];
        ad[t * 2] += ad[t];
        ad[t * 2 + 1] += ad[t];
        ad[t] = 0;
    }
}

void add(int t, int l, int r, int tl, int tr, int x) {
    if (tl >= l && tr <= r) {
        tree[t] += x;
        ad[t] += x;
        return;
    }
    if (tl >= r || tr <= l) {
        return;
    }
    push(t);
    int m = (tl + tr) / 2;
    add(t * 2,l,r,tl,m,x);
    add(t * 2 + 1,l,r,m,tr,x);
    tree[t] = min(tree[t * 2], tree[t * 2 + 1]);
}

void solve() {
    int n,m,T;
    cin >> n >> m >> T;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        pref[i + 1] = pref[i] + a[i];
    }
    vector<bool> b(n);
    for (int i =0; i < m; i++) {
        int x;
        cin >> x;
        x--;
        b[x]=1;
    }
    vector<int> minl(n,-1);
    vector<int> minr(n);
    int last = -1;
    for (int i = 0; i < n; i++) {
        if (b[i]) {
            minl[i]=i;
            last = i;
        } else {
            minl[i]=last;
        }
    }
    last = -1;
    for (int i = n-1; i >=0;i--) {
        if (b[i]) {
            minr[i]=i;
            last = i;
        } else {
            minr[i]=last;
        }
    }

    int ans = 0;
    for (int i = 0; i < n; i++) {
        if (minr[i] != -1) {
            int d = pref[minr[i]+1] - pref[i+1];
            int cnt = minr[i]-i;
            if (d <= T) {
                ans = max(ans, cnt + (T-d)/a[i]);
            }
        }
        if (minl[i]!=-1) {
            int d = pref[i]-pref[minl[i]];
            int cnt = i-minl[i];
            if (d <= T) {
                ans = max(ans, cnt + (T-d)/a[i]);
            }
        }
    }
    cout << ans;
}
