//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,fma")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>

using namespace std;

long long n, m, t;
vector<long long> v1, v2;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m >> t;

	v1.resize(n);
	v2.resize(n);

	for (long long i = 0; i < n; ++i)
		cin >> v1[i];

	for (long long i = 0; i < n; ++i) {
		long long x3 = t / v1[i], sum = v1[i];
		for (long long j = i + 1; j < n; ++j) {
			x3 = max(x3, j - i + (t - sum) / v1[j]);
			sum += v1[j];
			if (sum >= t)
				break;
		}
		sum = v1[i];
		for (long long j = i - 1; j >= 0; --j) {
			x3 = max(x3, i - j + (t - sum) / v1[j]);
			sum += v1[j];
			if (sum >= t)
				break;
		}
		v2[i] = x3;
	}
	long long ans = 0;
	for (long long i = 0; i < m; ++i) {
		long long a;
		cin >> a;
		--a;
		ans = max(ans, v2[a]);
	}
	cout << ans;
	return 0;
};
