#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <random>
#include <time.h>
#include <climits>
//#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

using namespace std;
using ll = long long;
using ld = long double;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution <> distr(0, INT_MAX);

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	ll t;
	cin >> n >> m >> t;
	vector<ll> a(n), b(m);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	vector<bool> runs(n, 0);
	for (int i = 0; i < m; i++) {
		cin >> b[i];
		runs[b[i] - 1] = 1;
	}
	vector<ll> rmax(n, 0), lmax(n, 0);
	vector<ll> ps(n);
	ps[0] = a[0];
	for (int i = 1; i < n; i++)
		ps[i] = ps[i - 1] + a[i];
	int r = 0;
	for (int l = 0; l < n; l++) {
		r--;
		//cout << l << " " << r << endl;
		ll curmax = 0;
		while (r + 1 < n) {
			r++;
			ll one = 0;
			ll onecnt = 0;
			if (r > l) {
				onecnt = r - l;
				one = ps[r - 1];
				if (l > 0)
					one -= ps[l - 1];
			}
			if (one + a[r] > t)
				break;
			ll left = t - one;
			ll add = left / a[r];
			//cout << onecnt << " " << add << " " << l << " " << r << endl;
			curmax = max(curmax, onecnt + add);
		}
		if (runs[l]) {
			rmax[l] = curmax;
			//cout << curmax << endl;
		}
	}
	reverse(a.begin(), a.end());
	ps[0] = a[0];
	for (int i = 1; i < n; i++)
		ps[i] = ps[i - 1] + a[i];
	r = 0;
	for (int l = 0; l < n; l++) {
		r--;
		//cout << l << " " << r << endl;
		ll curmax = 0;
		while (r + 1 < n) {
			r++;
			ll one = 0;
			ll onecnt = 0;
			if (r > l) {
				onecnt = r - l;
				one = ps[r - 1];
				if (l > 0)
					one -= ps[l - 1];
			}
			if (one + a[r] > t)
				break;
			ll left = t - one;
			ll add = left / a[r];
			//cout << onecnt << " " << add << " " << l << " " << r << endl;
			curmax = max(curmax, onecnt + add);
		}
		if (runs[n - l - 1]) {
			lmax[n - l - 1] = curmax;
			//cout << curmax << endl;
		}
	}
	ll ans = 0;
	for (auto i : rmax)
		ans = max(ans, i);
	for (auto i : lmax)
		ans = max(ans, i);
	cout << ans;
}
