#include <bits/stdc++.h>
#define int long long

using namespace std;

const int inf = 2e18;

void solve() {
    int n, m, t; cin >> n >> m >> t;
    vector<int> a(n), pref(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    auto sum = [&](int l, int r) {
        return pref[r] - pref[l];
    };
    int ans = 0;
    vector<int> b(m);
    for (int i = 0; i < m; ++i) {
        cin >> b[i]; --b[i];
    }
    for (int i = 0; i < n; ++i) {
        int j = lower_bound(b.begin(), b.end(), i) - b.begin();
        if (j < m) {
            if (b[j] == i) {
                ans = max(ans, t / a[i]);
                continue;
            } else {
                int c = sum(i + 1, b[j] + 1);
                if (c <= t) {
                    int cnt = b[j] - i + (t - c) / a[i];
                    ans = max(ans, cnt);
                }
            }
        }
        --j;
        if (j >= 0) {
            int c = sum(b[j], i);
            if (c <= t) {
                int cnt = i - b[j] + (t - c) / a[i];
                ans = max(ans, cnt);
            }
        }
    }
    cout << ans << '\n';
}

signed main(void) {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n = 1;
    for (int i = 0; i < n; ++i) {
        solve();
    }
}