#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = int(1e9) + 7, lg = 20;
const ll inf = ll(2e18) + 36;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n), pf(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        pf[i] = (i ? pf[i - 1] : 0) + a[i];
    }
    vector <ll> b(m);
    for (ll i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
    }
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        auto it = lower_bound(b.begin(), b.end(), i);
        if (it != b.end()) {
            ll j = *it;
            ll S = t - (pf[j] - pf[i]);
            if (S >= 0) {
                ll k = j - i + S / a[i];
                ans = max(ans, k);
            }
        }
        if (it != b.begin()) {
            it--;
            ll j = *it;
            ll S = t - (pf[i - 1] - (j ? pf[j - 1] : 0));
            if (S >= 0) {
                ll k = i - j + S / a[i];
                ans = max(ans, k);
            }
        }
    }
    cout << ans;
    return 0;
}
