#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define itn int
#define int long long
#define all(a) begin(a), end(a)
#define rall(a) rbegin(a), rend(a)
#define pii pair<int, int>
#define ff first
#define ss second
#define sz(a) (int)(a).size()
#define ll long long
#define ld long double

mt19937 rnd(time(0));

int ans(int n, int m, int T, vector <int> &a, vector <int> &b){
    vector <int> p(n + 1);
    for (itn i = 0; i < n; ++i){
        p[i + 1] = p[i] + a[i];
    }

    int cur = 0;
    for (itn j = 0; j < n; ++j){
        for (auto i: b){
            if (i > j) continue;

            int sm = p[j] - p[i];
            if (sm < T) {
                cur = max(cur, (T - sm) / a[j] + (j - i));
            }
        }
    }
    return cur;
}

void solve(){
    int n, m, T;
    cin >> n >> m >> T;
    vector <int> a(n), b(m);
    for (auto &x: a) cin >> x;
    for (auto &x: b) {
        cin >> x;
        x--;
    }

    int cur = ans(n, m, T, a, b);
    reverse(all(a));
    for (int i = 0; i < m; ++i){
        b[i] = n - b[i] - 1;
    }
    reverse(all(b));

    cout << max(cur, ans(n, m, T, a, b)) << '\n';
}

signed main(){
    cin.tie(nullptr) ->sync_with_stdio(false);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;
    while (t--){
        solve();
    }
}