
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
template <typename t>
ostream& operator<<(ostream& out, const vector<t> &v){
    for(auto x: v)out<<x<<" ";
    return out;
}
template <typename t>
istream& operator>>(istream& in,  vector<t> &v){
    for(auto &x: v)in>>x;
    return in;
}
template <typename t, typename u>
ostream& operator<<(ostream& out, const pair<t, u> p){
    out<<p.first<<" "<<p.second<<"\n";
    return out;
}
template <typename t, typename u>
istream& operator>>(istream& in,  pair<t, u> &p){
    in>>p.first>>p.second;
    return in;
}
ll solve2(ll n, ll m, ll t, vector<ll> v, vector<ll> v1){
    ll idx = 0;
    map<ll, ll> mp;
    for(int i = 0;i<m; i++){
        mp[v1[i]-1]=1;
    }
    vector<ll> pref(n+1);
    for(int i = 0; i<n; i++){
        pref[i+1]=pref[i]+v[i];        
    }
    ll k = 21, ans = 0;
    vector<ll> last(k, -1);
    for(int i = 0; i<n; i++){
        last[v[i]]=i;
        for(int j = 0; j<k; j++){
            if(last[j]!=-1&&mp[i]==1&&pref[i+1]-pref[last[j]]<=t){
                ans = max(ans, (t-(pref[i+1]-pref[last[j]]))/v[last[j]]+i-last[j]+1);
            }
        }
    }
    return ans;
}
void solve () {
    int n, m, t;
    cin>>n>>m>>t;
    vector<ll> v(n), v1(m);
    cin>>v>>v1;
    ll ans = solve2(n, m, t, v, v1);
    reverse(v.begin(), v.end());
    for(int i = 0; i<m; i++){
        v1[i]=n+1-v1[i];
    }
    cout<<max(ans, solve2(n, m, t, v, v1))<<"\n";
}
signed main () {
    // ios_base::sync_with_stdio(0);
    // cin.tie(0);
    cout<<fixed<<setprecision(18);
    ll AnyaSamsonovaGoSex = 1;
    //cin>>AnyaSamsonovaGoSex;
    while(AnyaSamsonovaGoSex--) solve();
}