#include <bits/stdc++.h>

using ll = long long;

using namespace std;

#define int ll

const int INF = LLONG_MAX / 2;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n);
    vector<int> pref(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    vector<int> b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
    }

    sort(b.begin(), b.end());

    int ans = 0;
    for (int i = 0; i < n; i++) {
        int r = lower_bound(b.begin(), b.end(), i) - b.begin();
        int l = r - 1;
        if (r != m) {
            int dist = pref[b[r] + 1] - pref[i + 1];
            if (dist <= t) {
                ans = max(ans, b[r] - i + (t - dist) / a[i]);
            }
        }
        if (l != -1) {
            int dist = pref[i] - pref[b[l]];
            if (dist <= t) {
                ans = max(ans, i - b[l] + (t - dist) / a[i]);
            }
        }
    }
    cout << ans;


    cout << "\n";
    return 0;
}