#include <bits/stdc++.h>

using namespace std;

#define int long long

int n, m, T;

int rs(vector<int> a, vector<int> b) {
    vector<int> pr(n + 10);
    vector<int> us(n);
    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i] + a[i];
    }
    for (int i : b) us[i] = 1;
    vector<int> st;
    int mx = 0;
    for (int i = 0; i < n; i++) {
        while (!st.empty() && a[st.back()] >= a[i]) {
            st.pop_back();
        }
        st.push_back(i);
        if (us[i]) {
            int cb = 0;
            int sz = (int) st.size();
            for (int h = 0; h < sz; h++) {
                int j = st[h];
                int d = pr[i + 1] - pr[j + 1];
                int cn = i - j;
                int t = T - d;
                if (t >= 0) {
                    mx = max(mx, cn + t / a[j]);
                }
                cb++;
            }
            mx = max(mx, T / a[i]);
        }
    }
    return mx;
}

int solve(vector<int> a, vector<int> b) {
    int mx = 0;
    vector<int> pr(n + 10);
    vector<int> us(n);
    for (int i = 0; i < n; i++) {
        pr[i + 1] = pr[i] + a[i];
    }
    for (int j : b) {
        int l, r;
        l = -1;
        r = j + 1;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (pr[j + 1] - pr[mid] <= T) {
                r = mid;
            } else {
                l = mid;
            }
            mx = max(mx, j - r + 1 + (T - (pr[j + 1] - pr[r])) / a[r]);
            mx = max(mx, j - r + 1);
        }

    }
    return mx;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> T;
    vector<int> a(n), b(m);
    bool f = 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 1; i < n; i++) {
        if (a[i - 1] > a[i]) {
            f = 0;
            break;
        }
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i]; b[i]--;
    }
    if (f) {
        cout << solve(a, b);
        return 0;
    }
    int ans = 0;
    ans = max(ans, rs(a, b));
    reverse(a.begin(), a.end());
    for (int i = 0; i < m; i++) {
        b[i] = n - b[i] - 1;
    }
    ans = max(ans, rs(a, b));
    cout << ans;
    return 0;
}