#include <bits/stdc++.h>

#define int long long
constexpr int INF = 4e18;

void solve()
{
    int n, m, t;
    std::cin >> n >> m >> t;
    std::vector<int> a(n);
    for (int i = 0; i < n; ++i)
        std::cin >> a[i];
    std::vector<int> b(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> b[i];
        b[i]--;
    }
    std::vector<int> pref(n + 1);
    for (int i = 1; i <= n; ++i) 
        pref[i] = pref[i - 1] + a[i - 1];
    int res = 0;
    for (int i = 0; i < m; ++i) {
        int pos = b[i];
        int prv = i == 0 ? 0 : b[i - 1] + 1;
        int nxt = i == m - 1 ? n : b[i + 1];
        for (int j = prv; j < pos; ++j) {
            if (t >= pref[pos + 1] - pref[j])
                res = std::max(res, (t - (pref[pos + 1] - pref[j + 1])) / a[j] + pos - j);
        }
        for (int j = pos; j < nxt; ++j) {
            if (t >= pref[j] - pref[pos])
                res = std::max(res, (t - (pref[j] - pref[pos])) / a[j] + j - pos);
        }
    }
    std::cout << res << '\n';
}

signed main()
{
    int t = 1;
#ifdef LOCAL
    freopen("stream/inb.txt", "r", stdin);
    freopen("stream/outb.txt", "w", stdout);
    std::cin >> t;
#else
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
#endif
    for (int i_t = 1; i_t <= t; ++i_t) {
#ifdef LOCAL
    std::cout << "Test case " << i_t << '\n';
#endif
        solve();
    }
    std::cout.flush();
    return 0;
}