#include <bits/stdc++.h>

#ifndef  WILEYNE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#endif

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
using ordered_set = __gnu_pbds::tree<int, __gnu_pbds::null_type, std::less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;


using ll = long long;
using ld = long double;

using namespace std;

const int MAX_N = (int) 3e5 + 100;
const double eps = acos(-1);
const int INT_INF = (int) 2e9 + 10;
const int MOD = (int) 1e9 + 7;
auto seet = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 rng(seet);

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef WILEYNE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n,m;
    cin>>n>>m;
    ll t;
    cin>>t;
    vector<ll>a(n);
    vector<ll>pref_sums(n+1);
    for(auto &c:a) cin>>c;
    for(int i = 1;i<=n;++i){
        pref_sums[i] = pref_sums[i-1]+a[i-1];
    }
    vector<int>b(m);
    for(int i = 0;i<m;++i){
        cin>>b[i];
        b[i]--;
    }
    int u = 0;
    ll res = 0;
    ll ans = 0;
    for(int i = 0;i<n;++i){
        while(u+1<m && b[u]<i){
            u++;
        }
        if(b[u] == i){
            ans = max(ans,t/a[i]);
        }
        else {
            if(b[u]<i){
                int d = i-b[u];
                ll pr = pref_sums[i] - pref_sums[b[u]];
                if(pr<=t){
                    ans = max(ans,d+(t-pr)/a[i]);
                }
            }
            else {
                if (u != 0) {
                    int d = i - b[u - 1];
                    ll pr = pref_sums[i] - pref_sums[b[u - 1]];
                    if (pr <= t) {
                        ans = max(ans, d + (t - pr) / a[i]);
                    }
                }
                int d = b[u] - i;
                ll pr = pref_sums[b[u] + 1] - pref_sums[i + 1];
                if (pr <= t) {
                    ans = max(ans, d + (t - pr) / a[i]);
                }
            }
        }
    }
    cout<<ans;
    return 0;
}
