//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#pragma GCC optimize("Ofast,unroll-loops")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <random>
using ll = long long;
#define int ll
#define all(a) a.begin(), a.end()

using namespace std;
//using namespace __gnu_pbds;

//using odered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(0);

int n, m, t;
vector<int> a, b, ps{ 0 };

int ans = 0;

void rec(int l, int r, int opl, int opr) {
	if (l > r) return;
	int k = (l + r) / 2;
	int pos = b[k];
	int op = opl;
	int val = -1e9;
	for (int i = opl; i <= opr; i++) {
		int dst;
		if (i >= pos) {
			dst = ps[i] - ps[pos];
		}
		else {
			dst = ps[pos + 1] - ps[i + 1];
		}
		if (dst > t) continue;
		int c = (t - dst) / a[i] + abs(i-pos);
		if (c > val) {
			val = c;
			op = i;
		}
	}
	ans = max(ans, val);
	rec(l, k - 1, opl, op);
	rec(k+1, r, op, opr);
}

void solve() {
	cin >> n >> m >> t;
	a.resize(n);
	b.resize(m);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		ps.push_back(ps.back() + a[i]);
	}
	for (int i = 0; i < m; i++) {
		cin >> b[i];
		b[i]--;
	}
	rec(0, m-1, 0, n-1);
	cout << ans;;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif

	int t;
	t = 1;// cin >> t;
	while (t--) {
		solve();
	}
}