// 1.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <immintrin.h>
#include <set>
#include <map>
#include <numeric>
#include <queue>

using ll = long long;
using ld = long double;
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m, T;
    cin >> n >> m >> T;
    vector <ll> a(n);
    for (auto& i : a)
    {
        cin >> i;
    }
    vector <ll> pref = a;
    pref.insert(pref.begin(), 0);
    partial_sum(pref.begin(), pref.end(), pref.begin());
    vector <ll> b(m);
    for (auto& i : b)
    {
        cin >> i; 
        i--;
    }
    sort(b.begin(), b.end());
    ll ans = 0;
    for (size_t i = 0; i < n; i++)
    {
        auto it = lower_bound(b.begin(), b.end(), i);
        if (it != b.end())
        {
            int was = *it;
            ll dst = pref[was + 1] - pref[i + 1];
            if (T >= dst)
                ans = max(ans, (T - dst) / a[i] + was - i);
        }
        if (it != b.begin())
        {
            int was = *prev(it);
            ll dst = pref[i] - pref[was];
            if (T >= dst)
                ans = max(ans, (T - dst) / a[i] + i - was);
        }
    }
    cout << ans << '\n';
    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
