#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>

using namespace std;

vector<long long> pref;

long long get(int l, int r) {
    if (r < l) {
        swap(l, r);
    }
    return pref[r + 1] - pref[l];
}

vector<long long> solve(vector<long long> &v, long long t) {
    int n = v.size();
    stack<int> st;
    vector<int> nxt(n, -1);
    for (int i = n - 1; i >= 0; i--) {
        while (st.size() > 0 && v[i] <= v[st.top()]) {
            st.pop();
        }
        if (st.size() != 0) {
            nxt[i] = st.top();
        }
        st.push(i);
    }
    vector<long long> ans(n);
    vector<int> opt(n);
    for (int i = n - 1; i >= 0; i--) {
        if (nxt[i] == -1) {
            opt[i] = i;
            ans[i] = t / v[i];
            continue;
        }
        
    }
}

int main()
{
    int n, m, t;
    cin >> n >> m >> t;
    vector<long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    long long mx = 0;
    for (int i = 0; i < m; i++) {
        int b;
        cin >> b;
        b--;
        mx = max(mx, t / v[i]);
    }
    cout << mx;
    return 0;
}