#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <bitset>
#include <string>

//#pragma GCC optimize("unroll-loops,inline,O2,O3,Ofast")
//#pragma GCC target("avx,avx2,bmi,bmi2,sse,sse2,sse3,sse4,ssse3,abm,mmx,fma,popcnt,lzcnt")

using namespace std;

typedef long long ll;

ll INF = 1e18 + 9;

void solve() {

    ll n, m, t;
    cin >> n >> m >> t;

    vector<ll> a(n), ans1, ans2, ans3(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }


    set<pair<ll, ll>> sp;

    vector<ll> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = a[i];
        if (i) {
            p[i] += p[i - 1];
        }
    }

    {
        vector<ll> ans(n, 0);
        ll res = 0, j = 0, smt = t;
        for (ll i = 0; i < n; i++) {
            if (j <= i) {
                j = i;
                smt = t;
            }

            while (!sp.empty() && (--sp.end())->second <= i) {
                sp.erase(--sp.end());
            }

            if (sp.empty()) {
                while (j + 1 < n && smt - a[j] >= 0) {

                    res++;
                    smt -= a[j];

                    sp.insert({smt / a[j + 1] + res, j + 1});

                    j++;
                }
            }

            if (!sp.empty()) {
                ll ind = (--sp.end())->second;
                ll ost = t - p[ind - 1];
                if (i) {
                    ost += p[i - 1];
                }
                ll stp = ind - i;
                ans[i] = stp + ost / a[ind];
            }
        }
        ans1 = ans;
    }

    {
        sp.clear();
        vector<ll> ans(n, 0);
        ll res = 0, j = n - 1, smt = t;
        for (ll i = n - 1; i >= 0; i--) {
            if (j >= i) {
                j = i;
                smt = t;
            }

            while (!sp.empty() && (--sp.end())->second >= i) {
                sp.erase(--sp.end());
            }

            if (sp.empty()) {
                while (j > 0 && smt - a[j] >= 0) {

                    res++;
                    smt -= a[j];

                    sp.insert({smt / a[j - 1] + res, j - 1});

                    j--;
                }
            }

            if (!sp.empty()) {
                ll ind = (--sp.end())->second;
                ll ost = t - p[i];
                if (ind >= 0) {
                    ost += p[ind];
                }
                ll stp = i - ind;
                ans[i] = stp + ost / a[ind];
            }
        }
        ans2 = ans;
    }

    {
        for (int i = 0; i < n; i++) {
            ans3[i] = t / a[i];
        }
    }

    ll mx = 0;
    for (int i = 0; i < m; i++) {
        ll x;
        cin >> x;
        x--;
        mx = max(mx, max(ans1[x], max(ans2[x], ans3[x])));
    }

    cout << mx;
}

signed main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}
