#include <bits/stdc++.h>
using namespace std;
#define ll long long
mt19937 rnd(12749123);

vector<ll> a;
vector<int> b;
int n,m;
ll T;

int fl(int pos) {
    int l = 0;
    int r = m;
    while (r - l > 1) {
        int mid = ((r + l)>>1);
        if (b[mid] <= pos) l = mid;
        else r = mid;
    }
    return l;
}

int fr(int pos) {
    int l = -1;
    int r = m-1;
    while (r - l > 1) {
        int mid = ((r + l)>>1);
        if (b[mid] >= pos) r = mid;
        else l = mid;
    }
    return r;
}

void solve() {
    cin >> n >> m >> T;
    a.resize(n);
    vector<ll> ans(m), pref(n + 1);
    b.resize(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }

    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        b[i]--;
    }

    for (int i = 0; i < n; ++i) {
        int posl = fl(i);
        int posr = fr(i);

        if (b[posl] <= i && T >= pref[i] - pref[b[posl]]) {
            ans[posl] = max(ans[posl], (ll)i - b[posl] + (T - pref[i] + pref[b[posl]])/a[i]);
            //cout << i << ' ' << b[posl] << ' ' << pref[i] << ' ' << pref[b[posl]] << ' ' << ans[posl] << '\n';
        }
        if (b[posr] >= i && T >= pref[b[posr] + 1] - pref[i + 1]) {
            ans[posr] = max(ans[posr], (ll)b[posr] - i + (T - pref[b[posr] + 1] + pref[i + 1])/a[i]);
            //cout << i << ' ' << b[posr] << ' ' << pref[b[posr] + 1] << ' ' << pref[i + 1] << ' ' << ans[posr] << '\n';
        }
    }

    ll mx = 0;
    for (int i = 0; i < m; ++i) mx = max(mx, ans[i]);
    cout << mx;
}

/*
ll stupid() {
    vector<ll> ans(n), pref(n + 1);
    for (int i = 0; i < n; ++i) {
        //cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= i; ++j) {
            ans[i] = max(ans[i], i - j + (T - pref[i + 1] + pref[j + 1])/a[j]);
            cout << i << ' ' << j << ' ' << pref[i + 1] << ' ' << pref[i - j + 1] << '\n';
        }
        for (int j = i + 1; j < n; ++j) {
            ans[i] = max(ans[i], j - i + (T - pref[j] + pref[i])/a[j]);
        }
    }
    ll mx = 0;
    for (int i = 0; i < m; ++i) mx = max(mx, ans[b[i]]);
    return mx;
}
*/

int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
}
