#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, T;
    cin >> n >> m >> T;
    vector<int> a(n), b(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        b[i]--;
    }
    vector<int> p(n + 1);
    for (int i = 0; i < n; ++i) {
        p[i + 1] = p[i] + a[i];
    }
    vector<int> l(n, -1), r(n, -1);
    int j = 0;
    for (int i = 0; i < n; ++i) {
        while (j < m && b[j] < i) {
            j++;
        }
        if (j) {
            l[i] = b[j - 1];
        }
        if (j != m) {
            r[i] = b[j];
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (l[i] != -1 && T - p[i] + p[l[i]] >= 0) {
            ans = max(ans, (i - l[i]) + (T - p[i] + p[l[i]]) / a[i]);
        }
        if (r[i] != -1 && T - p[r[i] + 1] + p[i + 1] >= 0) {
            ans = max(ans, (r[i] - i) + (T - p[r[i] + 1] + p[i + 1]) / a[i]);
        }
    }
    cout << ans;
}
