#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;

template <class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int long long

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, t;
    cin >> n >> m >> t;

    vector <int> a(n), b(m);
    vector <ll> pref(n+1);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i+1] = a[i] + pref[i];
    }

    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }

    vector <int> ans(n);

    // for (int i = 1; i <= n; i++) {
    //     cout << pref[i] << ' ';
    // }

    // cout << '\n';

    int lastmn = -1;
    for (int i = 0; i < n; i++) {
        if (lastmn == -1) {
            ans[i] = max(ans[i], t / a[i]);
            lastmn = i;
        } else {
            int cur1 = t / a[i];
            int cur2 = -1e9;

            if (pref[i+1] - pref[lastmn+1] <= t) {
                cur2 = (t - pref[i+1] + pref[lastmn+1]) / a[lastmn] + (i - lastmn);
            }

            //cout << cur1 << ' ' << cur2 << '\n';


            if (cur1 >= cur2) {
                lastmn = i;
            }

            ans[i] = max(ans[i], max(cur1, cur2));
        }
    }

    lastmn = -1;

    for (int i = n-1; i >= 0; i--) {
        if (lastmn == -1) {
            ans[i] = max(ans[i], t / a[i]);
            lastmn = i;
        } else {
            int cur1 = t / a[i];
            int cur2 = -1e9;
            if (pref[lastmn] - pref[i] <= t) {
                cur2 = (t - pref[lastmn] + pref[i]) / a[lastmn] + (lastmn - i);
            }

            if (cur1 >= cur2) {
                lastmn = i;
            }

            ans[i] = max(ans[i], max(cur1, cur2));
        }
    }

    int res = 0;

    for (int i = 0; i < m; i++) {
        res = max(res, ans[b[i]-1]);
    }

    cout << res << '\n';
}

/*

*/