#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <random>
#include <string>

using namespace std;
#define int long long
using ll = long long;
using ld = long double;

#define dbg(x) cerr << #x << ": " << x << '\n'
int n, m, t;
int solve(vector<int> a, vector<int> bsh) {
	sort(bsh.begin(), bsh.end());
	int ind = 0;
	vector<int> pref(n + 1);
	for (int i = 0; i < n; i++) {
		pref[i + 1] = pref[i] + a[i];
	}
	int ans = 0;
	for (int i = bsh[0]; i < n; i++) {
		if (ind + 1 < m && i >= bsh[ind + 1]) ind++;

		int dist = pref[i] - pref[bsh[ind]];
		if (t - dist >= 0) {
			int left = t - dist;
			ans = max(ans, left / a[i] + i - bsh[ind]);
			dbg(i);
			dbg(ind);
			dbg(ans);
		}
	}
	return ans;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	cin >> n >> m >> t;
	vector<int> a(n), b(m);
	for (int i = 0; i < n; i++) cin >> a[i];

	for (int i = 0; i < m; i++) {
		cin >> b[i];
		b[i]--;
	}
	int ans = solve(a, b);
	reverse(a.begin(), a.end());
	for (int i = 0; i < m; i++) b[i] = n - b[i] - 1;
	ans = max(ans, solve(a, b));
	cout << ans;
}
