#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("Ofast, unroll-loops, fast-math, no-stack-protector, inline")
//#pragma GCC target("avx, avx2")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define int long long

const ll INF = 1e18 + 228;
const ll mod = 1e9 + 7;
const ld eps = 1e-8;

random_device rd;
mt19937 rnd(rd() + 228 + 57 - 179);

void solve() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n);
    vector<ll> p(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        p[i + 1] = p[i] + a[i];
    }
    ll ans = 0;
    for (int i = 0; i < m; ++i) {
        ll st;
        cin >> st;
        --st;
        for (int j = 0; j < n; ++j) {
            ll tt = 0;
            if (st >= j) tt = p[st + 1] - p[j + 1];
            else tt = p[j] - p[st];
            if (tt > t) continue;
            ll cur = abs(st - j);
            cur += (t - tt) / a[j];
            ans = max(ans, cur);
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int tt = 1;
    //cin >> tt;
    while (tt--) solve();
    return 0;
}
