#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("Ofast, unroll-loops, fast-math, no-stack-protector, inline")
//#pragma GCC target("avx, avx2")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define int long long

const ll INF = 1e18 + 228;

random_device rd;
mt19937 rnd(rd() + 228 + 57 - 179);

void calc(int n, int t, vector<int> &a, vector<int> &ans) {
    vector<int> p(n + 1);
    for (int i = 0; i < n; ++i) {
        p[i + 1] = p[i] + a[i];
    }
    int opt = -1;
    ll cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (i > opt) opt = i;
        for (int j = opt; j < n; ++j) {
            ll tt = t - (p[j] - p[i]);
            if (tt < 0) break;
            ll cur = j - i + tt / a[j];
            if (cur >= ans[i]) {
                ans[i] = cur;
                opt = j;
            }
        }
    }
}

void solve() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n);
    vector<ll> p(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> ans1(n), ans2(n);
    calc(n, t, a, ans1);
    reverse(a.begin(), a.end());
    calc(n, t, a, ans2);
    reverse(ans2.begin(), ans2.end());
    int ans = 0;
    while (m--) {
        int x;
        cin >> x;
        --x;
        ans = max(ans, max(ans1[x], ans2[x]));
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int tt = 1;
    //cin >> tt;
    while (tt--) solve();
    return 0;
}
