#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define ff first
#define ss second
#define endl '\n'
#define all(a) (a).begin, (a).end()

const int INF = 1e18 + 123;

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> p(m);
    for (int i = 0; i < m; ++i) {
        cin >> p[i];
        p[i]--;
    }

    vector<int> pr(n + 1);
    for (int i = 0; i < n; ++i) {
        pr[i + 1] = pr[i] + a[i];
    }
    
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = p[i]; j < n; ++j) {
            if (pr[j + 1] - pr[p[i]] > t) break;
            ans = max(ans, (t - (pr[j + 1] - pr[p[i]])) / a[j] + j + 1 - p[i]);
        }
        for (int j = 0; j < p[i]; ++j) {
            if (pr[p[i] + 1] - pr[j] > t) break;
            ans = max(ans, (t - (pr[p[i] + 1] - pr[j])) / a[j] + p[i] + 1 - j);
        }
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int qq = 1;
//    cin >> qq;
    while (qq--) {
        solve();
    }
}
