#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
using ill = long long;
using namespace std;


vector<ill> p;
ill dist(ill m, ill s) {
    if (m >= s)
        return p[m] - p[s];
    return p[s + 1] - p[m + 1];
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ill n, k, T;
    cin >> n >> k >> T;
    vector<ill> a(n);
    for (auto &i : a)
        cin >> i;
    vector<ill> b(k);
    for (ill i = 0; i < k; i++) {
        cin >> b[i];
        b[i]--;
    }

    p.resize(n + 1, 0);
    for (ill i = 0; i < n; i++)
        p[i + 1] = p[i] + a[i];

    vector<ill> l(n, -1);
    for (ill i = 0; i < k; i++) {
        l[b[i]] = b[i];
    }
    for (ill i = 1; i < n; i++)
        l[i] = max(l[i], l[i - 1]);

    vector<ill> r(n, n);
    for (ill i = 0; i < k; i++) {
        r[b[i]] = b[i];
    }
    for (ill i = n - 2; i >= 0; i--)
        r[i] = min(r[i], r[i + 1]);

    ill ans = 0;
    for (ill m = 0; m < n; m++) {
        ill ansl = 0, ansr = 0;
        if (l[m] > -1) {
            ill tl = T - dist(m, l[m]);
            if (tl >= 0)
                ansl = (m - l[m]) + (tl / a[m]);
        }
        if (r[m] < n) {
            ill tr = T - dist(m, r[m]);
            if (tr >= 0)
                ansr = (r[m] - m) + (tr / a[m]);
        }
        ans = max(ans, max(ansl, ansr));
    }

    cout << ans;
    return 0;
}