#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <climits>
#define ll long long
#define ld long double
using namespace std;
void solve() {
    ll n, m, T;
    cin >> n >> m >> T;
    vector<ll>a(n), pref(n);
    for (ll i = 0;i < n;++i) cin >> a[i];
    pref[0] = a[0];
    for (ll i = 1;i < n;++i) pref[i] = pref[i - 1] + a[i];
    vector<ll>b(m);
    ll ans = 0;
    for (ll i = 0;i < m;++i) cin >> b[i];
    for (ll i = 0;i < n;++i) {
        auto it1 = lower_bound(b.begin(), b.end(), i + 1);
        auto it2 = lower_bound(b.begin(), b.end(), i + 1);
        if (it1 != b.end()) {
            ll pos = *it1;
            --pos;
            if (pref[pos] - (i > 0 ? pref[i - 1] : 0ll) <= T) {
                ll cnt = pos - i + 1 + (T - pref[pos] + (i > 0 ? pref[i - 1] : 0ll)) / a[i];
                ans = max(ans, cnt);
            }
        }
        if (it2 != b.begin()) {
            --it2;
            ll pos = *it2;
            --pos;
            if (pref[i] - (pos > 0 ? pref[pos - 1] : 0ll) <= T) {
                ll cnt = i - pos + 1 + (T - pref[i] + (pos > 0 ? pref[pos - 1] : 0ll)) / a[i];
                ans = max(ans, cnt);
            }
        }
    }
    cout << ans;
}
int main()
{
    ll t = 1;
   /* cin >> t;*/
    while (t--) {
        solve();
    }
}
