#include <vector>
#include <iostream>
#include <algorithm>
#include <map>
using  namespace  std;

#define int long long

int sum(int l, int r, vector<int> &pr)
{
    return pr[r + 1] - pr[l];
}
signed  main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    int n, m, T;
    cin >> n >> m >> T;

    vector<int> a(n);
    vector<int> b(m);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    for (int i = 0 ;i  < m;i++)
        cin >> b[i];

    vector<int> pr(n + 1);
    for (int i  = 1; i < n + 1; i++)
        pr[i] = a[i - 1] + pr[i  - 1];

    vector<int> l(n);
    vector<int> r(n);
    vector<int> st;
    for (int i = 0; i < n; i++)
    {

        while (st.size() != 0 && a[st[st.size() - 1]] > a[i])
        {
            st.pop_back();
        }
        st.push_back(i);
        l[i] = T / a[i];
        int lx = -1;
        int rx = st.size() -1;
        while (rx - lx > 1)
        {
            int  m = (rx + lx)  / 2;
            if (T - sum(st[m], i, pr) < 0)
                lx = m;
            else
            {
                int x1 = (T - sum(st[m], i, pr)) / a[st[m]] + (i-  st[m] + 1);
                int x2 = (T - sum(st[m + 1], i, pr)) / a[st[m + 1]] +  (i-  st[m + 1] + 1);
                if (x1 > x2)
                    rx = m;
                else
                    lx = m;
            }

        }
        if (T - sum(st[rx], i, pr) >= 0)
            l[i] = max(l[i],(T - sum(st[rx], i, pr)) / a[st[rx]] + (i -  st[rx] + 1) );
    }

    vector<int> s;
    for (int i = n - 1; i > -1; i--)
    {
        while (s.size() != 0 && a[s[s.size() - 1]] > a[i])
        {
            s.pop_back();
        }
        s.push_back(i);
        r[i] = T / a[i];
        int lx = -1;
        int rx = s.size() -1;
        while (rx - lx > 1)
        {
            int  m = (rx + lx)  / 2;
            if (T - sum(i, s[m], pr) < 0)
                lx = m;
            else
            {
                int x1 = (T - sum(i, s[m], pr)) / a[s[m]] + (s[m] - i + 1);
                int x2 = (T - sum(i, s[m + 1], pr)) / a[s[m + 1]] +  (s[m + 1] - i + 1);
                if (x1 > x2)
                    rx = m;
                else
                    lx = m;
            }

        }
        if (T - sum(i, s[rx], pr) > 0)
            r[i] = max(r[i],(T - sum(i, s[rx], pr)) / a[s[rx]] + (s[rx] - i + 1) );
    }

    int ans = 0;
    for (int i = 0; i < m; i++)
    {
        b[i]--;
        if (ans < max(r[b[i]], l[b[i]]))
        {
            ans = max(r[b[i]], l[b[i]]);
        }
    }

    cout << ans;
}
