#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

void solve() {
	int n, m, t;
	std::cin >> n >> m >> t;
	std::vector<int> a(n), b(m + 2);
	for (int& i : a) {
		std::cin >> i;
	}
	for (int i = 0; i < m; ++i) {
		std::cin >> b[i + 1];
		--b[i + 1];
	}
	b[0] = -1;
	b[m + 1] = n;
	int mx = 0;
	for (int i = 1; i <= m; ++i) {
		int p = t;
		for (int j = b[i]; j > b[i - 1] && p > 0; --j) {
			mx = std::max(mx, p / a[j] + (b[i] - j));
			p -= a[j];
		}
		p = t;
		for (int j = b[i]; j < b[i + 1] && p > 0; ++j) {
			mx = std::max(mx, p / a[j] - (b[i] - j));
			p -= a[j];
		}
	}
	std::cout << mx << '\n';
}
int main() {
	int t = 1;
	//std::cin >> t;
	while (t--) {
		solve();
	}
}