#include <bits/stdc++.h>
// #include <bits/extc++.h>

using namespace std;

#define all(a)	a.begin(),a.end()
#define rall(a)	a.rbegin(),a.rend()
#define FastIO	ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

typedef long long			ll;
typedef long double			ld;
typedef unsigned long long	ull;
// typedef _int128_t lll;

template<typename T1, typename T2>
ostream& operator<< (ostream &x, const pair<T1, T2> &pr) { return x << "{" << pr.first << ", " << pr.second << "}"; }
template<typename T> void cerr_cont(const T &cont) { for (auto &it : cont) cerr << it << ' '; }
template<typename T> void print_cont(const T &cont, ostream &x=cout) { for (auto &it : cont) x << it << ' '; }

int main() {
	FastIO;
	int n, m, T;
	cin >> n >> m >> T;

	vector<int> a(n);
	for (auto &it : a) cin >> it;
	
	vector<int> b(m);
	for (auto &it : b) {
		cin >> it;
		--it;
	} 

	int best = 0;

	for (auto i : b) {
		int curt = T;
		int res = 0;
		for (int j = i; j >= 0; --j) {
			if (curt < a[j]) break;
			curt -= a[j];
			++res;
			best = max(best, res + curt / a[j]);
		}

		curt = T;
		res = 0;
		for (int j = i; j < n; ++j) {
			if (curt < a[j]) break;
			curt -= a[j];
			++res;
			best = max(best, res + curt / a[j]);
		}
	}
	cout << best;
	return 0;
}

