//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2")
#define _GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forsn(i,s,e) for(ll i = s; i <= e; i++)
#define rforsn(i,s,e) for(ll i = s; i >= e; i--)
#define ln '\n'
#define all(x) x.begin(), x.end()

const ll inf = INT64_MAX;

int main() {
    ios::sync_with_stdio(0), cin.tie(0);

    ll n, m, T;
    cin >> n >> m >> T;
    vector <ll> a(n + 1, inf);
    forsn(i, 1, n)
    cin >> a[i];
    vector <ll> b(m);
    for (ll& i: b)
        cin >> i;

    vector <ll> pref(n + 1, inf);
    forsn(i, 1, n) {
        pref[i] = pref[i - 1] + a[i];
    }

    ll ans = 0;
    forsn(i, 0, m - 1) {
        ll l = 0, r = b[i];
        while (l < r - 1) {
            ll mid = (r + l) / 2;
            ll s = pref[b[i]] - pref[b[i] - mid] + a[b[i] - mid];
            if (s > T)
                r = mid;
            else
                l = mid;
        }
        ll t = pref[b[i]] - pref[b[i] - l];
        ll res = l + (T - t) / a[b[i] - l];
        ans = max(ans, res);
    }

    cout << ans;

    return 0;
}
