//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2")
#define _GLIBCXX_DEBUG 1
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forsn(i,s,e) for(ll i = s; i <= e; i++)
#define rforsn(i,s,e) for(ll i = s; i >= e; i--)
#define ln '\n'
#define all(x) x.begin(), x.end()

const ll inf = INT64_MAX;

vector <ll> pref;

ll get_sum(ll l, ll r) {
    if (l > r)
        return 0;
    if (l == 0)
        return pref[r];
    return pref[r] - pref[l - 1];
}

ll n, m, T;
vector <ll> b;

ll get_ans(vector <ll>& a) {pref.resize(n);
    pref.clear();
    pref.resize(n);
    pref[0] = a[0];
    forsn(i, 1, n - 1) {
        pref[i] = pref[i - 1] + a[i];
    }
    vector <ll> dp(n);
    dp[0] = 1;
    forsn(i, 1, n - 1) {
        if (a[i] >= a[i - 1])
            dp[i] = dp[i - 1] + 1;
        else
            dp[i] = 1;
    }
    ll ans = 0;
    forsn(idx, 0, m - 1) {
        ll i = b[idx] - 1;
        ll l = 0, r = dp[i] - 1;
        while (l < r - 1) {
            ll mid = (l + r) / 2;
            ll s = get_sum(i - mid + 1, i);
            if (s > T)
                r = mid;
            else
                l = mid;
        }
        ll s = get_sum(i - r + 1, i);
        ll j = i - l + 1;
        if (s <= T)
            j = i - r + 1;
        ll t = get_sum(j, i);
        ll cnt = i - j + 1;
        ll res = cnt + (T - t) / a[j - 1];
        ans = max(ans, res);
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0);

    cin >> n >> m >> T;
    vector <ll> a(n);
    forsn(i, 0, n - 1)
        cin >> a[i];
    b.resize(n);
    for (ll& i: b)
        cin >> i;

    ll ans1 = get_ans(a);
    reverse(all(a));
    forsn(i, 0, m - 1) {
        b[i] = n - b[i] + 1;
    }
    ll ans2 = get_ans(a);

    ll ans = max(ans1, ans2);

    cout << ans;

    return 0;
}
