#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#pragma GCC optimize("03")
#pragma GCC target("avx2")

#define endl '\n'
#define int long long
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()

#ifdef local
#define dbg(x) cout << __LINE__ << " : " << (#x) << " = " << x << endl;
#else
#define dbg(x) ;
#endif

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n + 1), pref(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    vector<int> b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        int it = lower_bound(all(b), i) - b.begin();
        if (it != m) {
            int pos = b[it];
            ans = max(ans, (t - (pref[pos] - pref[i])) / a[i] + pos - i);
        }
        if (it > 0) {
            int pos = b[it - 1];
            ans = max(ans, (t - (pref[i - 1] - pref[pos - 1])) / a[i] + i - pos);
        }
    }
    for (int i = 0; i < m; i++) {
        int pos = b[i];
        int l = pos - 1, r = n + 1;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (pref[mid] - pref[pos - 1] <= t) {
                l = mid;
            } else {
                r = mid;
            }
        }
        ans = max(ans, l - pos + 1);
    }
    for (int i = 0; i < m; i++) {
        int pos = b[i];
        int l = 0, r = pos + 1;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (pref[pos] - pref[mid - 1] <= t) {
                r = mid;
            } else {
                l = mid;
            }
        }
        ans = max(ans, pos - r + 1);
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef local
    freopen("in.txt", "r", stdin);
#endif
    solve();
    return 0;
}
