#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>

#define int long long

using namespace std;

signed main() {
    int n, m, t, mn = 1e9;
    cin >> n >> m >> t;
    vector<int> a(n), b(m), pref(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pref[i + 1] = pref[i] + a[i];
        mn = min(mn, a[i]);
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        b[i]--;
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int ind1 = -1, ind2 = -1;
        if (b[0] <= i) {
            int l = 0, r = m;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if (b[mid] <= i) {
                    l = mid;
                }
                else {
                    r = mid;
                }
            }
            ind1 = b[l];
        }
        if (b[m - 1] >= i) {
            int l = -1, r = m - 1;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if (b[mid] >= i) {
                    r = mid;
                }
                else {
                    l = mid;
                }
            }
            ind2 = b[r];
        }
        if (ind1 != -1) {
            if (t >= pref[i + 1] - pref[ind1]) {
                ans = max(ans, i - ind1 + 1 + (t - (pref[i + 1] - pref[ind1])) / a[i]);
            }
        }
        if (ind2 != -1) {
            if (t >= pref[ind2 + 1] - pref[i]) {
                ans = max(ans, ind2 - i + 1 + (t - (pref[ind2 + 1] - pref[i])) / a[i]);
            }
        }
    }
    cout << ans;
}


