#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;

int main(int, char**) {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    ll n, m, T;
    cin >> n >> m >> T;
    vector<ll> a(n);
    vector<ll> p(n + 1, 0);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        p[i + 1] = p[i] + a[i];
    }
    vector<ll> b(m);
    for (ll i = 0; i < m; ++i) {
        cin >> b[i];
        b[i]--;
    }
    sort(b.begin(), b.end());

    ll best = 0;
    for (ll i = 0; i < n; ++i) {
        ll right = upper_bound(b.begin(), b.end(), i) - b.begin();
        if (right != 0) {
            ll left = right - 1;
            if (T >= p[i] - p[b[left]]) {
                best = max(best, i - b[left] + (T - (p[i] - p[b[left]])) / a[i]);
            }
        }
        if (right != b.size()) {
            if (T >= p[b[right] + 1] - p[i + 1]) {
                best = max(best, b[right] - i + (T - (p[b[right] + 1] - p[i + 1])) / a[i]);
            }
        }
    }
    cout << best;


    return 0;
}
