#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("avx2")

#define int long long

using ll = long long;
using namespace std;

//const int MAXN = 3e5, INF = 1e15;
//
//struct Node {
//    int val;
//    int ind;
//    int mod = 0;
//};
//
//vector<int> used(MAXN), pref(MAXN + 1, 0);
//vector<Node> t (4 * MAXN);
//
//void build(int v, int l, int r) {
//    if (l + 1 == r) {
//        if (used[l]) {
//            t[v].val = pref[r];
//        } else {
//            t[v].val = INF;
//        }
//        t[v].ind = l;
//        return;
//    }
//    int m = (r + l) / 2;
//    build(2 * v + 1, l, m);
//    build(2 * v + 2, m, r);
//    if (t[2 * v + 1].val )
//    t[v].val = min(t[2 * v + 1].val, t[2 * v + 2].val);
//}
//
//void push(int v, int l, int r) {
//    int m = (r + l) / 2;
//    t[2 * v + 1].val += t[v].mod * (m - l);
//    t[2 * v + 2].val += t[v].mod * (r - m);
//    t[2 * v + 1].mod += t[v].mod;
//    t[2 * v + 2].mod += t[v].mod;
//    t[v].mod = 0;
//}
//
//void update(int v, int l, int r, int ql, int qr, int x) {
//    if (l >= qr || ql >= r) {
//        return;
//    }
//    if (ql <= l && r <= qr) {
//        t[v].val += x * (r - l);
//        t[v].mod += x;
//        return;
//    }
//    push(v, l, r);
//    int m = (r + l) / 2;
//    update(2 * v + 1, l, m, ql, qr, x);
//    update(2 * v + 2, m, r, ql, qr, x);
//    t[v].val = min(t[2 * v + 1].val, t[2 * v + 2].val);
//}

void solve() {
    int n, m, T, ind1 = -1, ind2 = 0, ans = 0;
    cin >> n >> m >> T;
    vector<int> a(n), b(n), used(n, 0), pref(n + 1, 0);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref[i + 1] = a[i] + pref[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
        used[b[i]] = 1;
    }
    for (int i = 0; i < n; i++) {
        if (ind1 != -1) {
            int t = pref[i] - pref[b[ind1]];
            ans = max(ans, (T - t) / a[i] + (i - b[ind1]));
        }
        if (ind2 != m) {
            int t = pref[b[ind2] + 1] - pref[i + 1];
            ans = max(ans, (T - t) / a[i] + (b[ind2] - i));
        }
        if (used[i]) {
            ind1++;
            ind2++;
        }
    }
    cout << ans << "\n";
}

signed main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tests;
#else
    ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
#endif
//    cin >> tests;
    while (tests--) {
        solve();
    }
}
