#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

#define all(x) begin(x), end(x)
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll ran(ll l=LLONG_MIN, ll r=LLONG_MAX){
    return uniform_int_distribution<ll>(l, r)(rnd);
}

void solve() {
    ll n, m, T;
    cin >> n >> m >> T;
    vector<ll> a(n);
    for (auto &x: a) cin >> x;
    ll ans = 0;
    while (m--){
        int x;
        cin >> x;
        --x;
        ll x1 = x;
        ll sum = 0, cnt = 0;
        while (x < n && sum + a[x] <= T) {
            sum += a[x];
            cnt++;
            ans = max(ans, (T - sum) / a[x] + cnt);
            ++x;
        }
        sum = 0, cnt = 0;
        x = x1;
        while (x > -1 && sum + a[x] <= T)
            sum += a[x], cnt++, ans = max(ans, (T - sum) / a[x] + cnt), --x;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ll t = 1;
//    cin >> t;
    while (t--) solve(), cout << '\n';
    return 0;
}