#include <bits/stdc++.h>
#define int long long

using ll = long long;
using ld = long double;
using namespace std;

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m, t;
    cin >> n >> m >> t;

    vector<int> a(n);
    for(int i = 0; i < n; ++i)
        cin >> a[i];

    vector<int> pref(n + 1);
    pref[0] = 0;
    for(int i = 1; i <= n; ++i)
        pref[i] = pref[i - 1] + a[i - 1];

    vector<int> place(m);
    for(int i = 0; i < m; ++i)
        cin >> place[i];

    vector<int> right(n, -1);
    int now = 0;
    for(int i = 0; i < m; ++i){
        for(int j = now; j < place[i]; ++j)
            right[j] = place[i];
        now = place[i];
    }

    vector<int> left(n, -1);
    now = n - 1;
    for(int i = m - 1; i >= 0; --i){
        for(int j = now; j >= place[i] - 1; --j)
            left[j] = place[i];
        now = place[i] - 2;
    }

    int ans = 0;
    for(int i = 0; i < n; ++i){
        int t2, am;
        if(left[i] != -1){
            t2 = pref[i] - pref[left[i] - 1];
            if(t2 <= t){
                am = i - left[i] + 1;
                am += (t - t2) / a[i];
                ans = max(ans, am);
            }
        }
        if(right[i] != -1){
            t2 = pref[right[i]] - pref[i + 1];
            if(t2 <= t){
                am = right[i] - i - 1;
                am += (t - t2) / a[i];
                ans = max(ans, am);
            }
        }
    }
    cout << ans;
}
