#include <bits/stdc++.h>
#include <ext//pb_ds//assoc_container.hpp>

using namespace std;
using ll = long long;
using namespace __gnu_pbds;
using ordered_set = tree<ll, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update>;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n);
    vector<ll> pref(n + 1);
    unordered_map<int, vector<ll> > raz;
    unordered_map<int, int> l;
    unordered_map<int, int> used;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        raz[a[i]].push_back(i);
        pref[i + 1] = pref[i] + (ll)a[i];
        l.insert({a[i], 0});
        used[a[i]] = false;
    }
    ll ans = 0;
    int L = 0;
    int R = 0;
    unordered_set<int> z;
    for (int i = 0; i < m; i++) {
        ll x;
        cin >> x;
        x--;
        for (int j = R; j < x; j++) {
            if (j != 0 && a[j] < a[j - 1]) {
                z.insert(a[j]);
                ++used[a[j]];
            }
        }
        while (L < n && pref[x + 1] - pref[L] > t) {
            --used[a[L]];
            if (used[a[L]] == 0) {
                z.erase(a[L]);
            }
            L++;
        }
        while (R < n && pref[R + 1] - pref[x] <= t) {
            if (R != 0 && a[R] < a[R - 1]) {
                z.insert(a[R]);
                ++used[a[R]];
            }
            R++;
        }
        if (z.size() > 1e4) {
            cout << 1 / 0;
        }
        for (auto d : z) {
            const int sz = raz[d].size();
            while (l[d] != sz && raz[d][l[d]] < x) {
                l[d]++;
            }
            if (l[d] != sz) {
                const ll j = raz[d][l[d]];
                const ll sol = pref[j + 1] - pref[x];
                if (sol > t) {
                    continue;
                }
                ans = max(j - x + 1 + (t - sol) / d, ans);
            }
            if (l[d] != 0) {
                const ll j = raz[d][l[d] - 1];
                const ll sol = pref[x + 1] - pref[j];
                if (sol > t) {
                    continue;
                }
                ans = max(x - j + 1 + (t - sol) / d, ans);
            }
        }
    }
    cout << ans;
    return 0;
}
