#include <bits/stdc++.h>
using namespace std;

using ll = long long;

int main() {
    ll n, m, t;
    cin >> n >> m >> t;

    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<ll> b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
    }

    vector<ll> pref(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + a[i - 1];
    }

    vector<pair<int, int>> st;
    vector<ll> ans(n, 0);
    for (int i = 0; i < n; i++) {
        while (!st.empty() && st.back().first >= a[i])
            st.pop_back();
        st.push_back({a[i], i});
        for (auto [val, pos] : st) {
            ll sum = pref[i + 1] - pref[pos + 1];
            if (sum > t)
                continue;
            ans[i] = max(ans[i], (t - sum) / a[pos] + (i - pos));
        }
    }
    st.clear();
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && st.back().first >= a[i])
            st.pop_back();
        st.push_back({a[i], i});
        for (auto [val, pos] : st) {
            ll sum = pref[pos] - pref[i];
            if (sum > t)
                continue;
            ans[i] = max(ans[i], (t - sum) / a[pos] + (pos - i));
        }
    }

    ll mx = 0;
    for (int i : b) {
        mx = max(mx, ans[i]);
    }

    cout << mx << '\n';
}