#include <bits/stdc++.h>

using namespace std;

void build(vector<int>& A, vector<int>& tree, int n, int t) {
    if (n >= t - 1)
        tree[n] = A[n - t + 1];
    else {
        build(A, tree, 2*n + 1, t);
        build(A, tree, 2*n + 2, t);
        tree[n] = min(tree[2*n + 1], tree[2*n + 2]);
    }
}

int get(vector<int>& tree, int t, int n, int l, int r, int L, int R) {
    if (R <= l || r <= L)
        return 1000000000;
    if (l <= L && r >= R)
        return tree[n];
    else {
        int a = get(tree, t, 2*n + 1, l, r, L, (L + R)/2);
        int b = get(tree, t, 2*n + 2, l, r, (L + R)/2, R);
        return min(a, b);
    }
}

int main()
{
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> A(4*n, 1000000000);
    vector<int> B(m);
    vector<long long> C(n, 0);
    int Min = 1000000000;
    for (int i = 0; i < n; ++i) {
        cin >> A[i];
        Min = min(Min, A[i]);
        if (i == 0)
            C[0] = A[0];
        else
            C[i] = A[i] + C[i-1];
    }
    for (int i = 0; i < m; ++i) {
        cin >> B[i];
        --B[i];
    }

    sort(B.begin(), B.end());
    int T = 1;
    long long sum;
    while (T < n)
        T *= 2;
    vector<int> tree (4*n, 1000000000);
    build(A, tree, 0, T);
    int cnt;
    int Max = 0;
    int k = 0;
    for (int i = 0; i < n; ++i) {
        if (B[0] > i)
            continue;
        if (k == m)
            break;
        if (k < m - 1 && B[k+1] <= i)
            ++k;
        sum = C[i];
        if (B[k] > 0)
            sum -= C[B[k]-1];
        if (sum > t)
            continue;
        cnt = i - B[k] + 1;
        cnt += (t - sum) / A[i];
        Max = max(Max, cnt);

        if (k != m - 1) {
            sum = C[B[k+1]];
            if (i > 0)
                sum -= C[i-1];
            if (sum > t)
                continue;
            cnt = abs(i - B[k+1]) + 1;
            cnt += (t - sum) / A[i];
            Max = max(Max, cnt);
        }
    }
    cout << Max << endl;


    return 0;
}
