#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define all(vec) vec.begin(), vec.end()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fi first
#define se second
#define int ll

mt19937_64 rnd;

void solve() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<ll> a(n + 1);
    vector<ll> b(m + 1);

    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= m; i++) cin >> b[i];

    vector<ll> pref(n + 1);
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + a[i];
    ll ans = 0;
    for (int i = 1; i <= n; i++) {
        ll l = 0, r = m + 1;
        while (l < r - 1) {
            int mid = (l + r) / 2;
            if (b[mid] >= i) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (l != 0) {
            ll _t = t - (pref[i] - pref[b[l] - 1]);
            ll k = i - b[l] + 1;
            if (_t >= 0) {
                k += _t / a[i];
                ans = max(ans, k);
            }
        }
        if (r != m + 1) {
            ll _t = t - (pref[b[r]] - pref[i - 1]);
            ll k = b[r] - i + 1;
            if (_t >= 0) {
                k += _t / a[i];
                ans = max(ans, k);
            }
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
