#include <iostream>
#include <string>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>


typedef long long ll;
typedef double db;
typedef long double ld;

#define pb push_back
#define eb emplace_back
#define sz(s) int(s.size())
#define mp make_pair
#define all(s) s.begin(), s.end()

const int MAX_N = 4e5 + 10;
const int LOG = 25;
const ld EPS = 1e-7;

using namespace std;

ll a[MAX_N];
ll pref[MAX_N];
ll next_min[MAX_N];
ll jump_prev[MAX_N][LOG];
ll jump_next[MAX_N][LOG];
ll prev_min[MAX_N];
ll n, m, t;
int quest[MAX_N];
int my_solution() {
    vector <pair <ll,ll>> st;
    st.eb(0, 0);
    for (int i = 1; i <= n; i++) {
        pair <ll,ll> p = {a[i], i};
        while (st.back().first >= p.first) {
            st.pop_back();
        }
        prev_min[i] = st.back().second;
        jump_prev[i][0] = prev_min[i];
        st.pb(p);
    }
    for (int k = 1; k < LOG; k++){
        for (int i = 1; i <= n; i++) {
            if (jump_prev[i][k - 1] == 0) {
                jump_prev[i][k] = 0;
            } else {
                jump_prev[i][k] = jump_prev[jump_prev[i][k - 1]][k - 1];
            }
        }
    }


    st = {};
    st.eb(0, n + 1);
    for (int i = n; i >= 1; i--) {
        pair <ll,ll> p = {a[i], i};
        while (st.back().first >= p.first) {
            st.pop_back();
        }
        next_min[i] = st.back().second;
        jump_next[i][0] = next_min[i];
        st.pb(p);
    }
    // for (int i = 1; i <= n; i++) {
    //     cout << next_min[i] << " s ";
    // }
    // cout << endl;
    for (int k = 1; k < LOG; k++) {
        for (int i = 1; i <= n; i++) {
            if (jump_next[i][k - 1] == n + 1) {
                jump_next[i][k] = n + 1;
            } else {
                jump_next[i][k] = jump_next[jump_next[i][k - 1]][k - 1];
            }
            // cout << i << " " << k << " p " << jump_next[i][k] << endl;
        }
    }

    ll ans = 0;
    for (int i = 0; i < m; i++) {
        ll start = quest[i];
        ll ans_now = t / a[start];
        ll j = start;
        ll k = LOG - 1;
        while (k != -1) {
            // cout << start << " " << j << " " << jump_prev[j][k] << " " << k << endl;
            if ((jump_prev[j][k] != 0) && t >=  ((pref[start] - pref[jump_prev[j][k] - 1])) &&  ans_now <  ((start - jump_prev[j][k] + 1 + (t - (pref[start] - pref[jump_prev[j][k] - 1])) / a[jump_prev[j][k]]))) {
                ans_now =  (start - jump_prev[j][k] + 1 + (t - (pref[start] - pref[jump_prev[j][k] - 1])) / a[jump_prev[j][k]]);
                j = jump_prev[j][k];
            }
            k--;
        }
        // cout << "!!! " << " " << start << " " << ans_now << " LEF" << " " << j << endl;
        // cout << a[start] << " " << a[j] << endl;
        ans = max(ans, ans_now);
        j = start;
        k = LOG - 1;
        ans_now = t / a[start];

        while (k != -1) {
            // cout << start << " " << j << " " << jump_next[j][k] << " " << k << endl;
            if ((jump_next[j][k] != n + 1) && (t >= (pref[jump_next[j][k]] - pref[start - 1])) && ( ans_now <  (jump_next[j][k] - start + 1 + (t - (pref[jump_next[j][k]] - pref[start - 1])) / a[jump_next[j][k]]))) {
                ans_now =  (jump_next[j][k] - start + 1 + (t - (pref[jump_next[j][k]] - pref[start - 1])) / a[jump_next[j][k]]);
                j = jump_next[j][k];
            }
            k--;
        }
        ans = max(ans, ans_now);
        // cout << "!!! " << " " << start << " " << ans_now << " RIG" << " " << j << endl;
    
        
    }
    return ans;

}
int main () {
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> m >> t;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    ll ans = 0;
    for (int i = 0; i < m; i++) {
        int start;
        cin >> start;
        quest[i] = start;
        // cout << i << "ASDASD" << endl;
        for (int j = 1; j <= n; j++) {
            if (j < start) {
                if (t >= pref[start] - pref[j - 1]) {
                    // cout << ans << "BEG " << endl;
                    ans = max(ans, start - j + 1 + (t - (pref[start] - pref[j - 1])) / a[j]);
                }
            } else {
                if (t >= pref[j] - pref[start - 1]) {
                    // cout << ans << "PPP" << endl;
                    ans = max(ans, j - start + 1 + (t - (pref[j] - pref[start - 1])) / a[j]);
                }

            }
            // cout << ans << endl;
        }
    }
    cout << ans << endl;
    
    

    
}
// 5 3 6
// 1 3 4 5 6
// 3 4 5
// 6 2 9
// 3 5 2 6 3 4
// 4 6