#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_map>
#include <map>
#include <random>
#include <chrono>

#define int long long

using namespace std;

signed main() {
    cin.tie(nullptr);
    ios::sync_with_stdio(false);
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n);
    vector<int> b(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        x--;
        b[i] = x;
    }
    sort(b.begin(), b.end());
    vector<int> pref(n);
    pref[0] = a[0];
    for (int i = 1; i < n; i++) {
        pref[i] = pref[i-1] + a[i];
    }
    vector<int> l(n, -1);
    vector<int> r(n, -1);
    int i = 0;
    int j = 0;
    while (i < n) {
        //cout << "a";
        if (j < m && i > b[j]) {
            j++;
        }
        if (j < m) {
            r[i] = b[j];
        }
        if (j > 0) {
            l[i] = b[j-1];
        }
        i++;
    }
    int ans = 0;

    for (int k = 0; k < n; k++) {
        //переберём левого бегуна
        if (l[k] != -1) {
            int cnt = 0;
            int tt = t;
            if (l[k] == 0) {
                tt -= pref[k];
                cnt += k+1;
            } else {
                tt -= (pref[k] - pref[l[k] - 1]);
                cnt += k-l[k] + 1;
            }
            if (tt >= 0) {
                cnt += tt / a[k];
                ans = max(ans, cnt);
            }
        }

        //переберём правого бегуна
        if (r[k] != -1) {
            int cnt = 0;
            int tt = t;
            if (k == 0) {
                tt -= pref[r[k]];
                cnt += r[k] + 1;
            } else {
                tt -= (pref[r[k]] - pref[k-1]);
                cnt += r[k] - k + 1;
            }
            if (tt >= 0) {
                cnt += tt/a[k];
                ans = max(ans, cnt);
            }
        }
    }
    cout << ans;
    return 0;
}


/*
5 3 10
4 5 2 7 1
1 2 4

4 2 11
4 5 7 10
2 3
 */