#ifdef LOCAL
#pragma optimize("", off)
#include "localstd1.h"
#else
#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/allocator.h>
#pragma GCC target("avx2,bmi,bmi2")
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

#define all(a) (a).begin(), (a).end()

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, m; cin >> n >> m;
	vector<pair<int, int>> c(n + m, { -1, -1 });
	for (int i = 0; i < n; i++) {
		cin >> c[i].first;
	}
	for (int i = 0; i < n; i++) {
		cin >> c[i].second;
	}
	for (int i = 0; i < m; i++) {
		cin >> c[n + i].first;
	}
	sort(all(c));
	n = n + m;
	int nexta = INT_MAX;
	int nextai = n;
	for (int i = n - 1; i >= 0; i--) {
		if (c[i].second != -1 && c[i].second < nexta) {
			nexta = c[i].first;
			nextai = i;
		}
	}
	cout << (nextai % 2 == 0 ? "First" : "Second");
	
	return 0;
}