#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define int long long

const int MAX = 5e5 + 7;
const int mod = 1e9 + 7;

mt19937_64 rng(time(0));

int n, m;
int a[MAX];
int b[MAX];
int c[MAX];
int type[MAX];
int id[MAX];

int mem[(1 << 20)][51];

bool win(int mask, int lst) {
    if (lst == n * 2 + m + 1) return 0;
    if (mem[mask][lst] != -1) return mem[mask][lst];
    if (type[lst] == 1) {
        if ((mask >> (id[lst] - 1) & 1)) {
            return mem[mask][lst] = win(mask, lst + 1);
        } else {
            bool good = false;
            good |= !win(mask, lst + 1);
            if (b[id[lst]] < a[id[lst]]) {
                good |= win(mask + (1 << (id[lst] - 1)), lst + 1);
            } else {
                good |= !win(mask + (1 << (id[lst] - 1)), lst + 1);
            }
            return mem[mask][lst] = good;
        }
    }
    if (type[lst] == 2) {
        if (!(mask >> (id[lst] - 1) & 1)) {
            return mem[mask][lst] = win(mask, lst + 1);
        } else {
            return mem[mask][lst] = !win(mask, lst + 1);
        }
    }
    if (type[lst] == 3) {
        return mem[mask][lst] = !win(mask, lst + 1);
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        type[a[i]] = 1;
        id[a[i]] = i;
    }
    for (int i = 1; i <= n; i++) {
        cin >> b[i];
        type[b[i]] = 2;
        id[b[i]] = i;
    }
    for (int i = 1; i <= m; i++) {
        cin >> c[i];
        type[c[i]] = 3;
    }
    for (int i = 0; i < (1 << n); i++) {
        for (int j = 1; j <= n * 2 + m; j++) {
            mem[i][j] = -1;
        }
    }
    cout << (win(0, 1) ? "First" : "Second");
}

int32_t main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}