#include <bits/stdc++.h>

using namespace std;
const int INF = 1e9;


int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);


    int n, m;
    cin >> n >> m;
    vector<int> A(n), B(n), C(m);
    for (int &x: A) cin >> x;
    for (int &x: B) cin >> x;
    for (int &x: C) cin >> x;

    map<int, int> mp, pref;
    for (int i = 0; i < n; i++) {
        mp[max(A[i], B[i])] = A[i];
    }
    pref[-1] = -1;
    for (auto [v, x] : mp) {
        pref[v] = max(pref.rbegin()->second, x);
    }
    // max A[i], max(A[i], B[i]) < x && B[i] < x
    int want = INF;
    while (true) {
        int pos = prev(pref.lower_bound(want))->second;
        if (pos == -1) {
            break;
        }
        want = pos;
    }
    set<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.emplace(A[i], B[i]);
    }
    for (int i = 0; i < m; i++) {
        s.emplace(C[i], -1);
    }
    int steps = 0;
    while (!s.empty()) {
        steps ^= 1;
        auto [x, y] = *s.begin();
        s.erase(s.begin());
        if (x == want) {
            break;
        }
    }
    cout << (steps ? "First" : "Second");
    return 0;
}