#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
using ull = long long;
using ld = long double;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int N = 5e5;
pair<int, int> a[N];
int b[N], n, m;
int f[2 * N + 1];
vector<pair<int, int>> v;

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        v.emplace_back(a[i].first, i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        v.emplace_back(b[i], -i - 1);
    }
    sort(all(v));
    f[n + m] = 0;
    for (int i = n + m - 1; i >= 0; --i) {
        auto [pos, vid] = v[i];
        if (vid >= 0) {
            if (f[i + 1] == 0) {
                f[i] = 1;
                continue;
            }
            if (a[vid].first > a[vid].second) {
                f[i] = 1;
                continue;
            }
            f[i] = 1;
        } else {
            f[i] = f[i + 1] ^ 1;
        }
    }
    cout << (f[0] ? "First" : "Second");
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
