#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

#define int long long
#define all(x) (x).begin(), (x).end()
using ll = long long;
using ull = long long;
using ld = long double;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int N = 5e5;
pair<int, int> a[N];
int b[N], n, m;
int used[N];
pair<int, int> f[3 * N + 1];

int rec(int pos) {
    if (pos == 2 * n + m + 1) {
        return 0;
    }
    if (f[pos].first == 3) {
        return rec(pos + 1) ^ 1;
    }
    int i = f[pos].second;
    if (f[pos].first == 1) {
        if (a[i].first > a[i].second) {
            return 1;
        }
        if (rec(pos + 1) == 0) {
            return 1;
        }
        used[i] = 1;
        if (rec(pos + 1) == 0) {
            used[i] = 0;
            return 1;
        }
        used[i] = 0;
        return 0;
    } else {
        if (a[i].first > a[i].second) {
            return rec(pos + 1);
        }
        return rec(pos + 1) ^ used[i];
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        f[a[i].first] = {1, i};
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
        f[a[i].second] = {2, i};
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        f[b[i]] = {3, i};
    }
    cout << (rec(1) ? "First" : "Second");
}

signed main() {
    fast_in_out();
    int qwe = 1;
//    cin >> qwe;
    while (qwe--) {
        solve();
    }
    return 0;
}
