#pragma GCC optimize("O3")
//#pragma GCC target("avx")

#include <bits/extc++.h>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i], a[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i], b[i]--;
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i], c[i]--;
    }
//    sort(c.begin(), c.end());
//    {
//        vector<int> ord(n);
//        iota(ord.begin(), ord.end(), 0);
//        sort(ord.begin(), ord.end(), [&](int i, int j) {
//            return a[i] < a[j];
//        });
//        auto aa = a;
//        auto bb = b;
//        for (int i = 0; i < n; i++) {
//            a[i] = aa[ord[i]];
//            b[i] = bb[ord[i]];
//        }
//    }
    int N = n + n + m;
    vector dp(N, vector<int>(1 << n));
    std::fill(dp[N - 1].begin(), dp[N - 1].end(), 1);
    vector<int> is_b(N);
    vector<int> is_a(N);
    vector<int> is_c(N);
    for (int i = 0; i < n; i++) {
        is_b[b[i]] = i + 1;
        is_a[a[i]] = i + 1;
    }
    for (int i = 0; i < m; i++) {
        is_c[c[i]] = 1;
    }
    for (int mask = 0; mask < (1 << n); mask++) {
        if (is_b[N - 1] && (((mask >> (is_b[N - 1] - 1)) & 1)) == 0) {
            dp[N - 1][mask] = 0;
        }
    }
    for (int i = N - 2; i >= 0; i--) {
        for (int mask = 0; mask < (1 << n); mask++) {
            int flag = 0;
            if (is_b[i] > 0 || is_c[i]) {
                int ii = is_b[i] - 1;
                if (((mask >> ii) & 1) || is_c[i]) {
                    if (dp[i + 1][mask] == 0) {
                        flag = 1;
                    }
                } else {
                    dp[i][mask] = dp[i + 1][mask];
                }
            } else {
                assert(is_a[i]);
                int bit = ((mask >> (is_a[i] - 1)) & 1);
                int ii = is_a[i] - 1;
                if (bit == 0 && b[ii] < a[ii]) {
                    flag = 1;
                }
                int mask_ = (mask ^ (bit << (is_a[i] - 1)));
                if (dp[i + 1][mask_] == 0) {
                    flag = 1;
                }
                mask_ = (mask | (1 << (is_a[i] - 1)));
                if (dp[i + 1][mask_] == 0) {
                    flag = 1;
                }
            }
            dp[i][mask] = flag;
        }
    }
    cout << (dp[0][0] ? "First" : "Second") << '\n';
    return 0;
}
/*

2 1
5 3
1 2
4

1 2
2
3
4 1

 #include <bits/extc++.h>

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i], a[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i], b[i]--;
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i], c[i]--;
    }
    {
        auto aa = a;
        auto bb = b;
        vector<int> ord(n);
        for (int i = 0; i < n; i++) {
            ord[i] = i;
        }
        sort(ord.begin(), ord.end(), [&](int i, int j) {
            return a[i] < a[j];
        });
        for (int i = 0; i < n; i++) {
            a[i] = aa[ord[i]];
            b[i] = bb[ord[i]];
        }
    }
    vector<tuple<int, int, int>> z;
    for (int i = 0; i < n; i++) {
        z.emplace_back(a[i], 0, i);
    }
    for (int i = 0; i < m; i++) {
        z.emplace_back(c[i], 1, i);
    }
    sort(z.begin(), z.end());
    int N = 2 * n + m;
    vector<int> id(N, -1);
    for (int i = 0; i < n; i++) {
        id[b[i]] = id[a[i]] = i;
    }
    vector dp(N, vector<int>(n + 1));
    for (int i = N - 1; i >= 0; i--) {
        for (int cnt = 0; cnt <= n; cnt++) {
            if (cnt > 0 && a[cnt - 1] >= i) {
                break;
            }

        }
    }
    cout << (dp[0][0] ? "First" : "Second") << '\n';
    return 0;
}
/*

2 1
5 3
1 2
4

1 2
2
3
4 1

 */
