#ifndef SEREGA
#include <bits/allocator.h>
#pragma GCC target("avx2,popcnt")
#pragma GCC optimize("O3,no-stack-protector")
#endif
#include <bits/stdc++.h>
using namespace std;
#define int int64_t

int n, m;
vector<int> a, b, c;

bool dfs(vector<int> &is_reverted, vector<int> &is_deletedn, vector<int> &is_deletedm, int cntdeletedn, int cntdeletedm) {
    if (cntdeletedm + cntdeletedn == n + m) return false;
    int mnn = INT_MAX;
    int mnindexn = -1;
    int mnm = INT_MAX;
    int mnindexm = -1;
    
    for (int i = 0; i < n; ++i) {
        if (!is_deletedn[i]) {
            int val = is_reverted[i] ? b[i] : a[i];
            if (val < mnn) {
                mnn = val;
                mnindexn = i;
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        if (!is_deletedm[i]) {
            if (c[i] < mnm) {
                mnm = c[i];
                mnindexm = i;
            }
        }
    }
    if (mnn > mnm) {
        is_deletedm[mnindexm] = 1;
        int val = dfs(is_reverted, is_deletedn, is_deletedm, cntdeletedn, cntdeletedm + 1);
        is_deletedm[mnindexm] = 0;
        return !val;
    } else {
        if (is_reverted[mnindexn]) {
            is_deletedn[mnindexn] = 1;
            int val = dfs(is_reverted, is_deletedn, is_deletedm, cntdeletedn + 1, cntdeletedm);
            is_deletedn[mnindexn] = 0;
            return !val;
        } else {
            is_deletedn[mnindexn] = 1;
            bool val = dfs(is_reverted, is_deletedn, is_deletedm, cntdeletedn + 1, cntdeletedm);
            is_deletedn[mnindexn] = 0;
            is_reverted[mnindexn] = 1;
            bool val2 = dfs(is_reverted, is_deletedn, is_deletedm, cntdeletedn, cntdeletedm);
            is_reverted[mnindexn] = 0;
            return !(val & val2);
        }
    }
}

void solve() {
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
    }
    vector<int> is_reverted(n), is_deletedn(n), is_deletedm(m);
    cout << (dfs(is_reverted, is_deletedn, is_deletedm, 0, 0) ? "First" : "Second") << endl;
    
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}