#ifndef SEREGA
#include <bits/allocator.h>
#pragma GCC target("avx2,popcnt")
#pragma GCC optimize("O3,no-stack-protector")
#endif
#include <bits/stdc++.h>
using namespace std;
#define int int64_t

int n, m;
vector<int> a, b, c;

bool dfs(vector<int> &is_reverted, vector<int> &is_deletedn, int cntdeletedn) {
    if (cntdeletedn == n) return false;
    int mnn = INT_MAX;
    int mnindexn = -1;
    
    for (int i = 0; i < n; ++i) {
        if (!is_deletedn[i]) {
            int val = is_reverted[i] ? b[i] : a[i];
            if (val < mnn) {
                mnn = val;
                mnindexn = i;
            }
        }
    }
    if (is_reverted[mnindexn]) {
        is_deletedn[mnindexn] = 1;
        int val = dfs(is_reverted, is_deletedn, cntdeletedn + 1);
        is_deletedn[mnindexn] = 0;
        return !val;
    } else {
        is_deletedn[mnindexn] = 1;
        bool val = dfs(is_reverted, is_deletedn, cntdeletedn + 1);
        is_deletedn[mnindexn] = 0;
        is_reverted[mnindexn] = 1;
        bool val2 = dfs(is_reverted, is_deletedn, cntdeletedn);
        is_reverted[mnindexn] = 0;
        return !(val & val2);
    }
}

void solve() {
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i];
    }
    vector<int> is_reverted(n), is_deletedn(n);
    if (!(m & 1)) {
        cout << (dfs(is_reverted, is_deletedn, 0) ? "Second" : "First") << endl;
    } else {
        cout << (dfs(is_reverted, is_deletedn, 0) ? "First" : "Second") << endl;
    }
    
    
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}