#include <bits/stdc++.h>

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

using namespace std;

int n, m;
vector<pair<int, int>> a;
vector<int> who;
vector<int> c;

bool solve(int mask, int pos) {
    vector<int> cur;
    for (int i = 0; i < n; i++) {
        if (mask & (1 << i)) {
            if (a[i].second >= pos) {
                cur.push_back(a[i].second);
            }
        } else {
            if (a[i].first >= pos) {
                cur.push_back(a[i].first);
            }
        }
    }
    for (int i = 0; i < m; i++) {
        if (c[i] >= pos) {
            cur.push_back(c[i]);
        }
    }
    sort(all(cur));
    auto it = upper_bound(all(cur), pos);
    if (it == cur.end()) {
        return true;
    }
    int nxt = *it;
    if (who[pos] == -1) {
        return !solve(mask, nxt);
    }
    int i = who[pos];
    if (nxt > a[i].second) {
        return true;
    }
    bool rev = 0;
    for (int npos = nxt; npos <= 2 * n + m; npos++) {
        if (who[npos] == -1) {
            rev ^= 1;
            continue;
        }
        if (!rev) {
            return !solve(mask, npos) || !solve(mask | (1 << i), npos);
        }
        return !(!solve(mask, npos) || !solve(mask | (1 << i), npos));
    }
    return rev;
}

void solve_case() {
    cin >> n >> m;
    a.resize(n);
    who.assign(2 * n + m + 1, -1);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].second;
    }
    sort(all(a));
    for (int i = 0; i < n; i++) {
        who[a[i].first] = i;
    }
    c.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> c[i];
    }
    sort(all(c));
    cout << (solve(0, min(a[0].first, c[0])) ? "First" : "Second") << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve_case();
    }
}