#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);


using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    vector<int> b(n);
    vector<int> c(m);
    cin >> a >> b >> c;

    vector<pair<int, int>> vals;
    for (int i = 0; i < n; ++i) {
        if (a[i] > b[i])
            vals.push_back({a[i], 0});
    }
    for (int i = 0; i < m; ++i) {
        vals.push_back({c[i], 1});
    }
    std::sort(vals.begin(), vals.end());

    for (int i = 0; i < vals.size(); ++i) {
        if (vals[i].second == 0) {
            if (i % 2 == 0) {
                cout << "First" << "\n";
                return 0;
            } else {
                cout << "Second" << "\n";
                return 0;
            }
        }
    }
    cout << (vals.size() % 2 == 0 ? "Second" : "First");
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}
