#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <string>
#include <vector>
#include <chrono>
#include <random>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>
#include <set>
#include <deque>
#define endl '\n'
#define mp make_pair

using namespace std;
using i64 = long long;
using ld = long double;

const i64 INF = 1e18 + 5;

mt19937 rnd(32);

i64 gcd_ext(i64 a, i64 b, i64& x, i64& y) {
	if (b == 0) {
		x = 1; y = 0;
		return a;
	}
	i64 x1 = 0, y1 = 0;
	i64 c = gcd_ext(b, a % b, x1, y1);
	x = y1, y = (-y1 * (a / b) + x1);
	return c;
}

i64 gcd(i64 a, i64 b) {
	while (b) swap(b, a %= b);
	return a;
}

const i64 S = 5e5 + 10;
i64 a[S], b[S], c[S];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	i64 n, m; cin >> n >> m;

	for (i64 x = 1; x <= n; ++x) {
		cin >> a[x];
	}

	for (i64 x = 1; x <= n; ++x) {
		cin >> b[x];
	}

	for (i64 x = 1; x <= m; ++x) {
		cin >> c[x];
	}

	bool g = rnd() % 2;
	if (g) cout << "First";
	else cout << "Second";
}