#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
#ifdef home
    freopen("f.in", "r", stdin);
    freopen("f.out", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i];
    }
    for (int i = 0; i < n; i++) {
        if (b[i] < a[i]) {
            b[i] = a[i];
        }
    }
    vector<array<int, 3>> dora;
    for (int i = 0; i < n; i++) {
        dora.push_back({a[i], 1, i});
    }
    for (int i = 0; i < n; i++) {
        dora.push_back({b[i], 2, i});
    }
    for (int i = 0; i < m; i++) {
        dora.push_back({c[i], 0, i});
    }
    ranges::sort(dora);
    int k = (int) dora.size();
    vector<int> remove(k);
    for (int i = k - 1; i >= 0; i--) {
        remove[i] = (dora[i][1] == 2);
        if (i + 1 < k) {
            remove[i] += remove[i + 1];
        }
    }
    vector<vector<int>> dp(k, vector<int>(k + 1, -1));
    auto calc = [&](auto &&self, int i, int cnt) -> bool {
        if (i == k) {
            assert(!cnt);
            return false;
        }
        if (dp[i][cnt] != -1) {
            return dp[i][cnt];
        }
        auto &[x, t, id] = dora[i];
        if (t == 0) {
            return dp[i][cnt] = !self(self, i + 1, cnt);
        } else if (t == 2) {
            if (remove[i] == cnt && cnt > 0) {
                return dp[i][cnt] = !self(self, i + 1, cnt - 1);
            }
            if (cnt > 0) {
                return dp[i][cnt] = (!self(self, i + 1, cnt - 1) || self(self, i + 1, cnt));
            } else {
                return dp[i][cnt] = self(self, i + 1, cnt);
            }
        } else {
            if (remove[i + 1] < cnt + 1) {
                return dp[i][cnt] = !self(self, i + 1, cnt);
            }
            return dp[i][cnt] = (!self(self, i + 1, cnt + 1) || !self(self, i + 1, cnt));
        }
    };
    cout << (calc(calc, 0, 0) ? "First\n" : "Second\n");
    return 0;
}
