#include "bits/stdc++.h"

using namespace std;

template<class T>
istream &operator>>(istream &is, vector<T> &vec) {
      for (auto &elem: vec) is >> elem;
      return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &vec) {
      for (auto &elem: vec) os << elem << ' ';
      os << '\n';
      return os;
}

signed main() {
#ifdef LOCAL
      freopen("input.txt", "r", stdin);
      freopen("output.txt", "w", stdout);
#else
      ios_base::sync_with_stdio(false);
      cin.tie(nullptr);
#endif
      int n, m;
      cin >> n >> m;
      vector<int> a(n), c(n), b(m);
      cin >> a >> c >> b;

      set<pair<int, int>> now;
      for (int i = 0; i < n; ++i) now.insert({a[i], i});
      for (int i = 0; i < m; ++i) now.insert({b[i], -1});
      function<bool()> rec = [&]() {
            if (now.empty()) return 1;

            auto mem = *now.begin();
            now.erase(mem);
            if (rec()) {
                  now.insert(mem);
                  return 0;
            }
            now.insert(mem);

            if (mem.second >= 0) {
                  int id = mem.second;
                  now.erase(mem);
                  now.insert({c[id], -1});
                  if (rec()) {
                        now.erase({c[id], -1});
                        now.insert(mem);
                        return 0;
                  }
                  now.erase({c[id], id});
                  now.insert(mem);
            }

            return 1;
      };

      if (rec()) {
            cout << "Second";
      } else {
            cout << "First";
      }
}