#ifdef ONPC
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;


mt19937_64 rng(chrono::steady_clock().now().time_since_epoch().count());

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    vector<int> cnt(2 * n + m + 1);
    for (int i = 0; i < n; i++) cin >> a[i], cnt[a[i]]++;
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < m; i++) cin >> c[i], cnt[c[i]]++;
    sort(c.begin(), c.end());
    sort(a.begin(), a.end());

    for (int i = 1; i <= 2 * n + m; i++) cnt[i] += cnt[i - 1];

    cout << (cnt[a.back()] % 2 == 1 ? "First\n" : "Second\n");

    return 0;
}
