#ifdef ONPC
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using i128 = __int128_t;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;


mt19937_64 rng(chrono::steady_clock().now().time_since_epoch().count());

int dp[1 << 20][21];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<array<int, 2>> a(n + 1);
    vector<int> c(m);
    vector<int> cnt(2 * n + m + 2);
    for (int i = 0; i < n; i++) cin >> a[i][0], cnt[a[i][0]]++;
    for (int i = 0; i < n; i++) cin >> a[i][1];
    for (int i = 0; i < m; i++) cin >> c[i], cnt[c[i]]++;
    a[n] = {2 * n + m + 1, -1};
    cnt[2 * n + m + 1]++;
    sort(a.begin(), a.end());

    for (int i = 1; i <= 2 * n + m + 1; i++) cnt[i] += cnt[i - 1];

    for (int mask = 0; mask < (1 << n); mask++) dp[mask][n] = 0;

    for (int now = n - 1; now >= 0; now--) {
        for (int mask = 0; mask < (1 << now); mask++) {
            dp[now][mask] = 0;

            int nxt = (cnt[a[now + 1][0]] - cnt[a[now][0] - 1]) & 1;
            for (int i = 0; i < now; i++) {
                if (((mask >> i) & 1) && a[now][0] < a[i][1] && a[i][1] < a[now + 1][0]) {
                    nxt ^= 1;
                }
            }
//            cout << now << ' ' << mask << ' ' << nxt << '\n';

            // flip
            nxt ^= (a[now][1] < a[now + 1][0]);
            if (1 ^ nxt ^ dp[mask | (1 << now)][now + 1]) dp[mask][now] = 1;
            // no flip
            nxt ^= (a[now][1] < a[now + 1][0]);
            if (1 ^ nxt ^ dp[mask][now + 1]) dp[mask][now] = 1;

//            cout << "dp[" << now << "][" << mask << "] = " << dp[now][mask] << '\n';
        }
    }

    cout << ((1 ^ (cnt[a[0][0]] & 1) ^ dp[0][0]) ? "First\n" : "Second\n");

    return 0;
}
