#include <iostream>
#include <algorithm>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <chrono>
#include <queue>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define allv(x) (x).begin(), (x).end()
#define allv_rev(x) (x).rbegin(), (x).rend()
#define lolset(x) memset(x, 0, sizeof (x))
#define lolfill(x, v) fill(x, x + sizeof(x) / sizeof(*x), v)
#define sz(x) ((int)(x).size())
using namespace std;
using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
mt19937 rnd(chrono::system_clock::now().time_since_epoch().count());
template<typename T, typename T2>
bool smin(T &a, T2 const& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}
template<typename T, typename T2>
bool smax(T &a, T2 const& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (T &i : v)
        is >> i;
    return is;
}




#ifdef DEBUG
const ll MAXN = 0, INF = 1e6;
#else
const ll MAXN = 0, INF = 1e9 + 1e6 * 228;
#define cerr if (0) cerr
#endif



signed one() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    cin >> a >> b >> c;
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> q;
    for (int i = 0; i < n; i++)
        q.push({a[i], i * 2});
    for (int i = 0; i < m; i++)
        q.push({c[i], i + 2 * n});
    bool hod = 0;
    while (!q.empty()) {
        auto [_, idx] = q.top();
        q.pop();
        hod ^= 1;
        if (idx < 2 * n) {
            int i = idx >> 1;
            if (idx & 1) {
                continue;
            } else {
                bool flag = true;
                for (int j = 0; j < n && flag; j++) {
                    if (min(a[j], b[j]) > min(a[i], b[i]) && max(a[j], b[j]) < max(a[i], b[i]))
                        flag = false;
                }
                if (!flag && a[i] < b[i])
                    continue;
                cout << (hod ? "First\n" : "Second\n");
                return 0;
            } 
        } else {
            int i = idx - 2 * n;
            continue;
        }
    }
    cout << (hod ? "Second\n" : "First\n");
    return 0;
}



signed main() {
#ifndef DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    signed t;
    t = 1;
    while (t--) {
        signed retcode = one();
        if (retcode) return retcode;
    }
    return 0;
}
