#include <bits/stdc++.h>


using namespace std;


using ll = long long;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


bool f(set<tuple<int, int, int>> &s, const vector<int> &b, const vector<int> &c, int pos) {
    if (int(s.size()) == 1 && pos == int(c.size())) {
        return 0;
    }
    bool win = 0;
    auto v = s.begin();
    int num = get<0>(*v);
    int side = get<1>(*v);
    int id = get<2>(*v);
    s.erase(v);
    auto it = upper_bound(c.begin(), c.end(), get<0>(*s.begin()));
    int dist = int(it - c.begin()) - pos;
    if (dist % 2 == 0) {
        win = win || !f(s, b, c, pos + dist);
    } else {
        win = win || f(s, b, c, pos + dist);
    }
    if (side == 0) {
        s.insert({b.at(id), 1, id});
        it = upper_bound(c.begin(), c.end(), get<0>(*s.begin()));
        dist = int(it - c.begin()) - pos;
        if (dist % 2 == 0) {
            win = win || !f(s, b, c, pos + dist);
        } else {
            win = win || f(s, b, c, pos + dist);
        }
    }
    return win;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    int mn = 2 * n + m;
    set<tuple<int, int, int>> s;
    s.insert({2 * n + m + 1, -1, -1});
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
        s.insert({a.at(i), 0, i});
    }
    for (int i = 0; i < n; i++) {
        cin >> b.at(i);
    }
    for (int i = 0; i < m; i++) {
        cin >> c.at(i);
    }
    sort(c.begin(), c.end());
    auto it = upper_bound(c.begin(), c.end(), get<0>(*s.begin()));
    int dist = int(it - c.begin());
    bool win = f(s, b, c, dist);
    if (dist % 2 == 0) {
        if (win) {
            cout << "First";
        } else {
            cout << "Second";
        }
    } else {
        if (win) {
            cout << "Second";
        } else {
            cout << "First";
        }
    }
    return 0;
}


/*1 2
3
4
1 2*/
