#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define db long double

using namespace std;
//using namespace __gnu_pbds;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, m; cin >> n >> m;

    vector<pair<int, int>> a(n);
    vector<int> b(m);

    vector<int> type(2 * n + m + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        type[a[i].first] = 1;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
        type[a[i].second] = 2;
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
    }

    sort(a.begin(), a.end());
    std::sort(b.begin(), b.end());

    vector<bool> res(n, 0);
    res[n - 1] = true;

    for (int i = n - 2; i >= 0; --i) {
        int cnt = 0;

        for (int el : b) {
            if (a[i].first <= el && el <= a[i + 1].first) ++cnt;
        }

        if (a[i].second <= a[i + 1].first) {
            res[i] = true;
            continue;
        }

        if (res[i + 1]) {
            if (cnt % 2 == 0) {
                res[i] = true;
            } else {
                res[i] = false;
            }
        } else {
            if (cnt % 2 == 1) {
                res[i] = true;
            } else {
                res[i] = false;
            }
        }
    }

    int ans = lower_bound(b.begin(), b.end(), a[0].first) - b.begin();
    if (res[0]) ++ans;

    if (ans % 2) {
        cout << "First";
    } else {
        cout << "Second";
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}