#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define db long double

using namespace std;
//using namespace __gnu_pbds;
//using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, m; cin >> n >> m;

    vector<pair<int, int>> a(n);
    vector<int> b(m);

    set<int> s;

    vector<int> type(2 * n + m + 1);
    vector<int> par(2 * n + m + 1, -1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first;
        type[a[i].first] = 1;
        s.insert(a[i].first);
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].second;
        type[a[i].second] = 2;
        par[a[i].first] = a[i].second;
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
        type[b[i]] = 3;
        s.insert(b[i]);
    }

    sort(a.begin(), a.end());
    sort(b.begin(), b.end());

    int cur = 0;
    while (!s.empty()) {
        int x = *s.begin(); s.erase(s.begin());

        if (par[x] != -1) {
            int dist = 0;

            for (auto el : s) {
                ++dist;

                if (par[el] == -1) continue;
                break;
            }

            if (dist % 2 == 1 || (dist == 0 && s.size() % 2)) {
                s.insert(par[x]);
            } 
        }

        cur = (cur + 1) % 2;
    }

    if (cur) {
        cout << "Second";
    } else {
        cout << "First";
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    int tt = 1;
    while (tt--) {
        solve();
        cout << "\n";
    }
}