#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <numeric>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <map>
#include <set>
#include <chrono>
#include <random>
#include <unordered_map>
#include <unordered_set>
using namespace std;
using ll = long long;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> a(n);
    vector<int> c(m);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first >> a[i].second;
    sort(a.begin(), a.end());
    for (int i = 0; i < m; ++i)
        cin >> c[i];
    int sz = 2 * n + m + 1;
    vector<pair<int, int>> col(sz);
    vector<int> cnt(n + 1);
    int j = 0;
    for (int i = 0; i < m; ++i){
        if (c[i] < a[0].first)
            cnt[0] = (cnt[0] + 1) % 2;
        else {
            while (j != n - 1 && c[i] > a[j + 1].first) {
                j++;
            }
            cnt[j + 1] = (cnt[j + 1] + 1) % 2;
        }
    }
    int f = cnt[0] % 2;
    for (int i = 1; i < n; ++i) {
        f = (f + (cnt[i] + 1) % 2);
    }
    if (f % 2 == 0)
        cout << "First";
    else
        cout << "Second";
}
