#include <fstream>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <queue>
#include <cmath>
#include <algorithm>
using namespace std;

using ll = long long;

//                                              ВАНЯ ПАНИН 542 ЛЕГЕНДА!!!!!

const int maxn = 15e5 + 7;
const int inf = 1e9 + 239;

int maxx = 0;

vector<int> tr(maxn, 0);

void add(int v, int l, int r, int i) {
    if (r - l == 1) {
        tr[v]++;
        return;
    }
    int m = (r + l) / 2;
    if (i >= l && i < m) {
        add(2 * v, l, m, i);
    } else {
        add(2 * v + 1, m, r, i);
    }
    tr[v] = tr[2 * v] + tr[2 * v + 1];
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return tr[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = (r + l) / 2;
    return get(2 * v, l, m, ql, qr) + get(2 * v + 1, m, r, ql, qr);
}


bool ans(priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> q) {
    auto cur = q.top();
    q.pop();
    int l = cur.first;
    int r = maxx;
    if (!q.empty()) {
        r = q.top().first;
    }
    int len = get(1, 0, maxx, l, r);
    bool fst = 0;
    bool scd = 0;
    if (q.empty()) {
        return true;
    }
    if (cur.second < cur.first) {
        return true;
        if (len % 2 == 1) {
            scd = !ans(q);
        } else {
            scd = ans(q);
        }
    } else {
        add(1, 0, maxx, cur.second);
        len = get(1, 0, maxx, l, r);
        if (len % 2 == 1) {
            scd = ans(q);
        } else {
            scd = !ans(q);
        }
    }
    if (len % 2 == 1) {
        fst = ans(q);
    } else {
        fst = !ans(q);
    }
    return fst || scd;
}



void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> b(n);
    vector<int> c(m);
    for (int i = 0;  i < n; i++) {
        cin >> a[i];
        maxx = max(maxx, a[i]);
    }
    for (int i = 0;  i < n; i++) {
        cin >> b[i];
        maxx = max(maxx, b[i]);
    }
    for (int i = 0;  i < m; i++) {
        cin >> c[i];
        maxx = max(maxx, c[i]);
    }
    maxx++;
    
    for (int i = 0; i < m; i++) {
        add(1, 0, maxx, c[i]);
    }
    
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> q;
    for (int i = 0; i < n; i++) {
        q.push({a[i], b[i]});
    }
    int len = get(1, 0, maxx, 0, q.top().first);
    if (/*ans(q) ^ */(len % 2 == 0)) {
        cout << "First";
    } else {
        cout << "Second";
    }
}


//                                              ВАНЯ ПАНИН 542 ЛЕГЕНДА!!!!!


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}

//                                              ВАНЯ ПАНИН 542 ЛЕГЕНДА!!!!!

