#include "bits/stdc++.h"
using namespace std;
# define int long long
# define all(a) a.begin(), a.end()
const int INF = 1e18;
map<vector<pair<int, int>>, int> mem;
int rq(vector<pair<int, int>> &a){
    if(!mem.count(a)) {
        int best = 0;
        int cnt1 = 0, cnt2 = 0;
        for (int i = 0; i < a.size(); ++i) {
            if (a[i].first < a[best].first) {
                best = i;
            }
            cnt1 += a[i].second == INF;
            cnt2 += a[i].first != INF;
        }
        if (a[best].first == INF) {
            mem[a] = 1;
            return 1;
        }
        if(cnt1 == a.size()){
            mem[a] = (cnt2 + 1) % 2;
            return (cnt2 + 1) % 2;
        }
        auto tmp = a[best];
        a[best].first = a[best].second;
        a[best].second = INF;
        int res = rq(a);
        a[best] = tmp;
        if (res == 1) {
            mem[a] = 0;
            return 0;
        }
        a[best] = {INF, INF};
//    return rq(cur)
        res = rq(a);
        a[best] = tmp;
        if (res == 1) {
            mem[a] = 0;
            return 0;
        }
        mem[a] = 1;
        return 1;
    }
    return mem[a];
}

signed main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
//    cerr << sizeof(node);
//cerr << (int)pow(3, 14);
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for(auto &i : a) cin >> i;
    for(auto &i : b) cin >> i;
    for(auto &i : c) cin >> i;
    vector<pair<int, int>> d(n + m);
    for(int i = 0; i < n; ++i){
        d[i] = {a[i], b[i]};
    }
    for(int i = n; i < n + m; ++i){
        d[i] = {c[i - n], INF};
    }
    int ans = rq(d);
    if(ans == 0){
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
    return 0;
}