#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <iomanip>

using namespace std;

long long n, m;
vector<pair<long long, long long>> v1;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;

	v1.resize(n + m, { -1, -1 });

	for (long long i = 0; i < n; ++i)
		cin >> v1[i].first;
	for (long long i = 0; i < n; ++i)
		cin >> v1[i].second;
	for (long long j = n; j < n + m; ++j)
		cin >> v1[j].first;

	sort(v1.begin(), v1.end());

	vector<long long> dp(n + m);

	dp[n + m - 1] = 1;

	for (long long i = n + m - 2; i >= 0; --i) {
		if (dp[i + 1] == 0) {
			dp[i] = 1;
			continue;
		}
		if (v1[i].second != -1) {
			dp[i] = 1;
			continue;
		}
		dp[i] = 0;
	}

	//if (dp[0] == 0)
		//cout << "Second";
	//else
		cout << "First";
	return 0;
}
