#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <random>
#include <time.h>
#include <climits>
//#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

using namespace std;
using ll = long long;
using ld = long double;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution <> distr(0, INT_MAX);

struct el {
	int x, t, num;
	el() {}
	el(int x, int t, int num) {
		this->x = x;
		this->t = t;
		this->num = num;
	}
};

bool cmp(el& a, el& b) {
	return a.x < b.x;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	vector<pair<int, int>> v;
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		v.push_back({ a, -1 });
	}
	for (int i = 0; i < n; i++) {
		cin >> v[i].second;
	}
	for (int i = 0; i < m; i++) {
		int x;
		cin >> x;
		v.push_back({ x, -1 });
	}
	sort(v.begin(), v.end());
	int f = -1;
	int switcht = -1;
	for (int i = 0; i < v.size(); i++) {
		if (v[i].second != -1) {
			f = i;
			//break;
		}
		if (v[i].second != -1 && v[i].first > v[i].second && switcht == -1) {
			switcht = i;
		}
	}
	if (switcht == -1) {
		switcht = n;
	}
	stack<int> lasts;
	vector<el> ev;
	for (int i = 0; i < switcht; i++) {
		if (v[i].second > switcht || v[i].second == -1)
			continue;
		ev.push_back(el(v[i].first, 1, i));
		ev.push_back(el(v[i].second, -1, i));
	}
	vector<int> nums(2 * n + m + 1, -1);
	sort(ev.begin(), ev.end(), cmp);
	if (ev.empty()) {
		if (switcht & 1)
			cout << "Second";
		else
			cout << "First";
		return 0;
	}
	for (auto i : ev) {
		if (i.t == 1) {
			int formal = 1;
			if (i.num & 1)
				formal = 2;
			if (!lasts.empty() && lasts.top() != formal)
				formal = 3 - formal;
			nums[i.num] = formal;
		}
		else {
			lasts.push(nums[i.num]);
		}
	}
	if (lasts.top() == 1)
		cout << "First";
	else
		cout << "Second";
}
