//#pragma GCC optimize("O3, Ofast, unroll-loops, inline, no-stack-protector")
#include <bits/stdc++.h>
//#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using pii = pair<int, int>;

vector<int> a, b, c;
int n, m;


int gen(set<pii> &s, vector<int> &used) {
    if (s.empty()) return 0;
    auto [val, i] = *s.begin();
    s.erase(s.begin());
    if (i >= n) {
        int res = 0;
        if (!gen(s, used)) {
            res = 1;
        }
        s.insert({val, i});
        return res;
    }
    int res = 0;
    if (!used[i]) {
        used[i] = 1;
        s.insert({b[i], i});
        if (!gen(s, used)) {
            res = 1;
        }
        s.erase({b[i], i});
        used[i] = 0;
    }
    if (!gen(s, used)) {
        res = 1;
    }
    s.insert({val, i});
    return res;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 0; i < m; ++i) cin >> c[i];
    vector<pii> s(n + m);
    for (int i = 0; i < n; ++i) s[i] = {a[i], i};
    for (int j = 0; j < m; ++j) s[n + j] = {c[j], j + n};
    std::sort(s.begin(), s.end());
    int last = 0;
    for (int i = 0; i < n + m; ++i) {
        if (s[i].second < n) {
            last = i % 2;
        }
    }
    if (last == 0) {
        cout << "First";
    } else {
        cout << "Second";
    }
}
