//#pragma GCC optimize("O3, Ofast, unroll-loops, inline, no-stack-protector")
#include <bits/stdc++.h>
//#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using pii = pair<int, int>;

vector<int> a, b, c;
int n, m;


int gen(set<pii> &s, vector<int> &used) {
    if (s.empty()) return 0;
    auto [val, i] = *s.begin();
    s.erase(s.begin());
    if (i >= n) {
        int res = 0;
        if (!gen(s, used)) {
            res = 1;
        }
        s.insert({val, i});
        return res;
    }
    int res = 0;
    if (!used[i]) {
        used[i] = 1;
        s.insert({b[i], i});
        if (!gen(s, used)) {
            res = 1;
        }
        s.erase({b[i], i});
        used[i] = 0;
    }
    if (!gen(s, used)) {
        res = 1;
    }
    s.insert({val, i});
    return res;
}

vector<pii> s;
vector<int> pos_a, pos_b;

pair<int, int> calc(int l, int r) {
        int dp_last0[2];
        dp_last0[0] = 1;
        dp_last0[1] = 0;
        int dp_last1[2];
        dp_last1[0] = 1;
        dp_last1[1] = 0;
        for (int i = r - 1; i >= l; --i) {
            int j = s[i].second;
            int dp_now0[2]{};
            int dp_now1[2]{};
            if (j >= n && j < 2 * n) {
                int pos = pos_a[j - n];
                if (pos > i) continue;
                auto [res0, res1] = calc(pos + 1, i);
                if (!res0) {
                    dp_now0[0] = 1;
                    dp_now1[1] = 1;
                }

                if (!res1) {
                    dp_now0[0] = 1;
                    dp_now1[1] = 1;
                }

                i = pos;
                if (dp_now0[0] != 1) dp_now0[1] = 1;
                if (dp_now1[1] != 1) dp_now1[0] = 1;
                swap(dp_last0, dp_now0);
                swap(dp_last1, dp_now1);
            } else {
                if (j >= 2 * n) {
                    swap(dp_last0[0], dp_last0[1]);
                    swap(dp_last1[0], dp_last1[1]);
                } else {
                    dp_last0[1] = 0;
                    dp_last1[1] = 1;
                    dp_last1[0] = 0;
                    dp_last0[0] = 1;
                }
            }
        }
        return {dp_last0[0], dp_last1[1]};

}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 0; i < m; ++i) cin >> c[i];
    s.resize(2 * n + m);
    for (int i = 0; i < n; ++i) s[i] = {a[i], i};
    for (int i = 0; i < n; ++i) s[i + n] = {b[i], i + n};
    for (int j = 0; j < m; ++j) s[2 * n + j] = {c[j], j + 2 * n};
    std::sort(s.begin(), s.end());
    pos_a.resize(n);
    pos_b.resize(n);
    for (int i = 0; i < 2 * n + m; ++i) {
        if (s[i].second < n) {
            pos_a[s[i].second] = i;
        } else if (s[i].second < 2 * n) {
            pos_b[s[i].second - n] = i;
        }
    }
    if (calc(0, 2 * n + m).first) {
        cout << "First";
    } else {
        cout << "Second";
    }
}
