//#pragma GCC optimize("O3, Ofast, unroll-loops, inline, no-stack-protector")
#include <bits/stdc++.h>
//#pragma GCC target("avx2")

using namespace std;

using ll = long long;
using pii = pair<int, int>;

vector<int> a, b, c;
int n, m;


int gen(set<pii> &s, vector<int> &used, int last) {
    if (s.empty()) return 0;
    auto [val, i] = *s.begin();
    int id = std::upper_bound(c.begin(), c.end(), last) - c.begin();
    int id2 = std::lower_bound(c.begin(), c.end(), val) - c.begin();
    if ((id2 - id) % 2 == 0) {
        s.erase(s.begin());
        int res = 0;
        if (!used[i]) {
            used[i] = 1;
            s.insert({b[i], i});
            if (!gen(s, used, a[i])) {
                res = 1;
            }
            s.erase({b[i], i});
            used[i] = 0;
        }
        if (!gen(s, used, a[i])) {
            res = 1;
        }
        s.insert({val, i});
        return res;
    } else {
        s.erase(s.begin());
        int res = 0;
        if (!used[i]) {
            used[i] = 1;
            s.insert({b[i], i});
            if (!gen(s, used, a[i])) {
                res = 1;
            }
            s.erase({b[i], i});
            used[i] = 0;
        }
        if (!gen(s, used, a[i])) {
            res = 1;
        }
        s.insert({val, i});
        return 1 - res;
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 0; i < m; ++i) cin >> c[i];
    vector<int> used(n);
    set<pii> s;
    for (int i = 0; i < n; ++i) {
        s.insert({a[i], i});
    }
    std::sort(c.begin(), c.end());
    if (gen(s, used, -1)) {
        cout << "First";
    } else {
        cout << "Second";
    }
}
