#include <bits/stdc++.h>
#define int long long

using namespace std;

string s; // ()  (o)
vector<int> pr;
pair<int, int> dfs(int l, int r) {
    int ans1 = 1, ans2 = 0;
    int st = -1;
    for (int i = l; i <= r; ++i) {
        if (s[i] == 'o') {
            swap(ans1, ans2);
        } else {
            if (s[i] == '(') {
                st = i;
                i = pr[i];
                swap(ans1, ans2);
                auto [g1, g2] = dfs(st + 1, i - 1);
                if (g1 != g2) {
                    ans2 = ans1;
                } else {
                    if (g1 == 0) {
                        ans1 = ans2;
                    } else {
                        ans2 = ans1;
                    }
                }
            }
        }
    }
    return {ans1, ans2};
}

void solve() {
    int n, m; cin >> n >> m;
    vector<int> a(n), b(n), c(n);
    vector<pair<int, int>> ev;
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; a[i] *= 2;
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i]; b[i] *= 2;
    }
    for (int i = 0; i < m; ++i) {
        cin >> c[i]; c[i] *= 2;
    }
    for (int i = 0; i < n; ++i) {
        if (a[i] < b[i]) {
            ev.push_back({a[i], 0});
            ev.push_back({b[i], 1});
        } else {
            ev.push_back({a[i] - 1, 0});
            ev.push_back({a[i], 1});
        }
    }
    for (int i = 0; i < m; ++i) {
        ev.push_back({c[i], 2});
    }
    sort(ev.begin(), ev.end());
    for (auto [x, tp]: ev) {
        if (tp == 0) {
            s.push_back('(');
        } else if (tp == 1) {
            s.push_back(')');
        } else {
            s.push_back('o');
        }
    }
    // cin >> s;
    pr.resize(s.size());
    vector<int> st;
    int ii = 0;
    for (int i = (int) s.size() - 1; i >= 0; --i) {
        if (s[i] == ')') {
            st.push_back(i);
        }
        if (s[i] == '(') {
            if (st.empty()) {
                while (true) {
                    ++ii;
                }
            }
            pr[i] = st.back();
            st.pop_back();
        }
    }
    // cout << s << '\n';
    auto [ans1, ans2] = dfs(0, s.size() - 1);
    cout << (ans1 == 0? "First" : "Second") << '\n';
}

signed main(void) {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n = 1;
    for (int i = 0; i < n; ++i) {
        solve();
    }
}