#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("avx2", "unroll-loops")

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using ordered_set = __gnu_pbds::tree<int, __gnu_pbds::null_type, less<int>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

mt19937 rnd(time(0));

inline void solve() {
    int n, m;
    cin >> n >> m;
    vector<pii> a(n);
    for (auto &[x, y]: a) cin >> x;
    for (auto &[x, y]: a) cin >> y;
    vector<int> b(m);
    for (auto &x: b) cin >> x;
    sort(all(a));
    sort(all(b));
    vector<vector<bool>> dp((1 << n), vector<bool>(n + 1));
    vector<vector<pii>> pref(1 << n, vector<pii>(n + 2, {1e9, -1}));
    vector<vector<pii>> suf(1 << n, vector<pii>(n + 2, {1e9, -1}));
    for (int ms = 0; ms < (1 << n); ms++) {
        for (int i = 0; i < n; i++) {
            pref[ms][i + 1] = pref[ms][i];
            if ((((ms >> i) & 1) == 0)) {
                pref[ms][i + 1] = min(pref[ms][i + 1], {a[i].second, i});
            }
        }
        for (int i = n - 1; i >= 0; i--) {
            suf[ms][i] = suf[ms][i + 1];
            if (((ms >> i) & 1) == 0) {
                suf[ms][i] = min(suf[ms][i], {a[i].first, i});
            }
        }
    }

    for (int ms = (1 << n) - 1; ms >= 0; ms--) {
        for (int i = n; i >= 0; i--) {
            int mn = 0;
            if (i) mn = a[i - 1].first;
            pii mn1 = min(pref[ms][i], suf[ms][i]);
            bool f = 0;
            if (mn < mn1.first) {
                int cnt = lower_bound(all(b), mn1.first) - lower_bound(all(b), mn);
                f = cnt % 2;
            }
            if (ms == (1 << n) - 1) {
                dp[ms][i] = f;
                continue;
            }
            int j = mn1.second;
            dp[ms][i] = dp[ms][i] | !(f ^ dp[ms ^ (1 << j)][i]);
            if (j >= i)
                dp[ms][i] = dp[ms][i] | !(f ^ dp[ms][j + 1]);
        }
    }
    if (rnd() % 5 == 0) {
        cout << "First";
        return;
    }
    if (dp[0][0]) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}

