#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3")
#endif

#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) int((x).size())
using pii = pair<int, int>;
using pll = pair<int64_t, int64_t>;
using ll = int64_t;
using ull = uint64_t;
using ld = long double;

mt19937_64 rnd(52);

void answer(bool first_won) {
    if (first_won) {
        cout << "First\n";
    }
    else {
        cout << "Second\n";
    }
    exit(0);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < m; i++) cin >> c[i];
    priority_queue<pii, vector<pii>, greater<>> table;
    for (int i = 0; i < n; i++) {
        table.push({a[i], i});
    }
    for (int i = 0; i < m; i++) {
        table.push({c[i], -1});
    }
    int ragnarok = 1e9;
    bool first_wins = false;
    bool first_moves = true;
    while (table.size()) {
        auto [x, i] = table.top();
        table.pop();
        if (x > ragnarok) {
            answer(first_wins);
        }
        if (i != -1 && b[i] < ragnarok) {
            ragnarok = b[i];
            first_wins = first_moves;
        }
        first_moves = !first_moves;
    }
    answer(first_wins);
    // int i = 0;
    // for (auto [x, y] : table) {
    //     if (y == 0) {
    //         if (i % 2 == 0) {
    //             cout << "First\n";
    //         }
    //         else {
    //             cout << "Second\n";
    //         }
    //         return;
    //     }
    //     i++;
    // }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) solve();
}