#include <string>
#include <bitset>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <map>
#include <set>

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

// #define SUBMIT

#ifdef SUBMIT
#pragma GCC optimize("Ofast,unroll-loops")
#endif

void fast() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cout << setprecision(8) << fixed;
}

ll mod = 1e9 + 7;
ll binpow(ll a, ll n) {
    ll res = 1;
    for (int i = 0; (1ll << i) <= n; ++i, a = a * a % mod) {
        if ((n >> i) & 1) res = res * a % mod;
    }
    return res;
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    for (auto& el : a) cin >> el;
    for (auto& el : b) cin >> el;
    for (auto& el : c) cin >> el;
    vector<pair<int, int>> arr(n + m);
    for (int i = 0; i < n; ++i) {
        arr[i] = make_pair(a[i], b[i]);
    }
    for (int i = 0; i < m; ++i) {
        arr[i + n] = make_pair(c[i], -1);
    }
    sort(all(arr));
    vector<bool> dp(n + m);
    dp.back() = true;
    for (int i = n + m - 2; i >= 0; --i) {
        if (arr[i].second == -1) {
            dp[i] = !dp[i + 1];
        } else {
            dp[i] = true;
        }
    }
    if (dp[0]) {
        cout << "First";
    } else {
        cout << "Second";
    }
}
int main() {
    fast();
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}