//#define _GLIBCXX_DEBUG
//#define _GLIBCXX_DEBUG_PEDANTIC

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define OPTIMIZETHISSHIT ios::sync_with_stdio(false); cin.tie(nullptr);
#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define fi first
#define se second

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937_64 rng(0);

int rand(int l, int r) {
    return uniform_int_distribution<int>(l, r)(rng);
}

vector<array<int, 2>> a;
vector<int> c;

int swap_bits(int mask, int x, int y) {
    bool bit1 = mask & (1 << x);
    bool bit2 = mask & (1 << y);
    mask &= ~(1 << x);
    mask &= ~(1 << y);
    mask |= (bit2 << x);
    mask |= (bit1 << y);
    return mask;
}

bool rec(int mask, int d1, int d2, int p) {
    if (d1 + d2 == a.size() + c.size()) return p;
    int mn;
    if (d2 < c.size()) {
        mn = c[d2];
    } else {
        mn = INT_MAX;
    }
    int j = -1;
    for (int i = d1; i < a.size(); i++) {
        if (a[i][(mask >> i) & 1] < mn) {
            mn = a[i][(mask >> i) & 1];
            j = i;
        }
    }
    if (j == -1) {
        return rec(mask, d1, d2 + 1, !p);
    } else {
        if (mask & (1 << j)) {
            swap(a[d1], a[j]);
            mask = swap_bits(mask, d1, j);
            bool res = rec(mask, d1 + 1, d2, !p);
            swap(a[d1], a[j]);
            mask = swap_bits(mask, d1, j);
            return res;
        } else {

            swap(a[d1], a[j]);
            mask = swap_bits(mask, d1, j);
            bool res = rec(mask, d1 + 1, d2, !p);
            swap(a[d1], a[j]);
            mask = swap_bits(mask, d1, j);

            mask |= (1 << j);
            bool res1 = rec(mask, d1, d2, !p);
            mask ^= (1 << j);

            if (p) {
                return res | res1;
            } else {
                return res & res1;
            }
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    a.resize(n);
    c.resize(m);
    for (int i = 0; i < n; i++) cin >> a[i][0];
    for (int i = 0; i < n; i++) cin >> a[i][1];
    for (int i = 0; i < m; i++) cin >> c[i];
    sort(all(c));
    bool ans = rec(0, 0, 0, true);
    cout << (ans ? "First" : "Second") << endl;
}

signed main() {
    OPTIMIZETHISSHIT

    solve();
}