// semenInRussia 2025
#pragma GCC optimize("Ofast,unroll-loops")
#include <algorithm>
#include <cstdint>
#include <iostream>
#include <vector>
using namespace std;
#pragma GCC target("avx2")

vector<pair<int, int>> v;

bool f() {
  if (v.empty()) {
    return false;
  }

  int k = -1;
  for (int i = 0; i < (int)v.size(); i++) {
    if (k == -1 || v[k].first > v[i].first) {
      k = i;
    }
  }

  auto old = v[k];
  bool ans = false;

  if (v[k].second != -1) {
    swap(v[k].first, v[k].second);
    v[k].second = -1;
    ans |= !f();
    v[k] = old;
  }

  v.erase(v.begin() + k);
  ans |= !f();
  v.insert(v.begin() + k, old);

  return ans;
}

int main() {
  int n, m;
  cin >> n >> m;
  v.resize(n + m);
  for (int i = 0; i < n; i++) {
    cin >> v[i].first;
  }
  for (int i = 0; i < n; i++) {
    cin >> v[i].second;
  }
  for (int i = 0; i < m; i++) {
    cin >> v[i + n].first;
    v[i + n].second = -1;
  }

  bool ans = f();
  cout << (ans ? "First" : "Second");
}