// semenInRussia 2025
#pragma GCC optimize("Ofast,unroll-loops")
#include <algorithm>
#include <cstdint>
#include <iostream>
#include <queue>
#include <set>
#include <vector>
using namespace std;
#pragma GCC target("avx2")

set<pair<int, int>> v;

bool f() {
  if (v.empty()) {
    return false;
  }

  auto it = v.begin();
  auto old = *it;
  bool ans = false;

  if (old.second != -1) {
    v.erase(it);
    pair<int, int> nw = {old.second, -1};
    v.insert(nw);
    ans |= !f();
    v.erase(nw);
    v.insert(old);
  }

  v.erase(old);
  ans |= !f();
  v.insert(old);

  return ans;
}

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, m;
  cin >> n >> m;
  vector<int> a(n), b(n), c(m);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  for (int i = 0; i < n; i++) {
    cin >> b[i];
  }
  for (int i = 0; i < m; i++) {
    cin >> c[i];
  }

  for (int i = 0; i < n; i++) {
    v.insert({a[i], b[i]});
  }
  for (int i = 0; i < m; i++) {
    v.insert({c[i], -1});
  }

  bool ans = f();
  cout << (ans ? "First" : "Second");
}