// semenInRussia 2025
#pragma GCC optimize("Ofast,unroll-loops")
#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;
#ifndef home
#pragma GCC target("avx2")
#endif

int main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, m;
  cin >> n >> m;
  vector<int> a(n), b(n), c(m);

  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  for (int i = 0; i < n; i++) {
    cin >> b[i];
  }
  for (int i = 0; i < m; i++) {
    cin >> c[i];
  }

  vector<pair<int, int>> v(n + m);
  for (int i = 0; i < n; i++) {
    v[i] = {a[i], b[i]};
  }
  for (int i = 0; i < m; i++) {
    v[i + n] = {c[i], -1};
  }

  sort(v.rbegin(), v.rend());

  vector<vector<int>> dp(n + m + 1, vector<int>(n + 1));

  for (int j = 0; j <= n; j++) {
    dp[0][j] = j & 1;
  }

  for (int i = 0; i < n + m; i++) {
    for (int j = 0; j <= n; j++) {
      if (v[i].second != -1) {
        dp[i + 1][j] |= dp[i][j + 1];
      }
      dp[i + 1][j] |= dp[i][j];
    }
  }

  bool ans = 0;
  for (int j = 0; j <= n; j++) {
    ans |= dp[n + m][j];
  }

  cout << (ans ? "First" : "Second");
}