#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = int(1e9) + 7, lg = 20;
const ll inf = ll(2e18) + 36;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll n, m;
vector<ll> a, b, c;

bool rec(set <pair <ll, ll>> cur) {
    if (cur.empty()) {
        return false;
    }
    auto [x, p] = *cur.begin();
    cur.erase(cur.begin());
    if (p >= n) {
        return !rec(cur);
    }
    bool win = false;
    win |= !rec(cur);
    cur.emplace(b[p], p + n);
    win |= !rec(cur);
    return win;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (auto &it: a) cin >> it;
    for (auto &it: b) cin >> it;
    for (auto &it: c) cin >> it;
    sort(c.begin(), c.end());
    set <pair <ll, ll>> cur;
    for (ll i = 0; i < n; i++) {
        cur.emplace(a[i], i);
    }
    for (ll j = 0; j < m; j++) {
        cur.emplace(c[j], n * 2 + j);
    }
    cout << (rec(cur) ? "First" : "Second");
    return 0;
}
