#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template <class T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = int(1e9) + 7, lg = 20;
const ll inf = ll(2e18) + 36;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll n, m; cin >> n >> m;
    vector <ll> a(n), b(n), c(m);
    for (auto& it : a) cin >> it;
    for (auto& it : b) cin >> it;
    for (auto& it : c) cin >> it;
    set <pair <ll, ll>> cur;
    for (ll i = 0; i < n; i++) {
        cur.insert({a[i], i});
    }
    for (ll i = 0; i < m; i++) {
        cur.insert({c[i], n * 2 + i});
    }
    vector <pair <ll, ll>> tp;
    for (ll i = 0; i < n; i++) {
        tp.emplace_back(a[i], b[i]);
    }
    for (ll i = 0; i < m; i++) {
        tp.emplace_back(c[i], -1);
    }
    vector <bool> win(n * 2 + m + 1);
    ll k = 0;
    for (ll i = n + m - 1; i >= 0; i--) {
        k++;
        if (!win[k - 1]) {
            win[k] = true;
        }
        if (tp[i].second >= 0) {
            k++;
            if (!win[k - 2]) {
                win[k] = true;
            }
        }
    }
    cout << (win[n * 2 + m] ? "First" : "Second");
    return 0;
}
