#include <bits/stdc++.h>

#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
template<class T> using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = int(1e9) + 7, lg = 20;
const ll inf = ll(2e18) + 36;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ll n, m;
    cin >> n >> m;
    vector<ll> a(n), b(n), c(m);
    for (auto &it: a) cin >> it;
    for (auto &it: b) cin >> it;
    for (auto &it: c) cin >> it;
    vector<pair<ll, ll>> tp;
    for (ll i = 0; i < n; i++) {
        tp.emplace_back(a[i], i);
    }
    for (ll i = 0; i < m; i++) {
        tp.emplace_back(c[i], i + n * 2);
    }
    sort(tp.begin(), tp.end());
    vector<ll> t;
    for (ll i = 0; i < n + m; i++) {
        t.emplace_back(tp[i].second);
        if (tp[i].second < n) {
            t.emplace_back(tp[i].second + n);
        }
    }
    ll all = n * 2 + m;
    vector<bool> win(all + 1);
    ll k = 0;
    vector <vector <ll>> g(all + 1);
    for (ll i = 0; i < all; i++) {
        g[all - i].emplace_back(all - i - 1);
        if (t[i] < n) {
            g[all - i].emplace_back(all - i - 2);
        }
    }
    for (ll i = 0; i <= all; i++) {
        for (auto& j : g[i]) {
            if (!win[j]) {
                win[i] = true;
                break;
            }
        }
    }
    cout << (win[n * 2 + m] ? "First" : "Second");
    return 0;
}
