#pragma GCC optimize("O3, unroll-loops, no-stack-protector")
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <string>
#define int long long

using namespace std;

const int INF = 2e15;

struct Card {
	int type;
	int a, b;
	bool isA;
};

bool operator<(Card f, Card s) {
	int v1 = f.a;
	if (!f.isA) {
		v1 = f.b;
	}
	int v2 = s.a;
	if (!s.isA) {
		v2 = s.b;
	}
	return v1 < v2;
}

map <multiset<Card>, int> mp;

bool game(multiset <Card> &st) {
	if (st.empty()) {
		return false;
	}
	if (mp.find(st) != mp.end()) {
		return mp[st];
	}
	auto c = *st.begin();
	st.erase(st.begin());
	if (c.type == 1 || !c.isA) {
		bool ans = !game(st);
		st.insert(c);
		mp[st] = ans;
		return ans;
	}
	bool fir = !game(st);
	st.insert({ 2, c.a, c.b, false });
	bool sec = !game(st);
	if (!sec && !fir) {
		st.erase(st.find({ 2, c.a, c.b, false }));
		st.insert(c);
		mp[st] = false;
		return false;
	}
	st.erase(st.find({ 2, c.a, c.b, false }));
	st.insert(c);
	mp[st] = true;
	return true;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, m;
	cin >> n >> m;
	vector <pair<int, int>> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first;
	}
	for (int i = 0; i < n; i++) {
		cin >> arr[i].second;
	}
	vector <int> brr(m);
	for (int i = 0; i < m; i++) {
		cin >> brr[i];
	}
	multiset <Card> st;
	for (auto el : arr) {
		st.insert({ 2, el.first, el.second, true });
	}
	for (auto el : brr) {
		st.insert({ 1, el, 0, true });
	}
	if (game(st)) {
		cout << "First";
	}
	else {
		cout << "Second";
	}
}
