#include <iostream>
#include <vector>
#include <map>
#include <random>
#include <set>
#include <algorithm>
#include <assert.h>
using namespace std;

#define int long long
#define ll long long
#define vi vector<int>
#define pi pair<int, int>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define vpi vector<pi>
#define vvi vector<vi>
#define gb(a, b) (((a) >> (b)) & 1)



signed main() {

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);


	int n, m;
	cin >> n >> m;
	int lw = 2 * n + m;
	vi typ(2 * n + m + 1);
	vi link(2 * n + m + 1);
	vi uplink(2 * n + m + 1);
	vi a(n);
	vi b(n);
	vi c(m);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		typ[a[i]] = 1;
		uplink[a[i]] = i;
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		if (b[i] < a[i]) {
			lw = min(lw, a[i]);
			typ[b[i]] = -1;
		}
		else {
			typ[b[i]] = 2;
		}
		link[a[i]] = b[i];
		uplink[b[i]] = i;
	}
	for (int i = 0; i < m; i++) {
		cin >> c[i];
	}
	vvi dp(2 * n + m + 1, vi(1 << n));
	dp[lw] = vi(1 << n, 1);
	for (int i = lw - 1; i > -1; i--) {
		for (int mask = 0; mask < (1 << n); mask++) {
			if (typ[i] == 0) {
				dp[i][mask] = 1 - dp[i + 1][mask];
			}
			else if (typ[i] == -1) {
				dp[i][mask] = dp[i + 1][mask];
			}
			else if (typ[i] == 2) {
				if (gb(mask, uplink[i])) {
					dp[i][mask] = 1 - dp[i + 1][mask];
				}
				else {
					dp[i][mask] = dp[i + 1][mask];
				}
			}
			else {
				if (gb(mask, uplink[i])) continue;
				dp[i][mask] = max(1 - dp[i + 1][mask + (1 << uplink[i])], 1 - dp[i + 1][mask]);
			}
		}
	}
	int tt = 1;
	while (typ[tt] != 0 && typ[tt] != 1) tt++;
	if (dp[tt][0]) {
		cout << "First";
	}
	else {
		cout << "Second";
	}
}
