//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
#define int long long
using ll = long long;
using ld = long double;
template <typename t>
ostream& operator<<(ostream& out, const vector<t> &v){
    for(auto x: v)out<<x<<" ";
    return out;
}
template <typename t>
istream& operator>>(istream& in,  vector<t> &v){
    for(auto &x: v)in>>x;
    return in;
}
template <typename t, typename u>
ostream& operator<<(ostream& out, const pair<t, u> p){
    out<<p.first<<" "<<p.second<<"\n";
    return out;
}
template <typename t, typename u>
istream& operator>>(istream& in,  pair<t, u> &p){
    in>>p.first>>p.second;
    return in;
}
__int128_t one = 1;
struct SegTree{
    vector<ll> t, add, a;
    ll sz;
    SegTree(vector<ll> v = {1}){
        sz = v.size();
        add.resize(4*sz);
        t.resize(4*sz);
        a = v;
        build(1, 0, sz);
    }
    void build(ll v, ll l, ll r){
        if(l+1==r){
            t[v]=a[l];
        }
        else{
            ll m =  (r+l)/2;
            build(2*v, l, m);
            build(2*v+1, m, r);
            t[v]=t[2*v]+t[2*v+1];
        }
    }
    ll get(ll l, ll r){
        return _get(1, 0, sz, l, r);
    }
    void push(ll v, ll tl, ll tr){
        t[v]+=add[v]*(tr-tl);
        if(tl+1!=tr){
            add[2*v]+=add[v];
            add[2*v+1]+=add[v];
        }
        add[v]=0;
    }
    ll _get(ll v, ll tl, ll tr, ll l, ll r){
        push(v, tl, tr);
        if(l<=tl&&tr<=r){
            return t[v];
        }
        ll tm = (tr+tl)/2;
        if(tm>=r){
            return _get(2*v, tl, tm, l, r);
        }
        if(tm<=l){
            return _get(2*v+1, tm, tr, l, r);
        }
        return _get(2*v, tl, tm, l, tm)+_get(2*v+1, tm, tr, tm, r);
    }
    void update(ll l, ll r, ll val){
        _update(1, 0, sz, l, r, val);
    }
    void _update(ll v, ll tl, ll tr, ll l, ll r, ll val){
        if(tl>=r||l>=tr){
            return;
        }
        if(l<=tl&&tr<=r){
            add[v]+=val;
            push(v, tl, tr);
            return;
        }
        push(v, l, r);
        ll tm = (tr+tl)/2;
        _update(2*v, tl, tm, l, r, val);
        _update(2*v+1, tm, tr, l, r, val);
        t[v]=t[2*v]+t[2*v+1];
    }
};
// vector<ll> val, dp, tin, tout, go, mn;
// vector<vector<ll>> g;
// ll cnt = 0, ans = 0;
// bool is_anc(ll par, ll son){
//     return tin[par]<=tin[son]&&tout[son]<=tout[par];
// }
// void dfs(ll v, ll cur, ll base){
//     //cout<<v<<" "<<cur<<"\n";
//     assert(v!=base);
//         cnt++;
//         dp[v]++;
//     for(auto to: g[v]){
//         if((is_anc(v, base)&&(val[to]>mn[v]&&!is_anc(to, base)))||(!is_anc(v, base)&&val[to]>cur)||(is_anc(to, base)&&to!=base)){
//             if(is_anc(v, base)&&!is_anc(to, base)){
//                 cur = mn[v];
//             }
//             dfs(to, cur, base);
//             dp[v]+=dp[to];
//         }
//     }
//     if(!is_anc(v, base))ans = max(ans, dp[v]);
// }
// ll tim = 0;
// void dfsb(ll v){
//     tin[v]=tim++;
//     for(auto to: g[v])dfsb(to);
//     tout[v]=tim++;
// }
void solve () {
    ll n, m;
    cin>>n>>m;
    vector<pair<ll, ll>> v(n);
    for(int i = 0; i<n; i++){
        cin>>v[i].first;
    }
    for(int i = 0; i<n; i++){
        cin>>v[i].second;
    }
    vector<ll> v1(m);
    cin>>v1;
    if(n>=1){
        cout<<"First\n";
    }
    else{
        if(m%2==1){
            cout<<"First\n";
        }
        else{
            cout<<"Second\n";
        }
    }
}
signed main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout<<fixed<<setprecision(18);
    ll AnyaSamsonovaGoSex = 1;
    //cin>>AnyaSamsonovaGoSex;
    while(AnyaSamsonovaGoSex--) solve();
}