#include <bits/stdc++.h>

using namespace std;

// #define int long long
using ld = long double;
using ll = long long;
using pii = pair<int, int>;

// const int A = 0, B = 1, C = 2;

void solve()
{
    int n, m;
    cin >> n >> m;
    int k = 2 * n + m;
    vector<int> arr(k + 1, -1);
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        --a[i];
        arr[a[i]] = 0;
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> b[i];
        --b[i];
        arr[b[i]] = 1;
    }
    for (int i = 0; i < m; ++i)
    {
        int c;
        cin >> c;
        --c;
        arr[c] = 2;
    }
    vector<int> pref(k = 1); // количество C
    pref[0] = arr[0] == 2;
    for (int i = 1; i <= k; ++i)
    {
        pref[i] = pref[i - 1] + (arr[i] == 2);
    }
    auto get = [&](int l, int r)
    {
        int res = pref[r];
        if (l != 0)
        {
            res -= pref[l - 1];
        }
        return res;
    };

    vector<vector<int>> dp((1 << n), vector<int>(n + 1, -1));

    function<void(int, int)> build = [&](int mask, int i)
    {
        if (i == 0 && mask == 0)
        {
            cout << "";
        }
        if (i == n) // фиктивная вершина - выигрышная
        {
            dp[mask][i] = 1;
            return;
        }
        if (dp[mask][i] != -1)
            return;
        dp[mask][i] = 0; // по умолчанию - проигрышная
        // ищем способ выиграть
        {
            // 1) берем нашу карту
            int mask2 = mask + (1 << i);
            int nxt = i == n - 1 ? k : a[i + 1];
            int count_on_way = get(a[i], nxt);
            if (b[i] < a[i])
            {
                // нужно использовать нашу b
                ++count_on_way;
            }
            for (int j = 0; j < i; ++j)
            {
                if (mask & (1 << j) && a[i] < b[j] && b[j] <= nxt)
                {
                    // нужно использовать эту b
                    ++count_on_way;
                }
            }
            build(mask2, i + 1);
            bool win1 = count_on_way % 2 == 1 && dp[mask2][i + 1] == 1;
            bool win2 = count_on_way % 2 == 0 && dp[mask2][i + 1] == 0;
            if (win1 || win2)
            {
                dp[mask][i] = 1;
            }
        }
        {
            // 2) не берем нашу карту
            int nxt = i == n - 1 ? k : a[i + 1];
            int count_on_way = get(a[i], nxt);
            for (int j = 0; j < i; ++j)
            {
                if (mask & (1 << j) && a[i] < b[j] && b[j] <= nxt)
                {
                    // нужно использовать эту b
                    ++count_on_way;
                }
            }
            build(mask, i + 1);
            bool win1 = count_on_way % 2 == 1 && dp[mask][i + 1] == 1;
            bool win2 = count_on_way % 2 == 0 && dp[mask][i + 1] == 0;
            if (win1 || win2)
            {
                dp[mask][i] = 1;
            }
        }
    };
    build(0, 0);
    bool norm = true;
    for (int i = 0; i < arr.size(); ++i)
    {
        if (arr[i] == 0)
            break;
        if (arr[i] == 2)
        {
            norm = !norm;
        }
    }
    cout << norm << endl;
    if (norm)
    {
        if (dp[0][0] == 1)
        {
            cout << "First" << endl;
        }
        else
        {
            cout << "Second" << endl;
        }
    }
    else
    {
        if (dp[0][0] == 1)
        {
            cout << "Second" << endl;
        }
        else
        {
            cout << "First" << endl;
        }
    }
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(0);
    ios::sync_with_stdio(0);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}