#include <bits/stdc++.h>

using namespace std;

// #define int long long
using ld = long double;
using ll = long long;
using pii = pair<int, int>;

// const int A = 0, B = 1, C = 2;

void solve()
{
    int n, m;
    cin >> n >> m;
    int k = 2 * n + m;
    vector<int> arr(k, -1);
    vector<int> a(n);
    vector<int> B(n);
    vector<int> sb(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        --a[i];
        arr[a[i]] = 0;
    }
    for (int i = 0; i < n; ++i)
    {
        cin >> B[i];
        --B[i];
        arr[B[i]] = 1;
    }
    for (int i = 0; i < n; ++i)
    {
        sb[a[i]] = B[i];
    }
    // for (int i = 0; i < n; ++i)
    // {
    //     for (int j = i + 1; j < n; ++j)
    //     {
    //         if (a[j] < a[i])
    //         {
    //             swap(a[j], a[i]);
    //             swap(b[j], b[i]);
    //         }
    //     }
    // }
    for (int i = 0; i < m; ++i)
    {
        int c;
        cin >> c;
        --c;
        arr[c] = 2;
    }
    // vector<int> pref(k); // количество C
    // pref[0] = arr[0] == 2;
    // for (int i = 1; i <= k; ++i)
    // {
    //     pref[i] = pref[i - 1] + (arr[i] == 2);
    // }
    // auto get = [&](int l, int r)
    // {
    //     int res = pref[r];
    //     if (l != 0)
    //     {
    //         res -= pref[l - 1];
    //     }
    //     return res;
    // };

    // 0 - следующий после отрезка элемент проигрышный
    // 1 - следующий после отрезка элемент выигрышный
    vector<vector<vector<int>>> dp(k + 1, vector<vector<int>>(k + 1, vector<int>(2, -1)));

    function<void(int, int, int)> build = [&](int l, int r, int v)
    {
        if (dp[l][r][v] != -1)
        {
            return;
        }
        if (r == l - 1)
        {
            // вырожденный отрезок
            dp[l][r][v] = v;
            return;
        }
        if (arr[l] == 2)
        {
            // на данной позиции просто C
            build(l + 1, r, v);
            // обязаны сделать единственный ход
            dp[l][r][v] = !dp[l + 1][r][v];
            return;
        }
        if (arr[l] == 1)
        {
            // здесь B, игнорируем
            build(l + 1, r, v);
            dp[l][r][v] = dp[l + 1][r][v];
            return;
        }
        // здесь A, начинается интересное
        int b = sb[l];
        // по умолчанию проигрышное, пытаемся выиграть
        dp[l][r][v] = 0;
        {
            // 1) берем нашу b
            if (b < l)
            {
                // она слева
                build(l + 1, r, v);
                if (dp[l + 1][r][v] == 1)
                {
                    dp[l][r][v] = 1;
                }
            }
            else
            {
                // она справа
                build(b + 1, r, v);
                int xval = dp[b + 1][r][v];
                int bval = !xval;
                build(l + 1, b - 1, bval);
                int yval = dp[l + 1][b - 1][bval];
                if (yval == 0)
                {
                    dp[l][r][v] = 1;
                }
            }
        }
        {
            // 2) не берем нашу b
            build(l + 1, r, v);
            if (dp[l + 1][r][v] == 0)
            {
                dp[l][r][v] = 1;
            }
        }
    };

    build(0, k - 1, 1);
    if (dp[0][k - 1][1])
    {
        cout << "First" << endl;
    }
    else
    {
        cout << "Second" << endl;
    }
}

signed main()
{
#ifdef ROMALOCAL
    freopen("in.txt", "r", stdin);
#endif

    cin.tie(0);
    ios::sync_with_stdio(0);

    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}