#include <bits/stdc++.h>
using ll = long long;
using namespace std;

void solve() {
    int n, m; cin >> n >> m;
    vector <int> a(n, 0), b(n, 0), c(m, 0);
    vector <tuple <int, int, int>> val;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        val.emplace_back(a[i], 2, i);
    }
    for (int i = 0; i < n; i++) cin >> b[i];
    for (int i = 0; i < m; i++) {
        cin >> c[i];
        val.emplace_back(c[i], 1, i);
    }
    sort(val.begin(), val.end(), greater<>());
    vector <vector <int>> dp(n + m + 1, vector <int>(n + 1, -1));
    dp[0][0] = 0;
    for (int bal = 1; bal <= n; bal++) {
        dp[0][bal] = (dp[0][bal - 1] ^ 1);
    }
    for (int i = 0; i < n + m; i++) {
        int t = get<1>(val[i]);
        int id = get<2>(val[i]);
        for (int bal = 0; bal <= n; bal++) {
            int fl = 0;
            if (t == 1) {
                if (!dp[i][bal]) fl = 1;
            } else {
                if (!dp[i][bal]) fl = 1;
                if (a[id] > b[id]) {
                    if (dp[i][bal]) fl = 1;
                } else {
                    if (bal + 1 <= n && dp[i][bal + 1]) fl = 1;
                }
            }
            dp[i + 1][bal] = fl;
        }
    }
    cout << (dp[n + m][0] ? "First" : "Second") << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
    for (int i = 0; i < test; i++) {
        solve();
    }
}

