#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<tuple<ll, ll, ll>> all;
	vector<pair<ll, ll>> a(n);
	vector<ll> b(n);
	for (ll i = 0; i < n; i++) {
		cin >> a[i].first;
	}
	for (ll i = 0; i < n; i++) {
		cin >> a[i].second;
		all.emplace_back(a[i].first, a[i].second, 0);
	}
	for (ll i = 0; i < m; i++) {
		cin >> b[i];
		all.emplace_back(b[i], b[i], 1);
	}
	sort(all.begin(), all.end());
	ll now = 1;
	ll lnow = -1;
	ll le = INF;
	for (auto[s, e, t] : all) {
		now = 1 - now;
		if (t == 0) {
			if (s > le || e > le) {
				break;
			}
			if (s > e) {
				lnow = now;
				break;
			}
			le = e;
			lnow = now;
		}
	}
	if (lnow == -1) {
		lnow = now;
	}
	cout << (lnow ? "Second" : "First") << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
