#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

bool win(set<ll>& m1, set<pair<ll, ll>>& m2) {
	bool xo = false;
	vector<ll> e1;
	while (!m1.empty() && (m2.empty() || *m1.begin() < m2.begin()->first)) {
		ll x = *m1.begin();
		m1.erase(m1.begin());
		e1.push_back(x);
		xo = !xo;
	}
	if (m2.empty()) {
		return !xo;
	}
	auto[a, b] = *m2.begin();
	m2.erase(m2.begin());
	bool b1 = win(m1, m2);
	if (!b1) {
		m2.insert(make_pair(a, b));
		for (auto j : e1) {
			m1.insert(j);
		}
		return b1 == xo;
	}
	m1.insert(b);
	bool b2 = win(m1, m2);
	m1.erase(b);
	m2.insert(make_pair(a, b));
	for (auto j : e1) {
		m1.insert(j);
	}
	return b2 == xo;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	vector<tuple<ll, ll, ll>> all;
	vector<pair<ll, ll>> a(n);
	vector<ll> b(m);
	for (ll i = 0; i < n; i++) {
		cin >> a[i].first;
	}
	for (ll i = 0; i < n; i++) {
		cin >> a[i].second;
		all.emplace_back(a[i].first, a[i].second, 0);
	}
	for (ll i = 0; i < m; i++) {
		cin >> b[i];
		all.emplace_back(b[i], b[i], 1);
	}
	sort(all.begin(), all.end());
	ll now = 1;
	ll wd = -1;
	deque<pair<ll, ll>> wdn;
	for (auto[s, e, t] : all) {
		while (!wdn.empty() && wdn.front().first < s) {
			wd = wdn.front().second;
			wdn.pop_front();
		}
		now = 1 - now;
		if (t == 0) {
			while (!wdn.empty() && wdn.back().first > e) {
				wdn.pop_back();
			}
			wdn.emplace_back(e, (wd == -1 ? now : wd));
		}
	}
	if (wd == -1) {
		wd = now;
	}
	if (!wdn.empty()) {
		wd = wdn.back().second;
	}
	cout << (wd ? "Second" : "First") << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
