#include <bits/stdc++.h>
#define int long long

struct Node
{
    int type;
    int li;
    int off;

    Node(int type, int li, int off) : type(type), li(li), off(off) {};
};

struct cmp
{
    bool operator()(const Node &a, const Node &b) const
    {
        int now_a = 0;
        int now_b = 0;
        if (a.type == -2)
        {
            now_a = a.li;
        }
        else if (a.type == -1)
        {
            now_a = a.li;
        }
        else
        {
            now_a = a.off;
        }

        if (b.type == -2)
        {
            now_b = b.li;
        }
        else if (b.type == -1)
        {
            now_b = b.li;
        }
        else
        {
            now_b = b.off;
        }
        return now_a < now_b;
    }
};

int solve(int now, std::multiset<Node, cmp> &s)
{
    if (s.size() == 0)
    {
        return 0;
    }
    auto th = *s.begin();
    s.erase(s.begin());

    if (th.type == -1)
    {
        int tmp = solve(1 - now, s);
        s.insert(Node(0, th.li, th.off));
        tmp = std::min(solve(1 - now, s), tmp);
        s.erase(s.find(Node(0, th.li, th.off)));
        return 1 - tmp;
    }

    int tmp = solve(1 - now, s);
    s.insert(th);
    return 1 - tmp;
}

signed
main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n, m;
    std::cin >> n >> m;

    std::vector<std::pair<int, int>> a(n);
    std::multiset<Node, cmp> s;
    for (int i = 0; i < n; i++)
    {
        std::cin >> a[i].first;
    }
    for (int i = 0; i < n; i++)
    {
        std::cin >> a[i].second;

        s.insert(Node(-1, a[i].first, a[i].second));
    }
    std::vector<int> c(m);
    for (int i = 0; i < m; i++)
    {
        std::cin >> c[i];
        s.insert(Node(-2, c[i], -1));
    }

    int tmp = solve(0, s);
    if (tmp == 1)
    {
        std::cout << "First";
    }
    else
    {
        std::cout << "Second";
    }
}