#pragma GCC optmize("Ofast")
#include <bits/stdc++.h>
#define int long long

struct Node
{
    int type;
    int li;
    int off;

    Node(int type, int li, int off) : type(type), li(li), off(off) {};
};

struct cmp
{
    bool operator()(const Node &a, const Node &b) const
    {
        int now_a = 0;
        int now_b = 0;
        if (a.type == -2)
        {
            now_a = a.li;
        }
        else if (a.type == -1)
        {
            now_a = a.li;
        }
        else
        {
            now_a = a.li;
        }

        if (b.type == -2)
        {
            now_b = b.li;
        }
        else if (b.type == -1)
        {
            now_b = b.li;
        }
        else
        {
            now_b = b.li;
        }
        return now_a < now_b;
    }
};

int give(int l, int r, std::vector<int> &pref)
{
    if (l == 0)
    {
        return pref[r];
    }
    return pref[r] - pref[l - 1];
}

int solve(int now, std::multiset<Node, cmp> &s, std::vector<int> &pref)
{
    if (s.size() == 0)
    {
        return 0;
    }
    // std::cout << now << std::endl;
    auto th = *s.begin();
    s.erase(s.begin());

    if (th.type == -1)
    {
        int left = th.li;
        int right = pref.size() - 1;
        if (s.size() != 0)
        {
            right = s.begin()->li;
        }
        int delta = give(left, right, pref);
        int tmp = 1;
        int next = (now + delta % 2 + 1) % 2;
        if (next == now)
        {
            tmp = std::min(1 - solve(next, s, pref), tmp);
        }
        else
        {
            tmp = std::min(solve(next, s, pref), tmp);
        }

        s.insert(Node(0, th.off, th.li));

        left = th.li;
        right = s.begin()->li;
        delta = give(left, right, pref);
        next = (now + delta % 2 + 1) % 2;

        if (next == now)
        {
            tmp = std::min(1 - solve(next, s, pref), tmp);
        }
        else
        {
            tmp = std::min(solve(next, s, pref), tmp);
        }
        s.erase(s.find(Node(0, th.off, th.li)));

        s.insert(th);
        return 1 - tmp;
    }

    int left = th.li;
    int right = pref.size() - 1;
    if (s.size() != 0)
    {
        right = s.begin()->li;
    }
    int delta = give(left, right, pref);
    int next = (now + delta % 2 + 1) % 2;
    int tmp = 1;

    if (next == now)
    {
        tmp = std::min(1 - solve(next, s, pref), tmp);
    }
    else
    {
        tmp = std::min(solve(next, s, pref), tmp);
    }
    s.insert(th);
    return 1 - tmp;
}

signed
main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n, m;
    std::cin >> n >> m;

    std::vector<std::pair<int, int>> a(n);
    std::multiset<Node, cmp> s;
    for (int i = 0; i < n; i++)
    {
        std::cin >> a[i].first;
    }
    for (int i = 0; i < n; i++)
    {
        std::cin >> a[i].second;

        s.insert(Node(-1, a[i].first, a[i].second));
    }
    std::vector<int> pref(2 * n + m + 1);
    std::vector<int> c(m);
    for (int i = 0; i < m; i++)
    {
        std::cin >> c[i];
        pref[c[i]]++;
    }
    for (int i = 1; i < pref.size(); i++)
    {
        pref[i] += pref[i - 1];
    }

    if (n == 0)
    {
        if (m % 2 == 0)
        {
            std::cout << "Second";
        }
        else
        {
            std::cout << "First";
        }
        return 0;
    }

    int left = 0;

    int right = s.begin()->li;
    int delta = give(left, right, pref);
    // std::cout << delta << std::endl;
    int next = (0 + delta % 2) % 2;

    if (next == 0)
    {

        int tmp = solve(next, s, pref);
        if (tmp == 1)
        {
            std::cout << "First";
        }
        else
        {
            std::cout << "Second";
        }
    }
    else
    {
        int tmp = solve(next, s, pref);
        if (tmp == 1)
        {
            std::cout << "Second";
        }
        else
        {
            std::cout << "First";
        }
    }
}