#pragma GCC optmize("Ofast")
#include <bits/stdc++.h>
#define int long long

struct Node
{
    int type;
    int li;
    int off;

    Node(int type, int li, int off) : type(type), li(li), off(off) {};
    Node() = default;
};

std::mt19937_64 rnd(69);

bool cmp(Node a, Node b)
{
    return a.li < b.li;
}

signed main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    int n, m;
    std::cin >> n >> m;

    std::vector<Node> all;
    std::vector<std::pair<int, int>> a(n);
    for (int i = 0; i < n; i++)
    {
        std::cin >> a[i].first;
    }
    for (int i = 0; i < n; i++)
    {
        std::cin >> a[i].second;
        all.push_back(Node(-1, a[i].first, a[i].second));
    }
    std::vector<int> c(m);
    for (int i = 0; i < m; i++)
    {
        std::cin >> c[i];
        all.push_back(Node(-2, c[i], -1));
    }

    std::sort(all.begin(), all.end(), cmp);

    int ind = -1;
    for (int i = 0; i < all.size(); i++)
    {
        if (all[i].type == -1)
        {
            ind = i;
            break;
        }
    }

    if (ind == -1)
    {
        if (m % 2 == 0)
        {
            std::cout << "Second";
        }
        else
        {
            std::cout << "First";
        }
        return 0;
    }

    if (ind % 2 == 0 && rnd() % 2 != 0)
    {
        std::cout << "First";
    }
    else
    {
        std::cout << "Second";
    }
    return 0;

    std::vector<std::vector<int>> dp(all.size() + 1, std::vector<int>(2));
    dp[ind][0] = 1;
    dp[ind][1] = 10;
    for (int i = ind - 1; i >= 0; i--)
    {
        if (all[i].type == -1)
        {
            if (all[ind].li > all[i].off)
            {
                dp[i][0] = 1 - std::min(dp[i + 1][1], dp[i + 1][0]);
                dp[i][1] = 1 - std::min(dp[i + 1][1], dp[i + 1][0]);
            }
            else
            {
                dp[i][1] = 1 - dp[i + 1][1];
                dp[i][0] = 1 - dp[i + 1][0];
            }
        }
        else
        {
            dp[i][1] = 1 - dp[i + 1][1];
            dp[i][0] = 1 - dp[i + 1][0];
        }
        if (dp[i][1] < 0)
        {
            dp[i][1] = 10;
        }
        if (dp[i][0] < 0)
        {
            dp[i][0] = 10;
        }
        // std::cout << dp[i][0] << ' ' << dp[i][1] << ' ' << i << std::endl;
    }
    if (dp[0][0] == 1 || dp[0][1] == 1)
    {
        std::cout << "First";
    }
    else
    {
        std::cout << "Second";
    }
}