#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define rs resize
#define pb push_back
#define ff first
#define ss second
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
//#define int long long

typedef long double ld;
typedef long long ll;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T>
istream &operator >>(istream &in, pair<T, T> &a) {
    in >> a.ff >> a.ss;
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, pair<T, T> &a) {
    out << a.ff << " " << a.ss;
    return out;
}

template<typename T>
istream &operator >>(istream &in, vector<T> &a) {
    for (auto &i : a) in >> i;
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &a) {
    for (auto i : a) cout << i << " ";
    return out;
}

const int maxn =3e5 + 10;


void solve() {
    int n, m; cin >> n >> m;
    vector<pii> a(n); vector<int> c(m);
    for (int i = 0; i < n; i++) cin >> a[i].ff;
    for (int i = 0; i < n; i++) cin >> a[i].ss;
    for (int i = 0; i < m; i++) cin >> c[i];
    sort(all(a)); sort(all(c));

    int lst = n - 1, r = n - 2;
    while (r > -1) {
        if (a[r].ss < a[lst].ff) {
            lst = r;
        }
        r--;
    }
    int i = lst;

    int l1 = 0, l2 = 0, f = 1;
    while (l2 < m) {
        if (a[l1].ff < c[l2]) {
            if (l1 == i) {
                if (f) cout << "First";
                else cout << "Second";
                return;
            }
            l1++;
        } else {
            l2++;
        }
        f ^= 1;
    }
    while (l1 < i) {
        f ^= 1;
        l1++;
    }
    if (f) cout << "First";
    else cout << "Second";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double tim = clock();
#endif

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "-------------------\n";
#endif
    }

#ifdef LOCAL
    cout << (double)(clock() - tim) / CLOCKS_PER_SEC;
#endif
}
