#include <bits/stdc++.h>
// #pragma GCC optimize("O3")
// #pragma GCC target("avx2")
#define LOCAL

// std::mt19937 rnd(time(0));

void solve();

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);

    #ifdef LOCAL
        std::freopen("input.txt", "r", stdin);
        std::freopen("output.txt", "w", stdout);
    #endif

    int t = 1;
    // std::cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}

class SegmentTree {
 private:
    std::vector <int> body;
 public:
    SegmentTree (int n) {
        body.resize(4 * n);
    }

    inline int get(int curV, int l, int r, int ql, int qr) {
        if (r <= ql || qr <= l) return 0;

        if (ql <= l && r <= qr) return body[curV];

        int m = (l + r) / 2;
        return get(curV * 2 + 1, l, m, ql, qr) + get(curV * 2 + 2, m, r, ql, qr);
    }
};

void solve() {
    int n, m;
    std::cin >> n >> m;

    std::vector <int> type(2 * n + m);

    std::vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
        --a[i];
        type[a[i]] = 1;
    }

    std::vector <int> b(n);
    for (int i = 0; i < n; ++i) {
        std::cin >> b[i];
        --b[i];
        type[b[i]] = 2;
    }

    std::vector <int> c(m);
    for (int i = 0; i < m; ++i) {
        std::cin >> c[i];
        --c[i];
        type[c[i]] = 3;
    }

    std::set <std::pair <int, int>> ab, ba;
    for (int i = 0; i < n; ++i) {
        ab.insert({a[i], b[i]});
        ba.insert({b[i], a[i]});
    }

    std::pair <int, int> lastA;
    while (!ab.empty()) {
        std::pair <int, int> needA = *ab.rbegin();
        ab.erase({needA.first, needA.second});
        ba.erase({needA.second, needA.first});
        lastA = needA;
        while (!ba.empty() && needA.first < ba.rbegin()->first) {
            std::pair <int, int> delB = *ba.rbegin();
            ab.erase({delB.second, delB.first});
            ba.erase({delB.first, delB.second});
        }
    }

    int cnt = 0;
    for (auto i : c) {
        if (i < lastA.first) cnt++;
    }
    for (auto i : a) {
        if (i < lastA.first) cnt++;
    }

    if (cnt & 1) std::cout << "Second";
    else std::cout << "First";
}