#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl "\n"
#define ff first
#define ss second
#define ordered_set tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>
#define all(x) x.begin(), x.end()

const int INF = 1e18;


void solve() {

    int n, m;
    cin >> n >> m;

    vector<int> a(n, 0);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> b(n, 0);

    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    vector<int> c(m, 0);

    for (int i = 0; i < m; i++) {
        cin >> c[i];
    }

    vector<pair<int, int>> vls;

    for (int i = 0; i < n; i++) {
        vls.push_back({a[i], b[i]});
    }

    for (int i = 0; i < m; i++) {
        vls.push_back({c[i], 0});
    }

    sort(all(vls));

    vector<int> sa;
    vector<int> pa;
    vector<int> sb;

    int cnt = 0;

    for (auto [x, y]: vls) {
        if (y == 0) {
            cnt++;
            continue;
        }
        sa.push_back(x);
        sb.push_back(y);
        pa.push_back(cnt);
    }

    vector<int> dp(n, -1);

    for (int i = n - 1; i >= 0; i--) {
        if (i == n - 1 || sb[i] < sa[i] || sa[i + 1] > sb[i]) {
            dp[i] = 1;
            continue;
        }
        int dist = pa[i + 1] - pa[i];
        if (dist % 2 == 0) {
            dp[i] = (dp[i + 1] == 0);
        } else {
            dp[i] = (dp[i + 1] == 1);
        }
    }

    int ans = dp[0] ^ (pa[0] % 2);

    if (ans) {
        cout << "First" << endl;
    } else {
        cout << "Second" << endl;
    }

}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int TN;
    TN = 1;
//    cin >> TN;

    while (TN--) {
        solve();
    }

}
