#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using sll = __int128;

template <typename T>
istream &operator>>(istream &in, pair<T, T> &a){
    in >> a.first >> a.second;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, pair<T, T> &a){
    out << a.first << ' ' << a.second;
    return out;
}

template <typename T>
istream &operator>>(istream &in, vector<T> &a){
    for(auto &x : a) in >> x;
    return in;
}

template <typename T>
ostream &operator<<(ostream &out, vector<T> &a){
    for(auto x : a) out << x << ' ';
    return out;
}

int n, m;
vector<int> a, b, c;

int check(int mask){
    set<array<int, 3>> st;
    for(int i = 0; i < n; i++){
        st.insert({a[i], i, 2});
    }
    for(int i = 0; i < m; i++){
        st.insert({c[i], i, 1});
    }
    int ord = 1;
    bool f = 0, s = 0;
    while(!st.empty()){
        auto cur = *st.begin();
        st.erase(st.begin());
        if(cur[2] == 1){
            ord = 3 - ord;
            continue;
        }
        if(((mask >> cur[1]) & 1) && cur[2] == 2){
            if(ord == 1) f = 1;
            else s = 1;
            st.insert({b[cur[1]], cur[1], 3});
        }
        ord = 3 - ord;
    }
//    cout << mask << ' ' << ord << " * " << '\n';
    if(ord == 2){
        return (s ? -1 : 1);
    }
    return (f ? -1 : 2);
}

void solve(){
    cin >> n >> m;
    int mn = 2e9;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    cin >> a >> b >> c;
    int win;
    for(int mask = 0; mask < (1 << n); mask++){
        int res = check(mask);
        if(res != -1) win = res;
    }
    cout << (win == 1 ? "First" : "Second");
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int test = 1;
//    cin >> test;
    while(test--){
        solve();
    }
}

