#include <bits/stdc++.h>
#define ll long long
#define len(x) (int)x.size()
#define ld long double
#define all(x) x.begin(), x.end()
const ll mod1 = 1e9 + 7;

using namespace std;

void print(vector<int> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<ll> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<char> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<string> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<pair<int, int>> &a){
    for(auto x : a){
        cout << x.first << ' ' << x.second << '\n';
    }
}

void print(vector<vector<int>> &a){
    for(auto x : a){
        print(x);
    }
}

void print(vector<vector<ll>> &a){
    for(auto x : a){
        print(x);
    }
}

//#define int ll
//#define mtask

void solve() {
    int n, m;
    cin >> n >> m;
    int mmin = 1e9;
    vector<pair<int, int>> a(n);
    vector<int> c(m);
    for(int i = 0; i < n; ++i){
        cin >> a[i].first;
        mmin = min(mmin, a[i].first);
    }
    for(int i = 0; i < n; ++i){
        cin >> a[i].second;
    }
    for(int i = 0; i < m; ++i){
        cin >> c[i];
    }
    sort(all(c));

    auto get = [&](int l, int r){
        return upper_bound(all(c), r) - lower_bound(all(c), l);
    };

    sort(all(a));
    vector<bool> dp(n);
    dp[n - 1] = true;
    for(int i = n - 2; i >= 0; --i){
        if(a[i].second < a[i + 1].first){
            dp[i] = true;
        }
        else{
            if(get(a[i].first, a[i + 1].first) % 2 == 0){
                dp[i] = !dp[i + 1];
            }
            else{
                dp[i] = dp[i + 1];
            }
        }
    }
    bool fl = false;
    for(auto x : c){
        if(x < a[0].first) fl ^= true;
    }
    if((dp[0] ^ fl)){
        cout << "First\n";
    }
    else{
        cout << "Second\n";
    }
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
    int tt;
    cin >> tt;
    while(tt--)
#endif
        solve();
}