#include <bits/stdc++.h>
#define ll long long
#define len(x) (int)x.size()
#define ld long double
#define all(x) x.begin(), x.end()
const ll mod1 = 1e9 + 7;

using namespace std;

void print(vector<int> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<ll> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<char> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<string> &a){
    for(auto x : a){
        cout << x << ' ';
    }
    cout << '\n';
}

void print(vector<pair<int, int>> &a){
    for(auto x : a){
        cout << x.first << ' ' << x.second << '\n';
    }
}

void print(vector<vector<int>> &a){
    for(auto x : a){
        print(x);
    }
}

void print(vector<vector<ll>> &a){
    for(auto x : a){
        print(x);
    }
}

//#define int ll
//#define mtask

struct obj{

    int val= 0;

    obj(){

    }

    obj(int val2){
        val = val2;
    }

    obj operator+(const obj &oth){
        obj ans;
        ans.val = min(val, oth.val);
        return ans;
    }

    void operator=(int a){
        val = a;
    }

    int get(){
        return val;
    }

};

struct tree{

    int n;
    vector<obj> t;
    vector<obj> a;

    void build(int v, int vl, int vr){
        if(vl + 1 == vr){
            t[v] = a[vl];
            return;
        }
        int mid = (vl + vr) / 2;
        build(2 * v + 1, vl, mid);
        build(2 * v + 2, mid, vr);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    tree(vector<int> &b){
        n = len(b);
        a.resize(n);
        for(int i = 0; i < n; ++i){
            a[i] = b[i];
        }
        t.resize(4 * n);
        build(0, 0, n);
    }

    void change(int v, int vl, int vr, int ind, obj val){
        if(ind < vl || vr <= ind) return;
        if(vl + 1 == vr){
            t[v] = val;
            return;
        }
        int mid = (vl + vr) / 2;
        change(2 * v + 1, vl, mid, ind, val);
        change(2 * v + 2, mid, vr, ind, val);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    void change(int ind, obj val){
        change(0, 0, n, ind, val);
    }

    obj get(int v, int vl, int vr, int ql, int qr){
        if(qr <= vl || vr <= ql) return {};
        if(ql <= vl && vr <= qr) return t[v];
        int mid = (vl + vr) / 2;
        return get(2 * v + 1, vl, mid, ql, qr) + get(2 * v + 2, mid, vr, ql, qr);
    }

    auto get(int l, int r){
        return get(0, 0, n, l, r).get();
    }

};

void solve() {
    int n, m;
    cin >> n >> m;
    int mmin = 1e9;
    vector<pair<int, int>> a(n);
    vector<int> c(m);
    for(int i = 0; i < n; ++i){
        cin >> a[i].first;
        mmin = min(mmin, a[i].first);
    }
    for(int i = 0; i < n; ++i){
        cin >> a[i].second;
    }
    for(int i = 0; i < m; ++i){
        cin >> c[i];
    }
    sort(all(c));

    auto get = [&](int l, int r){
        return upper_bound(all(c), r) - lower_bound(all(c), l);
    };

    sort(all(a));
    vector<int> to_tree(n);
    for(int i = 0; i < n; ++i){
        to_tree[i] = a[i].second;
    }
    tree t(to_tree);
    vector<bool> dp(n);
    dp[n - 1] = true;
    for(int i = n - 2; i >= 0; --i){
        bool fl = true;
        int mx = 1e9;
        int l = i, r = n;
        {
            while(l + 1 != r){
                int mid = (l + r) / 2;
                if(a[mid].first > a[i].second){
                    r = mid;
                }
                else{
                    l = mid;
                }
            }
        }
        for(int j = i + 1; j < r; ++j){
            if(a[j].first > a[i].second) {
                mx = a[j].first;
                break;
            }
        }
        for(int j = i + 1; j < r; ++j){
            if(a[j].second < mx) {
                fl = false;
                break;
            }
        }
        if(fl){
            dp[i] = true;
        }
        else{
            if(get(a[i].first, a[i + 1].first) % 2 == 0){
                dp[i] = !dp[i + 1];
            }
            else{
                dp[i] = dp[i + 1];
            }
        }
    }
#ifdef LOCAL
    for(auto x : dp){
        cout << x << ' ';
    }
    cout << '\n';
#endif
    bool fl = false;
    for(auto x : c){
        if(x < a[0].first) fl ^= true;
    }
    if((dp[0] ^ fl)){
        cout << "First\n";
    }
    else{
        cout << "Second\n";
    }
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
#ifdef mtask
    int tt;
    cin >> tt;
    while(tt--)
#endif
    solve();
}