#include "bits/stdc++.h"

using namespace std;

#define int long long

void solve() {
    int n, m;
    cin >> n >> m;

    multiset<pair<int, int>> tog;
    multiset<int> alone;

    vector<int> a(n), b(n), c(m);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    for (int i = 0; i < m; i++) {
        cin >> c[i];
    }

    for (int i = 0; i < n; i++) {
        tog.emplace(a[i], b[i]);
    }

    for (int i = 0; i < m; i++) {
        alone.emplace(c[i]);
    }

    int ts = (int)tog.size(), as = (int)alone.size();

    int cnt = 0;

    while (ts + as > 0) {
        while (as > 0 && (ts == 0 || tog.begin()->first > *alone.begin())) {
            alone.extract(alone.begin());
            as--;
            cnt++;
        }

        if (ts + as <= 0) {
            break;
        }

        if (ts > 0 && (ts + as) % 2 == 0) {
            alone.emplace(tog.begin()->second);
            as++;
        }
        tog.extract(tog.begin());
        ts--;
        cnt++;
    }

    cout << (cnt % 2 != 0 ? "First" : "Second");
}
signed main() {
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int akbalin = 1;
    // cin >> akbalin;

    for (int i = 1; i <= akbalin; i++) {
        solve();
    }
}