#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<random>
#include<chrono>
#include<set>
#include<map>
#include<deque>
#include<array>
//#define int long long
#define all(v) v.begin(), v.end()
#define ll long long
#define ld long double
using namespace std;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

void solve() {
	int n, m;
	cin >> n >> m;
	map<int, int> mp;
	vector<int> A(n), B(n), C(m);
	vector<array<int, 3>> v;
	for (int i = 0; i < n; i++) {
		cin >> A[i];
		v.push_back({ A[i], 1, i });
	}
	for (int i = 0; i < n; i++) {
		cin >> B[i];
		v.push_back({ B[i], -1, i });
	}
	for (int i = 0; i < m; i++) {
		cin >> C[i];
		v.push_back({ C[i], 0, i });
	}
	sort(all(v));
	array<int, 2> cnt = { 0,0 };
	map<int, int> sta, stb;
	int cur = 0;
	for (int i = 0; i < v.size(); i++) {
		array<int, 3> ev = v[i];
		if (ev[1] == 0) {
			cur ^= 1;
		}
		else if (ev[1] == 2) {
			if (sta.count(ev[2])) {
				cnt[sta[ev[2]]]++;
			}
			stb[ev[2]] = cur;
		}
		else {
			if (stb.count(ev[2])) {
				cnt[cur]++;
			}
			sta[ev[2]] = cur;
			cur ^= 1;
		}
	}

	int N = 2 * n + m;
	vector<vector<int>> dp(N + 1, vector<int>(N + 1));
	for (int sum = 0; sum <= 2 * (N - 1); sum++) {
		for (int i = 0; i <= sum; i++) {
			int j = sum - i;
			if (i <= N && j <= N && i >= 0 && j >= 0) {
				if (i == 0 && j == 0) {
					dp[i][j] = N % 2;
					continue;
				}
				if (i) {
					dp[i][j] = !dp[i - 1][j] || !dp[j][i - 1];
				}
				else dp[i][j] = 0;
			}
		}
	}
	cout << (dp[cnt[0]][cnt[1]] ? "First" : "Second");
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	//cin >> t;
	t = 1;
	while (t--) {
		solve();
	}
}
