#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<random>
#include<chrono>
#include<set>
#include<map>
#include<deque>
#include<array>
//#define int long long
#define all(v) v.begin(), v.end()
#define ll long long
#define ld long double
using namespace std;
mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());
map<set<pair<int, int>>, bool> mp;
void dfs(set<pair<int, int>> st) {
	if (st.size() == 0) {
		mp[st] = 0;
		return;
	}
	set<pair<int, int>> st1 = st;
	st1.erase(st1.begin());
	if (!mp.count(st1)) {
		dfs(st1);
	}
	mp[st] = !mp[st1];

	if (st.begin()->second != -1 && mp[st] == 0) {
		st1.insert({ st.begin()->second, -1 });
		if (!mp.count(st1)) {
			dfs(st1);
		}
		mp[st] = !mp[st1];
	}
}
void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> A(n), B(n), C(m);
	set<pair<int, int>> st;
	for (int i = 0; i < n; i++) {
		cin >> A[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> B[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> C[i];
	}
	for (int i = 0; i < n; i++) {
		st.insert({ A[i], B[i] });
	}
	for (int i = 0; i < m; i++) {
		st.insert({ C[i], -1 });
	}
	dfs(st);
	cout << (mp[st] ? "First" : "Second");
	
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t;
	//cin >> t;
	t = 1;
	while (t--) {
		solve();
	}
}
