#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
// #include<ext/pb_ds/assoc_container.hpp>
// #include<ext/pb_ds/tree_policy.hpp>
// #pragma GCC target("avx2")
#include<bits/stdc++.h>
// using namespace __gnu_pbds;
using namespace std;
using ll = long long;
// using ordered_map = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
// using hash_map = gp_hash_table<int, int>;
#define watch(x) cout << #x << ": " << x << '\n';
#define watch_arr(arr) cout << #arr << ": "; \
for (int i = 0; i < (int)arr.size(); ++i) { \
    cout << arr[i] << ' '; \
} \
cout << '\n';
#define all(arr) arr.begin(), arr.end()

random_device rd;
mt19937 rnd(rd());


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> cards(n);
    vector<int> swaps(m);
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> cards[i].second;
    }
    for (int i = 0; i < m; ++i) {
        cin >> swaps[i];
    }
    sort(all(cards), [](pair<int, int> p1, pair<int, int> p2){ return min(p1.first, p1.second) < min(p2.first, p2.second); });
    sort(all(swaps)); 

    int cnt = 0;
    int j = 0;
    for (int i = 0; i < n; ++i) {
        while (j < m && swaps[j] < min(cards[i].first, cards[i].second)) {
            ++cnt, ++j;
        }
        if (i == n - 1 || min(cards[i + 1].first, cards[i + 1].second) > max(cards[i].first, cards[i].second)) {
            while (j < m && swaps[j] < cards[i].first) {
                ++cnt, ++j;
            }
            break;
        } else if (cards[i].first < cards[i].second) {
            ++cnt;
        }
    }

    if (cnt & 1) {
        cout << "Second";
    } else {
        cout << "First";
    }

    return 0;
}
