#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

//#include <ext/pb_ds/assoc_containe.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template <class T> order_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//find_by_orede, order_of_key

#define int long long
#define all(a) (a).begin(), (a).end()

#pragma GCC optimize ("O3")
#pragma GCC target ("avx2")


const int inf = 1e18;


void solve() {
	int n, m; cin >> n >> m;
	set<pair<int, int>> st;
	vector<int> a(n), b(n), c(m);
	for (int i = 0; i < n; ++i) cin >> a[i];
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		st.insert({ a[i], b[i] });
	}
	for (int i = 0; i < m; ++i) {
		cin >> c[i];
		st.insert({ c[i], -1 });
	}

	int t = 0;

	while (st.size()) {
		t ^= 1;
		auto [a, b] = *st.begin();
		st.erase(st.begin());
		if (b == -1) continue;
		if ((int)st.size() % 2) st.insert({ b, -1 });
	}
	if (t) cout << "First\n";
	else cout << "Second\n";
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t = 1; //cin >> t;
	while (t--) solve();
}