#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

//#include <ext/pb_ds/assoc_containe.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template <class T> order_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//find_by_orede, order_of_key

#define int long long
#define all(a) (a).begin(), (a).end()

#pragma GCC optimize ("O3")
#pragma GCC target ("avx2")


const int inf = 1e18;

set<pair<int, int>> st;


void ans(int t) {
	if (t) cout << "First\n";
	else cout << "Second\n";
	exit(0);
}

void solve() {
	int n, m; cin >> n >> m;
	if (n == 0) ans(m & 1);

	vector<int> a(n), b(n), c(m);
	for (int i = 0; i < n; ++i) cin >> a[i];

	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		st.insert({ a[i], b[i] });
	}
	for (int i = 0; i < m; ++i) {
		cin >> c[i];
		st.insert({ c[i], -1 });
	}
	
	int start = 0, i = 0, t = 0;
	vector<pair<int, int>> card;

	for (auto [a, b] : st) {
		card.push_back({ a, b });
		t ^= 1;
		if (b == -1) continue;
		start += (1 << i) * t;
		i++;
	}

	for (int mask = 0; mask < (1 << n); ++mask) {
		int cur = start;

		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				for (int j = i + 1; j < n; ++j)
					if (card[i].second < card[j].first) cur ^= (1 << j);
			}
		}
		if ((cur >> (n - 1)) & 1) ans(1);
	}

	ans(0);
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t = 1; //cin >> t;
	while (t--) solve();
}