#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll N1 = 5e5 * 3 + 5;
ll tree[N1 * 2 * 3];

void add(ll k, ll x) {
    for (; k < N1; k += k & (-k)) {
        tree[k] += x;
    }
}

ll get(ll k) {
    ll ans = 0;
    for (; k > 0; k -= k & (-k)) {
        ans += tree[k];
    }
    return ans;
}

ll get(ll l, ll r) {
    return get(r) - get(l - 1);
}

const ll N = 5e5 + 5;
ll a[N], b[N], ind_a[N1], nx_a[N1];
ll h[N];

unordered_map<ll, ll> dp;

ll dfs(ll i, ll e) {
    if (i == N1) {
        return 0;
    }
    ll hash = i + e * N;
    if (dp.count(hash)) {
        return dp[hash];
    }
    if (ind_a[i] == -1) {
        return dfs(i + 1, e) ^ h[i];
    }
    if (!(dfs(nx_a[i], e) ^ (get(i, nx_a[i] - 1) & 1))) {
        return dp[hash] = 1;
    }
    add(max(b[ind_a[i]], i), 1);
    e += (1 << ind_a[i]);
    ll ans = !(dfs(nx_a[i], e) ^ (get(i, nx_a[i] - 1) & 1));
    add(max(b[ind_a[i]], i), -1);
    return dp[hash] = ans;
}

void solve() {
    for (int i = 0; i < N1; ++i) {
        ind_a[i] = -1;
    }
    ll n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ind_a[a[i]] = i;
    }
    nx_a[N1 - 1] = N1;
    for (int i = N1 - 2; i >= 0; --i) {
        nx_a[i] = nx_a[i + 1];
        if (ind_a[i + 1] != -1) {
            nx_a[i] = i + 1;
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < m; ++i) {
        ll c;
        cin >> c;
        add(c, 1);
        h[c] = 1;
    }
    if (dfs(1, 0)) {
        cout << "First" << '\n';
    } else {
        cout << "Second" << '\n';
    }
}

int main() {
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}



