#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>

using namespace std;

mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());

using ll = long long;
using ld = long double;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector <int> a(n);
    for (int i=0; i < n; ++i) {
        cin >> a[i];
    }
    vector <int> b(n);
    for (int i=0; i < n; ++i) {
        cin >> b[i];
    }
    vector <int> c(m);
    for (int i=0; i < m; ++i) {
        cin >> c[i];
    }
    vector <int> q;
    for (int i=0; i < n; ++i) {
        q.push_back(a[i]);
        q.push_back(b[i]);
    }
    for (int i=0; i < m; ++i) {
        q.push_back(c[i]);
        q.push_back(0);
    }
    sort(q.begin(), q.end());
    vector <bool> ans(2 * (n + m) + 1);
    ans[2 * (n + m)] = false;
    for (int i=2 * (n + m) - 1; i >= 0; --i) {
        if (i + 1 < 2 * (n + m) && q[i + 1]) {
            ans[i] = (!ans[i + 1] || !ans[i + 2]);
        } else {
            ans[i] = (!ans[i + 1]);
        }
    }
    if (ans[0]) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
    return 0;
}
