#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <climits>
#include <cmath>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<ll, ll>;

#define all(v) v.begin(), v.end()
#define len(v) (ll)v.size()

mt19937 rnd(525252);

const ll INF = 1e9, SZ = 30, MOD = 1e9 + 7;
const ld eps = 1e-8, pi = acosl(-1);

void solve() {
    ll n, m; cin >> n >> m;
    vector<ll>a(n), b(n), c(m);
    for (ll i = 0; i < n; ++i){
        cin >> a[i];
    }
    for (ll i = 0; i < n; ++i){
        cin >> b[i];
        b[i] = max(a[i], b[i]);
    }
    for (ll j = 0; j < m; ++j){
        cin >> c[j];
    }
    vector<pii>g;
//    set<pii>v;
    for (ll i = 0; i < n; ++i){
        g.emplace_back(a[i], b[i]);
    }
    for (ll i = 0; i < m; ++i){
        g.emplace_back(c[i], -1);
    }
    sort(all(g));
    ll pl = 1;
    for (ll i = 0; g[i].second == -1; ++i){
        pl = 1 - pl;
    };
    if ((n % 2 == 0) ^ pl) cout << "First";
    else cout << "Second";
}

int main()
{
    ll t = 1;
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

//	freopen("in.txt", "r", stdin);
//	freopen("out.txt", "w", stdout);
//    cin >> t;

    while (t--) {
        solve();
        cout << '\n';
    }
}
