#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <random>
#include <queue>

using namespace std;
using ll = long long;
using ld = long double;
mt19937 rd(3231213214);
const ll INF = 1e18;

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	vector<int> b(n);
	vector<int> c(m);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	for (int i = 0; i < n; i++)
		cin >> b[i];
	for (int i = 0; i < m; i++)
		cin >> c[i];

	
	vector<pair<int, int>> vec;
	for (int i = 0; i < n; i++)
		vec.push_back({ a[i], max(b[i], a[i]) });
	sort(vec.begin(), vec.end());

	int l = n * 2 + m, r = n * 2 + m;
	for (int i = 0; i < n; i++) {
		if (vec[i].first > r)
			break;
		l = vec[i].first;
		r = vec[i].second;
	}

	int ans = 0, gr = l;
	for (int i = 0; i < n; i++) {
		if (a[i] <= gr)
			ans++;
	}
	for (auto x : c)
		if (x <= gr)
			ans++;
	cout << (ans % 2 == 1 ? "First" : "Second");
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);

	solve();
}