#include <iostream>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <string>
#include <sstream>
#include <stack>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <math.h>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = long long;
using ull = unsigned long long;
using ld = long double;

static const int inf = 1e15;
static const ld eps = 1e-7;

deque<pair<int, int>> cards;

inline bool f(bool p) {
    if (!cards.size()) {
        return p ^ 1;
    }
    if (cards.begin()->second == inf) {
        auto qwe = *cards.begin();
        cards.pop_front();
        bool res = f(p ^ 1);
        cards.push_front(qwe);
        return res;
    } else {
        auto qwe = *cards.begin();
        auto push = qwe;
        swap(push.first, push.second);
        push.second = inf;
        cards[0] = push;
        int i = 0;
        while (i != (int) cards.size() - 1 && cards[i].first > cards[i + 1].first) {
            swap(cards[i], cards[i + 1]);
            i++;
        }
        bool res1 = f(p ^ 1);
        while (i != 0) {
            swap(cards[i], cards[i - 1]);
            i--;
        }
        cards.pop_front();
        bool res2 = f(p ^ 1);
        cards.push_front(qwe);
        if (res1 == p || res2 == p) {
            return p;
        } else {
            return p ^ 1;
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> cards_pre(n + m);
    bool group3 = true;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        cards_pre[i].first = a;
    }
    for (int i = 0; i < n; i++) {
        int b;
        cin >> b;
        if (cards_pre[i].first < b) {
            group3 = false;
        }
        cards_pre[i].second = b;
    }
    for (int i = n; i < n + m; i++) {
        int c;
        cin >> c;
        cards_pre[i].first = c;
        cards_pre[i].second = inf;
    }
    for (auto &c : cards_pre) {
        cards.push_back(c);
    }
    if (group3) {
        int lenn = n + m;
        bool nw = false;
        for (int i = 0; i < lenn; i++) {
            if (cards[i].second == inf) {
                nw ^= 1;
            } else {
                if ((lenn - i - 1) % 2 == 1) {
                    continue;
                } else {
                    nw ^= 1;
                }
            }
        }
        if (!(nw ^ 1)) {
            cout << "First";
        } else {
            cout << "Second";
        }
        return;
    }
    sort(all(cards));
    int ans = f(0);
    if (ans == 0) {
        cout << "First";
    } else {
        cout << "Second";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
