#include <bits/stdc++.h>

using namespace std;
#define int long long
#define F first
#define S second

const int inf = 1e18;

int rec(set<pair<int, int>> &s) {
    if (s.empty()) {
        return 0;
    }
    if (s.begin()->second == inf) {
        auto x = *s.begin();
        s.erase(x);
        int res = rec(s);
        s.insert(x);
        return res ^ 1;
    } else {
        auto [x, y] = *s.begin();
        s.erase({x, y});
        int res1 = rec(s);
        s.insert({y, inf});
        int res2 = rec(s);
        s.erase({y, inf});
        s.insert({x, y});
        return min(res1, res2) ^ 1;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> a(n);
    vector<int> b(m);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].F;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].S;
    }
    for (int i = 0; i < m; ++i) {
        cin >> b[i];
    }
    set<pair<int, int>> s;
    for (int i = 0; i < n; ++i) {
        s.insert({a[i].F, a[i].S});
    }
    for (int i = 0; i < m; ++i) {
        s.insert({b[i], inf});
    }
    if (rec(s)) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
