#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using li = __int128;
using db = double;
using ld = long double;
using pi = pair <int, int>;
using pll = pair <ll, ll>;
#define all(x) x.begin(), x.end()

//mt19937 rnd(time(NULL));


void solve() {
    int n, m;
    cin >> n >> m;
    vector <pi> vec(n + m);
    vector <int> a(n + 1);
    for (int i = 0; i < n; ++i) cin >> vec[i].first, a[i] = vec[i].first;
    for (int i = 0; i < n; ++i) cin >> vec[i].second;
    for (int i = n; i < n + m; ++i) {
        cin >> vec[i].first;
        vec[i].second = 0;
    }
    a[n] = n * 2 + m + 1;
    sort(all(a));
    sort(all(vec));
    vector <int> cnt(n + 1);
    int sum = 0;
    vector <int> b;
    int ind = 0;
    for (int i = 0; i < n + m; ++i) {
        if (vec[i].second) {
            b.push_back(vec[i].second);
            cnt[ind++] = sum;
            sum = 0;
        }
        else ++sum;
    }
    vector <int> pred(n + 1, -1);
    int start = 0;
    for (int i = 0; i < n; ++i) {
        int next = upper_bound(all(a), b[i]) - a.begin();
        if (next <= i + 1) {
            start = i;
            break;
        }
        pred[next] = i;
    }
    int last = start;
    for (int i = start; i >= 0;) {
        if (pred[i] == -1)  {
            --i;
            continue;
        }
        last = pred[i];
        i = pred[i];
    }
    for (int i = 0; i < n + m; ++i) {
        if (vec[i].first == a[last]) {
            cout << (i % 2 ? "Second" : "First") << '\n';
            return;
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
