#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
#define db long double
#define MX LLONG_MAX
#define MN LLONG_MIN
#define gcd(a, b) __gcd(a, b)
#define lcm(a, b) (a / gcd(a, b) * b)

using namespace std;
using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

bool compare(const pair<int, bool>& a, const pair<int, bool>& b) {
    if (a.first == b.first) return a.second > b.second;
    return a.first < b.first;
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    vector<int> c(m);
    for (int i = 0; i < m; i++) {
        cin >> c[i];
    }

    vector<pair<int, bool>> v;
    for (int i = 0; i < n; i++)
        v.push_back({a[i], true});
    for (int i = 0; i < m; i++)
        v.push_back({c[i], false});

    sort(v.begin(), v.end(), compare);
    for (int i = 0; i < v.size(); i++) {
        if (v[i].second) {
            cout << (i % 2 ? "Second" : "First");
            return 0;
        }
    }
}
