//#pragma GCC optimize("O3,unroll-loops")
#include <vector>
//#pragma GCC target("avx2")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define segl i*2+1, l, (r + l) / 2
#define segr i*2+2, (r + l) / 2, r

const long long MOD = 1e9 + 7;
const int maxn = 2e5 + 5;

template<typename T, typename K>
istream& operator>>(istream& a, pair<T, K>& b) {
    a >> b.first >> b.second;
    return a;
}

template<typename T>
istream& operator>>(istream& a, vector<T>& b) {
    for(auto&i : b)
        a >> i;
    return a;
}

template<typename T, typename K>
ostream& operator<<(ostream& a, pair<T, K>& b) {
    a << b.first << ' ' << b.second;
    return a;
}

template<typename T>
ostream& operator<<(ostream& a, vector<T>& b) {
    for(auto& i : b)
        a << i << ' ';
    return a;
}

/*
                               .
                              .#.
                             .z@z.
                            .z#@#z.
                           .z#@@@#z.
                          .z#@@@@@#z.
                            `^#@#^`
                              .@.
                              .@.
                            ._z@z_.
                        ._z@#^` `^#@z_.
                       @#^`         `^#@
                       @               @
                       @z_.         ._z@
                        `^#@z_.  ._z@#^`
                    ._z@#^` `^#@#^`  `^#@z_.
                ._z@#^`                    `^#@z_.
      ._z#z_. .@#^`                            `^#@.  ._z#z_.
    ._z###@@@#^`                                  `^#@@@@@###z_.
  ._z###@@@@@#^`                                  `^#@@@@@@###z_.
 ._z###@@@@@#^`                                    `^#@@@@@@@###z_.
.zz###@@###^^`                                      ``^^###@@@@@##zz..
 */

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> dsk(n + m);
    for(int i = 0; i<n; ++i) {
        cin >> dsk[i].first;
    }
    for(int i = 0; i<n; ++i) {
        cin >> dsk[i].second;
    }
    for(int i = n; i<n+m; ++i) {
        cin >> dsk[i].first;
        dsk[i].second = -1;
    }

    bool crd = 0;
    int lstVul = n+m;
    sort(dsk.begin(), dsk.end());
    for(int i = n+m-1; i>=0; --i) {
        if(dsk[i].second == -1) {
            crd = !crd;
        } else {
            int pls = lower_bound(dsk.begin(), dsk.end(), make_pair(dsk[i].second, -1ll)) - dsk.begin();
            if(pls <= lstVul) {
                lstVul = i;
                crd = 1;
            } else {
                crd = !crd;
            }
        }
    }
    if(crd) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}
