#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include "ext/pb_ds/hash_policy.hpp"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/trie_policy.hpp"
#pragma GCC optimize("O3", "unroll-loops")
using namespace std;
using ll = long long;
const int maxn = 300000 + 52;
struct cd{
    int v, c;
    int ci;
    int mi;
};
const string Sec = "Second", Fir = "First";
string sol2(vector<int> a, vector<int> b, vector<int> s){
    int n = a.size(), m = s.size();

    vector<cd> v;
    vector<pair<int, int>> predobr(n);
    vector<int> q(2*n + m);
    for(int i = 0; i < n; ++i){
        ++q[a[i]-1];
    }
    vector<int> pref(2*n+m+1);
    for(int i = 0; i < 2*n+m; ++i){
        pref[i+1] = pref[i] + q[i];
    }
    for(int i = 0; i < n; ++i){
        if(pref[b[i]] - pref[a[i]-1] == 1){
            v.push_back({a[i], 1});
        }
    }
    for(int i = 0; i < m; ++i){
        v.push_back({s[i], 0});
    }
    sort(v.begin(), v.end(), [](const auto &a, const auto &b){ return   a.v < b.v;});
    vector<cd> nv;
    for(int i = 0; i < v.size(); ++i){
        if(!nv.empty() && nv.back().c == 1 && v[i].c == 1){
            continue;
        }
        else if(!nv.empty() && nv.back().c == v[i].c){
            //      cout << v[i].v << " " << v[i].c << endl;
            nv.pop_back();
        }
        else{
            //  cout << v[i].c << " pushed " << endl;
            nv.push_back(v[i]);
        }
    }

    const string Sec = "Second", Fir = "First";
    if(nv.empty()){
        return Sec;

    }
    for(auto i : nv){
        cerr << i.c << " ";
    }
    cerr  << endl;
    if(nv.front().c == 0 && nv.size() != 1){
        return Sec;
    }
    else{
        return Fir;
    }
}
bool wn(vector<cd> order, vector<bool> skip, int i, int who){
    while (i < order.size() && skip[i]){
        ++i;
    }
    if( ((i == order.size() - 1) && (who == 0)) || ((i == order.size()) && (who == 1))){
        return 1;
    }
    if( ((i == order.size() - 1) && (who == 1)) || ((i == order.size()) && (who == 0))) {
        return 0;
    }
    if(who == 0) {
        if (order[i].c == 0) {
            return wn(order, skip, i + 1, 1 - who);
        } else {
            bool r1 = wn(order, skip, i + 1, 1 - who);
            skip[order[i].ci] = 1;
            bool r2 = wn(order, skip, i + 1, 1 - who);
            // cerr << i << " " << r2 << endl;
            return r1 || r2;
        }
    }
    else{
        if (order[i].c == 0) {
            return wn(order, skip, i + 1, 1 - who);
        } else {
            bool r1 = wn(order, skip, i + 1, 1 - who);
            skip[order[i].ci] = 1;
            return r1 && wn(order, skip, i + 1, 1 - who);
        }
    }
}


string sol1(vector<int> a, vector<int> b, vector<int> s){
    int n = a.size(), m = s.size();
    vector<cd> initor;

    vector<int> pos(2 * n+m);
    for(int i = 0; i < n; ++i){
        if(b[i] < a[i]){
            b[i] = a[i];
        }
        initor.push_back({a[i], 1, 2*i+1, 2 * i});
        initor.push_back({b[i], 0, -1, 2*i+1});
    }
    for(int i = 0; i < m; ++i){
        initor.push_back({s[i], 0, -1, 2*(n) + i});
    }
    sort(initor.begin(), initor.end(), [](const auto &a, const auto &b){
        if(a.v == b.v){
            return a.c > b.c;
        }
        return   a.v < b.v;});
    vector<cd> new_initor;
    int one_ct = 0;
    for(int i = 0; i < initor.size(); ++i){
        if(!new_initor.empty() && new_initor.back().mi >= 2*n && initor[i].mi >= 2*n){
            one_ct -= 1;
            new_initor.pop_back();
            //  cout << new_initor.back().v << " " << initor[i].v << endl;
        }
        else{
            if(initor[i].mi >= 2*n){
                ++one_ct;
            }
            new_initor.push_back(initor[i]);
        }
    }
    swap(new_initor, initor);
    for(int i = 0; i < initor.size(); ++i){
        pos[initor[i].mi] = i;
    }
    for(int i = 0; i < initor.size(); ++i) {
        if (initor[i].c == 1) {
            initor[i].ci = pos[initor[i].ci];
        }
    }
//        for(int i = 0; i < initor.size(); ++i){
//            cout << " i: " << i << " c: " << initor[i].c << " " << " ci " << initor[i].ci << " v: " << initor[i].v << endl;
//
//    }
    vector<bool> skip(initor.size());

    if(wn(initor, skip, 0 ,0)){
        return Fir;
    }
    return Sec;


}
signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("main.in", "r", stdin);
    freopen("main.out", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n), s(m);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int i = 0; i < n; ++i){
        cin >> b[i];
    }
    for(int i = 0; i < m; ++i){
        cin >> s[i];

    }
    cout << sol2(a, b, s);

//    int n = 2, m = 1;
//    vector<int> t(2 * n  +m);
//    for(int i = 1; i <= 2 *n + m; ++i){
//        t[i-1] = i+0;
//    }
//    mt19937 rnd(239);
//    for(int i = 0; i < 1000; ++i){
//        cout << "Pas" << i << endl;
//        shuffle(t.begin(), t.end(), rnd);
//        vector<int> a(n), b(n), s(m);
//        for(int i = 0; i < n; ++i){
//            a[i] = t[i];
//        }
//        for(int i = 0; i < n; ++i){
//            b[i] = t[i + n];
//        }
//        for(int i = 0; i < n; ++i){
//            s[i] = t[2 * n + i];
//        }
//        string r1 = sol1(a, b, s), r2 = sol2(a, b, s);
//        if(r1 != r2){
//            for(int i : a){
//                cout << i << " ";
//            }
//            cout << endl;
//            for(int i : b){
//                cout << i << " ";
//            }
//            cout << endl;
//            for(int i : s){
//                cout << i << " ";
//            }
//            cout << endl;
//            cout << r1 << endl;
//        }
//    }




    return 0;
}
