#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll SZ = 5e5;
ll a[SZ], b[SZ], c[SZ];

bool f(set<pii> se) {
	if (se.empty()) return 0;
	pii p = *se.begin();
	se.erase(p);
	if (!f(se)) {
		return 1;
	}
	if (p.se != -1) {
		se.insert({ b[p.se], -1 });
		if (!f(se)) {
			return 1;
		}
	}
	return 0;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	for (ll i = 0; i < n; i++) cin >> a[i];
	for (ll i = 0; i < n; i++) cin >> b[i];
	for (ll i = 0; i < m; i++) cin >> c[i];
	set<pii> se;
	for (ll i = 0; i < n; i++) se.insert({ a[i], i });
	for (ll i = 0; i < m; i++) se.insert({ c[i], -1 });
	if (f(se)) {
		cout << "First\n";
	}
	else {
		cout << "Second\n";
	}
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}
