#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

typedef long long ll;

using namespace std;

void fio() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
}

const int MOD = 1'000'000'000 + 7;
const int UNDEF = -1;

void solveA() {
    int n;
    cin >> n;

}

void solveC() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> val(2 * n + m);
    for (int i = 0; i < n; i++) {
        cin >> val[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> val[i + n].first;
        val[i].second = val[i + n].first;
        val[i + n].second = UNDEF;
    }
    for (int i = 0; i < m; i++) {
        cin >> val[2 * n + i].first;
        val[2 * n + i].second = UNDEF;
    }
    sort(val.begin(), val.end());
    vector<bool> res(2 * n + m, false);
    res.back() = true;
    for (int i = 2 * n + m - 2; i >= 0; i--) {
        if (val[i].second == UNDEF) {
            res[i] = !res[i + 1];
        } else {
            int left = i;
            int right = n;
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (val[mid].first <= val[i].second) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            res[i] = !res[left] || !res[i + 1];
        }
    }
    if (res[0]) {
        cout << "First";
    } else {
        cout << "Second";
    }
}

int main() {
    fio();
    solveC();
    return 0;
}