#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ld long double
#define F first
#define S second

const int inf = 1e18;
const int maxn = 6e6;
const int LOG = 30;
const int N = 2e3;
const ld eps = 1e-12;

int t[maxn];

void upd(int pos, int val) {
    for(int i = pos + 1; i < maxn; i += (i & (-i))) {
        t[i] += val;
    }
}

int get(int r) {
    int res = 0;
    for(int i = r; i > 0; i -= (i & (-i))) {
        res += t[i];
    }
    return res;
}

int get(int l ,int r) {
    return get(r + 1) - get(l);
}

inline void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> a(n);
    for(int i  =0; i < n; i++) cin >> a[i].F;
    for(int i = 0; i < n; i++) cin >> a[i].S;

    for(int i = 0; i < n; i++) {
        a[i].S = max(a[i].F, a[i].S);

        upd(a[i].F, 1);
    }

    vector<int> c(m);

    for(int i = 0; i < m; i++) {
        cin >> c[i];
    }

    int lst = inf;

    for(int i = n - 1; i > -1; i--) {
        if(lst < a[i].S) {
            c.pb(a[i].F);
            upd(a[i].F, -1);
            a[i] = {-1, -1};
            continue;
        }
        if(get(a[i].F, a[i].S) == 1) {
            lst = a[i].F;
        }
    }

    sort(all(c));

    int ind = -1;
    for(int i = 1; i < n; i++) {
        if(a[i].F == -1) continue;
        if(ind == -1 || a[i].S < a[ind].S) ind = i;
    }

    int cnt = 0;

    for(int i = 0; i < n; i++) {
        if(a[i].F == -1) continue;
        cnt += (a[i].F <= a[ind].F);
    }

    for(int i = 0; i < c.size(); i++) {
        cnt += (c[i] <= a[ind].F);
    }



    if(cnt % 2 == 0) {
        cout << "Second\n";
    } else {
        cout << "First\n";
    }
    return;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tt = 1;
    //cin >> tt;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    while (tt--) {
        solve();
    }
    return 0;
}
