#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <map>

using namespace std;

#define ll long long
#define FOR(i, s, f) for(ll (i) = (s); (i) < (f); (i)++)
const long long INF = 1e9;

void solve(){
    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> cards(n);
    FOR(i, 0, n){
        ll a;
        cin >> a;
        cards[i].first = a;
    }
    FOR(i, 0, n){
        ll a;
        cin >> a;
        cards[i].second = a;
    }
    FOR(i, 0, m){
        ll x;
        cin >> x;
        cards.push_back({x, -1});
    }
    sort(cards.begin(), cards.end());
    ll ind = n + m - 1;
    while(cards[ind].second == -1) ind--;
    if (ind % 2 == 1) cout << "Second";
    else cout << "First";
}

int main() {
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
