#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
#include <map>

using namespace std;

#define ll long long
#define FOR(i, s, f) for(ll (i) = (s); (i) < (f); (i)++)
const long long INF = 1e9;

bool func(set<pair<ll, ll>> &card, auto it){
    ll cnt = 0;
    vector<pair<ll, ll>> arr(0);
    while(it != --card.end() && (*it).second == -1){
        cnt++;
        it++;
    }
    if (it == --card.end()){
        cnt++;
        return cnt % 2;
    }
    pair<ll, ll> c = (*it);
    bool a, b;
    auto tt = it;
    a = func(card, ++tt);
    if (c.first > c.second){
        card.insert({c.second, -1});
        tt = it;
        tt++;
        b = func(card, tt);
    }
    else{
        cnt++;
        b = func(card, ++tt);
    }
    return (cnt + !(a & b)) % 2;
}

void solve(){
    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> cards(n);
    FOR(i, 0, n){
        ll a;
        cin >> a;
        cards[i].first = a;
    }
    FOR(i, 0, n){
        ll a;
        cin >> a;
        cards[i].second = a;
    }
    FOR(i, 0, m){
        ll x;
        cin >> x;
        cards.push_back({x, -1});
    }
    set<pair<ll, ll>> card;
    for(auto it: cards){
        card.insert(it);
    }
    if (func(card, card.begin())) cout << "First";
    else cout << "Second";
}

int main() {
    cout.precision(32);
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
