#include <bits/stdc++.h>
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")
using namespace std;
using ll = long long;
using ull = unsigned long long;

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//
//template <class T> using ordered_set = tree<T, null_type, less<T>,
//        rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e9;
const ll MOD = 1e9 + 7;

mt19937 rnd(time(0));

vector <vector <int>> g;
vector <int> deg;
vector <bool> good;

void dfs(int v) {
    for (auto to : g[v]) {
        deg[to]--;
        if (!good[v]) {
            good[to] = true;
        }
        if (deg[to] == 0) {
            dfs(to);
        }
    }
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0); std::cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector <ll> a(n), b(n), c(m);
    vector <pair<int, int>> ab;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        b[i]--;
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i];
        c[i]--;
    }
    for (int i = 0; i < n; i++) {
        ab.push_back({a[i], b[i]});
    }
    sort(ab.begin(), ab.end());
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    sort(c.begin(), c.end());
    g.resize(2 * n + m);
    deg.resize(2 * n + m);
    good.resize(2 * n + m);
    for (int i = 0; i < n; i++) {
        auto [aa, bb] = ab[i];
        g[bb].push_back(aa);
        deg[aa]++;
        auto w1 = lower_bound(a.begin(), a.end(), aa + 1);
        auto w2 = lower_bound(c.begin(), c.end(), aa + 1);
        if (w1 != a.end() && w2 != c.end()) {
            g[min(*w1, *w2)].push_back(bb);
            deg[bb]++;
        } else if (w1 != a.end()) {
            g[*w1].push_back(bb);
            deg[bb]++;
        } else if (w2 != c.end()) {
            g[*w2].push_back(bb);
            deg[bb]++;
        }

        w1 = lower_bound(a.begin(), a.end(), max(aa, bb) + 1);
        w2 = lower_bound(c.begin(), c.end(), max(aa, bb) + 1);
        if (w1 != a.end() && w2 != c.end()) {
            g[min(*w1, *w2)].push_back(aa);
            deg[aa]++;
        } else if (w1 != a.end()) {
            g[*w1].push_back(aa);
            deg[aa]++;
        } else if (w2 != c.end()) {
            g[*w2].push_back(aa);
            deg[aa]++;
        }
    }
    for (int i = 0; i < m; i++) {
        auto w1 = lower_bound(a.begin(), a.end(), c[i] + 1);
        auto w2 = lower_bound(c.begin(), c.end(), c[i] + 1);
        if (w1 != a.end() && w2 != c.end()) {
            g[min(*w1, *w2)].push_back(c[i]);
            deg[c[i]]++;
        } else if (w1 != a.end()) {
            g[*w1].push_back(c[i]);
            deg[c[i]]++;
        } else if (w2 != c.end()) {
            g[*w2].push_back(c[i]);
            deg[c[i]]++;
        }
    }
    if (c.back() > a.back()) {
        good[c.back()] = true;
        dfs(c.back());
    } else {
        auto [aa, bb] = ab.back();
        good[aa] = true; good[bb] = true;
        dfs(aa); dfs(bb);
    }
    if (good[min(a.front(), c.front())]) {
        cout << "First";
    } else {
        cout << "Second";
    }
    return 0;
}
