#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <string>

#define len(v) (int)((v).size())
#define ss second
#define ff first


typedef long long ll;

using namespace std;

const ll inf = 1e12 + 7;

struct card {
	int nx;
	bool fl;

	card() = default;
};

bool operator<(card a, card b) {
	return false;
}

void solve() {
	int n, m;
	cin >> n >> m;
	int k = n * 2 + m;
	vector<card> tp(k);

	vector<int> a(n), b(n), c(m);

	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
		tp[a[i]].nx = i;
		tp[a[i]].fl = true;
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
		--b[i];
		tp[b[i]].fl = false;
		tp[b[i]].nx = i;
	}
	for (int i = 0; i < m; ++i) {
		cin >> c[i];
		--c[i];
		tp[c[i]].fl = true;
		tp[c[i]].nx = -1;
	}

	vector<pair<int, card>> d;
	d.push_back({ 2 * n + m , card()});
	for (int i = 0; i < n; ++i) {
		d.push_back({ a[i], tp[a[i]] });
		d.push_back({ b[i], tp[b[i]] });
	}
	sort(d.begin(), d.end());

	vector<vector<bool>> dp(2 * n + 1, vector<bool>((1 << n), false));
	for (int i = 2 * n - 1; i >= 0; --i) {
		for (int j = 0; j < (1 << n); ++j) {
			dp[i][j] = dp[i + 1][j] != ((d[i + 1].first - d[i].first) % 2 == 1);
			if (d[i].second.fl) {
				if (j & (1 << d[i].second.nx)) {
					if (b[d[i].second.nx] < d[i].first) {
						dp[i][j] = true;
					}
					else {
						dp[i][j] = dp[i][j] || dp[i + 1][j | (1 << d[i].second.nx)] != ((d[i + 1].first - d[i].first) % 2 == 1);
					}
				}
			}
			else {
				dp[i][j] = dp[i][j] != ((j & (1 << d[i].second.nx)) > 0);
			}
		}
	}

	if (n == 0) {
		dp[0][0] = (m % 2 == 1);
	}

	vector<string> res = { "Second\n", "First\n" };
	cout << res[dp[0][0] != (d[0].first % 2 == 1)];
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cout.precision(30);

	int t = 1;
	//	cin >> t;
	while (t--) solve();
}



