#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pr = pair<ll, ll>;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 1;
const ll INFLL = 1e18 + 1;
int reps = 1;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;

template<typename T>
inline void print(const vector<T> &a, string sep=" ") {
    for (auto &x : a) cout << x << sep;
    cout << "\n";
}

template<typename T>
inline void print(const set<T> &a, string sep=" ") {
    for (auto &x : a) cout << x << sep;
    cout << "\n";
}

//====================================

void solve() {
    int n, m; cin >> n >> m;
    vector<pii> a(n);
    vector<int> c(m);
    for (auto &[x, y] : a) cin >> x;
    for (auto &[x, y] : a) cin >> y;
    for (auto &x : c) cin >> x;
    sort(all(a));
    sort(all(c));
    int mnf = INF, mns = INF;
    vector<pii> cur;
    for (auto [x, y] : a) cur.push_back({x, y});
    for (auto x : c) cur.push_back({x, INF});
    sort(all(cur));
    int i = 0;
    vector<int> cc(n, -1);
    while (i < m) {
        auto [x, y] = cur[i];
        if (y == -1) {
            i++;
            continue;
        }
        int cd = i % 2;
        int pos = 0;
        while (pos < n && a[pos].first != x) pos++;
        if (pos < n && cc[pos] != -1) cd = cc[pos];

        for (int j = 0; j < n; j++) {
            if (a[j].first > y) cc[j] = cd;
        }
        i++;
    }
    // for (i = 0; i < n; i++) {
    //     for (int j = i  +1; j < n; j++) {
    //         if (a[j].first > a[i].second) cc[j] = cc[i];
    //     }
    // }
    if (cc[n-1] == 0) cout << "First\n";
    else cout << "Second\n";
}

//====================================

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL 
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
#endif
    for (int i = 0; i < reps; i++) {
#ifdef LOCAL 
        cout << "Test case #" << i + 1 << " ==============\n";
#endif
        solve();
#ifdef LOCAL 
        cout << "End test ==============\n";
#endif
    }
    return 0;
}

// g++ -std=c++23 -Wall -Wextra -Wshadow -DLOCAL -D_GLIBCXX_DEBUG -fsanitize=address,undefined -O2 A.cpp -o A
