#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

//#pragma GCC optimize("Ofast, unroll-loops, fast-math, no-stack-protector, inline")
//#pragma GCC target("avx2")

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using ull = unsigned long long;
#define int long long

const ll INF = 1e18 + 228;
const ll mod = 1e9 + 7;
const ld eps = 1e-8;

random_device rd;
mt19937 rnd(rd() + 228 + 57 - 179);

bool rec(vector<pair<int, int>> &dv, int cur, int mm) {
    if (cur + 1 == dv.size()) return 1;
    if (dv[cur].second < dv[cur + 1].first) return 1;
    bool res1 = rec(dv, cur + 1, mm);
    //int pos = upper_bound(dv.begin(), dv.end(), make_pair(dv[cur].second, -1), less<p) - dv.begin();
    int l = -1, r = dv.size();
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (dv[m].first < dv[cur].second) l = m;
        else r = m;
    }
    int pos = r;
    int nm = ((~0) >> pos << pos) ^ mm;
    bool res2 = rec(dv, cur + 1, nm);
    if (res1 && bool(mm & (1 << cur)) == bool(mm & (1 << (cur + 1)))) return 1;
    if (res2 && bool(mm & (1 << cur)) == bool(nm & (1 << (cur + 1)))) return 1;
    if (!res1 && bool(mm & (1 << cur)) != bool(mm & (1 << (cur + 1)))) return 1;
    if (!res2 && bool(mm & (1 << cur)) != bool(nm & (1 << (cur + 1)))) return 1;
    return 0;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> card(n + m, {-1, -1});
    for (int i = 0; i < n; ++i) {
        cin >> card[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> card[i].second;
    }
    for (int i = n; i < n + m; ++i) {
        cin >> card[i].first;
    }
    sort(card.begin(), card.end());
    vector<pair<int, int>> dv;
    vector<int> pos;
    int mask = 0;
    for (int i = 0; i < n + m; ++i) {
        if (card[i].second != -1) {
            dv.push_back(card[i]);
            pos.push_back(i);
            if (i & 1) {
                mask += (1 << (pos.size() - 1));
            }
        }
    }
    
    bool res = rec(dv, 0, mask);
    int fp = mask & 1;
    if (!fp && res) cout << "First";
    else if (fp && !res) cout << "First";
    else cout << "Second";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int tt = 1;
    //cin >> tt;
    while (tt--) solve();
    return 0;
}
