#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#ifndef DEBUG
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
#endif

using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using pll = std::pair<ll, ll>;
using ld = long double;
using i128 = __int128;

#define lv(v) v + 1
#define rv(v) v + 2 * (m - l)

std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

std::priority_queue<pll, std::vector<pll>, std::greater<pll>> d;
std::vector<ll> a, b, c;

ll rec(bool isfrst){
    if (d.empty() && isfrst){
        return true;
    }
    else if (d.empty()){
        return false;
    }
    if (d.top().second == -1){
        auto it = d.top();
        d.pop();
        bool flg = rec(!isfrst);
        d.push(it);
        return flg;
    }
    else{
        auto it = d.top();
        d.pop();
        bool flg = rec(!isfrst);
        if (isfrst == flg){
            d.push(it);
            return isfrst;
        }
        else{
            d.push({it.second, -1});
            flg = rec(!isfrst);
            d.pop();
            d.push(it);
            if (isfrst == flg){
                return isfrst;
            }
            else{
                return !isfrst;
            }
        }
    }
}

void solve() {
    ll n, m;
    std::cin >> n >> m;
    a.resize(n);
    b.resize(n);
    c.resize(m);
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        std::cin >> b[i];
        d.push({a[i], b[i]});
    }
    for (int i = 0; i < m; ++i) {
        std::cin >> c[i];
        d.push({c[i], -1});
    }
    bool flg = rec(true);
    if (flg){
        std::cout << "First";
    }
    else{
        std::cout << "Second";
    }
}

int main() {
#ifdef DEBUG
    std::freopen("/home/olymp/CLionProjects/untitled/input.txt", "r", stdin);
#endif
    std::cin.tie(0)->std::ios::sync_with_stdio(0);
    int tt = 1;
//    std::cin >> tt;
    while (tt--) {
        solve();
    }
}
