#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n);
    cin >> a >> b;
    vector<int> c(m);
    cin >> c;
    
    set<pair<int, int>> st;
    for (int i : c) st.insert({i, -1});
    for (int i = 0; i < n; i++) st.insert({a[i], b[i]});
    int cur = n + m;
    bool e = true;
    
    while (!st.empty()) {
        auto [q, w] = *st.begin();
        st.erase(st.begin());
        if (w == -1) {
            e = !e;
            continue;
        } else {
            if (e) {
                if (cur % 2 == 0) {
                    st.insert({w, -1});
                    cur++;
                }
            } else {
                if (cur % 2) {
                    st.insert({w, -1});
                    cur++;
                }
            }
            
            e = !e;
        }
    }
    
    cout << (cur % 2 ? "First" : "Second");
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}
