#include <bits/stdc++.h>
using namespace std;
#define int long long

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (T& i : v) in >> i;
    return in;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), b(n);
    cin >> a >> b;
    vector<int> c(m);
    cin >> c;
    sort(c.begin(), c.end());

    vector<int> p(n);
    iota(p.begin(), p.end(), 0ll);
    sort(p.begin(), p.end(), [&](int f, int s) {
        return a[f] < a[s];
    });

    c.push_back(1e9);

    vector<pair<int, int>> bs;
    int lastgood = -1;

    for (int i = 0; i < n; i++) {
        int player = -1;
        if (bs.size()) {
            auto it = lower_bound(bs.begin(), bs.end(), make_pair(i, 0ll));
            if (it != bs.begin()) {
                --it;
                player = it->second;
            }
        }

        if (player == -1 && lastgood != -1) {
            player = lastgood;
        }

        if (player == -1) {
            int cnt = i + upper_bound(c.begin(), c.end(), a[p[i]]) - c.begin();
            if (cnt % 2) player = 1;
            else player = 0;
        }

        if (i == n - 1) {
            if (player == 0) cout << "First";
            else cout << "Second";
            return;
        }

        if (a[p[i+1]] > b[p[i]] || b[p[i]] < a[p[i]]) {
            // is good
            lastgood = player;
            bs.clear();
        } else {
            bs.emplace_back(b[p[i]], player);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve(), cout << '\n';
}
