#include <iostream>
#include <algorithm>
#include <vector>
#include <bitset>
#include <cmath>
#include <set>

bool dfs(std::set<std::pair<int, int>> a, std::set<int> c) {
	if (c.size() == 0 && a.size() == 0) {
		return 0;
	}
	if (c.size() == 0) {
		int z = (*a.begin()).second;
		a.erase(a.begin());
		if (!dfs(a, c)) {
			return 1;
		}
		c.insert(z);
		return !dfs(a, c);
	}
	if (a.size() == 0) {
		c.erase(c.begin());
		return !dfs(a, c);
	}
	int x = (*a.begin()).first;
	int y = (*c.begin());
	if (y < x) {
		c.erase(c.begin());
		return !dfs(a, c);
	}
	int z = (*a.begin()).second;
	a.erase(a.begin());
	if (!dfs(a, c)) {
		return 1;
	}
	c.insert(z);
	return !dfs(a, c);
}
int main() {
	std::ios_base::sync_with_stdio(0);
	std::cin.tie(0);
	int n, m;
	std::cin >> n >> m;
	std::vector<int> a(n), b(n);
	std::set<int> c;
	std::vector<int> f(n + 1);
	for (int& i : a) {
		std::cin >> i;
	}
	for (int& i : b) {
		std::cin >> i;
	}
	for (int i = 0; i < m; ++i) {
		int x;
		std::cin >> x;
		c.insert(x);
	}
	/*
	for (int i = 0; i < m; ++i) {
		int x;
		std::cin >> x;
		int t = std::lower_bound(a.begin(), a.end(), x) - a.begin();
		if (f[t] == 0) {
			f[t] = x;
		}
		else {
			f[t] = 0;
		}
	}
	for (int i = 0; i <= n; ++i) {
		if (f[i] != 0) {
			c.insert(f[i]);
		}
	}
	*/
	std::set<std::pair<int, int>> p;
	for (int i = 0; i < n; ++i) {
		p.insert({ a[i], b[i] });
	}
	if (dfs(p, c)) {
		std::cout << "First\n";
	}	
	else {
		std::cout << "Second\n";
	}
}