#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

//#pragma GCC optimize("O3")

#define out(x) std::cout << x << ' ';
#define oute(x) std::cout << x << '\n';
#define enter std::cout << '\n';
#define debout(x) std::cout << #x << x << '\n';
#define debvout(x) std::cout << #x << " : "; for (auto i: x) std::cout << x << ' '; std::cout << '\n';
#define all(x) x.begin(), x.end()
using ll = long long;

const ll inf = 1e18;

void s1nmeee() {
    ll n, m;
    std::cin >> n >> m;
    std::vector<std::pair<ll, ll>> e(n + m, {inf, inf});
    for (ll i = 0; i < n; i++) std::cin >> e[i].first;
    for (ll i = 0; i < n; i++) std::cin >> e[i].second;
    for (ll i = n; i < n + m; i++) std::cin >> e[i].first;
    std::sort(all(e));
    ll ind = -1;
    for (ll i = n + m - 1; i >= 0; i--) {
        if (e[i].second != inf) {
            if (ind == -1) ind = i;
            else {
                if (e[i].second < e[ind].first) ind = i;
            }
        }
    }
    out((ind % 2 == 0 ? "First" : "Second"))
}

signed main() {
    std::cin.tie(nullptr), std::ios::sync_with_stdio(false);
    ll TT = 1;
    //std::cin >> TT;
    while (TT--) {
        s1nmeee();
        std::cout << '\n';
    }
}