#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define forsn(i,s,e) for(ll i = s; i <= e; i++)
#define rforsn(i,s,e) for(ll i = s; i >= e; i--)
#define ln '\n'
#define all(x) x.begin(), x.end()

const ll inf = INT64_MAX;

ll get(set <pair <ll, ll>>& s, ll p) {
    if (s.size() == 1)
        return p;
    auto s1 = s;
    s1.erase(s1.begin());
    ll v1 = get(s1, (p + 1) % 2);
    auto cur = *s.begin();
    if (cur.second) {
        swap(cur.first, cur.second);
        cur.second = 0;
        s1.insert(cur);
        ll v2 = get(s1, (p + 1) % 2);
        if (v1 == p || v2 == p)
            return p;
        return (p + 1) % 2;
    }
    return v1;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0);

    ll n, m;
    cin >> n >> m;
    vector <ll> a(n);
    for (ll& i: a)
        cin >> i;
    vector <ll> b(n);
    for (ll& i: b)
        cin >> i;
    vector <ll> c(m);
    for (ll& i: c)
        cin >> i;

    set <pair <ll, ll>> s;
    forsn(i, 0, n - 1) {
        s.emplace(a[i], b[i]);
    }

    for (ll i: c)
        s.emplace(i, 0);

    ll ans = get(s, 0);

    if (ans == 0)
        cout << "First";
    else
        cout << "Second";

    return 0;
}
