#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pi;

#define int ll
#define pb push_back
#define pf push_front
#define in insert
#define f first
#define s second

mt19937_64 rnd;

const int inf = 1e17, N = 210, mod = 1e9 + 7;

map<int, int> mp;
vector<vector<int>> dp(N, vector<int>(N));

void dfs(int n, int m, set<int> st){
  if(!st.size()){
    dp[n][m] = 0;
    return;
  }
  int beg = *st.begin();
  st.erase(beg);
  if(mp[beg] == -1){
    dfs(n, m - 1, st);
    if(!dp[n][m - 1]) dp[n][m] = 1;
  }
  else{
    st.in(mp[beg]);
    dfs(n - 1, m + 1, st);
    if(!dp[n - 1][m + 1]) dp[n][m] = 1;
    st.erase(mp[beg]);
    dfs(n - 1, m, st);
    if(!dp[n - 1][m]) dp[n][m] = 1;
  }
}

signed main(){
  int n, m;
  cin >> n >> m;
  vector<int> a(n), b(n), c(m);
  if(n == 0){
    cout << (m ? "First" : "Second");
    return 0;
  }
  for(int &x : a) cin >> x;
  for(int i = 0; i < n; i++){
    cin >> b[i];
    mp[a[i]] = b[i];
    mp[b[i]] = -1;
  }
  for(int &x : c){
    cin >> x;
    mp[x] = -1;
  }
  set<int> st;
  for(int i = 0; i < n; i++) st.in(a[i]);
  for(int i = 0; i < m; i++) st.in(c[i]);
  dfs(n, m, st);
  cout << (dp[n][m] ? "First" : "Second");
  return 0;
}