#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pi;

#define int ll
#define pb push_back
#define pf push_front
#define in insert
#define f first
#define s second

mt19937_64 rnd;

const int inf = 1e17, N = 210, mod = 1e9 + 7;

map<int, int> mp;
vector<vector<int>> dp(N, vector<int>(N));

bool dfs(set<int> st){
  bool res = 0;
  if(!st.size()) return 0;
  int beg = *st.begin();
  st.erase(beg);
  if(mp[beg] == -1) return !dfs(st);
  else{
    st.in(mp[beg]);
    if(!dfs(st)) return 1;
    st.erase(mp[beg]);
    if(!dfs(st)) return 1;
  }
  return 0;
}

signed main(){
  int n, m;
  cin >> n >> m;
  vector<int> a(n), b(n);
  set<int> c;
  vector<int> line(2 * n + m + 1);
  if(n == 0){
    cout << (m ? "First" : "Second");
    return 0;
  }
  for(int &x : a) cin >> x;
  for(int i = 0; i < n; i++){
    cin >> b[i];
    mp[a[i]] = b[i];
    mp[b[i]] = -1;
    line[a[i]] = line[b[i]] = -1;
  }
  for(int i = 0; i < m; i++){
    int x;
    cin >> x;
    c.in(x);
    mp[x] = -1;
    line[x] = 1;
  }
  int prev = -1;
  for(int i = 1; i <= 2 * n + m; i++){
    if(line[i] == -1){
      prev = -1;
      continue;
    }
    if(line[i] == 1){
      if(prev == -1) prev = i;
      else{
        c.erase(prev);
        c.erase(i);
        prev = -1;
      }
    }
  }
  set<int> st;
  for(int i = 0; i < n; i++) st.in(a[i]);
  for(int x : c) st.in(x);
  int mem = 0, k = 1;
  for(set<int>::iterator it = st.begin(); it != st.end(); it++){
    if(mp[*it] != -1) mem = k;
    k++;
  }
  cout << (mem % 2 ? "First" : "Second");
  return 0;
}