#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast")

#define int long long

using namespace std;

const int mod = 1e9 + 7;
const int maxn = 2e5 + 1;
const int inf = 4e18;

void solve() {
    int n, m; cin >> n >> m;
    vector<int> a(n), b(n), c(m);
    vector<array<int, 2>> d;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        d.push_back({a[i], i});
    }
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i];
        d.push_back({c[i], -1});
    }

    function<bool(int)> who_win = [&](int mask) {
        int move = 0;
        set<pair<int, int>> s;
        for (int i = 0; i < m; i++) {
            s.emplace(c[i], -1);
        }
        for (int i = 0; i < n; i++) {
            s.emplace(a[i], i);
        }
        while (!s.empty()) {
            int v = s.begin()->first;
            int idx = s.begin()->second;
            s.erase(s.begin());
            if (idx != -1 and (mask >> idx) & 1) {
                s.emplace(b[idx], -1);
            }
            move ^= 1;
        }
        return move;
    };

    for (int mask = 0; mask < (1 << n); mask++) {
        if (who_win(mask)) {
            cout << "First\n";
            return;
        }
    }
    cout << "Seconnd\n";
}

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
