#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

//#define int long long

using ll = long long;
using namespace std;

//bool get_ans(vector<int> &b, set<pair<int, int>> &d) {
//    if (d.empty()) {
//        return 0;
//    }
//    if (d.begin() -> second == -1) {
//        auto cur = *d.begin();
//        d.erase(d.begin());
//        int ans = get_ans(b, d) ^ 1;
//        d.insert(cur);
//        return ans;
//    } else {
//        auto cur = *d.begin();
//        d.erase(d.begin());
//        int ans1 = get_ans(b, d) ^ 1;
//        d.insert({b[cur.second], -1});
//        int ans2 = get_ans(b, d) ^ 1;
//        d.erase({cur.second, -1});
//        d.insert(cur);
//        return (ans1 || ans2);
//    }
//}

bool get_ans(int ind, vector<pair<int, int>> &a, vector<int> &used) {
    if (ind == a.size()) {
        return !used.back();
    }
    int ans1 = get_ans(ind + 1, a, used);
    for (int i = ind + 1; i < a.size(); i++) {
        if (a[i].first > a[ind].second) {
            used[i] ^= 1;
        }
    }
    int ans2 = get_ans(ind + 1, a, used);
    for (int i = ind + 1; i < a.size(); i++) {
        if (a[i].first > a[ind].second) {
            used[i] ^= 1;
        }
    }
    return (ans1 || ans2);
}

void solve() {
    int n, m, ind = 0;
    cin >> n >> m;
    vector<int> used(n), c(m);
    vector<pair<int, int>> a(n), d;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
        d.push_back({a[i].first, 0});
    }
    for (int i = 0; i < n; i++) {
        cin >> a[i].second;
    }
    for (int i = 0; i < m; i++) {
        cin >> c[i];
        d.push_back({c[i], -1});
    }
    sort(a.begin(), a.end());
    sort(d.begin(), d.end());
    for (int i = 0; i < d.size(); i++) {
        if (d[i].second != -1) {
            used[ind] = i % 2;
            ind++;
        }
    }
    if (get_ans(0, a, used)) {
        cout << "First\n";
    } else {
        cout << "Second\n";
    }
}

signed main() {
    int t = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> t;
#else
    ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
#endif
//    cin >> t;
    while (t--) {
        solve();
    }
}
