#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve2(ll n, ll m, vector<ll> &a, vector<ll> &b, vector<ll> &c) {
    ll minn = 1e18;
    for (ll i = 0; i < n; i++) {
        if (a[i] < minn) {
            minn = a[i];
        }
    }
    ll cnt = 0;
    for (ll i : c) {
        if (i < minn) cnt++;
    }
    if (cnt % 2 == 0) {
        cout << "First" << '\n';
    } else {
        cout << "Second" << '\n';
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<ll> a(n), b(n), c(m);
    for (ll &i : a) cin >> i;
    for (ll &i : b) cin >> i;
    for (ll &i : c) cin >> i;
    vector<ll> t(2 * n + m);
    for (ll i : a) {
        t[i]++;
    }
    for (ll i : b) {
        t[i]--;
    }
    ll cc = 0;
    bool g = true;
    for (ll i : t) {
        cc += i;
        if (cc > 1) {
            g = false;
        }
    }
    if (g) {
        solve2(n, m, a, b, c);
        return;
    }
    map<ll, ll> ma;
    set<pair<ll, ll>> cur;
    for (ll i = 0; i < n; i++) {
        cur.insert({a[i], i});
    }
    for (ll i = 0; i < m; i++) {
        cur.insert({c[i], i + n});
    }
    ll x = 1;
    for (ll i = 0; i < n + m; i++) {
        auto [cost, j] = *cur.begin();
        cur.erase({cost, j});
        if (j > n) {
            x ^= 1;
            continue;
        }
        if (j == n - 1 || (b[j] < a[j + 1])) {
            if (x) {
                cout << "First" << '\n';
            } else {
                cout << "Second" << '\n';
            }
            break;
        }
        x ^= 1;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}
