#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
//#define int long long
using namespace std;
using ll = long long;
using pii = pair<int, int>;
const int inf = 1e9 + 52;



signed main() {
    int n, m;
    cin >> n >> m;
    vector<pii> all(n + m);
    vector<pii> a(n);
    for (int i = 0; i < n; i++) {
        cin >> all[i].first;
    }
    for (int i = 0; i < n; i++) {
        cin >> all[i].second;
        a[i] = all[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> all[i + n].first;
        all[i + n].second = 0;
    }
    sort(a.begin(), a.end());
    pii nd = {-1, -1};

    vector<int> nxtv(n, inf);
    vector<int> st;
    for (int i = 0; i < n; i++) {
        while (!st.empty() && a[st.back()].second > a[i].second) {
            nxtv[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }

    for (int i = 0; i < n; i++) {
        if (nd.first != -1) {
            break;
        }
        if (i == n - 1) {
            nd = a[i];
        }
        else {
            if (a[n - 1].first > a[i].second) {
                int fbg = upper_bound(a.begin(), a.end(), make_pair(a[i].second, 0)) - a.begin();
                if (fbg <= nxtv[i]) {
                    nd = a[i];
                }
            }
        }
    }
    sort(all.begin(), all.end());

    for (int i = 0; i < n + m; i++) {
        if (all[i] == nd) {
            if (i % 2) {
                cout << "Second" << endl;
            }
            else {
                cout << "First" << endl;
            }
            return 0;
        }
    }
}  