#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) x.begin(),x.end()
#define mem(x, y) memset(x, y, sizeof x)
#define sz(x) int(x.size())
#define int ll

map <set <pair <int, int>>, int> memo;
bool solve(set <pair <int, int>> s) {
	if (s.empty()) return 0;
	if (memo.count(s)) return memo[s];
	
	if (s.begin()->second == -1) {
		s.erase(s.begin());
		return memo[s] = !solve(s);
	}
	
	auto beg = *s.begin();
	s.erase(s.begin());
	bool ok = !solve(s);
	s.insert({beg.second, -1});
	return memo[s] = (ok | (!solve(s)));
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	
	int n, m;
	cin >> n >> m;
	
	vector <pair <int, int>> a(n);
	for (int i = 0; i < n; i++) cin >> a[i].first;
	for (int i = 0; i < n; i++) cin >> a[i].second;
	vector <int> c(m);
	for (int i = 0; i < m; i++) cin >> c[i];
	
	set <pair <int, int>> s;
	for (int i = 0; i < n; i++) s.insert(a[i]);
	for (int i = 0; i < m; i++) s.insert({c[i], -1});
	
	cout << (solve(s) ? "First" : "Second") << '\n';
	
	return 0;
}
