#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) x.begin(),x.end()
#define mem(x, y) memset(x, y, sizeof x)
#define sz(x) int(x.size())

vector <pair <int, int>> s;
map <vector <pair <int, int>>, int> memo;

bool solve() {
	if (s.empty()) return 0;
	if (!memo.count(s)) {
		auto x = *s.begin();
		s.erase(s.begin());
		bool res = !solve();
		
		if (!res && x.second != -1) {
			s.push_back({x.second, -1});
			sort(all(s));
			
			res |= (!solve());
			
			for (int i = 0; i < sz(s); i++) {
				if (s[i] == make_pair(x.second, -1)) {
					s.erase(s.begin() + i);
					break;
				}
			}
		}
		
		s.push_back(x);
		sort(all(s));
		
		memo[s] = res;
	}
	return memo[s];
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	
	int n, m;
	cin >> n >> m;
	
	vector <int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		s.push_back({a[i], x});
	}
	
	for (int i = 0; i < m; i++) {
		int x;
		cin >> x;
		s.push_back({x, -1});
	}
	
	sort(all(s));
	cout << (solve() ? "First" : "Second");
			
	return 0;
}
