#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<stack>
#include<queue>
#include<deque>
#include<bitset>
#include<iomanip>

using namespace std;
using ll = long long int;
using ld = long double;

const int INF = 1e9;

vector<int> l, b, o;
vector<int> ind;
set<pair<int, int>> S;

bool rec(bool F) {
    if (S.empty()) {
        if (F) return false;
        else return true;
    }
    pair<int, int> t = *S.begin();
    //cout << t.first << " " << t.second << " " << F << endl;
    S.erase(S.begin());
    bool ans = false;
    if (t.second == INF) {
        ans = rec(!F);
    } else {
        int I = ind[t.first];
        if (l[I] == t.first) {
            bool t1, t2;
            S.insert({t.second, t.first});
            t1 = rec(!F);
            S.erase({t.second, t.first});
            t2 = rec(!F);
            if (t1 && t2) {
                ans = true;
            } else if (!(t1) && !(t2)) {
                ans = false;
            } else {
                ans = F;
            }
        } else {
            ans = rec(!F);
        }
    }
    S.insert(t);
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    l.resize(n);
    b.resize(n);
    o.resize(m);
    ind.resize(2 * n + m + 1);
    vector<pair<int, int>> a;
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
        ind[l[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        ind[b[i]] = i;
        S.insert({l[i], b[i]});
    }
    for (int i = 0; i < m; ++i) {
        cin >> o[i];
        S.insert({o[i], INF});
    }
    if (rec(true)) {
        cout << "First";
    } else {
        cout << "Second";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    while (tt--) {
        solve();
    }
}