#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define ld long double
#define F first
#define S second
mt19937 rnd1(chrono::high_resolution_clock::now().time_since_epoch().count());
mt19937 rnd(100);


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, m;
    cin >> n >> m;
    if (!n) {
        if (m % 2)
            cout << "First";
        else
            cout << "Second";
        return 0;
    }

    vector<pair<ll, ll>> a(n);
    vector<ll> b(m);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first;

    for (int i = 0; i < n; ++i)
        cin >> a[i].second;

    for (int i = 0; i < m; ++i)
        cin >> b[i];

    sort(a.begin(), a.end());
    ll p1 = 0, p2 = 0;
    a.emplace_back(LLONG_MAX, LLONG_MAX);
    b.emplace_back(LLONG_MAX);
    while (p1 + p2 < n + m) {
        if (b[p2] < a[p1].first)
            p2++;
        else {
            cout << (p2 % 2 == 0 ? "First" : "Second");
            return 0;
        }
    }

    return 0;
}

/*

*/
/*
Каждая двусторонняя карта - возможность продлить игру на 1 ход.

*/
/*
Ребра делятся на два типа.
Внутри КСС и между КСС.

Они не влияют друг на друга.
Из каждой категории мы удалим максимум.

Вторая задача.
Дан орграф без циклов.
Сколько ребер можно зашифровать, чтобы по информации что в нем нет циклов, он расшифровывался однозначно?



*/
/*
5 3
1 2
4


2
3
4 1
*/
/*


*/
/*


*/