#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define int ll

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void solve() {
    int n, m0, k0, q; cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    for (int&u : a) cin >> u;
    sort(all(a));
    int rest = m0 * k0;
    vector<int> suff(n);
    suff[n - 1] = a[n - 1];
    for (int i = n - 2; i >= 0; i--) suff[i] = suff[i + 1] + a[i];
    // for (int u : a) cout << u << ' ';
    // cout << '\n';
    vector<int> vls;
    vector<int> pref(n + 1);
    for (int i = 0; i < n; i++) pref[i + 1] = pref[i] + a[i];
    for (int i = 0; i < n; i++) {
        // not more than m0
        if (i + 1 < n) {
            int L = -1, R = min(rest, m0);
            while (R - L > 1) {
                int M = (L + R) / 2;
                int l1 = i, r1 = n;
                while (r1 - l1 > 1) {
                    int m1 = (l1 + r1) / 2;
                    if (a[m1] - a[i] + M <= m0) l1 = m1;
                    else r1 = m1;
                }
                int S = M + pref[l1 + 1] - pref[i + 1] - (a[i] - M) * (l1 - i) + (n - l1 - 1) * m0;
                if (S >= rest) R = M;
                else L = M; 
            }
            rest -= R;
            vls.pb(a[i] - R);
        }
    }
    vls.pb(a[n - 1] - rest);
    assert(is_sorted(all(vls)));
    //sort(all(vls));
    for (int u : vls) cout << u << ' ';
    cout << '\n';
}

signed main() {
    int tt = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else
        cin.tie(0)->sync_with_stdio(false);
    #endif  

    while (tt--) {
        solve();
    }

    return 0;
}