#include <bits/stdc++.h>
#define int long long

using namespace std;

void solve() {
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    vector<long long> pr_sum(n + 1);
    for (int i = 0; i < n; ++i) {
        pr_sum[i + 1] = pr_sum[i] + a[i];
    }
    auto get_cnt_eq = [&](int m) -> int {
        int l = 1, r = n + 1;
        while (l < r - 1) {
            int md = (l + r) / 2;
            int pos = n - md;
            int val = a[pos];
            if (pr_sum[n] - pr_sum[pos] - m <= val * 1LL * md) {
                l = md;
            } else {
                r = md;
            }
        }
        return l;
    };
    for (int i = 0; i < n; ++i) {
        int cnt_eq = get_cnt_eq(m0);
        if (i < n - cnt_eq) {
            cout << a[i] << ' ';
        } else {
            int used = pr_sum[n] - pr_sum[n - cnt_eq] - a[n - cnt_eq] * cnt_eq;
            int vl = (m0 - used) / cnt_eq;
            if (i - (n - cnt_eq) < (m0 - used) % cnt_eq) {
                cout << a[n - cnt_eq] - vl - 1 << ' '; 
            } else {
                cout << a[n - cnt_eq] - vl << ' ';
            }
        }
    }
    cout << '\n';
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int m_nw, k_nw, i;
            cin >> m_nw >> k_nw >> i;
            i--;
            int cnt_eq = get_cnt_eq(m_nw);
            if (i < n - cnt_eq) {
                cout << a[i] << ' ';
            } else {
                int used = pr_sum[n] - pr_sum[n - cnt_eq] - a[n - cnt_eq] * cnt_eq;
                int vl = (m_nw - used) / cnt_eq;
                if (i - (n - cnt_eq) < (m_nw - used) % cnt_eq) {
                    cout << a[n - cnt_eq] - vl - 1 << '\n'; 
                } else {
                    cout << a[n - cnt_eq] - vl << '\n';
                }
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
