#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define int long long

const int MAX = 5e5 + 7;
const int mod = 1e9 + 7;

mt19937_64 rng(time(0));

void solve() {
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    sort(a.begin() + 1, a.end());
    int l = -1e10, r = 1e10;
    while (l < r) {
        int mid = l + (r - l) / 2;
        int cnt = 0;
        for (int i = 1; i <= n; i++) {
            cnt += max(0ll, a[i] - mid);
        }
        if (cnt > m0) {
            l = mid + 1;
        } else {
            r = mid;
        }
    }
    for (int i = 1; i <= n; i++) {
        m0 -= max(0ll, a[i] - l);
        a[i] = min(a[i], l);
    }
    sort(a.begin() + 1, a.end());
    for (int i = n; i >= 1; i--) {
        if (m0) {
            a[i]--;
            m0--;
        }
    }
    sort(a.begin() + 1, a.end());
    for (int i = 1; i <= n; i++) {
        cout << a[i] << ' ';
    }
}

int32_t main() {
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0); cin.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
}