#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rng(time(0));

int fl = 0;
void tgo(vector<int>& a, int n, int m) {
    a[0] = -2e9;
    fl = lower_bound(a.begin(), a.end(), a[n]) - a.begin() - 1;

    for (int it = 0; it < m; ++it) {
        int diff = a[n] - a[fl];
        int len = n - fl;

        if (len * diff > m) {
            int cdiff = m / len;
            for (int j = fl + 1; j <= n; ++j) {
               a[j] -= cdiff;
            }

            diff = m - cdiff * len;
            for (int j = fl + 1; j <= fl + diff; ++j) {
                a[j]--;
            }
            fl += diff;
            m = 0;
        } else {
            for (int j = fl + 1; j <= n; ++j) {
                a[j] -= diff;
            }
            m -= len * diff;
        }

        if (!m) break;

        while (fl > 0 && a[fl] >= a[n]) {
            --fl;
        }
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    int n, m, k, q;
    cin >> n >> m >> k >> q;

    vector<int> a(n + 1), c(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }

    sort(a.begin() + 1, a.end());
    
    c = a;
    tgo(a, n, m);
    for (int i = 1; i <= n; ++i) {
        cout << a[i] << " \n"[i == n];
    }

    if (!q) return 0;

    vector<array<int, 4>> query;
    query.push_back({0, 0, 0, 0});

    for (int tt = 0; tt < q; ++tt) {
        int t, mi, ki, xi;
        cin >> t >> mi >> ki >> xi;
        query.push_back({mi, ki, xi, tt});
    }

    vector<int> ans(q);
    sort(query.begin() + 1, query.end());

    fl = lower_bound(c.begin(), c.end(), c[n]) - c.begin() - 1;
    for (int i = 1; i <= q; ++i) {
        int diff = query[i][0] - query[i - 1][0];
        tgo(c, n, diff);
        ans[query[i][3]] = c[query[i][2]];
    }

    for (int i = 0; i < q; ++i) {
        cout << ans[i] << "\n";
    }

    return 0;
}
