#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll inf = 1e18;
const ll mod = 1e9 + 7;

void solve() {
    ll n, m0, k0, q; cin >> n >> m0 >> k0 >> q;
    vector<ll> a(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    multiset<ll> s;
    for(int i = 0; i < n; i++) s.insert(a[i]);
    multiset<ll> now = s;
    for(int j = 0; j < m0; j++) {
        multiset<ll> now1;
        for(int k1 = 0; k1 < k0; k1++) {
            now1.insert((*now.rbegin()) - 1);
            now.erase(now.find(*now.rbegin()));
        }
        for(ll el : now1) now.insert(el);
    }
    for(ll el : now) cout << el << " ";
    cout << "\n";
    vector<ll> now2;
    k0 = 1;
    now = s;
    vector<ll> ans1(q);
    vector<vector<pair<ll, ll>>> z(n + 1);
    for(int i = 0; i < q; i++) {
        ll t; cin >> t;
        if (t == 1) {
            ll m, k, x; cin >> m >> k >> x;
            if (k != 1) {
                multiset<ll> now = s;
                for (int j = 0; j < m; j++) {
                    multiset<ll> now1;
                    for (int k1 = 0; k1 < k; k1++) {
                        now1.insert((*now.rbegin()) - 1);
                        now.erase(now.find(*now.rbegin()));
                    }
                    for (ll el: now1) now.insert(el);
                }
                ll ind = 0, ans = 0;
                for (ll el: now) {
                    ind++;
                    if (x <= ind && ind <= x) {
                        ans += el;
                    }
                }
                ans1[i] = ans;
                z[m].push_back({x, i});
            }
        } else if (t == 2) {
            ll p, v; cin >> p >> v;
            p--;
            a[p] = v;
            s.clear();
            for(int i1 = 0; i1 < n; i1++) s.insert(a[i1]);
        } else {
            ll m, k, l, r; cin >> m >> k >> l >> r;
            multiset<ll> now = s;
            for(int j = 0; j < m; j++) {
                multiset<ll> now1;
                for(int k1 = 0; k1 < k; k1++) {
                    now1.insert((*now.rbegin()) - 1);
                    now.erase(now.find(*now.rbegin()));
                }
                for(ll el : now1) now.insert(el);
            }
            ll ind = 0, ans = 0;
            for(ll el : now) {
                ind++;
                if (l <= ind && ind <= r) {
                    ans += el;
                }
            }
            ans1[i] = ans;
        }
    }
    for(int j = 0; j <= n; j++) {
        if (j != 0) {
            multiset<ll> now1;
            for (int k1 = 0; k1 < k0; k1++) {
                now1.insert((*now.rbegin()) - 1);
                now.erase(now.find(*now.rbegin()));
            }
            for (ll el: now1) now.insert(el);
        }
        vector<ll> now2;
        for(ll el : now) now2.push_back(el);
        for(int i = 0; i < z[j].size(); i++) {
            ans1[z[j][i].second] = now2[z[j][i].first];
        }
    }
    for(ll el : ans1) cout << el << "\n";
    cout << "\n";
}

int main() {
#ifdef KABANDJAN
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll ttt = 1;
//    cin >> ttt;
    while(ttt--) {
        solve();
    }
    return 0;
}
