// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

// #pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#ifdef LOCAL
    #define debug(x) cout << #x << ": " << x << endl;
#else
    #define debug(x)
#endif
#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define time_now chrono::high_resolution_clock::now()
#define time_res(s, f) chrono::duration_cast<chrono::nanoseconds>(f - s).count()
#define time_out(s) cout << fixed << setprecision(10) << endl << "Used: " << (ld)time_res(s, time_now) / 1e6 << " ms" << endl;
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define file_in freopen("input.txt", "r", stdin);
#define file_out freopen("output.txt", "w", stdout);
#define all(a) a.begin(), a.end()
#define sz(a) (int)(a.size())
#define pb push_back
#define ff first
#define sc second
#define int ll

using namespace std;
using namespace __gnu_pbds;

using ld = long double;
using ll = long long;
using ull = unsigned long long;
using str = string;
using pii = pair<int, int>;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T1, typename T2> istream& operator>>(istream &in, pair<T1, T2> &a) { in >> a.ff >> a.sc; return in; }
#ifdef LOCAL
    template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << "{" << a.ff << ' ' << a.sc << "}"; return out; }
#else
    template<typename T1, typename T2> ostream& operator<<(ostream &out, const pair<T1, T2> &a) { out << a.ff << ' ' << a.sc; return out; }
#endif
template<typename T> istream& operator>>(istream &in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream &out, const vector<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const set<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> ostream& operator<<(ostream &out, const multiset<T> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T, typename comp> ostream& operator<<(ostream &out, const unordered_set<T, comp> &a) { for (auto &el : a) out << el << " "; return out; }
template<typename T> T max(T a, T b, T c) { return max(a, max(b, c)); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
template<typename T> T min(T a, T b, T c) { return min(a, min(b, c)); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
const ll LOL = mt_seed;
mt19937_64 genom(LOL); ll randint(ll l, ll r) { uniform_int_distribution<ll> random_distrib_2_0(l, r); return random_distrib_2_0(genom); }
const ll RANDOM = genom(); struct chash { ll operator()(ll x) { return x ^ RANDOM; } };

const int logn = 19;

struct fen_tree {
    int n;
    vector<int> t;
    fen_tree(int _n) {
        n = _n;
        t.resize(n + 1);
    }

    void upd(int k, int x) {
        for (; k <= n; k += k & -k)
            t[k] += x;
    }

    int get(int x) {
        int res = 0;
        for (; x > 0; x -= x & -x)
            res += t[x];
        return res;
    }

    int getK(int sum) {
        ++sum;
        int cur_sum = 0, cur = 0;
        for (int k = logn; k >= 0; --k) {
            if ((cur | (1 << k)) > n) continue;
            if (cur_sum + t[cur | (1 << k)] < sum) {
                cur |= 1 << k;
                cur_sum += t[cur];
            }
        }
        return n - (cur + 1);
    }
};

struct event {
    int t, x, y, z, w;
};

signed main() {
    fast
#ifdef LOCAL
    file_in
#endif

    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int> a(n);
    cin >> a;
    sort(all(a), greater<>());
    vector<int> X = a;

    vector<event> events;

    for (int _i = 0; _i < q; ++_i) {
        int t;
        cin >> t;
        if (t == 1) {
            int m, k, x;
            cin >> m >> k >> x;
            --x;
            events.pb({t, m, k, x, 0});
        } else if (t == 2) {
            int p, v;
            cin >> p >> v;
            --p;
            X.pb(v);
            events.pb({t, p, v, 0, 0});
        } else {
            
        }
    }

    sort(all(X));
    for (auto &el : a) el = lower_bound(all(X), el) - X.begin();    

    debug(a)

    fen_tree ft(sz(X));
    for (auto el : a) ft.upd(sz(X) - el, X[el]);

    fen_tree kth(sz(X));
    for (auto el : a) kth.upd(sz(X) - el, 1);

    // for (int i = 0; i < sz(X) + 1; ++i) {
    //     // if (i < n)
    //     //     cout << i << ": " << kth.getK(i) << " | " << X[kth.getK(i)] << endl;
    //     // cout << i << ": " << ft.get(i) << endl;
    //     // cout << i << ": " << kth.get(i) << endl;
    // }

    for (int x = 0; x < n; ++x) {
        int m = m0, k = k0;
        if (ft.get(sz(X)) - n * X[kth.getK(n - 1)] <= m) {
            int last = X[kth.getK(n - 1)];
            m -= ft.get(sz(X)) - n * last;
            last -= m / n;
            m %= n;
            if (x < m) {
                cout << last - 1 << ' ';
            } else {
                cout << last << ' ';
            }
        } else {
            int l = 0, r = n;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                int last = kth.getK(mid);
                if (ft.get(sz(X) - last) - kth.get(sz(X) - last) * X[last] <= m) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            // debug(l)
            int last = kth.getK(l);
            // debug(last)
            // debug(X[last])

            // debug(m)

            // debug(ft.get(sz(X) - last))
            // debug(kth.get(sz(X) - last) * X[last])

            m -= ft.get(sz(X) - last) - kth.get(sz(X) - last) * X[last];

            // debug(m)
            last = X[last];
            last -= m / (l + 1);
            m %= l + 1;
            // debug(last)
            // debug(m)
            if (x < n - l - 1) {
                cout << X[kth.getK(n - x - 1)] << ' ';
            } else if (x < n - l + m - 1) {
                cout << last - 1 << ' ';
            } else {
                cout << last << ' ';
            }
        }
    }

    for (auto el : events) {
        if (el.t == 1) {
            auto [t, m, k, x, _lol] = el;


            if (ft.get(sz(X)) - n * X[kth.getK(n - 1)] <= m) {
            int last = X[kth.getK(n - 1)];
            m -= ft.get(sz(X)) - n * last;
            last -= m / n;
            m %= n;
            if (x < m) {
                cout << last - 1 << '\n';
            } else {
                cout << last << '\n';
            }
        } else {
            int l = 0, r = n;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                int last = kth.getK(mid);
                if (ft.get(sz(X) - last) - kth.get(sz(X) - last) * X[last] <= m) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            // debug(l)
            int last = kth.getK(l);
            // debug(last)
            // debug(X[last])

            // debug(m)

            // debug(ft.get(sz(X) - last))
            // debug(kth.get(sz(X) - last) * X[last])

            m -= ft.get(sz(X) - last) - kth.get(sz(X) - last) * X[last];

            // debug(m)
            last = X[last];
            last -= m / (l + 1);
            m %= l + 1;
            // debug(last)
            // debug(m)
            if (x < n - l - 1) {
                cout << X[kth.getK(n - x - 1)] << '\n';
            } else if (x < n - l + m - 1) {
                cout << last - 1 << '\n';
            } else {
                cout << last << '\n';
            }
        }

            
        } else if (el.t == 2) {
            auto [t, p, v, _kek, _lol] = el;
            ft.upd(n - a[p], -a[p]);
            kth.upd(n - a[p], -1);
            a[p] = v;
            ft.upd(n - a[p], a[p]);
            kth.upd(n - a[p], 1);
        } else {

        }
    }

    // cout << "GOOD\n";

    return 0;
}
