#include <iostream>
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T> using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

ll rand1(ll a, ll b) {
    return uniform_int_distribution<ll> (a, b) (gen);
}

void solve() {
    ll n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<ll> a(n);
    for (auto &i : a) cin >> i;
    set<ll> b;
    map<ll, ll> c;
    for (ll i = 0; i < n; i++) b.insert(a[i]);
    ll cnt = 0;
    for (auto &e : a) {
        if (e == *b.rbegin()) cnt++;
        c[e]++;
    }
    ll cmax = *b.rbegin();
    b.erase(--b.end());
    while (!b.empty() && m > 0) {
        ll last = *b.rbegin();
        if ((cmax - last) * cnt > m) {
            break;
        } else {
            m -= (cmax - last) * cnt;
            cmax = last;
            cnt += c[last];
            b.erase(--b.end());
        }
    }
    vector<ll> res;
    for (ll i = 0; i < n; i++) {
        res.push_back(min(a[i], cmax));
    }
    sort(res.begin(), res.end());
    if (res[0] == res[n - 1]) {
        ll del = (m - (m % n)) / n;
        m -= del * n;
        for (auto &e : res) e -= del;
    }
    ll pos = n - 1;
    while (m > 0) {
        res[pos]--;
        m--;
        pos--;
        if (pos == -1 || res[pos] != res[n - 1] + 1) pos = n - 1;
    }
    sort(res.begin(), res.end());
    for (auto &e : res) cout << e << " ";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t12 = 1;
//    cin >> t12;
    while (t12--) {
        solve();
        cout << '\n';
    }
    return 0;
}