#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;
using ld = long double;

#define int long long

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

	int n, m, k, q;
	cin >> n >> m >> k >> q;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	sort(a.rbegin(), a.rend());
	vector<ll> pref(n);
	for (int i = 0; i < n; ++i) {
		pref[i] = a[i];
		if (i > 0) {
			pref[i] += pref[i - 1];
		}
	}
	auto get = [&](int m, int k, int x) -> int {
		x = n - 1 - x;
		assert(k == 1);
		int l = 0, r = n;
		while (l + 1 < r) {
			int mid = (l + r) >> 1;
			ll sum1 = (mid + 1) * 1ll * a[mid];
			ll sum2 = pref[mid];
			if (sum2 - sum1 <= m) {
				l = mid;
			} else {
				r = mid;
			}
		}
		if (l < x) {
			return a[x];
		} else {
			ll temp_sum1 = (l + 1) * 1ll * a[l];
			ll temp_sum2 = pref[l];
			ll ord = m - (temp_sum2 - temp_sum1);
			int take = ord / (l + 1);
			ord %= l + 1;
			if (l - x + 1 <= ord) {
				return a[l] - take - 1;
			} else {
				return a[l] - take;
			}
		}
	};
	for (int i = 0; i < n; ++i) {
		cout << get(m, k, i) << ' ';
	}
	cout << '\n';
	while (q--) {
		int type;
		cin >> type;
		assert(type == 1);
		int m, k, x;
		cin >> m >> k >> x;
		x--;
		cout << get(m, k, x) << '\n';
	}
}
