#include <bits/stdc++.h>
using namespace std;
using ll = long long;
//using ll = int;
using ld = long double;
using ull = unsigned long long;
#define pb push_back
#define all(vec) vec.begin(), vec.end()
#define eb emplace_back
#ifdef LOCAL
#define deb(x) cout << #x << " = " << x << '\n'
#else
#define deb(x) 52
#endif
const ll inf = 1e9 + 11;
const long long INF = (long long)2e18 + 11;
const ll P = 73;
const ll MOD = 1e9 + 7;


void solve() {
    auto get_ans = [&](vector<ll> a, ll m) -> vector<ll> {
        ll n = (ll)a.size();
        sort(all(a));
        vector<ll> suf(n + 1);
        for (ll i = n - 1; i >= 0; --i) {
            suf[i] = suf[i + 1] + a[i];
        }
        ll l = (ll)-1e10, r = (ll)1e10;
        auto f = [&](ll x) -> ll {
            ll ind = lower_bound(all(a), x) - a.begin();
            return suf[ind];
        };
        while (r - l > 1) {
            ll mid = (r + l) >> 1;
            if (f(mid) <= m) {
                r = mid;
            } else {
                l = mid;
            }
        }
        for (ll &i : a) {
            if (i > r) {
                i = r;
            }
        }
        ll need = m - f(r);
        sort(all(a));
        for (ll i = n - 1; i >= n - need && i >= 0; --i) {
            --a[i];
        }
        return a;
    };
    ll n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(all(a));
    vector<ll> suf(n + 1);
    for (ll i = n - 1; i >= 0; --i) {
        suf[i] = suf[i + 1] + a[i];
    }
    auto f = [&](ll x) -> ll {
        ll ind = upper_bound(all(a), x) - a.begin();
        ll cnt = n - ind;
        ll sum = suf[ind] - cnt * x;
        if (a.back() - x <= (sum + 1) / 2) {
            return (sum + 1) / 2;
        } else {
            return a.back() - x;
        }
    };
    ll l = (ll)-1e12, r = (ll)1e12;
    while (r - l > 1) {
        ll mid = (r + l) >> 1;
        if (f(mid) <= m) {
            r = mid;
        } else {
            l = mid;
        }
    }
    ll need = m - f(r);
    ll ind = upper_bound(all(a), r) - a.begin();
    ll cnt = n - ind;
    ll sum = suf[ind] - cnt * r;
    if (a.back() - r <= (sum + 1) / 2) {
        for (ll &i : a) {
            if (i > r) {
                i = r;
            }
        }
        if (sum % 2 == 1) {
            for (ll &i : a) {
                if (i == r) {
                    i = r - 1;
                    break;
                }
            }
        }
    } else {
        ll cnt_op = a.back() - r;
        vector<ll> b(a.begin(), a.begin() + n - 1);
        b = get_ans(b, cnt_op);
        b.pb(r);
        a = b;
    }
    priority_queue<ll> pq(all(a));
    while (need--) {
        ll x = pq.top();
        pq.pop();
        ll y = pq.top();
        pq.pop();
        --x, --y;
        pq.push(x);
        pq.push(y);
    }
    a.clear();
    while (!pq.empty()) {
        a.pb(pq.top());
        pq.pop();
    }
    sort(all(a));
    for (ll i : a) {
        cout << i << ' ';
    }
}


int main() {
#ifdef LOCAL
    freopen("C:/work/untitled/input.txt", "r", stdin);
    freopen("C:/work/untitled/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll cfmode = 0;
    ll tc = 1;
    if (cfmode) {
        cin >> tc;
    }
    while (tc--) {
        solve();
        if (tc) {
            cout << '\n';
        }
    }
}