#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

template<typename T>
istream &operator>>(istream &is, vector<T> &a);

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a);


using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;

    vector<int> a(n);
    cin >> a;
    for (int i = 0; i < m0; ++i) {
        vector<int> pos(n);
        std::iota(pos.begin(), pos.end(), 0);

        std::sort(pos.begin(), pos.end(), [&](int l, int r) {
            if (a[l] == a[r])return l < r;
            return a[l] > a[r];
        });
        for (int j = 0; j < k0; ++j) {
            a[pos[j]]--;
        }
    }
    std::sort(a.begin(), a.end());
    cout << a;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &v: a) is >> v;
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (auto v: a) os << v << " ";
    return (os << "\n");
}
