#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <math.h>
#include <string>
#include <vector>
#include <chrono>
#include <random>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <assert.h>
#include <set>
#define endl '\n'
#define mp make_pair

using namespace std;
using i64 = long long;
using ld = long double;

const i64 INF = 1e18 + 5;

mt19937 rnd(29);

i64 gcd_ext(i64 a, i64 b, i64& x, i64& y) {
	if (b == 0) {
		x = 1; y = 0;
		return a;
	}
	i64 x1 = 0, y1 = 0;
	i64 c = gcd_ext(b, a % b, x1, y1);
	x = y1, y = (-y1 * (a / b) + x1);
	return c;
}

i64 gcd(i64 a, i64 b) {
	while (b) swap(b, a %= b);
	return a;
}

const i64 S = 2e5 + 10;
i64 a[S];
vector <pair<i64, i64>> d;

bool cmp(pair<i64, i64> a, pair<i64, i64> b) {
	return mp(a.first, b.second) < mp(b.first, a.second);
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	i64 n, m0, k0, q; cin >> n >> m0 >> k0 >> q;
	d.resize(n);

	for (i64 x = 1; x <= n; ++x) {
		cin >> a[x];
		d[x - 1] = { a[x], x };
	}

	while (q--) {
		i64 t; cin >> t;
		if (t == 1) {
			i64 m, k, x; cin >> m >> k >> x;
		}
		else if (t == 2) {
			i64 p, u; cin >> p >> u;
		}
		else {
			i64 m, k, l, r; cin >> m >> k >> l >> r;
		}
	}

	for (i64 x = 1; x <= m0; ++x) {
		sort(d.begin(), d.end(), cmp);
		for (i64 y = d.size() - 1; y >= d.size() - k0; --y) {
			d[y].first -= 1;
		}
	}

	sort(d.begin(), d.end(), cmp);

	for (i64 x = 0; x < d.size(); ++x) {
		cout << d[x].first << " ";
	}

}