#include <iostream>
#include <vector>
#include <math.h>
#include <cmath>
#include <algorithm>
#include <set>

using ll = long long;
using ld = long double;

#define int ll
#define pii pair<int, int>
#define all(obj) obj.begin(), obj.end()
#define rall(obj) obj.rbegin(), obj.rend()
#define pb push_back

const int inf = 1e9;
const int INF = 1e18;

using namespace std;

signed main() {
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<int>a(n);
    for (int i=0; i<n; i++) {
        cin >> a[i];
    }
    
    sort(rall(a));
    vector<int>pref(n+1);
    pref[0] = 0;
    for (int i=1; i<=n; i++) {
        pref[i] = pref[i-1] + a[i-1];
    }
    
    int cur = 1, d = 0;
    while (cur < n && d < m0) {
        cur++;
        d = pref[cur] - cur*a[cur-1];
    }

    if (d == m0) {
        for (int i = n-1; i >= 0; i--) {
            if (i >= cur) {
                cout << a[i] << " ";
            }
            else {
                cout << a[cur-1] << " ";
            }
        }
        return 0;
    }
    
    if (m0 < d) cur--;
    d = pref[cur] - cur*a[cur-1];
    for (int i=0; i<cur; i++) {
        a[i] = a[cur-1];
    }

    int ost = m0-d;
    int k = ost/cur;
    for (int i=0; i < cur; i++) {
        a[i] -= k;
    }
    ost %= cur;
    for (int i=0; i<ost; i++) {
        a[i]--;
    }
    sort(all(a));
    for (int i=0; i<n; i++) {
        cout << a[i] << " ";
    }
}