#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;


using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;


using ll = long long;


const ll inf = 1e18 + 7;


template<typename T>
ostream & operator <<(ostream &os, const vector<T> &a) {
    for (T el : a) {
        os << el << " ";
    }
    os << '\n';
    return os;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a.at(i);
    }
    sort(a.begin(), a.end());
    vector<ll> suf(n + 1, 0);
    for (int i = n - 1; i >= 0; i--) {
        suf.at(i) = suf.at(i + 1) + a.at(i);
    }
    int pos = 0;
    for (int i = 0; i < n; i++) {
        ll dist = n - i;
        ll sum = suf.at(i) - dist * a.at(i);
        if (sum <= m0) {
            pos = i;
            break;
        }
    }
    ll len = (n - pos);
    m0 = m0 - (suf.at(pos) - len * a.at(pos));
    ll full = m0 / len;
    for (int i = pos + 1; i < n; i++) {
        a.at(i) = a.at(pos);
    }
    for (int i = pos; i < pos + m0 % len; i++) {
        a.at(i) -= 1;
    }
    for (int i = pos; i < n; i++) {
        a.at(i) -= full;
    }
    cout << a;
    return 0;
}
