#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>

#include <ext/pb_ds/assoc_container.hpp>

#define all(a) a.begin(), a.end()
#define int long long

// #pragma GCC optimize("O3")

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

using oset = tree<pll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>; 

constexpr ll inf = 1e18;

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;

    multiset<ll> a;
    ll t;
    for (int i = 0; i < n; ++i) {
        cin >> t;
        a.insert(t);
    }
    while (*a.begin() != *prev(a.end())) {
        t = *prev(a.end());
        a.erase(prev(a.end()));
        if (m <= t - *prev(a.end())) {
            t -= m;
            a.insert(t);
            break;
        } else {
            m -= t - *prev(a.end()) + 1;
            a.insert(*prev(a.end()) - 1);
        }
    }
    if (m == 0) {
        for (auto const &e : a) {
            cout << e << ' ';
        }
    } else {
        vector<ll> z;
        for (auto const &e : a) z.push_back(e);
        for (int i = 0; i < n - m % n; ++i) {
            cout << z[i] + m / n << ' ';
        }
        for (int i = n - m % n; i < n; ++i) {
            cout << z[i] + (m + n - 1) / n << ' ';
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}