#include <bits/stdc++.h>
#define pb push_back
#define int long long

using namespace std;
using ll = long long;
using vi = vector<int>;
using ld = long double;
using pi = pair<int, int>;

const int INF = 1e18;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, k, q;
    cin >> n >> m >> k >> q;

    vi a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];

    sort(a.begin(), a.end());

    int l = -INF;
    int r = INF;

    while (r - l > 1) {
        int mid = (l + r) / 2;

        int opers = 0;

        for (int i = 0; i < n; ++i) {
            opers += max((int)0, a[i] - mid);
        }

        if (opers <= m) r = mid;
        else l = mid;
    }

    int total = 0;

    for (int i = 0; i < n; ++i) {
        total += max((int)0, a[i] - r);
        a[i] = min(a[i], r);
    }

    int rest = m - total;

    sort(a.rbegin(), a.rend());

    for (int i = 0; i < rest; ++i) --a[i];

    sort(a.begin(), a.end());

    for (int x : a) cout << x << ' ';
}