#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll infLL = 3e15;

ll div(ll a, ll b) {
    ll x = a / b;
    if (x * b > a) {
        x -= 1;
    }
    return x;
}

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<ll> a(n + 2);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    a[0] = infLL;
    a[n + 1] = -infLL;
    sort(a.begin(), a.end(), greater<>());
    n += 2;
    k += 1;
    vector<pair<ll, ll>> s; // {len, sum}
    for (int i = 0, j = 0; i < n; i = j) {
        while (j < n && a[j] == a[i]) {
            j += 1;
        }
        s.push_back({j - i, 1LL * (j - i) * a[i]});
    }
    auto qry = [&](pair<ll, ll> f) -> pair<ll, ll> {
        ll lo = div(f.second, f.first);
        return {lo + (f.second != f.first * lo), lo};
    };
    while (a.size() > 3 && m > 0) {
        int pref = 0, i = 0;
        while (pref + s[i].first < k) {
            pref += s[i].first;
            i += 1;
        }
        int h = k - pref;
        if (qry(s[i]).first <= qry(s[i + 1]).second + 1) {
            s[i].first += s[i + 1].first;
            s[i].second += s[i + 1].second;
            s.erase(s.begin() + i + 1);
            continue;
        }
        if (qry(s[i - 1]).first <= qry(s[i]).second + 1) {
            s[i - 1].first += s[i].first;
            s[i - 1].second += s[i].second;
            s.erase(s.begin() + i);
            continue;
        }
        auto check = [&](ll mid) {
            auto L = s[i - 1];
            auto M = s[i];
            auto R = s[i + 1];
            L.second -= L.first * mid;
            M.second -= mid * h;
            if (qry(L).first <= qry(M).second + 1) {
                return false;
            }
            if (qry(M).first <= qry(R).second + 1) {
                return false;
            }
            return true;
        };
        ll lo = 0, hi = m;
        while (lo + 1 < hi) {
            ll mid = lo + hi >> 1;
            if (check(mid)) {
                lo = mid;
            } else {
                hi = mid;
            }
        }
        s[i].second -= h * hi;
        for (int j = 0; j < i; ++j ){
            s[j].second -= s[j].first * hi;
        }
        m -= hi;
        if (0) {
            vector<ll> res(n);
            for (int i = 0, ptr = 0; i < s.size(); ++i) {
                ll mn = s[i].second / s[i].first;
                ll cntmx = s[i].second % s[i].first;
                for (int _ = 0; _ < s[i].first; ++_) {
                    res[ptr++] = mn + (_ < cntmx);
                }
            }
            cout << m << ": ";
            for (auto x: res) {
                cout << x << " ";
            }
            cout << endl;
        }
    }
    vector<ll> res(n);
    for (int i = 0, ptr = 0; i < s.size(); ++i) {
        ll mn = div(s[i].second, s[i].first);
        ll cntmx = s[i].second - mn * s[i].first;
        for (int _ = 0; _ < s[i].first; ++_) {
            res[ptr++] = mn + (_ < cntmx);
        }
    }
    for (int i = n - 2; i >= 1; --i) {
        cout << res[i] << " ";
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}