#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define int ll

constexpr ll infLL = 3e15;

ll divi(ll a, ll b) {
    ll x = a / b;
    if (x * b > a) {
        x -= 1;
    }
    return x;
}

void massert(int f) {
    if (!f) {
        exit(1);
    }
}

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<ll> a(n + 2);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    a[0] = infLL;
    a[n + 1] = -infLL;
    sort(a.begin(), a.end(), greater<>());
    n += 2;
    k += 1;
    vector<pair<ll, ll>> s; // {len, sum}
    for (int i = 0, j = 0; i < n; i = j) {
        while (j < n && a[j] == a[i]) {
            j += 1;
        }
        s.push_back({j - i, 1LL * (j - i) * a[i]});
    }
    auto qry = [&](pair<ll, ll> f) -> pair<ll, ll> {
        ll lo = divi(f.second, f.first);
        return {lo + (f.second != f.first * lo), lo};
    };
    vector<int> nxt(n, -1), prv(n, -1);
    for (int i = 0; i < n; ++i) {
        nxt[i] = i + 1;
        prv[i] = i - 1;
    }
    int pref = 0, i = 0;
    while (pref + s[i].first < k) {
        pref += s[i].first;
        i += 1;
    }
    vector<int> prefs(s.size() + 1);
    for (int i = 0; i < s.size(); ++i) {
        prefs[i + 1] = prefs[i] + s[i].first;
    }
    ll did = 0;
    auto query = [&](int id) {
        if (id < i) {
            s[id].second -= s[id].first * did;
        }
        auto res = qry(s[id]);
        if (id < i) {
            s[id].second += s[id].first * did;
        }
        return res;
    };
    vector<array<ll, 3>> queries;
    vector<ll> answers(q);
    for (int i = 0; i < q; ++i) {
        int tp;
        cin >> tp;
        ll M, K, X;
        cin >> M >> K >> X;
        queries.push_back({M, i, X});
    }
    queries.push_back({m, -1, -1});
    sort(queries.begin(), queries.end());
    int ptr = 0;

    vector<ll> res(n);
    while (ptr < queries.size()) {
        int h = k - prefs[i];
        int l = prv[i];
        int r = nxt[i];
        if (query(i).first <= qry(s[r]).second + 1) {
            s[i].first += s[r].first;
            s[i].second += s[r].second;
            nxt[i] = nxt[r];
            prv[nxt[r]] = i;
//            s.erase(s.begin() + i + 1);
            continue;
        }
        if (query(l).first <= qry(s[i]).second + 1) {
            s[l].second -= s[l].first * did;
            s[l].first += s[i].first;
            s[l].second += s[i].second;
            nxt[l] = nxt[i];
            prv[nxt[i]] = l;
            i = l;
//            s.erase(s.begin() + i);
            continue;
        }
        auto check = [&](ll mid) {
            auto L = s[l];
            L.second -= L.first * did;
            auto M = s[i];
            auto R = s[r];
            L.second -= L.first * mid;
            M.second -= mid * h;
            if (qry(L).first <= qry(M).second + 1) {
                return false;
            }
            if (qry(M).first <= qry(R).second + 1) {
                return false;
            }
            return true;
        };
        ll lo = 0, hi = queries[ptr][0] - did;
        while (lo + 1 < hi) {
            ll mid = lo + hi >> 1;
            if (check(mid)) {
                lo = mid;
            } else {
                hi = mid;
            }
        }
        s[i].second -= h * hi;
        did += hi;
        if (queries[ptr][0] == m && queries[ptr][1] == -1) {
            int ii = i;
            for (int ijj = 0, ptr = 0; ijj < s.size(); ijj = nxt[ijj]) {
                if (ii > ijj) {
                    s[ijj].second -= s[ijj].first * did;
                }
                ll mn = divi(s[ijj].second, s[ijj].first);
                ll cntmx = s[ijj].second - mn * s[ijj].first;
                for (int _ = 0; _ < s[ijj].first; ++_) {
                    res[ptr++] = mn + (_ < cntmx);
                }
            }
        } else {
            auto [M, ID, X] = queries[ptr];
            assert(M == did);
            X = (n - 2) - X + 2 - 1;
            if (X < i) {
                answers[ID] = a[X] - did;
            } else if (X < nxt[i]) {
                auto [mx, mn] = query(i);
                ll cntmx = s[i].second - s[i].first * mn;
                if (i + cntmx - 1 < X) {
                    answers[ID] = mn;
                } else {
                    answers[ID] = mx;
                }
            } else {
                answers[ID] = a[X];
            }
        }
        if (did == queries[ptr][0]) {
            ptr += 1;
        }
//        m -= hi;
        if (0) {
            vector<ll> res(n);
            for (int i = 0, ptr = 0; i < s.size(); ++i) {
                ll mn = s[i].second / s[i].first;
                ll cntmx = s[i].second % s[i].first;
                for (int _ = 0; _ < s[i].first; ++_) {
                    res[ptr++] = mn + (_ < cntmx);
                }
            }
            cout << m << ": ";
            for (auto x: res) {
                cout << x << " ";
            }
            cout << endl;
        }
    }

    for (int i = n - 2; i >= 1; --i) {
        cout << res[i] << " ";
    }
    cout << '\n';
    vector<ll> prefa(n + 1);
    for (int i = 0; i < n; ++i) {
        prefa[i + 1] = prefa[i] + a[i];
    }
    for (int i = 0; i< q; ++i) {
        cout << answers[i] << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}