#include <bits/stdc++.h>
#include <bits/extc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3")
#pragma GCC target("avx2")
#pragma GCC optimize("unrool-loops")
#endif

std::random_device rd;
std::mt19937_64 gen(rd());

using namespace __gnu_pbds;
using ll = long long;
using ld = long double;

template<class T>
using ordered_set = tree<T, null_type, std::less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void get_first(int n, int m, std::vector<ll> a) {
    std::ranges::sort(a);
    while (m > 0) {
        int i = n - 1;
        while (i >= 0 && a[i] == a[n - 1]) {
            --i;
        }
        ll d;
        if (i != -1) {
            d = a[n - 1] - a[i];
        } else {
            d = 1e9;
        }
        if (n - 1 - i > m) {
            for (int it = 0; it < m; ++it) {
                int j = (int) (std::ranges::lower_bound(a, a.back()) - a.begin());
                --a[j];
            }
            break;
        }
        if ((n - 1 - i) * d > m) {
            d = m / (n - 1 - i);
            for (int j = i + 1; j < n; ++j) {
                a[j] -= d;
                m -= d;
            }
            continue;
        }
        for (int j = i + 1; j < n; ++j) {
            a[j] -= d;
            m -= d;
        }
    }
    for (int i = 0; i < n; ++i) {
        std::cout << a[i] << ' ';
    }
    std::cout << '\n';
}

void update(int n, int dm, std::vector<ll> &a) {
    std::ranges::sort(a);
    while (dm > 0) {
        int i = n - 1;
        while (i >= 0 && a[i] == a[n - 1]) {
            --i;
        }
        ll d;
        if (i != -1) {
            d = a[n - 1] - a[i];
        } else {
            d = 1e9;
        }
        if (n - 1 - i > dm) {
            for (int it = 0; it < dm; ++it) {
                int j = (int) (std::ranges::lower_bound(a, a.back()) - a.begin());
                --a[j];
            }
            break;
        }
        if ((n - 1 - i) * d > dm) {
            d = dm / (n - 1 - i);
            for (int j = i + 1; j < n; ++j) {
                a[j] -= d;
                dm -= d;
            }
            continue;
        }
        for (int j = i + 1; j < n; ++j) {
            a[j] -= d;
            dm -= d;
        }
    }
}

void not_main() {
    int n, m, k, q;
    std::cin >> n >> m >> k >> q;
    std::vector<ll> a(n);
    for (auto &i: a) {
        std::cin >> i;
    }
    get_first(n, m, a);
    std::vector<std::vector<int>> query(q, std::vector<int>(3));
    std::vector<ll> ans(q);
    for (int i = 0; i < q; ++i) {
        query[i][2] = i;
        int type;
        std::cin >> type >> query[i][0] >> query[i][1];
        --query[i][1];
    }
    std::ranges::sort(query);
    int lm = 0;
    for (int i = 0; i < q; ++i) {
        update(n, query[i][0] - lm, a);
        ans[query[i][2]] = a[query[i][1]];
    }
    for (int i = 0; i < q; ++i) {
        std::cout << ans[i] << ' ';
    }
    std::cout << '\n';
}

signed main() {
    std::ios_base::sync_with_stdio(false);
#ifndef LOCAL
    std::cin.tie(nullptr);
#endif
    int tests = 1;
    // std::cin >> tests;
    while (tests--) {
        not_main();
    }
    return 0;
}