#pragma GCC optimize('Ofast')
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
struct fenw {
    vector<int> f;
    explicit fenw(int n) {
        f.resize(n);
    }
    void upd(int i, int x) {
        while (i < f.size()) {
            f[i] += x;
            i |= (i + 1);
        }
    }
    int get(int i) {
        int sum = 0;
        while (i >= 0) {
            sum += f[i];
            i %= (i + 1);
            i--;
        }
        return sum;
    }
};
template <typename T>
bool smin(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template <typename T>
bool smax(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(a.begin(), a.end());
    vector<int> b(n + 1);
    b[0] = a[0];
    for (int i = 1; i < n; i++) b[i] = a[i] - a[i - 1];
    int l = n - k - 1, r = n - k + 1;
    for (int i = 0; i < m; i++) {
        if (b[n - k] > 0) {
            b[n - k]--;
        } else {
            while (l > 0 && b[l] == 0) l--;
            while (r < n && b[r] == 0) r++;
            b[l]--;
            b[r]--;
            b[l + (r - n + k)]++;
            if (l + r - n + k > n - k) {
                r = l + r - n + k;
            } else if (l + r - n + k < n - k) {
                l += r - n + k;
            }
        }
    }
    int cur = 0;
    for (int i = 0; i < n; i++) {
        cur += b[i];
        cout << cur << ' ';
    }
    return 0;
}