#pragma GCC optimize('Ofast')
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
struct fenw {
    vector<int> f;
    explicit fenw(int n) {
        f.resize(n);
    }
    void upd(int i, int x) {
        while (i < f.size()) {
            f[i] += x;
            i |= (i + 1);
        }
    }
    int get(int i) {
        int sum = 0;
        while (i >= 0) {
            sum += f[i];
            i %= (i + 1);
            i--;
        }
        return sum;
    }
};
template <typename T>
bool smin(T& a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template <typename T>
bool smax(T& a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}
struct DSU {
    vector<int> p, sz;
};
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(a.begin(), a.end());
    if (k == n) {
        for (int i = 0; i < n; i++) a[i] -= m;
        for (auto e : a) cout << e << ' ';
        cout << '\n';
        return 0;
    }
    vector<int> b(n + 1);
    b[0] = a[0];
    for (int i = 1; i < n; i++) b[i] = a[i] - a[i - 1];
    vector<int> nznl(n + 1), nznr(n + 1);
    for (int i = 1; i < n; i++) {
        if (b[i] != 0) {
            nznl[i] = i;
        } else {
            nznl[i] = nznl[i - 1];
        }
    }
    nznr[n] = n;
    for (int i = n - 1; i >= 0; i--) {
        if (b[i] != 0) {
            nznr[i] = i;
        } else {
            nznr[i] = nznr[i + 1];
        }
    }
    for (int i = 0; i < m; i++) {
        if (b[n - k] > 0) {
            b[n - k]--;
            if (b[n - k] == 0) {
                nznl[n - k] = nznl[n - k - 1];
                nznr[n - k] = nznr[n - k + 1];
            }
        } else {
            int l = nznl[n - k], r = nznr[n - k];
            b[l]--;
            b[r]--;
            b[l + r - n + k]++;
            if (l != 0 && b[l] == 0) {
                nznl[n - k] = nznl[l - 1];
            }
            if (r != n && b[r] == 0) {
                nznr[n - k] = nznr[r + 1];
            }
            if (b[l + r - n + k] == 1) {
                if (l + r - n + k > n - k) {
                    nznr[l + r - n + k + 1] = nznr[n - k];
                    nznr[n - k] = l + r - n + k;
                } else if (l + r - n + k < n - k) {
                    nznl[l + r - n + k - 1] = nznl[n - k];
                    nznl[n - k] = l + r - n + k;
                }
            }
        }
    }
    int cur = 0;
    for (int i = 0; i < n; i++) {
        cur += b[i];
        cout << cur << ' ';
    }
    return 0;
}