#include <fstream>
#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <queue>
#include <cmath>
#include <algorithm>
using namespace std;

using ll = long long;

//                                              ВАНЯ ПАНИН 542 ЛЕГЕНДА!!!!!

const int maxn = 400;
const int inf = 1e9 + 239;


void solvek1() {
    int n, k, q;
    ll m;
    cin >> n >> m >> k >> q;
    vector<ll> a(n);
    ll minx = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        minx=  min(minx, a[i]);
    }
    ll sum = 0;
    for (int i = 0; i < n; i++) {
        sum += a[i] - minx;
    }
    if (m <= sum) {
        cout << minx << '\n';
    } else {
        m -= sum;
        cout << minx - (m + n - 1) / n;
    }

}

void solve() {
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    priority_queue<pair<ll, int>> qq;
    for (int i = 0; i < n; i++) {
        ll x;
        cin >> x;
        qq.push({x, -i});
    }
    for (int i = 0; i < m0; i++) {
        vector<pair<ll, int>> st(0);
        for (int j = 0; j < k0; j++) {
            st.push_back(qq.top());
            qq.pop();
            st.back().first--;
        }
        for (int j = 0; j < k0; j++) {
            qq.push(st[j]);
        }
    }
    vector<int> res(n);
    for (int i = 0; i < n; i++) {
        res[i] = qq.top().first;
        qq.pop();
    }
    for (int i = n - 1; i >= 0; i--) {
        cout << res[i] << ' ';
    }
}


//                                              ВАНЯ ПАНИН 542 ЛЕГЕНДА!!!!!


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solvek1();
}

//                                              ВАНЯ ПАНИН 542 ЛЕГЕНДА!!!!!

