#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using vii = vector<pair<int, int>>;
using vc = vector<char>;
using vb = vector<bool>;
template<typename T>
using ve = vector<T>;
template<typename T1, typename T2>
using pr = pair<T1, T2>;

const int INF = 1e9 + 1;
const long long INFLL = 1e18 + 1;
const int MOD = 1e9 + 7;

inline void fchmin(int &a, int &b) { a = min(a, b); }
inline void fchmax(int &a, int &b) { a = max(a, b); }

template<typename T>
inline bool chmin(T &a, T &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
inline bool chmax(T &a, T &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

// #include<ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_pbds;
// using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int reps = 1;

void solve() {
    int n, m, k, q; cin >> n >> m >> k >> q;
    vi a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vi b = a;
    sort(all(b));
    vi pref(n + 1);
    for (int i = 1; i <= n; i++) pref[i] = pref[i - 1] + b[i - 1];
    {
        int l = *min_element(all(a)) - k * m - 1, r = *max_element(all(a)) + 1;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            int ind = lower_bound(all(b), mid) - b.begin();
            int ost = pref[n] - pref[ind] - mid * (n - ind);
            if (ost / k >= m) l = mid;
            else r = mid;
        }
        vi res(n);
        int ind = lower_bound(all(b), l) - b.begin();
        int ost = pref[n] - pref[ind] - l * (n - ind);
        int cnt = ost - m * k;
        // cout << l << ' ' << ind << ' ' << ost << ' ' << cnt << '\n';
        for (int i = n - 1; i >= 0; i--) {
            if (a[i] <= l) res[i] = a[i];
            else if (cnt) { res[i] = l + 1; cnt--; }
            else res[i] = l;
        }
        sort(all(res));
        for (auto el : res) cout << el << ' ';
        cout << '\n';
    }
    while (q--) {
        int x; cin >> m >> k >> x; x--;
        int l = *min_element(all(a)) - k * m - 1, r = *max_element(all(a)) + 1;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            int ind = lower_bound(all(b), mid) - b.begin();
            int ost = pref[n] - pref[ind] - mid * (n - ind);
            if (ost / k >= m) l = mid;
            else r = mid;
        }
        vi res(n);
        int ind = lower_bound(all(b), l) - b.begin();
        int ost = pref[n] - pref[ind] - l * (n - ind);
        int cnt = ost - m * k;
        if (b[x] <= l) cout << b[x] << '\n';
        else if (n - x > cnt) cout << l << '\n';
        else cout << l + 1 << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> reps;
    #endif

    for (int i = 1; i <= reps; i++) {
        #ifdef LOCAL
        cout << "===== Test #" << i << " ========\n";
        #endif
        solve();
        #ifdef LOCAL
        cout << "==== End test =====\n\n";
        #endif
    }
}