#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <string>
#include <random>
#include <time.h>
#include <climits>
//#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

using namespace std;
using ll = long long;
using ld = long double;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution <> distr(0, INT_MAX);

bool cmp(pair<ll, ll> &a, pair<ll, ll>& b) {
	if (a.first != b.first)
		return a.first > b.first;
	else return a.second < b.second;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m0, k0, q;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	for (int i = 0; i < m0; i++) {
		int idx = -1;
		for (int j = 0; j < n; j++) {
			if (idx == -1 || v[j] > v[idx])
				idx = j;
		}
		v[idx]--;
	}
	sort(v.begin(), v.end());
	for (auto i : v)
		cout << i << " ";
}
