#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

int64_t get(vector<int>& a, vector<int64_t>& pref, int64_t m, int x) {
    int n = a.size();
    int L = -1, R = n;
    while (R-L > 1) {
        int M = (L+R)/2;
        int64_t cnt = n-M-1;
        if ((pref[n-1]-pref[M]-cnt*a[M])>m) L = M;
        else R = M;
    }
    if (x<R) return a[x];
    int64_t cnt = n-R-1;
    m -= pref[n-1]-pref[R]-cnt*a[R];
    ++cnt;
    int64_t d = m/cnt;
    int64_t ans = a[R]-d;
    if ((x-R+1)>m%cnt) return ans;
    return ans-1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    sort(a.begin(), a.end());
    vector<int64_t> pref(n); pref[0] = a[0];
    for (int i = 1; i < n; ++i) pref[i] = pref[i-1]+a[i];
    for (int i = 0; i < n; ++i) cout << get(a, pref, m, i) << ' ';
    cout << '\n';

    return 0;
}
