#include <string>
#include <bitset>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <iomanip>
#include <iostream>
#include <algorithm>
#include <map>
#include <set>

using namespace std;
using ll = long long;
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()

// #define SUBMIT

#ifdef SUBMIT
    #pragma GCC optimize("Ofast,unroll-loops")
#endif

void fast() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cout << setprecision(8) << fixed;
}

ll mod = 1e9 + 7;
ll binpow(ll a, ll n) {
    ll res = 1;
    for (int i = 0; (1ll << i) <= n; ++i, a = a * a % mod) {
        if ((n >> i) & 1) res = res * a % mod;
    }
    return res;
}

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> arr(n);
    for (auto &el : arr) cin >> el;
    ll l = *min_element(all(arr)) - m - 1, r = *max_element(all(arr));
    while (r - l > 1) {
        ll mid = (r + l) / 2ll;
        ll low = 0;
        for (int i = 0; i < n; ++i) {
            low += min((ll)m, max(0ll, arr[i] - mid));
        }
        if (low > m) {
            l = mid;
        } else {
            r = mid;
        }
    }
    l = r;
    ll rest = m * k;
    vector<bool> marked(n);
    for (int i = 0; i < n; ++i) {
        if (arr[i] < l) continue;
        if (arr[i] - m >= l) {
            arr[i] -= m;
            rest -= m;
            marked[i] = true;
        } else {
            rest -= (arr[i] - l);
            arr[i] = l;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (rest == 0) break;
        if (marked[i] || arr[i] < l) continue;
        rest--;
        arr[i]--;
    }
    sort(all(arr));
    for (auto el : arr) cout << el << ' ';
}
int main() {
    fast();
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}