#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;


long long n;
vector<long long> v, pref;


long long f(long long a, long long k, long long x) {
	long long l = 0, r = n, m;
	while (r - l > 1) {
		m = (l + r) / 2;
		//cout << m << ' ' << pref[m + 1] - pref[0] - v[m] * (m + 1) << '\n';
		if (pref[m + 1] - pref[0] - v[m] * (m + 1) <= a)
			l = m;
		else
			r = m;
	}
	if (l < x)
		return v[x];
	if (l == 0)
		return v[0] - a;
	long long res = a - (pref[l + 1] - pref[0] - v[l] * (m + 1)), y = res / l, z = res % l;
	if (x <= l - z)
		return v[l] - y;
	return v[l] - y - 1;
}


int main() {
	long long m, k, q, x;
	cin >> n >> m >> k >> q;
	v.resize(n);
	for (long long i = 0; i < n; i++)
		cin >> v[i];
	sort(v.rbegin(), v.rend());
	pref.resize(n + 1, 0);
	for (long long i = 0; i < n; i++)
		pref[i + 1] = pref[i] + v[i];
	for (long long i = 0; i < n; i++)
		cout << f(m, k, i) << ' ';
	cout << '\n';
}