#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;


long long n;
vector<long long> v, pref;


long long f(long long a, long long k, long long x) {
	long long l = 0, r = n, m;
	while (r - l > 1) {
		m = (l + r) / 2;
		//cout << "m " << a << ' ' << m << " || " << pref[m + 1] - pref[0] - v[m] * (m + 1) << '\n';
		if (pref[m + 1] - pref[0] - v[m] * (m + 1) <= a)
			l = m;
		else
			r = m;
	}
	if (l < x)
		return v[x];
	long long res = a - (pref[l + 1] - pref[0] - v[l] * (l + 1)), y = res / (l + 1), z = res % (l + 1);
	//cout << l << ' ' << res << ' ' << y << ' ' << z << '\n';
	if (x <= l - z)
		return v[l] - y;
	return v[l] - y - 1;
}


int main() {
	long long m, k, q, x, t;
	cin >> n >> m >> k >> q;
	v.resize(n);
	for (long long i = 0; i < n; i++)
		cin >> v[i];
	sort(v.rbegin(), v.rend());
	pref.resize(n + 1, 0);
	for (long long i = 0; i < n; i++)
		pref[i + 1] = pref[i] + v[i];
	for (long long i = 0; i < n; i++)
		cout << f(m, k, i) << ' ';
	cout << '\n';
	for (long long i = 0; i < q; i++) {
		cin >> t >> m >> k >> x;
		cout << f(m, k, x - 1) << '\n';
	}
}