#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
using ll = long long;
using ull = unsigned long long;

//tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> st;
//gp_hash_table<int, int> a;

struct segtree {
    vector<int> tr;
    int n;
    segtree(int n) : n(n), tr(2 * n) {}
    void upd(int i, int x) {
        for (tr[i += n] = x; i >= 0; tr[i >>= 1] = max(tr[i], tr[i ^ 1]));
    }
    int get(int l, int r) {
        int ans = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                ans = max(ans, tr[l++]);
            if (~r & 1)
                ans = max(ans, tr[r--]);
        }
        return ans;
    }
};

struct fenwick {
    vector<int> t;
    int n;
    fenwick(int n) : n(n), t(n + 1) {}
    void upd(int i, int x) {
        for (++i; i <= n; i += i & -i) t[i] += x;
    }
    int get(int i) {
        int x = 0;
        for (++i; i > 0; i -= i & -i) x += t[i];
        return x;
    }
};

template<class T>
bool chmin(T &a, const T &b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<class T>
bool chmax(T &a, const T &b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

mt19937 rnd(1337);

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    for (int &i : a)
        cin >> i;
    map<int, int> cnt;
    for (int i : a)
        ++cnt[i];
    while (m > 0) {
        if (cnt.size() == 1)
            break;
        int x = prev(cnt.end())->first;
        int y = prev(prev(cnt.end())) -> first;
        if (m >= (x - y) * cnt[x]) {
            m -= (x - y) * cnt[x];
            int c = cnt[x];
            cnt.erase(x);
            cnt[y] += c;
        } else {
            break;
        }
    }
    vector<int> b;
    for (auto i : cnt)
        while (i.second--) {
            b.push_back(i.first);
        }
    sort(rall(b));
    int mx = *max_element(all(b));
    int len = count(all(b), mx);
    for (int i = 0; i < m % len; ++i)
        b[i] -= m / len - 1;
    for (int i = m % len; i < len; ++i)
        b[i] -= m / len;
    sort(all(b));
    for (int i : b)
        cout << i << ' ';
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) solve();
//    cerr << fixed << setprecision(10) << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
}
