#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll MINC = -2'000'000'001, MAXC = 1'000'000'000;

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, m0, k0, q;
	cin >> n >> m0 >> k0 >> q;
	vector<ll> arr(n);
	for (ll i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector<ll> sa = arr;
	sort(sa.begin(), sa.end());
	vector<ll> psa(1, 0);
	for (ll i = 0; i < n; i++) {
		psa.push_back(psa.back() + sa[i]);
	}
	ll sc = m0 * k0;
	ll l = MINC, r = MAXC;
	while (r - l > 1) {
		ll mid = (l + r) / 2;
		ll colbm = sa.end() - lower_bound(sa.begin(), sa.end(), mid + m0);
		ll colgood = sa.end() - lower_bound(sa.begin(), sa.end(), mid);
		if (psa[n - colbm] - psa[n - colgood] - mid * (colgood - colbm) + colbm * m0 > sc) {
			l = mid;
		} else {
			r = mid;
		}
	}
	ll colbm = sa.end() - lower_bound(sa.begin(), sa.end(), r + m0);
	ll colgood = sa.end() - lower_bound(sa.begin(), sa.end(), r);
	ll ost = sc - (psa[n - colbm] - psa[n - colgood] - r * (colgood - colbm) + colbm * m0);
	ll num = 0;
	for (ll i = 0; i < n; i++) {
		if (sa[i] < r) {
			cout << sa[i] << ' ';
		} else {
			if (num < ost) {
				cout << max(r - 1, sa[i] - m0) << ' ';
			} else {
				cout << max(r, sa[i] - m0) << ' ';
			}
			num++;
		}
	}
	cout << '\n';
	for (ll i = 0; i < q; i++) {
		ll t;
		cin >> t;
		if (t == 1) {
			ll x;
			cin >> m0 >> k0 >> x;
			x--;
			ll sc = m0 * k0;
			ll l = MINC, r = MAXC;
			while (r - l > 1) {
				ll mid = (l + r) / 2;
				ll colbm = sa.end() - lower_bound(sa.begin(), sa.end(), mid + m0);
				ll colgood = sa.end() - lower_bound(sa.begin(), sa.end(), mid);
				if (psa[n - colbm] - psa[n - colgood] - mid * (colgood - colbm) + colbm * m0 > sc) {
					l = mid;
				} else {
					r = mid;
				}
			}
			if (sa[x] < r) {
				cout << sa[x] << '\n';
				continue;
			}
			if (sa[x] >= r + m0) {
				cout << sa[x] - m0 << '\n';
				continue;
			}
			ll colbm = sa.end() - lower_bound(sa.begin(), sa.end(), r + m0);
			ll colgood = sa.end() - lower_bound(sa.begin(), sa.end(), r);
			ll ost = sc - (psa[n - colbm] - psa[n - colgood] - r * (colgood - colbm) + colbm * m0);
			ll num = x - (n - colgood);
			if (num < ost) {
				cout << r - 1 << '\n';
			} else {
				cout << r << '\n';
			}
		}
		if (t == 2) {
			ll p, v;
			cin >> p >> v;
			p--;
		}
		if (t == 3) {
			ll l, r;
			cin >> m0 >> k0 >> l >> r;
			l--;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
