#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template<typename T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define rs resize
#define pb push_back
#define ff first
#define ss second
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef long double ld;
typedef long long ll;

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T>
istream &operator >>(istream &in, pair<T, T> &a) {
    in >> a.ff >> a.ss;
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, pair<T, T> &a) {
    out << a.ff << " " << a.ss;
    return out;
}

template<typename T>
istream &operator >>(istream &in, vector<T> &a) {
    for (auto &i : a) in >> i;
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &a) {
    for (auto i : a) cout << i << " ";
    return out;
}


void solve() {
    int n, m, k, q; cin >> n >> m >> k >> q;
    vector<pii> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i].ff;
        s[i].ss = i;
    }
    sort(all(s));

    int cnt = 0, r = n - 1, zn = s[n - 1].ff;
    while (m > 0) {
        while (r >= 0 && s[r].ff == zn) {
            r--; cnt++;
        }

        if (r > -1) {
            if (m > (zn - s[r].ff) * cnt) {
                m -= (zn - s[r].ff) * cnt;
                zn = s[r].ff;
            } else {
                int c = m / cnt;
                for (int i = n - 1; i > r; i--) s[i].ff = zn - c;
                sort(all(s));

                for (int i = n - 1; i > n - 1 - m % cnt; i--) s[i].ff--;
                break;
            }
        } else {
            int c = m / cnt;
            for (int i = n - 1; i > r; i--) s[i].ff = zn - c;
            sort(all(s));

            for (int i = n - 1; i > n - 1 - m % cnt; i--) s[r].ff--;
            break;
        }
    }

    for (int i = 0; i < n; i++) cout << s[i].ff << " ";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double tim = clock();
#endif

    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "-------------------\n";
#endif
    }

#ifdef LOCAL
    cout << (double)(clock() - tim) / CLOCKS_PER_SEC;
#endif
}
