#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <ctime>
#include <random>
#include <map>
#include <set>
#define ll long long
#define nl '\n'
#define m_p make_pair
#define emp emplace_back
#define all(x) x.begin(), x.end()
#define pll pair<ll, ll>
#define pii pair<int, int>
#define popcnt __builtin_popcount
#define ffs __builtin__ffs
#define ss second
#define ff first
//#include <ext/pb_ds/assoc_container.hpp>
//#pragma GCC optimize("O3")
//#pragma GCC target("avx")
//#pragma GCC target("avx2")

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll INF = 1e18;

const ll mod = 998244353;

mt19937 rnd(time(nullptr));

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &x : arr) {
        in >> x;
    }
    return in;
}

template<typename T>
ostream &operator <<(ostream &out, vector<T> &arr) {
    for (auto &x : arr) {
        out << x << ' ';
    }
    out << '\n';
    return out;
}

bool comp(const pll &p1, const pll &p2) {
    if (p1.ff == p2.ff) {
        return p1.ss < p2.ss;
    }
    return p1.ff > p2.ff;
}

void solve() {
    ll n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<pll> a(n);
    for (ll i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        a[i] = {x, i};
    }
    sort(all(a));
    vector<ll> suff(n + 1);
    suff[n] = 0;
    for (ll i = n - 1; i >= 0; --i) {
        suff[i] = suff[i + 1] + a[i].ff;
    }
    ll l = -1e12, r = 1e12;
    while (r - l > 1) {
        ll sr = (l + r) / 2;
        ll i = lower_bound(all(a), m_p(sr, -1ll)) - a.begin();
        ll sum = suff[i] - sr * (n - i);
        if (sum > m) {
            l = sr;
        }
        else {
            r = sr;
        }
    }
    ll i = lower_bound(all(a), m_p(l, -1ll)) - a.begin();
    ll kol = (suff[i] - l * (n - i)) - m;
    for (ll j = i; j < (n - kol); ++j) {
        a[j].ff = l;
    }
    for (ll j = n - kol; j < n; ++j) {
        a[j].ff = r;
    }
    for (ll j = 0; j < n; ++j) {
        cout << a[j].ff << ' ';
    }
}

int main() {
#ifdef CLOCK
    ll time1 = clock();
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll tpk = 1;

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif

    while (tpk--) {
        solve();
        cout << nl;
    }

#ifdef CLOCK
    cout << clock() - time1 << " ms";
#endif
}