#include <bits/stdc++.h>

#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

using namespace std;
using ll = long long;

const ll infll = (ll) 1e18;
const int inf = (int) 1e9;
const ll MOD = 1e9 + 7;

ll mod(ll a) {
    ll r = a % MOD;
    if (r < 0) {
        return r + MOD;
    }
    return r;
}

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

vector<ll> a;

ll f(int m, int k, int x) {
    multiset<ll, greater<>> st;
    for (auto y : a) {
        st.insert(y);
    }
    for (int i = 0; i < m; ++i) {
        int d = 0;
        multiset<ll, greater<>> st2;
        for (auto y : st) {
            if (d < k) {
                st2.insert(y - 1);
            } else {
                st2.insert(y);
            }
            d++;
        }
        swap(st, st2);
    }
    vector<ll> ans;
    for (auto y : st) {
        ans.push_back(y);
    }
    reverse(all(ans));
    return ans[x - 1];
}

void solve() {
    ll n, m, k0, q;
    cin >> n >> m >> k0 >> q;
    a.resize(n);
    for (auto &x : a) cin >> x;
    sort(all(a), greater<>());
    for (int i = 0; i < m; ++i) {
        a[0]--;
        if (a[0] < a[1]) {
            swap(a[0], a[1]);
        }
    }
    reverse(all(a));
    for (auto y : a) {
        cout << y << ' ';
    }
    cout << '\n';
    for (int _ = 0; _ < q; ++_) {
        int t;
        cin >> t;
        if (t == 1) {
            int k, x;
            cin >> m >> k >> x;
            cout << ans[x - 1] << '\n';
        } else if (t == 2) {
            int ind, x;
            cin >> ind >> x;
            ind--;
            a[ind] = x;
        } else {
            int k, l, r;
            cin >> m >> k >> l >> r;
            ll s = 0;
            for (int x = l; x <= r; ++x) {
                s += f(m, k, x);
            }
            cout << s << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}