#include "bits/stdc++.h"

using namespace std;

#define int long long

void solve() {
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;

    vector<int> s(n);

    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }

    sort(s.begin(), s.end());

    auto func = [&](int m, int k) {
        auto g = s;
        for (int i = 0; i < m; i++) {
            sort(g.rbegin(), g.rend());

            for (int j = 0; j < k; j++) {
                g[j]--;
            }
        }
        return g;
    };

    auto g = func(m0, k0);
    sort(g.rbegin(), g.rend());

    for (int i = n - 1; i >= 0; i--) {
        cout << g[i] << ' ';
    }
    cout << '\n';

    while (q--) {
        int t;
        cin >> t;

        int m, k, x;
        cin >> m >> k >> x;

        g = func(m, k);
        cout << g[x - 1] << '\n';
    }
}
signed main() {
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int akbalin = 1;
    // cin >> akbalin;

    for (int i = 1; i <= akbalin; i++) {
        solve();
    }
}