//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#pragma GCC optimize("Ofast,unroll-loops")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <random>
using ll = long long;
#define int ll
#define all(a) a.begin(), a.end()

using namespace std;
//using namespace __gnu_pbds;

//using odered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
mt19937 rnd(0);

struct Node {
	int sum = 0, psh = 1e18;
};
vector<Node> t;
vector<int> a;

void build(int v, int l, int r) {
	if (l == r - 1) {
		t[v].sum = a[l];
		return;
	}
	int m = (l + r) / 2;
	build(v * 2 + 1, l, m);
	build(v * 2 + 2, m, r);
	t[v].sum = t[v * 2 + 1].sum + t[v * 2 + 2].sum;
}

void psh(int v, int l, int m, int r) {
	if (t[v].psh != 1e18) {
		t[v * 2 + 1].sum = t[v].psh * (m - l);
		t[v * 2 + 2].sum = t[v].psh * (r - m);
		t[v * 2 + 1].psh = t[v].psh;
		t[v * 2 + 2].psh = t[v].psh;
		t[v].psh = 1e18;
	}
}

int get(int v, int l, int r, int lq, int rq) {
	if (lq <= l && r <= rq) {
		return t[v].sum;
	}
	if (lq >= r || l >= rq) {
		return 0;
	}
	int m = (l + r) / 2;
	psh(v, l, m, r);
	return get(v * 2 + 1, l, m, lq, rq) + get(v * 2 + 2, m, r, lq, rq);
}

void st(int v, int l, int r, int lq, int rq, int val) {
	if (lq <= l && r <= rq) {
		t[v].sum = (r - l) * val;
		t[v].psh = val;
		return ;
	}
	if (lq >= r || l >= rq) {
		return;
	}
	int m = (l + r) / 2;
	psh(v, l, m, r);
	st(v * 2 + 1, l, m, lq, rq, val);
	st(v * 2 + 2, m, r, lq, rq, val);
	t[v].sum = t[v * 2 + 1].sum + t[v * 2 + 2].sum;
}

void solve() {
	int n, m, k, q;
	cin >> n >> m >> k >> q;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	t.resize(n * 4);
	sort(all(a));
	for (int i = n - k; i < n; i++) {
		a[i] -= m;
	}
	build(0, 0, n);
 	for (int i = n - 2; i >= 0; i--) {
		int j = i;
		for (int k = 20; k >= 0; k--) {
			int j1 = j + (1 << k);
			if (j1 >= n - 1) continue;
			int s = get(0, 0, n, i, j1+1);
			int h1 = s / (j1 - i + 1);
			int rem = s % (j1 - i + 1);
			if (h1 + bool(rem) > get(0, 0, n, j1+1, j1 + 2)) {
				j = j1;
			}
		}
		j++;
		int s = get(0, 0, n, i, j + 1);
		int h1 = s / (j - i + 1);
		if (h1 > get(0, 0, n, i, i + 1)) continue;
		int rem = s % (j - i + 1);
		if (rem < 0) {
			h1--;
			rem = (j - i + 1) + rem;
		}
		st(0, 0, n, i, j - rem + 1, h1);
		st(0, 0, n, j - rem + 1, j+1, h1 + 1);
	}
	for (int i = 0; i < n; i++) {
		cout << get(0, 0, n, i, i + 1) << ' ';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef LOCAL
	auto f1 = freopen("input.txt", "r", stdin);
	auto f2 = freopen("output.txt", "w", stdout);
#endif

	int t;
	t = 1;// cin >> t;
	while (t--) {
		solve();
	}
}