#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>

//#include <ext/pb_ds/assoc_containe.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

//template <class T> order_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//find_by_orede, order_of_key

#define int long long
#define all(a) (a).begin(), (a).end()

#pragma GCC optimize ("O3")
#pragma GCC target ("avx2")


const int inf = 1e18;

void ans(int t) {
	if (t) cout << "First\n";
	else cout << "Second\n";
	exit(0);
}


vector<vector<int>> g;

bool connect(int u, int i, int j) {
	if (u == j) return 1;
	if (u > j) return 0;

	if (u == i) {
		bool f1 = 0;
		for (int v : g[u])
			if (v == j) f1 = 1;
		if (!f1) return 0;
	}

	for (int v : g[u])
		if (!(u == i && v == j))
			if (connect(v, i, j)) return 1;

	return 0;
}
void solve() {
	int n, m, k, q; cin >> n >> m >> k >> q;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) cin >> a[i];

	sort(all(a));
	if (n == k) {
		for (int i : a) cout << i - m << ' ';
		return;
	}

	set<pair<int, int>> st;
	unordered_map<int, int> ccc;

	for (int i : a) ccc[i]++;
	for (auto [a, b] : ccc) st.insert({ -a, b });

	while (m) {
		auto [a, b] = *st.begin();
		st.erase(st.begin());
		if (st.empty()) {
			if (m % b)
				st.insert({ a + m / b + 1, m % b });
			st.insert({ a + m / b, b - m % b });
			m = 0;
		}
		else {
			auto [c, d] = *st.begin();
			int A = abs(a - c);

			if (A * b <= m) {
				st.erase(st.begin());
				st.insert({ c, b + d });
				m -= A * b;
			}
			else {
				if (m % b)
					st.insert({ a + m / b + 1, m % b });
				st.insert({ a + m / b, b - m % b });
				m = 0;
			}
		}
	}

	for (auto [a, b] : st) {
		for (int i = 0; i < b; ++i) cout << a << ' ';
	}
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);

#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t = 1; //cin >> t;
	while (t--) solve();
}