// 4.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <immintrin.h>
#include <set>
#include <map>
#include <numeric>
#include <queue>
#include <cstring>

using ll = long long;
using ld = long double;
using namespace std;
#define int long long

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    if (k0 != 1)
        return -1;
    vector <ll> a(n);
    for (auto& i : a)
    {
        cin >> i;
    }
    sort(a.begin(), a.end());
    vector <ll> suff(n + 1);
    for (int i = n - 1; i >= 0; i--)
    {
        suff[i] = suff[i + 1] + a[i];
    }
    auto money_count = [&](ll d, ll m)
    {
        auto it = lower_bound(a.begin(), a.end(), d);
        int c1 = a.end() - it;
        ll c2 = suff[it - a.begin()];
        ll need = c2 - d * c1;
        if (need >= m)
            return (ll)c1;
        return max(0ll, c1 - (m - need));
    };
    auto gain_flag = [&](ll m, ll x)
    {
        ll ql = -1e18, qr = 1e18;
        while (qr - ql > 1)
        {
            ll qm = (ql + qr) / 2;
            if (money_count(qm, m) >= n - x)
                ql = qm;
            else
                qr = qm;
        }
        return ql;
    };
    for (size_t i = 0; i < n; i++)
    {
        cout << gain_flag(m0, i) << ' ';
    }
    cout << '\n';
    for (size_t i = 0; i < q; i++)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            ll mj, kj, xj;
            cin >> mj >> kj >> xj;
            if (kj != 1)
                return -1;
            cout << gain_flag(mj, xj - 1) << '\n';
        }
    }
    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
