// 4.cpp : This file contains the 'main' function. Program execution begins and ends there.
//
#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <immintrin.h>
#include <set>
#include <map>
#include <numeric>
#include <queue>
#include <cstring>
#include <unordered_map>
#include <ext/hash_map>
#include <ext/pb_ds/detail/standard_policies.hpp>
//#include <ext/gp_hash_table>

using ll = long long;
using ld = long double;
using namespace std;
//#define int long long

const ll MAXN = (1ll << 31), OFF = (1ll << 30);


__gnu_cxx::hash_map<ll, pair<ll, int>> st;

ll ql, qr, qc, qt;

void segment(ll v, ll l, ll r)
{
    if (qr <= l || ql >= r)
        return;
    if (st.find(v) == st.end())
        return;
    if (ql <= l && r <= qr)
    {
        qc += st[v].second;
        qt += st[v].first;
        return;
    }
    segment(2 * v + 1, l, (l + r) >> 1);
    segment(2 * v + 2, (l + r) >> 1, r);
}

void sett(ll v, ll l, ll r)
{
    if (qr <= l || ql >= r)
        return;
    st[v].first += qt;
    st[v].second += qc;
    if (r - l == 1)
        return;
    sett(2u * v + 1u, l, (l + r) >> 1);
    sett(2u * v + 2u, (l + r) >> 1, r);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;
    if (k0 != 1)
        return -1;
    vector <ll> a(n);
    for (auto& i : a)
    {
        cin >> i;
        ql = i;
        qr = i + 1;
        qt = i;
        qc = 1;
        ql += OFF;
        qr += OFF;
        sett(0, 0, MAXN);
    }
    //sort(a.begin(), a.end());

    vector <ll> suff(n + 1);
    for (int i = n - 1; i >= 0; i--)
    {
        suff[i] = suff[i + 1] + a[i];
    }
    auto money_count = [&](ll d, ll m)
    {
        //auto it = lower_bound(a.begin(), a.end(), d);
        //ll c1 = a.end() - it;
        //ll c2 = suff[it - a.begin()];
        qc = 0;
        qt = 0;
        ql = d;
        qr = OFF;
        ql += OFF;
        qr += OFF;
        segment(0, 0, MAXN);
        ll c1 = qc, c2 = qt;
        ll need = c2 - d * c1;
        if (need >= m)
            return (ll)c1;
        return max(0ll, c1 - (m - need));
    };
    auto gain_flag = [&](ll m, ll x)
    {
        ll ql = -1e12, qr = 1e12;
        while (qr - ql > 1)
        {
            ll qm = (ql + qr) / 2;
            if (money_count(qm, m) >= n - x)
                ql = qm;
            else
                qr = qm;
        }
        return ql;
    };
    for (size_t i = 0; i < n; i++)
    {
        cout << gain_flag(m0, i) << ' ';
    }
    cout << '\n';
    for (size_t i = 0; i < q; i++)
    {
        int t;
        cin >> t;
        if (t == 1)
        {
            ll mj, kj, xj;
            cin >> mj >> kj >> xj;
            if (kj != 1)
                return -1;
            cout << gain_flag(mj, xj - 1) << '\n';
        }
        if (t == 2)
        {
            int pj;
            ll vj;
            cin >> pj >> vj;
            ql = a[pj];
            qr = a[pj] + 1;
            qc = -1;
            qt = -a[pj];
            sett(0, 0, MAXN);
            ql = vj;
            qr = vj + 1;
            qc = 1;
            qt = vj;
            sett(0, 0, MAXN);
            a[pj] = vj;
        }
    }
    return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file

