#include <bits/stdc++.h>

using namespace std;
using ll = long long;

template<typename T>
void print(vector<T> ff) {
    for (auto dd: ff) cout << dd << ' ';
    cout << '\n';
}

#define int long long

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    std::sort(a.begin(), a.end(), greater());
    vector<ll> x(n + 1);

    for (int i = 1; i < n; ++i) {
        x[i] = (a[i - 1] - a[i]) * i + x[i - 1];
    }
    x[n] = max<ll>(x[n - 1] + 1, 1e9 + 7);
    int ind = -1;
    for (int i = 0; i <= n; ++i) {
        if (x[i] <= m) {
            continue;
        } else {
            ind = i;
            break;
        }
    }
    vector<int> c;
    m -= x[ind - 1];
    for (int i = 0; i < ind; ++i) {
        c.push_back(a[ind - 1] - (m / ind));
    }
    for (int i = 0; i < m % ind; ++i) {
        c[i]--;
    }
    for (int i = ind; i < n; ++i) {
        c.push_back(a[i]);
    }
    std::sort(c.begin(), c.end());
    print(c);
    std::reverse(a.begin(), a.end());
    std::reverse(x.begin(), x.end());
    x.push_back(-1);
//    print(x);
    while (q--) {
        int num;
        cin >> num >> m >> k >> num;
        num--;
        int l = 0, r = n + 2;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (x[mid] >= m) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (num + 1 <= l) {
            cout << a[num] << '\n';
            continue;
        }
        if (l == 0) {
            m -= x[1];
            cout << a[0] - m / n - (num < m % n) << '\n';
            continue;
        }
        m -= x[l];
        int cnt = n - l;
        cout << a[r] - m / cnt - (num - l - 1 < m % cnt) << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
