#include <bits/stdc++.h>
using namespace std;
#ifdef _LOCAL
#define debug(x) cerr << __LINE__ << ' ' << __PRETTY_FUNCTION__ << ": " << x << '\n';
#else
#define debug(...) 238;
#endif
mt19937 rng(238);
mt19937_64 rng64(238);
using ll = long long;
template <typename T, int U>
using ar = array<T, U>;
template <typename T, typename U>
bool chmin(T& x, const U&& y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
template <typename T, typename U>
bool chmax(T& x, const U&& y) {
    if (x < y) {
        x = y;
        return true;
    }
    return false;
}

#include <ext/pb_ds/assoc_container.hpp>
template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type,
                                     less<T>,
                                     __gnu_pbds::rb_tree_tag,
                                     __gnu_pbds::tree_order_statistics_node_update>; 

constexpr int Inf = 0x3f3f3f3f;
constexpr ll  inf = 0x3f3f3f3f3f3f3f3f;

ll matdiv(ll x, ll y) {
    if (x < 0) {
        return (x - y + 1) / y;
    }
    return x / y;
}
ll matmod(ll x, ll y) {
    return x % y;
    // return (x % y + y) % y;
}

void solve() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<ll> a(n);
    for (ll& x : a) {
        cin >> x;
    }
    sort(a.begin(), a.end());
    ll sum = 0;
    bool ok = false;
    for (ll i = n - 1; i >= 0; --i) {
        sum += a[i];
        if (i == 0 || (sum - m) / (n - i) >= a[i - 1]) {
            ll sm = sum - m;
            ll mn = matdiv(sm, (n - i));
            ll mx = matdiv(sm, (n - i)) + (bool)matmod(sm, (n - i));
            ll willbemx = sm - mn * (n - i);
            ll willbemn = n - i - willbemx;
            for (int j = i; j < n; ++j) {
                if (willbemn) {
                    a[j] = mn;
                    willbemn--;
                } else {
                    a[j] = mx;
                }
            }
            ok = true;
            break;
        }
    }
    for (int x : a) {
        cout << x << ' ';
    }
}

int main() {
#ifdef _LOCAL
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
#endif
    cin.tie(0)->sync_with_stdio(0);

    int Tc = 1;
    // cin >> Tc;
    while (Tc--) {
        solve();
        cout << '\n';
    }

    return 0;
}