#ifdef _MSC_VER
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#endif

using namespace std;
using ll = long long;
const int inf = 1e9 + 7;
const ll infll = 1e18;

template<typename T>
istream& operator>>(istream& is, vector<T>& a) {
	for (auto& i : a) {
		is >> i;
	}
	return is;
}

int32_t main() {
#ifdef LOCAL
	assert(freopen("C:\\Users\\User\\input.txt", "r", stdin));
#else
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
#endif
	int n, m0, k0, q;
	cin >> n >> m0 >> k0 >> q;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first;
		a[i].second = i;
	}
	for (int i = 0; i < m0; ++i) {
		sort(a.begin(), a.end(), [](const pair<int, int>& p, const pair<int, int>& q) {
			if (p.first == q.first) {
				return p.second < q.second;
			}
			return p.first > q.first;
			});
		for (int j = 0; j < k0; ++j) {
			--a[j].first;
		}
	}
	sort(a.begin(), a.end());
	for (int i = 0; i < n; ++i) {
		cout << a[i].first << " ";
	}
	cout << "\n";
	return 0;
}