#include <bits/stdc++.h>

using ll = long long;
using namespace std;
const int INF = 1e9, MOD = 1e9 + 7;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

void solve() {
    int n, k, q;
    ll m;
    cin >> n >> m >> k >> q;
    vector<ll> a(n);
    for (auto &i : a) cin >> i;
    sort(rall(a));
    vector<ll> pref(n + 1, 0);
    for (int i = 1; i <= n; ++i) {
        pref[i] = pref[i - 1] + a[i - 1];
    }
    for (ll i = 0; i < n; ++i) {
        ll L = -2e9, R = a[i] + 1;
        while (R - L > 1) {
            ll M = (R + L) / 2;
            ll l = i, r = n;
            while (r - l > 1) {
                ll mx = (r + l) / 2;
                if (a[mx] > M) {
                    l = mx;
                } else {
                    r = mx;
                }
            }
            ll sum = pref[r] - pref[i] - M * (r - i);
            if (sum <= m) {
                R = M;
            } else {
                L = M;
            }
        }
        m -= a[i] - R;
        a[i] = R;
    }
    reverse(all(a));
    for (int i = 0; i < n; ++i) {
        cout << a[i] << ' ';
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
