#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <random>
#include <deque>
#include <stack>
#include <cmath>
#include <iomanip>

using namespace std;
using ll = long long;
using ld = long double;
using str = string;

//mt19937 rnd(288);

const int INF = 1e9 + 239;
const int EPS = 1e-9;

void fastw() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

void solve() {
	int n, m, k, q;
	cin >> n >> m >> k >> q;
	vector<int> a(n + 1, 0);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	sort(a.begin(), a.end());
	int p = n;
	while (m > 0) {
		if ((a[p] - a[p - 1]) * (n - p + 1) >= m) {
			a[p] -= m / (n - p + 1);
			for (int i = p + 1; i <= n; i++) {
				a[i] = a[i - 1];
			}
			m %= n - p + 1;
			while (m > 0) {
				a[p]--;
				m--;
				p++;
			}
		}
		else {
			m -= (a[p] - a[p - 1]) * (n - p + 1);
			p--;
			while (a[p] == a[p + 1]) {
				p--;
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		cout << a[i] << ' ';
	}
}

int main() {
	fastw();
	int tt = 1;
	//cin >> tt;
	while (tt--) {
		solve();
		cout << '\n';
	}
}