#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using ll = long long;
using namespace __gnu_pbds;
using ord_set = tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n, m, k, Q;
    cin >> n >> m >> k >> Q;
    vector<int> a(n);
    struct node{
        pair<int, int> a;
        node(int v, int i) {
            a = {v, i};
        }
        bool operator<(const node &other) const {
            if (a.first == other.a.first) {
                return a.second > other.a.second;
            }
            return a.first < other.a.first;
        }
    };
    priority_queue<node, vector<node>> q;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        q.push({a[i], i});
    }
    while (m > 0) {
        auto [v1, pos1] = q.top().a;
        q.pop();
        if (q.empty()) {
            cout << v1 - m;
            return;
        }
        auto [v2, pos2] = q.top().a;
        int d = v1 - v2;
        if (d == 0) {
            m -= 1;
            a[pos1]--;
            q.push({a[pos1], pos1});
            continue;
        }
        if (m > d) {
            m -= d;
            a[pos1] = v2;
            q.push({v2, pos1});
        } else {
            a[pos1] = v1 - m;
            m = 0;
        }
    }
    for (auto u : a) {
        cout << u << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
}
