#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define int long long
#define db long double
#define MX LLONG_MAX
#define MN LLONG_MIN
#define gcd(a, b) __gcd(a, b)
#define lcm(a, b) (a / gcd(a, b) * b)

using namespace std;
using namespace __gnu_pbds;

typedef tree<
int,
null_type,
less<int>,
rb_tree_tag,
tree_order_statistics_node_update>
ordered_set;

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, m, k, q;
    cin >> n >> m >> k >> q;

    int mx = MN;
    ordered_set st;
    unordered_map<int, int> cnt;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        st.insert(v[i]);
        cnt[v[i]]++;
        mx = max(mx, v[i]);
    }

    if (m == 0 || k == 0) {
        sort(v.begin(), v.end());
        for (auto x: v) {
            cout << x << " ";
        }
        return 0;
    }

    while (m--) {
        vector<int> vec(k);
        for (int i = n - k; i < n; i++) {
            int x = *st.find_by_order(st.size() - 1);
            cnt[x]--;
            if (!cnt[x]) st.erase(x);
            vec[i - (n - k)] = x + 1;
        }

        for (int i = 0; i < k; i++) {
            cnt[vec[i]]++;
            st.insert(vec[i]);
        }
    }

    for (int i = 0; i < n; i++) {
        int x = *st.find_by_order(0);
        cout << x << " ";
        cnt[x]--;
        if (!cnt[x]) st.erase(x);
    }
}

/*
8 3 4 0
3 1 2 -1 0 2 -1 4
*/
