//#pragma GCC target("avx, avx2")
#pragma GCC optimize("O3, Ofast, unroll-loops")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <iomanip>
#include <random>
#include <vector>
#include <map>
#include <queue>
#include <deque>
#include <set>


using namespace std;
using ll = long long;
const ll MAX = 1e18;
const ll MIN = -1e18;

#define all(a) a.begin(), a.end()
#define each(x, a) for(auto &x : a)


struct P {
	ll f, s;
};


ll get(ll l, ll r, vector<ll>& pref) {
	if (!l) return pref[r];
	return pref[r] - pref[l - 1];
}


void solve() {
	ll n, m, k, q;
	cin >> n >> m >> k >> q;
	vector<ll> a(n);
	each(x, a) {
		cin >> x;
	}
	//vector<ll> c = { 3, 5, 2, 4, 6 };
	vector<ll> d(n);
	//merge(c.begin(), c.begin() + 2, c.begin() + 2, c.end(), d.begin());

	sort(all(a));
	/*each(x, a) {
		cout << x << " ";
	}
	cout << '\n';*/
	vector<ll> pref(n);
	pref[0] = a[0];
	for (int i = 1; i < n; ++i) {
		pref[i] = pref[i - 1] + a[i];
	}
	//ll l = MIN, r = a.back();
	ll l = 0, r = a.back();
	while (r - l > 1) {
		ll mid = l + (r - l) / 2;
		ll sum = 0;
		for (int i = 0; i < n; ++i) {
			sum += (max(0ll, a[i] - mid));
		}
		if (sum > m) {
			r = mid;
		}
		else {
			l = mid;
		}
	}
	for (int i = 0; i < n; ++i) {
		m -= max(0ll, a[i] - l);
		if (a[i] > l) a[i] = l;
	}
	for (int i = n - 1; i >= 0; --i) {
		a[i]--;
		m--;
		if (!m) break;
	}
	sort(all(a));
	for (int i = 0; i < n; ++i) {
		cout << a[i] << " ";
	}
}


signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}