#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#define all(v) v.begin(), v.end()
#define fi first
#define se second

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<long long, long long> pii;

const ll SZ = 5e5;

void solve() {
	ll n, m, k, q;
	cin >> n >> m >> k >> q;
	vector<ll> a(n);
	vector<ll> b(n);
	for (ll i = 0; i < n; i++) cin >> a[i];
	for (ll i = 0; i < n; i++) b[i] = a[i];
	sort(all(b));
	sort(all(a));
	vector<ll> pref;
	for (ll i = n - 1; i > 0; i--) {
		if (pref.empty()) pref.push_back(a[i] - a[i - 1]);
		else pref.push_back(pref.back() + (a[i] - a[i - 1]) * (n - i));
	}
	//for (auto i : pref) cout << i << ' ';
	//cout << '\n';
	bool f = true;
	for (ll i = n - 1; i > 0; i--) {
		if (m > (a[i] - a[i - 1]) * (n - i)) {
			m -= (a[i] - a[i - 1]) * (n - i);
		}
		else {
			f = false;
			a[i] -= m / (n - i);
			m %= (n - i);
			for (ll j = i + 1; j < n; j++) a[j] = a[i];
			break;
		}
	}
	if (f) {
		a[0] -= m / n;
		m %= n;
		for (ll j = 1; j < n; j++) a[j] = a[0];
	}
	priority_queue<ll> pq;
	for (ll i = 0; i < n; i++) pq.push(a[i]);
	for (ll i = 0; i < m; i++) {
		ll c = pq.top();
		c--;
		pq.pop();
		pq.push(c);
	}
	a = {};
	for (ll i = 0; i < n; i++) {
		a.push_back(pq.top());
		pq.pop();
	}
	sort(all(a));
	for (ll i = 0; i < n; i++) cout << a[i] << ' ';
	cout << '\n';
	a = b;
	ll type, x;
	for (ll _ = 0; _ < q; _++) {
		cin >> type >> m >> k >> x;
		--x;
		if (n == 1) {
			cout << a[0] - m << '\n';
			continue;
		}
		ll mid, l = -1, r = pref.size();
		while (r - l > 1) {
			mid = (l + r) / 2;
			if (pref[mid] > m) r = mid;
			else l = mid;
		}
		ll l1, r1, x1;
		if (l == -1) {
			l1 = n - 1;
			r1 = n - 1;
			x1 = a[l1] - m;
		}
		else {
			l1 = n - 2 - l;
			//cout << l1 << ' ' << pref[l1] << ' ' << a[l1] << '\n';
			x1 = a[l1];
			m -= pref[l];
			x1 -= m / (n - l1);
			m %= (n - l1);
			r1 = l1 + m;
		}
		if (x < l1) cout << a[x] << '\n';
		else if (x >= r1) cout << x1 << '\n';
		else cout << x1 - 1 << '\n';
	}
}

int main() {
	ll t = 1;
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	cin >> t;
#else
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
	while (t--) solve();
}
