#pragma GCC optimize("O3,unroll-loops")

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
using ll = long long int;
using ull = unsigned long long int;

using ordered_set = tree<array<int, 2>, null_type, less<array<int, 2>>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()
#define rall(X) (x).rbegin(), (x).rend()

void solve()
{
    int n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;

    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    vector<array<int, 3>> qs(n + q);
    for (int i = 0; i < n; i++)
        qs[i] = {m0, i, i};
    for (int i = 0; i < q; i++)
    {
        int t, m, k, x;
        cin >> t >> m >> k >> x;
        --x;

        qs[n + i] = {m, x, n + i};
    }
    sort(all(qs));
    vector<int> ans(n + q);
    ordered_set st;
    for (int i = 0; i < n; i++)
        st.insert({a[i], i});
    
    int cnt = 0;
    for (auto [m, x, id] : qs)
    {
        while (cnt < m)
        {
            vector<array<int, 2>> vals;
            for (int i = 0; i < k0; i++)
            {
                auto it = --st.end();
                vals.push_back(*it);
                st.erase(it);
            }
            for (auto [s, t] : vals)
                st.insert({s - 1, t});
            ++cnt;
        }
        ans[id] = (*st.find_by_order(x))[0];
    }

    for (int i = 0; i < n; i++)
        cout << ans[i] << ' ';
    cout << '\n';
    for (int i = n; i < n + q; i++)
        cout << ans[i] << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
#ifdef LOCAL
    freopen("C:/work/Day 2/in.txt", "r", stdin);
    freopen("C:/work/Day 2/out.txt", "w", stdout);
    cin >> t;
#else
    t = 1;
#endif

    while (t--)
        solve();
    return 0;
}
