//#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll INF = 1e18;

void solve() {
    ll n, m, k, q;
    cin >> n >> m >> k >> q;
    set<pair<ll, ll>> venom;
    for (ll i = 0; i < n; ++i) {
        ll ai;
        cin >> ai;
        venom.insert({-ai, i});
    }

    for (ll i = 0; i < m; ++i) {
        vector<pair<ll, ll>> cur;
        for (ll j = 0; j < k; ++j) {
            cur.push_back(*venom.begin());
            venom.erase(venom.begin());
        }
        for (ll j = 0; j < k; ++j) {
            venom.insert({cur[j].first + 1, cur[j].second});
        }
    }

    vector<ll> ans;
    for (auto x : venom) {
        ans.push_back(-x.first);
    }
    reverse(ans.begin(), ans.end());
    for (ll x : ans) {
        cout << x << ' ';
    }
    cout << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
