#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, m0, k0, q;
vector<ll> a;
vector<ll> p;

ll solve(ll m, ll k, ll x) {
    ll l = -1, r = n;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        ll sum = p[n] - p[mid] - (n - mid) * a[mid];
        if (sum >= m) {
            l = mid;
        } else {
            r = mid;
        }
    }
    if (l == -1) {
        m -= p[n] - n * a[0];
        ll gg = m / n;
        if (x < m % n) {
            return a[0] - gg - 1;
        } else {
            return a[0] - gg;
        }
    }
    if (x < l) {
        return a[x];
    }
    ll gg = p[n] - p[l] - (n - l) * a[l] - m;
    if (x < n - gg) {
        return a[l];
    } else {
        return a[l] + 1;
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m0 >> k0 >> q;
    a.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    p.assign(n + 1, 0);
    for (ll i = 1; i <= n; i++) {
        p[i] = p[i - 1] + a[i - 1];
    }
    for (ll i = 0; i < n; i++) {
        cout << solve(m0, k0, i) << ' ';
    }
    while (q--) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll m, k, x;
            cin >> m >> k >> x;
            cout << solve(m, k, x - 1) << '\n';
        } else if (t == 2) {
            ll x, v;
            cin >> x >> v;
        } else {
            ll m, k, l, r;
            cin >> m >> k >> l >> r;
        }
    }
}