#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

//#pragma GCC optimize("O3")

#define out(x) std::cout << x << ' ';
#define oute(x) std::cout << x << '\n';
#define enter std::cout << '\n';
#define debout(x) std::cout << #x << x << '\n';
#define debvout(x) std::cout << #x << " : "; for (auto i: x) std::cout << x << ' '; std::cout << '\n';
#define all(x) x.begin(), x.end()
using ll = long long;

void s1nmeee() {
    ll n, m, k, q;
    std::cin >> n >> m >> k >> q;
    std::vector<ll> a(n);
    for (ll& i : a) std::cin >> i;
    ll l = -1e12, r = 1e12, p = m * k;
    while (r - l > 1) {
        ll mid = (l + r) >> 1;
        ll sum = 0;
        for (ll i = 0; i < n; i++) {
            if (a[i] < mid) {
                sum = -1e18;
                break;
            }
            sum += a[i] - mid;
        }
        if (sum < p) r = mid; else l = mid;
    }
    ll mid = l;
    ll sum = 0;
    for (ll i = 0; i < n; i++) {
        sum += a[i] - mid;
    }
    p = sum - p;
    std::fill(all(a), l);
    while (p > 0) {
        for (ll i = 0; i < n && p > 0; i++, p--) a[i]++;
    }
    ll ans = 0;
    for (ll& i : a) ans += i;
    out(ans)
}

signed main() {
    std::cin.tie(nullptr), std::ios::sync_with_stdio(false);
    ll TT = 1;
    //std::cin >> TT;
    while (TT--) {
        s1nmeee();
        std::cout << '\n';
    }
}