#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

template<class T>
using order_set = tree<T, nullptr_t, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using mll = map<ll, ll>;
using pll = pair<ll, ll>;
using vll = vector<ll>;

const ll inf = 1e16;
const ll mod = 1e9 + 7;
const ld eps = 1e-9;


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n, m0, k0, q;
    cin >> n >> m0 >> k0 >> q;

    vector<ll> a(n);
    for (ll &i: a)
        cin >> i;

    for (ll i = 0; i < m0; i++) {
        sort(a.begin(), a.end());
        for (ll j = n - 1; j > n - k0 - 1; j--)
            a[j]--;
    }

    sort(a.begin(), a.end());
    for (ll &i: a)
        cout << i << ' ';
    cout << '\n';
}