#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

template<class T>
using order_set = tree<T, nullptr_t, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ld = long double;
using mll = map<ll, ll>;
using pll = pair<ll, ll>;
using vll = vector<ll>;

const ll inf = 1e16;
const ll mod = 1e9 + 7;
const ld eps = 1e-9;

const ll nmax = 3e5 + 1;
ll p[nmax], a[nmax];
vector<ll> b;
ll n, m, T;

ll f(ll i, ll j) {
    return p[max(i, j) + 1] - p[min(i, j)];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> m >> T;
    b.resize(m);
    for (ll i = 0; i < n; i++)
        cin >> a[i];
    for (ll i = 0; i < m; i++) {
        cin >> b[i];
        b[i]--;
    }
    b.push_back(n);

    for (ll i = 0; i < n; i++)
        p[i + 1] = p[i] + a[i];
    p[n + 1] = inf;

    ll p1 = -1, p2 = -1;
    ll ptr = 0;
    ll res = 0;
    for (ll i = 0; i < n; i++) {
        if (p2 < i) {
            p1 = b[ptr++];
            p2 = b[ptr];
        }
        if (T >= f(i, p1))
            res = max(res, (i - p1 + 1) + (T - f(i, p1)) / a[i]);
        if (T >= f(p2, i) && p2 != n)
            res = max(res, (p2 - i + 1) + (T - f(p2, i)) / a[i]);
    }
    for (ll i = b[0]; i >= 0; i--)
        if (T >= f(i, b[0]))
            res = max(res, (b[0] - i + 1) + (T - f(i, b[0])) / a[i]);
    cout << res << '\n';
}
