#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>

#define int long long

using namespace std;

signed main() {
    int n, m, k, q;
    cin >> n >> m >> k >> q;
    vector<int> a(n), pref(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < n; ++i) {
        pref[i + 1] = pref[i] + a[i];
    }
    int l1 = -1, r1 = n - 1;
    while (l1 + 1 < r1) {
        int mid = (l1 + r1) / 2;
        if (pref[n] - pref[mid + 1] - a[mid] * (n - 1 - mid) <= m) {
            r1 = mid;
        }
        else {
            l1 = mid;
        }
    }
    m -= pref[n] - pref[r1 + 1] - a[r1] * (n - 1 - r1);
    for (int i = r1 + 1; i < n; ++i) {
        a[i] = a[r1];
    }
    if (a[0] == a[n - 1]) {
        for (int i = 0; i < n; ++i) {
            a[i] -= m / n;
        }
        m %= n;
    }

    for (int i = 0; i < m; ++i) {
        a[n - 1]--;
        if (n != 1 && a[n - 1] < a[n - 2]) {
            int l = 0, r = n - 2;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if (a[mid] > a[n - 1]) {
                    r = mid;
                }
                else {
                    l = mid;
                }
            }
            int temp = a[n - 1];
            a[n - 1] = a[r];
            a[r] = temp;
        }
    }
    sort(a.begin(), a.end());
    for (auto i: a) {
        cout << i << " ";
    }
}


