#include <iostream>
#include <vector>
#include <math.h>
#include <map>
#include <algorithm>
#include <set>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <string>

typedef long long ll;
typedef long double ld;

using namespace std;

ll const MAXN = 2e3+1;
ll const A = 367;
ll const B = 1e9 + 7;
ll o = 0;
ll rex[MAXN];
ll tin[MAXN];
ll tout[MAXN];
vector <vector<ll>> point(MAXN);
ll ans = 0;
vector<vector<ll>> preshet(MAXN);
ll tim = 1;


ll logpow(ll num, ll deb) {
	ll sum = 1;
	while (deb != 0) {
		if (deb % 2 == 0) {
			num *= num;
			deb /= 2;
		}
		else {
			sum *= num;
			deb--;
		}
	}
	return sum;
}

void dfs(ll v) {
	rex[v] = 1;
	for (ll i = 0; i < point[v].size(); i++) {
		if (rex[point[v][i]] == 0) {
			dfs(point[v][i]);
		}
		else if (rex[point[v][i]] == 1 && tin[v]<tin[point[v][i]] && tout[v]>tout[point[v][i]]) {
			ans++;
		}
		else{
			preshet[point[v][i]][preshet[point[v][i]].size()-1]++;
		}
	}
}

void dfs2(ll v) {
	rex[v] = 1;
	tin[v] = tim;
	tim++;
	for (ll i = 0; i < point[v].size(); i++) {
		if (rex[point[v][i]] == 0) {
			dfs2(point[v][i]);
		}
	}
	tout[v] = tim;
	tim++;
}

void solve() {
	ll n, m, k, q;
	cin >> n >> m >> k >> q;
	vector<ll> row(n);
	for (ll i = 0; i < n; i++) {
		cin >> row[i];
	}
	sort(row.begin(), row.end());
	for (ll i = 0; i < m; i++) {
		for (ll j = n - 1; j >= n - k; j--) {
			row[j]--;
		}
		sort(row.begin(), row.end());
	}
	for (ll i = 0; i < n; i++) {
		cout << row[i] << " ";
	}
}

int main()
{
	ll t = 1;
	//cin>> t;
	while (t--) {
		solve();
	}
}
