#include <iostream>
#include <vector>
#include <math.h>
#include <map>
#include <algorithm>
#include <set>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <string>

typedef long long ll;
typedef long double ld;

using namespace std;

ll const MAXN = 1e9;
ll const A = 367;
ll const B = 1e9 + 7;
ll o = 0;


ll logpow(ll num, ll deb) {
	ll sum = 1;
	while (deb != 0) {
		if (deb % 2 == 0) {
			num *= num;
			deb /= 2;
		}
		else {
			sum *= num;
			deb--;
		}
	}
	return sum;
}

void solve() {
	ll n, m, k, q;
	cin >> n >> m >> k >> q;
	vector<ll> row(n);
	for (ll i = 0; i < n; i++) {
		cin >> row[i];
	}
	sort(row.begin(), row.end());
	ll l = -MAXN-200001, r = MAXN + 1;
	ll ans;
	while (r - l > 1) {
		ll mid = (r + l) / 2;
		ll shet = n - 1;
		ans = 0;
		while (shet >= 0 && row[shet] > mid) {
			ans += row[shet] - mid;
			shet--;
		}
		if (ans >= m) {
			l = mid;
		}
		else {
			r = mid;
		}
	}
	ans = 0;
	ll shet = n - 1;
	while (row[shet] > l && shet >= 0) {
		ans += row[shet] - l;
		row[shet] = l;
		shet--;
	}
	for (ll i = n - 1; n - (ans - m) <= i; i--) {
		row[i]++;
	}
	for (ll i = 0; i < n; i++) {
		cout << row[i] << " ";
	}
}

int main()
{
	ll t = 1;
	//cin>> t;
	while (t--) {
		solve();
	}
}
