#include <iostream>
#include <string>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>


typedef long long ll;
typedef double db;
typedef long double ld;

#define pb push_back
#define sz(s) int(s.size())
#define mp make_pair
#define all(s) s.begin(), s.end()

const int MAX_N = 2e5 + 10;
const int LOG = 20;
const ld EPS = 1e-7;

using namespace std;

int a[MAX_N];
ll syff[MAX_N];
ll n, m0, k0, q;
int ask(ll mi, ll ki, int index) {
    int lef = 0; 
    int rig = n - ki + 1;
    while (rig - lef != 1) {
        int mid = (lef + rig) / 2;
        if (syff[mid + 1] - 1LL * a[mid]  * (n - mid)>= mi * ki) {
            lef = mid;
        } else {
            rig = mid;
        }
    }
    int ind = lef;
    if (index <= lef) {
        return a[index];
    }
    ll rem = syff[ind + 1] - m0 * k0 ;
    int len = n - ind;
    // cout << rem << " sda " << index << " " << ind << endl;
    if (rem >= 0) { 
        int big = rem % len;    
        if (n - index + 1 <= big) {
            return rem / len + 1;
        } else {
            return rem / len;
        } 
    } else {
        rem = -rem;
        int big = rem % len;
        if (n - index + 1 <= n - big) {
            return -(rem / len);
        } else {
            return -(rem / len + 1);
        } 
    }
}
    

int main () {
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> m0 >> k0 >> q;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        
    }
    sort(a + 1, a + n + 1);
    for (int i = n; i >= 1; i--) {
        syff[i] = syff[i + 1] + a[i];
        
    }
    int ind = 0;
    vector <int> op;
    for (int i = 1; i <= n; i++) {
        if (i <= n - k0 && syff[i + 1] - 1LL * (n - i) * a[i] >= m0 * k0) {
            op.pb(a[i]);
            ind = i;
        } else {
            ll rem = syff[ind + 1] - m0 * k0 ;
            int len = n - ind;
            if (rem >= 0) { 
                int big = rem % len;    
                if (n - i + 1 <= big) {
                    op.pb(rem / len + 1);
                } else {
                    op.pb(rem / len);
                } 
            } else {
                rem = -rem;
                int big = rem % len;
                if (n - i + 1 <= big) {
                    op.pb(-(rem / len + 1));
                } else {
                    op.pb(-(rem / len));
                } 
            }
        }
    }
    // cout << ind << "!!!" << endl;
    sort(all(op));
    for (int i : op) {
        cout << i << " ";
    }
    cout << endl;
    for (int i = 0; i < q; i++) {
        int type, mi, ki, xi;
        cin >> type >> mi >> ki >> xi;
        cout << ask(mi, ki, xi) << endl;
    }

    

    


    
}
// 8 3 2 0
// 3 1 2 -1 0 2 -1 4