#include <iostream>
#include <string>
#include <vector>
#include <unordered_map>
#include <map>
#include <set>
#include <algorithm>
#include <iomanip>
#include <random>




typedef long long ll;
typedef double db;
typedef long double ld;

#define pb push_back
#define sz(s) int(s.size())
#define mp make_pair
#define all(s) s.begin(), s.end()

const int MAX_N = 2e5 + 10;
const int LOG = 20;
const ld EPS = 1e-7;

using namespace std;

ll a[MAX_N];
ll syff[MAX_N];
ll n, m0, k0, q;

mt19937 r(239239);

int ask(ll mi, ll ki, int index) {
    int lef = 0; 
    int rig = n - ki + 1;
    while (rig - lef != 1) {
        int mid = (lef + rig) / 2;
        if (syff[mid + 1] - 1LL * a[mid]  * (n - mid) >= mi * ki) {
            lef = mid;
        } else {
            rig = mid;
        }
    }
    int ind = lef;
    if (index <= lef) {
        return a[index];
    }
    ll rem = syff[ind + 1] - mi * ki ;
    int len = n - ind;
    // cout << rem << " sda " << index << " " << ind << endl;
    if (rem >= 0) { 
        int big = rem % len;    
        if (n - index + 1 <= big) {
            return rem / len + 1;
        } else {
            return rem / len;
        } 
    } else {
        rem = -rem;
        int big = rem % len;
        if (n - index + 1 <= (len - big)) {
            return -(rem / len);
        } else {
            return -(rem / len + 1);
        } 
    }
}
    

int main () {
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    // for (int test = 0; test < 100000; test++) {
        // n = r() % 10 + 1;
        // m0 = r() % 100;
        // k0 = 1;
        // q = 0;
        cin >> n >> m0 >> k0 >> q;

        for (int i = 1; i <= n; i++) {
            // a[i] = r() % 20;
            // if (r() % 2) {
            //     a[i] = -a[i];
            // }
            cin >> a[i];
        }
        sort(a + 1, a + n + 1);
        for (int i = n; i >= 1; i--) {
            syff[i] = syff[i + 1] + a[i];
            // cout << syff[i] << " ";
        }
        // cout << endl;
        int ind = 0;
        vector <int> op;
        for (int i = 1; i <= n; i++) {
            if (i <= n - k0 && syff[i + 1] - 1LL * (n - i) * a[i] >= m0 * k0) {
                op.pb(a[i]);
                ind = i;
            } else {
                ll rem = syff[ind + 1] - m0 * k0 ;
                int len = n - ind;
                if (rem >= 0) { 
                    int big = rem % len;    
                    if (n - i + 1 <= big) {
                        op.pb(rem / len + 1);
                    } else {
                        op.pb(rem / len);
                    } 
                } else {
                    rem = -rem;
                    int big = rem % len;
                    if (n - i + 1 <= big) {
                        op.pb(-(rem / len + 1));
                    } else {
                        op.pb(-(rem / len));
                    } 
                }
            }
        }
        // for (int i = n; i >= 1; i--) {
        //     cout << a[i] << " ";
        // }
        // cout << endl;
        // cout << ind << "!!!" << endl;
        // for (int i = 1; i <= n; i++) {
        //     cout << ask(m0, k0, i) << " ";
        // }
        // cout << endl;
        sort(all(op));
        vector <int> ans_no;
        for (int i = 1; i <= n; i++) {
            ans_no.pb(ask(m0, k0, i));
        }
        // bool f = false;
        
        // for (int i = 1; i <= n; i++) {
        //     if (op[i] != ans_no[i]) {
        //         f = true;
        //     }
        // }
        // if (f) {
            // cout << "WARINGN" << endl;
            // cout << n << " " << m0 << " " << k0 << endl;
            // for (int i = 1; i <= n; i++) {
            //     cout << a[i] << " ";
            // } 
            // cout << endl;
            // for (int i : op) {
            //     cout << i << " " ;
            // }
            // cout << endl;
            for (int i : ans_no) {
                cout << i << " ";
            }
            cout << endl;
        // }
        for (int i = 0; i < q; i++) {
            int type, mi, ki, xi;
            cin >> type >> mi >> ki >> xi;
            cout << ask(mi, ki, xi) << endl;
        }
    }
    // cout << "END" << endl;
    

    


    
}
// 5 18 1 0
// -9 -7 1 2 7